Lua_AttrIconItem = class("Lua_AttrIconItem", Lua_DisplayObject);
function Lua_AttrIconItem:ctor(p, fontName, fontSize, fontColorStr)
	self.fontName = fontName == nil and Lua_MyUISettings.defaultFontName or fontName;
	self.fontSize = fontSize == nil and 22 or fontSize;
	self.fontColorStr = fontColorStr == nil and "FFFFFF" or fontColorStr;
	self:superCall("ctor", p);
end

function Lua_AttrIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.pivot = 0;
	self.spacingX = 0;

	self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);

	self.text = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, self.fontSize);
	self.text.fontName = self.fontName;
	self.text.horizontalOverflowValue = 1;
	self.text.colorStr = Lua_ColorDefine.transColorStr(self.fontColorStr);
end

function Lua_AttrIconItem:dispose()
	self:superCall("dispose");
end

-- 1:从左往右 0:居中 -1:从右往左
function Lua_AttrIconItem.Set:pivot(val)
    self._pivot = val;
end

function Lua_AttrIconItem.Get:pivot()
    return self._pivot;
end

function Lua_AttrIconItem.Set:spacingX(val)
    self._spacingX = val;
end

function Lua_AttrIconItem.Get:spacingX()
    return self._spacingX;
end

function Lua_AttrIconItem:setData(iconAtlas, iconSprite, text)
	local iconWidth;
	if strIsNullOrEmpty(iconAtlas) or strIsNullOrEmpty(iconSprite) then
		self.icon:setEnable(false);
		iconWidth = 0;
	else
		self.icon:setEnable(true);
		self.icon:setAltas(iconAtlas, iconSprite);
		iconWidth = self.icon.width;
	end

	self.text.text = text;
	self.text:resetSize();
	local textWidth = self.text.width;

	if self.pivot == 1 then
		self.icon.pivotValue = 3;
		self.icon:setLocation(0, 0, 0);

		self.text.pivotValue = 3;
		self.text.alignmentValue = 3;
		self.text:setLocation(iconWidth + self.spacingX, 0, 0);
	elseif self.pivot == -1 then
		self.text.pivotValue = 5;
		self.text.alignmentValue = 5;
		self.text:setLocation(0, 0, 0);

		self.icon.pivotValue = 5;
		self.icon:setLocation(-textWidth + self.spacingX, 0, 0);
	else
		local width = (iconWidth + textWidth) / 2;
		self.icon.pivotValue = 3;
		self.icon:setLocation(-width - self.spacingX / 2, 0, 0);

		self.text.pivotValue = 3;
		self.text:setLocation(-width + iconWidth + self.spacingX / 2, 0, 0);
	end
end