-- buff 图标
Lua_BuffIcon = class("Lua_BuffIcon", Lua_DisplayObject);
function Lua_BuffIcon:ctor(p)
    self:superCall("ctor", p);
end

function Lua_BuffIcon:buildShowItem()
    self:superCall("buildShowItem");
    self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
end

function Lua_BuffIcon:dispose()
    self.owner = nil;
    self.callBack = nil;
    self._data = nil;
    self:superCall("dispose");
end

function Lua_BuffIcon:setIconImg(atlas, spName)
    if atlas ~= nil and spName ~= nil then
        self.icon:setEnable(true);
        self.icon:setAltas(atlas, spName);
    else
        self.icon:setEnable(false);
    end
end

function Lua_BuffIcon:setData(data)
    self._data = data;
    if data == nil then
        self:setIconImg(nil, nil);
        self:showNum(0);
    else
        self:setIconImg(data.atlas, data.sprite);
        self:showNum(data.overlayNum);
    end
end

function Lua_BuffIcon.Get:data()
    return self._data;
end

function Lua_BuffIcon:showNum(num)
    if num ~= nil and num > 1 then
        if self.numText == nil then
            self.numText = UICreate.createLabel(self.content, nil, 16.5, -9, 100, 31, 18);
            self.numText.pivot = Lua_WindowUtil.getPivot(5);
            self.numText.alignmentValue = 5;
            self.numText.horizontalOverflowValue = 1;
            self.numText.effectStyle = 2;
            self.numText.colorStr = Lua_ColorDefine.transColor("F7F7F3");
            self.numText.effectColorStr = Lua_ColorDefine.transColor("1D1D1D");
            self.numText:setEffectDistance(2, 2);
        end
        self.numText:setEnable(true);
        self.numText.text = num;
    else
        if self.numText ~= nil then
            self.numText:setEnable(false);
        end
    end
end

function Lua_BuffIcon:setClick(owner, callBack)
    self.owner = owner;
    self.callBack = callBack;
    if owner == nil or callBack == nil then
        self:setCanClick(false);
    else
        self:setCanClick(true);
    end
end

function Lua_BuffIcon:setCanClick(bValue)
    if bValue then
        self.icon.mouseEnable = true;
        self.icon:addClickFuntion(self, self.onClick);
    else
        self.icon.mouseEnable = false;
        self.icon:removeClickFuntion(self, self.onClick);
    end
end

function Lua_BuffIcon:onClick(go)
    if self.owner ~= nil and self.callBack ~= nil then
        self.callBack(self.owner);
    end
end