-- 闪卡组件
--[[
local info = Lua_FlashCardVo.new(4);
self.flashItem = Lua_CommonFlashCardItem.new(self.content);
self.flashItem:setData(info);
self.flashItem:setScale(0.7, 0.7);
self.flashItem.openTime = 0.8; -- 旋转时间
self.flashItem.rotateNum = 3; -- 旋转圈数
self.flashItem.canRotate = true; -- 是否可旋转
self:setCanClick(bValue);--是否可点击，默认可点击
--]]

Lua_CommonFlashCardItem = class("Lua_CommonFlashCardItem", Lua_DisplayObject);
function Lua_CommonFlashCardItem:ctor(p)
	-- self.itemW = 124;
	-- self.itemH = 124;
	-- self.minX = 0;
	-- self.maxX = 0;
	-- self.minY = 0;
	-- self.maxY = 0;
	self:superCall("ctor", p, "CommonFlashCardItem_skin");
end

function Lua_CommonFlashCardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.frontPageNoneSp:setEnable(false);
	self.frontPageNoneTxt.text = nil;	

	self.isShowFront = true;
	self:showFrontPage(self.isShowFront);
	self.frontPageBg.clickScale = false;
	self.backPageBg.clickScale = false;
	self.frontPageBg:addClickFuntion(self, self.onClickCard);
	self.backPageBg:addClickFuntion(self, self.onClickCard);
end

function Lua_CommonFlashCardItem:onClickCard()
	-- if not self.isComplete then
	-- 	return;
	-- end
	
	self:excuteCallBack();
	if not self.canRotate then
		return;
	end
	if self.bStartOpen then
		OperateAlert.showLangValue(410060);
	end

	self:starOpenCard();
	-- self.isShowFront = not self.isShowFront;
	-- self:showFrontPage(self.isShowFront);
end

function Lua_CommonFlashCardItem:setCanClick(bValue)
	if bValue then
		self.frontPageBg.mouseEnable = true;
		self.frontPageBg:addClickFuntion(self, self.onClickCard);
		self.backPageBg.mouseEnable = true;
		self.backPageBg:addClickFuntion(self, self.onClickCard);
	else
		self.frontPageBg.mouseEnable = false;
		self.frontPageBg:removeClickFuntion(self, self.onClickCard);
		self.backPageBg.mouseEnable = true;
		self.backPageBg:addClickFuntion(self, self.onClickCard);
	end
end

function Lua_CommonFlashCardItem:setData(param)
	if param == nil then
		return;
	end
	-- self.isComplete = param.isCompletionCard;
	self.data = param;
	self:showNoCollectCardTxt(false);
	self:displayItem(param);
	self:showFrontPage(self.isShowFront);
end

function Lua_CommonFlashCardItem:showEffect(bShow, effectName, posX, posY, scale)
	if bShow then
		local _effectName = effectName or "ui_scc_sk_0001";
		local _url = "/effects/uiEffects/".._effectName;
		local _posX = posX or 0;
		local _posY = posY or 0;
		local _scale = scale or 1;
		if self.uiEffect == nil then
	  		self.uiEffect = UICreate.createUIEffect(self.content, _url, _effectName, _posX, _posY);
	  	else
	  		self.uiEffect:setUrl(_url, _effectName);
	  		self.uiEffect:setLocation(_posX, _posY);
	   	end

	   	-- _scale = _scale * self.curScaleX;
	   	self.uiEffect:setScale(_scale, _scale);
	   	self.uiEffect:setEnable(true);
	else
		if self.uiEffect ~= nil then
			self.uiEffect:setEnable(false);
		end
	end
end

-- 是否展示特效,是否只展示正面特效，默认正反展示
function Lua_CommonFlashCardItem:setBShowEffect(bShow, bOnlyShowFront, effectName, posX, posY, scale)
	self._bShowEffect = bShow;
	self.bOnlyShowFront = bOnlyShowFront; 
	self.effectName = effectName;
	self.effectPosX = posX;
	self.effectPosY = posY;
	self.effectScale = scale;

	local showEffect;
	if self.bOnlyShowFront then
		showEffect = bShow and self.isShowFront;
	else
		showEffect = bShow;
	end
	self:showEffect(showEffect, effectName, posX, posY, scale);

end

-- 闪卡制作未完成的显示
function Lua_CommonFlashCardItem:showNocompleteCardState(noComplete)
	if noComplete then	
		local path = self.data.showNewCard and self.data.no_complete_path or self.data.classic_no_complete_path;
		if self.frontPageBg.url ~= path then
			self.frontPageBg:clearTexture();
			self.frontPageBg:setUrl(path);
		end
		self.frontPageCampSp:setEnable(not noComplete);
	end
end

function Lua_CommonFlashCardItem:showNoCollectCardTxt(noCollect)
	self.frontPageNoneTxt.text = noCollect and LanUtil.getValue(410061) or nil; 
	self.frontPageNoneSp:setEnable(noCollect);
	if self.data.showNewCard then
		self.frontPageNoneSp:SetDimensions(621, 94);
	else
		self.frontPageNoneSp:SetDimensions(490, 94);
	end
end

function Lua_CommonFlashCardItem:setCallBack(owner, callBackFunc)
	self.owner = owner;
	self.callBackFunc = callBackFunc;
end

function Lua_CommonFlashCardItem:excuteCallBack()
	if self.owner ~= nil and self.callBackFunc ~= nil then
		self.callBackFunc(self.owner);
	end
end

function Lua_CommonFlashCardItem:showFrontPage(bool)
	self.frontPageObj:SetActive(bool == true);
	self.backPageObj:SetActive(bool ~= true);
	if self.bOnlyShowFront then
		self:showEffect(self._bShowEffect and bool, self.effectName, self.effectPosX, self.effectPosY, self.effectScale);
	end
end

function Lua_CommonFlashCardItem:changeFrontPage(bool)
	if not self.isShowFront then
		bool = not bool;
	end
	self:showFrontPage(bool);
end

function Lua_CommonFlashCardItem:displayItem(param)
	local url = param.showFrontPagePath;
	if self.frontPageBg.url ~= url then
		self.frontPageBg:clearTexture();
		self.frontPageBg:SetDimensions(0, 0);
		self.frontPageBg:setUrl(url);
	end

	url = param.showBackPagePath;
	if self.backPageBg.url ~= url then
		self.backPageBg:clearTexture();
		self.backPageBg:SetDimensions(0, 0);
		self.backPageBg:setUrl(url);
	end

	if param.showNewCard then -- 新卡
		-- self.frontPageNoneSp:SetDimensions(621, 94);
		self.frontTxtBg:setEnable(true);
		self.frontPageCampSp:setAltas(param.frontAtlas, param.frontSprite);
		self.frontPageCampSp:setEnable(true);
		self.frontPageTxt.text = param.new_name;
		self.frontPageTxt:resetSize();
		self.frontTxtBg:setEnable(true);
		if self.frontPageTxt.height <= 144 then
			self.frontPageTxt:setLocation(-294, -238, 0);
			self.frontTxtBg:SetDimensions(73, 396);
			self.frontTxtBg:setAltas("hero_altas_1","xui_hb_widget_12")
		elseif self.frontPageTxt.height <= 252 and self.frontPageTxt.height > 144 then
			self.frontPageTxt:setLocation(-294, -186, 0);
			self.frontTxtBg:SetDimensions(73, 501);
			self.frontTxtBg:setAltas("hero_altas_1","xui_hb_widget_13");
		else
			self.frontPageTxt:setLocation(-294, -140, 0);
			self.frontTxtBg:SetDimensions(73, 597);
			self.frontTxtBg:setAltas("hero_altas_1","xui_hb_widget_14")
		end
		self.backPageCampSp:setAltas(param.backAtlas, param.backSprite);
		self.backPageCampSp:setEnable(true);
		local url = param.equip_path;
		if self.backPageWeaponSp.url ~= url then
			self.backPageWeaponSp:clearTexture();
			self.backPageWeaponSp:setUrl(url);
			-- self.backPageWeaponSp:SetDimensions(0, 0);
		end

		self.backPageWeaponSp:setEnable(true);
		if param.page_name ~= nil then--特殊卡序号描述
			self.backPageNumTxt:setEnable(false);
			self.backPageAllNumTxt.text = param.page_name;
			self.backPageAllNumTxt:setLocation(-130, 236);
		else
			self.backPageNumTxt.text = param.number;
			self.backPageAllNumTxt.text = DataCenter.heroUtil.hero_card_max_serial;
		end
		self.backPageTitleNameTxt.text = param.title_name;
		self.backPageOwnerContentTxt.text = param.ownerContent;
		self.backPageStoryTitleTxt.text = param.title;
		self.backPageStoryContentTxt.text = param.des;

		local equip_name = param.equip_name;
		self.backPageEquipNameRTxt:setEnable(false);
		local num = stringWidth(equip_name);
		if num > 0 and num <= 4 then
			self.backPageEquipNameLTxt.fontSize = 38;
			self.backPageEquipNameLTxt.alignmentValue = 3;
			self.backPageEquipNameLTxt:setLocation(-120, 366, 0)
			if num == 2 then
				self.backPageEquipNameLTxt.lineSpacing = 1.35;
			end
			self.backPageEquipNameLTxt.text = equip_name;
		elseif num >= 5 and num <= 6 then
			self.backPageEquipNameLTxt.fontSize = 30;
			self.backPageEquipNameLTxt.alignmentValue = 3;
			self.backPageEquipNameLTxt.text = equip_name;
			self.backPageEquipNameLTxt:setLocation(-117, 366, 0);
		elseif num >= 7 and num <= 8 then
			local str1 = StringHelperSub(equip_name,1,4);
			local str2 = StringHelperSub(equip_name,5,num);
			if num == 7 then
				self.backPageEquipNameLTxt.text = str2;
				self.backPageEquipNameRTxt.text = str1;
				self.backPageEquipNameLTxt:setLocation(-125, 333, 0);
			else
				self.backPageEquipNameLTxt.text = str1;
				self.backPageEquipNameRTxt.text = str2;
				self.backPageEquipNameLTxt:setLocation(-125, 346, 0);
			end
			self.backPageEquipNameRTxt:setEnable(true);
			
			self.backPageEquipNameLTxt.fontSize = 36;
			self.backPageEquipNameRTxt.fontSize = 36;
			self.backPageEquipNameRTxt:setLocation(-89, 346, 0);
		elseif num >= 9 and num <= 10 then
			local str1 = StringHelperSub(equip_name,1,5);
			local str2 = StringHelperSub(equip_name,6,num);
			-- print(str1,"       ",str2)
			self.backPageEquipNameLTxt.text = str1;
			self.backPageEquipNameRTxt.text = str2;

			self.backPageEquipNameLTxt.fontSize = 32;
			self.backPageEquipNameLTxt:setLocation(-124, 357, 0);

			self.backPageEquipNameRTxt.fontSize = 32;
			self.backPageEquipNameRTxt:setEnable(true);
			self.backPageEquipNameRTxt:setLocation(-88, 357, 0);
		else
			local length = Mathf.Floor(num/2);
			local str1 = StringHelperSub(equip_name,1,length);
			local str2 = StringHelperSub(equip_name,length+1,num);
			self.backPageEquipNameLTxt.text = str1;
			self.backPageEquipNameRTxt.text = str2;

			self.backPageEquipNameLTxt.fontSize = 30;
			self.backPageEquipNameLTxt:SetDimensions(40,200);
			self.backPageEquipNameLTxt:setLocation(-124, 362, 0);

			self.backPageEquipNameRTxt.fontSize = 30;
			self.backPageEquipNameRTxt:setEnable(true);
			self.backPageEquipNameLTxt:SetDimensions(40,200);
			self.backPageEquipNameRTxt:setLocation(-88, 362, 0);
		end

		num = Mathf.Ceil(LanUtil.getStrLen(param.des)/2);
		if num <= 160 then
			self.backPageStoryContentTxt.fontSize = 24;
			self.backPageStoryContentTxt.lineSpacing = 1.3;
		elseif num > 160 and num <= 250 then
			self.backPageStoryContentTxt.fontSize = 22;
			self.backPageStoryContentTxt.lineSpacing = 1.2;
		elseif num > 250 and num <= 330 then
			self.backPageStoryContentTxt.fontSize = 20;
			self.backPageStoryContentTxt.lineSpacing = 1.1;
		else
			self.backPageStoryContentTxt.fontSize = 20;
			self.backPageStoryContentTxt.lineSpacing = 1.1;
		end
	else -- 经典卡
		-- self.frontPageNoneSp:SetDimensions(490, 94);
		self.frontTxtBg:setEnable(false);
		self.frontPageCampSp:setEnable(false);
		self.frontPageTxt.text = nil;
		self.backPageCampSp:setEnable(false);
		self.backPageWeaponSp:setEnable(false);
		self.backPageNumTxt.text = nil;
		self.backPageAllNumTxt.text = nil;
		self.backPageTitleNameTxt.text = nil;
		self.backPageEquipNameLTxt.text = nil;
		self.backPageEquipNameRTxt.text = nil;
		self.backPageOwnerContentTxt.text = nil;
		self.backPageStoryTitleTxt.text = nil;
		self.backPageStoryContentTxt.text = nil;
		self.frontTxtBg:setEnable(false);
	end
end

function Lua_CommonFlashCardItem:setGray(val)
	-- if val == true then
	-- 	self.frontPageNoneSp:setEnable(true);
	-- 	self.frontPageNoneTxt.text = "暂未收集";
	-- end

	self.frontPageBg:setGray(val);
	self.frontPageTxt:setGray(val);
	self.frontPageCampSp:setGray(val);
	self.backPageBg:setGray(val);
	self.backPageWeaponSp:setGray(val);
	self.backPageNumTxt:setGray(val);
	self.backPageAllNumTxt:setGray(val);
	self.backPageTitleNameTxt:setGray(val);
	self.backPageEquipNameLTxt:setGray(val);
	self.backPageCampSp:setGray(val);
	self.backPageOwnerContentTxt:setGray(val);
	self.backPageStoryTitleTxt:setGray(val);
	self.backPageStoryContentTxt:setGray(val);
end

function Lua_CommonFlashCardItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(112, 177, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CommonFlashCardItem.Get:openTime()
	if self._openTime == nil then
		self._openTime = 1;
	end
	return self._openTime;
end

function Lua_CommonFlashCardItem.Set:openTime(value)
	self._openTime = value;
end

-- 旋转圈数
function Lua_CommonFlashCardItem.Get:rotateNum()
	if self._rotateNum == nil then
		self._rotateNum = 1;
	end
	return self._rotateNum;
end

function Lua_CommonFlashCardItem.Set:rotateNum(value)
	self._rotateNum = value;
end

function Lua_CommonFlashCardItem.Get:canRotate()
	if self._canRotate == nil then
		self._canRotate = false;
	end
	return self._canRotate;
end

function Lua_CommonFlashCardItem.Set:canRotate(value)
	self._canRotate = value;
end


function Lua_CommonFlashCardItem.Get:isShowFront()
	if self._isShowFront == nil then
		self._isShowFront = true;
	end
	return self._isShowFront;
end

function Lua_CommonFlashCardItem.Set:isShowFront(value)
	self._isShowFront = value;
end

-- 是否正在旋转
function Lua_CommonFlashCardItem.Get:bRotating()
	return self.bStartOpen;
end

function Lua_CommonFlashCardItem:starOpenCard()
	if self.bStartOpen ~= true then
		self.bStartOpen = true;
		self.curAngle = 0;
		Lua_CommonUtil.addTimer("Lua_CommonFlashCardItem_OPEN_FLASHCARD", 0.02, self, self.onOpeningCard);
	end
end

function Lua_CommonFlashCardItem:onOpeningCard()
	self.curAngle = self.curAngle + self.perAngle;
	if self.curAngle > self.totalAngle then
		self:endOpenCard();
	else
		local scaleX = Mathf.Cos(math.rad(self.curAngle));
		-- print(Mathf.Abs(scaleX) * self.curScaleX,"总时间：", self.openTime, "圈数",self.rotateNum, "总角度", self.totalAngle, "当前角度", self.curAngle, "scalce", self.curScaleX, "平均角度", self.perAngle);
		self:setScale(Mathf.Abs(scaleX) * self.curScaleX, self.curScaleY);
		self:changeFrontPage(scaleX >= 0);
	end
end

function Lua_CommonFlashCardItem:endOpenCard()
	if self.bStartOpen == true then
		self.bStartOpen = false;

		self.isShowFront = not self.isShowFront;
		self.totalAngle = nil;
		self.perAngle = nil;
		self:setScale(self.curScaleX, self.curScaleY);
		Lua_CommonUtil.removeTimer(self, self.onOpeningCard);
	end
end

function Lua_CommonFlashCardItem.Get:totalAngle()	
	if self._totalAngle == nil then
		self._totalAngle = self.rotateNum % 2 == 0 and (self.rotateNum + 1) * 180 or self.rotateNum * 180;
	end
	return self._totalAngle;
end

function Lua_CommonFlashCardItem.Set:totalAngle(value)	
	self._totalAngle = value;
end

function Lua_CommonFlashCardItem.Get:perAngle()
	if self._perAngle == nil then
		self._perAngle = self.totalAngle / (self.openTime / 0.02);
	end
	return self._perAngle;
end

function Lua_CommonFlashCardItem.Set:perAngle(value)
	self._perAngle = value;
end

function Lua_CommonFlashCardItem.Get:curScaleX()
	if self._curScaleX == nil then
		self._curScaleX = self.scaleX;
	end
	return self._curScaleX;
end

function Lua_CommonFlashCardItem.Set:curScaleX(value)
	self._curScaleX = value;
end


function Lua_CommonFlashCardItem.Get:curScaleY()
	if self._curScaleY == nil then
		self._curScaleY = self.scaleY;
	end
	return self._curScaleY;
end

function Lua_CommonFlashCardItem.Set:curScaleY(value)
	self._curScaleY = value;
end

function Lua_CommonFlashCardItem:reSetCurScale()
	self.curScaleX = nil;
	self.curScaleY = nil;
end

function Lua_CommonFlashCardItem:dispose()
	if self.uiEffect ~= nil then
		self.uiEffect:dispose();
		self.uiEffect = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:endOpenCard();
	self.owner = nil;
	self.callBackFunc = nil;
	self:superCall("dispose");
end