--[[
self.btnList = Lua_DragCustomBtnList.new(self.content, Lua_AxisDefine.Vertical, 360, 500);
self.btnList:setLocation(0, 0, 0);
self.btnList:setMainCell(Lua_MainCell, 360, 135, 0, 250);
self.btnList:setSubCell(Lua_SubCell, 354, 100, 0, 250);
self.btnList.clickDrawBack = true;

local arr = Array();
local subData;
for i = 1, 10 do
    subData = Array();
    subData:add({ index = i });
    arr:add({ index = i, subData = subData });
end
self.btnList:setData(arr);





Lua_MainCell = class("Lua_MainCell", Lua_DragCustomBtnListCell);
function Lua_MainCell:ctor(p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin)
    self:superCall("ctor", p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin);
end

function Lua_MainCell:buildShowItem()
    self:superCall("buildShowItem");
    self.banner = UICreate.createUIAtlasImage(self.content, "iconantlas1", "tips_bg", 0, 0, 360, 135);
end

function Lua_MainCell:dispose()
    self:superCall("dispose");
end





Lua_SubCell = class("Lua_SubCell", Lua_DragCustomBtnListCell);
function Lua_SubCell:ctor(p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin)
    self:superCall("ctor", p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin);
end

function Lua_SubCell:buildShowItem()
    self:superCall("buildShowItem");
    self.banner = UICreate.createUIAtlasImage(self.content, "iconantlas1", "tips_bg", 0, 0, 354, 100);
end

function Lua_SubCell:dispose()
    self:superCall("dispose");
end
--]]

checkRequire("Lua_DragCustomBtnListCell");
Lua_DragCustomBtnList = class("Lua_DragCustomBtnList", Lua_DisplayObject);
function Lua_DragCustomBtnList:ctor(p, dragType, rectW, rectH)
    self.dragType = dragType;
    self.rectWidth = rectW;
    self.rectHeight = rectH;
    
    self.minX = 0;
    self.minY = 0;
    self.maxX = 0;
    self.maxY = 0;
    self.offsetX = 0;
    self.offsetY = 0;
    self.maxSize = 0;
    self._isClick = false;
    self.startMouse = -1;
    self.startContainer = -1;
    self.childrenList = Array();

    self.showList = {};
    self.showList[Lua_DragCustomBtnDefine.TYPE_MAIN] = Array();
    self.showList[Lua_DragCustomBtnDefine.TYPE_SUB] = Array();
    self.hideList = {};
    self.hideList[Lua_DragCustomBtnDefine.TYPE_MAIN] = Array();
    self.hideList[Lua_DragCustomBtnDefine.TYPE_SUB] = Array();

    self.canDrag = true;
    self.clickDrawBack = false;

    self:superCall("ctor", p);
end

function Lua_DragCustomBtnList:buildShowItem()
    self:superCall("buildShowItem");
    
    self:setRectSize(self.rectWidth, self.rectHeight);

    self.mask = UICreate.createUIMaskContainer(self.content, nil, nil, 0, 0, 0, 0);
    self.mask.pivot = Lua_WindowUtil.getPivot(4);
    self.mask:setAnchorMin(0, 0);
    self.mask:setAnchorMax(1, 1);
    self.mask:SetDimensions(0, 0);
    self.mask:setSubRectPivot(0.5, 0.5);
    self.mask:setColor(255, 255, 255, 1);
    self.mask.clickScale = false;
    self.mask:addMousDownFuntion(self, self.onMouseDownHandle);
    self.mask:addMouseUpFuntion(self, self.onMouseUpHandle);
    self.mask:addMask();
    self.sub = self.mask.sub;
    self.subRect = self.mask.subRect;
end

function Lua_DragCustomBtnList:dispose()
    Lua_CommonUtil.removeTimer(self, self.onBackPostion);
    Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
    local cell = nil;
    local list = self.showList;
    if list ~= nil then
    	for k, arr in pairs(list) do
            if arr ~= nil then
                arr:dispose();
                arr:clear();
            end
            list[k] = nil;
    	end
    end
    self.showList = nil;

    local _cell = nil;
    local _list = self.hideList;
    if _list ~= nil then
        for k,arr in pairs(_list) do
            if arr ~= nil then
                arr:dispose();
                arr:clear();
            end
            _list[k] = nil;
        end
    end
    self.hideList = nil;

    self.mainCell = nil;
    self.subCell = nil;
    self.owner = nil;
    self.callBack = nil;
    self.sub = nil;
    self.subRect = nil;
    self.mask = nil;
    self:superCall("dispose");
end

function Lua_DragCustomBtnList:setRect(rectW, rectH)
    self.rectWidth = rectW;
    self.rectHeight = rectH;
    self:setRectSize(self.rectWidth, self.rectHeight);
end

function Lua_DragCustomBtnList:setMainCell(cell, cellWidth, cellHeight, offsetX, offsetY)
    self.mainCell = cell;
    self.mainCellWidth = cellWidth;
    self.mainCellHeight = cellHeight;
    self.mainCellOffsetX = offsetX;
    self.mainCellOffsetY = offsetY;
end

function Lua_DragCustomBtnList:setSubCell(cell, cellWidth, cellHeight, offsetX, offsetY)
    self.subCell = cell;
    self.subCellWidth = cellWidth;
    self.subCellHeight = cellHeight;
    self.subCellOffsetX = offsetX;
    self.subCellOffsetY = offsetY;
end

function Lua_DragCustomBtnList:createButton(btnType)
    local len = self.hideList[btnType]:getSize();
    local cell = nil;
    if len > 0 then
        cell = self.hideList[btnType][1];
        self.hideList[btnType]:remove(1);
        cell:setEnable(true);
    end
    if cell == nil then
        if btnType == Lua_DragCustomBtnDefine.TYPE_MAIN then
            cell = self.mainCell.new(self.sub, btnType, self.mainCellWidth, self.mainCellHeight, self.mainCellOffsetX, self.mainCellOffsetY);
            cell.btnType = Lua_DragCustomBtnDefine.TYPE_MAIN; 
        else
            cell = self.subCell.new(self.sub, btnType, self.subCellWidth, self.subCellHeight, self.subCellOffsetX, self.subCellOffsetY);
            cell.btnType = Lua_DragCustomBtnDefine.TYPE_SUB;
        end
    end
    self.showList[btnType]:add(cell);
    return cell;
end

function Lua_DragCustomBtnList:returntButton(btnType, btn)
    local len = self.showList[btnType]:getSize();
    for i = 1, len do
    	local cell = self.showList[btnType][i];
        if cell == btn then
            cell:setEnable(false);
            self.showList[btnType]:remove(i);
            break;
        end
    end
    self.hideList[btnType]:add(btn);
end

function Lua_DragCustomBtnList:setData(data, owner, callBack)
    if data == nil then
        return;
    end
    self.data = data;

    self.owner = owner;
    self.callBack = callBack;
    self.lastMainSelected = -1;

    local len = self.childrenList:getSize();
    for i = 1, len do
        self:returntButton(self.childrenList[i].btnType, self.childrenList[i]);
    end
    self.childrenList:clear();

    len = data:getSize();
    for i = 1, len do
        local cell = self:createButton(Lua_DragCustomBtnDefine.TYPE_MAIN);
        data[i].mainIndex = i;
        data[i].subIndex = nil;
        cell:setData(data[i], self, self.onBtnClick);
        self:addSubContainer(cell, false);
    end

    self:updateChildPos();
end

function Lua_DragCustomBtnList:addSubContainer(cell, bUpdatePos)
    cell:setParent(self.sub);
    cell:setScale(1, 1);
    self.childrenList:add(cell);
    if bUpdatePos == true then
        self:updateChildPos();
    end
end

function Lua_DragCustomBtnList:onBtnClick(data)
    self:setMainSlected(data.mainIndex, data.subIndex);
end

function Lua_DragCustomBtnList:setMainSlected(mainIndex, subIndex)
    local len = 0;
    local cell = nil;
    
    if self.lastMainSelected ~= mainIndex then
        self.lastMainSelected = mainIndex;
        self.subSelected = -1;

        local numIndex = 0;
        len = self.childrenList:getSize();
        for i = 1, len do
            numIndex = numIndex + 1;
            if self.childrenList[numIndex] ~= nil then
                if self.childrenList[numIndex].btnType == Lua_DragCustomBtnDefine.TYPE_SUB then
                    cell = self.childrenList[numIndex];
                    self:returntButton(Lua_DragCustomBtnDefine.TYPE_SUB, cell);
                    self.childrenList:remove(numIndex);
                    numIndex = numIndex - 1;
                else
                    cell = self.childrenList[numIndex];
                    cell.selected = (cell.data.mainIndex == mainIndex);
                end
            end
        end

        len = self.childrenList:getSize();
        for i = 1, len do
            if self.childrenList[i].data.mainIndex == mainIndex then
                local arr = self.childrenList[i].data.subData;
                if arr == nil or arr:getSize() == 0 then
                    if self.childrenList[i].selected == true and self.owner ~= nil and self.callBack ~= nil then
                        self.callBack(self.owner, self.childrenList[i].data);
                    end
                else
                    for j = 1, arr:getSize() do
                        cell = self:createButton(Lua_DragCustomBtnDefine.TYPE_SUB);
                        arr[j].mainIndex = self.childrenList[i].data.mainIndex;
                        arr[j].subIndex = j;
                        cell:setData(arr[j]); -- , self, self.onBtnClick);
                        self.childrenList:add(cell, i + j);
                    end
                end
                break;
            end
        end

        self:updateChildPos();
    elseif self.clickDrawBack == true then
        local numIndex = 0;
        len = self.childrenList:getSize();
        for i = 1, len do
            numIndex = numIndex + 1;
            if self.childrenList[numIndex] ~= nil then
                if self.childrenList[numIndex].btnType == Lua_DragCustomBtnDefine.TYPE_SUB then
                    cell = self.childrenList[numIndex];
                    self:returntButton(Lua_DragCustomBtnDefine.TYPE_SUB, cell);
                    self.childrenList:remove(numIndex);
                    numIndex = numIndex - 1;
                else
                    cell = self.childrenList[numIndex];
                    cell.selected = false; --(cell.data.mainIndex == mainIndex);
                end
            end
        end

        self:updateChildPos();
        self.lastMainSelected = -1;
    end

    if self.lastMainSelected ~= -1 then
        subIndex = subIndex == nil and 1 or subIndex;
        if subIndex ~= nil and subIndex ~= self.subSelected then
            self.subSelected = subIndex;
            len = self.childrenList:getSize();
            for i = 1, len do
                if self.childrenList[i].btnType == Lua_DragCustomBtnDefine.TYPE_SUB then
                    cell = self.childrenList[i];
                    cell.selected = (cell.data.subIndex == self.subSelected);
                    if cell.selected == true and self.owner ~= nil and self.callBack ~= nil then
                        self.callBack(self.owner, cell.data);
                    end
                end
            end
        end
    end
end

function Lua_DragCustomBtnList:updateChildPos()
    local len = self.childrenList:getSize();
    self.maxSize = 0;
    for i = 1, len do
        local ox = 0;
        local oy = 0;
        if self.childrenList[i].getOffsetX ~= nil then
            ox = self.childrenList[i]:getOffsetX();
        end
        if self.childrenList[i].getOffsetY ~= nil then
            oy = self.childrenList[i]:getOffsetY();
        end

        if self.dragType == Lua_AxisDefine.Vertical then
            self.maxSize = self.maxSize - self.childrenList[i]:getHeight() / 2;
            -- 因为这里oy所以offsetY保持一致，大小为超过大背景大小
            -- print("这里是对所有MailCell和SubCell重新设置posY值，第{1}个posY值为{2}", i, self.maxSize);
            self.childrenList[i]:setLocation(self.offsetY + ox, self.maxSize + self.offsetX + oy, 0);
            self.maxSize = self.maxSize - self.childrenList[i]:getHeight() / 2;
        end
    end
    
    if self.dragType == Lua_AxisDefine.Vertical then
        self.minY = 0;
        self.maxY = -(self.maxSize + self.rectHeight);
    end
end

function Lua_DragCustomBtnList:onMouseDownHandle(go, state)
    self:onPress(go, true);
end

function Lua_DragCustomBtnList:onMouseUpHandle(go, state)
    self:onPress(go, false);
end

function Lua_DragCustomBtnList:onPress(go, state)
    if state == true then
        if self.startMouse == -1 then
            if self.dragType == Lua_AxisDefine.Vertical then
                self.startMouse = CommonUtil.mousePositionY;
                self.startContainer = self.subRect.anchoredPosition.y;
            else
                self.startMouse = CommonUtil.mousePositionX;
                self.startContainer = self.subRect.anchoredPosition.x;
            end
        end
        if self._isClick == false then
            self._isClick = true;
            Lua_CommonUtil.addTimer("onEnterFrame", 0.01, self, self.onEnterFrame);
        end
        Lua_CommonUtil.removeTimer(self, self.onBackPostion);
    else
        if self.dragType == Lua_AxisDefine.Vertical then
            local endPos = self.subRect.anchoredPosition.y;
            local co = endPos - self.startContainer;
            if co < 2 and co > -2 then
                local winPos = LuaUtil.getTouchPosInverseObj(self.sub);
                local len = self.childrenList:getSize();
                for i = 1, len do
                    local ty = self.childrenList[i].y + self.childrenList[i]:getHeight() / 2;
                    local dy = self.childrenList[i].y - self.childrenList[i]:getHeight() / 2; 
                    if ty >= winPos.y and dy <= winPos.y then
                        self.childrenList[i]:onPressClick();
                        break;
                    end
                end
            end
        end
        self.startMouse = -1;
        self.startContainer = -1;
        if self._isClick == true then
            self._isClick = false;
            Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
        end
        self:checkPosFix();
    end
end

function Lua_DragCustomBtnList:checkPosFix()
    if self.dragType == Lua_AxisDefine.Vertical then
        local py = self.subRect.anchoredPosition.y;
        if self.minY >= self.maxY or py < self.minY then
            self.targetPos = self.minY;
            Lua_CommonUtil.addTimer("onBackPostion", 0.01, self, self.onBackPostion);
        elseif py > self.maxY then
            self.targetPos = self.maxY;
            Lua_CommonUtil.addTimer("onBackPostion", 0.01, self, self.onBackPostion);
        end
    else
        local px = self.subRect.anchoredPosition.x;
        if self.minX >= self.maxX or px < self.minX then
            self.targetPos = self.minX;
            Lua_CommonUtil.addTimer("onBackPostion", 0.01, self, self.onBackPostion);
        elseif px > self.maxX then
            self.targetPos = self.maxX;
            Lua_CommonUtil.addTimer("onBackPostion", 0.01, self, self.onBackPostion);
        end
    end
end

function Lua_DragCustomBtnList:onEnterFrame()
    local d = 0;
    if self.dragType == Lua_AxisDefine.Vertical then
        d = CommonUtil.mousePositionY - self.startMouse;
    else
        d = CommonUtil.mousePositionX - self.startMouse;
    end
    local rs = d + self.startContainer;
    if self.startContainer ~= -1 then
        if self.dragType == Lua_AxisDefine.Vertical then
            self:updateSubPos(0, rs, 0);
        else
            self:updateSubPos(rs, 0, 0);
        end
    end
end


function Lua_DragCustomBtnList:onBackPostion()
    local isEnd = false;
    if self.dragType == Lua_AxisDefine.Vertical then
        local py = self.subRect.anchoredPosition.y;
        if Mathf.Abs(self.targetPos - py) < 2 then
            self:updateSubPos(0, self.targetPos, 0);
            isEnd = true;
        else
            self:updateSubPos(0,(self.targetPos - py) * 0.15 + py, 0);
            isEnd = false;
        end
    else
        local px = self.subRect.anchoredPosition.x;
        if Mathf.Abs(self.targetPos - px) < 2 then
            self:updateSubPos(self.targetPos, 0, 0);
            isEnd = true;
        else
            self:updateSubPos((self.targetPos - px) * 0.15 + px, 0, 0);
            isEnd = false;
        end
    end
    if isEnd == true then
        Lua_CommonUtil.removeTimer(self, self.onBackPostion);
    end
end

function Lua_DragCustomBtnList:moveToIndex(val, isNow)
    local tp = 0;
    if self.dragType == Lua_AxisDefine.Vertical then
        if val < 0 then
            tp = self.minY
        elseif val > self.childrenList:getSize() then
            tp = self.maxY;
        else
            tp = Mathf.Abs(self.childrenList[val].y);
        end
        self.targetPos = tp;
        if self.minY >= self.maxY or tp < self.minY then
            self.targetPos = self.minY;
        elseif tp > self.maxY then 
            self.targetPos = self.maxY;
        end
        if isNow == true then
            self:updateSubPos(0, self.targetPos, 0);
        else
            Lua_CommonUtil.addTimer("onBackPostion", 0.01, self, self.onBackPostion);
        end
    else
        if val < 0 then
            tp = self.minX
        elseif val > self.childrenList:getSize() then
            tp = self.maxX
        else
            tp = self.childrenList[val].x;
        end
        self.targetPos = tp;
        if self.minX >= self.maxX or tp < self.minX then
            self.targetPos = self.minX;
        elseif tp > self.maxX then 
            self.targetPos = self.maxX;
        end
        if isNow == true then
            self:updateSubPos(self.targetPos, 0, 0);
        else
            Lua_CommonUtil.addTimer("onBackPostion", 0.01, self, self.onBackPostion);
        end
    end
end

function Lua_DragCustomBtnList:updateSubPos(x, y, z)
    if self.canDrag == false then 
        return 
    end

    LuaUtil.setRectPos(self.subRect, x, y, z);
end