Lua_FightStarPanel = class("Lua_FightStarPanel", Lua_DisplayObject)
function Lua_FightStarPanel:ctor(p)
    self:superCall("ctor", p)
end

function Lua_FightStarPanel:buildShowItem()
    self:superCall("buildShowItem")
    self.bShow = false
    
    self.btnShowHide = UICreate.createUIAtlasImage(self.content, "fight_atlas_1", "xui_xhd_button_003_n", 0, 0, 0, 0)
    self.btnShowHide:addClickFuntion(self, self.onShowHide)

    self.showContainer = Lua_WindowUtil.createContaner(self.content, Vector3.zero)
    self.showContainer:SetActive(self.bShow)

    self.bg = UICreate.createUIAtlasImage(self.showContainer, "fight_atlas_1", "xui_xhd_widget_002", 193, 0, 340, 104)
end

function Lua_FightStarPanel:dispose()
    Lua_CommonUtil.removeTimer(self, self.onAutoHide)
    if self.itemArr then
        self.itemArr:dispose()
        self.itemArr:clear()
        self.itemArr = nil
    end
    self:superCall("dispose")
end

function Lua_FightStarPanel:setShowHide(value)
    self.bShow = value
    self:updateShowHide()
end

function Lua_FightStarPanel:setAutoHide(value)
    value = value or 0
    Lua_CommonUtil.delayCall(value, self, self.onAutoHide)
end

function Lua_FightStarPanel:onAutoHide()
    self:setShowHide(false)
end

function Lua_FightStarPanel:setData(data)
    if self.itemArr == nil then
        self.itemArr = Array()
    end

    local len = self.itemArr:getSize()
    if data == nil then
        len = -len
    else
        len = data:getSize() - len
    end
    
    local item
    while (len > 0) do
        item = Lua_FightStarItem.new(self.showContainer)
        self.itemArr:add(item)
        len = len - 1
    end

    while (len < 0) do
        item = self.itemArr:remove(1)
        item:dispose()
        len = len + 1
    end

    len = self.itemArr:getSize()
    for i = 1, len do
        item = self.itemArr[i]
        item:setLocation(46, 32.5 - (i - 1) * 31, 0)
        item:setData(data[i])
    end
end

function Lua_FightStarPanel:updateData()
    if self.itemArr then
        for i = 1, self.itemArr:getSize() do
            self.itemArr[i]:updateData()
        end
    end
end

function Lua_FightStarPanel:onShowHide()
    self.bShow = not self.bShow
    self:updateShowHide()
end

function Lua_FightStarPanel:updateShowHide()
    if self.bShow then
        self.btnShowHide:setAltas("fight_atlas_1", "xui_xhd_button_004_n")
    else
        self.btnShowHide:setAltas("fight_atlas_1", "xui_xhd_button_003_n")
    end
    self.showContainer:SetActive(self.bShow)
end




















Lua_FightStarItem = class("Lua_FightStarItem", Lua_DisplayObject)
function Lua_FightStarItem:ctor(p)
    self:superCall("ctor", p)
end

function Lua_FightStarItem:buildShowItem()
    self:superCall("buildShowItem")

    self.starIcon = UICreate.createUIAtlasImage(self.content, "fight_atlas_1", "xui_xhd_label_003", 0, 0, 0, 0)
    self.starIcon:setScale(0.5, 0.5, 0.5)

    self.desText = UICreate.createLabel(self.content, nil, 69, 0, 100, 31, 22)
    self.desText.alignmentValue = 3
    self.desText.horizontalOverflowValue = 1
    self.desText.fontName = Lua_MyUISettings.huakangFontName;
    self.desText.colorStr = Lua_ColorDefine.transColor("EFE9E4")
    self.desText.effectStyle = 2
    self.desText.effectColorStr = Lua_ColorDefine.transColor("100E0B")
    self.desText:setEffectDistance(2, 2)
end

function Lua_FightStarItem:dispose()
    self.starIcon = nil
    self.desText = nil
    self.data = nil
    self:superCall("dispose")
end

function Lua_FightStarItem:setData(data)
    self.data = data
    self.desText.text = data.desc
    self:updateData()
end

function Lua_FightStarItem:updateData()
    if self.data.isMeet then
        self.starIcon:setAltas("fight_atlas_1", "xui_xhd_label_004")
        self.desText.colorStr = Lua_ColorDefine.transColor("2CE654")
    else
        self.starIcon:setAltas("fight_atlas_1", "xui_xhd_label_003")
        self.desText.colorStr = Lua_ColorDefine.transColor("EFE9E4")
    end
end