--英雄item
Lua_HeroItemIcon = class("Lua_HeroItemIcon", Lua_DisplayObject);
function Lua_HeroItemIcon:ctor(p)
	self:superCall("ctor", p, "HeroItemIcon_skin");
end

function Lua_HeroItemIcon:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroItemIcon:dispose()
	if self.starArr ~= nil then
		self.starArr:dispose();
		self.starArr:clear();
		self.starArr = nil;
	end
	if self.redDotIcon ~= nil then
		self.redDotIcon:dispose();
		self.redDotIcon = nil;
	end
	self.trial_spr = nil;
	self.fight_spr = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroItemIcon:setData(data)
	self.bShowEffect = nil;
	self.data = data;
	if data == nil then
		self:showStar(nil);
		self:showLevel(nil);
		self:setIconBg(nil);
		self:setIconImg(nil);
		self:showRedPoint(false);
		self:showCampIcon(nil);
		self:showEffect(false);
		self:showFightIcon(false);
		self:showTrialIcon(false);
	else
		self.content.name = data.id;
		self:showStar(data.star);
		self:showLevel(data.level);
		self:setIconBg(data.color);
		self:setIconImg(data.path);
		self:showEffect(data.star >= 11);
		self:showCampIcon(data.campType);
		self:showFightIcon(data.isShowFight);
		self:showTrialIcon(data.trial_state);
	end
end

--背景框
function Lua_HeroItemIcon:setIconBg(color)
	if color ~= nil and color > 0 then
		self.icon_bg:setAltas("hero_altas", "xui_hb_window_0"..color);
	else
		self.icon_bg:setAltas("hero_altas", "xui_hb_window_01");
	end
end

--英雄立绘
function Lua_HeroItemIcon:setIconImg(path)
	if path ~= nil then
		self.icon_img:setEnable(true);
		self.icon_img:setUrl(path);
	else
		if self.icon_img ~= nil then
			self.icon_img:setEnable(false);
		end
	end
end

--英雄等级
function Lua_HeroItemIcon:showLevel(level)
	if level ~= nil then
		self.show_level:setEnable(true);
		if self.data.is_resonance then
			self.show_level.colorStr = Lua_ColorDefine.transColorStr("4192bf");
			self.show_level.effectColorStr = Lua_ColorDefine.transColorStr("fffef9");
		else
			self.show_level.colorStr = Lua_ColorDefine.transColorStr("4F4947");
			self.show_level.effectColorStr = Lua_ColorDefine.transColorStr("FFFFFF");
		end
		self.show_level.text = level;
	else
		if self.show_level ~= nil then
			self.show_level:setEnable(false);
		end
	end
end

--阵容图标
function Lua_HeroItemIcon:showCampIcon(campType)
	if campType ~= nil and campType > 0 then
		self.camp_icon:setAltas("common_altas_2", "xui_common_attribute_"..campType);
		self.camp_icon:setEnable(true);
	else
		self.camp_icon:setEnable(false);
	end
end

--点击
function Lua_HeroItemIcon:setCanClick(bClick)
	if bClick then
		self.icon_bg.mouseEnable = true;
		self.icon_bg:addClickFuntion(self, self.onIconClick);
	else
		self.icon_bg.mouseEnable = false;
		self.icon_bg:removeClickFuntion(self, self.onIconClick);
	end
end

--显示星
function Lua_HeroItemIcon:showStar(star)
	if star ~= nil and star > 0 then
		local showStar = DataCenter.heroUtil:getShowStar(star);
		if star <= 10 then
			if self.starArr == nil then
	            self.starArr = Array();
	        end
	        local len = self.starArr:getSize();
	        local spr = DataCenter.heroUtil:getStarSprite(star, 1);
	        local starWidth = 21;
	        local num = len;
	        if len < showStar then
	            num = showStar;
	        end
	        for i = 1, num do
	            local item = self.starArr[i];
	            if item == nil then
	                item = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_label_02", 0, 0, 22, 23);
	                item:setScale(0.9,0.9,0.9);
	                self.starArr:add(item);
	            else
	                item:setEnable(i <= showStar);
	            end  
	            item:setLocation(-1 * starWidth * showStar / 2 + starWidth * (i-1) + starWidth / 2, -81, 0);
	            item:setAltas("common_altas_1", spr);
	        end
	        self.star_bg:setEnable(false);
			self.star_level:setEnable(false);
		else
			if self.starArr ~= nil then
	            local len = self.starArr:getSize();
	            for i = 1, len do
	                self.starArr[i]:setEnable(false);
	            end
	        end
			self.star_bg:setEnable(true);
			self.star_level:setEnable(showStar > 0);
			self.star_level.text = showStar;
		end
	else
		if self.starArr ~= nil then
            local len = self.starArr:getSize();
            for i = 1, len do
                self.starArr[i]:setEnable(false);
            end
        end
		self.star_bg:setEnable(false);
		self.star_level:setEnable(false);
	end
end

--出战标识
function Lua_HeroItemIcon:showFightIcon(bShow)
	if bShow then
		if self.fight_spr == nil then
			self.fight_spr = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_08", -53, 88, 0, 0);
		end
		self.fight_spr:setEnable(true);
	else
		if self.fight_spr ~= nil then
			self.fight_spr:setEnable(false);
		end
	end
end

--红点
function Lua_HeroItemIcon:showRedPoint(bShow)
	if bShow then
		if self.redDotIcon == nil then
			self.redDotIcon = Lua_RedPointIcon.new(self.content);
			self.redDotIcon:setLocation(65, 87, 0);
            self.redDotIcon:createRedPointImg(nil);
		end
		self.redDotIcon:updateRedPointShow(bShow);
	else
		if self.redDotIcon ~= nil then
			self.redDotIcon:updateRedPointShow(false);
		end
	end
end

--试用标识
function Lua_HeroItemIcon:showTrialIcon(bShow)
	if bShow then
		if self.trial_spr == nil then
			self.trial_spr = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_label_10", -59, 32, 0, 0);
		end
		self.trial_spr:setEnable(true);
	else
		if self.trial_spr ~= nil then
			self.trial_spr:setEnable(false);
		end
	end
end

function Lua_HeroItemIcon:setLock(bState, atlas, sprite)
	if bState then
		if self.lockIcon == nil then
			atlas = strIsNullOrEmpty(atlas) and "common_altas_1" or atlas
			sprite = strIsNullOrEmpty(sprite) and "ui_common_button_018_n" or sprite
			self.lockIcon = UICreate.createUIAtlasImage(self.content, atlas, sprite, 0, 0, 0, 0)
		end
		self.lockIcon:setEnable(true)
	else
		if self.lockIcon then
			self.lockIcon:setEnable(false)
		end
	end
end

-- 遮罩
function Lua_HeroItemIcon:setMask(bState)
	if bState then
		if self.maskIcon == nil then
			self.maskIcon = UICreate.createUIAtlasImage(self.content, "hero_altas_1", "ui_hb_window_007", 0, 0, 0, 0)
			self.maskIcon:setScale(1.08, 1.08, 1.08)
		end
		self.maskIcon:setEnable(true)
	else
		if self.maskIcon then
			self.maskIcon:setEnable(false)
		end
	end
end

-- 勾选
function Lua_HeroItemIcon:setTick(bState)
	if bState then
		if self.tickIcon == nil then
			self.tickIcon = UICreate.createUIAtlasImage(self.content, "hero_altas_1", "ui_hb_window_010", 0, 0, 0, 0)
		end
		self.tickIcon:setEnable(true)
	else
		if self.tickIcon then
			self.tickIcon:setEnable(false)
		end
	end
end

function Lua_HeroItemIcon:setAdd(bState)
	if bState then
		if self.addIcon == nil then
			self.addIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_045_n", 0, 0, 0, 0)
		end
		self.addIcon:setEnable(true)
	else
		if self.addIcon then
			self.addIcon:setEnable(false)
		end
	end
end

function Lua_HeroItemIcon:showEffect(bValue)
	if not bValue or self.data == nil then
		if self.iconEff1 then
			self.iconEff1:setEnable(false);
			self.iconEff2:setEnable(false);
		end
	else
		if self.iconEff1 == nil then
			self.iconEff1 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_yx_xj_1001","ui_yx_xj_1001", 2, -88);
			self.iconEff2 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_yx_tx_1001","ui_yx_tx_1001", 8, 11);
		else
			self.iconEff1:setEnable(true);
			self.iconEff2:setEnable(true);
		end
	end
end