-- 英雄技能item
Lua_HeroSkillItem = class("Lua_HeroSkillItem", Lua_DisplayObject);
function Lua_HeroSkillItem:ctor(p)
    self:superCall("ctor", p, "HeroSkillItem_skin");
end

function Lua_HeroSkillItem:buildShowItem()
    self:superCall("buildShowItem");
    self.skill_icon:addClickFuntion(self, self.onBtnClick);
end

function Lua_HeroSkillItem:setData(data)
    self.skillVo = data.skillVo;
    self.skill_level = data.skill_level;

    self.skill_lvl.text = self.skill_level;
    self.skill_icon:setAltas(self.skillVo.atlas, self.skillVo.sprite);
    
    local bActivite = self.skill_level == 0;
    self.lvl_bg:setEnable(not bActivite);
    self.skill_lvl:setEnable(not bActivite);
    self.skill_mash:setEnable(bActivite);
    self.unlock_type = 1;
    self.skill_bg:SetDimensions(110,110);
    self.skill_mash:SetDimensions(92,92);
end

--连携技能
function Lua_HeroSkillItem:setConnectData(heroVo)
    self.heroVo = heroVo;
    
    if heroVo.otherLineup ~= nil then
        self.bActivite, self.connectVo = DataCenter.heroLineupData:checkConnectByProto(heroVo.otherLineup, heroVo.connectId);
    else
        if heroVo.isShowFight then--是否是主线
            self.bActivite, self.connectVo = DataCenter.heroLineupData:checkConnectByLineup(Lua_HeroUtil.LINEUP_MAIN_TYPE, 1, heroVo.connectId);
        else
            self.bActivite = false;
            self.connectVo = Lua_HeroConnectVo.new(heroVo.connectId);
        end
    end

    self.lvl_bg:SetDimensions(78,24);
    self.skill_mash:setEnable(not self.bActivite);
    self.skill_lvl.text = LanUtil.getValue(126065);
    self.skill_bg:setAltas("hero_altas_1","xui_hb_widget_16");
    self.skill_bg:SetDimensions(97,113);
    self.skill_mash:setAltas("hero_altas_1","xui_hb_widget_16_1");
    self.skill_mash:SetDimensions(79,95);
    self.unlock_type = 3;
    self.skillVo = Lua_SkillConfigData.getConfigData(heroVo.connectSkillId);
    if self.skillVo == nil then
        return
    end
    self.skill_icon:setAltas(self.skillVo.atlas, self.skillVo.sprite);
    self.skill_icon:resetSize();
end

function Lua_HeroSkillItem:setShowLevel(isShow)
    self.lvl_bg:setEnable(isShow);
    self.skill_lvl:setEnable(isShow);
end

function Lua_HeroSkillItem:onBtnClick(val)
    if self.skillVo == nil then
        return
    end

    local list = {skillVo = self.skillVo, skill_level = self.skill_level, 
    unlock_type = self.unlock_type, bActConnect = self.bActivite, connectVo = self.connectVo};
    Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, list);
end

function Lua_HeroSkillItem:dispose()
    self.heroVo = nil;
    self.skillVo = nil;
    self.connectVo = nil;
    self:superCall("dispose");
end