Lua_IconShowItem = class("Lua_IconShowItem", Lua_DisplayObject);
function Lua_IconShowItem:ctor(p)
	self:superCall("ctor", p, "IconShowItem_skin", false);
end

function Lua_IconShowItem:buildShowItem()
	self:superCall("buildShowItem");

	self.addBtn:setEnable(false);
end

function Lua_IconShowItem:dispose()
	self.iconOwner = nil;
	self.iconCallBack = nil;
	self.addOwner = nil;
	self.addCallBack = nil;
	self:superCall("dispose");
end

function Lua_IconShowItem:setBg(bShowBg, bgAltas, bgSprite, width, height, posX, posY)
	bShowBg = bShowBg == nil and true or bShowBg;
	bgAltas = bgAltas == nil and "common_altas_1" or bgAltas;
	bgSprite = bgSprite == nil and "ui_common_edit_003" or bgSprite;
	width = width == nil and 168 or width;
	height = height == nil and 32 or height;
	posX = posX == nil and -80 or posX;
	posY = posY == nil and 0 or posY;

	self.bg:setEnable(bShowBg);
	self.bg:setAltas(bgAltas, bgSprite);
	self.bg:SetDimensions(width, height);
	self.bg:setLocation(posX, posY);
end

function Lua_IconShowItem:setIcon(iconAtlas, icon, width, height)
	if iconAtlas ~= nil and icon ~= nil then
		self.icon:setAltas(iconAtlas, icon);
		if width ~= nil and width > 0 and height ~= nil and height > 0 then
			self.icon:SetDimensions(width, height);
		else
			self.icon:resetSize();
		end
	end
end

function Lua_IconShowItem:setTextFieldStyle(fontSize)
	self.count.fontSize = fontSize;
end

function Lua_IconShowItem:setCount(count, colorStr, effectColorStr)
	if effectColorStr == nil then
		self.count.effectStyle = 0;
	else
		self.count.effectStyle = 2;
		self.count.effectColorStr = Lua_ColorDefine.transColor(effectColorStr);
	end

	if colorStr == nil then
		self.count.colorStr = Lua_ColorDefine.transColor("FFFFFF");
	else
		self.count.colorStr = Lua_ColorDefine.transColor(colorStr);
	end
	
	self.count.text = count;
end

function Lua_IconShowItem:setIconClick(iconId, owner, callBack)
	self.iconId = iconId;
	self.icon:addClickFuntion(self, self.onIconClick);
	if owner ~= nil and callBack ~= nil then
		self.iconOwner = owner;
		self.iconCallBack = callBack;
	end
end

function Lua_IconShowItem:setAddClick(owner, callBack)
	-- if owner ~= nil and callBack ~= nil then
	-- 	self.addOwner = owner;
	-- 	self.addCallBack = callBack;
	-- 	self.addBtn:setEnable(true);
	-- 	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	-- end

	self.addBtn:setEnable(true);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	if owner ~= nil and callBack ~= nil then
		self.addOwner = owner;
		self.addCallBack = callBack;
	end

end

function Lua_IconShowItem:onIconClick(go)
	if self.iconOwner ~= nil and self.iconCallBack ~= nil then
        self.iconCallBack(self.iconOwner);
        return;
    end
    if self.iconId ~= nil then
    	DataCenter.packUtil:openPathWindow(self.iconId, false);
    end
end

function Lua_IconShowItem:onAddBtnClick(go)
	if self.addOwner ~= nil and self.addCallBack ~= nil then
        self.addCallBack(self.addOwner);
        return;
    end
    if self.iconId ~= nil then
    	DataCenter.packUtil:openPathWindow(self.iconId, false);
    end
end