-- 图标跳转
Lua_IconSkipItem = class("Lua_IconSkipItem", Lua_DisplayObject)
function Lua_IconSkipItem:buildShowItem()
    self:superCall("buildShowItem");

    self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
    self.icon.name = "icon"; -- 引导用
    self.icon:addClickFuntion(self, self.onPressClick);

    self.nameText = UICreate.createLabel(self.content, nil, 0, -60, 100, 31, 28);
    self.nameText.pivotValue = 4;
    self.nameText.alignmentValue = 4;
    self.nameText.horizontalOverflowValue = 1;
    self.nameText.verticalOverflowValue = 1;
    self.nameText.fontName = Lua_MyUISettings.huakangFontName;
    self.nameText.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
end

function Lua_IconSkipItem:dispose()
    self.icon = nil;
    self.nameText = nil;
    self.owner = nil;
    self.callBack = nil;
    self.data = nil;
    self:superCall("dispose");
end

function Lua_IconSkipItem:setClick(owner, callBack)
    self.owner = owner;
    self.callBack = callBack;
end

function Lua_IconSkipItem:setData(data)
    self.content.name = "Lua_IconSkipItem"..data;-- 引导用
    self.data = DataCenter.funcPathUtil:getFuncPathVo(data)
    if self.data then
        self.icon:setAltas(self.data.icon_atlas, self.data.icon_sprite);
        self.nameText.text = self.data.name;
    end
end

function Lua_IconSkipItem:onPressClick(go)
    if self.clickTime ~= nil and getTime() - self.clickTime < 1 then
        return;
    end
    self.clickTime = getTime();
    
    if self.owner and self.callBack then
        self.callBack(self.owner, self.data.id);
    end
end