-- DragList子对象 用于显示单个道具
Lua_ItemIconCell = class("Lua_ItemIconCell", Lua_ListCell)
function Lua_ItemIconCell:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
end

function Lua_ItemIconCell:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ItemIconCell:setData(data)
	if data == nil then
		return;
	end

	if type(data) == "table" then
		if data.classname ~= nil then
			self.data = data;
		else
			if data.id == nil then -- 配置表数据
				self.data = Lua_ToolVo.createToolVo(data[1], data[2]);
			else -- 服务端数据
				self.data = Lua_ToolVo.createToolVo(data.id);
                self.data:fromServer(data);
			end
		end
	else
		if self.data == nil then
			self.data = Lua_ToolVo.createToolVo(data);
		else
			self.data:setData(data);
		end
	end

	self.itemIcon:setData(self.data);
end

function Lua_ItemIconCell:onPressClick()
    if self.data == nil then
        return;
    end
    DataCenter.packUtil:showItemInfo(self.data);
end




















Lua_ItemIconCell2 = class("Lua_ItemIconCell2", Lua_ItemIconCell)
function Lua_ItemIconCell2:buildShowItem()
	self:superCall("buildShowItem")

	self.itemIcon:setScale(0.8, 0.8, 1)
end