Lua_MoneyItem = class("Lua_MoneyItem", Lua_DisplayObject);
function Lua_MoneyItem:ctor(p, canClick)
	self.canClick = canClick == nil and 1 or canClick;
	self:superCall("ctor", p, "MoneyItem_skin", true);
end

function Lua_MoneyItem:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("MONEY_UPDATE", self, self.onMoneyUpdate);
end

function Lua_MoneyItem:dispose()
	TweenUtil.getInstance():stop(self.moneyObject);
	self:superCall("dispose");
end

function Lua_MoneyItem:setCanClick(bCan)
	if bCan == true then
		self.clickArea:addClickFuntion(self, self.onBtnAddClick);
	else
		self.clickArea:removeClickFuntion(self, self.onBtnAddClick);
	end
end

function Lua_MoneyItem:onBtnAddClick(go)
	if self.moneyType == Lua_ResourcesDefine.GOLD then
		DataCenter.funcPathUtil:gotoFunction(1075)
	elseif self.moneyType == Lua_ResourcesDefine.DIAMOND then
		DataCenter.funcPathUtil:gotoFunction(1024)
	else
		DataCenter.packUtil:openPathWindow(self.moneyType, false);
	end
end

function Lua_MoneyItem:setMoneyType(moneyType, fontColor, bShowAdd)
	self.moneyType = moneyType;
	fontColor = fontColor == nil and "FFF7D9" or fontColor;
	if bShowAdd == nil then
		bShowAdd = true
	end

	local resourceData = Lua_ResourcesData.getConfigDataById(moneyType);
	if moneyType == Lua_ResourcesDefine.DIAMOND then
		self.icon:setAltas("common_altas_1", "xui_common_icon_008");
		self.icon:SetDimensions(30, 28);
	elseif moneyType == Lua_ResourcesDefine.GOLD then
		self.icon:setAltas("common_altas_1", "xui_common_icon_007");
		self.icon:SetDimensions(30, 28);
	else
		self.icon:setAltas(resourceData.iconAtlas, resourceData.iconSprite);
		self.icon:SetDimensions(30, 30);
		-- self.icon:SetDimensions(resourceData.iconWidth, resourceData.iconHeight);
	end

	self.count.colorStr = Lua_ColorDefine.transColor(fontColor);
	self.count.text = numberTrans(DataCenter.moneyData:getMoney(self.moneyType));
	self.btnAdd:setEnable(bShowAdd);

	self:createRedPoint()
end

function Lua_MoneyItem:setPlayTween(bTween)
	self.bPlayTween = bTween;
end

function Lua_MoneyItem:onMoneyUpdate(dic)
	if self.moneyType == nil or dic == nil or dic[self.moneyType] == nil then
		return;
	end

	self.count.text = numberTrans(DataCenter.moneyData:getMoney(self.moneyType));
	if self.bPlayTween == true then
		LuaUtil.setObjScale(self.moneyObject, 1.08, 1.08, 1.08);
		TweenUtil.getInstance():stop(self.moneyObject);
		TweenUtil.getInstance():addTweenTargetScale(self.moneyObject, 0.6, 0, 1, 1, 1, 0, false);
	end
end

function Lua_MoneyItem:createRedPoint()
	if self.moneyType == Lua_ResourcesDefine.GOLD then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content, Lua_RedPointList.Alchemy)
			self.redPointIcon:setLocation(50, 10)
		end
		self.redPointIcon:setEnable(true)
	else
		if self.redPointIcon then
			self.redPointIcon:setEnable(false)
		end
	end
end