Lua_NumberInputItem = class("Lua_NumberInputItem", Lua_DisplayObject)
function Lua_NumberInputItem:ctor(p)
	self:superCall("ctor", p, "NumberInputItem_skin");
end
function Lua_NumberInputItem:buildShowItem()
	self:superCall("buildShowItem");

	self.inputText.keyboardTypeValue = 12;
	self.inputText.contentTypeValue =  2;
	-- 字符验证Integer
	self.inputText.characterValidationValue = 1;
	self.inputText:onChange(self, self.onInputChange);
	self.inputText:onEndEdit(self, self.onInputEnd);
	self:setValue(0, 0, 100);

	self.btnLess:addClickFuntion(self, self.onLessBtnClick);
	self.btnPlus:addClickFuntion(self, self.onPlusBtnClick);
	self.btnMin:addClickFuntion(self, self.onMinBtnClick);
	self.btnMax:addClickFuntion(self, self.onMaxBtnClick);
end

function Lua_NumberInputItem:dispose()
	self.owner = nil;
	self.callBack = nil;
	self:superCall("dispose");
end

function Lua_NumberInputItem:setMinMaxEnable(minShow, maxShow)
	self.btnMin:setEnable(minShow);
	self.btnMax:setEnable(maxShow);
end

function Lua_NumberInputItem:setCallBack(owner, callBack)
	self.owner = owner;
	self.callBack = callBack;
end

function Lua_NumberInputItem:setTips(minTips, maxTips)
	self.minTips = minTips;
	self.maxTips = maxTips;
end

function Lua_NumberInputItem:setValue(curNum, minNum, maxNum)
	self.curNum = curNum;
	self.minNum = minNum;
	self.maxNum = maxNum;
	self:updateNum();
end

function Lua_NumberInputItem:onInputChange()
	self.curNum = tonumber(self.inputText.text);
end

function Lua_NumberInputItem:onInputEnd()
	self:updateNum();
end

function Lua_NumberInputItem:onLessBtnClick(go)
	self.curNum = self.curNum - 1;
	self:updateNum();
end

function Lua_NumberInputItem:onPlusBtnClick(go)
	self.curNum = self.curNum + 1;
	self:updateNum();
end

function Lua_NumberInputItem:onMinBtnClick(go)
	self.curNum = self.minNum
	self:updateNum();
end

function Lua_NumberInputItem:onMaxBtnClick(go)
	self.curNum = self.maxNum;
	self:updateNum();
end

function Lua_NumberInputItem:updateNum()
	self.curNum = self.curNum == nil and self.minNum or self.curNum;
	if self.curNum < self.minNum then
		self.curNum = self.minNum;
		if not strIsNullOrEmpty(self.minTips) then
			OperateAlert.show(self.minTips);
		end
	elseif self.curNum > self.maxNum then
		self.curNum = self.maxNum;
		if not strIsNullOrEmpty(self.maxTips) then
			OperateAlert.show(self.maxTips);
		end
	end
	self.inputText.text = tostring(self.curNum);

	if self.owner ~= nil and self.callBack ~= nil then
		self.callBack(self.owner, self.curNum);
	end
end

-- 移除点击事件
function Lua_NumberInputItem:removeClickFun()
	self.btnLess:removeClickFuntion(self, self.onLessBtnClick);
	self.btnPlus:removeClickFuntion(self, self.onPlusBtnClick);
	self.btnMin:removeClickFuntion(self, self.onMinBtnClick);
	self.btnMax:removeClickFuntion(self, self.onMaxBtnClick);
end

function Lua_NumberInputItem:setBtnGray(value)
	self.btnLess:setGray(value);
	self.btnPlus:setGray(value);
	self.btnMin:setGray(value);
	self.btnMax:setGray(value);
end