Lua_ScrollBoardCell = class("Lua_ScrollBoardCell", Lua_DisplayObject);
function Lua_ScrollBoardCell:ctor(p, skin)
	self.frameBuild = false;
	self:superCall("ctor", p, skin, false);
	self.itemX = 0;
	self.itemY = 0;
    self.minX = 0;
    self.maxX = 0;
    self.minY = 0;
    self.maxY = 0;
end

function Lua_ScrollBoardCell:checkSaveParam(key)
	if key == "onBuildingItem" or key == "checkSaveParam" or key == "saveFunKey" or key == "saveParam" or key == "setLocation" or key == "setBoxSize" then
		return false;
	end
	return self.skinBuilded == false;
end

function Lua_ScrollBoardCell:setLocation(posx, posy, posz)
	self:superCall("setLocation", posx, posy, posz);
	self.itemX = posx;
	self.itemY = posy;
	if self.boxW ~= nil then
		self.minX = posx - self.boxW / 2;
		self.maxX = posx + self.boxW / 2;
	end
	if self.boxH ~= nil then
		self.minY = posy - self.boxH / 2;
		self.maxY = posy + self.boxH / 2;
	end
end

function Lua_ScrollBoardCell:setLocationOffset(posx, posy, posz)
    self:setLocation(self.itemX + posx, self.itemY + posy, 0);
end

function Lua_ScrollBoardCell:isBounds(posx, posy)
	if posx >= self.minX and posx <= self.maxX and posy >= self.minY and posy <= self.maxY then
		return true;
	end
	return false;
end

function Lua_ScrollBoardCell:setBoxSize(boxW, boxH)
	self.boxW = boxW;
	self.boxH = boxH;
end

function Lua_ScrollBoardCell:setData(data)
	
end

function Lua_ScrollBoardCell.Set:showIndex(value)
	self._showIndex = value;
	self.content.name = self.classname..tostring(self._showIndex);
end

function Lua_ScrollBoardCell.Get:showIndex()
	return self._showIndex;
end

function Lua_ScrollBoardCell:onPressClick(idx)
    
end