--技能图标icon
Lua_SkillIconItem = class("Lua_SkillIconItem", Lua_DisplayObject);
function Lua_SkillIconItem:ctor(p)
	self:superCall("ctor", p);
	self.skill_level = nil; -- 技能等级 （不显示等级的技能不赋值）
	self.unlock_type = nil;	-- 解锁类型 1:需要解锁条件，展示所有等级技能描述，2:需要解锁条件，展示满足解锁等级的技能描述 nil:无需条件，展示配置所有等级技能描述
	self.unlock_level = nil;-- 解锁等级 (现在神器使用)
	self.extra_des = nil;	-- 额外描述效果展示
end

function Lua_SkillIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.iconBg = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_widget_017", 0, 0, 0, 0);
	self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 92, 92);
end

function Lua_SkillIconItem:dispose()
	self.iconBg = nil;
	self.icon = nil;
	self.levelText = nil;
	self.rarityIcon = nil;
	self.owner = nil
	self.callBack = nil
	self.data = nil;
	self.mask = nil;
	self:superCall("dispose");
end

function Lua_SkillIconItem:checkInBound(touchX, touchY)
	local posX = self.posX or 0
	local posY = self.posY or 0
	local scaleX = self.scaleX or 1
	local scaleY = self.scaleY or 1
	local minX = posX - self.icon.width / 2 * scaleX
	local maxX = posX + self.icon.width / 2 * scaleX
	local minY = posY - self.icon.height / 2 * scaleY
	local maxY = posY + self.icon.height / 2 * scaleY
	if touchX >= minX and touchX <= maxX and touchY >= minY and touchY <= maxY then
		return true
	end
	return false
end

function Lua_SkillIconItem:setBg(atlas, sprite)
	self.iconBg:setAltas(atlas, sprite)
	self.iconBg:resetSize()
end

function Lua_SkillIconItem:setBgAlpha(val)
	self.iconBg.alpha = val;
end

function Lua_SkillIconItem:setCanClick(bClick, owner, callBack)
	self.icon.mouseEnable = bClick;
	self.owner = owner
	self.callBack = callBack
	if bClick == true then
		self.icon:addClickFuntion(self, self.onCheckSkill);
	else
		self.icon:removeClickFuntion(self, self.onCheckSkill);
	end
end

function Lua_SkillIconItem:setSkillId(id)
	if id and id > 0 then
		self:setData(Lua_SkillConfigData.getConfigData(id));
	else
		self:setData(nil);
	end
end

function Lua_SkillIconItem:setData(data)
	self.data = data;
	if data == nil then
		self.icon:setEnable(false);
	else
		self.icon:setEnable(true);
		self.icon.name = data.skillId;
		self.icon:setAltas(data.atlas, data.sprite);
		self.icon:resetSize();
	end
	if self.rarityIcon then self.rarityIcon:setEnable(false); end
	if self.lockIcon then self.lockIcon:setEnable(false); end
	if self.nameText then self.nameText:setEnable(false); end
	self:showLevel();
	self:showEnergy();
end

--展示稀有图标
function Lua_SkillIconItem:setRarityIcon(rarity)
	if rarity ~= nil and rarity > 0 then
		if self.rarityIcon == nil then
			self.rarityIcon = UICreate.createUIAtlasImage(self.content, nil, nil, -33, 37, 0, 0);
		end
		self.rarityIcon:setAltas("common_altas_2", "xui_fs_label_"..rarity);
		self.rarityIcon:setEnable(true);
	else
		if self.rarityIcon ~= nil then
			self.rarityIcon:setEnable(false);
		end
	end
end

-- 锁
function Lua_SkillIconItem:setLock(bState)
	self.icon:setEnable(not bState);
	if bState then
		if self.lockIcon == nil then
			self.lockIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_button_023", 0, 0, 0, 0);
		end
		self.lockIcon:setEnable(true);
	else
		if self.lockIcon ~= nil then
			self.lockIcon:setEnable(false);
		end
	end
end

-- 遮罩
function Lua_SkillIconItem:setMask(bState)
	self.icon:setEnable(not bState);
	if bState then
		if self.mask == nil then
			self.mask = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_fs_widget_06", 0, 0, 0, 0);
		end
		self.mask:setEnable(true);
	else
		if self.mask ~= nil then
			self.mask:setEnable(false);
		end
	end
end

function Lua_SkillIconItem:showName(color)
	if self.data == nil then return end
	if self.nameText == nil then
		self.nameText = UICreate.createLabel(self.content, nil, 0, -73, 100, 31, 24)
		self.nameText.alignmentValue = 4
		self.nameText.pivotValue = 4
		self.nameText.horizontalOverflowValue = 1
	end
	-- 这里是神器技能的色值
	if color == 2 then
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("459252")
	elseif color == 3 then
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("159EC5")
	elseif color == 4 then
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("C616B7")
	elseif color == 5 then
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("FF9702")
	elseif color == 6 then
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("ED4C30")
	else
		self.nameText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
	end
	self.nameText:setEnable(true);
	self.nameText.text = self.data.name
end

function Lua_SkillIconItem:showLevel()
	if self.data == nil then
		if self.levelBg then
			self.levelBg:setEnable(false);
			self.levelText:setEnable(false);
		end
	elseif self.data.artifactId > 0 then
		if self.levelBg == nil then
			self.levelBg = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_hx_window_16", 35, 38, 0, 0)

			self.levelText = UICreate.createLabel(self.content, nil, 35, 38, 100, 31, 22)
			self.levelText.pivotValue = 4
			self.levelText.fontName = Lua_MyUISettings.fangzhengFontName
			self.levelText.alignmentValue = 4
			self.levelText.horizontalOverflowValue = 1
			self.levelText.verticalOverflowValue = 1
			self.levelText:setEffectDistance(2, 2)
		end
		self.levelBg:setEnable(true);
		self.levelText:setEnable(true);
		self.levelText.text = self.data.level;
	end
end

function Lua_SkillIconItem:showEnergy()
	if self.data == nil then
		if self.energyIcon then
			self.energyIcon:setEnable(false);
			self.energyText:setEnable(false);
		end
	elseif self.data.artifactId > 0 then
		if self.energyIcon == nil then
			self.energyIcon = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_hx_title_5", 0, -40, 0, 0)
			self.energyIcon:setScale(0.8, 0.8, 1)

			self.energyText = UICreate.createLabel(self.content, nil, 0, -47, 100, 31, 22)
			self.energyText.alignmentValue = 4
			self.energyText.pivotValue = 4
			self.energyText.horizontalOverflowValue = 1
			self.energyText.verticalOverflowValue = 1
			self.energyText.effectStyle = 2
			self.energyText.effectColorStr = Lua_ColorDefine.transColor("000000")
			self.energyText:setEffectDistance(2, 2)
		end
		self.energyIcon:setEnable(true);
		self.energyText:setEnable(true);
		self.energyText.text = self.data.costEnergy;
	end
end

function Lua_SkillIconItem:setGray(value)
	self.icon:setGray(value)
	if self.rarityIcon then self.rarityIcon:setGray(value) end
end

function Lua_SkillIconItem:onCheckSkill(go)
	if self.data == nil then
		return;
	end

	if self.owner and self.callBack then
		self.callBack(self.owner, self.data);
		return
	end

	if self.data.subType == 1 then
		Lua_WindowUtil.openWin("Lua_HeroAwakenSkillDetailsWindow", Lua_WinParam.ACTION_OPEN, self.data);
	elseif self.data.artifactId > 0 then
		Lua_WindowUtil.openWin("Lua_ArtifactSkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.data);
	else
		local param = { skillVo = self.data, skill_level = self.skill_level, unlock_type = self.unlock_type,
			unlock_level = self.unlock_level, extra_des = self.extra_des
		};
		Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, param);
	end
end
