-- 自定义拼接文本
Lua_SpliceTextItem = class("Lua_SpliceTextItem", Lua_DisplayObject)
function Lua_SpliceTextItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_SpliceTextItem:buildShowItem()
	self:superCall("buildShowItem")
	self.pivot = 0
	self.spaceWidth = 0

	self.leftText = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 22)
	self.leftText.pivotValue = 4
	self.leftText.alignmentValue = 4
	self.leftText.horizontalOverflowValue = 1
	self.leftText.verticalOverflowValue = 1

	self.rightText = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 22)
	self.rightText.pivotValue = 4
	self.rightText.alignmentValue = 4
	self.rightText.horizontalOverflowValue = 1
	self.rightText.verticalOverflowValue = 1
end

function Lua_SpliceTextItem:dispose()
	self:superCall("dispose")
end

-- 1:从左往右 0:居中 -1:从右往左
function Lua_SpliceTextItem.Set:pivot(value)
    self._pivot = value
end

-- function Lua_SpliceTextItem.Get:pivot()
--     return self._pivot
-- end

function Lua_SpliceTextItem.Get:totalWidth()
    return (self._totalWidth or 0) + self.spaceWidth
end

function Lua_SpliceTextItem:setLeftStyle(fontName, fontSize, colorStr, effectStyle, effectColor, effectDistanceX, effectDistanceY)
	self.leftText.fontName = fontName or Lua_MyUISettings.defaultFontName
	self.leftText.fontSize = fontSize or 22
	self.leftText.colorStr = Lua_ColorDefine.transColorStr(colorStr or "FFFFFF")
	self.leftText.effectStyle = effectStyle or 0
	self.leftText.effectColorStr = Lua_ColorDefine.transColorStr(effectColor or "000000")
	self.leftText:setEffectDistance(effectDistanceX or 1, effectDistanceY or 11)
end

function Lua_SpliceTextItem:setRightStyle(fontName, fontSize, colorStr, effectStyle, effectColor, effectDistanceX, effectDistanceY)
	self.rightText.fontName = fontName or Lua_MyUISettings.defaultFontName
	self.rightText.fontSize = fontSize or 22
	self.rightText.colorStr = Lua_ColorDefine.transColorStr(colorStr or "FFFFFF")
	self.rightText.effectStyle = effectStyle or 0
	self.rightText.effectColorStr = Lua_ColorDefine.transColorStr(effectColor or "000000")
	self.rightText:setEffectDistance(effectDistanceX or 1, effectDistanceY or 11)
end

function Lua_SpliceTextItem:setData(leftStr, rightStr)
	self.leftText.text = leftStr
	self.leftText:resetSize()

	self.rightText.text = rightStr
	self.rightText:resetSize()

	self._totalWidth = self.leftText.width + self.rightText.width
	if self._pivot == 1 then
		self.leftText.pivotValue = 3
		self.leftText.alignmentValue = 3
		self.leftText:setLocation(0, 0, 0)

		self.rightText.pivotValue = 3
		self.rightText.alignmentValue = 3
		self.rightText:setLocation(self.leftText.width + self.spaceWidth, 0, 0)
	elseif self._pivot == -1 then
		self.rightText.pivotValue = 5
		self.rightText.alignmentValue = 5
		self.rightText:setLocation(0, 0, 0)

		self.leftText.pivotValue = 5
		self.leftText.alignmentValue = 5
		self.leftText:setLocation(-self.rightText.width - self.spaceWidth, 0, 0)
	else
		self.leftText.pivotValue = 5
		self.leftText.alignmentValue = 5

		self.rightText.pivotValue = 3
		self.rightText.alignmentValue = 3

		if self.leftText.width > self.rightText.width then
			local value = self.leftText.width - (self._totalWidth / 2)
			self.leftText:setLocation(value - self.spaceWidth / 2, 0, 0)
			self.rightText:setLocation(value + self.spaceWidth / 2, 0, 0)
		elseif self.leftText.width < self.rightText.width then
			local value = self.rightText.width - (self._totalWidth / 2)
			self.leftText:setLocation(-value - self.spaceWidth / 2, 0, 0)
			self.rightText:setLocation(-value + self.spaceWidth / 2, 0, 0)
		else
			self.leftText:setLocation(-self.spaceWidth / 2, 0, 0)
			self.rightText:setLocation(self.spaceWidth / 2, 0, 0)
		end
	end
end