Lua_TipsBaseWindow = class("Lua_TipsBaseWindow", Lua_Window)
function Lua_TipsBaseWindow:ctor()
	self:superCall("ctor")
	
	self.w = 684
	self.h = 408
	self.layer = MainWinDefine.TIPS_WINDOW_LAYER
	self.showBlackMask = true
	self.showWinBg = true
	self.winBgAtlas = "common_altas_1"
	self.winBgSprite = "xui_common_window_003"
	self.showTitle = true
	self.titleText = LanUtil.getValue(100000)
	self.titleNamePosY = 152
	self.bShowTitleDeco = true
	self.showClose = true
	self.btnCloseAtlas = "common_altas_1"
	self.btnCloseSprite = "xui_common_button_003_n"
	self.btnClosePosX = 321
	self.btnClosePosY = 182
	self.isClickClose = true

	self.showCancel = true
	self.showSure = true
end

function Lua_TipsBaseWindow:buildShowItem()
	self:superCall("buildShowItem")

	local posY = -(self.h / 2 - 61)
	if self.showCancel and self.btnCancel == nil then
		self.btnCancel = UICreate.createButton(self.content, nil, -174, posY, 220, 67)
		self.btnCancel.name = "btnCancel"
		self.btnCancel:setStyle(3)
		self.btnCancel:setLangValue(100001)
		self.btnCancel:addClickFuntion(self, self.onCancelClick)
	end

	if self.showSure and self.btnSure == nil then
		self.btnSure = UICreate.createButton(self.content, nil, 0, 0, 220, 67)
		self.btnSure.name = "btnSure"
		if self.showCancel then
			self.btnSure:setLocation(174, posY, 0)
		else
			self.btnSure:setLocation(0, posY, 0)
		end
		self.btnSure:setStyle(1)
		self.btnSure:setLangValue(100002)
		self.btnSure:addClickFuntion(self, self.onSureClick)
	end

	self:updateWin()
end

function Lua_TipsBaseWindow:dispose()
	self.lineImg = nil
	self.btnCancel = nil
	self.btnSure = nil
	self:superCall("dispose")
end

function Lua_TipsBaseWindow:updateWin()
	local value = self.h - 408
	self:createTitleName(self.titleNamePosX, self.titleNamePosY + value)
	self:createTitleDeco(self.titleNamePosY + value)
	self:createBtnClose(self.btnClosePosX, self.btnClosePosY + value, 0, self.btnCloseAtlas, self.btnCloseSprite)

	local posY = -(self.h / 2 - 61) + value
	if self.showCancel then
		self.btnCancel:setLocation(-174, posY, 0)
	end
	if self.showSure then
		if self.showCancel then
			self.btnSure:setLocation(174, posY, 0)
		else
			self.btnSure:setLocation(0, posY, 0)
		end
	end
end

function Lua_TipsBaseWindow:onCancelClick(go)
	self:hide()
end

function Lua_TipsBaseWindow:onSureClick(go)

end