--联盟系统 联盟信息Vo
Lua_AllianceInfoVo = class("Lua_AllianceInfoVo");

function Lua_AllianceInfoVo:ctor(data)
	if data ~= nil then
		self:fromServer(data);
	end
end

function Lua_AllianceInfoVo:dispose()
end

function Lua_AllianceInfoVo:fromServer(msg)
	self.id = tonumber(tostring(msg.id));--联盟id
	self.head = msg.head;--联盟头像
	self.name = msg.name;--联盟名称
	self.level = msg.level;--联盟等级
	self.memberAmount = msg.member_amount;--当前成员数
	self.maxMember = msg.max_member;--最大成员数上限
	self.force = tonumber(tostring(msg.force));--战力
	self.rank = msg.rank;--排名
	self.hasApply = msg.has_apply;--是否已申请加入该联盟, 0 未申请，1 已申请
	self.levelCond = msg.level_cond;--等级条件
	self.forceCond = msg.force_cond;--战力条件
	self.autoJoin = msg.auto_join;--自动加入 1:自动加入 0：不自动加入
	self.declaration = msg.declaration;--联盟宣言
	self.leaderName = msg.leader_name;--会长名字
	self.buildExp = tonumber(tostring(msg.build_val));--建设值
	self.leftMailNum = msg.left_mail_num;--当日群发邮件次数
	self.startDiscussTick = tonumber(tostring(msg.start_discuss_tick));--开始解散联盟时间
	self.serverFlag = msg.server_flag; -- 服务器标识
	self.serverPrev = msg.server_prev; -- 服务器前缀
end

function Lua_AllianceInfoVo.Get:curLevelVo()
	if self._curLevelVo == nil or self._curLevelVo.id ~= self.level then
		self._curLevelVo = Lua_AllianceLevelVo.new(self.level);
	end
	return self._curLevelVo;
end

function Lua_AllianceInfoVo.Get:isMaxMember()
	return self.memberAmount >= self.maxMember;
end

function Lua_AllianceInfoVo.Get:getDiscussRemainTime()
	if self.startDiscussTick == nil or tonumber(self.startDiscussTick) <= 0 then
		return 0;
	end

	if self._dissolveSureTime == nil then
		self._dissolveSureTime = DataCenter.allianceUtil:getConstConfig("league_dissolve_sure_time", 1);
	end
	return self._dissolveSureTime - (DataCenter.roleData.serverTime - self.startDiscussTick);
end

function Lua_AllianceInfoVo.Get:showLeagueName()
	if DataCenter.allianceData.isOpenKuafu and not strIsNullOrEmpty(self.serverPrev) then
		return LanUtil.formateStr(201249, self.name, self.serverPrev);
	else
		return self.name;
	end
end