Lua_ChampionshipData = class("Lua_ChampionshipData")
function Lua_ChampionshipData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_ChampionshipData:dispose()
	self.is_draw_red_pack = 0; -- 是否领取本轮红包 1已领取 0未领取
	self.quizLvStateDic = nil;
	self.likeTimes = 0;
end

-- 当前排名
function Lua_ChampionshipData.Get:curRank()
	return self._cur_rank or 0
end

-- 历史最高排名
function Lua_ChampionshipData.Get:historyRank()
	return self._history_rank or 0
end

-- 是否进入本轮比赛 1：进入 0:未进入
function Lua_ChampionshipData.Get:isEnter()
	return self._is_enter or 0
end

-- 当前开始时间
function Lua_ChampionshipData.Get:startTick()
	return self._start_tick or 0
end

-- 当前比赛结束时间
function Lua_ChampionshipData.Get:endTick()
	return self._end_tick or 0
end

-- 剩余点赞次数
function Lua_ChampionshipData.Get:leftPariseTimes()
	return self._left_praise_times or 0
end

function Lua_ChampionshipData.Set:leftPariseTimes(value)
	self._left_praise_times = value
end

-- 斗技场排名
function Lua_ChampionshipData.Get:arenaRank()
	return self._arena_rank or 0
end

-- 上场比赛前3名
function Lua_ChampionshipData.Get:topPlayerList()
	return self._player_list
end

-- 阶段信息
function Lua_ChampionshipData.Set:stageInfo(value)
	local state = false;
	if value ~= nil and DataCenter.roleData:checkInTime(self.startTick, self.endTick) then
		local serverTime = DataCenter.roleData.serverTime
		if serverTime > tonumber(value.prepare_end_tick) and serverTime < tonumber(value.guress_end_tick) then -- 竞猜阶段
			state = true;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Championship_QuizTips, state);

	self._stageInfo = value
end

function Lua_ChampionshipData.Get:stageInfo()
	return self._stageInfo
end

-- 获胜的玩家Id
function Lua_ChampionshipData.Get:winPlayerId()
	return self._win_player_id or 0
end

-- 战斗记录Id
function Lua_ChampionshipData.Get:fightRecordId()
	return self._fight_record_id or 0
end

-- 攻方角色
function Lua_ChampionshipData.Get:attRole()
	return self._att_role
end

-- 守方角色
function Lua_ChampionshipData.Get:defRole()
	return self._def_role
end

function Lua_ChampionshipData.Get:guessLevel()
	return self._guess_level or 0
end

-- 匹配记录
function Lua_ChampionshipData.Get:matchRecordList()
	return self._match_record_list
end

function Lua_ChampionshipData:fromServer80148011(msg)
	if msg == nil then
		return;
	end
	
	self.stageInfo = msg.stage_info;
	DataCenter.roleData.serverTime = msg.server_tick;
end

function Lua_ChampionshipData:fromServer80148023(msg)
	if msg == nil then
		return;
	end

	local info
	for i = 1, #msg.red_point_state do
		info = msg.red_point_state[i]
		if info.key == 1 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Championship_MySchedule, info.value == 1);
		elseif info.key == 2 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Championship_Quiz_RedEnvelope, info.value == 1);
		elseif info.key == 3 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Championship_Quiz_Title_Task, info.value == 1);
		elseif info.key == 4 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Championship_Quiz_Title_Reward, info.value == 1);
		end
	end
end

function Lua_ChampionshipData:fromServer50148020(msg)
	if msg == nil then
		return;
	end
	self._cur_rank = msg.cur_rank;
	self._history_rank = msg.history_rank;
	self._is_enter = msg.is_enter;
	self._start_tick = tonumber(msg.start_tick);
	self._end_tick = tonumber(msg.end_tick);
	self._left_praise_times = msg.left_praise_times;
	self._arena_rank = msg.arena_rank;
	self._player_list = msg.player_list;
	self.stageInfo = msg.stage_info;
end

function Lua_ChampionshipData:fromServer50148021(msg)
	if msg == nil then
		return;
	end
	self._is_enter = msg.is_enter;
	self._win_player_id = msg.win_player_id;
	self._fight_record_id = msg.fight_record_id;
	self.stageInfo = msg.stage_info;
	self._att_role = msg.att_role;
	self._def_role = msg.def_role;
	self._match_record_list = msg.match_record_list;
end

function Lua_ChampionshipData:fromServer50148004(msg)
	if msg == nil then
		return;
	end
	self.stageInfo = msg.stage_info;
end

function Lua_ChampionshipData:fromServer50148013(msg)
	if msg == nil then
		return;
	end

	self._guess_level = msg.guess_level; -- 竞猜等级
	if msg.task_info ~= nil then
		local vo;
		for i = 1, #msg.task_info do
			vo = DataCenter.championshipUtil:getTaskVo(msg.task_info[i].key);
			vo:fromServerInfo(msg.task_info[i]);
		end
	end
end

function Lua_ChampionshipData:fromServer50148014(msg)
	if msg == nil then
		return;
	end

	if self.quizLvStateDic == nil then
		self.quizLvStateDic = {};
	end
	local obj;
	for i = 1, #msg.reward_info do
		obj = msg.reward_info[i];
		self.quizLvStateDic[obj.key] = obj.value;
	end
end

function Lua_ChampionshipData:getQuizLevelState(id)
	if self.quizLvStateDic == nil or self.quizLvStateDic[id] == nil then
		return 0;
	end
	return self.quizLvStateDic[id];
end