checkRequire("Lua_ChampionshipQuizTaskVo");
Lua_ChampionshipUtil = class("Lua_ChampionshipUtil");
function Lua_ChampionshipUtil:ctor()
	self:superCall("ctor");
end

function Lua_ChampionshipUtil:dispose()
	self.taskDic = nil;
end

function Lua_ChampionshipUtil.Get:openShowReward()
	return getConfig("classic_event_const", "open_show_reward", "arr_value")
end

function Lua_ChampionshipUtil.Get:praiseNum()
	return getConfig("classic_event_const", "praise_num", "value")
end

function Lua_ChampionshipUtil.Get:guessItemId()
	return getConfig("classic_event_const", "guess_item", "value")
end

function Lua_ChampionshipUtil.Get:guessLimit()
	return getConfig("classic_event_const", "guess_limit", "value")
end

function Lua_ChampionshipUtil.Get:redEnvelopeTweenInterval()
	return getConfig("classic_event_const", "red_envelope_tween_interval", "float_value") or 5
end

function Lua_ChampionshipUtil.Get:fireRandomParam()
	return getConfig("classic_event_const", "fire_random_param", "arr_value")
end

function Lua_ChampionshipUtil:getTaskVo(id)
	if self.taskDic == nil then
		self.taskDic = {};
	end
	if self.taskDic[id] == nil then
		local config = getConfig("classic_event_guess_task", id)
		if config == nil then
			return nil;
		end
		self.taskDic[id] = Lua_ChampionshipQuizTaskVo.new(id, config);
	end
	return self.taskDic[id];
end

function Lua_ChampionshipUtil:getTaskArr()
	if self.taskArr == nil then
		self.taskArr = Array();
		local config = getConfig("classic_event_guess_task");
		for k, _ in pairs(config) do
			self.taskArr:add(k);
		end
	end
	quickSortf(self.taskArr, self, self.taskSortFun);
	return self.taskArr;
end

function Lua_ChampionshipUtil:taskSortFun(a, b)
	a = self:getTaskVo(a);
	b = self:getTaskVo(b);
	if a.rState == b.rState then
		if a.sort > b.sort then
			return true;
		end
	else
		if a.rState == 2 and b.rState ~= 2 then
			return true;
		elseif a.rState ~= 1 and b.rState == 1 then
			return true;
		end
	end
	return false;
end

function Lua_ChampionshipUtil:getRankRewardArr()
	if self.rankRewardArr == nil then
		self.rankRewardArr = Array();
		local config = getConfig("classic_event_rank_reward")
		for _, v in pairs(config) do
			self.rankRewardArr:add(v);
		end
		quickSort(self.rankRewardArr, "id", true);
	end
	return self.rankRewardArr;
end

function Lua_ChampionshipUtil:getLevelRewardArr()
	if self.levelRewardArr == nil then
		self.levelRewardArr = Array();
		local config = getConfig("classic_event_guess_level_reward")
		for _, v in pairs(config) do
			self.levelRewardArr:add(v);
		end
		quickSort(self.levelRewardArr, "guess_level", true);
	end
	return self.levelRewardArr;
end

function Lua_ChampionshipUtil:getScheduleStr(type, round)
	if type == 3 then
		if round == 1 then -- 半决赛
			return LanUtil.getValue(540005);
		else -- 决赛
			return LanUtil.getValue(540006);
		end
	elseif type == 2 then
		if round == 1 then -- 16强赛
			return LanUtil.getValue(540007);
		elseif round == 2 then -- 8强赛
			return LanUtil.getValue(540008);
		elseif round == 3 then -- 4强赛
			return LanUtil.getValue(540009);
		end
	elseif type == 1 then -- 选拔赛
		return LanUtil.formateStr(540010, convert_arab_to_chinese(round));
	end
	return LanUtil.getValue(540011);
end