Lua_ChaosForestData = class("Lua_ChaosForestData")
function Lua_ChaosForestData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_ChaosForestData:dispose()
	self.hurtState = nil;
	self.recordBoss = 1001;
	self.recordMaxBoss = 0;
	self.recordDic = nil;

	self.round = 1;
	self.round_tick = 0;
	self.boss_id = 1001;
	self.open_tick = 0;
	self.close_tick = 0;
	self.high_hurt = 0;
	self.rank = 0;
	self.challenge_times = 0;

	self.bRecordState = false;
end

function Lua_ChaosForestData:fromServer50195001(msg)
	if msg == nil then
		return;
	end
	
	self.round = msg.round; -- 当前轮次
	self.round_tick = msg.round_tick; -- 轮次刷新时间
	self.boss_id = msg.boss_id; -- 当前怪物id
	self.open_tick = msg.open_tick; -- 今天开启时间
	self.close_tick = msg.close_tick; -- 第二天关闭时间
	self.high_hurt = tonumber(msg.high_hurt); -- 今天的最高单次伤害
	self:setHurtRewardState(msg.daily_hurt_reward);
	self.rank = msg.rank; -- 玩家当前排行
	self.challenge_times = msg.challenge_times; -- 今日已挑战次数

	self:checkTimesRedPoint();
end

function Lua_ChaosForestData:fromServer50195003(msg)
	self.bRecordState = false;
	if msg == nil then
		return;
	end

	self.recordBoss = msg.cur_boos;
	self.recordMaxBoss = 0;
	self.recordDic = {};
	local obj;
	for i = 1, #msg.grant do
		obj = msg.grant[i];
		if obj.boss_id > self.recordMaxBoss then
			self.recordMaxBoss = obj.boss_id;
		end
		self.recordDic[obj.boss_id] = obj;

		if obj.reward_state == 1 then
			self.bRecordState = true;
		end
	end

	self:checkRecordRedPoint();
end

function Lua_ChaosForestData:setHurtRewardState(list)
	if list == nil then
		return;
	end

	self.hurtState = {};
	local key;
	local value;
	for i = 1, #list do
		key = tonumber(list[i].key);
		value = tonumber(list[i].value);
		self.hurtState[key] = value;
	end
end

function Lua_ChaosForestData:getHurtRewardState(id)
	if self.hurtState == nil or self.hurtState[id] == nil then
		return 0;
	end
	return self.hurtState[id];
end

function Lua_ChaosForestData:getRecordInfo(id)
	if self.recordDic == nil or self.recordDic[id] == nil then
		return nil;
	end
	return self.recordDic[id];
end

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
function Lua_ChaosForestData:checkTimesRedPoint()
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ChaosForest_Times, self.challenge_times <= 0);
end

function Lua_ChaosForestData:checkRecordRedPoint()
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ChaosForest_Record, self.bRecordState);
end