checkRequire("Lua_ChaosForestUtil");
checkRequire("Lua_ChaosForestData");
Lua_ChaosForestProxy = class("Lua_ChaosForestProxy");
function Lua_ChaosForestProxy:ctor()
	DataCenter.chaosForestUtil = Lua_ChaosForestUtil.new();
	DataCenter.chaosForestData = Lua_ChaosForestData.new();

	Lua_MsgUtil.addLuaMsg(50195001, self, self.rWinInfo); -- 请求混沌森林界面信息(返回)
	Lua_MsgUtil.addLuaMsg(50195002, self, self.rRankInfo); -- 请求混沌森林排行榜信息(返回)
	Lua_MsgUtil.addLuaMsg(50195003, self, self.rRecordInfo); -- 请求查看神赐祝福信息(返回)
	Lua_MsgUtil.addLuaMsg(50195005, self, self.rFightHurtCollect); -- 请求混沌森林伤害数据(返回)
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 事件监听





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求混沌森林界面信息
function Lua_ChaosForestProxy:sWinInfo()
	sendMsg(10195001);
end

-- 请求混沌森林排行榜信息
function Lua_ChaosForestProxy:sRankInfo(page)
	local cmd = ProtoPublic_pb.Proto10195002();
	cmd.page = page;
	sendMsg(10195002, cmd);
end

-- 请求查看神赐祝福信息
function Lua_ChaosForestProxy:sRecordInfo()
	sendMsg(10195003);
end

function Lua_ChaosForestProxy:sReceiveRecordReward(boos_id)
	local cmd = ProtoPublic_pb.Proto10195004();
	cmd.boos_id = boos_id;
	sendMsg(10195004, cmd);
end

function Lua_ChaosForestProxy:sFightHurtCollect(player_id)
	local cmd = ProtoPublic_pb.Proto10195005();
	cmd.player_id = tonumber(player_id);
	sendMsg(10195005, cmd);
end







------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_ChaosForestProxy:rWinInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50195001();
		msg:ParseFromString(mp.data);
		DataCenter.chaosForestData:fromServer50195001(msg);
		Lua_MsgUtil.callFunc("CHAOSFOREST_UPDATE");
	end
end

function Lua_ChaosForestProxy:rRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50195002();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAOSFOREST_RANK_UPDATE", msg);
	end
end

function Lua_ChaosForestProxy:rRecordInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50195003();
		msg:ParseFromString(mp.data);
		DataCenter.chaosForestData:fromServer50195003(msg);
		Lua_MsgUtil.callFunc("CHAOSFOREST_RECORD_UPDATE");
	end
end

function Lua_ChaosForestProxy:rFightHurtCollect(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50195005();
        msg:ParseFromString(mp.data);
        Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, msg.hurt_collect);
    end
end