Lua_ChaosForestUtil = class("Lua_ChaosForestUtil");
function Lua_ChaosForestUtil:ctor()
	self:superCall("ctor");
end

function Lua_ChaosForestUtil:getConstConfig(key, valType, defaultVal)
	local config = getConfig("chaos_forest_const", key);
	if config ~= nil then
		if valType == 1 then
			return config.value;
		elseif valType == 2 then
			return config.strvalue;
		elseif valType == 3 then
			return config.jsonvalue;
		elseif valType == 4 then
			return config.floatvalue;
		end
	end
	return defaultVal;
end

function Lua_ChaosForestUtil:getLevelConfig(id)
	return getConfig({ "chaos_forest_level", id });
end

function Lua_ChaosForestUtil:initHurtReward()
	if self.bInitHurtReward ~= true then
		self.bInitHurtReward = true;
		self._hurtRewardShow = Array();
		self._hurtRewardArr = Array();
		self._hurtRewardDic = {};
		local config = getConfig("chaos_forest_hurt_reward");
		for k,v in pairs(config) do
			if v.is_show == 1 then
				self._hurtRewardShow:add(v);
			end
			self._hurtRewardArr:add(k);
			self._hurtRewardDic[k] = v;
		end
		self._hurtRewardArr:sortf(self, self.sortFun);
	end
end

function Lua_ChaosForestUtil:sortFun(a, b)
	if a > b then
		return false;
	end
	return true;
end

function Lua_ChaosForestUtil:getHurtRewardShow()
	self:initHurtReward();
	return self._hurtRewardShow;
end

function Lua_ChaosForestUtil:getHurtRewardArr()
	self:initHurtReward();
	return self._hurtRewardArr;
end

function Lua_ChaosForestUtil:getHurtRewardInfo(id)
	self:initHurtReward();
	return self._hurtRewardDic[id];
end

function Lua_ChaosForestUtil:getRankRewardConfig()
	return getConfig("chaos_forest_rank_reward");
end

function Lua_ChaosForestUtil:getMaxHurt(hurt)
    local arr = self:getHurtRewardArr();
    local len = arr:getSize();
    local config;
    local idx;
    local curValue;
    local prevValue;
    local isFinally = false;
    for i = 1, len do
        config = self:getHurtRewardInfo(arr[i]);
        if hurt < config.hurt then
            idx = i;
            break;
        end
    end

    if idx == nil then
        idx = len;
        isFinally = true;
    end
    curValue = self:getHurtRewardInfo(arr[idx]).hurt;
    if idx > 1 then
        prevValue = self:getHurtRewardInfo(arr[idx - 1]).hurt;
    else
        prevValue = 0;
    end
        
    return idx, curValue, prevValue, isFinally;
end