Lua_BulletinConfigVo = class("Lua_BulletinConfigVo");
function Lua_BulletinConfigVo:ctor(configId)
    self:superCall("ctor");

    self.itemInfo = { };
    self.playerInfo = { };
    self.configId = configId;
    self.config = getConfig( { "broadcast", self.configId });
end

function Lua_BulletinConfigVo.Get:chatChannel()
    if self._chatChannel == nil then
        self._chatChannel = Array();
        if self.config ~= nil then
            for i = 1, #self.config.channel do
                self._chatChannel:add(self.config.channel[i]);
            end
        end
    end

    return self._chatChannel;
end
function Lua_BulletinConfigVo.Get:fight_id()
    if self.config ~= nil and self.config.fight_id ~= nil then
        return self.config.fight_id;
    else
        return nil;
    end
end
function Lua_BulletinConfigVo.Get:isContinueBoard()
    local bl=false;
    if self.fight_id ~= nil then
        for i = 1, #self.fight_id do
            local isFightIng = DataCenter.fightPlayData:isFightPlayingByFightId(self.fight_id[i]);
            if isFightIng == true then
                bl=true;
                break;
            end
        end
    end
    return bl;
end
function Lua_BulletinConfigVo.Get:broadcast_type()
    if self.config ~= nil and self.config.broadcast_type ~= nil then
        return self.config.broadcast_type;
    else
        return 3;
    end
end
function Lua_BulletinConfigVo.Get:delay_type()
    if self.config ~= nil and self.config.delay_type ~= nil then
        return self.config.delay_type;
    else
        return 0;
    end
end
function Lua_BulletinConfigVo.Get:content()
    if self.config ~= nil and self.config.content ~= nil then
        return self.config.content;
    else
        return "";
    end
end

function Lua_BulletinConfigVo.Get:boardContent()
    if self.config ~= nil and self.config.boardContent ~= nil then
        return self.config.boardContent;
    else
        return "";
    end
end

function Lua_BulletinConfigVo.Get:showTime()
    if self.config ~= nil then
        return self.config.showTime;
    else
        return 3;
    end
end

function Lua_BulletinConfigVo.Get:notice()
    if self.config ~= nil then
        return self.config.notice;
    else
        return 0;
    end
end

function Lua_BulletinConfigVo.Get:priority()
    if self.config ~= nil and self.config.priority ~= nil then
        return self.config.priority;
    else
        return 0;
    end
end

function Lua_BulletinConfigVo.Get:showCount()
    if self.config ~= nil and self.config.showCount ~= nil and self.config.showCount > 0 then
        return self.config.showCount;
    else
        return 1;
    end
end

-- parseType nil或0 用content（聊天面板内容）   1用boardContent（公告板内容）
function Lua_BulletinConfigVo:parseContent(msg, parseType)
    self.itemInfo = { };
    local str;
    if parseType ~= nil and parseType == 1 then
        str = self.boardContent;
    else
        str = self.content;
    end
    local len = #msg.broad_args;
    for i = 1, len do
        local sd = msg.broad_args[i];
        local substr = nil;
       
        if sd.arg_type == 1 then
            substr = self:getInt(sd);
        elseif sd.arg_type == 2 then
            substr = self:getInt64(sd);
        elseif sd.arg_type == 3 then
            substr = self:getString(sd);
            if tonumber(self.configId)==1008 then--派对聊天，玩家携带礼物进场广播
               local colorStr= DataCenter.charityPartyUtil:getJoinColor(substr)
               substr=colorStr..substr.."[-]"
            end
        elseif sd.arg_type == 4 then
            substr = self:getRoleName(sd);
        elseif sd.arg_type == 5 then
            substr = self:getItem(sd, i);
        elseif sd.arg_type == 6 then
            substr = self:getCelebrityName(sd);
        end
        if substr == nil then
            substr = "";
        end
        local temp = "{" ..(i - 1) .. "}";

        str = LanUtil.replaceStr(str, temp, substr);
    end
    return str;
end

function Lua_BulletinConfigVo:getInt(value)
    return tostring(value.ivalue);
end

function Lua_BulletinConfigVo:getInt64(value)
    return tostring(value.dvalue);
end

function Lua_BulletinConfigVo:getString(value)
    return value.strvalue;
end

function Lua_BulletinConfigVo:getRoleName(value)
    self.playerInfo = value.role_info;
    -- return "[url=playerClick_" .. value.role_info.role_id .. "_" .. value.role_info.role_name .."][u]" .. value.role_info.role_name .. "[/u][/url]";
    return value.role_info.role_name;

end

function Lua_BulletinConfigVo:getItem(value, idx)
    if value.item_info ~= nil and value.item_info.id ~= nil and value.item_info.id > 0 then
        local tvo = Lua_ToolVo.createToolVo(value.item_info.id);
        tvo:fromServer(value.item_info);
        if DataCenter.moneyData:isMoney(value.item_info.id) == true then
            -- 货币
            return tvo.count .. tvo.name;
        else
            local str = value.item_info.id .. idx;
            local nameStr = tvo.broadcastName;
            self.itemInfo[str] = tvo;
            if tvo.count > 1 then
                -- return "[url=itemClick_" .. str .. "][u]" .. nameStr .. "[/u][18c828]X" .. tvo.count .. "[-][/url]";
                return nameStr .. "[18c828]X" .. tvo.count .. "[-]";
            else
                -- return "[url=itemClick_" .. str .. "][u]" .. nameStr .. "[/u][/url]";
                return nameStr;
            end
        end
    end
    return self:getItemName(value);
end

function Lua_BulletinConfigVo:getItemName(value)
    if value.ivalue ~= nil and value.ivalue > 0 then
        local tvo = Lua_ToolVo.new(value.ivalue);
        -- return "[u]" .. tvo.colorName .. "[/u]";
        return tvo.colorName;
    end
    return "";
end

function Lua_BulletinConfigVo:getCelebrityName(value)
    if value.ivalue ~= nil and tonumber(value.ivalue) > 0 then
        local celebrityVo = Lua_CelebrityVo.new(value.ivalue);
        if celebrityVo ~= nil then
            return celebrityVo.colorName;
        end
    end
    return "";
end