-- 聊天频道配置
Lua_ChatChannelData = class("Lua_ChatChannelData");
function Lua_ChatChannelData.getConfigDataById(id)
    if Lua_ChatChannelData.configs == nil then
        Lua_ChatChannelData.configs = { };
    end
    if Lua_ChatChannelData.configs[id] == nil then
        local cfg = getConfig({ "chat", id });
        if cfg == nil then
            return nil;
        end
        Lua_ChatChannelData.configs[id] = Lua_ChatChannelData.new(id, cfg);
    end
    return Lua_ChatChannelData.configs[id];
end

function Lua_ChatChannelData:ctor(id, config)
    self:superCall("ctor");

    self.id = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig({ "chat", id });
    end
end

-------------------- 配置数据 --------------------
--频道
function Lua_ChatChannelData.Get:channel()
    return self.id;
end
--频道名
function Lua_ChatChannelData.Get:channelName()
    if self.config.channelName == nil then
        return "";
    end
    return self.config.channelName;
end
--聊天间隔
function Lua_ChatChannelData.Get:interval()
    if self.config.interval == nil then
        return 0;
    end
    return self.config.interval;
end
--离线聊天记录保留时长
function Lua_ChatChannelData.Get:history_timeout()
    if self.config.history_timeout == nil then
        return 0;
    end
    return self.config.history_timeout;
end
--字数限制 0无限制
function Lua_ChatChannelData.Get:num_limit()
    if self.config.num_limit == nil then
        return 0;
    end
    return self.config.num_limit;
end
--聊天记录显示限制0无限制
function Lua_ChatChannelData.Get:msg_limit()
    if self.config.msg_limit == nil then
        return 0;
    end
    return self.config.msg_limit;
end
--频道开启等级
function Lua_ChatChannelData.Get:openLv()
    if self.config.openLv == nil then
        return 0;
    end
    return self.config.openLv;
end
--未开启提示
function Lua_ChatChannelData.Get:tips()
    return self.config.tips;
end
--私聊玩家显示数量
function Lua_ChatChannelData.Get:showPrivateCount()
    return self.config.showPrivateCount;
end
--语音录音时间限制
function Lua_ChatChannelData.Get:voice_limit()
    return self.config.voice_limit;
end
--显示界面类型 1显示在聊天界面
function Lua_ChatChannelData.Get:show_type()
    if self.config.show_type == nil then
        return 1;
    end
    return self.config.show_type;
end

function Lua_ChatChannelData.Get:sort()
    if self.config.sort == nil then
        return 0;
    end
    return self.config.sort;
end

-- 开启id
function Lua_ChatChannelData.Get:openId()
    if self.config.function_id == nil then
        return 0;
    end
    return self.config.function_id;
end