checkRequire("Lua_ChatVo");
checkRequire("Lua_ChatUtil");
checkRequire("Lua_ChatChannelData");
Lua_ChatData = class("Lua_ChatData");

-- 频道类型
Lua_ChatData.CHANNEL_ALL_MSG = 0; --全部
Lua_ChatData.CHANNEL_WORLD = 1; --世界频道
Lua_ChatData.CHANNEL_LEAGUE = 2; --联盟频道
Lua_ChatData.CHANNEL_SYSTEM = 3; --系统频道
Lua_ChatData.CHANNEL_FRIEND = 4; --私聊频道
Lua_ChatData.CHANNEL_CROSS_SERVER = 5; --跨服频道
Lua_ChatData.CHANNEL_CHAMPIONSHIP = 6; --精英赛频道
Lua_ChatData.CHANNEL_PEAKDUEL = 7; --巅峰对决频道 

-- 内容类型
Lua_ChatData.CONTENT_TEXT = 1; --文字
Lua_ChatData.CONTENT_VOICE = 2; --语音
Lua_ChatData.CONTENT_SYSTEM = 3; --系统
Lua_ChatData.CONTENT_FIGHT_VIDEO = 4; --战斗录像
Lua_ChatData.CONTENT_PEAKDUEL_RECORD = 5; --巅峰对决战绩
Lua_ChatData.CONTENT_COLLECTION = 6; --藏品
Lua_ChatData.CONTENT_EQUIP_COPY = 7; --寂灭岛队伍邀请
Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD = 8;--收藏册单个卡牌
Lua_ChatData.CONTENT_COLLECTION_BOOK = 9;--整个收藏册
Lua_ChatData.CONTENT_RECRUIT_LUCKY = 10;-- 招募欧气分享
Lua_ChatData.CONTENT_DYNANIC_EMOJI = 11;-- 动态表情


Lua_ChatData.CONTENT_XUANYAO = 0; --炫耀
Lua_ChatData.CONTENT_POINT = 50; --@玩家

-- 附件类型
Lua_ChatData.ANNEX_ITEM = 1; --道具
Lua_ChatData.ANNEX_HERO = 2; --明星分享
Lua_ChatData.ANNEX_PEAKDUEL_RECORD = 3; --巅峰对决战绩
Lua_ChatData.ANNEX_FIGHT_VIDEO = 4; --战斗记录分享
Lua_ChatData.ANNEX_COLLECTION = 5; --藏品分享
Lua_ChatData.ANNEX_EQUIP_COPY = 7; --寂灭岛队伍邀请
Lua_ChatData.ANNEX_COLLECTIONBOOK_CARD = 8;--收藏册单个卡牌
Lua_ChatData.ANNEX_COLLECTION_BOOK = 9;--整个收藏册
Lua_ChatData.ANNEX_RECRUIT_LUCKY = 10; -- 招募欧气分享

function Lua_ChatData:ctor()
    self:dispose();
end

function Lua_ChatData:dispose()
    self.singleAllDic = {}
	self.chatDic = {};
	self.privateDic = {};
	self.newNumber = {};
    self.privateNewNumber={};
    self.contentData = nil;
    self.contentType = 0;
    self.openChannelTag=0;
    self.pointList={}
    self.showPrivateList=Array();
    self.selectPrivate=0;
    self.act_check_state=false;
    self.fightBoardList=Array();
    self.iconPosIndex=1;
    self.boardStateDic={};
    self.delayBoardDic={};
    self.crossServerState=false;
    self.firstEnter = false;
    if self.latestChatVoArr ~= nil then
        self.latestChatVoArr:dispose();
        self.latestChatVoArr:clear();
        self.latestChatVoArr = nil; -- 最新聊天信息
    end
    self.channelList = Array();
    self.chatSettingDic = {};

    self.lastestRoleAvatar = {};

    if self.showChatIconWins then
        self.showChatIconWins:clear()
        self.showChatIconWins = nil
    end
    self.chatIconPos = nil

    ChatUtil.removeAllChatVideo(); -- 清除语音
end

function Lua_ChatData:getChatChannelConfig()
    if self.channelList:getSize() == 0 then
        local config = getConfig({ "chat" });
        local channelInfo;
        if config ~= nil then
            for k,v in pairs(config) do
                channelInfo = Lua_ChatChannelData.getConfigDataById(k);
                if channelInfo ~= nil and channelInfo.show_type == 1 then
                    self.channelList:add(channelInfo);
                end
            end
        end
        self.channelList:sort("sort", false);
    end
    return self.channelList;
end

function Lua_ChatData:checkChatIconStateByWinName(winName, bShow)
    if DataCenter.bConfigLoaded ~= true then
        return
    end

    local config = Lua_WinConfigData.getConfigData(winName)
    if config == nil or config.chatPos == nil then
        return
    end

    if self.showChatIconWins == nil then
        self.showChatIconWins = Array()
    end
    if bShow then
        if self.showChatIconWins:indexOf(winName) == -1 then
            self.showChatIconWins:add(winName)
        end
    else
        self.showChatIconWins:removeItem(winName)
    end
    local len = self.showChatIconWins:getSize()
    if len > 0 then
        for i = 1, len do
            for j = i + 1, len do
                local a1 = self.showChatIconWins[i]
                local d1 = WindowMananger.getInstance():getWindowDepth(a1)
                local b1 = self.showChatIconWins[j]
                local d2 = WindowMananger.getInstance():getWindowDepth(b1)
                if d1 < d2 then
                    self.showChatIconWins[i] = b1
                    self.showChatIconWins[j] = a1
                end
            end
        end
    end

    if len > 0 then
        if self.chatIconPos then
            Lua_MsgUtil.callFunc("CHAT_ICON_POS_UPDETA", self.chatIconPos)
        else
            config = Lua_WinConfigData.getConfigData(self.showChatIconWins[1])
            if config and config.chatPos then
                Lua_MsgUtil.callFunc("CHAT_ICON_POS_UPDETA", config.chatPos)
            end
        end
    else
        config = Lua_WinConfigData.getConfigData("default")
        if config and config.chatPos then
            Lua_MsgUtil.callFunc("CHAT_ICON_POS_UPDETA", config.chatPos)
        end
    end
end

function Lua_ChatData:setChatShowItem(val, data)
	if data == nil then
		self.contentType = 0;
	else
		self.contentType = val;
	end
    self.contentData = data;
end

-- 打开聊天窗口时， 默认打开的聊天频道
function Lua_ChatData:getAutoOpenChannel()
    local chatPriority = Lua_ChatData.CHANNEL_WORLD; -- 所有频道均无消息时，打开世界频道
    local priorityList = Lua_ChatUtil.getChatPriority();
    for k, v in ipairs(priorityList) do
        if v.id == Lua_ChatData.CHANNEL_FRIEND and self:getAllPrivateNewMsgNum() > 0 then
            chatPriority = v.id;
            break;
        elseif self:getChannelNewMsgNum(v.id) > 0 then
            chatPriority = v.id;
            break;
        end
    end
    return chatPriority;
end

function Lua_ChatData:getChannelNewMsgNum(channel)
    if Lua_ChatUtil.checkChannelOpen(channel)==false then
        return 0;
    end
    if channel == Lua_ChatData.CHANNEL_FRIEND then
        return self:getAllPrivateNewMsgNum()
    end
    if self:getChatSettingByChannel(channel) == 0 then
        self.newNumber[channel] = 0;
        return 0;
    end
	if self.newNumber[channel] == nil then
		return 0;
	end
	return self.newNumber[channel];
end
function Lua_ChatData:setChannelNewMsgNum(channel, val)
    if Lua_ChatUtil.checkChannelOpen(channel) == false then
        self.newNumber[channel] = 0;
    else
        self.newNumber[channel] = val;
    end
end
function Lua_ChatData:getPointList(channel)
    if self.pointList==nil or self.pointList[channel]==nil then
        return Array();
    end
    return self.pointList[channel];
end

function Lua_ChatData:reomvePointListItem(channel,item)
    if self.pointList==nil then
        self.pointList={};
    end
    if self.pointList[channel] == nil then
        self.pointList[channel]=Array();
    end
    self.pointList[channel]:removeItem(item);
end

function Lua_ChatData:addChatMsg(msg)
    if msg.chat_player~=nil and DataCenter.friendData:isBacklistById(msg.chat_player.id)==true then
        return;
    end
    if Lua_ChatUtil.checkChannelOpen(msg.channel) == false then
        return;
    end
	if self.chatDic[msg.channel] == nil then
		self.chatDic[msg.channel] = Array();
	end
    if self.pointList[msg.channel] == nil then
        self.pointList[msg.channel] = Array();
    end
	local arr = self.chatDic[msg.channel];
	arr:add(msg);
	while true do
		if arr:getSize() > Lua_ChatChannelData.getConfigDataById(msg.channel).msg_limit then
            if self.pointList[msg.channel][1] == 1 then
                self.pointList[msg.channel]:remove(1);
            end
            for i = 1, self.pointList[msg.channel]:getSize() do
                local temp=self.pointList[msg.channel][i];
                self.pointList[msg.channel][i]=temp-1;
            end
            arr:remove(1);
		else
			break;
		end
	end
    if msg.chat_player ~= nil then
        local rid = tonumber(msg.chat_player.id);
        if self:isSaveToAll(msg) == true then
            if self.singleAllDic[rid] == nil then
                self.singleAllDic[rid]=Array();
            end
            self.singleAllDic[rid]:add(msg);
            while true do
                if self.singleAllDic[rid]:getSize() > 16 then
                    self.singleAllDic[rid]:remove(1);
                else
                    break;
                end
            end
        end
    end
    if self.openChannelTag ~= msg.channel and msg.info_offline==false then
        local count=self:getChannelNewMsgNum(msg.channel);
        self:setChannelNewMsgNum(msg.channel,count+1);
    end
    if Lua_ChatUtil.checkHasPoint(msg.content)==true and msg.info_offline==false and self.openChannelTag~=msg.channel then
        self.pointList[msg.channel]:add(arr:getSize());
    end
    self:addChatInfo(msg);
    -- print("addChatMsg", msg.recordInfo.total_force)
	Lua_MsgUtil.callFunc("ADD_CHAT_MSG", msg);
end

function Lua_ChatData:getSingleMsgList(rid)
    rid=tonumber(rid);
    if self.singleAllDic[rid] == nil then
        return Array();
    else
        return self.singleAllDic[rid];
    end
end
function Lua_ChatData:getChannelMsgList(channel)
    if self.chatDic[channel] == nil then
        return Array();
    else
        return self.chatDic[channel];
    end
end
function Lua_ChatData:getPrivateMsgList(role_id)
	local rid = tonumber(role_id);
	if self.privateDic[rid] == nil then
		return Array();
	else
		return self.privateDic[rid];
	end
end
function Lua_ChatData:clearPrivateMsgList(rid)
    rid=tonumber(rid);
    self.privateDic[rid] = nil;
end

function Lua_ChatData:getShowPrivateList()
    return self.showPrivateList;
end
function Lua_ChatData:setShowPrivateList(info,isRemove)
    local removeIndex=0;
    for i = 1, self.showPrivateList:getSize() do
        if tonumber(info.id) == tonumber(self.showPrivateList[i].id) then
            removeIndex = i;
        end
    end
    if removeIndex ~= 0 then
        -- local count = self:getPrivateNewMsgNum(info.id);
        -- self:setPrivateNewMsgNum(info.id, count + 1);
        -- self:setPrivateNewMsgNum(info.id, 0);
        -- self.showPrivateList:remove(removeIndex);
        -- if isRemove==nil or isRemove==false then
        --     self.showPrivateList:add(info);
        -- end
        if isRemove == nil or isRemove == false then
            if removeIndex == 1 then -- 排序，后来居上
                self.showPrivateList[removeIndex] = info;
            else
                self.showPrivateList:remove(removeIndex);
                self.showPrivateList:unshift(info);
            end
        else
            self.showPrivateList:remove(removeIndex);
        end
    elseif isRemove == nil or isRemove == false then
        local show_limit=Lua_ChatChannelData.getConfigDataById(Lua_ChatData.CHANNEL_FRIEND).showPrivateCount;
        if self.showPrivateList:getSize() >= show_limit then
            self.showPrivateList:remove(1);
        end
        self.showPrivateList:unshift(info);
    end
    -- 更新私聊窗口，更新好友头像
    if isRemove ~= true then
        Lua_MsgUtil.callFunc("CHAT_UPDATE_FRIEND");
    end
end
function Lua_ChatData:addPrivateChatMsg(msg)
    if DataCenter.friendData:isBacklistById(msg.chat_player.id)==true then
        return;
    end
    if Lua_ChatUtil.checkChannelOpen(msg.channel) == false then
        return;
    end

    local privateInfo = msg.chat_player; --私聊目标
    local myselfInfo; --自身信息
    local rid;
    local bMySelf = Lua_ChatUtil.judgeIsPlayer(privateInfo.id);
    if bMySelf then -- 是否是玩家自身发送的消息 
        privateInfo = msg.private_player;
        myselfInfo = msg.chat_player;
    else
        privateInfo = msg.chat_player;
        myselfInfo = msg.private_player;
    end
    rid = tonumber(privateInfo.id);


	if self.privateDic[rid] == nil then
		self.privateDic[rid] = Array();
	end
    if self.singleAllDic[rid] == nil then
        self.singleAllDic[rid] = Array();
    end
   
    self:setShowPrivateList(privateInfo);
    
    -- 私聊双方各自最新的信息 friendInfo：私聊目标  playerInfo：玩家自身
    self.lastestRoleAvatar[rid] = { friendInfo = privateInfo, playerInfo = myselfInfo };

	local arr = self.privateDic[rid];
	arr:add(msg);
	while true do
		if arr:getSize() > Lua_ChatChannelData.getConfigDataById(msg.channel).msg_limit then
			arr:remove(1);
		else
			break;
		end
	end
    if self:isSaveToAll(msg) == true then
        self.singleAllDic[rid]:add(msg);
        while true do
            if self.singleAllDic[rid]:getSize() > 16 then
                self.singleAllDic[rid]:remove(1);
            else
                break;
            end
        end
    end

    local bCalculate = (self.openChannelTag ~= msg.channel or self.selectPrivate ~= rid ) and msg.bReadMessage == false and not bMySelf;
    if bCalculate then
        local count=self:getPrivateNewMsgNum(rid);
        self:setPrivateNewMsgNum(rid,count+1);
    end

    -- 新消息下发时刚好处于该私聊窗口
    if self.openChannelTag == msg.channel and self.selectPrivate == rid then
        Lua_ProxyManager.getProxy("Lua_ChatProxy"):sReadPrivateChat(rid);
    end
    self:addChatInfo(msg);
	Lua_MsgUtil.callFunc("ADD_CHAT_MSG", msg);
end
function Lua_ChatData:isSaveToAll(msg)
    if msg.content_type == Lua_ChatData.CONTENT_VOICE then
        return false;
    end
    if msg.channel == Lua_ChatData.CHANNEL_WORLD
    or msg.channel == Lua_ChatData.CHANNEL_LEAGUE
    or msg.channel == Lua_ChatData.CHANNEL_FRIEND
    or msg.channel == Lua_ChatData.CHANNEL_CROSS_SERVER then
        return true;
    end
    return false;
end
function Lua_ChatData:getPrivateNewMsgNum(rid)
    rid=tonumber(rid);
    if self.privateNewNumber[rid] == nil or self:getChatSettingByChannel(Lua_ChatData.CHANNEL_FRIEND) == 0 then
        self.privateNewNumber[rid] = 0;
        return 0;
    end
    return self.privateNewNumber[rid];
end
function Lua_ChatData:setPrivateNewMsgNum(rid, val)
    if rid == nil then
        return;
    end
    rid=tonumber(rid);
    if Lua_ChatUtil.checkChannelOpen(Lua_ChatData.CHANNEL_FRIEND) == false then
        self.privateNewNumber[rid] = 0;
    else
        self.privateNewNumber[rid] = val;
    end
end

function Lua_ChatData:getAllPrivateNewMsgNum()
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_FRIEND) == 0 then
        self.privateNewNumber = {};
        return 0
    end
    local count=0;
    for k,v in pairs(self.privateNewNumber) do
        count=count+v;
    end
    return count;
end

function Lua_ChatData:getAllChannelNewMsgNum()
    local count=0;
    for k,v in pairs(self.newNumber) do
        count = count + self:getChannelNewMsgNum(k);
    end
    count = count + self:getAllPrivateNewMsgNum();
    return count;
end

function Lua_ChatData:shieldShowRedDotCount()
    local count=0
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_WORLD) == 0 then
        count=count+self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_WORLD);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_LEAGUE) == 0 then
        count=count+self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_LEAGUE);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_CROSS_SERVER) == 0 then
        count=count+self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_CROSS_SERVER);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_FRIEND) == 0 then
        count=count+self:getAllPrivateNewMsgNum();
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_SYSTEM) == 0 then
        count=count+self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_SYSTEM);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_CHAMPIONSHIP) == 0 then
        count = count + self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_CHAMPIONSHIP);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_PEAKDUEL) == 0 then
        count = count + self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_PEAKDUEL);
    end
    return count;
end
function Lua_ChatData:addDelayBoardInfo(delay_type,msg)
    if delay_type == nil then
        return;
    end
    if msg == nil then
        return;
    end
    if self.delayBoardDic == nil then
        self.delayBoardDic={};
    end
    if self.delayBoardDic[delay_type] == nil then
        self.delayBoardDic[delay_type]=Array();
    end
    self.delayBoardDic[delay_type]:add(msg);
end
function Lua_ChatData:getBoardPlayStateByType(delay_type)
    if delay_type == nil then
        return true;
    end
    if self.boardStateDic[delay_type] == nil then
        return true;
    end
    return self.boardStateDic[delay_type];
end
function Lua_ChatData:setBoardPlayState(delay_type,state)
    if delay_type == nil then
        return;
    end
    if state == nil then
        state = true;
    end
    if state == false then
        self.boardStateDic[delay_type]=state;
        return;
    end
    self.boardStateDic[delay_type]=state;
    if self.delayBoardDic == nil then
        self.delayBoardDic={};
        return;
    end
    if self.delayBoardDic[delay_type] == nil then
        return;
    end
    local boardList=self.delayBoardDic[delay_type];
    if boardList:getSize() > 0 then
        while boardList:getSize() > 0 do
            local msg=boardList:remove(1);
            self:playBoard(msg);
        end
        boardList:clear()
        self.delayBoardDic[delay_type]=nil;
    end
end
function Lua_ChatData:setFightBoardPlay()
    if self.fightBoardList ~= nil and self.fightBoardList:getSize() > 0 then
        while self.fightBoardList:getSize()>0 do
            local msg=self.fightBoardList:remove(1);
            self:playBoard(msg);
        end
    end
end
function Lua_ChatData:playBoard(msg)
    local bcv = Lua_BulletinConfigVo.new(msg.shout_id);
    if bcv.notice == 1 or bcv.notice == 2 then
        local shoutStr = bcv:parseContent(msg, 1);
        local bv = Lua_BulletinVo.new();
        bv.content = shoutStr;
        bv.priority = bcv.priority;
        bv.circle = bcv.showCount;
        bv.itemInfo = bcv.itemInfo;
        bv.playerInfo=bcv.playerInfo;
        bv.showTime = bcv.showTime;
        bv.notice=bcv.notice;
        Lua_WindowUtil.openWin("Lua_BulletinBoardSecWindow", Lua_WinParam.ACTION_OPEN, bv);
    end
    for i = 1, bcv.chatChannel:getSize() do
        local chatVo = Lua_ChatVo.new();
        chatVo.channel = bcv.chatChannel[i];
        chatVo.type = Lua_ChatData.CONTENT_TEXT;
        chatVo.content = bcv:parseContent(msg,0);
        chatVo.broadcast_type=bcv.broadcast_type;
        DataCenter.chatData:addChatMsg(chatVo);
    end
end

function Lua_ChatData:addChatInfo(chatVo)
    if chatVo == nil or chatVo.channel == nil or chatVo.channel == Lua_ChatData.CHANNEL_CHAMPIONSHIP
    or chatVo.channel == Lua_ChatData.CHANNEL_PEAKDUEL then
        return;
    end

    if self.latestChatVoArr == nil then
        self.latestChatVoArr = Array();
    end

    local len = self.latestChatVoArr:getSize();
    if chatVo.info_offline == true and len >= 3 then
        self.latestChatVoArr:sort("chat_tick", false);
        local lastItem = self.latestChatVoArr[len];
        if tonumber(lastItem.chat_tick) > tonumber(chatVo.chat_tick) then
            return;
        end
    end
    
    if len >= 3 then
        self.latestChatVoArr:remove(1);
    end
    self.latestChatVoArr:add(chatVo);
end

-- 服务端下发处理数据
function Lua_ChatData:updataChatSetting(list)
    -- for k,v in ipairs(list) do
    --     self.chatSettingDic[tonumber(v)] = 0;
    -- end
    for k, v in pairs(self.chatSettingDic) do
       self.chatSettingDic[k] = nil;
    end

    if #list == 0 then
        return;
    end

    local channelId;
    for i = 1, #list do
        channelId = tonumber(list[i]);
        self:setChatSettingByChannel(channelId, 0);
    end
end

function Lua_ChatData:setChatSettingByChannel(channel,value)
    self.chatSettingDic[channel] = value
end

function Lua_ChatData:getChatSettingByChannel(channel) -- 1：开启红点提示  0：关闭红点提示
    if channel == Lua_ChatData.CHANNEL_CHAMPIONSHIP or channel == Lua_ChatData.CHANNEL_PEAKDUEL then
        return 0;
    end
    if self.chatSettingDic[channel] ~= nil then
        return self.chatSettingDic[channel]
    end
    return 1;
end

-- 播放进入广播
function Lua_ChatData:playEnterBroadcast()
    if self.firstEnter == true then
        return;
    end
   --  local bcv = Lua_BulletinConfigVo.new(1003);
   --  if bcv.notice == 1 or bcv.notice == 2 then
   --     local bv = Lua_BulletinVo.new();
   --     bv.content = LanUtil.formateStr(bcv.boardContent,DataCenter.roleData.name);
   --     bv.priority = bcv.priority;
   --     bv.circle = bcv.showCount;
   --     bv.itemInfo = bcv.itemInfo;
   --     bv.playerInfo=bcv.playerInfo;
   --     bv.showTime = bcv.showTime;
   --     bv.notice=bcv.notice;
   --     Lua_WindowUtil.openWin("Lua_BulletinBoardSecWindow", Lua_WinParam.ACTION_OPEN, bv);
   -- end
   -- for i = 1, bcv.chatChannel:getSize() do
   --     local chatVo = Lua_ChatVo.new();
   --     chatVo.channel = bcv.chatChannel[i];
   --     chatVo.type = Lua_ChatData.CONTENT_TEXT;
   --     chatVo.content = LanUtil.formateStr(bcv.content,DataCenter.roleData.name);
   --     chatVo.broadcast_type=bcv.broadcast_type;
   --     DataCenter.chatData:addChatMsg(chatVo);
   -- end
    self.firstEnter = true;
end

function Lua_ChatData:checkSelectPrivate()
    if tonumber(self.selectPrivate) == 0 then
        local tempId = 0;
        local privateList = DataCenter.chatData:getShowPrivateList();
        for i = 1, privateList:getSize() do
            local redCount=DataCenter.chatData:getPrivateNewMsgNum(privateList[i].id);
            if redCount > 0 then
                tempId = tonumber(privateList[i].id);
                break;
            end
        end

        if tempId == 0 and privateList:getSize() > 0 then
            self.selectPrivate = tonumber(privateList[privateList:getSize()].id);
        else
            self.selectPrivate = tonumber(tempId);
        end
    end
end


----------------------表情-----------------------------------
function Lua_ChatData:getEmjioListByType(type)
    if self.emjioList == nil then
        self.emjioList = {};

        local list;
        local config = getConfig({"chat_emoji"});
        for k, v in pairs(config) do
            list = self.emjioList[v.type];
            if list == nil then
                self.emjioList[v.type] = {};
                list = self.emjioList[v.type];
            end
            list[#list + 1] = v.id;
        end
    end

    for k, v in pairs(self.emjioList) do
        table.sort(v, function(a, b)
            local AVo = self:getConfigById(a);
            local BVo = self:getConfigById(b);
            return AVo.sort < BVo.sort; end
         )
    end

    return self.emjioList[type];
end

function Lua_ChatData:getConfigById(id)
    return getConfig({"chat_emoji", id});
end









----------------------------------- 好友处理 -----------------------------------

-- 删除好友聊天处理
function Lua_ChatData:removeFriendInfo(friendId)
    local arr = self.latestChatVoArr;
    if arr ~= nil then
        self.latestChatVoArr = Array();
        local vo;
        for i = 1, arr:getSize() do
            vo = arr[1];
            if vo ~= nil and vo.chat_player ~= nil and vo.chat_player.id ~= friendId then
                self.latestChatVoArr:add(vo);
            end
        end
    end

    self:setShowPrivateList({id = friendId}, true);
    self:setPrivateNewMsgNum(friendId, 0);
    Lua_MsgUtil.callFunc("REMOVE_FRIEND_UPDATE");
end