Lua_ChatVo = class("Lua_ChatVo");
function Lua_ChatVo:ctor()
    self:superCall("ctor");

end

function Lua_ChatVo:fromServer(vo)
	self.channel = vo.chat_type; -- 频道类型
	self.content_type = vo.content_type; -- 内容类型

	self.voice_id = vo.voice_id; -- 语音id
	self.voice_len = vo.voice_sec; -- 语音时长
    self._content = vo.wcontent; -- 文字内容
	self.special_value = vo.value;
    self.prev = vo.prev;
    self.add_list = vo.add_list; -- 聊天附件
    self.chat_player = vo.show; -- 发起聊天的玩家信息
    self.private_player = vo.private_show; -- 私聊时，私聊目标信息
    self.id_list = vo.id_list;
    self.chat_tick = tonumber(vo.tick);
    self.bReadMessage = tonumber(vo.is_read) == 1;

    if self.add_list ~= nil and self.add_list[1] ~= nil then
        if self.content_type == Lua_ChatData.CONTENT_XUANYAO and self.add_list[1].addit_type == Lua_ChatData.ANNEX_ITEM then
            local obj = self.add_list[1].item_info;
            self.itemData = Lua_ToolVo.createToolVo(obj.id, 1, 1);
            self.itemData:fromServer(obj);
            self.itemData.count = 0; -- 炫耀道具不显示数量，这里改成0
        elseif self.content_type == Lua_ChatData.CONTENT_FIGHT_VIDEO and self.add_list[1].addit_type == Lua_ChatData.ANNEX_FIGHT_VIDEO then
            self.recordInfo = self.add_list[1].record_info;
        elseif self.content_type == Lua_ChatData.CONTENT_PEAKDUEL_RECORD and self.add_list[1].addit_type == Lua_ChatData.ANNEX_PEAKDUEL_RECORD then
            self.recordInfo = self.add_list[1].standings_info;
        elseif self.content_type == Lua_ChatData.CONTENT_COLLECTION and self.add_list[1].addit_type == Lua_ChatData.ANNEX_COLLECTION then
            self.recordInfo = self.add_list[1].collection_info;
        elseif self.content_type == Lua_ChatData.CONTENT_EQUIP_COPY and self.add_list[1].addit_type == Lua_ChatData.ANNEX_EQUIP_COPY then
            self.recordInfo = self.add_list[1].silent_island_invite;
        elseif self.content_type == Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD and self.add_list[1].addit_type == Lua_ChatData.ANNEX_COLLECTIONBOOK_CARD then
            self.recordInfo = self.add_list[1].card_info;
        elseif self.content_type == Lua_ChatData.CONTENT_COLLECTION_BOOK and self.add_list[1].addit_type == Lua_ChatData.ANNEX_COLLECTION_BOOK then
            self.recordInfo = self.add_list[1].card_info;  
        elseif self.content_type == Lua_ChatData.CONTENT_RECRUIT_LUCKY and self.add_list[1].addit_type == Lua_ChatData.ANNEX_RECRUIT_LUCKY then
            self.recordInfo = { playerInfo = self.chat_player, recruit_show = self.add_list[1].recruit_show };
        end
    end

    self.class_event_chat_role = vo.class_event_chat_role;
end

function Lua_ChatVo.Get:content()
    if self.add_list ~= nil and self.add_list[1] ~= nil then
        if self.content_type == Lua_ChatData.CONTENT_XUANYAO and self.add_list[1].addit_type == Lua_ChatData.ANNEX_ITEM then
            local str = spliceStr("<color=#", self.itemData.colorStr, "><url=showItem>[", self.itemData.name, "]</url></color>");
            return string.gsub(self._content, "〖〗", str);
        elseif self.content_type == Lua_ChatData.CONTENT_FIGHT_VIDEO and self.add_list[1].addit_type == Lua_ChatData.ANNEX_FIGHT_VIDEO then
            return spliceStr("<url=checkVideo_", self.recordInfo.record_id, ">", self._content, "</url>");
        elseif self.content_type == Lua_ChatData.CONTENT_PEAKDUEL_RECORD and self.add_list[1].addit_type == Lua_ChatData.ANNEX_PEAKDUEL_RECORD then
            return spliceStr("<url=pdRecord_", self.recordInfo.region_id, "_", self.recordInfo.role_id, "_", self.recordInfo.server_flag, ">", self._content, "</url>");
        elseif self.content_type == Lua_ChatData.CONTENT_COLLECTION and self.add_list[1].addit_type == Lua_ChatData.ANNEX_COLLECTION then
            return spliceStr("<url=collection_", self.recordInfo.collection_id, ">", self._content, "</url>");
        elseif self.content_type == Lua_ChatData.CONTENT_RECRUIT_LUCKY and self.add_list[1].addit_type == Lua_ChatData.ANNEX_RECRUIT_LUCKY then
            return spliceStr(self._content, "<url=recruitLucky_", ">", "〖去看看〗", "</url>");
        end
    end
    return self._content;
end

function Lua_ChatVo.Set:content(val)
	self._content = val;
end

function Lua_ChatVo.Get:broadcast_type()
    return self._broadcast_type;
end

function Lua_ChatVo.Set:broadcast_type(val)
    self._broadcast_type = val;
end

function Lua_ChatVo.Set:chat_tick(val)
    self._chat_tick = val;
end

function Lua_ChatVo.Get:chat_tick()
    if self._chat_tick == nil then
        return 0;
    end
    return self._chat_tick;
end

function Lua_ChatVo:getMsg(showChannel, showName, point)
	local str = "";
	if showChannel == true then
        str = str.."　　　";
	end
	if showName == true and self.chat_player.name ~= nil and string.len(self.chat_player.name) > 0 then
        -- str = str.."<color=#"..Lua_ColorDefine.GREEN_STR..">"..self.chat_player.name.."</color>:";
        str = spliceStr(str, "<color=#", Lua_ColorDefine.GREEN_STR, ">", self.chat_player.name, "</color>:");
	end
    if showName == true and self.private_player.name ~= nil and string.len(self.private_player.name) > 0 then
        -- str = str.."<color=#"..Lua_ColorDefine.GREEN_STR..">"..self.private_player.name.."</color>:";
        str = spliceStr(str, "<color=#", Lua_ColorDefine.GREEN_STR, ">", self.private_player.name, "</color>:");
    end
    if point ~= nil and point ~= 1 then
        -- str = "<color=#a16a3e>"..str..self.content.."</color>";
        str = spliceStr("<color=#a16a3e>", str, self.content, "</color>");
    else
        -- str = "<color=#4a6793>"..str..self.content.."</color>";
        str = spliceStr("<color=#4a6793>", str, self.content, "</color>");
    end
    str = string.gsub(str, "◆", " ");
	return str;
end

function Lua_ChatVo.Get:info_offline()
    if self._info_offline==nil then
        return false;
    else
        return self._info_offline;
    end
end

function Lua_ChatVo.Set:info_offline(val)
    self._info_offline = val;
end

-- 已读
function Lua_ChatVo.Get:bReadMessage()
    if self._bReadMessage==nil then
        return false;
    else
        return self._bReadMessage;
    end
end

function Lua_ChatVo.Set:bReadMessage(val)
    self._bReadMessage = val;
end