checkRequire("Lua_ChatWithChanelItem");
checkRequire("Lua_ChatHeadRightItem");
checkRequire("Lua_ChatHeadLeftItem");
Lua_ChatDragContainerItem = class("Lua_ChatDragContainerItem", Lua_DragContainerItem);
function Lua_ChatDragContainerItem:ctor(p)
	self:superCall("ctor", p);
end
function Lua_ChatDragContainerItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ChatDragContainerItem:setData(vo)
	self.chatData=vo;
	if self.chatItem ~= nil then
		self.chatItem:dispose();
		self.chatItem = nil;
	end
	self.chatItem = self:genItem(vo);
	-- self.chatItem:setRectSize(self:getWidth(), self:getHeight());
	-- self.chatItem:setLocation(-self:getWidth() / 2, 0, 0);
	self.chatItem:setRectAnchor(1);
end

function Lua_ChatDragContainerItem:getWidth()
    return 680;
end

function Lua_ChatDragContainerItem:getHeight()
	return self.chatItem:getHeight();
end

function Lua_ChatDragContainerItem:dispose()
	self:superCall("dispose");
end

function Lua_ChatDragContainerItem:onPressClick()
	self.chatItem:onPressClick();
end

function Lua_ChatDragContainerItem:genItem(chatVo)
	local chatItem;
	local width = 680;
	if DataCenter.chatData.openChannelTag == Lua_ChatData.CHANNEL_FRIEND then
		local privateInfo = chatVo.chat_player;

        if privateInfo==nil or privateInfo.id == nil or tonumber(privateInfo.id) == 0 then
			chatItem = Lua_ChatWithChanelItem.new(self.content, width);
		elseif tonumber(privateInfo.id) == tonumber(DataCenter.roleData.roleId) then
			chatItem = Lua_ChatHeadRightItem.new(self.content, width);
		else
			chatItem = Lua_ChatHeadLeftItem.new(self.content, width);
		end
	else
		if chatVo.chat_player==nil or chatVo.chat_player.id == nil or tonumber(chatVo.chat_player.id) == 0 then
			chatItem = Lua_ChatWithChanelItem.new(self.content, width);
		elseif tonumber(chatVo.chat_player.id) == tonumber(DataCenter.roleData.roleId) then
			chatItem = Lua_ChatHeadRightItem.new(self.content, width);
		else
			chatItem = Lua_ChatHeadLeftItem.new(self.content, width);
		end
	end

	chatItem:setData(chatVo);
	return chatItem;
end