checkRequire("Lua_ChatSoundItem");
checkRequire("Lua_ChatHeadIconItem");
checkRequire("Lua_ChatVipItem");
checkRequire("Lua_ChatInfoItem");
checkRequire("Lua_CollectionBookSingleCardItem");
checkRequire("Lua_CollectBookCardItem");
Lua_ChatHeadLeftItem = class("Lua_ChatHeadLeftItem", Lua_DisplayObject);
function Lua_ChatHeadLeftItem:ctor(p, cellWidth)
    self.type = 2;
	self.cellWidth = cellWidth == nil and 330 or cellWidth;
	self:superCall("ctor", p, "ChatHeadLeftItem_skin", false);
end

function Lua_ChatHeadLeftItem:buildShowItem()
	self:superCall("buildShowItem"); 
    self.nameStr:setLocation(-168,-33, 0);
    self.contentBg:setLocation(-218, -51, 0);

	self.headIconItem = Lua_ChatHeadIconItem.new(self.content, true);
    self.headIconItem:setLocation(-280, -58, 0);
end

function Lua_ChatHeadLeftItem:setData(vo)
    self.chatData = vo;
    if DataCenter.chatData.openChannelTag == Lua_ChatData.CHANNEL_FRIEND then -- 实时更新私聊目标的玩家信息
        local chatId = DataCenter.chatData.selectPrivate; 
        local friendInfo = DataCenter.chatData.lastestRoleAvatar[chatId].friendInfo;
        self.headIconItem:setData(friendInfo);
    else
        self.headIconItem:setData(vo.chat_player);
    end

    if self.vipItem == nil then
        self.vipItem = Lua_ChatVipItem.new(self.content);
    end
    self.vipItem:setVipLevel(vo.chat_player.vip);
    self.vipItem:setLocation(-199,-33,0);
    local nameStr = vo.chat_player.name;
    if vo.channel == Lua_ChatData.CHANNEL_LEAGUE then
        nameStr="["..DataCenter.allianceUtil:getLeagueIdentityByPosition(vo.chat_player.league_position).."] "..nameStr;
    end
    if vo.channel == Lua_ChatData.CHANNEL_CROSS_SERVER and vo.chat_player.server_prev ~= nil and vo.chat_player.server_prev ~= "" then
        nameStr=" ["..vo.chat_player.server_prev.."] "..nameStr;
    end
    if vo.channel == Lua_ChatData.CHANNEL_FRIEND and DataCenter.roleData.roleId ~= tonumber(vo.chat_player.id) then
        if tonumber(vo.chat_player.is_cluster) == 1 and vo.chat_player.server_prev ~= nil and vo.chat_player.server_prev ~= "" then
            nameStr=" ["..vo.chat_player.server_prev.."] "..nameStr;
        end
    end
    self.nameStr.text = nameStr;
    self.nameStr:resetSize();
    self.sexSp:setAltas("chat_atlas", "ui_liaotian_icon_0"..(3 - vo.chat_player.sex));
    self.sexSp:resetSize();
    self.sexSp:setLocation(-148 + self.nameStr.width, -33, 0);-- 28 -11

    --聊天展示Item
    if vo.content_type == Lua_ChatData.CONTENT_VOICE then--语音
        if self.soundItem == nil then
            self.soundItem = Lua_ChatSoundItem.new(self.content, 1);
        end
        self.soundItem:setLocation(-211,-76,0);
        self.soundItem:setData(vo);
        self.contentBg:setEnable(false);
        self.height = 50;
    elseif vo.content_type == Lua_ChatData.CONTENT_EQUIP_COPY then--寂灭岛邀请分享
        if self.equipCopyItem == nil then
            self.equipCopyItem = Lua_EquipCopyInfoItem.new(self.content, 1);
        end
        self.equipCopyItem:setData(vo);
        self.contentBg:setEnable(false);
        self.equipCopyItem:setLocation(58, -126, 0);
        -- self.height = self.equipCopyItem:getHeight();
    elseif vo.content_type == Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD then--单卡牌分享
        if self.collectBookSingleCardItem == nil then
            self.collectBookSingleCardItem = Lua_CollectionBookSingleCardItem.new(self.content, 1);
        end
        self.collectBookSingleCardItem:setData(vo);
        self.collectBookSingleCardItem:setLocation(-239, -191, 0);
        self.contentBg:setEnable(false);
    elseif vo.content_type == Lua_ChatData.CONTENT_COLLECTION_BOOK then--卡册分享
        if self.collectBookCardItem == nil then
            self.collectBookCardItem = Lua_CollectBookCardItem.new(self.content, 1);
        end
        self.collectBookCardItem:setData(vo);
        self.collectBookCardItem:setLocation(-97, -218, 0);
        self.contentBg:setEnable(false);
    elseif vo.content_type == Lua_ChatData.CONTENT_DYNANIC_EMOJI then -- 动态表情
        local emojiInfo = DataCenter.chatData:getConfigById(vo.content);
        if emojiInfo == nil then
            return;
        end
        self.emojiWidget = 101;
        self.emojiHeight = 101;
        if self.emjioEff == nil then
            self.emjioEff = UICreate.createUIEffect(self.content, nil, nil, -148, -172)
        end
        self.emjioEff:setUrl(emojiInfo.url, emojiInfo.matName);
        self.contentBg:setEnable(true);
        self.contentBg:SetDimensions(self.emojiWidget + 41, self.emojiHeight + 19);
    else
        if self.infoItem == nil then
            self.infoItem = Lua_ChatInfoItem.new(self.content, self.cellWidth - 230);
        end
        self.infoItem:setLocation(-193, -63, 0);
        self.infoItem:setChatData(vo);
        self.infoItem:setData("<color=#192e41>"..vo:getMsg(false, false).."</color>");

        local w = self.infoItem:getWidth() + 40;
        self.height = self.infoItem:getHeight() + 19;
        self.contentBg:setEnable(true);
        self.contentBg:SetDimensions(w, self.height);
    end
end

function Lua_ChatHeadLeftItem:getHeight()
    if self.chatData.content_type == Lua_ChatData.CONTENT_EQUIP_COPY then--寂灭岛邀请分享
        return 196 + 15;
    elseif self.chatData.content_type == Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD or self.chatData.content_type == Lua_ChatData.CONTENT_COLLECTION_BOOK then--收藏册
        return 376 + 15;
    elseif self.chatData.content_type == Lua_ChatData.CONTENT_DYNANIC_EMOJI then -- 动态表情
        return self.emojiHeight + 70 + 15;
    else
        local lineCount = Mathf.Ceil((self.height-24)/26);
        if lineCount <= 2 then
            return 127;
        else
            return 75 + (self.height-24) + 15;
        end
    end
end

function Lua_ChatHeadLeftItem:dispose()
	if self.headIconItem ~= nil then
        self.headIconItem:dispose();
        self.headIconItem = nil;
    end
    if self.infoItem ~= nil then
        self.infoItem:dispose();
        self.infoItem=nil;
    end

    if self.soundItem ~= nil then
        self.soundItem:dispose();
        self.soundItem=nil;
    end

    if self.equipCopyItem ~= nil then
        self.equipCopyItem:dispose();
        self.equipCopyItem = nil;
    end

    if self.collectBookSingleCardItem ~= nil then
        self.collectBookSingleCardItem:dispose();
        self.collectBookSingleCardItem = nil;
    end
    
    if self.collectBookCardItem ~= nil then
        self.collectBookCardItem:dispose();
        self.collectBookCardItem = nil;
    end

    if self.emjioEff ~= nil then
        --print("Lua_ChatHeadRightItem    Lua_ChatHeadRightItem")
        self.emjioEff:dispose();
        self.emjioEff = nil;
    end
	self:superCall("dispose");
end

function Lua_ChatHeadLeftItem:onPressClick()
    if self.infoItem ~= nil then
        self.infoItem:checkUrlClick();
    end
end