checkRequire("Lua_ChatSoundItem");
checkRequire("Lua_ChatHeadIconItem");
checkRequire("Lua_ChatVipItem");
checkRequire("Lua_ChatInfoItem");
checkRequire("Lua_EquipCopyInfoItem");
checkRequire("Lua_CollectionBookSingleCardItem");
checkRequire("Lua_CollectBookCardItem");
Lua_ChatHeadRightItem = class("Lua_ChatHeadRightItem", Lua_DisplayObject);
function Lua_ChatHeadRightItem:ctor(p, cellWidth)
	self.type = 3;
	self.cellWidth = cellWidth == nil and 330 or cellWidth;
	self:superCall("ctor", p, "ChatHeadRightItem_skin", false);
end

function Lua_ChatHeadRightItem:buildShowItem()
	self:superCall("buildShowItem"); 
    self.sexSp:setLocation(204,-33);
    self.nameStr:setLocation(189, -33);
    self.contentBg:setLocation(229,-51);

    self.headIconItem = Lua_ChatHeadIconItem.new(self.content, true);
    self.headIconItem:setLocation(286, -58, 0);
end

function Lua_ChatHeadRightItem:setData(vo)
    self.chatData = vo;
    if DataCenter.chatData.openChannelTag == Lua_ChatData.CHANNEL_FRIEND then -- 实时更新私聊目标的玩家信息
        local chatId = DataCenter.chatData.selectPrivate; -- 聊天窗口id（私聊目标）
        local playerInfo = DataCenter.chatData.lastestRoleAvatar[chatId].playerInfo;
        self.headIconItem:setData(playerInfo);
    else
        self.headIconItem:setData(vo.chat_player);
    end

    self.sexSp:setAltas("chat_atlas", "ui_liaotian_icon_0"..(3 - vo.chat_player.sex));
    self.sexSp:resetSize();

    local nameStr ="  ".. vo.chat_player.name;
    if vo.channel == Lua_ChatData.CHANNEL_LEAGUE then
        nameStr=" ["..DataCenter.allianceUtil:getLeagueIdentityByPosition(vo.chat_player.league_position).."]"..nameStr;
    end
    if vo.channel == Lua_ChatData.CHANNEL_CROSS_SERVER and vo.chat_player.server_prev ~= nil and vo.chat_player.server_prev ~= "" then
        nameStr=" ["..vo.chat_player.server_prev.."] "..nameStr;
    end
    if vo.channel == Lua_ChatData.CHANNEL_FRIEND and DataCenter.roleData.roleId ~= tonumber(vo.chat_player.id) then
        if tonumber(vo.chat_player.is_cluster) == 1 and vo.chat_player.server_prev ~= nil and vo.chat_player.server_prev ~= "" then
            nameStr=" ["..vo.chat_player.server_prev.."] "..nameStr;
        end
    end
    self.nameStr.text = nameStr;

    if self.vipItem == nil then
        self.vipItem = Lua_ChatVipItem.new(self.content);
    end

    self.nameStr:resetSize();
    self.vipItem:setVipLevel(vo.chat_player.vip);
    self.vipItem:setLocation(169 - self.nameStr.width, -33, 0);
    --聊天展示Item
    if vo.content_type == Lua_ChatData.CONTENT_VOICE then--语音
        if self.soundItem == nil then
            self.soundItem = Lua_ChatSoundItem.new(self.content, 2);
        end
        self.soundItem:setLocation(211, -76, 0);
        self.soundItem:setData(vo);
        self.contentBg:setEnable(false);
        self.height = 50;
    elseif vo.content_type == Lua_ChatData.CONTENT_EQUIP_COPY then--寂灭岛邀请分享
        if self.equipCopyItem == nil then
            self.equipCopyItem = Lua_EquipCopyInfoItem.new(self.content, 2);
        end
        self.equipCopyItem:setData(vo);
        self.contentBg:setEnable(false);
        self.equipCopyItem:setLocation(-58, -126, 0);
        -- self.height = self.equipCopyItem:getHeight();
    elseif vo.content_type == Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD then--单卡牌分享
        if self.collectBookSingleCardItem == nil then
            self.collectBookSingleCardItem = Lua_CollectionBookSingleCardItem.new(self.content, 2);
        end
        self.collectBookSingleCardItem:setData(vo);
        self.collectBookSingleCardItem:setLocation(-72, -202, 0);
        self.contentBg:setEnable(false);
    elseif vo.content_type == Lua_ChatData.CONTENT_COLLECTION_BOOK then--卡册分享
        if self.collectBookCardItem == nil then
            self.collectBookCardItem = Lua_CollectBookCardItem.new(self.content, 2);
        end
        self.collectBookCardItem:setData(vo);
        self.collectBookCardItem:setLocation(97, -219, 0);
        self.contentBg:setEnable(false);
    elseif vo.content_type == Lua_ChatData.CONTENT_DYNANIC_EMOJI then -- 动态表情
        local emojiInfo = DataCenter.chatData:getConfigById(vo.content);
        if emojiInfo == nil then
            return;
        end

        self.emojiWidget = 101;
        self.emojiHeight = 101;
        
        if self.emjioEff == nil then
            -- print(emojiInfo.url,"              ", emojiInfo.matName)
            self.emjioEff = UICreate.createUIEffect(self.content, nil, nil, 146, -172);
        end
        self.emjioEff:setUrl(emojiInfo.url, emojiInfo.matName);
        
        self.contentBg:setEnable(true);
        self.contentBg:SetDimensions(self.emojiWidget + 41, self.emojiHeight + 19);
    else
        if self.infoItem == nil then
            self.infoItem = Lua_ChatInfoItem.new(self.content, self.cellWidth - 230);
        end
        self.infoItem:setChatData(vo);
        self.infoItem:setData(vo:getMsg(false, false,2));
        -- local posX = 49 + self.cellWidth - 150 - self.infoItem:getWidth();
        local posX = 680/2 - self.infoItem:getWidth() - 138;-- 680/2 :显示宽度的一半， 110 为头像等间距
        -- print(vo.chat_player.name,vo:getMsg(false, false,2), posX, "cellWidth:"..self.cellWidth - 150, "self.infoItem:getWidth:"..self.infoItem:getWidth(), "lineCount:"..self.infoItem.modelLabel.lineCount);
        self.infoItem:setLocation(posX, -63, 0);

        local w = self.infoItem:getWidth() + 40;
        self.height = self.infoItem:getHeight() + 19;
        self.contentBg:setEnable(true);
        self.contentBg:SetDimensions(w, self.height);
    end
end

function Lua_ChatHeadRightItem:getHeight()
    if self.chatData.content_type == Lua_ChatData.CONTENT_EQUIP_COPY then--寂灭岛邀请分享
        return 196 + 15;
    elseif self.chatData.content_type == Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD or self.chatData.content_type == Lua_ChatData.CONTENT_COLLECTION_BOOK then--收藏册
        return 376 + 15;
    elseif self.chatData.content_type == Lua_ChatData.CONTENT_DYNANIC_EMOJI then -- 动态表情
        return self.emojiHeight + 70 + 15;
    else
        local lineCount = Mathf.Ceil((self.height-24)/26);
        if lineCount <= 2 then
            return 127 + 15;
        else
            return 75 + (self.height-24)+ 15;
        end
    end
end

function Lua_ChatHeadRightItem:onPressClick()
    if self.infoItem ~= nil then
        self.infoItem:checkUrlClick();
    end
end

function Lua_ChatHeadRightItem:dispose()
    if self.headIconItem ~= nil then
        self.headIconItem:dispose();
        self.headIconItem = nil;
    end
    if self.infoItem ~= nil then
        self.infoItem:dispose();
        self.infoItem=nil;
    end

    if self.soundItem ~= nil then
        self.soundItem:dispose();
        self.soundItem=nil;
    end

    if self.equipCopyItem ~= nil then
        self.equipCopyItem:dispose();
        self.equipCopyItem = nil;
    end

    if self.collectBookSingleCardItem ~= nil then
        self.collectBookSingleCardItem:dispose();
        self.collectBookSingleCardItem = nil;
    end

    if self.collectBookCardItem ~= nil then
        self.collectBookCardItem:dispose();
        self.collectBookCardItem = nil;
    end

    if self.emjioEff ~= nil then
        --print("Lua_ChatHeadRightItem    Lua_ChatHeadRightItem")
        self.emjioEff:dispose();
        self.emjioEff = nil;
    end
	self:superCall("dispose");
end