Lua_ChatInfoItem = class("Lua_ChatInfoItem", Lua_DisplayObject);
function Lua_ChatInfoItem:ctor(p, w)
	self.textWidth = w == nil and 330 or w;
	self._width = 10;
	self._height = 10;
	self:superCall("ctor", p);
end
function Lua_ChatInfoItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.modelLabel = UICreate.createLabel(self.content, "", -20, -2, 60, 30, 22);
    self.modelLabel.pivot = Lua_WindowUtil.getPivot(0);
	self.modelLabel.anchor=Lua_WindowUtil.getAnchor(0)
    self.modelLabel:setLocation(0, 0, 0);
    self.modelLabel:SetDimensions(self.textWidth, 28);
	self.modelLabel.verticalOverflowValue = 1;
end

function Lua_ChatInfoItem:setWidth(value)
	self._width = value;
	-- self.textWidth = value;
	-- self.modelLabel:SetDimensions(self.textWidth, 28);
	-- self.modelLabel:resetPreferredSize();
end

function Lua_ChatInfoItem:getWidth()
	return self._width;
end
function Lua_ChatInfoItem:getHeight()
	return self._height;
end
function Lua_ChatInfoItem:setChatData(data)
	self.chatData = data;
end

function Lua_ChatInfoItem:setData(str, colorStr)
	--self:returnToHideList();
	local arr = Lua_ChatUtil.genChatString(str);
	local len = arr:getSize();

	local iconId;
	local tempStr = "";
	local emojiInfo;
	for i = 1, len do
		if Lua_ChatUtil.isChatFace(arr[i]) == true then
			iconId = string.sub(arr[i], 2, 4);
			emojiInfo = DataCenter.chatData:getConfigById(iconId);
			tempStr = tempStr..spliceEmojiStr(emojiInfo.sprite, Lua_ChatUtil.FACE_SIZE, Lua_ChatUtil.FACE_SIZE);
		else
			tempStr = tempStr..arr[i];
		end
	end

	self.modelLabel.text = Lua_ChatUtil.getRealStr(tempStr);
	self.modelLabel:resetPreferredSize();

	if self.modelLabel.preferredWidth > self.textWidth then
		self._width = self.textWidth;
	else
		self._width = self.modelLabel.preferredWidth;
	end

	-- if self.modelLabel.lineCount > 1 then
	-- 	self._width = self.textWidth;
	-- else
	-- 	self._width = self.modelLabel.preferredWidth;
	-- end
	self._height = self.modelLabel.preferredHeight;
	-- print("@@@@@文本",tempStr, "行数",self.modelLabel.lineCount, "宽",self._width, "高",self._height)
	self.modelLabel.text = tempStr;
end

function Lua_ChatInfoItem:checkUrlClick()
	local urlStr = self.modelLabel:getUrlByMousePos()
	if urlStr ~= nil then
		if self.chatData ~= nil and self.chatData.itemData ~= nil then
			Lua_ChatUtil.urlClickHandle(urlStr, self.chatData.itemData);
		else
			Lua_ChatUtil.urlClickHandle(urlStr, self.chatData);
		end
	end
end

function Lua_ChatInfoItem:dispose()
	self.modelLabel = nil;
	self:superCall("dispose");
end
