Lua_ChatSoundItem = class("Lua_ChatSoundItem", Lua_DisplayObject);
function Lua_ChatSoundItem:ctor(p, t)
	self:superCall("ctor", p, t == 1 and "ChatLeftSoundItem_skin" or "ChatRightSoundItem_skin");
	self.sendTime = 0;
    self.dire=t;
end
function Lua_ChatSoundItem:buildShowItem()
	self:superCall("buildShowItem");
    self:addCSharpEvent("CHAT_PLAY_SOUND", self, self.onVoicePlay);

	self.bg:addClickFuntion(self, self.onSoundBgClick);
    self.bg.clickScale=false;
end

function Lua_ChatSoundItem:setData(vo)
	self._data = vo;
	self.timeTxt.text =LanUtil.formateStr(171040, tostring(vo.voice_len));
end

function Lua_ChatSoundItem:onSoundBgClick(go)
	if self._data == nil then
		return;
	end
	if getTime() - self.sendTime < 2 then
		return;
	end
	self.sendTime = getTime();

    ChatUtil.playChatVideo(self._data.voice_id);
end

function Lua_ChatSoundItem:onVoicePlay(voiceId)
    if self._data ~= nil and self._data.content_type == Lua_ChatData.CONTENT_VOICE then
        print(self._data.voice_id, tonumber(tostring(voiceId)));
        if tonumber(tostring(self._data.voice_id)) == tonumber(tostring(voiceId)) then
            self:playVoiceEffect();
        else
            self:stopVoiceEffect();
        end
    end   
end

function Lua_ChatSoundItem:playVoiceEffect()
    print("playVoiceEffect")
    if tonumber(self._data.voice_len) > 0 then
        self.startTime=getTime();
        self.sp_index=0;
        Lua_CommonUtil.removeTimer(self, self.showVoiceEffect);
        Lua_CommonUtil.addTimer("showVoiceEffect", 0.3, self, self.showVoiceEffect);
    end
end
function Lua_ChatSoundItem:stopVoiceEffect()
    Lua_CommonUtil.removeTimer(self, self.showVoiceEffect);
    if self.dire==1 then
        self.soundSp:setAltas("common_altas_1", "Chat_widget_020");
    else
        self.soundSp:setAltas("chat_atlas", "Chat_widget_023");
    end
end
function Lua_ChatSoundItem:showVoiceEffect()
    local dt=getTime()-self.startTime;
    if dt >= tonumber(self._data.voice_len) then
        Lua_CommonUtil.removeTimer(self, self.showVoiceEffect);
        self.sp_index=3;
    else
        self.sp_index=self.sp_index+1;
        if self.sp_index > 3 then
            self.sp_index=1;
        end
    end
    if self.dire==1 then
        self.soundSp:setAltas("iconantlas2", "Chat_widget_0"..(self.sp_index+17));
    else
        self.soundSp:setAltas("iconantlas2", "Chat_widget_0"..(self.sp_index+20));
    end
end
function Lua_ChatSoundItem:getWidth()
	return 140;
end
function Lua_ChatSoundItem:dispose()
    Lua_CommonUtil.removeTimer(self, self.showVoiceEffect);
    self:superCall("dispose");
end