-- 寂灭岛邀请分享
Lua_EquipCopyInfoItem = class("Lua_EquipCopyInfoItem", Lua_DisplayObject);
function Lua_EquipCopyInfoItem:ctor(p,t)
	self:superCall("ctor", p, "EquipCopyInfoItem_skin");
	self.dire = t; -- 1左边，2右边
end

function Lua_EquipCopyInfoItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.subBtn:addClickFuntion(self, self.onJoinBtnClick)
end

function Lua_EquipCopyInfoItem:setData(chatVo)
	if chatVo.recordInfo == nil then
		return;
	end
	self.chatVo = chatVo;

	self.team_id = chatVo.recordInfo.team_id; -- 寂灭岛队伍id
	self.diff = chatVo.recordInfo.boss_difficulty; -- boss难度

	local force_cond = chatVo.recordInfo.force_cond; -- 战力级别
	local force = DataCenter.equipCopyUtil:getForceNumByType(force_cond);
	local total_force = chatVo.recordInfo.total_force; -- 战力总和
	self.isForce = DataCenter.roleData.force >= force; -- 战力是否不足

	local member_num = chatVo.recordInfo.member_num; -- 队伍人数
	local max_num = DataCenter.equipCopyUtil.team_num; -- 总人数
	self.isMax = member_num == max_num; -- 是否满员

	self.subBtn:setLangValue(420081);
	self.subBtn:setStyle(1);
	local color = "459252";
	if self.isForce == false then
		color = "ED4C2F";
		self.subBtn:setLangValue(420082);
		self.subBtn:setStyle(3);
	elseif DataCenter.equipCopyData.team_id == tonumber(self.team_id) then -- 是否已在队伍中
		color = "459252";
		self.subBtn:setLangValue(420081);
		self.subBtn:setStyle(3);
	elseif DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_COPY_MORE) > 0 then
		color = "459252";
		self.subBtn:setLangValue(420081);
		self.subBtn:setStyle(3);
	elseif self.isMax then -- 满员
		color = "ED4C2F";
		self.subBtn:setLangValue(420083);
		self.subBtn:setStyle(3);
	end


	force = force == 0 and LanUtil.getValue(420084) or force;
	local memberColor = self.isMax and "C78E63" or "459252";
	local cfgData = getConfig({"equip_copy_more", self.diff});

	if cfgData ~= nil then
		self.bossNameTxt.text = LanUtil.formateStr(420116, cfgData.boss_name, tostring(self.diff));
	end

	self.forceTxt.text = LanUtil.formateStr(420085, color, force);
	self.allForceTxt.text = LanUtil.formateStr(420086, tostring(total_force));
	self.teamCountTxt.text = LanUtil.formateStr(420087, memberColor, tostring(member_num), tostring(max_num));
end

function Lua_EquipCopyInfoItem:getWidth()
	return 548;
end

function Lua_EquipCopyInfoItem:getHeight()
	return 152;
end

function Lua_EquipCopyInfoItem:onJoinBtnClick()
	if self.isMax == true then
		OperateAlert.showLangValue(420083);
		return
	end

	if self.isForce == false then
		OperateAlert.showLangValue(420082);
		return;
	end

	local myselfTeamId = DataCenter.equipCopyData.team_id;
	if myselfTeamId == 0 then -- 没队伍
		-- 客户端无法动态判断对应boss是否已激活
		-- if self.diff > DataCenter.equipCopyData.max_difficulty then
		-- 	OperateAlert.show("boss未激活");
		-- 	return;
		-- end
		self:sendJoinTeam();
	else
		if tonumber(self.team_id) == myselfTeamId then
			OperateAlert.showLangValue(420088);
		else
			local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_COPY_MORE);
			if recordId > 0 then
				OperateAlert.showLangValue(420118);
				return
			end
			self:showTips();
		end
	end
end

-- 是否切换队伍
function Lua_EquipCopyInfoItem:showTips()
	local tipsData = {des = LanUtil.getValue(420089), btnType = 1, owner = self, sureFun = self.sendJoinTeam};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_EquipCopyInfoItem:sendJoinTeam()
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sJoinTeam(self.team_id,self.chatVo.chat_player.name);
end

function Lua_EquipCopyInfoItem:dispose()
	self:superCall("dispose");
end