checkRequire("Lua_BulletinConfigVo")
checkRequire("Lua_BulletinVo")
checkRequire("Lua_ChatData");
Lua_ChatProxy = class("Lua_ChatProxy");
function Lua_ChatProxy:ctor()
	self:superCall("ctor");
	DataCenter.chatData = Lua_ChatData.new();

	Lua_MsgUtil.addLuaMsg(80105002, self, self.returnChatMsg);
	Lua_MsgUtil.addLuaMsg(80105003, self, self.returnAutoBroadcasting);
	Lua_MsgUtil.addLuaMsg(80105004, self, self.onSystemBroadcasting);
    Lua_MsgUtil.addLuaMsg(80105007, self, self.returnOfflineChatMsg);
    Lua_MsgUtil.addLuaMsg(80105010, self, self.setShowOrHideActChatMsg);--
    Lua_MsgUtil.addLuaMsg(80105009, self, self.rSetCrossServerState);
    Lua_MsgUtil.addLuaMsg(80105011, self, self.updataChatSetting);
end

function Lua_ChatProxy:setShowOrHideActChatMsg(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80105010();
        msg:ParseFromString(mp.data);
        DataCenter.chatData.act_check_state=msg.state==1 and true or false;
    end
end
function Lua_ChatProxy:returnChatMsg(mp)
	local msg = ProtoPublic_pb.Proto80105002();
	msg:ParseFromString(mp.data);
    local chatVo = Lua_ChatVo.new();
    chatVo:fromServer(msg);
    if tonumber(msg.chat_type) == Lua_ChatData.CHANNEL_FRIEND then
        DataCenter.chatData:addPrivateChatMsg(chatVo);
    else
        -- print("not Lua_ChatData.CHANNEL_FRIEND", chatVo.recordInfo.total_force);
        DataCenter.chatData:addChatMsg(chatVo);
    end
    return nil, false;
end
function Lua_ChatProxy:returnOfflineChatMsg(mp)
    local msg = ProtoPublic_pb.Proto80105007();
    msg:ParseFromString(mp.data);
    if DataCenter.bConfigLoaded ~= true then
        return;
    end
    local chatVo = Lua_ChatVo.new();
    chatVo:fromServer(msg);
    chatVo.info_offline=true;
    if tonumber(msg.chat_type) == Lua_ChatData.CHANNEL_FRIEND then
        DataCenter.chatData:addPrivateChatMsg(chatVo);
    else
        DataCenter.chatData:addChatMsg(chatVo);
    end
end

function Lua_ChatProxy:returnAutoBroadcasting(mp)
	if DataCenter.bConfigLoaded ~= true then
		return;
	end
    if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto80105003();
		msg:ParseFromString(mp.data);
        if msg.type == 1 or msg.type == 3 then
            local bv = Lua_BulletinVo.new();
            bv.content = msg.content;
            bv.priority = 1;
            bv.circle = 1;
            bv.notice=msg.cast_type;
            bv.showTime = Lua_CommonUtil.getCommonConfig("common_broadcast_time", 1);
            if msg.cast_type == 2 then
                bv.showTime =10;
            end
            Lua_WindowUtil.openWin("Lua_BulletinBoardSecWindow", Lua_WinParam.ACTION_OPEN, bv);
        end
        if msg.type ~= 1 then
            local chatVo = Lua_ChatVo.new();
            chatVo.channel = Lua_ChatData.CHANNEL_SYSTEM;
            chatVo.type = Lua_ChatData.CONTENT_TEXT;
            chatVo.content = msg.content;
            DataCenter.chatData:addChatMsg(chatVo);
        end
    end
end

function Lua_ChatProxy:onSystemBroadcasting(mp)
    if DataCenter.bConfigLoaded ~= true then
        return;
    end
    if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto80105004();
        msg:ParseFromString(mp.data);
        local bcv = Lua_BulletinConfigVo.new(msg.shout_id);
        if bcv.isContinueBoard then
            DataCenter.chatData.fightBoardList:add(msg);
        elseif DataCenter.chatData:getBoardPlayStateByType(bcv.delay_type) == false then
            DataCenter.chatData:addDelayBoardInfo(bcv.delay_type,msg);
        else
            DataCenter.chatData:playBoard(msg);
        end
    end
end
function Lua_ChatProxy:rSetCrossServerState(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80105009();
        msg:ParseFromString(mp.data);
        if tonumber(msg.flag) == 1 then
            DataCenter.chatData.crossServerState = true;
        else
            DataCenter.chatData.crossServerState = false;
        end
    end
end
function Lua_ChatProxy:updataChatSetting(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80105011();
        msg:ParseFromString(mp.data);
        DataCenter.chatData:updataChatSetting(msg.channel_list);
    end
end

-- 通知服务端私聊玩家信息已读取（服务端那边判断时间戳，下次登陆时判断是否已读取）
function Lua_ChatProxy:sReadPrivateChat(friend_id)
    local cmd = ProtoPublic_pb.Proto10105012();
    cmd.friend_id = friend_id;
    sendMsg(10105012, cmd);
end