--爬塔vo
Lua_ClimbTowerVo = class("Lua_ClimbTowerVo");
function Lua_ClimbTowerVo:ctor(id, config)
    self.id = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig({ "towerscript_list", id });
    end
end

function Lua_ClimbTowerVo:fromServer(msg)
    self._bInitServer = 1;

    self._is_open = msg.is_open; -- 副本今天是否开启（0：不开启， 1：开启）
    self._cur_stage_id = msg.cur_stage_id; -- 当前未通关关卡id
    self._cur_stage_state = msg.cur_stage_state; -- 当前关卡状态， 0 未通关，1 通关（正常返回的是未通关，玩家通关成功最高层就变成已通关）
    self._pass_times = msg.pass_times; -- 今日已通关层数

    -- 可领取奖励id列表
    self.pass_stage_state = msg.pass_stage_state;
    self.receiveDic = {};  
    local id;
    for i = 1, #msg.pass_stage_state do
        id = msg.pass_stage_state[i];
        self.receiveDic[id] = 1;
    end
    
    -- 每日奖励状态 key：前一天最高通关关卡id，value：奖励状态（0：不可领取，1：可领取，2：已领取）
    self.daily_gift_state = msg.daily_gift_state;
    self.top_ranker = msg.top_ranker; -- 前三名排行
end

function Lua_ClimbTowerVo.Get:bInitServer()
    return self._bInitServer == 1;
end

function Lua_ClimbTowerVo.Get:cur_stage_id()
    if self._cur_stage_id == nil or self._cur_stage_id <= 0 then
        return self.id * 10000 + 1;
    end
    return self._cur_stage_id;
end

function Lua_ClimbTowerVo.Get:cur_stage_state()
    return self._cur_stage_state == nil and 0 or self._cur_stage_state;
end

function Lua_ClimbTowerVo.Get:pass_times()
    return self._pass_times == nil and 0 or self._pass_times;
end

-- 是否开启爬塔
function Lua_ClimbTowerVo.Get:isOpened()
    return self._is_open == 1;
end

--当前未通关塔层数
function Lua_ClimbTowerVo.Get:cur_stage_storey()
    return getConfig("towerscript_stage", self.cur_stage_id, "storey");
end

--当前所在塔层数
function Lua_ClimbTowerVo.Get:cur_storey()
    if self.cur_stage_state == 1 then
        return self.cur_stage_storey;
    end
    return self.cur_stage_storey - 1;
end

--是否达到当天通关层数上限
function Lua_ClimbTowerVo.Get:isLimit()
    return self.pass_times >= self.pass_limit;
end

--阵营
function Lua_ClimbTowerVo.Get:camp()
    return self.config.camp;
end

--名字
function Lua_ClimbTowerVo.Get:name()
    return self.config.name;
end

--战斗模板id
function Lua_ClimbTowerVo.Get:fight_id()
    return self.config.fight_id;
end

--开启文本
function Lua_ClimbTowerVo.Get:open_str()
    if self.config.open_str == nil then
        return "";
    end
    return self.config.open_str;
end

--每日可通关层数
function Lua_ClimbTowerVo.Get:pass_limit()
    return self.config.pass_limit;
end

--初始每日奖励
function Lua_ClimbTowerVo.Get:daily_reward()
    return self.config.daily_reward;
end

function Lua_ClimbTowerVo.Get:sort()
    return self.config.sort;
end

--功能开启id
function Lua_ClimbTowerVo.Get:func_id()
    return self.config.func_id;
end

--战斗模板id
function Lua_ClimbTowerVo.Get:fight_id()
    return self.config.fight_id;
end

-- 开启新战斗类型
function Lua_ClimbTowerVo.Get:new_step()
    return self.config.new_step or 0;
end

--上阵类型限制
function Lua_ClimbTowerVo.Get:limit_camp()
    return self.config.limit_camp;
end

function Lua_ClimbTowerVo.Get:rule()
    return self.config.rule;
end

function Lua_ClimbTowerVo.Get:title_sprite()
    return self.config.title_sprite;
end

function Lua_ClimbTowerVo.Get:redpointId()
    return self.config.redpoint_id;
end

function Lua_ClimbTowerVo.Get:loginId()
    return self.config.login_id;
end

function Lua_ClimbTowerVo.Get:windowName()
    return self.config.windowName;
end

function Lua_ClimbTowerVo.Get:next_fight_cond()
    if self.config.next_fight_cond == nil then
        return 0;
    end
    return self.config.next_fight_cond;
end

function Lua_ClimbTowerVo.Get:rank_path_id()
    return self.config.rank_path_id;
end

function Lua_ClimbTowerVo.Get:prev_storeys()
    return self.config.prev_storeys or 20;
end

function Lua_ClimbTowerVo.Get:next_storeys()
    return self.config.next_storeys or 20;
end