checkRequire("Lua_ClimbTowerUtil");
checkRequire("Lua_ClimbTowerData");
Lua_ClimbTowerProxy = class("Lua_ClimbTowerProxy");
function Lua_ClimbTowerProxy:ctor()
	DataCenter.climbTowerUtil = Lua_ClimbTowerUtil.new();
	DataCenter.climbTowerData = Lua_ClimbTowerData.new();

	Lua_MsgUtil.addLuaMsg(50185001, self, self.rTowerInfo);      -- 请求爬塔副本界面信息(返回)
	Lua_MsgUtil.addLuaMsg(50185005, self, self.rSingleTowerInfo);-- 请求爬塔关卡通关信息(返回)
	Lua_MsgUtil.addLuaMsg(50185006, self, self.rTowerRankInfo);  -- 请求查看爬塔通关排行榜(返回)

	Lua_MsgUtil.addLuaMsg(80185001, self, self.updateTowerInfo); -- 爬塔信息更新（通知）
end

------------------------------------------------------------
-- 上行
-- 请求爬塔副本界面信息
function Lua_ClimbTowerProxy:sTowerInfo(index)
	local cmd = ProtoPublic_pb.Proto10185001();
	cmd.index = index;
	sendMsg(10185001, cmd);
end

-- 请求领取爬塔副本通关层数奖励
function Lua_ClimbTowerProxy:sReceiveTowerReward(index,stage_id)
	local cmd = ProtoPublic_pb.Proto10185003();
	cmd.index = index;
	cmd.stage_id = stage_id;
	sendMsg(10185003, cmd);
end

-- 请求领取爬塔每日奖励
function Lua_ClimbTowerProxy:sReceiveDailyReward(index)
	local cmd = ProtoPublic_pb.Proto10185004();
	cmd.index = index;
	sendMsg(10185004, cmd);
end

-- 请求爬塔关卡通关信息
function Lua_ClimbTowerProxy:sSingleTowerInfo(index, stage_id)
	local cmd = ProtoPublic_pb.Proto10185005();
	cmd.index = index;
	cmd.stage_id = stage_id;
	sendMsg(10185005, cmd);
end

-- 请求查看爬塔通关排行榜
function Lua_ClimbTowerProxy:sTowerRank(index, page)
	local cmd = ProtoPublic_pb.Proto10185006();
	cmd.index = index;
	cmd.page = page;
	sendMsg(10185006, cmd);
end








------------------------------------------------------------
-- 下行
function Lua_ClimbTowerProxy:rTowerInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50185001();
		msg:ParseFromString(mp.data);
		DataCenter.climbTowerData:fromServer50185001(msg);
		Lua_MsgUtil.callFunc("UPDATE_TOWER_INFO", msg.tower_list.index);
	end
end

function Lua_ClimbTowerProxy:updateTowerInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80185001();
		msg:ParseFromString(mp.data);
		DataCenter.climbTowerData:fromServer80185001(msg);
		Lua_MsgUtil.callFunc("UPDATE_TOWER_INFO", msg.tower.index);
	end
end

function Lua_ClimbTowerProxy:rSingleTowerInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50185005();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_SINGLETOWER_INFO", msg);
	end
end

function Lua_ClimbTowerProxy:rTowerRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50185006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_TOWER_RANK_IFNO", msg);
	end
end