Lua_ClimbTowerUtil = class("Lua_ClimbTowerUtil");
Lua_ClimbTowerUtil.LIGHT_ID = 9;
function Lua_ClimbTowerUtil:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_ClimbTowerUtil:dispose()

end

function Lua_ClimbTowerUtil:getTowerArrByType(towerType, curStorey)
	if self.towerArr == nil then
		self.towerArr = Array()
	else
		self.towerArr:clear()
	end
	local vo = DataCenter.climbTowerData:getTowerVoById(towerType)
	local curId = towerType * 10000 + curStorey
	local id
	local config
	for i = 1, vo.prev_storeys do
		id = curId - i
		config = self:getTowerConfig(id)
		if config then
			self.towerArr:add(id)
		end
	end
	self.towerArr:add(curId)
	for i = 1, vo.next_storeys do
		id = curId + i
		config = self:getTowerConfig(id)
		if config then
			self.towerArr:add(id)
		end
	end
	
	quickSort(self.towerArr, nil, false)
	return self.towerArr
end

--获取爬塔数据
function Lua_ClimbTowerUtil:getTowerConfig(id)
	return getConfig("towerscript_stage", id);
end

--获取爬塔整合累积通关奖励
function Lua_ClimbTowerUtil:getRewardConfig(id)
	return getConfig("towerscript_pass", id);
end

function Lua_ClimbTowerUtil:getRewardsInfoById(index)
	if self.rewardsInfo == nil then
		self.rewardsInfo = {};
		local config = getConfig("towerscript_pass");
		for k,v in pairs(config) do
			if self.rewardsInfo[v.index] == nil then
				self.rewardsInfo[v.index] = Array();
			end
			self.rewardsInfo[v.index]:add(k);
		end
	end
	self:onRewardsSortFun(self.rewardsInfo[index], index);
	return self.rewardsInfo[index];
end

function Lua_ClimbTowerUtil:onRewardsSortFun(arr, index)
	local len = arr:getSize();
	if len <= 1 then
		return;
	end

	local a;
	local b;
	local state;
	local temp;
	for i = 1, len do
		for j = i + 1, len do
			a = arr[i];
			state = DataCenter.climbTowerData:getStageRewardState(index, a);
			if state == 1 then
				a = 1000000000 + a;
			elseif state == 2 then
				a = 3000000000 + a;
			else
				a = 2000000000 + a;
			end

			b = arr[j];
			state = DataCenter.climbTowerData:getStageRewardState(index, b);
			if state == 1 then
				b = 1000000000 + b;
			elseif state == 2 then
				b = 3000000000 + b;
			else
				b = 2000000000 + b;
			end

			if a > b then
				temp = arr[i];
				arr[i] = arr[j];
				arr[j] = temp;
			end
		end
	end
end

function Lua_ClimbTowerUtil:getRewardInfo(index)
	local vo = DataCenter.climbTowerData:getTowerVoById(index);
	local arr = self:getRewardsInfoById(index);
	local state;
	local tvo;
	local data;
	for i = 1, arr:getSize() do
		data = self:getRewardConfig(arr[i]);
		state = DataCenter.climbTowerData:getStageRewardState(index, data.id);
		if state == 1 then
			tvo = Lua_ToolVo.createToolVo(data.reward[1][1], data.reward[1][2]);
			return LanUtil.getValue(201003), tvo;
		elseif state == 0 then
			tvo = Lua_ToolVo.createToolVo(data.reward[1][1], data.reward[1][2]);
			return LanUtil.formateStr(201004, tostring(data.storey - vo.cur_stage_storey + 1)), tvo;
		end
	end
	return nil, nil;
end

--限制上阵的阵营名
function Lua_ClimbTowerUtil:limitCampName(list)
	local str;
	for i = 1, #list do
		if str == nil then
			str = LanUtil.getValue(126030 + list[i]);
		else
			str = str..LanUtil.getValue(201026)..LanUtil.getValue(126030 + list[i]);
		end
	end
	return str
end