checkRequire("Lua_CommonFlashCardItem");
Lua_CollectionBookData = class("Lua_CollectionBookData");
function Lua_CollectionBookData:ctor()
	Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.onPackUpdate); -- 背包道具增加
	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.onPackUpdate); -- 货币增加
end

function Lua_CollectionBookData:dispose()
	self.ownerPageIdTab = nil; -- 自身的收藏册封面卡牌idtable
	self.ownerPageIdDir = nil; -- 自身的收藏册封面卡牌Dir
	self.curFlashCount = nil; -- 闪卡收集数量
	self.curCommonAmount = nil; -- 普卡收集数量
	self.cardBagDir = nil; -- 卡包数据
	self.cardDir = nil; -- 卡牌数据
	self.residueAdmireCount = nil; -- 玩家剩余点赞次数
	self.canAdmireOtherPlayer = nil; -- 玩家是否已被点赞
	self.otherAdmireCount = nil;
	self.otherPlayerId = nil;
	self.otherPlayerName = nil;
	self.otherFlashCount = nil;
	self.otherCommonCount = nil;
	self.bUpdateRankInfo = nil;
	self.itemDir = nil; -- 道具
	self.itemIdDic = nil;
	self.needActiveCards = nil;
	self.bShowRewardRed = nil;
	self:clearPageEditData();
	self:setOtherPlayerInfo(nil);

	--羁绊
    if self._fetterDic ~= nil then
		self._fetterDic = nil;
	end
	self._fetterIdList = nil;
	self.bUpdateDataFromServer = nil;
	self.fetterHasRewardIndex = nil;
end

-- 自身卡册封面信息
function Lua_CollectionBookData:fromServer50203001(msg)
	if msg == nil then
		return;
	end

	if self.ownerPageIdTab == nil then
		self.ownerPageIdDir = {};
		self.ownerPageIdTab = {0, 0, 0};
	end

	local id;
	local obj = msg.cover_list;
	local count = #obj;
	for i = 1, count do
		id = tonumber(obj[i]);
		self.ownerPageIdDir[id] = i;
		self.ownerPageIdTab[i] = id;--tonumber(id);
	end

	self.curFlashCount = msg.flash_amount;
	self.curCommonAmount = msg.common_amount;
end

-- 请求卡册普卡信息(返回)
function Lua_CollectionBookData:fromServer50203003(msg)
	if msg == nil then
		return;
	end

	local obj = msg.card_list;
	local count = #obj;
	for i = 1, count do
		self:updateSingleCardBagInfo(obj[i]);
	end

	self:updateRewardRedPointState();
	-- self:testCollectionbookData(msg);
end

-- 请求激活卡牌(返回)
function Lua_CollectionBookData:fromServer50203005(msg)
	if msg == nil then
		return;
	end

	self:updateSingleCardBagInfo(msg.card_info);
	self:updateRewardRedPointState();
end

-- 请求卡牌放入卡册(返回)
function Lua_CollectionBookData:fromServer50203006(msg)
	if msg == nil then
		return;
	end

	self:updateSingleCardBagInfo(msg.card_info);
end

-- 请求给其他玩家点赞(返回)
function Lua_CollectionBookData:fromServer50203007(msg)
	if msg == nil then
		return;
	end
	 -- 登录时发0申请剩余次数，其余刷新排行榜
    if self.bUpdateRankInfo then
        Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sGetCBRankInfo(); -- 刷新排行榜信息
    end
    self.bUpdateRankInfo = true;
	self.residueAdmireCount = tonumber(msg.times);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_Rank, self.residueAdmireCount > 0);
end

-- -- 请求查看玩家卡册排行榜信息(返回) 
-- function Lua_CollectionBookData:fromServer50203008(msg)
-- 	if msg == nil then
-- 		return;
-- 	end
-- end

-- 通知收藏册排行榜刷新(返回)跨天
function Lua_CollectionBookData:fromServer80203008(msg)
    if msg == nil then
        return;
    end

	local bShow = msg.flag == 1;
	if bShow then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_Rank, true);
	end
end

-- 请求领取奖励(返回)
function Lua_CollectionBookData:fromServer50203009(msg)
	if msg == nil then
		return;
	end

	self:updateSingleCardBagInfo(msg.card_info);
	self:updateRewardRedPointState();
end

-- 请求请求玩家卡册信息(返回)
function Lua_CollectionBookData:fromServer50203010(msg)
	if msg == nil then
		return;
	end

	self.canAdmireOtherPlayer = msg.is_like == 0; -- 玩家是否已被点赞 0否 1是
	self.otherAdmireCount = msg.card_show.like_num;
	self.otherPlayerId = msg.card_show.player_id;
	self.otherPlayerName = msg.card_show.player_name;
	self.otherFlashCount = msg.card_show.flash_amount;
	self.otherCommonCount = msg.card_show.common_amount;

	if self.otherPageIdTab == nil then
		self.otherPageIdTab = {-1, -1, -1};
	end

	local id;
	local activeTime;
	local bCompleteCard;
	local obj = msg.card_show.cover_list; --封面展示卡牌列表 key 卡牌id value 激活时间戳
	-- 封面
	for i = 1, #obj do
		id = tonumber(obj[i].key);
		activeTime = tonumber(obj[i].value);
		self:updateCardInfoById(id, nil, true, activeTime);

		bCompleteCard = DataCenter.collectionBookUtil:checkCompletedCard(id);
		if bCompleteCard then
			self.otherPageIdTab[i] = id;
		end
	end

	-- 卡牌share_bag
	obj = msg.card_show.share_bag;
	local pushId;
	local cardBagId;
	local cardId;
	for i = 1, #obj do
		cardBagId = tonumber(obj[i].bag_id);
		pushId = tonumber(obj[i].push_id);
		self:updateCardBagInfoById(cardBagId, nil, nil, true, pushId, obj[i].flash_amount); 

		-- 卡包封面
		activeTime = tonumber(obj[i].unlock_tick);
		self:updateCardInfoById(pushId, nil, true, activeTime);

		-- 经典卡
		cardId = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(cardBagId, Lua_CollectionBookUtil.CLASSIC_CARD);
		activeTime = tonumber(obj[i].classic_tick);
		self:updateCardInfoById(cardId, nil, true, activeTime);

		--普卡
		cardId = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(cardBagId, Lua_CollectionBookUtil.COMMON_CARD);
		activeTime = tonumber(obj[i].common_tick);
		self:updateCardInfoById(cardId, nil, true, activeTime);
	end

end


function Lua_CollectionBookData:updateSingleCardBagInfo(serverData)
	if serverData ~= nil then
		--	卡包
		self:updateCardBagInfoById(serverData.bag_id, serverData.push_id, serverData.reward_state, false, nil, 0);

		-- 卡牌
		local _unlockTime;
		local obj = serverData.card_state;
		local count = #obj;
		for i = 1, count do
			id = tonumber(obj[i].key);
			_unlockTime = tonumber(obj[i].value);
			self:updateCardInfoById(id, _unlockTime, false, nil);
		end
	end
end

function Lua_CollectionBookData:updateCardBagInfoById(_cardBagId, _pushCardId, _rewardState, _bOther, _otherPushId, _otherFlashCount)
	if _cardBagId == nil then
		return;
	end

	_cardBagId = tonumber(_cardBagId);
	local cardBagInfo = self:getCardBagById(_cardBagId);
	if cardBagInfo == nil then
		if self.cardBagDir == nil then
			self.cardBagDir = {};
		end
		self.cardBagDir[_cardBagId] = { pushCardId = 0, rewardState = 0, otherPushId = 0, otherFlashCount = 0 }; -- 0未激活  rewardState:0 不可领取 1可领取 2已领取
		cardBagInfo = self.cardBagDir[_cardBagId];
	end

	if not _bOther then
		cardBagInfo.pushCardId = tonumber(_pushCardId);
		cardBagInfo.rewardState = tonumber(_rewardState);
		-- self:updateRewardRedPointState();
	else
		cardBagInfo.otherPushId = tonumber(_otherPushId);
		cardBagInfo.otherFlashCount = _otherFlashCount;
	end
end

function Lua_CollectionBookData:updateCardInfoById(cardId, activeTime, bOther, otherActiveTime)
	local bCompleteCard = DataCenter.collectionBookUtil:checkCompletedCard(cardId);
	if bCompleteCard then -- 只有制作完成的卡牌才将服务端数据写入
		cardId = tonumber(cardId);
		local cardInfo = self:getCollectCardById(cardId);
		if cardInfo == nil then
			if self.cardDir == nil then
				self.cardDir = {};
			end
			self.cardDir[cardId] = {unlockTime = 0, otherUnlockTime = 0} ; --  0未解锁 1可解锁 >1解锁时间戳
			cardInfo = self.cardDir[cardId];
		end

		if not bOther then
			activeTime = tonumber(activeTime);
			cardInfo.unlockTime = activeTime;
			local exchangeItems = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(cardId, Lua_CollectionBookUtil.CHANGE_ITEM);
			if activeTime > 1 and exchangeItems ~= nil and #exchangeItems > 0 then -- 卡牌激活时移除激活道具
				self:removeByCardId(cardId); 
			end
		else
			otherActiveTime = tonumber(otherActiveTime);
			cardInfo.otherUnlockTime = otherActiveTime;
		end
	end
end

function Lua_CollectionBookData:getCardBagById(cardBagId)
	if cardBagId == nil or self.cardBagDir == nil or self.cardBagDir[cardBagId] == nil then
		return;
	end

	return self.cardBagDir[cardBagId];
end

function Lua_CollectionBookData:getCollectCardById(cardId)
	if cardId == nil or self.cardDir == nil or self.cardDir[cardId] == nil then
		return;
	end

	return self.cardDir[cardId];
end

function Lua_CollectionBookData:getBActiveByCardId(id, state, bShare)
	id = tonumber(id);
	local unlockTime;
	local cardData = self:getCollectCardById(id);
	if cardData ~= nil then
		if bShare then
			unlockTime = cardData.otherUnlockTime;
		else
			unlockTime = cardData.unlockTime;
		end

		if state == Lua_CollectionBookUtil.LOCK_CARD then 
			return unlockTime == 0;
		elseif state == Lua_CollectionBookUtil.RECEIVE_CARD then
			return unlockTime == 1;
		elseif state == Lua_CollectionBookUtil.UNLOCK_CARD then
			return unlockTime > 1;
		end
	end
end

-- 卡包是否有奖励可领取
function Lua_CollectionBookData:getCanReceiveByBagId(bagId)
	local bagData = self:getCardBagById(bagId);
	if bagData ~= nil then
		return bagData.rewardState == 1;
	end
end

-- 卡包中展示的卡牌
function Lua_CollectionBookData:bShowCardInBag(bagId, bShare)
	-- if cardData ~= nil then
	if DataCenter.collectionBookUtil:getCardBagConfigById(bagId) then
		-- pushCardId = 0, rewardState = 0, otherPushId = 0, otherFlashCount = 0 

		local pushId;
		local cardData = self:getCardBagById(bagId);
		if cardData ~= nil then
			pushId = bShare and cardData.otherPushId or cardData.pushCardId;
		end
		if pushId == nil or pushId == 0 then
			pushId = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.COMMON_CARD);
		end
		return pushId;
	end
end

function Lua_CollectionBookData:getClassicCardCountRadio(cardIdList, bShare)
	local curCount, totalCount = 0, 0;
	if cardIdList ~= nil and #cardIdList > 0 then
		for i = 1, #cardIdList do
			bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardIdList[i]);
			local cardId = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CLASSIC_CARD);
			if DataCenter.collectionBookUtil:getSingleCardConfigById(cardId) then
				curCount = self:getBActiveByCardId(cardId, Lua_CollectionBookUtil.UNLOCK_CARD, bShare) and curCount + 1 or curCount;
				totalCount = DataCenter.collectionBookUtil:checkCompletedCard(cardId) and totalCount + 1 or totalCount;
			end
		end
	end
	return curCount, totalCount;
end

function Lua_CollectionBookData:getCardCountRadio(cardIdList, bShare)
	local curCommonCount, totalCommonCount, curFlashCount, totalFlashCount = 0, 0, 0, 0; 
	if cardIdList ~= nil and #cardIdList > 0 then
		local bagId;
		for i = 1, #cardIdList do
			bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardIdList[i]);
			local param_1, param_2, param_3, param_4 = self:getCardCountRadioInSingleBag(bagId, bShare);
			curCommonCount = curCommonCount + param_1;
			totalCommonCount = totalCommonCount + param_2;
			curFlashCount = curFlashCount + param_3;
			totalFlashCount = totalFlashCount + param_4;
		end
	end
	return curCommonCount, totalCommonCount, curFlashCount, totalFlashCount;
end

--计算单个卡包中普卡、闪卡的收集进度
function Lua_CollectionBookData:getCardCountRadioInSingleBag(bagId, bShare)
	local cardId;
	local collectionBookUtil = DataCenter.collectionBookUtil;
	local config = collectionBookUtil:getCardBagConfigById(bagId);
	local curCommonCount, totalCommonCount, curFlashCount, totalFlashCount = 0, 0, 0, 0; 
	if config then
		cardId = collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.COMMON_CARD);-- 普卡
		if collectionBookUtil:getSingleCardConfigById(cardId) then
			curCommonCount = self:getBActiveByCardId(cardId, Lua_CollectionBookUtil.UNLOCK_CARD, bShare) and curCommonCount + 1 or curCommonCount;
			totalCommonCount = collectionBookUtil:checkCompletedCard(cardId) and totalCommonCount + 1 or totalCommonCount;
		end

		cardId = collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.FLASH_CARD);-- 英雄闪卡
		if collectionBookUtil:getSingleCardConfigById(cardId) then
			curFlashCount = self:getBActiveByCardId(cardId, Lua_CollectionBookUtil.UNLOCK_CARD, bShare) and curFlashCount + 1 or curFlashCount;
			totalFlashCount = collectionBookUtil:checkCompletedCard(cardId) and totalFlashCount + 1 or totalFlashCount;
		end

		local list = collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CLOTH_CARD);-- 皮肤闪卡
		if list ~= nil then
			for i = 1, #list do
				cardId = list[i];
				if collectionBookUtil:getSingleCardConfigById(cardId) then
					curFlashCount = self:getBActiveByCardId(cardId, Lua_CollectionBookUtil.UNLOCK_CARD, bShare) and curFlashCount + 1 or curFlashCount;
					totalFlashCount = collectionBookUtil:checkCompletedCard(cardId) and totalFlashCount + 1 or totalFlashCount;
				end
			end
		end

		if bShare then
			local cardBag = self:getCardBagById(bagId);
			if cardBag then
				curFlashCount = cardBag.otherFlashCount;
			end
		end
	end
	return curCommonCount, totalCommonCount, curFlashCount, totalFlashCount;
end

function Lua_CollectionBookData:getCardListByType(type, bSelected, bShare)
	local bShow;
	local bagId;
	local cardId;
	local cardList = {};
	local collectionBookUtil = DataCenter.collectionBookUtil;
	local cardBags = collectionBookUtil:getAllBags();
	for i = 1, #cardBags do
		bShow = false;
		cardId = nil;
		bagId = cardBags[i];
		if type == 1 then
			bShow = collectionBookUtil:checkBagTypeById(bagId, Lua_CollectionBookUtil.MODEL_CARD) or 
				collectionBookUtil:checkBagTypeById(bagId, Lua_CollectionBookUtil.ONLY_CARD);
		elseif type == 2 then
			bShow = true;
		elseif type == 3 then
			bShow = collectionBookUtil:checkBagTypeById(bagId, Lua_CollectionBookUtil.CREATE_CARD);
		elseif type == 4 then
			bShow = collectionBookUtil:checkBagTypeById(bagId, Lua_CollectionBookUtil.FRAME_CARD);
		end

		-- 需展示的卡包
		if bShow then
			if type == 2 then -- 经典卡
				cardId = collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CLASSIC_CARD);
			else
				cardId = self:bShowCardInBag(bagId, bShare);
			end
			if collectionBookUtil:getSingleCardConfigById(cardId) then
				if bSelected then
					if not self:getBActiveByCardId(cardId, Lua_CollectionBookUtil.UNLOCK_CARD, bShare) then
						cardId = nil;
					end
				end
			else
				cardId = nil;
			end
		end

		if cardId ~= nil then
			cardList[#cardList + 1] = cardId;
		end
	end

	table.sort( cardList, function(a, b)
			local ABagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(a);
			local BBagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(b);
			local Asort = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(ABagId, Lua_CollectionBookUtil.CARDBAG_SORT);
			local Bsort = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(BBagId, Lua_CollectionBookUtil.CARDBAG_SORT);
			return Asort < Bsort;
		end
	 )
	return cardList;
end

-- 闪卡
function Lua_CollectionBookData:getFlashCardIdListByType(type)
	local bShow;
	local cardId;
	local cardList = {};
	for k, v in pairs(self.cardDir) do
		cardId = k;
		if type == 1 then
			bShow = DataCenter.collectionBookUtil:checkCardTypeById(cardId, Lua_CollectionBookUtil.FLASH_CARD) or 
					DataCenter.collectionBookUtil:checkCardTypeById(cardId, Lua_CollectionBookUtil.CLOTH_CARD);
		elseif type == 2 then
			bShow = DataCenter.collectionBookUtil:checkCardTypeById(cardId, Lua_CollectionBookUtil.FLASH_CARD);
		elseif type == 3 then
			bShow = DataCenter.collectionBookUtil:checkCardTypeById(cardId, Lua_CollectionBookUtil.CLOTH_CARD);
		end

		if bShow and self:getBActiveByCardId(k, Lua_CollectionBookUtil.UNLOCK_CARD, false) then
			cardList[#cardList + 1] = cardId;
		end
	end

	table.sort( cardList, function(a, b)
			local aUnlockTime = self:getCollectCardById(a).unlockTime;
			local bUnlockTime = self:getCollectCardById(b).unlockTime;
			aUnlockTime = DataCenter.collectionBookUtil:checkCardTypeById(a, Lua_CollectionBookUtil.FLASH_CARD) and aUnlockTime * 10 or aUnlockTime;
			bUnlockTime = DataCenter.collectionBookUtil:checkCardTypeById(b, Lua_CollectionBookUtil.FLASH_CARD) and bUnlockTime * 10 or bUnlockTime;
			return aUnlockTime > bUnlockTime;
		end
			 );
	return cardList;
end

-- 获取解锁的时间文本
function Lua_CollectionBookData:getUnlockTimeStr(type, cardId, bShare)
	local cardData = self:getCollectCardById(cardId);
	if cardData ~= nil then
		local time = bShare and cardData.otherUnlockTime or cardData.unlockTime;
		if time > 1 then
			time = tonumber(time);
			if type == 1 then
				return LanUtil.formateStr(410035, Lua_TimeTransform.transSeconds25(time));
			elseif type == 2 then
   				return os.date("%Y/%m/%d", time);
   			elseif type == 3 then
   				return LanUtil.formateStr(410055, Lua_TimeTransform.transSeconds25(time))
   			elseif type == 4 then
   				return time; 
   			end
		end
	end
end


-- 封面编辑
function Lua_CollectionBookData:setPageEditData(index, cardId)
	if self.editPages == nil then
		self:getPageEditData();
	end
	cardId = cardId <= 0 and 0 or cardId;
	if self.editPages[index] ~= nil then
		local id = self.editPages[index];
		self.editPages[index] = cardId;
		self.selectedIdDir[id] = nil;
		self.selectedIdDir[cardId] = index;
	end
end

-- 封面编辑
function Lua_CollectionBookData:getPageEditData()
	if self.editPages == nil then
		local id;
		self.editPages = {};
		self.selectedIdDir = {};
		for i = 1, #self.ownerPageIdTab do
			id = self.ownerPageIdTab[i];
			self.editPages[i] = id;
			self.selectedIdDir[id] = i;
		end
	end
	return self.editPages;
end

-- 封面编辑时是否被选中
function Lua_CollectionBookData:getBSelectedById(cardId)
	if self.selectedIdDir == nil then
		self:getPageEditData();
	end

	return self.selectedIdDir[cardId];
end

function Lua_CollectionBookData:getCardIdByIndex(index)
	if self.editPages == nil then
		self:getPageEditData();
	end
	return self.editPages[index];
end

-- 封面编辑
function Lua_CollectionBookData:clearPageEditData()
	self.editPages = nil;
	self.selectedIdDir = nil;
end

function Lua_CollectionBookData:getPushBookIdListByType()
	local id;
	local cardList = {};
	for k, v in pairs(self.cardBagDir) do
		id = self:bShowCardInBag(k, false);
		if DataCenter.collectionBookUtil:getSingleCardConfigById(id) and self:getBActiveByCardId(id, Lua_CollectionBookUtil.UNLOCK_CARD, false) then
			cardList[#cardList + 1] = id;
		end
	end

	table.sort( cardList, function(a, b)
			local ABagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(a);
			local BBagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(b);
			local Asort = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(ABagId, Lua_CollectionBookUtil.CARDBAG_SORT);
			local Bsort = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(BBagId, Lua_CollectionBookUtil.CARDBAG_SORT);
			return Asort < Bsort;
		end
	 )
	return cardList;
end

--获取放入卡册的卡牌数量
function Lua_CollectionBookData:getPushCardCount()
	local id;
	local count = 0;
	for k, v in pairs(self.cardBagDir) do
		id = self:bShowCardInBag(k, false);
		if DataCenter.collectionBookUtil:getSingleCardConfigById(id) and self:getBActiveByCardId(id, Lua_CollectionBookUtil.UNLOCK_CARD, false) then
			count = count + 1;
		end
	end
	return count;
end

-- 封面卡牌更新
function Lua_CollectionBookData:updatePushIdInBag(cardId)
	local index;
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
	local pushId = self:bShowCardInBag(bagId, false);
	local bChange = pushId ~= nil and pushId ~= cardId;
	if bChange then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sPlaceCardInBookInfo(cardId);
		index = self.ownerPageIdDir[pushId];
		if index ~= nil then
			local id;
			local list = {0, 0, 0}; -- 与服务端数据分割开
			for i = 1, 3 do
				id = self.ownerPageIdTab[i];
				if index == i then
					if id == pushId then -- 进一步校验
						list[i] = cardId;
					end
				else
					list[i] = id;
				end
			end
			Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sSaveCBPageInfo(list);
		end
	end
end

-- 卡牌详情页中显示的卡牌组
function Lua_CollectionBookData:getCardListByCardId(cardId)
	local idTab = {};
	local cardDir = {};
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
	local config = DataCenter.collectionBookUtil:getCardBagConfigById(bagId);
	if config ~= nil then
		local count;
		local id = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.COMMON_CARD);
		local bCompleteCard = DataCenter.collectionBookUtil:checkCompletedCard(id);
		if bCompleteCard then
			count = #idTab + 1;
			idTab[count] = id;
			cardDir[id] = count;
		end

		id = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.FLASH_CARD);
		bCompleteCard = DataCenter.collectionBookUtil:checkCompletedCard(id);
		if bCompleteCard then
			count = #idTab + 1;
			idTab[count] = id;
			cardDir[id] = count;
		end

		local list = DataCenter.collectionBookUtil:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CLOTH_CARD);
		if list ~= nil and #list > 0 then
			for i = 1, #list do
				id = list[i];
				bCompleteCard = DataCenter.collectionBookUtil:checkCompletedCard(id);
				if bCompleteCard then
					count = #idTab + 1;
					idTab[count] = id;
					cardDir[id] = count;
				end
			end
		end
	end
	return idTab, cardDir;
end



-------------------------------------红点----------------------------
-- 卡包item上是否显示红点
function Lua_CollectionBookData:bShowRedPointByCardId(cardId)
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
	if bagId ~= nil then
		local bShow = self:getCanReceiveByBagId(bagId);
		if bShow then
			return true;
		end

		-- 激活道具预留
		local canActive = DataCenter.collectionBookUtil:canActiveByCardId(cardId);
		return canActive;
	end
end

-- 奖励红点
function Lua_CollectionBookData:updateRewardRedPointState()
	if self.cardBagDir == nil then
		return;
	end

	local allBags = DataCenter.collectionBookUtil:getAllBags();
	local bagId;
	local bShow;
	for i = 1, #allBags do
		bagId = allBags[i];
		bShow = self:getCanReceiveByBagId(bagId);
		if bShow then
			break;
		end
	end

	if self.bShowRewardRed ~= bShow then
		self.bShowRewardRed = bShow;
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_HasReward, bShow);
		DataCenter.heroAtlasData:checkAtlasCarRedDotState();--英雄图鉴闪卡红点
	end

	DataCenter.heroData:checkHeroCarRedDotState();--英雄背包闪卡红点
end

function Lua_CollectionBookData:onPackUpdate(dic)
	if not DataCenter.funcOpenData:isOpened(10239) then -- 功能未开启
		return;
	end
	if self.bShowRewardRed then -- 已有奖励红点不往下操作
		return;
	end

	if self.itemDir == nil then
		self:initNeedActiveItem();
	end
	for k, v in pairs(dic) do
		if self.itemIdDic[k] then
			local canActive;
			local arr = self.itemDir[k];
			if arr ~= nil and arr:getSize() > 0 then
				for i = 1, arr:getSize() do
					canActive = DataCenter.collectionBookUtil:canActiveByCardId(arr[i])
					if canActive then
						break;
					end
				end
			end

			if canActive then
				DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_CanActive, canActive);
				break;
			end
		end
	end
end



function Lua_CollectionBookData:initNeedActiveItem()
	if self.itemDir == nil then
		self.itemDir = {};
		self.itemIdDic = {};
		self.needActiveCards = {};
		local cardId;
		local exchangeItems;
		local bShowRedPoint;
		local cardList = DataCenter.collectionBookUtil:getAllNeedActiveCards();
		if cardList == nil or #cardList <= 0 then
			return;
		end
		for i = 1, #cardList do
			cardId = cardList[i];
			exchangeItems = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(cardId, Lua_CollectionBookUtil.CHANGE_ITEM);
			if exchangeItems ~= nil and #exchangeItems > 0 then
				self.needActiveCards[cardId] = true;
				local itemId;
				for j = 1, #exchangeItems do
					itemId = exchangeItems[j][1];
					if self.itemDir[itemId] == nil then
						self.itemDir[itemId] = Array();
						self.itemIdDic[itemId] = true;
					end
					if self.itemDir[itemId]:indexOf(cardId) == -1 then
						self.itemDir[itemId]:add(cardId);
					end
				end
			end

			-- 初始化时判断
			if not bShowRedPoint then
				bShowRedPoint = DataCenter.collectionBookUtil:canActiveByCardId(cardId);
				if bShowRedPoint then
					DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_CanActive, bShowRedPoint);
				end
			end

		end

		-- print("初始化监听数据")
		-- self:testItemData();
	end
end

-- 移除监控激活道具的卡牌
function Lua_CollectionBookData:removeActiveItem(cardId)
	local config = DataCenter.collectionBookUtil:getSingleCardConfigById(cardId);
	if config ~= nil and self.itemDir ~= nil then
		local exchangeItems = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(cardId, Lua_CollectionBookUtil.CHANGE_ITEM);--config.change_item;
		if exchangeItems == nil or #exchangeItems <= 0 then
			return;
		end
		local itemId;
		for i = 1, #exchangeItems do
			itemId = exchangeItems[i][1];

			local bCleared = self.itemDir[itemId] == nil;
			if bCleared then
				-- print("重复卡牌",cardId)
			else
				local index = self.itemDir[itemId]:indexOf(cardId);
				if index ~= -1 then
					self.itemDir[itemId]:remove(index);
					if self.itemDir[itemId]:getSize() == 0 then
						self.itemDir[itemId] = nil;
						self.itemIdDic[itemId] = nil;
					end
				end
			end
		end
		self.needActiveCards[cardId] = nil;
	end
end

function Lua_CollectionBookData:removeByCardId(cardId)
	if self.itemDir == nil then
		self:initNeedActiveItem();
	end

	local bActive = self:getBActiveByCardId(cardId, Lua_CollectionBookUtil.UNLOCK_CARD, false)
	if bActive and self.needActiveCards[cardId] then
		self:removeActiveItem(cardId);
		-- print("移除卡牌：", cardId)
		-- self:testItemData();
	end



end



---------------------------------其他玩家--------------------------------
-- 重置其他玩家的卡册数据
function Lua_CollectionBookData:resetOtherPlayerInfo()
	if self.cardDir ~= nil then
		for k, v in pairs(self.cardDir) do
			self:updateCardInfoById(k, nil, true, 0);
		end
	end

	if self.cardBagDir ~= nil then
		for k, v in pairs(self.cardBagDir) do
			self:updateCardBagInfoById(k, nil, nil, true, 0, 0);
		end
	end

	self:setOtherPlayerInfo(nil);
end

function Lua_CollectionBookData:resetOtherSingleCardData(cardId)
	self:updateCardInfoById(cardId, nil, true, nil);
end

function Lua_CollectionBookData:setOtherPlayerInfo(otherPlayerInfo)
	self.otherPlayerInfo = otherPlayerInfo;
end

function Lua_CollectionBookData:getOtherPlayerInfo()
	return self.otherPlayerInfo;
end




----------------------------------外部接口------------------------------------
-- 根据闪卡id《hero_des》获取卡包的奖励状态是否可领取，奖励
function Lua_CollectionBookData:getRewardStateByFlashId(flashId)
	local canRecReward;
	local rewardItem;
	local bagId = DataCenter.collectionBookUtil:getCardBagIdByFlashId(flashId);
	local config = DataCenter.collectionBookUtil:getCardBagConfigById(bagId);
	if config then
		canRecReward = self:getCanReceiveByBagId(bagId)
		rewardItem = config.reward;
	end
	return canRecReward, rewardItem;
end

-- 根据卡牌id《collection_book》获取该卡牌的状态：0：未激活，1：可激活，2：已激活  3:有奖励可领取且返回奖励
function Lua_CollectionBookData:getCardStateByCardId(cardId, type)
	if type == 0 then
		return self:getBActiveByCardId(cardId, Lua_CollectionBookUtil.LOCK_CARD, false);
	elseif type == 1 then
		return DataCenter.collectionBookUtil:canActiveByCardId(cardId);
	elseif type == 2 then
		return not self:getBActiveByCardId(cardId, Lua_CollectionBookUtil.LOCK_CARD, false);
	elseif type == 3 then
		local canRecReward;
		local rewardItem;
		local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
		local config = DataCenter.collectionBookUtil:getCardBagConfigById(bagId);
		if config then
			canRecReward = self:getCanReceiveByBagId(bagId)
			rewardItem = config.reward;
		end
		return canRecReward, rewardItem;
	end
end













-----------------------------------------------羁绊-----------------------------
function Lua_CollectionBookData:initFetterData()
	if self._fetterDic == nil then
		self._fetterDic = {};
		self._fetterIdList = {};
	
		local obj;
		local count;
		local configObj;
		local config = getConfig({ "hero_fetter" });
		for k, v in pairs(config) do
			self._fetterDic[k] = {rewardState = 0, activeNum = 0, heroDir = {} };-- 1可领取 2已领取
			obj = self._fetterDic[k].heroDir;
			if v.hero_list ~= nil then
				for i = 1, #v.hero_list do
					configObj = v.hero_list[i];
					obj[configObj[1]] = false;
				end
			end
			count = #self._fetterIdList + 1;
			self._fetterIdList[count] = k;
		end

		table.sort( self._fetterIdList, function(a, b) 
				local Asort = DataCenter.collectionBookUtil:getFetterConfigById(a).sort; 
				local Bsort = DataCenter.collectionBookUtil:getFetterConfigById(b).sort;
				return Asort < Bsort;
			end 
		);
	end 
end

function Lua_CollectionBookData:updateSingleFetterInfo(serverData)
	if serverData == nil then
		return;
	end

	local id;
	local value;
	local isActive;
	local count = 0;
	local vo = self:getHeroFetterVoById(tonumber(serverData.fetter_id));
	if vo ~= nil then
		vo.rewardState = serverData.reward_state; -- 1可领取 2已领取
		for i = 1, #serverData.fetter_list do
			id = tonumber(serverData.fetter_list[i].hero_id);
			value = tonumber(serverData.fetter_list[i].state); --state 是否激活：0未激活，1：已激活
			isActive = value == 1;
			vo.heroDir[id] = isActive;
			count = isActive and count + 1 or count;
		end
		vo.activeNum = count;
	end
end

function Lua_CollectionBookData:updateFetterRedPoint()
	local id;
	local obj;
	local isShow = false;
	self.fetterHasRewardIndex = nil;
	for i = 1, #self._fetterIdList do
		id = self._fetterIdList[i];
		obj = self:getHeroFetterVoById(id);
		if obj.rewardState == 1 then
			self.fetterHasRewardIndex = i;
			isShow = true;
			break;
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_Fetter, isShow);
end

function Lua_CollectionBookData:getHeroFetterVoById(id)
	if id == nil or self._fetterDic == nil or self._fetterDic[id] == nil then
		return nil;
	end
	return self._fetterDic[id];
end

-- 英雄羁绊
function Lua_CollectionBookData:fromServer50114019(msg)
    if msg == nil then
        return;
    end
    self.bUpdateDataFromServer = true;
    self:initFetterData();

    local obj;
    for i = 1, #msg.fetter_info do
    	obj = msg.fetter_info[i];
    	self:updateSingleFetterInfo(obj);
    end

    self:updateFetterRedPoint();
end

-- 英雄羁绊奖励返回
function Lua_CollectionBookData:fromServer50114037(msg)
    if msg == nil then
        return;
    end

    local fetter_id = msg.fetter_id;
    local vo = self:getHeroFetterVoById(fetter_id);
    if vo ~= nil then 
    	vo.rewardState = tonumber(msg.reward_state);
    end

    self:updateFetterRedPoint();
end

-- 通知羁绊状态变更(返回)
function Lua_CollectionBookData:fromServer80114019(msg)
    if msg == nil then
        return;
    end

	self:initFetterData();
	
    local obj;
    for i = 1, #msg.fetter_info do
    	obj = msg.fetter_info[i];
    	self:updateSingleFetterInfo(obj);
    end

    self:updateFetterRedPoint();
end

function Lua_CollectionBookData:getFetterIdList()
	return self._fetterIdList;
end

function Lua_CollectionBookData:getCollectionTotalAttrib()
	local health, attack, defence = 0, 0, 0;
	local vo;
	local configObj;
	for i = 1, #self._fetterIdList do
		vo = self:getHeroFetterVoById(self._fetterIdList[i]);
		if vo ~= nil and vo.rewardState ~= 0 then
			configObj = DataCenter.collectionBookUtil:getFetterConfigById(self._fetterIdList[i]);
			health, attack, defence = health + configObj.health, attack + configObj.attack, defence + configObj.defence;
		end
	end
	return health, attack, defence;
end

function Lua_CollectionBookData.Get:bUpdateDataFromServer()
	return self._bUpdateDataFromServer;
end

function Lua_CollectionBookData.Set:bUpdateDataFromServer(value)
	self._bUpdateDataFromServer = value;
end

function Lua_CollectionBookData:getHasFetterRewardIndex()
	return self.fetterHasRewardIndex;
end






















-- ---------------------测试收藏册数据---------------------------
-- function Lua_CollectionBookData:testCollectionbookData(msg)

-- 	local obj = msg.card_list;
-- 	for i = 1 , #obj do
-- 		local bagId = tonumber(obj[i].bag_id);
-- 		local pushId = tonumber(obj[i].push_id);
-- 		local rewardState = tonumber(obj[i].reward_state);
-- 		local bag = self.cardBagDir[bagId];
-- 		if bag then
-- 			print("====================================================================")
-- 			print("卡包",bagId, "封面卡", bag.pushCardId == pushId, "奖励状态", bag.rewardState == rewardState, "其他玩家封面id", bag.otherPushId, "其他玩家闪卡数量", bag.otherFlashCount)
-- 			local cardList = obj[i].card_state;
-- 			for i = 1, #cardList do
-- 				local cardId = tonumber(cardList[i].key);
-- 				local value = tonumber(cardList[i].value);
-- 				local cardInfo = self.cardDir[cardId];
-- 				if cardInfo then
-- 					-- print("卡牌id:", k, "unlockTime", v.unlockTime, "otherUnlockTime", v.otherUnlockTime)
-- 					print("卡牌", cardId, "解锁时间", cardInfo.unlockTime == value, "其他玩家解锁时间", cardInfo.otherUnlockTime );
-- 				else
-- 					print("没有卡牌", cardId)
-- 				end
-- 			end
-- 		else
-- 			print("没有卡包", bagId)
-- 		end
-- 	end
-- end

-- function Lua_CollectionBookData:testItemData()
-- 	-- 测试数据
-- 	print("测试数据")
-- 	local str = ""
-- 	for k, arr in pairs(self.itemDir) do
-- 		str = ""
-- 		for i = 1, arr:getSize() do
-- 			str = str.."    "..arr[i];
-- 		end
-- 		print(k, str)
-- 	end
-- end
