Lua_CollectionBookUtil = class("Lua_CollectionBookUtil");
-- 卡包
Lua_CollectionBookUtil.COMMON_CARD = 1; -- 普卡
Lua_CollectionBookUtil.CLASSIC_CARD = 2; -- 经典卡
Lua_CollectionBookUtil.FLASH_CARD = 3; -- 闪卡
Lua_CollectionBookUtil.CLOTH_CARD = 4; -- 皮肤闪卡
Lua_CollectionBookUtil.CARDBAG_TYPE = 5; -- 卡包类型
Lua_CollectionBookUtil.CARDBAG_REWARD = 6; -- 卡包奖励
Lua_CollectionBookUtil.CARDBAG_SORT = 7; -- 卡包排序

-- 卡牌
Lua_CollectionBookUtil.HEROID = 1;--英雄id hero_id
Lua_CollectionBookUtil.CHANGE_ITEM = 2;-- 兑换道具 change_item
Lua_CollectionBookUtil.COMPLETION_CARD = 3;-- 是否制作完成 completion_card
Lua_CollectionBookUtil.CARD_NAME = 4;-- 卡牌名称card_Name
Lua_CollectionBookUtil.FLASH_ID = 5;--闪卡id flash_id
Lua_CollectionBookUtil.PROP_TYPE = 6;-- 皮肤加成类型 prop_type
Lua_CollectionBookUtil.CARD_PROP = 7;-- 加成属性 card_prop


-- 普卡类型
Lua_CollectionBookUtil.MODEL_CARD = 1; -- 模型卡
Lua_CollectionBookUtil.ONLY_CARD = 2; -- 仅有卡
Lua_CollectionBookUtil.CREATE_CARD = 3; -- 原创卡
Lua_CollectionBookUtil.FRAME_CARD = 4; --名人堂


-- 卡牌状态
Lua_CollectionBookUtil.LOCK_CARD = 0;-- 未解锁
Lua_CollectionBookUtil.RECEIVE_CARD = 1;-- 可解锁
Lua_CollectionBookUtil.UNLOCK_CARD = 2;-- 已解锁

function Lua_CollectionBookUtil:ctor()

end

function Lua_CollectionBookUtil:dispose()
	self.allBags = nil;
end

-- function Lua_CollectionBookUtil:initData()
-- 	if self.constConfig == nil then
-- 		self.constConfig = getConfig({ "collection_book_const", "const" });
-- 	end
-- end

-- 封面最多展示个数
function Lua_CollectionBookUtil.Get:CBMaxCount()
	return getConfig({ "collection_book_const", "const", "max_count"});
end

-- 排行榜上榜限制
function Lua_CollectionBookUtil.Get:showRankLimit()
	return getConfig({ "collection_book_const", "const", "show_limit"});
end

-- 点赞次数上限
function Lua_CollectionBookUtil.Get:rankAdmireLimit()
	return getConfig({ "collection_book_const", "const", "like_limit"});
end

-- -- 点赞奖励
-- function Lua_CollectionBookUtil.Get:rankAdmireReward()
-- 	return self.constConfig.like_reward;
-- end

-- 普卡总数
function Lua_CollectionBookUtil.Get:ordinaryCardTotalCount()
	if self._ordinaryCardTotalCount == nil then
		self:getAllBags();
	end
	return self._ordinaryCardTotalCount;
end

-- 闪卡总数
function Lua_CollectionBookUtil.Get:flashCardTotalCount()
	if self._flashCardTotalCount == nil then
		self:getAllBags();
		self._flashCardTotalCount = self.skinCardCount + self.heroCardCount;
	end
	return self._flashCardTotalCount;
end

-- 皮肤闪卡总数
function Lua_CollectionBookUtil.Get:skinCardCount()
	if self._skinCardCount == nil then
		self:getAllBags();
	end
	return self._skinCardCount;
end

-- 英雄闪卡总数
function Lua_CollectionBookUtil.Get:heroCardCount()
	if self._heroCardCount == nil then
		self:getAllBags();
	end
	return self._heroCardCount;
end

-- 读取配置表信息
function Lua_CollectionBookUtil:getFetterConfigById(id)
	return getConfig({ "hero_fetter", id});
end

-- 读取卡包排序
function Lua_CollectionBookUtil:getCardBagSortById(id)
	local sort = 0;
	local config = getConfig({ "collection_bag", id});
	if config ~= nil and config.sort ~= nil then
		sort = config.sort;
	end
	return sort;
end

-- 获取皮肤获取途径
function Lua_CollectionBookUtil:getCollectionSkinPathId()
	return getConfig({ "collection_book_const", "const", "skin_collect_id"});
end

-- 获取英雄获取途径
function Lua_CollectionBookUtil:getCollectionHeroPathId()
	return getConfig({ "collection_book_const", "const", "hero_collect_id"});
end

-- 获取闪卡获取途径
function Lua_CollectionBookUtil:getCollectionFlashPathId()
	return getConfig({ "collection_book_const", "const", "flash_collect_id"});
end

-- 根据闪卡id（hero_des-闪卡表）计算出卡包id
function Lua_CollectionBookUtil:getCardBagIdByFlashId(flashId)
	if flashId ~= nil then
		return Mathf.Floor(flashId / 100); -- 闪卡id = 卡包id * 100 + 类型
	end

	return nil;
end

-- 根据收藏册卡牌id（collection_book-收藏册表）计算出卡包id
function Lua_CollectionBookUtil:getCardBagIdByCBId(collectionbookId)
	if collectionbookId ~= nil then
		return Mathf.Floor(collectionbookId / 1000); 
	end

	return nil;
end

-- 读取单张卡牌的配置数据
function Lua_CollectionBookUtil:getSingleCardConfigById(cardId)
	if cardId ~= nil then
		cardId = tonumber(cardId);
		return getConfig({ "collection_book", cardId});
	end
end

-- 读取卡包的配置数据
function Lua_CollectionBookUtil:getCardBagConfigById(cardBadId)
	if cardBadId ~= nil then
		cardBadId = tonumber(cardBadId);
		return getConfig({ "collection_bag", cardBadId});
	end
end

-- 判断该卡牌是否为已制作完成卡牌
function Lua_CollectionBookUtil:checkCompletedCard(cardId)
	if cardId then
		cardId = tonumber(cardId);
		local completion_card = self:getCardConfigByCardIdAndType(cardId, Lua_CollectionBookUtil.COMPLETION_CARD);
		return completion_card == 1;
	end
end

-- 根据闪卡id判断出收藏册id卡牌是否制作完成
function Lua_CollectionBookUtil:checkCompletedCardByFlashId(flashId)
	local cardBagId = self:getCardBagIdByFlashId(flashId);
	local cardType = tonumber(string.sub(flashId, 10, 11));
	local type;
	if cardType == 1 then
		type = Lua_CollectionBookUtil.COMMON_CARD;
	elseif cardType == 2 then
		type = Lua_CollectionBookUtil.CLASSIC_CARD;
	elseif cardType == 3 then
		type = Lua_CollectionBookUtil.FLASH_CARD;
	elseif cardType == 4 then
		type = Lua_CollectionBookUtil.CLOTH_CARD;
	end

	local cardId = self:getBagConfigByCardBagIdAndType(cardBagId, type);
	return self:checkCompletedCard(cardId);
end

-- 根据英雄id判断出普卡（经典卡）是否制作完成
-- 普卡、经典卡同时制作完成
function Lua_CollectionBookUtil:checkCompletedCardByHeroId(heroId)
	local cardBagId = tonumber(heroId);
	local cardId = self:getBagConfigByCardBagIdAndType(cardBagId, Lua_CollectionBookUtil.COMMON_CARD);
	return self:checkCompletedCard(cardId);
end

-- 获取卡包中某字段的配置
function Lua_CollectionBookUtil:getBagConfigByCardBagIdAndType(cardBadId, type)
	if cardBadId and type then
		local cardBagInfo = self:getCardBagConfigById(cardBadId);
		if cardBagInfo ~= nil then
			if type == Lua_CollectionBookUtil.COMMON_CARD then -- 普卡
				return cardBagInfo.common;
			elseif type == Lua_CollectionBookUtil.CLASSIC_CARD then -- 经典 
				return cardBagInfo.classic;
			elseif type == Lua_CollectionBookUtil.FLASH_CARD then -- 闪卡
				return cardBagInfo.flash;
			elseif type == Lua_CollectionBookUtil.CLOTH_CARD then -- 皮肤闪卡
				return cardBagInfo.cloth_card;
			elseif type == Lua_CollectionBookUtil.CARDBAG_TYPE then -- 卡包类型
				return cardBagInfo.sub_type;
			elseif type == Lua_CollectionBookUtil.CARDBAG_REWARD then -- 卡包奖励
				return cardBagInfo.reward;
			elseif type == Lua_CollectionBookUtil.CARDBAG_SORT then -- 卡包排序
				return cardBagInfo.sort;
			end
		end
	end
end

-- 获取卡牌中某字段的配置
function Lua_CollectionBookUtil:getCardConfigByCardIdAndType(cardId, type)
	if cardId and type then
		local config = self:getSingleCardConfigById(cardId);
		if config ~= nil then
			if type == Lua_CollectionBookUtil.HEROID then --英雄id hero_id
				return config.hero_id; 
			elseif type == Lua_CollectionBookUtil.CHANGE_ITEM then -- 兑换道具 change_item
				return config.change_item;
			elseif type == Lua_CollectionBookUtil.COMPLETION_CARD then-- 是否制作完成 completion_card
				return config.completion_card;
			elseif type == Lua_CollectionBookUtil.CARD_NAME then -- 卡牌名称 card_Name 
				return config.card_Name;
			elseif type == Lua_CollectionBookUtil.FLASH_ID then --闪卡id flash_id
				return config.flash_id;
			elseif type == Lua_CollectionBookUtil.PROP_TYPE then -- 皮肤加成类型 prop_type
				return config.prop_type;
			elseif type == Lua_CollectionBookUtil.CARD_PROP then -- 加成属性 card_prop
				return config.card_prop;
			end
		end
	end
end

-- 根据卡牌id,通过公式计算出是否为该type类型
function Lua_CollectionBookUtil:checkCardTypeById(cardId, type)
	if not self:getSingleCardConfigById(cardId) then
		return false;
	end

	if cardId and type then
		local residue = Mathf.Floor( (cardId % 1000) / 100 );
		if type == Lua_CollectionBookUtil.COMMON_CARD then -- 普卡
			return residue == 1;
		elseif type == Lua_CollectionBookUtil.CLASSIC_CARD then -- 经典 
			return residue == 2;
		elseif type == Lua_CollectionBookUtil.FLASH_CARD then -- 闪卡
			return residue == 3;
		elseif type == Lua_CollectionBookUtil.CLOTH_CARD then -- 皮肤闪卡
			return residue == 4;
		end
	end
end

-- 判断普卡的类型
function Lua_CollectionBookUtil:checkCommonCardTypeById(cardId, type)
	if not self:getSingleCardConfigById(cardId) then
		return false;
	end

	if not self:checkCardTypeById(cardId, Lua_CollectionBookUtil.COMMON_CARD) then -- 不是普卡，排除
		return false;
	end

	if cardId and type then
		local index = string.len( tonumber(cardId))
		local residue = string.sub(cardId, index, index);--cardId % 100000000000;
		residue = tonumber(residue);
		if type == Lua_CollectionBookUtil.MODEL_CARD then -- 模型卡
			return residue == 1;
		elseif type == Lua_CollectionBookUtil.ONLY_CARD then -- 仅有卡
			return residue == 2;
		elseif type == Lua_CollectionBookUtil.CREATE_CARD then -- 原创卡
			return residue == 3;
		elseif type == Lua_CollectionBookUtil.FRAME_CARD then -- 名人堂
			return residue == 4;
		end
	end
end

-- 是否是英雄系统收集
function Lua_CollectionBookUtil:checkCollectedFromHeroSystem(cardId)
	local bModelCard  = self:checkCommonCardTypeById(cardId, Lua_CollectionBookUtil.MODEL_CARD); -- 模型卡
	if bModelCard then
		return true;
	end
	local bCreateCard = self:checkCommonCardTypeById(cardId, Lua_CollectionBookUtil.CREATE_CARD);-- 原创卡
	if bCreateCard then
		return bCreateCard;
	end
	local bFrameCard = self:checkCommonCardTypeById(cardId, Lua_CollectionBookUtil.FRAME_CARD); -- 名人堂
	if bFrameCard then
		return bFrameCard;
	end
	return false;
end

function Lua_CollectionBookUtil:checkBagTypeById(bagId, type)
	local sub_type = self:getBagConfigByCardBagIdAndType(bagId, Lua_CollectionBookUtil.CARDBAG_TYPE);
	if sub_type ~= nil then
		if type == Lua_CollectionBookUtil.MODEL_CARD then -- 模型卡
			return sub_type == 1;
		elseif type == Lua_CollectionBookUtil.ONLY_CARD then -- 仅有卡
			return sub_type == 2;
		elseif type == Lua_CollectionBookUtil.CREATE_CARD then -- 原创卡
			return sub_type == 3;
		elseif type == Lua_CollectionBookUtil.FRAME_CARD then -- 名人堂
			return sub_type == 4;
		end
	end
end

function Lua_CollectionBookUtil:getAllBags()
	if self.allBags == nil then
		local cardId;
		self.allBags = {};
		self._ordinaryCardTotalCount = 0; --普卡总数
		self._heroCardCount = 0; -- 英雄闪卡总数
		self._skinCardCount = 0; -- 皮肤闪卡总数
		local config = getConfig({ "collection_bag"});
		for k, v in pairs(config) do
			self.allBags[#self.allBags + 1] = k;

			cardId = v.common;
			if cardId ~= nil and self:checkCompletedCard(cardId) then
				self._ordinaryCardTotalCount = self._ordinaryCardTotalCount + 1;
			end

			cardId = v.flash;
			if cardId ~= nil and self:checkCompletedCard(cardId) then
				self._heroCardCount = self._heroCardCount + 1;
			end

			if v.cloth_card ~= nil and #v.cloth_card > 0 then
				for i = 1, #v.cloth_card do
					cardId = v.cloth_card[i];
					if cardId ~= nil and self:checkCompletedCard(cardId) then
						self._skinCardCount = self._skinCardCount + 1;
					end
				end
			end
		end

		table.sort( self.allBags, function(a, b)
				local ASort = self:getBagConfigByCardBagIdAndType(a, Lua_CollectionBookUtil.CARDBAG_SORT); 
				local BSort = self:getBagConfigByCardBagIdAndType(b, Lua_CollectionBookUtil.CARDBAG_SORT);
				return ASort < BSort;
			end
			 );
	end
	return self.allBags;
end

-- 获取所有需要激活的卡牌且是已制作完成的
function Lua_CollectionBookUtil:getAllNeedActiveCards()
	if self.needActiveCards == nil then
		self.needActiveCards = {};
		local bagId;
		local config = getConfig({ "collection_book"});
		for k, v in pairs(config) do
			bagId = self:getCardBagIdByCBId(k);
			if self:getCardBagConfigById(bagId) and self:checkCompletedCard(k) and self:getCardConfigByCardIdAndType(k, Lua_CollectionBookUtil.CHANGE_ITEM) then
				self.needActiveCards[#self.needActiveCards + 1] = k;
			end
		end
	end
	return self.needActiveCards;
end

-- 是否有联动卡
function Lua_CollectionBookUtil.Get:hasLianDongCard()
	local sub_type;
	local hasCard = false;
	local allBags = self:getAllBags();
	for i = 1, #allBags do
		sub_type = self:getBagConfigByCardBagIdAndType(allBags[i], Lua_CollectionBookUtil.CARDBAG_TYPE);
		if sub_type == Lua_CollectionBookUtil.FRAME_CARD then
			hasCard = true;
			break;
		end
	end
	return hasCard;
end

function Lua_CollectionBookUtil:getAdditionDesc(cardId)
	local str;
	local type = self:getCardConfigByCardIdAndType(cardId, Lua_CollectionBookUtil.PROP_TYPE);
	if type ~= nil then
		if type == 0 then
			str = LanUtil.getValue(410044);--"所有英雄加成：";
		elseif type == 1 then
			str = LanUtil.getValue(410045);--"灵州英雄加成：";
		elseif type == 2 then
			str = LanUtil.getValue(410046);--"云渊英雄加成："
		elseif type == 3 then
			str = LanUtil.getValue(410047);--"岚谷英雄加成：";
		elseif type == 4 then
			str = LanUtil.getValue(410048);--"武境英雄加成：";
		end
	end
	return str;
end

-- 显示闪卡特效
function Lua_CollectionBookUtil:checkShowEffectByCardId(cardId)
	local isShowEffect = self:checkCardTypeById(cardId, Lua_CollectionBookUtil.FLASH_CARD) or 
						 self:checkCardTypeById(cardId, Lua_CollectionBookUtil.CLOTH_CARD);
	return isShowEffect;
end

function Lua_CollectionBookUtil:canActiveByCardId(cardId)
	local exchanges = self:getCardConfigByCardIdAndType(cardId, Lua_CollectionBookUtil.CHANGE_ITEM);
	if exchanges ~= nil then
		local itemId;-- = exchanges
		local hasCount;
		local itemCount;
		local bSatisfy = true;
		for i = 1, #exchanges do
			itemId = exchanges[i][1];
			itemCount = exchanges[i][2];
			hasCount = DataCenter.packData:getItemCountById(itemId);
			if hasCount < itemCount then
				bSatisfy = false;
				break;
			end
		end
		return bSatisfy;
	end
end