Lua_CollectionVo = class("Lua_CollectionVo", Lua_ToolVo);
function Lua_CollectionVo:ctor(id, count)
	self:superCall("ctor", id, count);

	self:dispose();
end

function Lua_CollectionVo:dispose()
	if self._configArr ~= nil then
		self._configArr:dispose();
		self._configArr:clear();
		self._configArr = nil;
	end
	self.grow_progress = 0;
end

function Lua_CollectionVo:fromServer(msg)
	self.is_active = msg.is_active; -- 是否激活 0未激活 1激活
	self.is_share = msg.is_share; -- 是否分享过 0未分享过 1已分享
	self.grow_progress = msg.grow_progress; -- 成长进度
	self.is_draw_active_reward = msg.is_draw_active_reward; -- 是否领取激活奖励 0可以领取 1不可领取
	self.get_tick = msg.get_tick; -- 藏品获取时间
	self.is_have = msg.is_have; -- 是否拥有 0未拥有 1拥有
	self.obtain_progress = msg.obtain_progress; -- 获取进度（完成进度）
end

function Lua_CollectionVo:changeInfo()
	local tag = self.configArr[1].entry_type;
	for i = 1, self.configArr:getSize() do
		if tag ~= self.configArr[i].entry_type then
			return tag, i - 1;
		end
		tag = self.configArr[i].entry_type;
	end
	return tag, self.configArr:getSize();
end

function Lua_CollectionVo.Get:configArr()
	if self._configArr == nil then
		self._configArr = Array();

		local vo;
		for i = 1, #self.entry_list do
			vo = Lua_CollectionSinleVo.new(self.entry_list[i]);
			self._configArr:add(vo);
		end
	end
	return self._configArr;
end










Lua_CollectionSinleVo = class("Lua_CollectionSinleVo");
function Lua_CollectionSinleVo:ctor(id)
	self.id = id;
	self.config = getConfig("collection_entry", id);
end

-- 词条类型 1.普通词条 2.成长词条
function Lua_CollectionSinleVo.Get:entry_type()
	return self.config.entry_type;
end

-- 普通加成描述
function Lua_CollectionSinleVo.Get:normal_desc()
	return self.config.normal_desc;
end

-- 普通加成属性
function Lua_CollectionSinleVo.Get:normal_prop()
	return self.config.normal_prop;
end

-- 成长目标，任务总表id
function Lua_CollectionSinleVo.Get:grow_cond_id()
	return self.config.grow_cond_id;
end

-- 成长加成，词头描述（可以点击)
function Lua_CollectionSinleVo.Get:title_desc()
	return self.config.title_desc;
end

-- 成长加成，词头描述（不可以点击)
function Lua_CollectionSinleVo.Get:title_desc2()
	return self.config.title_desc2;
end

-- 弹窗描述
function Lua_CollectionSinleVo.Get:popup_desc()
	return self.config.popup_desc;
end

-- 成长加成描述
function Lua_CollectionSinleVo.Get:change_desc()
	return self.config.change_desc;
end

-- 单位进度
function Lua_CollectionSinleVo.Get:each()
	return self.config.each;
end

-- 单位进度的属性加成
function Lua_CollectionSinleVo.Get:prop()
	return self.config.prop;
end

-- 附加加成描述
function Lua_CollectionSinleVo.Get:other_desc()
	return self.config.other_desc;
end

-- 额外附加加成值
function Lua_CollectionSinleVo.Get:other_value()
	return self.config.other_value;
end