-- 跨服时空数据
Lua_CrossServerData = class("Lua_CrossServerData")
function Lua_CrossServerData:ctor()
	self:dispose();
end

function Lua_CrossServerData:dispose()
	self.open_day = 0;
	self.reset_tick = 0;
	self.world_level = 0;
	self.server_list = {};
end

function Lua_CrossServerData:fromServer50198001(msg)
	if msg == nil then
		return;
	end
	self.open_day = msg.open_day; -- 跨服重置时间
	self.reset_tick = msg.reset_tick; -- 玩家所在服的开服天数
	self.world_level = msg.world_level; -- 玩家所在服的当前世界等级
	self.server_list = msg.cluster_server_list; -- 玩法跨服组的服务器信息列表
end

-- 功能开启描述
function Lua_CrossServerData:openedDes(funcId)
	local data = DataCenter.funcOpenUtil:getFuncOpenVoById(funcId);
	if data == nil then
		return "";
	end

	local openInfo = getConfig({"function_open", funcId});
	local bool;
	local showValue;
	for k,v in pairs(data.des_list) do
		if openInfo[v[1]] ~= nil then
			if v[1] == "world_level" then
				bool = self.world_level < openInfo[v[1]];
				showValue = openInfo[v[1]];
			elseif v[1] == "open_day" then
				bool = self.open_day < openInfo[v[1]];
				showValue = openInfo[v[1]] - self.open_day;
			end

			if bool then
				return LanUtil.formateStr(v[2], tostring(showValue));
			end
		end
	end
	return "";
end