checkRequire("Lua_CustomGiftVo");
Lua_CustomGiftData = class("Lua_CustomGiftData");
function Lua_CustomGiftData:ctor()
	self:dispose();
end

function Lua_CustomGiftData:dispose()
	self.rewardDic = {};
	self._rewardArr = Array(); -- 全部奖励
end

function Lua_CustomGiftData:fromServer50108007(msg)
	if msg == nil then
		return;
	end

	local vo;
	local obj;
	local info;
	local showRewardDic;
	for i = 1, #msg.gift_list do
		obj = msg.gift_list[i];
		vo = self.rewardDic[obj.id]; -- item
		if vo == nil then
			vo = Lua_CustomGiftVo:new();
			vo:init(obj);

			self.rewardDic[obj.id] = vo;
			self._rewardArr:add(vo);
		else
			vo:updateServerInfo(obj.buy_times, obj.buy_limit, obj.cur_rewards)
		end
	end
end

-- 根据购买次数和id排序
function Lua_CustomGiftData.Get:rewardArr()
	self._rewardArr:sortf(self, self.sortFun);
	return self._rewardArr;
end

function Lua_CustomGiftData:sortFun(a, b)
	local _a = a.buy_limit - a.buy_times;
	local _b = b.buy_limit - b.buy_times;
	if (_a > 0 and _b > 0) or (_a <= 0 and _b <= 0) then
		if a.recharge_money > b.recharge_money then
			return false;
		end
	elseif _b > 0 then
		return false;
	end
	return true;
end