Lua_CustomGiftVo = class("Lua_CustomGiftVo");
function Lua_CustomGiftVo:ctor(id)
end

function Lua_CustomGiftVo:init(msg)
	self.id = msg.id; -- 礼包ID
	self.buy_times = msg.buy_times; -- 已购买次数
	self.buy_limit = msg.buy_limit; -- 购买次数上限
	self.name = msg.name; -- 礼包名字
	self.fixed_rewards = self:fixedRewards(msg.fixed_rewards); -- 固定奖励
	self.cur_rewards = self:curRewards(msg.cur_rewards); -- 当前已定义礼包奖励
	self.custom_rewards = self:customRewards(msg.custom_rewards); -- 可选奖励
	self.recharge_id = msg.recharge_id; -- 充值id（充值档次）
	self.recharge_money = msg.recharge_money; -- 充值金额
	self.fixed_num = #self.fixed_rewards; -- 固定奖励个数
	self.choose_num = msg.choose_num; -- 可选择奖励个数

	self.all_reward = self:integrateRewardInfo(self.fixed_rewards, self.cur_rewards, self.choose_num); -- 整合后的全部奖励
end

function Lua_CustomGiftVo:updateServerInfo(buy_times, buy_limit, cur_rewards)
	self.buy_times = buy_times;
	self.buy_limit = buy_limit;
	self.cur_rewards = self:curRewards(cur_rewards);

	self.all_reward = self:integrateRewardInfo(self.fixed_rewards, self.cur_rewards, self.choose_num);
end

function Lua_CustomGiftVo:fixedRewards(fixedRewardInfo)
	local fixedReward = {};
	for i = 1, #fixedRewardInfo do
		fixedReward[i] = Lua_ToolVo.createToolVo(fixedRewardInfo[i].key, fixedRewardInfo[i].value);
	end
	return fixedReward;
end

function Lua_CustomGiftVo:curRewards(curRewardInfo)
	local curSelectReward = {};
	for i = 1, #curRewardInfo do
		curSelectReward[curRewardInfo[i].ex_value] = Lua_ToolVo.createToolVo(curRewardInfo[i].key, curRewardInfo[i].value);
	end
	return curSelectReward;
end

function Lua_CustomGiftVo:customRewards(rewardInfo)
	local vo;
	local index;
	local selectReward = {};
	for i = 1, #rewardInfo do
		index = rewardInfo[i].ex_value;
		if selectReward[index] == nil then
			selectReward[index] = Array();
		end
		vo = Lua_ToolVo.createToolVo(rewardInfo[i].key, rewardInfo[i].value);
		selectReward[index]:add(vo);
	end
	return selectReward;
end

-- 固定和定制奖励合起来的全部奖励
function Lua_CustomGiftVo:integrateRewardInfo(fixed, selected, chooseNum)
	local reward = {};
	for i = 1, #fixed + chooseNum do
		if i <= #fixed then
			reward[i] = fixed[i];
		else
			if selected[i - #fixed] == nil then
				reward[i] = 0;
			else
				reward[i] = selected[i - #fixed];
			end
		end
	end
	return reward;
end