checkRequire("Lua_DailyRechargeVo");
Lua_DailyRechargeData = class("Lua_DailyRechargeData")
function Lua_DailyRechargeData:ctor()
	self:dispose();
end

function Lua_DailyRechargeData:dispose()
	if self._dailyRechargeArr ~= nil then
		self._dailyRechargeArr:dispose();
		self._dailyRechargeArr:clear();
		self._dailyRechargeArr = nil;
	end
	self.dailyRechargeVo = {};
end

function Lua_DailyRechargeData:fromServer50197007(msg)
	if msg == nil then
		return;
	end

	self.totalRecharge = Mathf.Floor(msg.total_recharge); -- 累计充值

	local obj;
	local vo;
	local redDotState = false;
	for i = 1, #msg.grade_state do -- 各档位领取状态，key：id，value：0未达成 1可领取 2已领取
		obj = msg.grade_state[i];
		vo = self.dailyRechargeVo[obj.key];
		if vo == nil then
			vo = Lua_DailyRechargeVo.new(obj.key);
			self.dailyRechargeVo[obj.key] = vo;
		end
		if vo ~= nil then
			vo:updateRechargeInfo(obj.value, msg.world_level);
			if not redDotState and vo.drawState == 1 then
				redDotState = true;
			end
		end
	end
	-- 活动是否开启 1开启
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.DailyRecharge, redDotState);
end

function Lua_DailyRechargeData:getDailyRechargeVoById(id)
	if self.dailyRechargeVo[id] ~= nil then
		return self.dailyRechargeVo[id];
	end
	return;
end

function Lua_DailyRechargeData.Get:dailyRechargeArr()
	if self._dailyRechargeArr == nil then
		self._dailyRechargeArr = Array();

		local config = getConfig("daily_recharge");
		local vo;
		for k,v in pairs(config) do
			vo = self:getDailyRechargeVoById(v.id);
			if type(v.id) == type_str_number and vo ~= nil and vo.open then
				self._dailyRechargeArr:add(vo);
			end
		end
		self._dailyRechargeArr:sort("id", false);
	end
	return self._dailyRechargeArr;
end