-- 队伍大厅
Lua_TeamSaloonVo = class("Lua_TeamSaloonVo")
function Lua_TeamSaloonVo:ctor(id)
	self.id = id;
	self.team_list = nil;
end

function Lua_TeamSaloonVo:fromServer(msg)
	if msg == nil then
		return;
	end

	self.leader_name = msg.leader_name; -- 队长名
	self.is_full = msg.is_full; -- 是否满员 0未满 1满
	self.total_force = tonumber(msg.total_force); -- 总战力
	self.fight_set = msg.team_set_info.fight_set; -- 战斗设置 0没有选择 1人满自动开始挑战 2失败再次自动挑战 3人满自动挑战和失败再次挑战
	self.difficulty = msg.team_set_info.difficulty; -- 队伍难度
	self.force_cond = msg.team_set_info.force_cond; -- 战力要求 1无战力要求
	self.team_join_limit = msg.team_set_info.team_join_limit; -- 队伍加入限制 0任何可以加入 1邀请加入

	self.team_list = {};
	for i = 1, #msg.member_list do
		self.team_list[msg.member_list[i].pos] = msg.member_list[i];
	end
	self._showForec = nil;
end

-- 战力展示
function Lua_TeamSaloonVo.Get:showForec()
	if self._showForec == nil then
		self._showForec = DataCenter.equipCopyUtil:getForceNumByType(self.force_cond);
	end
	return self._showForec;
end

-- 战力是否达标
function Lua_TeamSaloonVo.Get:isForec()
	if self.force_cond == 1 then -- 无战力要求
		return;
	end
	return DataCenter.roleData.force >= self.showForec;
end