-- 寂灭岛装备副本消息类
checkRequire("Lua_EquipCopyUtil");
checkRequire("Lua_EquipCopyData");
Lua_EquipCopyProxy = class("Lua_EquipCopyProxy");
function Lua_EquipCopyProxy:ctor()
	DataCenter.equipCopyUtil = Lua_EquipCopyUtil.new();
	DataCenter.equipCopyData = Lua_EquipCopyData.new();

	Lua_MsgUtil.addLuaMsg(50201001, self, self.rEquipCopy); -- 请求寂灭岛界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50201002, self, self.rHarvest); -- 请求寂灭岛每日收获信息（返回）
	Lua_MsgUtil.addLuaMsg(50201003, self, self.rTeamSaloon); -- 请求寂灭岛队伍大厅信息（返回）
	Lua_MsgUtil.addLuaMsg(50201006, self, self.rTeamInfo); -- 请求寂灭岛队伍信息（返回）
	Lua_MsgUtil.addLuaMsg(50201012, self, self.rIsExchangePos); -- 请求处理队伍成员位置交换（返回）
	Lua_MsgUtil.addLuaMsg(50201013, self, self.rLockLog); -- 请求查看队伍日志信息（返回）
	Lua_MsgUtil.addLuaMsg(50201014, self, self.rJoinTeam); -- 请求加入队伍（返回）
	Lua_MsgUtil.addLuaMsg(50201015, self, self.rInviteJoinTeam); -- 请求邀请加入寂灭岛队伍（返回）
	Lua_MsgUtil.addLuaMsg(50201016, self, self.rLockInvite); -- 请求查看寂灭岛队伍邀请信息（返回）
	Lua_MsgUtil.addLuaMsg(50201017, self, self.rSutoJoin); -- 请求加入队伍（返回）
	Lua_MsgUtil.addLuaMsg(50201018, self, self.rIsInvite); -- 请求处理寂灭岛队伍邀请信息（返回）
	Lua_MsgUtil.addLuaMsg(50201020, self, self.rFirstPassRankInfo); -- 请求寂灭岛首通信息（返回）
	Lua_MsgUtil.addLuaMsg(50201021, self, self.rTypeRankInfo); -- 请求寂灭岛极限回合、极限战力信息（返回）
	Lua_MsgUtil.addLuaMsg(50201022, self, self.rFirstPassRankReceiveInfo); -- 请求领取寂灭岛首通奖励（返回）
	Lua_MsgUtil.addLuaMsg(50201027, self, self.rInvite); -- 请求寂灭岛邀请信息（返回）
	Lua_MsgUtil.addLuaMsg(50201029, self, self.rMoreOpenCard); -- 请求寂灭岛组队奖励翻牌（返回）
	Lua_MsgUtil.addLuaMsg(50201030, self, self.rSingleOpenCard); -- 请求寂灭岛单人奖励翻牌（返回）
	Lua_MsgUtil.addLuaMsg(50201034, self, self.rLookHort); -- 请求查看收获伤害统计信息（返回）

	Lua_MsgUtil.addLuaMsg(80201005, self, self.updateTeamInfo); -- 通知寂灭岛队伍信息（通知）
	Lua_MsgUtil.addLuaMsg(80201024, self, self.updateTeamMemberInfo); -- 通知队伍成员的准备状态（通知）
	Lua_MsgUtil.addLuaMsg(80201026, self, self.rTeamPosChange); -- 通知玩家处理更换位置（通知）
	Lua_MsgUtil.addLuaMsg(80201028, self, self.rCopyOpenState); -- 通知寂灭岛boss开启信息（通知）
	Lua_MsgUtil.addLuaMsg(80201031, self, self.updateMoreOpenCard); -- 通知寂灭岛多人奖励翻牌（通知）
	Lua_MsgUtil.addLuaMsg(80201033, self, self.updateHarvestRedPoint); -- 通知寂灭岛今日收获红点是否显示（通知）
	Lua_MsgUtil.addLuaMsg(80201035, self, self.openInvitePopUpWin); -- 通知寂灭岛队伍邀请信息(弹窗)（通知）
end

-- 请求寂灭岛界面信息（返回）
function Lua_EquipCopyProxy:rEquipCopy(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201001();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201001(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_INFO");
	end
end

-- 请求寂灭岛每日收获信息（返回）
function Lua_EquipCopyProxy:rHarvest(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201002();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201002(msg);
		Lua_MsgUtil.callFunc("UPDATE_HARVEST_INFO");
	end
end

-- 请求寂灭岛队伍大厅信息（返回）
function Lua_EquipCopyProxy:rTeamSaloon(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201003();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201003(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_SALOON");
	end
end

-- 通知寂灭岛队伍信息
function Lua_EquipCopyProxy:updateTeamInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80201005();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer80201005(msg);
		--print("更新战前准备状态   ",msg.type);
		if msg.type == 1 or msg.type == 2 or msg.type == 6 then -- 加入/退出/创建
			if msg.type == 2 then
				if Lua_WindowUtil.isWindowShowing("Lua_TeamSaloonWindow") then
					Lua_WindowUtil.openWin("Lua_TeamSaloonWindow", Lua_WinParam.ACTION_OPEN, 1);
				end
			else
				if Lua_WindowUtil.isWindowShowing("Lua_TeamInviteWindow") then
					Lua_WindowUtil.openWin("Lua_TeamInviteWindow", Lua_WinParam.ACTION_CLOSE);
				end
				if Lua_WindowUtil.isWindowShowing("Lua_InviteBtnWindow") then
					Lua_WindowUtil.openWin("Lua_InviteBtnWindow", Lua_WinParam.ACTION_CLOSE);
				end
				if Lua_WindowUtil.isWindowShowing("Lua_EquipCopyWindow") then
					Lua_WindowUtil.openWin("Lua_TeamSaloonWindow", Lua_WinParam.ACTION_OPEN, 2);
				else
					DataCenter.funcPathUtil:gotoFunction(1117, true);--组队
				end
			end
			Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_INFO");
		elseif msg.type == 7 then--战斗开始变化 
			Lua_MsgUtil.callFunc("UPDATE_TEAM_STATE_INFO"); -- 更新战前准备状态
		elseif msg.type == 8 then--队伍设置变化
			Lua_MsgUtil.callFunc("UPDATE_TEMA_SET_INFO"); -- 请求修改队伍设置信息
		elseif msg.type == 9 then--被队长踢出
			Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_INFO");
			if Lua_WindowUtil.isWindowShowing("Lua_TeamSaloonWindow") then
				Lua_WindowUtil.openWin("Lua_TeamSaloonWindow", Lua_WinParam.ACTION_OPEN, 1);
			end
			OperateAlert.showLangValue(420111);
		elseif msg.type == 10 then--被系统踢出
			Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_INFO");
			if Lua_WindowUtil.isWindowShowing("Lua_TeamSaloonWindow") then
				Lua_WindowUtil.openWin("Lua_TeamSaloonWindow", Lua_WinParam.ACTION_OPEN, 1);
			end
			OperateAlert.showLangValue(420112);
		else
			Lua_MsgUtil.callFunc("UPDATE_TEAM_MEMBER_INFO"); -- 更新成员信息
		end
	end
end

-- 请求寂灭岛队伍信息（返回）
function Lua_EquipCopyProxy:rTeamInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201006();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201006(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_INFO");
	end
end

-- 请求处理队伍成员位置交换（返回）
function Lua_EquipCopyProxy:rIsExchangePos(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201012();
		msg:ParseFromString(mp.data);
		if msg.result == 0 then
			OperateAlert.showLangValue(420092);
		end
	end
end

-- 请求查看队伍日志信息（返回）
function Lua_EquipCopyProxy:rLockLog(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201013();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201013(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_JOURNAL");
	end
end

-- 请求加入队伍（返回）
function Lua_EquipCopyProxy:rJoinTeam(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201014();
		msg:ParseFromString(mp.data);
		if msg.result == 1 or msg.result == 2 then
			OperateAlert.showLangValue(420093);
			Lua_WindowUtil.openWin("Lua_ChatWindow", Lua_WinParam.ACTION_CLOSE);
		else
			OperateAlert.showLangValue(420094);
		end
	end
end

-- 请求邀请加入寂灭岛队伍（返回）
function Lua_EquipCopyProxy:rInviteJoinTeam(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201015();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201015(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_INVITATION_WINDOW", true);
	end
end

-- 请求查看寂灭岛队伍邀请信息（返回）
function Lua_EquipCopyProxy:rLockInvite(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201016();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201016(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_INVITATION_JOURNAL");
	end
end

-- 请求自动加入队伍（返回）
function Lua_EquipCopyProxy:rSutoJoin(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201017();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData.is_auto_join = msg.is_auto_join;
		Lua_MsgUtil.callFunc("UPDATE_AUTO_JOIN_TIME_STATE");
	end
end

-- 请求处理寂灭岛队伍邀请信息（返回）
function Lua_EquipCopyProxy:rIsInvite(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201018();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201018(msg);
	end
end

-- 请求寂灭岛首通信息（返回）
function Lua_EquipCopyProxy:rFirstPassRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201020();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201020(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_FIRSTPASS_RANK");
	end
end

-- 请求寂灭岛极限回合、极限战力信息（返回）
function Lua_EquipCopyProxy:rTypeRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201021();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201021(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_TYPE_RANK");
	end
end

-- 请求领取寂灭岛首通奖励（返回）
function Lua_EquipCopyProxy:rFirstPassRankReceiveInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201022();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201022(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_FIRSTPASS_RANK", true);
	end
end

-- 通知队伍成员的准备状态
function Lua_EquipCopyProxy:updateTeamMemberInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80201024();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer80201024(msg);
		Lua_MsgUtil.callFunc("UPDATE_TEAM_MEMBER_INFO");
	end
end

-- 通知玩家处理更换位置（返回）
function Lua_EquipCopyProxy:rTeamPosChange(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80201026();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_ChangeTeamPosWindow", Lua_WinParam.ACTION_OPEN, msg);
		DataCenter.equipCopyUtil:delayedChangeTeamPosWindow();
	end
end

-- 请求寂灭岛邀请信息（返回）
function Lua_EquipCopyProxy:rInvite(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201027();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201027(msg);
		Lua_MsgUtil.callFunc("EQUIP_COPY_TEAM_INVITATION_WINDOW"); -- 好友、工会邀请
	end
end

-- 通知寂灭岛boss开启信息
function Lua_EquipCopyProxy:rCopyOpenState(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80201028();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer80201028(msg);
	end
	Lua_MsgUtil.callFunc("EQUIP_COPY_OPEN_STATE", true); -- 副本开启
end

-- 请求寂灭岛组队奖励翻牌（返回）
function Lua_EquipCopyProxy:rMoreOpenCard(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201029();
		msg:ParseFromString(mp.data);
		if msg.result == 0 then
			DataCenter.equipCopyData.isOnCardClick = nil; -- 当前点击卡牌奖励领取失败，重置点击状态，可以点击别的卡牌
			OperateAlert.showLangValue(420095);
		end
	end
end

-- 请求寂灭岛单人奖励翻牌（返回）
function Lua_EquipCopyProxy:rSingleOpenCard(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201030();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer50201030(msg);
		Lua_MsgUtil.callFunc("UPDATE_SINGLE_OPEN_CARD");
	end
end

-- 请求寂灭岛多人奖励翻牌
function Lua_EquipCopyProxy:updateMoreOpenCard(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80201031();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer80201031(msg);
		if #msg.reward_info == 1 then -- 队伍其他一个人翻的卡牌
			-- print("队伍其他一个人  翻牌奖励通知")
			Lua_MsgUtil.callFunc("UPDATE_MORE_OPEN_CARD"); -- 队伍其他 某个人翻牌奖励通知
		else -- 剩余三个翻牌奖励通知
			-- print("剩余三个翻牌奖励通知")
			Lua_MsgUtil.callFunc("UPDATE_REST_MORE_OPEN_CARD"); -- 剩余翻牌奖励通知
		end
	end
end

-- 通知寂灭岛今日收获红点是否显示
function Lua_EquipCopyProxy:updateHarvestRedPoint(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80201033();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer80201033(msg);
	end
end

-- 请求查看收获伤害统计信息（返回）
function Lua_EquipCopyProxy:rLookHort(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50201034();
		msg:ParseFromString(mp.data);
		-- print("请求查看收获伤害统计信息（返回）", #msg.hurt_collect_info);
		if msg.type == 1 then -- 单人
			Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, msg.hurt_collect_info[1]);
		elseif msg.type == 2 then -- 多人
			Lua_WindowUtil.openWin("Lua_FightMoreHurtWindow", Lua_WinParam.ACTION_OPEN, msg.hurt_collect_info);
		end
	end
end

-- 通知寂灭岛队伍邀请信息(弹窗)（通知）
function Lua_EquipCopyProxy:openInvitePopUpWin(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80201035();
		msg:ParseFromString(mp.data);
		DataCenter.equipCopyData:fromServer80201035(msg);
	end
end










-- 请求寂灭岛界面信息
function Lua_EquipCopyProxy:sEquipCopy()
	-- print("请求寂灭岛界面信息")
	sendMsg(10201001);
end

-- 请求寂灭岛每日收获信息
function Lua_EquipCopyProxy:sHarvest(_type)
	local cmd = ProtoPublic_pb.Proto10201002();
	cmd.type = _type; -- 1单人 2队伍
	sendMsg(10201002, cmd);
end

-- 请求寂灭岛队伍大厅信息
function Lua_EquipCopyProxy:sTeamSaloon(force_cond, difficulty)
	local cmd = ProtoPublic_pb.Proto10201003();
	cmd.force_cond = force_cond; -- 战力
	cmd.difficulty = difficulty; -- 难度
	sendMsg(10201003, cmd);
end

-- 请求创建寂灭岛队伍
function Lua_EquipCopyProxy:sCreateTeam(team_join_limit, difficulty, force_cond, fight_set)
	local cmd = ProtoPublic_pb.Proto10201004();
	cmd.team_set.team_join_limit = team_join_limit; -- 队伍加入限制 0任何可以加入 1邀请加入
	cmd.team_set.difficulty = difficulty; -- 队伍难度
	cmd.team_set.force_cond = force_cond; -- 战力要求 1无战力要求
	cmd.team_set.fight_set = fight_set; -- 战斗设置 1失败再次挑战 0失败不自动挑战
	sendMsg(10201004, cmd);
end

-- 请求寂灭岛队伍信息
function Lua_EquipCopyProxy:sTeam()
	sendMsg(10201006);
end

-- 请求领取 寂灭岛今日收获
function Lua_EquipCopyProxy:sReceiveReward(typev, record_id)
	local cmd = ProtoPublic_pb.Proto10201007();
	cmd.type = typev; -- 1单人 2队伍
	cmd.record_id = record_id; -- 0一键领取 其他战斗记录id
	sendMsg(10201007, cmd);
end

-- 请求修改队伍设置信息
function Lua_EquipCopyProxy:sChangeTeam(team_join_limit, difficulty,force_cond,fight_set)
	local cmd = ProtoPublic_pb.Proto10201008();
	cmd.team_set_info.team_join_limit = team_join_limit; -- 队伍加入限制 0任何可以加入 1邀请加入
	cmd.team_set_info.difficulty = difficulty; -- 队伍难度
	cmd.team_set_info.force_cond = force_cond; -- 战力要求 1无战力要求
	cmd.team_set_info.fight_set = fight_set; -- 战斗设置 1失败再次挑战 0失败不自动挑战
	sendMsg(10201008, cmd);
end

-- 请求踢出队伍成员
function Lua_EquipCopyProxy:sKickTeam(member_id)
	local cmd = ProtoPublic_pb.Proto10201009();
	cmd.member_id = tonumber(member_id); -- 队伍成员id
	sendMsg(10201009, cmd);
end

-- 请求退出寂灭岛队伍
function Lua_EquipCopyProxy:sQuitTeam()
	sendMsg(10201010);
end

-- 请求更换队伍成员位置
function Lua_EquipCopyProxy:sExchangePos(pos)
	local cmd = ProtoPublic_pb.Proto10201011();
	cmd.pos = tonumber(pos); -- 请求更换队伍成员位置
	sendMsg(10201011, cmd);
end

-- 请求处理队伍成员位置交换
function Lua_EquipCopyProxy:sIsExchangePos(is_agree, role_id)
	local cmd = ProtoPublic_pb.Proto10201012();
	cmd.is_agree = tonumber(is_agree); -- 是否同意交换
	cmd.role_id = tonumber(role_id); -- 队伍成员id
	sendMsg(10201012, cmd);
end

-- 请求查看队伍日志信息
function Lua_EquipCopyProxy:sLockLog()
	sendMsg(10201013);
end

-- 请求加入队伍
function Lua_EquipCopyProxy:sJoinTeam(team_id, invite_name)
	invite_name = invite_name == nil and "" or invite_name;
	local cmd = ProtoPublic_pb.Proto10201014();
	cmd.team_id = tonumber(team_id);
	cmd.invite_name = invite_name;
	sendMsg(10201014, cmd);
end

-- 请求邀请加入寂灭岛队伍
function Lua_EquipCopyProxy:sInviteJoinTeam(role_id, _type)
	local cmd = ProtoPublic_pb.Proto10201015();
	cmd.role_id = role_id; -- 角色id
	cmd.type = tonumber(_type); --  1好友 2联盟盟友
	sendMsg(10201015, cmd);
end

-- 请求查看寂灭岛队伍邀请信息
function Lua_EquipCopyProxy:sLockInvite()
	sendMsg(10201016);
end

-- 请求自动加入队伍
function Lua_EquipCopyProxy:sSutoJoin(is_auto_join, force_cond, difficulty)
	local cmd = ProtoPublic_pb.Proto10201017();
	cmd.is_auto_join = is_auto_join; -- 是否自动加入
	cmd.boss_difficulty = difficulty == nil and 0 or difficulty; -- 难度
	cmd.force_cond = force_cond == nil and 0 or force_cond; -- 队伍战力条件
	sendMsg(10201017, cmd);
end

-- 请求处理寂灭岛队伍邀请信息
function Lua_EquipCopyProxy:sIsInvite(team_id, is_join)
	local cmd = ProtoPublic_pb.Proto10201018();
	cmd.team_id = tonumber(team_id); -- 队伍id
	cmd.is_join = is_join; -- 是否加入 0拒绝 1同意
	sendMsg(10201018, cmd);
end

-- 寂灭岛首通界面信息请求
function Lua_EquipCopyProxy:sFirstPassRankInfo()  
	sendMsg(10201020);
end

-- 请求寂灭岛极限回合、极限战力排行榜信息：  camp:boss阵营  type:1极限回合 2极限战力
function Lua_EquipCopyProxy:sTypeRankInfo(camp, type)
	local cmd = ProtoPublic_pb.Proto10201021();
	cmd.camp = camp; -- boss阵营
	cmd.type = type; -- 极限回合、极限战力
	sendMsg(10201021, cmd);
end

-- 请求领取首通排行榜奖励
function Lua_EquipCopyProxy:sReceiveRankRewardInfo(difficulty, camp)
	local cmd = ProtoPublic_pb.Proto10201022();
	cmd.difficulty = difficulty; -- 难度
	cmd.camp = camp;
	sendMsg(10201022, cmd);
end

-- 请求开始寂灭岛队伍挑战
function Lua_EquipCopyProxy:sMoreStartFight(typev)
	local cmd = ProtoPublic_pb.Proto10201023();
	cmd.type = typev; -- 1开始 2取消
	sendMsg(10201023, cmd);
end

-- 请求设置 战前 准备状态
function Lua_EquipCopyProxy:sPrewarReadyStatus(status)
	local cmd = ProtoPublic_pb.Proto10201025();
	cmd.status = status; -- 0取消 1准备
	sendMsg(10201025, cmd);
end

-- 请求寂灭岛邀请界面信息
function Lua_EquipCopyProxy:sInvite(typev)
	local cmd = ProtoPublic_pb.Proto10201027();
	cmd.type = typev; -- 1好友 2工会
	sendMsg(10201027, cmd);
end

-- 请求寂灭岛组队奖励翻牌
function Lua_EquipCopyProxy:sMoreOpenCard(pos)
	local msg = ProtoPublic_pb.Proto10201029();
	msg.pos = pos; -- 奖牌的位置
	sendMsg(10201029, msg);
end

-- 请求寂灭岛单人奖励翻牌
function Lua_EquipCopyProxy:sSingleOpenCard(pos, record_id)
	local msg = ProtoPublic_pb.Proto10201030();
	msg.pos = pos; -- 奖牌的位置
	msg.record_id = tonumber(record_id); -- 奖牌的位置
	sendMsg(10201030, msg);
end

-- 请求寂灭岛一键邀请好友 
function Lua_EquipCopyProxy:sInviteAll(type)
	local msg = ProtoPublic_pb.Proto10201032();
	msg.type = type; -- type:1好友 2联盟
	sendMsg(10201032, msg);
end

-- 请求查看收获伤害统计信息
function Lua_EquipCopyProxy:sLookHort(type, record_id)
	local msg = ProtoPublic_pb.Proto10201034();
	msg.type = type -- 1单人 2队伍
	msg.record_id = record_id -- 战斗记录id
	sendMsg(10201034, msg);
end


-- 请求分享
function Lua_EquipCopyProxy:sChat(chat_type, content_type)
	local msg = ProtoPublic_pb.Proto10105001();
	msg.chat_type = chat_type -- 频道类型
	msg.content_type = content_type -- 内容类型
	sendMsg(10105001, msg);
end

-- 组队战斗播放结束后发送
function Lua_EquipCopyProxy:sEquipCopyFightEnd(record_id)
	local msg = ProtoPublic_pb.Proto10201036();
	msg.record_id = tonumber(record_id);--自己的战斗id
	sendMsg(10201036, msg);
end

-- 请求魔灵岛队伍上轮战斗录像
function Lua_EquipCopyProxy:sEquipCopyVideo()
	sendMsg(10201038);
end