-- 寂灭岛装备副本配置
checkRequire("Lua_EquipCopyRankVo");
Lua_EquipCopyUtil = class("Lua_EquipCopyUtil");
Lua_EquipCopyUtil.singleSceneId = 40110;
Lua_EquipCopyUtil.moreSceneId = 40114;
function Lua_EquipCopyUtil:ctor()
	self:dispose();
end

function Lua_EquipCopyUtil:dispose()
	self._equipCopyInfo = nil;
	self.singleCopyDic = nil;--单人难度数据
	self._singleCopyInfo = nil;--单人难度数据
	self.fightGradeDic = nil;--战斗回合评分
	self._singleGradeInfo = nil;--单人评分
	self._moreGradeInfo = nil;--组队评分
	self:clearDelayedTime();

	-- 排行榜
	if self.rankConfigDic ~= nil then
		for k, v in pairs(self.rankConfigDic) do
			v:dispose();
			v = nil;
		end
		self.rankConfigDic = nil; -- 排行榜配置表全部数据
	end
	self.rankList = nil; -- 记录各个阵营的id
	self.bossNamelists = nil; -- boss阵营
end










-- 功能开启id
function Lua_EquipCopyUtil.Get:first_artifact_id()
	return getConfig("equip_copy_const", "first_artifact_id", "value");
end

-- 单人每日挑战次数上限
function Lua_EquipCopyUtil.Get:single_count_limit()
	return getConfig("equip_copy_const", "single_count_limit", "value");
end

-- 组队每日挑战奖励次数上限
function Lua_EquipCopyUtil.Get:more_reward_limit()
	return getConfig("equip_copy_const", "more_reward_limit", "value");
end

-- 组队每日协助奖励次数上限
function Lua_EquipCopyUtil.Get:more_extra_reward_count()
	return getConfig("equip_copy_const", "more_extra_reward_count", "value");
end

-- 组队每日协助奖励
function Lua_EquipCopyUtil.Get:more_extra_reward()
	return getConfig("equip_copy_const", "more_extra_reward_count", "arr_value");
end

-- 组队每日协助次数上限
function Lua_EquipCopyUtil.Get:more_extra_limit()
	return getConfig("equip_copy_const", "more_extra_limit", "value");
end

-- 单人模式额外次数消耗的道具
function Lua_EquipCopyUtil.Get:single_boss_extra_item()
	return getConfig("equip_copy_const", "single_boss_extra_item", "arr_value");
end

-- 创建队伍需要解锁的boss难度
function Lua_EquipCopyUtil.Get:create_team_cond()
	return getConfig("equip_copy_const", "create_team_cond", "value");
end

-- 分享频道
function Lua_EquipCopyUtil.Get:share_channel()
	return getConfig("equip_copy_const", "share_channel", "arr_value");
end

-- 频道分享时间限制
function Lua_EquipCopyUtil.Get:share_time_limit()
	return getConfig("equip_copy_const", "share_time_limit", "value");
end

-- 换位时间限制
function Lua_EquipCopyUtil.Get:change_time_limit()
	return getConfig("equip_copy_const", "change_time_limit", "value");
end

-- 交换队伍延时时间
function Lua_EquipCopyUtil.Get:change_team_delayed()
	return getConfig("equip_copy_const", "change_team_delayed", "value");
end

-- 队伍成员数量
function Lua_EquipCopyUtil.Get:team_num()
    return getConfig("equip_copy_const", "team_num", "value");
end

-- 组队开启时间
function Lua_EquipCopyUtil.Get:team_boss_open_tick()
	return getConfig("equip_copy_const", "team_boss_open_tick", "arr_value");
end

-- 单人战斗模板id
function Lua_EquipCopyUtil.Get:single_template_id()
	return getConfig("equip_copy_const", "single_template_id", "value");
end

-- 组队战斗模板id
function Lua_EquipCopyUtil.Get:more_template_id()
	return getConfig("equip_copy_const", "more_template_id", "value");
end

-- 自动关闭战斗结算界面时间
function Lua_EquipCopyUtil.Get:close_window_time()
	return getConfig("equip_copy_const", "close_window_time", "value");
end

-- 阵营最高难度
function Lua_EquipCopyUtil.Get:maxDifficult()
	return getConfig("equip_copy_const", "single_max_difficult", "value");
end

-- 寂灭岛战令经验
function Lua_EquipCopyUtil.Get:war_exp_reward_list()
	return getConfig("equip_copy_const", "war_exp_reward_list", "arr_value");
end

-- 战令经验奖励次数
function Lua_EquipCopyUtil.Get:war_exp_reward_num()
	return getConfig("equip_copy_const", "war_exp_reward_num", "value");
end

-- 跳过战斗的通关评级
function Lua_EquipCopyUtil.Get:skip_fight_score()
	local grade = getConfig("equip_copy_const","skip_fight_score", "value");
	return self:getCopyScoreByGrade(grade);
end

-- 魔灵岛组队页签
function Lua_EquipCopyUtil.Get:boss_tag_list()
	return getConfig("equip_copy_const","boss_tag_list", "arr_value");
end






-- 单人模式难度
function Lua_EquipCopyUtil:getSingleCapyDicById(id)
	if self.singleCopyDic == nil then
		self.singleCopyDic = {};
	end

	if self.singleCopyDic[id] == nil then
		self.singleCopyDic[id] = Array();

		local config = getConfig("equip_copy_single"); 
		for k,v in pairs(config) do
			if v.camp == id then
				self.singleCopyDic[id]:add({id = v.id, camp = v.camp, sort = v.difficulty});
			end
		end
		self.singleCopyDic[id]:sort("sort", false)
	end

	if self.singleCopyDic[id] == nil then
		return Array();
	end
	return self.singleCopyDic[id];
end

function Lua_EquipCopyUtil:getSingleDiffCountByCamp(camp)
	if self.singleCampDic == nil then
		self.singleCampDic = {};

		local config = getConfig("equip_copy_single"); 
		for k,v in pairs(config) do
			if self.singleCampDic[v.camp] == nil then
				self.singleCampDic[v.camp] = 0;
			end
			self.singleCampDic[v.camp] = self.singleCampDic[v.camp] + 1;
		end
	end
	return self.singleCampDic[camp];
end

-- 单个难度数据
function Lua_EquipCopyUtil:getSingleCapyVoById(id)
	local configData = getConfig("equip_copy_single"); 
	if id == nil then
		return nil;
	end
	return configData[id];
end

-- 单人难度bossId
function Lua_EquipCopyUtil:getSingleBossIdById(id)
	local singleInfo = self:getSingleCapyVoById(id);
	return self:getTheBossId(singleInfo.boss_id);
end

function Lua_EquipCopyUtil:getTheBossId(id)
	local monsterPlayerInfo = getConfig("tb_monster_player", id, "fighter_list");
	local bossId;
	for i = 1, #monsterPlayerInfo[1] do
		if monsterPlayerInfo[1][i][2] == 6 then
			bossId = monsterPlayerInfo[1][i][1];
			break;
		end
	end
	return bossId;
end










-- 数据
-- 战力筛选
function Lua_EquipCopyUtil:forceScreenInfo(garde)
	local force;
	local isUnlock;
	local arr = Array();
	local list = getConfig("equip_copy_const", "force_level", "arr_value");
	local _index = #list;
	for i=1, #list do
		force = list[i][2];
		if list[i][1] == garde then
			_index = i;
		end
		if force == 0 then
			force = LanUtil.getValue(420096);
			isUnlock = true;
		else
			isUnlock = DataCenter.roleData.force >= force;
		end
		arr:add({index = i, setType = list[i][1], showDes = force, isUnlock = isUnlock});
	end
	return arr, _index;
end

-- 难度筛选
function Lua_EquipCopyUtil:getDiffScreenInfo(max_difficulty, select_diff)
	select_diff = select_diff == nil and max_difficulty or select_diff;
	
	local arr = Array();
	local list = getConfig("equip_copy_const", "difficulty_list", "arr_value");
	local setType;
	local _index = #list;
	for i = 1, #list do
		setType = list[i][1]
		if setType == select_diff then
			_index = i;
		end
		arr:add({index = i, setType = setType, showDes = list[i][2], isUnlock = setType <= max_difficulty});
	end
	return arr, _index;
end

-- 战力筛选描述
function Lua_EquipCopyUtil:getForceScreenDes(index)
	local list = getConfig("equip_copy_const", "force_level", "arr_value");
	for i = 1, #list do
		if list[i][1] == index then
			if list[i][2] == 0 then
				return LanUtil.getValue(420096);
			else
				return list[i][2];
			end
		end
	end
	return "";
end

-- 难度筛选描述
function Lua_EquipCopyUtil:getDiffScreenDes(diff)
	local list = getConfig("equip_copy_const", "difficulty_list", "arr_value");
	for i = 1, #list do
		if list[i][1] == diff then
			return list[i][2];
		end
	end
	return "";
end

-- 获取战力级别的战力值
function Lua_EquipCopyUtil:getForceNumByType(typev)
	local list = getConfig("equip_copy_const", "force_level", "arr_value");
	for i=1,#list do
		if typev == list[i][1] then
			return list[i][2];
		end
	end
	return 0;
end

-- 组队开启状态  true开启  false关闭
function Lua_EquipCopyUtil.Get:teamOpenState()
	local index = tonumber(os.date("%w", DataCenter.roleData.serverTime)); -- 周几
	if index == 0 then
		index = 7;
	end
	if self.tag_index ~= index then
		self.tag_index = index;
		self.bOpenState = false;
		for i = 1, #self.team_boss_open_tick do
			if index == self.team_boss_open_tick[i] then
				self.bOpenState = true;
				break;
			end
		end
	end
	return self.bOpenState;
end

-- 组队难度是否满足开放条件
function Lua_EquipCopyUtil.Get:bOpeneTeamDifficulty()
	return DataCenter.equipCopyData.max_difficulty >= self.create_team_cond;
end

-- 是否开启组队
function Lua_EquipCopyUtil.Get:bOpeneMoreTeam()
	if self.teamOpenState and self.bOpeneTeamDifficulty then -- 组队开启
        return true;
    end

    return false;
end

-- -- 通过回合制次数 获取战斗评级
-- function Lua_EquipCopyUtil:getFightGradeByNum(num)
-- 	if self.fightGradeDic == nil then
-- 		self.fightGradeDic = {};

-- 		local list = getConfig("equip_copy_const", "fight_grade", "arr_value");
-- 		for i = 1, #list do
-- 			self.fightGradeDic[list[i][1]] = list[i][2];
-- 		end
-- 	end
-- end

-- 获取评分表现 ["B","A","S","SS","SSS"]
function Lua_EquipCopyUtil:getCopyScoreByGrade(grade)
	local list = getConfig("equip_copy_const", "score_show_list", "arr_value");
	if list[grade] == nil then
		return "";
	end
	return list[grade];
end

function Lua_EquipCopyUtil:getCopyScoreArr(grade)
	local val = self:getCopyScoreByGrade(grade);
	local arr = Array();
	local str = tostring(val);
	local subStr;
	for i = 1, #str do
		subStr = string.sub(str, i, i);
		if not strIsNullOrEmpty(subStr) then
			if subStr == "S" then
				arr:add("xui_jmd_widget_47");
			elseif subStr == "A" then
				arr:add("xui_jmd_widget_46");
			elseif subStr == "B" then
				arr:add("xui_jmd_widget_11");
			end
		end
	end
	return arr;
end

-- 单人评分
function Lua_EquipCopyUtil.Get:singleGradeInfo()
	if self._singleGradeInfo == nil then
		self._singleGradeInfo = Array();

		local list = getConfig("equip_copy_const", "fight_grade","arr_value");
		for i = 1, #list do
			self._singleGradeInfo:add({grade = list[i][2], num = list[i][1]});
		end
		self._singleGradeInfo:sort("grade", false);
	end
	return self._singleGradeInfo;
end

-- 组队评分
function Lua_EquipCopyUtil.Get:moreGradeInfo()
	if self._moreGradeInfo == nil then
		self._moreGradeInfo = Array();

		local list = getConfig("equip_copy_const", "team_fight_grade", "arr_value");
		for i = 1, #list do
			self._moreGradeInfo:add({grade = list[i][2], num = list[i][1]});
		end
		self._moreGradeInfo:sort("grade", false);
	end
	return self._moreGradeInfo;
end










-- 排行榜
function Lua_EquipCopyUtil:initRankConfigInfo()
	if self.rankList == nil then
		local config = getConfig("equip_copy_single");
		local obj;
		local camp;
		self.rankList = {};
		self.rankConfigDic = {};
		for k, v in pairs(config) do
			-- 将配置表所有数据存储在rankConfigDic中
			obj = self:getConfigVoById(v.id);
			if obj == nil then
				obj = Lua_EquipCopyRankVo.new(v.id);
				self.rankConfigDic[v.id] = obj;
			end

			-- 将各同阵营的数据id记录于rankList中
			camp = self:getRankByCamp(obj.camp);
			if camp == nil then
				self.rankList[obj.camp] = {};
				camp = self.rankList[obj.camp];
			end
			camp[#camp + 1] = obj.id;
		end

		-- 将同阵营按难度排序
		for k, v in pairs(self.rankList) do
			table.sort(v, function(a, b)
				local AVo = self:getConfigVoById(a);
				local BVo = self:getConfigVoById(b); 
				if AVo == nil or BVo == nil then
					return false;
				end
				return AVo.difficulty < BVo.difficulty;
			end);
		end
	end

	-- 重置每个难度服务端数据
	for k, v in pairs(self.rankConfigDic) do
		v:resetServerInfo();
	end
	return self.rankList;    
end

-- 根据阵营id获取该阵营的排行榜
function Lua_EquipCopyUtil:getRankByCamp(campId)
	if self.rankList == nil or self.rankList[campId] == nil then
		return;
	end
	return self.rankList[campId];
end

-- 根据id获取对应id的配置
function Lua_EquipCopyUtil:getConfigVoById(id)
	if self.rankConfigDic == nil or self.rankConfigDic[id] == nil then
		return;
	end
	return self.rankConfigDic[id];
end

function Lua_EquipCopyUtil.Get:bossNameArr()
	if self._bossNameArr == nil then
		self._bossNameArr = Array();

		local config = getConfig("equip_copy");
		for k, v in ipairs(config) do
			self._bossNameArr:add({camp = v.id, boss_name = v.boss_name});
		end
		self._bossNameArr:sort("camp", false);
	end
	return self._bossNameArr;
end

--队伍交换弹窗处理
function Lua_EquipCopyUtil:delayedChangeTeamPosWindow()
	Lua_CommonUtil.delayCall( DataCenter.equipCopyUtil.change_team_delayed, self, self.closeChangeTeamPosTime);
end

-- 开始计时器
function Lua_EquipCopyUtil:closeChangeTeamPosTime()
	Lua_WindowUtil.openWin("Lua_ChangeTeamPosWindow", Lua_WinParam.ACTION_CLOSE);
	self:clearDelayedTime();
end

function Lua_EquipCopyUtil:clearDelayedTime()
	-- print("关闭计时器")
	self.bStarTime = nil;
	Lua_CommonUtil.removeTimer(self,self.closeChangeTeamPosTime);
end