Lua_CumulateGiftData = class("Lua_CumulateGiftData");
function Lua_CumulateGiftData:ctor()
end

function Lua_CumulateGiftData:fromServer50197018(msg)
	if msg == nil then
		return;
	end

	self.index = msg.index; -- 索引id
	self.curRound = Mathf.Floor(msg.index / 1000); -- 当前轮次
	self.rechargeDays = msg.index % 1000; -- 当前档次/已累充天数
	self.cumulateList = msg.cumulate_list; -- 奖励信息 key:索引id，value：0 未完成，1 可领取，2 已领取，other：充值金额
	self.endTime = msg.close_tick; -- 活动刷新（关闭）时间
	self.rewardKey = self:getRewardKey(self.curRound, msg.world_lvl); -- 活动刷新时世界等级

	local redDotState = false;
	for i = 1, #msg.cumulate_list do
		if msg.cumulate_list[i].value == 1 then
			redDotState = true;
			break;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_CumulateGift, redDotState);
end

function Lua_CumulateGiftData:getRewardKey(curRound, worldLevel)
	local worldLevelRange = self.cumulateGiftConstConfig.world_lvl_reward;
	for i=1, #worldLevelRange[curRound] do
		if worldLevel <= worldLevelRange[curRound][i][2] then
			return worldLevelRange[curRound][i][3];
		end
	end

	return worldLevelRange[#worldLevelRange[curRound]][3];
end

function Lua_CumulateGiftData.Get:cumulateGiftConstConfig()
	if self._cumulateGiftConstConfig == nil then
		self._cumulateGiftConstConfig = getConfig({"cumulate_days_recharge", "config"});
	end

	return self._cumulateGiftConstConfig;
end

function Lua_CumulateGiftData.Get:cumulateGiftInfoDic()
	if self._cumulateGiftInfoDic == nil then
		self._cumulateGiftInfoDic = {};
		self._showCumulateGiftInfoDic = {};

		local vo;
		local config = getConfig({"cumulate_days_recharge"});
		for k,v in pairs(config) do
			if v.round ~= nil then
				vo = {};
				vo.id = k;
				vo.round = v.round;
				vo.grade = v.grade;
				vo.money = v.money;
				vo.sortWeight = 0;

				self._showCumulateGiftInfoDic[k] = v;
				if self._cumulateGiftInfoDic[v.round] == nil then
					self._cumulateGiftInfoDic[v.round] = Array();
				end
				self._cumulateGiftInfoDic[v.round]:add(vo);
			end
		end
	end

	return self._cumulateGiftInfoDic;
end

function Lua_CumulateGiftData:getCumulateGiftInfoArrBy(round)
	self.cumulateGiftInfoDic[round]:sort("grade", false);
	for i=1, #self.cumulateList do -- key:索引id，value：0 未完成，1 可领取，2 已领取
		self.cumulateGiftInfoDic[round][i].sortWeight = (self.cumulateList[i].value + 1) % 3;
	end

	self.cumulateGiftInfoDic[round]:sortf(self, self.sortFun);
	return self.cumulateGiftInfoDic[round];
end

function Lua_CumulateGiftData:sortFun(a, b)
	local _a = a.sortWeight;
	local _b = b.sortWeight;
	if _a ~= _b then
		if _b > _a then
			return false;
		end
	else
		if a.id > b.id then
			return false;
		end
	end
	return true;
end