checkRequire("Lua_DailyDiscountVo");
Lua_DailyDiscountData = class("Lua_DailyDiscountData");
function Lua_DailyDiscountData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_DailyDiscountData:dispose()
	self.mainGiftList = {};
	self.giftDic = {};
end

function Lua_DailyDiscountData:fromServer50197001(msg)
	if msg == nil then
		return;
	end
	self.worldLv = msg.world_level;

	if #msg.daily_gift_info > 1 then
		table.sort( msg.daily_gift_info, function (a, b) return a.gift_id < b.gift_id; end );
	end
	
	local idArr = Array(); -- 子礼包id
	local redState = false;
	self.redShowState = {};
	self.mainGiftList = {};
	self.giftArrDic = {};
	for i = 1, #msg.daily_gift_info do
		local obj = msg.daily_gift_info[i];
		self.mainGiftList[i] = obj.gift_id;
		
		local giftArr = Array(); -- 子礼包Arr
		for j = 1, #obj.times_map do
			local giftInfo = obj.times_map[j];
			local vo = self.giftDic[giftInfo.key];
			if vo == nil then
				local config = getConfig("daily_gift", giftInfo.key);
				if config ~= nil then
					vo = Lua_DailyDiscountVo.new(giftInfo.key, config);
					self.giftDic[giftInfo.key] = vo;
				end
			end

			if vo ~= nil then
				vo:updateBuyTimes(giftInfo.value, obj.can_buy);
				if not self.redShowState[obj.gift_id] and vo.recharge == 0 and vo.limitTimes > 0 then
					redState = true;
					self.redShowState[obj.gift_id] = true;
				end
				giftArr:add(vo);
				idArr:add(giftInfo.key);
			end
		end
		giftArr:sort("id", false);
		self.giftArrDic[obj.gift_id] = giftArr;
	end
	
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_DailyDiscount, redState);
	for k,v in pairs(self.giftDic) do
		if idArr:indexOf(k) == -1 then
			self.giftDic[k] = nil;
		end
	end
end

-- 子礼包Arr
function Lua_DailyDiscountData:getGiftInfoById(mainId)
	return self.giftArrDic[mainId];
end

-- 子礼包
function Lua_DailyDiscountData:getDiscountGiftInfoById(id)
	return self.giftDic[id];
end