--成长投资数据
checkRequire("Lua_investmentVo");
Lua_InvestmentData = class("Lua_InvestmentData")
function Lua_InvestmentData:ctor()
	self:dispose();
end

function Lua_InvestmentData:dispose()
end

function Lua_InvestmentData:fromServer50110006(msg)
	if msg == nil then
		return;
	end

	self.stepList = msg.step_list;
	self.defaultStep = nil;
	self._redDotState = false;
	local stepInfo;
	local curStep = self.curStep

	for i = #msg.step_list, 1, -1 do
		stepInfo = msg.step_list[i];
		if stepInfo.step <= curStep then
			self:updateStepInfo(stepInfo);

			if stepInfo.step == curStep and self.defaultStep == nil then
				self.defaultStep = curStep;
			end
		end
	end
	self:updateRedPoint(self._redDotState);
	Lua_MsgUtil.callFunc("UPDATE_INVESTMENT_PANEL");
end

function Lua_InvestmentData:updateStepInfo(stepInfo)
	if stepInfo == nil then
		return;
	end

	local vo;
	local obj;
	for i = 1, #stepInfo.reward_state do
		obj = stepInfo.reward_state[i];
		vo = self:getInvestmentVo(obj.key);
		vo:fromServer(stepInfo.step, stepInfo.lock_state, obj);

		if obj.value == 1 or obj.ex_value == 1 then
			self._redDotState = true;
			if self.defaultStep == nil then
				self.defaultStep = stepInfo.step;
			end
		end
	end
end

function Lua_InvestmentData:updateRedPoint(state)
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_Investment, state);
end

function Lua_InvestmentData:getIdArrByStep(showStep)
	if self.idList == nil then
		self.idList = {};
	end
	if self.idList[showStep] == nil then
		self.idList[showStep] = self:initLevelIdByStep(showStep);
	end
	return self.idList[showStep];
end

function Lua_InvestmentData:initLevelIdByStep(showStep)
	local arr = Array();
	local stepConfig = getConfig({"grow_up_invest_const", showStep});
	local config = getConfig({"grow_up_invest"});

	for i = 1, #config do
		if config[i].reward_level >= stepConfig.level_limit[1] and 
		(config[i].reward_level <= stepConfig.level_limit[2] or stepConfig.level_limit[2] == 0) then
			arr:add(config[i].id);
		end
	end
	return arr;
end

function Lua_InvestmentData:getInvestmentVo(id, config)
	if self.investmentDic == nil then
		self.investmentDic = {};
	end
	if self.investmentDic[id] == nil then
		self.investmentDic[id] = Lua_investmentVo.new(id, config);
	end
	return self.investmentDic[id];
end

function Lua_InvestmentData:getRechargeId(step)
	return getConfig({"grow_up_invest_const", step, "recharge_id"});
end

function Lua_InvestmentData.Get:curStep()
	local config = getConfig({"grow_up_invest_const"});
	local level = DataCenter.roleData.level;
	local mainline = DataCenter.mainLineData.checkpointId;
	local curStep = 1
	for i = 1, #config do
		if level >= config[i].level_limit[1] and mainline > config[i].mainline_limit then
			curStep = config[i].step;
		end
	end
	return curStep;
end