-- 新服专享
checkRequire("Lua_NewServeGiftVo")
Lua_NewServeGiftData = class("Lua_NewServeGiftData")
function Lua_NewServeGiftData:ctor()
	self:dispose();
end

function Lua_NewServeGiftData:dispose()
	if self._newServeGiftArr ~= nil then
		self._newServeGiftArr:dispose();
		self._newServeGiftArr = nil;
	end
	self.giftVoDic = {};
end

function Lua_NewServeGiftData:fromServer50197003(msg)
	if msg == nil then
		return;
	end

	self.remainTime = msg.seconds; -- 剩余秒数
	self.first_login = msg.first_login; -- 首次登陆标志 0未登录 1已登录
	-- print("50197003", msg.first_login);

	local obj;
	local vo;
	local redDotState = false;
	for i = 1, #msg.grade_state do -- 档位状态 key礼包id value剩余次数
		obj = msg.grade_state[i];
		vo = self.giftVoDic[obj.key];
		if vo == nil then
			vo = Lua_NewServeGiftVo.new(obj.key);
			self.giftVoDic[obj.key] = vo;
		end
		if vo ~= nil then
			vo:fromServer(obj.value);
			if not redDotState and vo.recharge == 0 and vo.limitTimes > 0 then
				redDotState = true;
			end
		end
	end
	redDotState = redDotState or msg.first_login == 0;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_NewServeGift, redDotState);
end

-- 新服专享礼包VO
function Lua_NewServeGiftData:getGiftVoById(id) 
	if self.giftVoDic[id] ~= nil then
		return self.giftVoDic[id];
	end
	return;
end

-- 子礼包显示arr
function Lua_NewServeGiftData.Get:newServeGiftArr()
	if self._newServeGiftArr == nil then
		self._newServeGiftArr = Array();

		local config = getConfig("open_particular");
		for k,v in pairs(config) do
			vo = self:getGiftVoById(k);
			if vo ~= nil then
				self._newServeGiftArr:add(vo);
			end
		end
	end
	self._newServeGiftArr:sortf(self, self.sortFun);
	return self._newServeGiftArr;
end

function Lua_NewServeGiftData:sortFun(a, b)
	local _a = a.limitTimes;
	local _b = b.limitTimes;
	if (_a <= 0 and _b <= 0) or (_a > 0 and _b > 0) then
		return a.grade < b.grade;
	elseif (_a <= 0 and _b > 0) then
		return false;
	end
	return true;
end