Lua_FundsUtil = class("Lua_FundsUtil");
function Lua_FundsUtil:ctor()
end

-- 基金常量数据
function Lua_FundsUtil.Get:fundsLvInfo()
	if self._fundsLvInfo == nil then
		self._fundsLvInfo = getConfig("overflow_fund_config", "config");
	end
	return self._fundsLvInfo;
end

-- 基金数据
function Lua_FundsUtil.Get:fundsInfoDic()
	if self._fundsInfoDic == nil then
		self._fundsInfoDic = {};

		local vo;
		local grade;
		local config = getConfig("overflow_fund");
		for k,v in pairs(config) do
			grade = Mathf.Floor((v.id - v.round * 1000) / 100); -- 挡位
			if self._fundsInfoDic[v.round] == nil then
				self._fundsInfoDic[v.round] = {};
			end
			if self._fundsInfoDic[v.round][grade] == nil then
				self._fundsInfoDic[v.round][grade] = Array();
			end
			self._fundsInfoDic[v.round][grade]:add({
				id = v.id, -- id 1000*轮次 + 100*档位 + 天数
				day = v.day,
				reward = {v.reward_1, v.reward_2, v.reward_3}
			});
		end
	end
	return self._fundsInfoDic;
end

function Lua_FundsUtil:getFundsInfoByRound(round)
	local infoByRound = {};
	for i = 1, #self.fundsInfoDic[round] do
		infoByRound[i] = self:getFundsInfoByGrade(round, i);
	end
	return infoByRound;
end

-- 排序
function Lua_FundsUtil:getFundsInfoByGrade(round, grade)
	self.fundsInfoDic[round][grade]:sort("day", false);
	return self.fundsInfoDic[round][grade];
end