Lua_UpStarOfServerUtil = class("Lua_UpStarOfServerUtil");
function Lua_UpStarOfServerUtil:ctor()
end

-- 升星专属（开服）奖励配置
function Lua_UpStarOfServerUtil.Get:rewardInfoArr()
	if self._rewardInfoArr == nil then
		self._rewardInfoArr = Array();

		local vo;
		local index = 1;
		local curIndex;
		local rewardInfoDic = {};
		local config = getConfig({"star_particular_local"});
		for k,v in pairs(config) do
			if v.recharge ~= nil then
				if rewardInfoDic[v.star] == nil then
					vo = {};
					if v.recharge == 0 then
						vo[1] = v; -- 免费奖励
					else
						vo[2] = v; -- 充值奖励
					end

					rewardInfoDic[v.star] = index;
					index = index + 1;
					self._rewardInfoArr:add(vo);
				else
					curIndex = rewardInfoDic[v.star];
					if v.recharge == 0 then
						self._rewardInfoArr[curIndex][1] = v;
					else
						self._rewardInfoArr[curIndex][2] = v;
					end
				end
			end
		end

		self._rewardInfoArr:sortf(self, function(owner, a, b)
			return a[1].star < b[1].star;
		end);
	end
	return self._rewardInfoArr;
end

-- 升星专属（开服）常量配置
function Lua_UpStarOfServerUtil.Get:constConfig()
	if self._constConfig == nil then
		self._constConfig = getConfig({"star_particular_local", "const"});
	end

	return self._constConfig;
end

-- 获取初始星级为5的英雄uniqueId
function Lua_UpStarOfServerUtil:getHeroListArr(camp)
    local idArr = DataCenter.heroUtil:getHeroIdArr(5, camp);
    local arr = Array();
    local targetVo;
    local maxStar;
    local uidArr;
    local uidVo;

    if idArr ~= nil then
        for i = 1, idArr:getSize() do
            -- 存在英雄
            if DataCenter.heroData:isExistHeroById(idArr[i]) then
                uidArr = DataCenter.heroData:getHeroUidArrById(idArr[i]);
                if uidArr ~= nil then
                    uidVo = DataCenter.heroData:getItemByUniqueId(uidArr[1]);
                    targetVo = uidVo;
                    maxStar = uidVo.star;

                    for i = 2, uidArr:getSize() do
                        uidVo = DataCenter.heroData:getItemByUniqueId(uidArr[i]);
                        if maxStar < uidVo.star then
                            maxStar = uidVo.star;
                            targetVo = uidVo;
                        end
                    end

                    -- 升星配置表：最大星级配置
                    if maxStar >= self.constConfig.star_limit then
			            arr:add(targetVo);
			        end
                end
            end
        end
    end

    return arr;
end