checkRequire("Lua_ExpeditionUtil");
checkRequire("Lua_ExpeditionData");
Lua_ExpeditionProxy = class("Lua_ExpeditionProxy");
function Lua_ExpeditionProxy:ctor()
	DataCenter.expeditionUtil = Lua_ExpeditionUtil.new();
	DataCenter.expeditionData = Lua_ExpeditionData.new();

	Lua_MsgUtil.addEventListener("EXPEDITION_RECEIVE_BOX", self, self.onReceiveBox); -- 宝箱领取
	Lua_MsgUtil.addEventListener("EXPEDITION_GOTO_NEXT", self, self.onGotoNext); -- 进入下一关

	Lua_MsgUtil.addLuaMsg(50149001, self, self.rExpeditionInfo); -- 请求边境远征主界面信息(返回)
	Lua_MsgUtil.addLuaMsg(50149002, self, self.rHaveHeroList); -- 请求已邀请可助战的英雄列表(返回)
	Lua_MsgUtil.addLuaMsg(50149003, self, self.rBuffList); -- 请求远征的增效效果列表(返回)
	Lua_MsgUtil.addLuaMsg(50149005, self, self.rRevive); -- 请求远征复活十字架(返回)
	Lua_MsgUtil.addLuaMsg(50149006, self, self.rSupply); -- 请求远征的沙漠绿洲补给(返回)
	Lua_MsgUtil.addLuaMsg(50149007, self, self.rStoreList); -- 请求远征的打折商店信息(返回)
	Lua_MsgUtil.addLuaMsg(50149009, self, self.rChallengeInfo); -- 请求远征的对战布阵信息(返回)
	Lua_MsgUtil.addLuaMsg(50149011, self, self.rReceiveBox); -- 请求领取远征的全层宝箱奖励(返回)
	Lua_MsgUtil.addLuaMsg(50149013, self, self.rCheckBox); -- 请求查看全层宝箱奖励(返回)
	Lua_MsgUtil.addLuaMsg(50149014, self, self.rMercenaryList); -- 请求佣兵大厅的英雄列表(返回)
	Lua_MsgUtil.addLuaMsg(50149019, self, self.rHaveBuffList); -- 请求玩家已有的增效效果列表(返回)
	Lua_MsgUtil.addLuaMsg(50149021, self, self.rBoxReceive); -- 领取星数奖励(返回)

	Lua_MsgUtil.addLuaMsg(80149022, self, self.updateWinHero); -- 通知分队获胜英雄
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 事件监听
function Lua_ExpeditionProxy:onReceiveBox(data)
	self:sReceiveBox(data.station);
end

function Lua_ExpeditionProxy:onGotoNext(data)
	self:sNextLayer();
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求边境远征主界面信息
function Lua_ExpeditionProxy:sExpeditionInfo()
	sendMsg(10149001);
end

-- 请求已邀请可助战的英雄列表
function Lua_ExpeditionProxy:sHaveHeroList()
	sendMsg(10149002);
end

-- 请求远征的增效效果列表
function Lua_ExpeditionProxy:sBuffList()
	sendMsg(10149003);
end

-- 请求选择远征的增效效果
function Lua_ExpeditionProxy:sBuffChoose(effect_id)
	local cmd = ProtoPublic_pb.Proto10149004();
	cmd.effect_id = effect_id;
	sendMsg(10149004, cmd);
end

-- 请求远征复活十字架
function Lua_ExpeditionProxy:sRevive()
	sendMsg(10149005);
end

-- 请求远征的沙漠绿洲补给
function Lua_ExpeditionProxy:sSupply()
	sendMsg(10149006);
end

-- 请求远征的打折商店信息
function Lua_ExpeditionProxy:sStoreList(stage_id, location)
	local cmd = ProtoPublic_pb.Proto10149007();
	cmd.stage_id = stage_id;
	cmd.location = location;
	sendMsg(10149007, cmd);
end

-- 请求购买远征的打折商店
function Lua_ExpeditionProxy:sStoreBuy(shop_id, stage_id, location, _type, index)
	local cmd = ProtoPublic_pb.Proto10149008();
	cmd.shop_id = shop_id;
	cmd.stage_id = stage_id;
	cmd.location = location;
	cmd.type = _type;
	cmd.index = index;
	sendMsg(10149008, cmd);
end

-- 请求远征的对战布阵信息
function Lua_ExpeditionProxy:sChallengeInfo(stage_id, location)
	local cmd = ProtoPublic_pb.Proto10149009();
	cmd.stage_id = stage_id;
	cmd.location = location;
	sendMsg(10149009, cmd);
end

-- 跳过战斗设置
function Lua_ExpeditionProxy:sSkipFight(_type)
	local cmd = ProtoPublic_pb.Proto10149010();
	cmd.type = _type;
	sendMsg(10149010, cmd);
end

-- 请求领取远征的全层宝箱奖励
function Lua_ExpeditionProxy:sReceiveBox(station)
	local cmd = ProtoPublic_pb.Proto10149011();
	cmd.station = station;
	sendMsg(10149011, cmd);
end

-- 请求使用远征的复活卡
function Lua_ExpeditionProxy:sUseReviveItem()
	sendMsg(10149012);
end

-- 请求查看全层宝箱奖励
function Lua_ExpeditionProxy:sCheckBox()
	sendMsg(10149013);
end

-- 请求佣兵大厅的英雄列表
function Lua_ExpeditionProxy:sMercenaryList(stage_id, location)
	local cmd = ProtoPublic_pb.Proto10149014();
	cmd.stage_id = stage_id;
	cmd.location = location;
	sendMsg(10149014, cmd);
end

-- 请求选择佣兵大厅的英雄
function Lua_ExpeditionProxy:sMercenaryChoose(unique_id, stage_id, location)
	local cmd = ProtoPublic_pb.Proto10149015();
	cmd.unique_id = unique_id;
	cmd.stage_id = stage_id;
	cmd.location = location;
	sendMsg(10149015, cmd);
end

-- 请求选择远征的增效效果
function Lua_ExpeditionProxy:sDifficultyChoose(_type)
	local cmd = ProtoPublic_pb.Proto10149016();
	cmd.type = _type;
	sendMsg(10149016, cmd);
end

-- 请求远征选择路径
function Lua_ExpeditionProxy:sLatticeChoose(stage_id, location)
	local cmd = ProtoPublic_pb.Proto10149017();
	cmd.stage_id = stage_id;
	cmd.location = location;
	sendMsg(10149017, cmd);
end

-- 请求到下一层
function Lua_ExpeditionProxy:sNextLayer()
	sendMsg(10149018);
end

-- 请求玩家已有的增效效果列表
function Lua_ExpeditionProxy:sHaveBuffList()
	sendMsg(10149019);
end

-- 领取星数奖励
function Lua_ExpeditionProxy:sBoxReceive(id)
	local cmd = ProtoPublic_pb.Proto10149021();
	cmd.id = id;
	sendMsg(10149021, cmd);
end







------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_ExpeditionProxy:rExpeditionInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149001();
		msg:ParseFromString(mp.data);
		DataCenter.expeditionData:fromServer50149001(msg);
	end
end

function Lua_ExpeditionProxy:rHaveHeroList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149002();
		msg:ParseFromString(mp.data);
		DataCenter.expeditionData:fromServer50149002(msg);
		Lua_MsgUtil.callFunc("EXPEDITION_HAVEHERO_LIST");
	end
end

function Lua_ExpeditionProxy:rBuffList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149003();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("EXPEDITION_BUFF_LIST", msg);
	end
end

function Lua_ExpeditionProxy:rRevive(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_ExpeditionReviveWindow", Lua_WinParam.ACTION_CLOSE);
		OperateAlert.showLangValue(330038);
	end
end

function Lua_ExpeditionProxy:rSupply(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_ExpeditionSupplyWindow", Lua_WinParam.ACTION_CLOSE);
		OperateAlert.showLangValue(330040);
	end
end

function Lua_ExpeditionProxy:rStoreList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149007();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("EXPEDITION_STORE_LIST", msg);
	end
end

function Lua_ExpeditionProxy:rChallengeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149009();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("EXPEDITION_CHALLENGE_INFO", msg);
	end
end

function Lua_ExpeditionProxy:rReceiveBox(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149011();
		msg:ParseFromString(mp.data);
		local tab = DataCenter.packData:getRewardDic(msg.reward_item);
		local arr = DataCenter.packData:getRewardList(tab);
		if msg.all_pass == 1 then
			Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_OPEN, { data = arr, owner = self, cancelFun = self.openClearanceWin });
		else
			Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_OPEN, arr);
		end
	end
end

function Lua_ExpeditionProxy:openClearanceWin()
	Lua_WindowUtil.openWin("Lua_ExpeditionClearanceWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ExpeditionProxy:rCheckBox(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149013();
		msg:ParseFromString(mp.data);
		DataCenter.expeditionData:fromServer50149013(msg);
	end
end

function Lua_ExpeditionProxy:rMercenaryList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149014();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("EXPEDITION_MERCENARY_LIST", msg);
	end
end

function Lua_ExpeditionProxy:rHaveBuffList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149019();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("EXPEDITION_HAVEBUFF_LIST", msg);
	end
end

function Lua_ExpeditionProxy:rBoxReceive(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50149021();
		msg:ParseFromString(mp.data);
		local arr = Array();
		DataCenter.expeditionData:setStarState(msg.reward_state, arr);
		Lua_MsgUtil.callFunc("EXPEDITION_STAR_REWARD", arr);
	end
end

function Lua_ExpeditionProxy:updateWinHero(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80149022();
		msg:ParseFromString(mp.data);
		DataCenter.expeditionData:fromServer80149022(msg);
	end
end