--英雄数据
checkRequire("Lua_HeroVo")
checkRequire("Lua_HeroPropVo")   -- 英雄属性
checkRequire("Lua_HeroSkillVo"); -- 英雄技能
checkRequire("Lua_HeroCommentVo")-- 英雄评论
checkRequire("Lua_HeroUpgradeVo");--英雄升级
checkRequire("Lua_HeroUpStarVo");-- 英雄升星vo
checkRequire("Lua_HeroFashionVo");-- 英雄时装vo
checkRequire("Lua_HeroUpStarCostVo");-- 升星消耗英雄
checkRequire("Lua_HeroCostMaterialsVo");-- 材料消耗
checkRequire("Lua_HeroStarCostCofingData");-- 升星消耗
Lua_HeroData = class("Lua_HeroData")
function Lua_HeroData:ctor()
    self:superCall("ctor");
    self:dispose();
end

function Lua_HeroData:dispose()
    self.isBreak = false;  -- 升级是否突破
    self.bInitHeroInfo = false;-- 英雄数据初始化
    self.bSortHeroInfo = false;-- 是否英雄排序

    self.heroDesInfo = nil;-- 英雄传记数据
    self.commentInfo = nil;-- 英雄评论数据
    self.trialToweDic = nil;--试用英雄爬塔数据
    self.heroFashionInfo = nil;-- 时装数据

    self.bag_size = 0;
    self:resetAllHeroInfo();
end

function Lua_HeroData:resetAllHeroInfo()
    self.allHeroUidDic = {};     -- key:uid, value:hvo
    self.allHeroUidArr = Array();-- 排序的英雄uid集合
    self.heroUidArr = Array();-- 无排序的英雄uid集合

    self.heroCidDic = {}; -- key:英雄配置表id, value:uid集合
    self.heroStarDic = {};-- 星级  uid集合
    self.redDotStateDic = {};-- key:英雄Uid，val:bool
    self.redDotOnClickStateDic = {};--英雄升星红点点击状态记录
end

function Lua_HeroData:fromServer50114001(msg)
    if msg == nil then
        return;
    end
    self:resetAllHeroInfo();
    self.bag_size = msg.bag_size;-- 背包大小
    self.rebuild_times = msg.rebuild_times;  -- 今日已重修次数
    self.extend_times = msg.bag_extend_times;-- 背包扩展次数,从0开始

    local vo;
    local info;
    local unique_id;
    local list = msg.hero_list;
    self.bSortHeroInfo = true;
    for i = 1, #list do
        info = list[i];
        unique_id = tonumber(info.unique_id);
        vo = self:getItemByUniqueId(unique_id);
        if vo == nil then
            vo = self:addHeroItem(unique_id, info);
        else
            vo:fromServer(info);
        end
        -- 主线阵容Uid标记(红点处理)
        if vo ~= nil and vo.isShowFight == true and vo.trial_state == false then--使用英雄不参与红点
            self.redDotStateDic[unique_id] = true;
            self.redDotOnClickStateDic[unique_id] = true;
        end
    end
    self:checkHeroRedDotState(); -- 登录更新一次红点
    self:sortHeroInfo();--英雄排序
    self.bInitHeroInfo = true;--数据初始化完毕
    DataCenter.lifeTreeData:initLifeTreeInfo();
    Lua_MsgUtil.callFunc("INIT_HERO_INFO");--初始化完数据 派发事件
end

function Lua_HeroData:fromServer80114001(msg)
    if msg == nil then
        return;
    end
    local vo;
    local info;
    local unique_id;
    local lineupChangeState = false;--主线阵容是否发生改变
    local _type = msg.type;
    print("_type = =",_type)
    local list = msg.hero_info;
    for i = 1, #list do
        info = list[i];
        unique_id = tonumber(info.unique_id);
        if _type == 2 then--删除
            self:deleteHeroByUid(unique_id);
        else
            vo = self:getItemByUniqueId(unique_id);
            if vo == nil then
                if _type == 1 then--新增(服务端下发别的类型不再处理数据，防止数据出错)
                    self.bSortHeroInfo = true;
                    vo = self:addHeroItem(unique_id, info);
                else
                    local vo = Lua_HeroVo.new(tonumber(info.hero_id));
                    if not vo.isShield then--没屏蔽
                        LogManager.showLog(" 服务端下发 错误类型 = =  " .. _type);
                    end  
                end
            else
                local oldStar = vo.star;--星级
                local oldBackSort = vo.backSort;--排序权重
                local oldShowFight = vo.isShowFight;--更新红点
                vo:fromServer(info);
                --排序状态更新
                if self.bSortHeroInfo ~= true then
                    if oldBackSort ~= vo.backSort then
                        self.bSortHeroInfo = true;
                    end
                end
                --筛选数据更新
                if oldStar ~= vo.star then
                    self:updateScreenHeroItem(vo.star, oldStar, unique_id);
                end
                --主线阵容发生改变 更新红点数据
                if oldShowFight ~= vo.isShowFight and vo.trial_state == false then--使用英雄不参与红点
                    lineupChangeState = true;
                    if vo.isShowFight == true then
                        self.redDotStateDic[vo.unique_id] = true;
                        self.redDotOnClickStateDic[unique_id] = true;
                    else
                        self.redDotStateDic[vo.unique_id] = nil;
                        self.redDotOnClickStateDic[unique_id] = nil;
                    end
                end
            
                if _type == 19 then-- 19:装备变化
                    DataCenter.equipData:updateHeroEquipItem(vo.equip_info, unique_id);--更新英雄穿戴装备数据
                    Lua_MsgUtil.callFunc("UPDATE_EQUIP_CHANGE", unique_id);
                end

                Lua_MsgUtil.callFunc("UPDATE_ONE_HERO_INFO", unique_id);
            end
        end
    end

    if _type == 1 then
        Lua_MsgUtil.callFunc("ADD_HERO_ITEM");
        self:checkHeroRedDotState();
        self:checkHeroCarRedDotState();
        DataCenter.heroAssemblyUtil._upStarActiveNumDic = nil;
    elseif _type == 2 then  -- 2:删除
        Lua_MsgUtil.callFunc("DELETE_HERO_ITEM");
        DataCenter.heroAssemblyUtil._upStarActiveNumDic = nil;
        self:checkHeroRedDotState();
    elseif _type == 3 then  -- 3:升级信息
        self:checkHeroRedDotState();
    elseif _type == 4 then  -- 4:升星信息
        self:checkHeroRedDotState();
    elseif _type == 6 then  -- 6:英雄锁
        self:checkHeroRedDotState();--更新红点
        DataCenter.heroAssemblyUtil._upStarActiveNumDic = nil;
    elseif _type == 7 then  -- 7:上阵信息
        self:checkHeroRedDotState();--更新红点
        DataCenter.heroAssemblyUtil._upStarActiveNumDic = nil;
    elseif _type == 8 then  -- 8:重修
        self:checkHeroRedDotState();
    elseif _type == 9 then  -- 9:属性变化
    elseif _type == 10 then -- 10:时装变更
        self:checkHeroRedDotState();
    elseif _type == 11 then -- 11:星魂变更
    elseif _type == 12 then -- 12:转换状态
    elseif _type == 13 then -- 13:共鸣状态
        Lua_MsgUtil.callFunc("ENFORCE_UPDATA_HERO_PANEL");--刷新已打开的英雄背包界面
    elseif _type == 14 then -- 14:智能升星
        self:checkHeroRedDotState();
        Lua_MsgUtil.callFunc("UPDATE_INTELLIGENT_STATE");
    elseif _type == 15 then -- 15:英雄录英雄激活
    elseif _type == 16 then -- 16:英雄录英雄升级
    elseif _type == 17 then -- 17:情报派遣
	elseif _type == 18 then -- 18:英雄置换
        Lua_MsgUtil.callFunc("UPDATE_REPLACEMENT_STATE");
    elseif _type == 19 then -- 19:装备变化
        self:checkHeroRedDotState();
    elseif _type == 20 then -- 20:符石变化
        self:checkHeroRedDotState();
    elseif _type == 21 then -- 21:符石属性更新
        -- self:checkHeroRedDotState();
    elseif _type == 22 then -- 22:英雄回退
        Lua_MsgUtil.callFunc("UPDATE_REBUILD_INFO");
    elseif _type == 23 then -- 23:战技变化
    elseif _type == 24 then -- 24:觉醒变化 
        -- self:checkHeroRedDotState();
    elseif _type == 25 then -- 25:试用结束时间变化
    elseif _type == 26 then -- 26:神兵变化
        if list and #list > 0 then
            self:checkHeroRedDotState();
            vo = self:getItemByUniqueId(list[1].unique_id)
            vo = DataCenter.heroUtil:getHeroWeaponVo(vo.weapon_id)
            if vo and vo.show_tips == 1 then
                Lua_WindowUtil.openWin("Lua_HeroWeaponTipsWindow", Lua_WinParam.ACTION_OPEN, vo)
            end
        end
    end

    if lineupChangeState == true then
        Lua_MsgUtil.callFunc("ENFORCE_UPDATA_HERO_PANEL");--刷新已打开的英雄背包界面
    end
    self:sortHeroInfo();--排序
    Lua_MsgUtil.callFunc("UPDATE_HERO_INFO");
end

-- 新增英雄
function Lua_HeroData:addHeroItem(unique_id, serverInfo)
    if unique_id == nil or serverInfo == nil then
        return;
    end
    local vo = Lua_HeroVo.new(tonumber(serverInfo.hero_id));
    if vo.isShield then --配置需要屏蔽的英雄，前后端都做筛选
        return;
    end
    vo:fromServer(serverInfo);
    DataCenter.equipData:updateHeroEquipItem(vo.equip_info, unique_id);--更新英雄穿戴装备数据

    if self.allHeroUidDic[unique_id] == nil then
        self.allHeroUidArr:add(unique_id);
        self.heroUidArr:add(unique_id);
    end
    self.allHeroUidDic[unique_id] = vo;
    self:addScreenHeroItem(vo);
    Lua_MsgUtil.callFunc("ADD_ONE_HERO", unique_id);
    return vo;
end

--删除英雄
function Lua_HeroData:deleteHeroByUid(unique_id)
    if unique_id == nil or self.allHeroUidDic == nil then
        return;
    end
    local vo = self.allHeroUidDic[unique_id];
    if vo == nil then
        return;
    end
    local list = vo.equip_info;
    for i=1, #list do
        DataCenter.equipData:deleteEquipByUid(list[i].unique_id);--删除装备数据
    end

    self.allHeroUidDic[unique_id] = nil;
    self.allHeroUidArr:removeItem(unique_id);
    self.heroUidArr:removeItem(unique_id);
    self:removeScreenHeroItem(vo);
    self.bSortHeroInfo = true;
    Lua_MsgUtil.callFunc("DELETE_ONE_HERO", vo);
    vo:clean();
    vo = nil;
    self:checkHeroCarRedDotState();
end

-- 筛选数据
function Lua_HeroData:addScreenHeroItem(vo)
    -- id集合
    if self.heroCidDic[vo.id] == nil then
        self.heroCidDic[vo.id] = Array();
    end
    if self.heroCidDic[vo.id]:indexOf(vo.unique_id) == -1 then
        self.heroCidDic[vo.id]:add(vo.unique_id);
    end

    -- 星级集合
    if self.heroStarDic[vo.star] == nil then
        self.heroStarDic[vo.star] = Array();
    end
    if self.heroStarDic[vo.star]:indexOf(vo.unique_id) == -1 then
        self.heroStarDic[vo.star]:add(vo.unique_id);
    end
end

-- 删除 筛选数据
function Lua_HeroData:removeScreenHeroItem(vo)
    -- 删 id
    if self.heroCidDic[vo.id] ~= nil then
        self.heroCidDic[vo.id]:removeItem(vo.unique_id);
        if self.heroCidDic[vo.id]:getSize() <= 0 then
            self.heroCidDic[vo.id] = nil;
        end
    end
    -- 删星级
    if self.heroStarDic[vo.star] ~= nil then
        self.heroStarDic[vo.star]:removeItem(vo.unique_id);
    end
end

-- 更新 筛选数据
function Lua_HeroData:updateScreenHeroItem(new_star, old_star, unique_id)
    -- 删星级
    if self.heroStarDic[old_star] ~= nil then
        self.heroStarDic[old_star]:removeItem(unique_id);
    end

    -- 星级集合
    if self.heroStarDic[new_star] == nil then
        self.heroStarDic[new_star] = Array();
    end
    if self.heroStarDic[new_star]:indexOf(unique_id) == -1 then
        self.heroStarDic[new_star]:add(unique_id);
    end
end

-- 英雄排序
function Lua_HeroData:sortHeroInfo()
    if self.bSortHeroInfo ~= true then
        return;
    end
    
    -- 进行排序
    self.bSortHeroInfo = false;
    local len = self.allHeroUidArr:getSize();
    if len <= 1 then
        return;
    end
    local a;
    local b;
    for i = 1, len do
        for j = i + 1, len do
            a = self:getItemByUniqueId(self.allHeroUidArr[i]).backSort;
            b = self:getItemByUniqueId(self.allHeroUidArr[j]).backSort;
            if a < b then
                local temp = self.allHeroUidArr[i];
                self.allHeroUidArr[i] = self.allHeroUidArr[j];
                self.allHeroUidArr[j] = temp;
            end
        end
    end
end

-- 英雄排序 外部调用接口
function Lua_HeroData:sortHeroList(arr)
    local len = arr:getSize();
    if len <= 1 then
        return;
    end

    local a;
    local b;
    for i = 1, len do
        for j = i + 1, len do
            a = arr[i].backSort;
            b = arr[j].backSort;
            if a < b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end










---------------------------------- 数据接口 -------------------------------------------

-- 通过唯一id获取vo
function Lua_HeroData:getItemByUniqueId(unique_id)
    if self.allHeroUidDic == nil or unique_id == nil or self.allHeroUidDic[tonumber(unique_id)] == nil then
        return nil;
    end
    return self.allHeroUidDic[tonumber(unique_id)];
end

-- 通过id 获取英雄id数组
function Lua_HeroData:getHeroUidArrById(hero_id)
    if self.heroCidDic == nil or self.heroCidDic[hero_id] == nil then
        return nil;
    end
    return self.heroCidDic[hero_id];
end

-- 通过星级 获取唯一id数组
function Lua_HeroData:getHeroUidArrByStar(star)
    if self.heroStarDic == nil or self.heroStarDic[star] == nil then
        return Array();
    end
    return self.heroStarDic[star];
end

-- 通过Id 判断是否存在对应英雄
function Lua_HeroData:isExistHeroById(hero_id)
    if self.heroCidDic == nil then
        return false;
    end
    return self.heroCidDic[hero_id] ~= nil;
end

-- 英雄背包容量是否足够
function Lua_HeroData:isBagEnough(need)
    --need:需要的英雄数量
    local cur_pack_size = self.allHeroUidArr:getSize();
    if self.bag_size ~= nil and cur_pack_size + need <= self.bag_size then
        return true;
    end
    return false;
end












---------------------------------- 红点管理 -------------------------------------------
-- 检测主线阵容红点
function Lua_HeroData:checkHeroRedDotState()
    if DataCenter.funcOpenData:isOpened(10002) ~= true then
        return
    end
    local hvo;
    -- 英雄页签子功能红点
    for uid, state in pairs(self.redDotStateDic) do
        if state == true then
            hvo = self:getItemByUniqueId(uid);
            if hvo ~= nil and self:checkHeroTabRed(hvo) == true then
                break;
            end
        end
    end
    -- print("页签红点更新 = =",redDotState);
    Lua_MsgUtil.callFunc("UPDATE_HERO_TAB_REDDOT");--页签红点更新
    -- DataCenter.redPointData:updateRedPointState(Lua_RedPointList.HeroTab, redDotState);
end

-- 检测英雄红点
function Lua_HeroData:checkHeroTabRed(hvo)
    if hvo.trial_state == true then--试用英雄
        return false;
    end

    local redDotState = false;
    if redDotState == false then
        redDotState = self:checkFashionRedDot(hvo);
        -- print("时装红点 = =",redDotState)
        DataCenter.redPointData:updateRedPointState(Lua_RedPointList.HeroTabFashion, redDotState);
    end

    if redDotState == false then
        redDotState = hvo.heroUpgradeVo.heroUpgradeReddot;
        -- print("英雄升级红点 = =",redDotState)
        DataCenter.redPointData:updateRedPointState(Lua_RedPointList.HeroTabAttr, redDotState);
    end

    if redDotState == false and DataCenter.runesData.bInitRunesInfo == true then
        redDotState = DataCenter.runesData:checkRunesRedDotState(hvo);
        -- print("符石红点 = =",redDotState)
        DataCenter.redPointData:updateRedPointState(Lua_RedPointList.HeroTabEquip, redDotState);
    end

    if redDotState == false then
        redDotState = DataCenter.equipData:checkEquipRedDotState(hvo.unique_id);
        -- print("装备红点 = =",redDotState)
        DataCenter.redPointData:updateRedPointState(Lua_RedPointList.HeroTabEquip, redDotState);
    end

    if redDotState == false then
        if self.redDotOnClickStateDic[hvo.unique_id] then
            redDotState = DataCenter.heroUpStarData:checkUpStarRedDot(hvo);
        end
        DataCenter.redPointData:updateRedPointState(Lua_RedPointList.HeroTabUpStar, redDotState);
        -- print("英雄升星红点 = =",redDotState)
    end

    if redDotState == false then
        redDotState = self:checkWeaponRedPoint(hvo);
        --print("神兵红点 = =",redDotState)
        DataCenter.redPointData:updateRedPointState(Lua_RedPointList.HeroTabWeapon, redDotState);
    end

    -- if redDotState then
        --print(hvo.name,"   检测英雄红点");
    -- end
    return redDotState;
end


-- 界面英雄红点
function Lua_HeroData:checkSingleHeroRed(hvo)
    -- print(hvo.name,"   检测英雄红点      1",hvo.isShowFight)
    if hvo.trial_state == true then--试用英雄
        return false;
    end

    local redDotState = hvo.bHeroCardRedDot;
    -- print("英雄卡牌红点 = =",redDotState)

    if redDotState then
        return true;
    end

    if hvo.isShowFight == false then
        return false;
    end
    
    if redDotState == false then
        redDotState = self:checkFashionRedDot(hvo);
        -- print("时装红点 = =",redDotState)
    end

    if redDotState == false then
        redDotState = hvo.heroUpgradeVo.heroUpgradeReddot;
        -- print("英雄升级红点 = =",redDotState)
    end

    if redDotState == false and DataCenter.runesData.bInitRunesInfo == true then
        redDotState = DataCenter.runesData:checkRunesRedDotState(hvo);
        -- print("符石红点 = =",redDotState)
    end

    if redDotState == false then
        redDotState = DataCenter.equipData:checkEquipRedDotState(hvo.unique_id);
        -- print("装备红点 = =",redDotState)
    end

    if redDotState == false then
        if self.redDotOnClickStateDic[hvo.unique_id] then
            redDotState = DataCenter.heroUpStarData:checkUpStarRedDot(hvo);
        end
        -- print("英雄升星红点 = =",redDotState)
    end
    
    if redDotState == false then
        redDotState = self:checkWeaponRedPoint(hvo)
    end

    return redDotState;
end

--英雄闪卡红点更新
function Lua_HeroData:checkHeroCarRedDotState()
    if DataCenter.funcOpenData:isOpened(10002) ~= true then
        return
    end
    local hvo;
    -- 英雄页签子功能红点
    local redDotState = false
    for i = 1, self.allHeroUidArr:getSize() do
        hvo = self:getItemByUniqueId(self.allHeroUidArr[i]);
        if hvo.bHeroCardRedDot then
            redDotState = true;
            break
        end
    end
    -- print("英雄闪卡红点更新 00000 = = ",redDotState)
    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.HeroCard, redDotState);
end

--上阵英雄更新升星红点状态
function Lua_HeroData:updateHeroUpStarState(unique_id, state)
    self.redDotOnClickStateDic[unique_id] = state;
    self:checkHeroRedDotState();
end






---------------------------------- 背包界面数据 -------------------------------------------
-- 背包 获取对应类型所有数据
function Lua_HeroData:getPackAllInfoByCampType(campType, careerType, uid)
    local hvo;
    local index = 0;
    local curSelectIdx = 0;
    local arr = Array();
    for i = 1, self.allHeroUidArr:getSize() do
        hvo = self:getItemByUniqueId(self.allHeroUidArr[i]);
        if (campType == Lua_HeroUtil.All_TYPE or hvo.campType == campType)
        and (careerType == 0 or hvo.career == careerType) then
            index = index + 1;
            if self.allHeroUidArr[i] == uid then
                curSelectIdx = index;
            end
            arr:add({unique_id = self.allHeroUidArr[i], index = index});
        end
    end
    return arr, curSelectIdx;
end

-- 背包是否扩展到上限
function Lua_HeroData.Get:isExtendBagLimit()
    if self.extend_times == nil then
        return false;
    end
    return DataCenter.heroUtil:getBagCostVoById(self.extend_times+1) == nil;
end








---------------------------------- 升级升星展示数据 -------------------------------------------

--升级展示
function Lua_HeroData:showAttrsAniWin(msg)
    if msg == nil then
        return;
    end

    local list = {};
    local info = msg.prop;
    for i = 1, #info do
        list[info[i].name] = info[i].value;
    end
    local uid = tonumber(msg.uid);
    local hvo = self:getItemByUniqueId(uid);
    --突破成功展示
    if self.isBreak == true then
        Lua_WindowUtil.openWin("Lua_HeroBreakSucceedWindow", Lua_WinParam.ACTION_OPEN, {data = hvo, attrDic = list});
    else--升级属性动画播放
        local arr = Array();
        local attrVo
        local base_attr = DataCenter.heroUtil.hero_base_attr;
        for i=1, #base_attr do
            attrVo = DataCenter.attributesUtil:createAttrVo(base_attr[i]);
            attrVo.value = Mathf.Floor(list[base_attr[i]] + 0.5);
            arr:add(attrVo);
        end
        Lua_WindowUtil.openWin("Lua_AttrChangeTipsWindow", Lua_WinParam.ACTION_OPEN, arr);
    end
end

-- 展示突破属性
function Lua_HeroData:showAttrInfo(heroVo, attrDic)
    local propVo;   --属性vo
    local add_attr; --每级增加属性
    local up_value; --突破前展示属性
    local cur_value;--突破后展示属性
    local arr = Array();
    local cur_prop = heroVo.heroPropVo.heroBasePropInfo;
    local base_attr = DataCenter.heroUtil.hero_base_attr;
    for i=1,#base_attr do
        cur_value = cur_prop[base_attr[i]];
        add_attr = attrDic[base_attr[i]];
        if cur_value == nil then
            cur_value = 0;
        end
        if add_attr == nil then
            add_attr = 0;
        end
        up_value = cur_value - add_attr;
        propVo = DataCenter.attributesUtil:createAttrVo(base_attr[i]);
        arr:add({showName = propVo.show_name, leftValue = up_value, rightValue = cur_value, nextValue = add_attr, sort = propVo.sort})
    end
    arr:sort("sort",false);
    return arr;
end

-- 展示突破技能
function Lua_HeroData:showBreakSkill(heroVo)
    local level = heroVo.level;
    local cfgVo = DataCenter.heroUtil:getHeroLevelPropConfig(level);
    if cfgVo == nil then
        return nil;
    end

    local num = cfgVo.up_skill_num;--技能升级个数
    local index = cfgVo.unlock_skill_index;--技能变化索引

    --特殊技能处理
    local list = heroVo.lvl_skill_list;
    if list ~= nil then
        local list1;
        local tag_lvl = 0;
        for i, skill_list in ipairs(list) do
            if level >= skill_list[1] then
                tag_lvl = skill_list[1];
                list1 = skill_list[2];
            end
        end

        if tag_lvl ~= 0 then
            local upCfgVo = DataCenter.heroUtil:getHeroLevelPropConfig(level-1);
            if upCfgVo == nil then
                return nil;
            end

            num = 0;
            index = 0;
            local fight_skill_level = upCfgVo.fight_skill_level;
            for i=1,#fight_skill_level do
                if fight_skill_level[i] < list1[i] then
                    num = num +1;
                    index = i;
                end
            end
        end
    end


    local showState = 0;--技能表现状态 0:技能无变化 1：技能解锁 2：单个技能升级 3：多个技能升级
    local arr = Array();
    -- print(num,"   展示突破技能    ",index)
    if num ~= nil and index ~= nil then
        if num == 0 then
            if index ~= 0 then -- 1：技能解锁
                local skill_list = heroVo.heroSkillInfo;
                local heroSkillVo = skill_list[index];
                if heroSkillVo ~= nil then
                    showState = 1;
                    arr:add(heroSkillVo);
                end
            end
        elseif num == 4 then --多个技能升级
            showState = 3;
            local skill_list = heroVo.heroSkillInfo;
            for i=1,#skill_list do
                arr:add(skill_list[i]);
            end
        else--单个技能升级
            local skill_list = heroVo.heroSkillInfo;
            local heroSkillVo = skill_list[index];
            if heroSkillVo ~= nil then
                showState = 2;
                arr:add(heroSkillVo);
            end
        end
    end
    
    return showState, arr;
end











---------------------------------- 英雄时装 -------------------------------------------

-- 英雄时装
function Lua_HeroData:fromServer50114022(msg)
    if msg == nil then   
        return;
    end
    self.heroFashionInfo = {};
    local hid;
    local fvo;
    local list;
    local clothes_info = msg.clothes_list;
    for i=1,#clothes_info do
        hid = tonumber(clothes_info[i].hero_id);
        -- print("英雄时装  = =",hid)
        if self.heroFashionInfo[hid] == nil then
            self.heroFashionInfo[hid] = {};
        end
        list = clothes_info[i].clothes_list;
        local fid;
        local fvo;
        for j=1,#list do
            fid = tonumber(list[j].clothes_id);
            fvo = Lua_HeroFashionVo.new(fid);
            fvo:fromServerInfo(list[i]);
            self.heroFashionInfo[hid][fid] = fvo;
        end
    end

    self:checkHeroRedDotState();
end

function Lua_HeroData:fromServer80114022(msg)
    if msg == nil then
        return;
    end

    local clothes_info = msg.clothes_info;
    local hid = tonumber(clothes_info.hero_id);

    if self.heroFashionInfo == nil then
        self.heroFashionInfo = {};
    end
    
    if self.heroFashionInfo[hid] == nil then
        self.heroFashionInfo[hid] = {};
    end

    local fid;
    local fvo;
    local list = clothes_info.clothes_list;
    for i=1,#list do
        fid = tonumber(list[i].clothes_id);
        if self.heroFashionInfo[hid][fid] == nil then
            fvo = Lua_HeroFashionVo.new(fid);
        else
            fvo = self.heroFashionInfo[hid][fid];
        end
        
        fvo:fromServerInfo(list[i]);
        self.heroFashionInfo[hid][fid] = fvo;
    end

    self:checkHeroRedDotState();
end

function Lua_HeroData:getFashionVoById(hid, fid)
    if self.heroFashionInfo == nil or self.heroFashionInfo[hid] == nil or self.heroFashionInfo[hid][fid] == nil then
        return nil;
    end
    return self.heroFashionInfo[hid][fid];
end

--已穿戴时装索引
function Lua_HeroData:getUseFashionIndex(arr)
    for i=1,arr:getSize() do
        if arr[i].isUseClothes == true then
            return i;
        end
    end
    return 1;
end

--时装红点
function Lua_HeroData:checkFashionRedDot(hvo)
    if self.heroFashionInfo == nil or self.heroFashionInfo[hvo.id] == nil then
        return false;
    end

    local fashionDic = self.heroFashionInfo[hvo.id];
    for clothes_id, fvo in pairs(fashionDic) do
        if fvo.fashionRedDot == true then
            return true;
        end
    end
    return false;
end







---------------------------------- 英雄评论 -------------------------------------------

-- 英雄评论
function Lua_HeroData:fromServer50114012(msg)
    if msg == nil then
        return;
    end
    
    self.comment_have = msg.have;-- 是否拥有：0未拥有，1：已拥有
    self.comment_score = string.format("%.1f", msg.score);-- 评分
    print(msg.score,"   评分  = ==",self.comment_score)
    self.comment_hero_id = msg.hero_id;-- 评论明星id
    self.comment_num = msg.comment_num;-- 评星人数
    self.player_star = msg.player_star;-- 玩家上一次选择的星级

    self.commentInfo = {};
    local hot_list = msg.hot_comment;-- 热门评论
    local new_list = msg.new_comment;-- 最新评论
    local hvo;
    for i=1,#hot_list do
        if self.commentInfo[1]== nil then
            self.commentInfo[1] = Array();
        end
        hvo = Lua_HeroCommentVo.new(tonumber(hot_list[i].uid));
        hvo:fromServerInfo(hot_list[i]);
        hvo.isShowHot = i<=3;
        self.commentInfo[1]:add(hvo);
    end

    for i=1,#new_list do
        if self.commentInfo[2]== nil then
            self.commentInfo[2] = Array();
        end
        hvo = Lua_HeroCommentVo.new(tonumber(new_list[i].uid));
        hvo:fromServerInfo(new_list[i]);
        self.commentInfo[2]:add(hvo);
    end
end

function Lua_HeroData:getCommentArrByIndex(index)
    if self.commentInfo ~= nil and self.commentInfo[index] ~= nil then
        return self.commentInfo[index];
    end
    return Array();
end










---------------------------------- 英雄传记 -------------------------------------------

-- 英雄传记
function Lua_HeroData:fromServer80114021(msg)
    if msg == nil then
        return;
    end
    self.heroDesInfo = {};
    local list = msg.hero_id_list;
    for i=1,#list do
        -- print("英雄传记 = =",list[i])
        self.heroDesInfo[tonumber(list[i])] = 1;
    end
end

--获取英雄传记状态
function Lua_HeroData:getHeroDesStateByHid(hid)
    if self.heroDesInfo ~= nil and self.heroDesInfo[hid] ~= nil then
        return self.heroDesInfo[hid];
    end
    return 0;
end



---------------------------------- 英雄重修 -------------------------------------------
-- 英雄重修返还数据
function Lua_HeroData:rebuildInfo(data)
    local arr = Array();
    local rebuild_list = data.heroUpgradeVo.rebuildMaterialsInfo;
    local vo;
    if rebuild_list ~= nil then
        for i=1,#rebuild_list do
            vo = Lua_ToolVo.new(rebuild_list[i][1],rebuild_list[i][2])
            arr:add(vo);
        end
    end
    local equip_list = data.equip_info;
    if equip_list ~= nil then
        for i=1,#equip_list do
            vo = DataCenter.equipData:getEquipVoByUid(tonumber(equip_list[i]));
            arr:add(vo);
        end
    end
    return arr;
end

-- 英雄重修花费
function Lua_HeroData:getRebuildMoney(data)
    local arr = Array();
    local rebuild_list = data.heroUpgradeVo.rebuildMaterialsInfo;
    local vo;
    if rebuild_list ~= nil then
        for i=1,#rebuild_list do
            vo = Lua_ToolVo.new(rebuild_list[i][1],rebuild_list[i][2])
            arr:add(vo);
        end
    end
    local equip_list = data.equip_info;
    if equip_list ~= nil then
        for i=1,#equip_list do
            vo = DataCenter.equipData:getEquipVoByUid(tonumber(equip_list[i]));
            arr:add(vo);
        end
    end
    return arr;
end











---------------------------------- 试用英雄 -------------------------------------------

--试用英雄爬塔数据
function Lua_HeroData:fromServer80114030(msg)
    if msg == nil then
        return;
    end

    self.trialToweDic = {};
    local uid;
    for k, v in ipairs(msg.trial_hero_tower_info) do
        uid = tonumber(v.hero_uid);
        if self.trialToweDic[uid] == nil then
            self.trialToweDic[uid] = {};
        end

        for _, info in ipairs(v.tower_info) do
            self.trialToweDic[uid][info.key] = info.value; 
        end
    end
end

--根据唯一id判断是否是试用英雄
function Lua_HeroData:isTrialHero(uid)
    local heroVo = self:getItemByUniqueId(uid);
    if heroVo ~= nil then
        return heroVo.trial_state;
    end
    return false;
end

--获取试用英雄爬塔层数
function Lua_HeroData:getTrialTowerCount(uid, towerType)
    local count = nil;
    if self.trialToweDic ~= nil then
        local data = self.trialToweDic[uid];
        if data ~= nil then
            count = data[towerType] == nil and 0 or data[towerType];
        end
    end
    if count == nil and self:isTrialHero(uid) then
        count = 0;
    end
    return count;
end

--试用英雄是否能爬塔
function Lua_HeroData:isClimbLimit(uid, towerType)
    if towerType == nil then
        return nil;
    end

    local count = self:getTrialTowerCount(uid, towerType);
    if count ~= nil then
        return count < DataCenter.heroUtil:trialTowerlimit(towerType);
    end
    return false;
end




---------------------------------- 英雄加成项 -------------------------------------------
-- 英雄重修返还数据
function Lua_HeroData:fromServer50114032(msg)
    if msg == nil then
        return;
    end
    self.curRoleId = tonumber(tostring(msg.role_id));-- 角色ID
    self.league_level = msg.prop_option_info.league_level;--说明：社区等级
    self.potential_info = msg.prop_option_info.potential_info;--说明：key:潜能id value:潜能等级
    self.hero_power_level = msg.prop_option_info.hero_power_level;--说明：英雄之力等级

    -- print("角色ID = =",self.curRoleId);
    -- print("社区等级 = =",self.league_level);
    -- print("英雄之力等级 = =",self.hero_power_level);
    -- print(self.potential_info.key," 潜能id = = 潜能等级 ",self.potential_info.value );

    self.leagueScienceDic = {};
    local list = msg.prop_option_info.league_science_info;--说明：社区技巧信息 key:职业 value:社区技巧id
    for i=1,#list do
        -- print(list[i].key," 职业 = = 社区技巧等级  ",list[i].value);
        self.leagueScienceDic[list[i].key] = list[i].value;
    end
    

end




---------------------------------- 英雄通知弹窗 -------------------------------------------
-- 英雄通知弹窗
function Lua_HeroData:fromServer80114002(msg)
    if msg == nil then
        return;
    end
    local vo;
    local info;
    local unique_id;
    local _type = msg.type;

    -- 备注：type
    -- 1. 升星返还
    -- 2. 重修
    -- 3. 解约
    -- 4. 智能升星
    -- 5. 碎片转换

    local arr = Array();
    local item_list = msg.list;
    for i=1,#item_list do--道具
        vo = Lua_ToolVo.createToolVo(item_list[i].id,item_list[i].amount);
        vo:fromServer(item_list[i]);
        arr:add(vo);
    end
    if arr:getSize() > 0 then
        Lua_WindowUtil.openWin("Lua_HeroResourcesTipsWindow", Lua_WinParam.ACTION_OPEN, arr);
    end
end





---------------------------------- 英雄神兵 -------------------------------------------
function Lua_HeroData:checkWeaponRedPoint(heroVo)
    if heroVo.weaponId > 0 and heroVo.star >= DataCenter.heroUtil.weapon_unlock_star then
        local vo
        if heroVo.weapon_id > 0 then
            vo = DataCenter.heroUtil:getHeroWeaponVo(heroVo.weapon_id)
            if vo.next_id <= 0 then
                return false
            end

            local costId = DataCenter.packData:checkConsumeEnough(vo.upgrade_material)
            if costId then
                return false
            end
        else
            vo = DataCenter.heroUtil:getHeroWeaponVo(heroVo.weaponId)
            local costId = DataCenter.packData:checkConsumeEnough(vo.unlock_material)
            if costId then
                return false
            end
        end

        if DataCenter.heroMaterialData:checkEnoughByList(vo.hero_material, heroVo.unique_id) then
            return true
        else
            return false
        end
    end
    return false
end









---------------------------------- 引导英雄接口 -------------------------------------------

-- 英雄是否可以直升到指定等级
function Lua_HeroData:bHeroUpLevelByUidAndLevel(unique_id, limit_level)
    local vo = self:getItemByUniqueId(unique_id);
    if vo == nil then
        return false;
    end

    local cfgData = DataCenter.heroUtil:getHeroLevelCostConfig(limit_level); 
    if cfgData ~= nil and cfgData.resonance ~= nil and cfgData.resonance > DataCenter.lifeTreeData.cur_level then--不满足同调器等级
        return false;
    end

    local bUpLimitLevel = vo.heroUpgradeVo:bUpLimitLevel(limit_level);

    return bUpLimitLevel;
end
