-- 英雄 升星Vo
Lua_HeroUpStarVo = class("Lua_HeroUpStarVo")
function Lua_HeroUpStarVo:ctor(id)
    self.id = id;
end

function Lua_HeroUpStarVo:clean()
    self._speedyCostHeroInfo = nil;
    self._oneKeyCostHeroInfo = nil;
end

function Lua_HeroUpStarVo:updateServerInfo(star)
    self.star = star;
    self.cfg_id = Mathf.Floor(self.id/100) * 100 + star;
    -- print("self.cfg_id = =",self.cfg_id)
end

function Lua_HeroUpStarVo.Get:config()
    return Lua_HeroStarCostCofingData.getConfig(self.upStarId);
end

function Lua_HeroUpStarVo.Get:upStarId() 
    local upStarId = self.cfg_id;
    if self.isSpeedyStar == true then
        upStarId = upStarId - 1;
    end
    return upStarId;
end

-- 配置表英雄id 作为本体卡
function Lua_HeroUpStarVo.Get:hero_id()
    return self.config.hero_id;
end

-- 配置表英雄 星级作为本体卡
function Lua_HeroUpStarVo.Get:cfg_star()
    return self.config.star;
end

-- 英雄品质
function Lua_HeroUpStarVo.Get:color()
    return self.config.color;
end

-- 消耗英雄总数量
function Lua_HeroUpStarVo.Get:all_num()
    return self.config.all_num;
end

-- 升星材料
function Lua_HeroUpStarVo.Get:upgrade_material()
    return self.config.upgrade_material;
end

-- 升星所消耗的资源数量
function Lua_HeroUpStarVo.Get:costMaterialInfo()
    return self.config.costMaterialInfo;
end

-- 重修返还明星
function Lua_HeroUpStarVo.Get:rebuild_material()
    return self.config.rebuild_material;
end

-- 重修返还替身演员材料
function Lua_HeroUpStarVo.Get:rebuild_item()
    return self.config.rebuild_item;
end

-- 重修返还明星
function Lua_HeroUpStarVo.Get:getRebuildStarInfo()
    return self.config.getRebuildStarInfo;
end

-- 重修返还替身演员材料
function Lua_HeroUpStarVo.Get:getRebuildStarRepInfo()
    return self.config.getRebuildStarRepInfo;
end

-- 重修返还所消耗的资源数量
function Lua_HeroUpStarVo.Get:getRebuildStarExpInfo()
    return self.config.getRebuildStarExpInfo;
end

-- 等级上限
function Lua_HeroUpStarVo.Get:add_lvl_limit()
    return DataCenter.heroUtil:getHeroStarConfigInfo(self.star).add_lvl_limit;
end

-- 下星级等级上限
function Lua_HeroUpStarVo.Get:next_lvl_limit()
    return DataCenter.heroUtil:getHeroStarConfigInfo(self.star).next_lvl_limit;
end

-- 属性加成描述
function Lua_HeroUpStarVo.Get:next_des()
    return DataCenter.heroUtil:getHeroStarConfigInfo(self.star).next_des;
end

-- 共鸣等级条件
-- function Lua_HeroUpStarVo.Get:need_resonance()
--     return DataCenter.heroUtil:getHeroStarConfigInfo(self.star).resonance;
-- end

-- 是否到达最大等级上限
function Lua_HeroUpStarVo.Get:isMaxLevelLimit()
    return self.next_lvl_limit == self.add_lvl_limit;
end









---------------------------------- 升星数据处理 -------------------------------------------
-- 升星消耗英雄材料
function Lua_HeroUpStarVo.Get:costHeroInfo()
    local arr = Array();
    local cost_list = self.upgrade_material;
    if cost_list ~= nil then
        local cvo;
        for i=1,#cost_list do
            cvo = Lua_HeroUpStarCostVo.new(tonumber(cost_list[i][4]));
            cvo.costMaterialsIndex = i;
            cvo.star = cost_list[i][1];
            cvo.campType = cost_list[i][2];
            cvo.needNum = cost_list[i][3];
            arr:add(cvo);
        end
    end
    return arr;
end

-- 升星材料是否充满足
function Lua_HeroUpStarVo.Get:isMeetUpStarCost()
    local arr = self.costMaterialInfo;
    for i=1,arr:getSize() do
        if arr[i].isShowRed == false then
            return arr[i].id;
        end
    end
    return true;
end








---------------------------------- 快捷升星数据处理 -------------------------------------------

-- 快捷升星消耗英雄材料
function Lua_HeroUpStarVo.Get:speedyCostHeroInfo()
    if self._speedyCostHeroInfo == nil then
        --构建本体
        self._speedyCostHeroInfo = Array();
        local heroVo = Lua_HeroVo.new(self.hero_id);
        local upStarCostVo = Lua_HeroUpStarCostVo.new(tonumber(self.hero_id));
        upStarCostVo.costMaterialsIndex = 1;
        upStarCostVo.isSpeed = true;
        upStarCostVo.star = self.cfg_star;
        upStarCostVo.campType = heroVo.campType;
        upStarCostVo.needNum = 1;
        self._speedyCostHeroInfo:add(upStarCostVo);

        local cost_list = self.upgrade_material;
        if cost_list ~= nil then
            local cvo;
            for i = 1, #cost_list do
                cvo = Lua_HeroUpStarCostVo.new(tonumber(cost_list[i][4]));
                cvo.costMaterialsIndex = i + 1;
                cvo.star = cost_list[i][1];
                cvo.isSpeed = true;
                cvo.campType = cost_list[i][2];
                cvo.needNum = cost_list[i][3];
                self._speedyCostHeroInfo:add(cvo);
            end
        end
    end
    return self._speedyCostHeroInfo;
end

-- 一键升星消耗英雄材料
function Lua_HeroUpStarVo.Get:oneKeyCostHeroInfo()
    if self._oneKeyCostHeroInfo == nil then
        --构建本体
        self._oneKeyCostHeroInfo = Array();
        local heroVo = Lua_HeroVo.new(self.hero_id);
        local upStarCostVo = Lua_HeroUpStarCostVo.new(tonumber(self.hero_id));
        upStarCostVo.costMaterialsIndex = 1;
        upStarCostVo.isSpeed = true;
        upStarCostVo.star = self.cfg_star;
        upStarCostVo.campType = heroVo.campType;
        upStarCostVo.needNum = 1;
        self._oneKeyCostHeroInfo:add(upStarCostVo);

        local cost_list = self.upgrade_material;
        if cost_list ~= nil then
            local cvo;
            local index = 2;
            for i = 1, #cost_list do
                for j = 1, cost_list[i][3] do
                    cvo = Lua_HeroUpStarCostVo.new(tonumber(cost_list[i][4]));
                    cvo.costMaterialsIndex = index;
                    cvo.star = cost_list[i][1];
                    cvo.isSpeed = true;
                    cvo.campType = cost_list[i][2];
                    cvo.needNum = 1;
                    self._oneKeyCostHeroInfo:add(cvo);

                    index = index + 1;
                end
            end
        end
    end
    return self._oneKeyCostHeroInfo;
end