-- 英雄
checkRequire("Lua_HeroData");
checkRequire("Lua_HeroUtil");
checkRequire("Lua_HeroHeatData");
checkRequire("Lua_HeroHeatUtil");
checkRequire("Lua_HeroAtlasData");
checkRequire("Lua_HeroFetterData");
checkRequire("Lua_HeroUpStarData");
checkRequire("Lua_HeroLineupData");
checkRequire("Lua_HeroLineupUtil");
checkRequire("Lua_HeroMaterialData")
Lua_HeroProxy = class("Lua_HeroProxy");
function Lua_HeroProxy:ctor()
    DataCenter.heroUtil = Lua_HeroUtil.new(); -- 英雄配置数据
    DataCenter.heroData = Lua_HeroData.new(); -- 英雄数据
    DataCenter.heroHeatData = Lua_HeroHeatData.new();-- 热度榜
    DataCenter.heroHeatUtil = Lua_HeroHeatUtil.new();-- 热度榜配置数据
    DataCenter.heroAtlasData  = Lua_HeroAtlasData.new(); -- 英雄图鉴
    DataCenter.heroUpStarData = Lua_HeroUpStarData.new();-- 升星数据
    DataCenter.heroLineupData = Lua_HeroLineupData.new();-- 英雄布阵
    DataCenter.heroLineupUtil = Lua_HeroLineupUtil.new();-- 布阵配置数据
    DataCenter.heroMaterialData = Lua_HeroMaterialData.new();

    Lua_MsgUtil.addLuaMsg(50114001, self, self.rHeroInfo);        -- 获取英雄信息(返回)
    Lua_MsgUtil.addLuaMsg(50114004, self, self.rHeroUpStar);      -- 升星(返回)
    Lua_MsgUtil.addLuaMsg(50114002, self, self.rHeroUpgrade);     -- 升级(返回)
    Lua_MsgUtil.addLuaMsg(50114006, self, self.rHeroAtlasInfo);   -- 图鉴(返回)
    Lua_MsgUtil.addLuaMsg(50114007, self, self.rAddPackSize);     -- 背包扩展(返回)
    Lua_MsgUtil.addLuaMsg(50114008, self, self.rHeroLineup);      -- 布阵(返回)
    Lua_MsgUtil.addLuaMsg(50114009, self, self.rHeroSaveLineup);  -- 保存布阵(返回)
    Lua_MsgUtil.addLuaMsg(50114012, self, self.rHeroComment);     -- 评论(返回)
    Lua_MsgUtil.addLuaMsg(50114015, self, self.rHeroRebuild);     -- 重修(返回)
    Lua_MsgUtil.addLuaMsg(50114022, self, self.rHeroFashionInfo); -- 时装(返回)
    Lua_MsgUtil.addLuaMsg(50114023, self, self.rHeroAtlasAttr);   -- 图鉴(返回)
    Lua_MsgUtil.addLuaMsg(50114024, self, self.rActivateAwaken);  -- 请求激活激活英雄觉醒返回
    Lua_MsgUtil.addLuaMsg(50114025, self, self.rUpgradeAwaken);   -- 请求升级英雄觉醒返回
    Lua_MsgUtil.addLuaMsg(50114026, self, self.rSwitchAwaken);    -- 请求切换英雄觉醒类型返回
    Lua_MsgUtil.addLuaMsg(50114027, self, self.rUnlockAwakenSkill);-- 请求解锁觉醒技能栏返回
    Lua_MsgUtil.addLuaMsg(50114028, self, self.rSwitchAwakenSkill);-- 请求激活/切换觉醒技能返回
    Lua_MsgUtil.addLuaMsg(50114032, self, self.rHeroAddOption);    -- 请求英雄属性加成信息返回
    Lua_MsgUtil.addLuaMsg(50114033, self, self.rHeroAttr);         -- 请求英雄属性返回
    Lua_MsgUtil.addLuaMsg(50114034, self, self.rCheckRoleHeroInfo); -- 请求查看角色英雄信息返回
    Lua_MsgUtil.addLuaMsg(50114036, self, self.rUpgradeWeapon); -- 请求升级英雄神兵返回
    Lua_MsgUtil.addLuaMsg(50205001, self, self.rHeroHeatInfo);     -- 请求热度榜界面信息(返回)
    Lua_MsgUtil.addLuaMsg(50111007, self, self.rCheckHeroInfo); -- 请求功能英雄信息返回
    
    Lua_MsgUtil.addLuaMsg(80114001, self, self.updateHeroInfo);   -- 通知英雄信息
    Lua_MsgUtil.addLuaMsg(80114002, self, self.rHeroInformInfo);  -- 英雄通知弹窗
    Lua_MsgUtil.addLuaMsg(80114003, self, self.updateAttrInfo);   -- 通知属性变化飘字
    Lua_MsgUtil.addLuaMsg(80114010, self, self.updateHeroLineup); -- 通知英雄布阵
    Lua_MsgUtil.addLuaMsg(80114021, self, self.rHeroDesInfo);     -- 通知传记信息
    Lua_MsgUtil.addLuaMsg(80114022, self, self.updateFashionInfo);-- 通知皮肤信息
    Lua_MsgUtil.addLuaMsg(80114030, self, self.updateTrialToweInfo); -- 通知试用英雄爬塔通关层数
    Lua_MsgUtil.addLuaMsg(80205001, self, self.updateHeroHeatInfo);  -- 通知热度榜红点状态
    Lua_MsgUtil.addLuaMsg(80114038, self, self.showHeroForce);  -- 通知英雄战力变化

    Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.updateHeroRedDotByItem);--获取道具更新红点
    Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateHeroRedDotByMoney);--获取货币更新红点
    Lua_MsgUtil.addEventListener("UPDATE_HERO_REDDOT_STATE", self, self.updateHeroRedDotState);--更新英雄红点状态
end


----------------------------------------------------------------------------------------------------------------------------
-- 上行消息号

-- 请求英雄信息
function Lua_HeroProxy:sHeroInfo(mp)
    sendMsg(10114001);
end

-- 英雄升级
function Lua_HeroProxy:sHeroUpgrade(unique_id, max_level_up)
    local cmd = ProtoPublic_pb.Proto10114002();
    cmd.unique_id = tonumber(unique_id);
    cmd.max_level_up = tonumber(max_level_up);--是否直升到最大等级/直升到指定引导等级
    sendMsg(10114002, cmd);
end

-- 英雄升星
function Lua_HeroProxy:sHeroUpStar(unique_id)
    local list = DataCenter.heroUpStarData.selectCostIndexInfo;
    local cmd = ProtoPublic_pb.Proto10114004();
    cmd.unique_id = tonumber(unique_id);
    for i=1,#list do
        local struct = getProtoMsg("ProtoStarUpMaterial");
        struct.index = i;
        for uid, v in pairs(list[i]) do
            local len = string.len(uid);
            if len >= 20 then
                uid = string.sub(uid,1,9);
            end
            struct.uid_list:append(tonumber(uid));
        end
        cmd.material_list:addToList(struct);
    end
    sendMsg(10114004, cmd);
end

-- 英雄上锁
function Lua_HeroProxy:sHeroLock(unique_id, state)
    local cmd = ProtoPublic_pb.Proto10114005();
    cmd.unique_id = tonumber(unique_id);
    cmd.lock_state = state;
    sendMsg(10114005, cmd);
end

-- 英雄图鉴
function Lua_HeroProxy:sHeroAtlas(mp)
    sendMsg(10114006);
end

-- 扩展英雄背包
function Lua_HeroProxy:sAddPackSize(mp)
    sendMsg(10114007);
end

-- 查询英雄布阵阵容
function Lua_HeroProxy:sHeroLineup()
    local cmd = ProtoPublic_pb.Proto10114008();
    cmd.lineup_type = tonumber(0);
    sendMsg(10114008, cmd);
end

-- 英雄保存阵容
function Lua_HeroProxy:sHeroSaveLineup(lineup_type, stand_list, lineup_list, artifact_list)
    local cmd = ProtoPublic_pb.Proto10114009();
    local lineup = getProtoMsg("ProtoHeroLineup");
    lineup.lineup_type = lineup_type;

    local struct1;
    local struct2;
    local arr;
    local posList;
    local standIdx;
    for i = 1, #lineup_list do
        struct1 = getProtoMsg("ProtoHeroDetachment");
        struct1.index = i;
        struct1.stand_type = stand_list[i];

        arr = lineup_list[i];
        posList = DataCenter.heroLineupUtil:getPosListByType(stand_list[i]);
        for j = 1, #posList do
            standIdx = posList[j];
            if arr[standIdx] > 0 then
                struct2 = getProtoMsg("ProtoPairLong");
                struct2.key = tonumber(standIdx)
                struct2.value = tonumber(arr[standIdx])
                struct1.location_list:addToList(struct2);
            end
        end

        arr = artifact_list[i];
        for j = 1, arr:getSize() do
            if DataCenter.artifactUtil:checkEmbattleLatticeIsUnlock(j) then
                struct2 = getProtoMsg("ProtoPair");
                struct2.key = j;
                struct2.value = arr[j];
                struct1.artifact_list:addToList(struct2);
            end
        end

        lineup.detachment_list:addToList(struct1);
    end
    
    cmd.lineup:addToList(lineup);
    sendMsg(10114009, cmd);
end

-- 英雄下阵
function Lua_HeroProxy:sHeroDownLineup(lineup_type, uid)
    local cmd = ProtoPublic_pb.Proto10114017();
    cmd.lineup_type = lineup_type;
    cmd.uid = tonumber(uid);
    sendMsg(10114017, cmd);
end

-- 英雄评论界面
function Lua_HeroProxy:sHeroComment(hid)
    local cmd = ProtoPublic_pb.Proto10114012();
    cmd.hero_id = tonumber(hid);
    sendMsg(10114012, cmd);
end

-- 评论发送
function Lua_HeroProxy:sCommentSend(hid, comment, star)
    local cmd = ProtoPublic_pb.Proto10114013();
    cmd.hero_id = tonumber(hid);
    cmd.comment_text = comment;
    cmd.star = tonumber(star);
    sendMsg(10114013, cmd);
end

-- 评论点赞
function Lua_HeroProxy:sCommentPressLike(hid, comment_id)
    local cmd = ProtoPublic_pb.Proto10114014();
    cmd.hero_id = tonumber(hid);
    cmd.comment_id = tonumber(comment_id);
    -- print(hid," 评论点赞 ",comment_id)
    sendMsg(10114014, cmd);
end

-- 英雄羁绊
-- function Lua_HeroProxy:sHeroFetter(mp)
--     sendMsg(10114019);
-- end

-- 英雄时装穿戴
function Lua_HeroProxy:sUseFashion(uid, fid)
    local cmd = ProtoPublic_pb.Proto10114020();
    cmd.hero_uid = tonumber(uid);
    cmd.clothes_id = tonumber(fid);
    --print(uid,"    英雄时装穿戴    ",fid)
    sendMsg(10114020, cmd);
end

-- 领取传记奖励
function Lua_HeroProxy:sHeroDesReward(uid)
    local cmd = ProtoPublic_pb.Proto10114021();
    cmd.hero_uid = tonumber(uid);
    sendMsg(10114021, cmd);
end

-- 英雄时装
function Lua_HeroProxy:sHeroFashion(mp)
    sendMsg(10114022);
end

--请求图鉴属性
function Lua_HeroProxy:sHeroAtlasAttr(ahid)
    local cmd = ProtoPublic_pb.Proto10114023();
    cmd.id = tonumber(ahid);
    sendMsg(10114023, cmd);
end

--英雄重修
function Lua_HeroProxy:sHeroRebuild(unique_id)
    local cmd = ProtoPublic_pb.Proto10114015();
    cmd.unique_id = tonumber(unique_id);
    sendMsg(10114015, cmd);
end

-- 请求激活英雄觉醒
function Lua_HeroProxy:sActivateAwaken(awaken_type, hero_uid)
    local cmd = ProtoPublic_pb.Proto10114024();
    cmd.awaken_type = awaken_type;
    cmd.hero_uid = tonumber(hero_uid);
    local list = DataCenter.heroUpStarData.selectCostIndexInfo;
    for i = 1, #list do
        for uid, v in pairs(list[i]) do
            cmd.hero_material:append(tonumber(uid));
        end
    end
    sendMsg(10114024, cmd);
end

-- 请求升级英雄觉醒等级
function Lua_HeroProxy:sUpgradeAwaken(hero_uid)
    local cmd = ProtoPublic_pb.Proto10114025();
    cmd.hero_uid = tonumber(hero_uid);
    sendMsg(10114025, cmd);
end

-- 请求切换英雄觉醒类型
function Lua_HeroProxy:sSwitchAwaken(hero_uid, awaken_type)
    local cmd = ProtoPublic_pb.Proto10114026();
    cmd.hero_uid = tonumber(hero_uid);
    cmd.awaken_type = awaken_type;
    sendMsg(10114026, cmd);
end

-- 请求解锁觉醒技能栏
function Lua_HeroProxy:sUnlockAwakenSkill(hero_uid, awaken_column_id)
    local cmd = ProtoPublic_pb.Proto10114027();
    cmd.hero_uid = tonumber(hero_uid);

    local list = DataCenter.heroUpStarData.selectCostIndexInfo;
    for i = 1, #list do
        for uid, v in pairs(list[i]) do
            cmd.hero_material:append(tonumber(uid));
        end
    end

    cmd.awaken_column_id = awaken_column_id;
    sendMsg(10114027, cmd);
end

-- 请求激活/切换觉醒技能
function Lua_HeroProxy:sSwitchAwakenSkill(hero_uid, awaken_column_id, location, _type)
    local cmd = ProtoPublic_pb.Proto10114028();
    cmd.hero_uid = tonumber(hero_uid);
    cmd.awaken_column_id = awaken_column_id;
    cmd.location = location;
    cmd.type = _type;
    sendMsg(10114028, cmd);
end

--- 请求点击查看英雄皮肤
function Lua_HeroProxy:sFashionRedDot(hero_id, clothes_id)
    local cmd = ProtoPublic_pb.Proto10114031();
    cmd.hero_id = hero_id;
    cmd.clothes_id = clothes_id;
    -- print(hero_id,"   请求点击查看英雄皮肤   ",clothes_id)
    sendMsg(10114031, cmd);
end

--- 请求英雄属性加成项信息
function Lua_HeroProxy:sHeroAddOption(role_id, types)
    local cmd = ProtoPublic_pb.Proto10114032();
    cmd.role_id = role_id;
    cmd.type = types;
    sendMsg(10114032, cmd);
end

--- 请求英雄属性信息
function Lua_HeroProxy:sHeroAttr(hero_id, star, level)
    local cmd = ProtoPublic_pb.Proto10114033();
    cmd.hero_id = hero_id;
    cmd.star = star;
    cmd.level = level;
    sendMsg(10114033, cmd);
end

--- 查看角色英雄信息
function Lua_HeroProxy:sCheckRoleHeroInfo(hero_uid, role_id)
    role_id = role_id == nil and 0 or role_id;
    local cmd = ProtoPublic_pb.Proto10114034();
    cmd.role_id = tonumber(role_id);
    cmd.hero_uid = tonumber(hero_uid);
    sendMsg(10114034, cmd);
end

-- 请求解锁英雄神兵
function Lua_HeroProxy:sUnlockWeapon(hero_uid)
    local cmd = ProtoPublic_pb.Proto10114035()
    cmd.hero_uid = tonumber(hero_uid)
    sendMsg(10114035, cmd)
end

-- 请求升级英雄神兵
function Lua_HeroProxy:sUpgradeWeapon(hero_uid, hero_material)
    local cmd = ProtoPublic_pb.Proto10114036()
    cmd.hero_uid = tonumber(hero_uid)
    if hero_material then
        for uniqueId, v in pairs(hero_material) do
            cmd.hero_material:append(tonumber(uniqueId))
        end
    end
    sendMsg(10114036, cmd)
end

-- 请求热度榜界面信息
function Lua_HeroProxy:sHeroHeat(heat_rank_id, tower_value, camp_value)
    -- print("请求热度榜界面信息   ",heat_rank_id,"      ", tower_value,"      " ,camp_value)
    local cmd = ProtoPublic_pb.Proto10205001()
    cmd.id = heat_rank_id;
    cmd.tower_value = tower_value;
    cmd.camp_value = camp_value;
    sendMsg(10205001, cmd)
end

--- 请求功能英雄信息 1.精英赛
function Lua_HeroProxy:sCheckHeroInfo(hero_uid, type)
    local cmd = ProtoPublic_pb.Proto10111007();
    cmd.unique_id = tonumber(hero_uid);
    cmd.type = type;
    sendMsg(10111007, cmd);
end










----------------------------------------------------------------------------------------------------------------------------
-- 下行消息号

-- 获取英雄信息(返回)
function Lua_HeroProxy:rHeroInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114001();
        msg:ParseFromString(mp.data);
        -- print("获取英雄信息(返回)")
        DataCenter.heroData:fromServer50114001(msg);
    end
end

-- 通知英雄信息修改
function Lua_HeroProxy:updateHeroInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80114001();
        msg:ParseFromString(mp.data);
        -- print("通知英雄信息修改")
        DataCenter.heroData:fromServer80114001(msg);
    end
end

-- 英雄通知弹窗
function Lua_HeroProxy:rHeroInformInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80114002();
        msg:ParseFromString(mp.data);
        -- print("英雄通知弹窗")
        DataCenter.heroData:fromServer80114002(msg);
    end
end

-- 通知属性变化飘字
function Lua_HeroProxy:updateAttrInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80114003();
        msg:ParseFromString(mp.data);
        -- print("通知属性变化飘字")
        if msg ~= nil then
            local arr = DataCenter.attributesUtil:getAttrArrByServer(msg.prop_list);
            Lua_WindowUtil.openWin("Lua_AttrChangeTipsWindow", Lua_WinParam.ACTION_OPEN, arr);
        end
        -- DataCenter.heroData:fromServer80114002(msg);
    end
end

-- 英雄升级(返回)
function Lua_HeroProxy:rHeroUpgrade(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114002();
        msg:ParseFromString(mp.data);
        -- print("英雄升级(返回)")
        DataCenter.heroData:showAttrsAniWin(msg);
    end
end

-- 英雄升星(返回)
function Lua_HeroProxy:rHeroUpStar(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114004();
        msg:ParseFromString(mp.data);
        -- print("英雄升星(返回)")
        Lua_MsgUtil.callFunc("UPDATA_UP_STAR_SUCCEED_INFO",msg);
    end
end

-- 获取英雄图鉴(返回)
function Lua_HeroProxy:rHeroAtlasInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114006();
        msg:ParseFromString(mp.data);
        -- print("获取英雄图鉴(返回)")
        DataCenter.heroAtlasData:fromServer50114006(msg);
        Lua_MsgUtil.callFunc("UPDATE_STAR_ATLAS_INFO");
    end
end

-- 背包栏扩展(返回)
function Lua_HeroProxy:rAddPackSize(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114007();
        msg:ParseFromString(mp.data);
        -- print("背包栏扩展(返回)")
        DataCenter.heroData.bag_size = msg.bag_size;
        DataCenter.heroData.extend_times = msg.bag_extend_times;
        Lua_MsgUtil.callFunc("UPDATE_ADD_BAG_SIZE");
    end
end

-- 查询英雄布阵阵容 (返回)
function Lua_HeroProxy:rHeroLineup(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114008();
        msg:ParseFromString(mp.data);
        DataCenter.heroLineupData:fromServer50114008(msg);
    end
end

-- 保存布阵 (返回)
function Lua_HeroProxy:rHeroSaveLineup(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114009();
        msg:ParseFromString(mp.data);
        DataCenter.heroLineupData:fromServer50114009(msg);
        OperateAlert.showLangValue(126304);
    end
end

-- 通知英雄布阵 (返回)
function Lua_HeroProxy:updateHeroLineup(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80114010();
        msg:ParseFromString(mp.data);
        DataCenter.heroLineupData:fromServer80114010(msg);
    end
end

-- 英雄评论（返回）
function Lua_HeroProxy:rHeroComment(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114012();
        msg:ParseFromString(mp.data);
        -- print("英雄评论（返回）")
        DataCenter.heroData:fromServer50114012(msg);
        Lua_MsgUtil.callFunc("UPDATE_HERO_COMMENT_INFO");
    end
end

-- 英雄羁绊(返回)
-- function Lua_HeroProxy:rHeroFetter(mp)
--     if mp.errno == 0 then
--         local msg = ProtoPublic_pb.Proto50114019();
--         msg:ParseFromString(mp.data);
--         -- print("英雄羁绊(返回)")
--         DataCenter.heroFetterData:fromServer50114019(msg);
--         Lua_MsgUtil.callFunc("UPDATE_HERO_FETTER_INFO");
--     end
-- end

-- 通知传记信息
function Lua_HeroProxy:rHeroDesInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80114021();
        msg:ParseFromString(mp.data);
        -- print("通知传记信息")
        DataCenter.heroData:fromServer80114021(msg);
        Lua_MsgUtil.callFunc("UPDATE_HERO_DES_INFO");
    end
end

-- 英雄时装(返回)
function Lua_HeroProxy:rHeroFashionInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114022();
        msg:ParseFromString(mp.data);
        --print("英雄时装(返回)")
        DataCenter.heroData:fromServer50114022(msg);
    end
end

-- 更新英雄时装
function Lua_HeroProxy:updateFashionInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80114022();
        msg:ParseFromString(mp.data);
        --print("更新英雄时装")
        DataCenter.heroData:fromServer80114022(msg);
        Lua_MsgUtil.callFunc("UPDATE_HERO_FASHION_INFO");
    end
end

-- 请求英雄图鉴属性（返回）
function Lua_HeroProxy:rHeroAtlasAttr(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114023();
        msg:ParseFromString(mp.data);
        -- print("请求英雄图鉴属性（返回）")
        DataCenter.heroAtlasData:fromServer50114023(msg);
        Lua_MsgUtil.callFunc("UPDATE_HERO_ATLAS_INFO",tonumber(msg.atlas_id));
    end
end

-- 英雄重修（返回）
function Lua_HeroProxy:rHeroRebuild(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114015();
        msg:ParseFromString(mp.data);
        -- print("英雄重修（返回）")
        DataCenter.heroData.rebuild_times = msg.rebuild_times;
        Lua_MsgUtil.callFunc("HERO_REBUID_INFO");
    end
end

-- 请求激活激活英雄觉醒返回
function Lua_HeroProxy:rActivateAwaken(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114024();
        msg:ParseFromString(mp.data);
        local heroVo = DataCenter.heroData:getItemByUniqueId(msg.hero_uid);
        heroVo.awaken_id = msg.awaken_id;
        heroVo.awaken_info = msg.awaken_column_info;
        Lua_WindowUtil.openWin("Lua_HeroAwakenWindow", Lua_WinParam.ACTION_CLOSE);
    end
end

-- 请求升级英雄觉醒返回
function Lua_HeroProxy:rUpgradeAwaken(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114025();
        msg:ParseFromString(mp.data);
        local heroVo = DataCenter.heroData:getItemByUniqueId(msg.hero_uid);
        heroVo.awaken_id = msg.awaken_id;
    end
end

-- 请求切换英雄觉醒类型返回
function Lua_HeroProxy:rSwitchAwaken(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114026();
        msg:ParseFromString(mp.data);
        local heroVo = DataCenter.heroData:getItemByUniqueId(msg.hero_uid);
        heroVo.awaken_id = msg.awaken_id;
        heroVo.awaken_info = msg.awaken_column_info;
        Lua_WindowUtil.openWin("Lua_HeroAwakenWindow", Lua_WinParam.ACTION_CLOSE);
    end
end

-- 请求解锁觉醒技能栏返回
function Lua_HeroProxy:rUnlockAwakenSkill(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114027();
        msg:ParseFromString(mp.data);
        local heroVo = DataCenter.heroData:getItemByUniqueId(msg.hero_uid);
        heroVo.awaken_info = msg.awaken_column_list;
        Lua_WindowUtil.openWin("Lua_HeroAwakenSkillUnlockWindow", Lua_WinParam.ACTION_CLOSE);
    end
end

-- 请求激活/切换觉醒技能返回
function Lua_HeroProxy:rSwitchAwakenSkill(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114028();
        msg:ParseFromString(mp.data);
        local heroVo = DataCenter.heroData:getItemByUniqueId(msg.hero_uid);
        heroVo.awaken_info = msg.awaken_column_info;
        Lua_WindowUtil.openWin("Lua_HeroAwakenSkillSelectWindow", Lua_WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("Lua_HeroAwakenSkillSwitchWindow", Lua_WinParam.ACTION_CLOSE);
    end
end

-- 通知试用英雄爬塔通关层数
function Lua_HeroProxy:updateTrialToweInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80114030();
        msg:ParseFromString(mp.data);
        DataCenter.heroData:fromServer80114030(msg);
    end
end

-- 请求英雄属性加成信息返回
function Lua_HeroProxy:rHeroAddOption(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114032();
        msg:ParseFromString(mp.data);
        DataCenter.heroData:fromServer50114032(msg);
        Lua_MsgUtil.callFunc("HERO_ADD_OPTION_INFO");
    end
end

-- 请求英雄属性返回
function Lua_HeroProxy:rHeroAttr(mp)
    if mp.errno == 0 then
        -- print("请求英雄属性返回")
        local msg = ProtoPublic_pb.Proto50114033();
        msg:ParseFromString(mp.data);
        local hvo = Lua_HeroVo.new(tonumber(msg.hero_info.hero_id));
        hvo:fromServer(msg.hero_info);
        Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, hvo);
    end
end

-- 查看角色英雄信息返回
function Lua_HeroProxy:rCheckRoleHeroInfo(mp)
    if mp.errno == 0 then
        -- print("查看角色英雄信息返回")
        local msg = ProtoPublic_pb.Proto50114034();
        msg:ParseFromString(mp.data);
        local hvo = Lua_HeroVo.new(tonumber(msg.hero_info.hero_id));
        hvo:fromServer(msg.hero_info);
        Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, hvo);
    end
end

-- 请求升级英雄神兵返回
function Lua_HeroProxy:rUpgradeWeapon(mp)
    if mp.errno == 0 then
        Lua_MsgUtil.callFunc("HERO_WEAPON_UPGRADE");
    end
end

--请求热度榜界面信息(返回)
function Lua_HeroProxy:rHeroHeatInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50205001();
        msg:ParseFromString(mp.data);
        -- print("请求热度榜界面信息(返回)       ",msg.rank_id)
        DataCenter.heroHeatData:fromServer50205001(msg)
        Lua_MsgUtil.callFunc("HERO_HEAT_RANK_INFO",msg.rank_id);
    end
end

--通知热度榜红点状态
function Lua_HeroProxy:updateHeroHeatInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80205001();
        msg:ParseFromString(mp.data);
         -- print("通知热度榜红点状态(返回)        ",msg.red_point_state)
        DataCenter.heroHeatData:updateHeroHeatRedDot(msg.red_point_state);
        Lua_MsgUtil.callFunc("HERO_HEAT_RANK_RED");
    end
end

--通知英雄战力变化
function Lua_HeroProxy:showHeroForce(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80114038();
        msg:ParseFromString(mp.data);
        local old_force = tonumber(msg.old_force);
        local new_force = tonumber(msg.new_force);
        if DataCenter.bConfigLoaded and new_force > old_force then
            Lua_WindowUtil.openWin("Lua_ForceChangeTipsWindow", Lua_WinParam.ACTION_OPEN, {oldForce = old_force, newForce = new_force});
        end
    end
end

-- 请求功能英雄信息返回
function Lua_HeroProxy:rCheckHeroInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50111007();
        msg:ParseFromString(mp.data);
        local vo = Lua_HeroVo.new(tonumber(msg.hero_info.hero_id));
        vo:fromServer(msg.hero_info);
        Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, vo);
    end
end





















----------------------------------------------------------------------------------------------------------------------------
-- 红点更新

-- 获取到货币更新红点
function Lua_HeroProxy:updateHeroRedDotByMoney(dic)
    if dic[Lua_ResourcesDefine.GOLD] --金币
    or dic[Lua_ResourcesDefine.HERO_EXP] --英雄经验
    then
        -- print("获取到货币更新红点")
        DataCenter.heroData:checkHeroRedDotState();
    end
end

-- 获取道具更新红点
function Lua_HeroProxy:updateHeroRedDotByItem(dic)
    if dic[Lua_PackDefine.LOW_STONE] ~= nil --普通装备强化石
    or dic[Lua_PackDefine.HIGH_STONE] ~= nil --高级装备强化石
    or dic[Lua_PackDefine.ORDE_STONE] ~= nil --进阶石
    or dic[Lua_PackDefine.WEAPON_STONE_LOW] ~= nil -- 初级神兵石
    or dic[Lua_PackDefine.WEAPON_STONE_CENTER] ~= nil -- 中级神兵石
    or dic[Lua_PackDefine.WEAPON_STONE_HIGH] ~= nil -- 高级神兵石
    then 
        -- print("获取道具更新红点")
        DataCenter.heroData:checkHeroRedDotState();
    end
end

-- 更新红点状态
function Lua_HeroProxy:updateHeroRedDotState()
    DataCenter.heroData:checkHeroRedDotState();
end
