-- 升星消耗
Lua_HeroStarCostCofingData = class("Lua_HeroStarCostCofingData");
function Lua_HeroStarCostCofingData.getConfig(cId)
    if Lua_HeroStarCostCofingData.configDic == nil then
		Lua_HeroStarCostCofingData.configDic = {};
	end

	cId = tonumber(cId);
	if Lua_HeroStarCostCofingData.configDic[cId] == nil then
		local cfg = getConfig( { "hero_star_cost", cId });
	    if cfg == nil then
	    	LogManager.LogError("no hero_star_cost id = " .. cId, false);
	    	return nil;
	    end
		Lua_HeroStarCostCofingData.configDic[cId] = Lua_HeroStarCostCofingData.new(cId, cfg);
	end
	return Lua_HeroStarCostCofingData.configDic[cId];
end

function Lua_HeroStarCostCofingData:ctor(id, cfg)
    self:superCall("ctor");
    self.id = id;
    self.config = cfg;
    if self.config == nil then
	    self.config = getConfig({"hero_star_cost",id});
	end
end

function Lua_HeroStarCostCofingData.Get:hero_id() -- 英雄ID
    return self.config.hero_id;
end

function Lua_HeroStarCostCofingData.Get:star() -- 英雄星级
    return self.config.star;
end

function Lua_HeroStarCostCofingData.Get:color() -- 英雄品质
    return self.config.color;
end

function Lua_HeroStarCostCofingData.Get:upgrade_material() -- 升星材料
    return self.config.upgrade_material;
end

function Lua_HeroStarCostCofingData.Get:upgrade_exp() -- 升星所消耗的资源数量
    return self.config.upgrade_exp;
end

function Lua_HeroStarCostCofingData.Get:rebuild_material() -- 重修返还明星
    return self.config.client_rebuild_material;
end

function Lua_HeroStarCostCofingData.Get:rebuild_item() -- 重修返还替身演员材料
    return self.config.rebuild_item;
end

function Lua_HeroStarCostCofingData.Get:rebuild_exp() -- 重修返还所消耗的资源数量
    return self.config.rebuild_exp;
end

-- 升星总消耗数量
function Lua_HeroStarCostCofingData.Get:all_num()
    if self.config.all_num == nil then
        return 0;
    end
    return self.config.all_num;
end

-- 快捷升星总消耗数量
function Lua_HeroStarCostCofingData.Get:speed_all_num()
    if self.all_num == 0 then
        return 0;
    end
    return self.all_num +1;
end

-- 升星所消耗的资源数量
function Lua_HeroStarCostCofingData.Get:costMaterialInfo()
    if self._costMaterialInfo == nil then
        self._costMaterialInfo = Array();
        local cost_list = self.upgrade_exp;
        if cost_list ~= nil then
            for i=1,#cost_list do
                local upgradeCostVo = Lua_HeroCostMaterialsVo.new(cost_list[i][1]);
                self._costMaterialInfo:add(upgradeCostVo);
                self._costMaterialInfo[i].needNum = cost_list[i][2];
            end
        end
    end
    return self._costMaterialInfo;
end

-- 重修返还明星
function Lua_HeroStarCostCofingData.Get:getRebuildStarInfo()
    if self._rebuildHeroInfo == nil then
        self._rebuildHeroInfo = Array();
        local cost_list = self.rebuild_material;
        if cost_list ~= nil then
            for i=1,#cost_list do
                local cvo = Lua_HeroVo.new(cost_list[i][1]);
                cvo.star = cost_list[i][2];
                cvo.count = cost_list[i][3];
                cvo.level = 1;
                self._rebuildHeroInfo:add({vo = cvo});           
            end
        end
    end
    return self._rebuildHeroInfo;
end

-- 重修返还替身演员材料
function Lua_HeroStarCostCofingData.Get:getRebuildStarRepInfo()
    if self._rebuildHeroRepInfo == nil then
        self._rebuildHeroRepInfo = Array();
        if self.rebuild_item ~= nil then
            for i=1,#self.rebuild_item do
                self._rebuildHeroRepInfo:add({id = self.rebuild_item[i][1],num = self.rebuild_item[i][2]});
            end
        end
    end
    return self._rebuildHeroRepInfo;
end

-- 重修返还所消耗的资源数量
function Lua_HeroStarCostCofingData.Get:getRebuildStarExpInfo()
    if self._rebuildHeroExpInfo == nil then
        self._rebuildHeroExpInfo = Array();
        if self.rebuild_exp ~= nil then
            for i=1,#self.rebuild_exp do
                self._rebuildHeroExpInfo:add({id = self.rebuild_exp[i][1],num = self.rebuild_exp[i][2]});
            end
        end
    end
    return self._rebuildHeroExpInfo;
end


-- 解约返还数据
function Lua_HeroStarCostCofingData.Get:cancelHeroExpInfo()
    if self._cancelHeroExpInfo == nil then
        self._cancelHeroExpInfo = Array();
        if self.upgrade_exp ~= nil then
            for i=1,#self.upgrade_exp do
                self._cancelHeroExpInfo:add({id = self.upgrade_exp[i][1],num = self.upgrade_exp[i][2]});
            end
        end
    end

    return self._cancelHeroExpInfo;
end