checkRequire("Lua_HeroAssemblyUtil");
checkRequire("Lua_HeroAssemblyData");
Lua_HeroAssemblyProxy = class("Lua_HeroAssemblyProxy");
function Lua_HeroAssemblyProxy:ctor()
	DataCenter.heroAssemblyUtil = Lua_HeroAssemblyUtil.new();
	DataCenter.heroAssemblyData = Lua_HeroAssemblyData.new();

	Lua_MsgUtil.addLuaMsg(50183001, self, self.rHeroAssemblyInfo); --快捷升星(返回)
	Lua_MsgUtil.addLuaMsg(80183001, self, self.rHeroAssemblyOpen); --英雄神殿各功能开启通知
	Lua_MsgUtil.addLuaMsg(80183002, self, self.rAutoDecomposeInfo);
end

-------------------------上行消息号-------------------------

--快捷升星
function Lua_HeroAssemblyProxy:sHeroFastUpStar(list, isFastUp)
	local cmd = ProtoPublic_pb.Proto10183001();
	if isFastUp then
		for i = 1, #list do	
			local struct = getProtoMsg("ProtoCelStarUpPair");
			struct.unique_id = tonumber(list[i].unique_id);

			local costHeroInfo = DataCenter.heroData:getItemByUniqueId(list[i].unique_id).heroUpStarVo.costHeroInfo;
			local curIndex = 2;
			for j = 1, costHeroInfo:getSize() do
				local struct1 = getProtoMsg("ProtoStarUpMaterial");
				struct1.index = j;

				local Info = list[i].Info;
				local needNum = costHeroInfo[j].needNum;
				local curNum = 0;
				for k = curIndex, #Info do
					for uid, v in pairs(Info[k]) do
						struct1.uid_list:append(tonumber(uid));
					end

					curNum = curNum + 1;
					if curNum >= needNum then
						curIndex = curIndex + needNum;
						break;
					end
				end
				struct.material_list:addToList(struct1);
			end
			cmd.list:addToList(struct);
		end
	else
		for i = 1, #list do	
			local struct = getProtoMsg("ProtoCelStarUpPair");
			struct.unique_id = tonumber(list[i].unique_id);

			local Info = list[i].Info;
			for j = 2, #Info do
				local struct1 = getProtoMsg("ProtoStarUpMaterial");
				struct1.index = j - 1;

				for uid, v in pairs(Info[j]) do
					struct1.uid_list:append(tonumber(uid));
				end
				struct.material_list:addToList(struct1);
			end

			cmd.list:addToList(struct);
		end
	end

	sendMsg(10183001, cmd);
end

--英雄流放
function Lua_HeroAssemblyProxy:sHeroDecompose(uidList)
	local cmd = ProtoPublic_pb.Proto10183002();
	for k, v in pairs(uidList) do
		cmd.uid_list:append(tonumber(k));
	end
	sendMsg(10183002, cmd);
end

--英雄回退
function Lua_HeroAssemblyProxy:sHeroReshape(uniqueId)
	local cmd = ProtoPublic_pb.Proto10183003();
	cmd.unique_id = uniqueId;
	sendMsg(10183003, cmd);
end

--英雄替换
function Lua_HeroAssemblyProxy:sHeroReplacement()
	local cmd = ProtoPublic_pb.Proto10183004();
	cmd.unique_id = tonumber(DataCenter.heroAssemblyData.selectHeroVo.unique_id);

	local list = DataCenter.heroAssemblyData.replacementSelectList;
	for k, v in pairs(list) do	
		if v == 1 then
			cmd.uid_list:append(tonumber(k));
		end
	end
	sendMsg(10183004, cmd);
end


--设置自动流放
function Lua_HeroAssemblyProxy:sSetAutoDecompose(state)
	local cmd = ProtoPublic_pb.Proto10183005();
	cmd.state = state;--自动流放功能开启状态 0: 关闭 1: 开启
	sendMsg(10183005, cmd);
end

-------------------------上行消息号-------------------------

--快捷升星(返回)
function Lua_HeroAssemblyProxy:rHeroAssemblyInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50183001();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATA_HERO_ASSEMBLY_INFO", msg);
	end
end

--英雄神殿各功能开启通知
function Lua_HeroAssemblyProxy:rHeroAssemblyOpen(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80183001();
		msg:ParseFromString(mp.data);
		DataCenter.heroAssemblyData:fromServer80183001(msg);
	end
end

--英雄自动流放返回材料（通知）
function Lua_HeroAssemblyProxy:rAutoDecomposeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80183002();
		msg:ParseFromString(mp.data);
		DataCenter.heroAssemblyData:fromServer80183002(msg);
	end
end