Lua_HeroFastUpStarVo = class("Lua_HeroFastUpStarVo")
function Lua_HeroFastUpStarVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if config == nil then
		self.config = getConfig( { "hero_speedy", id });
	end
end

--升星材料展示英雄
function Lua_HeroFastUpStarVo.Get:heroVo()
	if self._heroVo == nil then
		self._heroVo = Lua_HeroVo.new(self.hero_id);
		self._heroVo.star = self.star;
		self._heroVo.color = self.color;
		self._heroVo.show_star = self.show_star;

		self._heroVo.level = self.level;
	end
	return self._heroVo;
end

--列表展示英雄
function Lua_HeroFastUpStarVo.Get:show_heroVo()
	if self._show_heroVo == nil then
		self._show_heroVo = Lua_HeroVo.new(self.hero_id);
		self._show_heroVo.star = self.star;
		self._show_heroVo.level = self.level;
	end
	return self._show_heroVo;
end

--获取快捷升星明星材料的初始已激活数量
function Lua_HeroFastUpStarVo.Get:getInitActiveNum()
	local activeNum = DataCenter.heroAssemblyUtil.upStarActiveNumDic[self.id];
	if activeNum ~= nil then
		return activeNum;
	end

	local activeNum = 0;
	local selectHeroUidDic = {};--已选的英雄唯一id
	local info = self.heroVo.heroUpStarVo.speedyCostHeroInfo;--快捷升星材料
	for i = 1, info:getSize() do
		local selectNum = 0;
		local unique_id;
		local heroUidArr = DataCenter.heroData:getHeroUidArrByStar(info[i].star);
		for j = 1, heroUidArr:getSize() do
			if selectNum >= info[i].needNum then
				break;
			end

			unique_id = heroUidArr[j];
			if selectHeroUidDic[unique_id] ~= 1 then
				hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
				if info[i].id ~= 0 then
					if hvo.isSpecialState == false and hvo.id == info[i].id and hvo.campType == info[i].campType and hvo.star == info[i].star then
						selectNum = selectNum + 1;
						selectHeroUidDic[unique_id] = 1;
					end
				else
					if hvo.isSpecialState == false and hvo.campType == info[i].campType and hvo.star == info[i].star then
						selectNum = selectNum + 1;
						selectHeroUidDic[unique_id] = 1;
					end
				end
			end
		end

		activeNum = activeNum + selectNum;
	end
	DataCenter.heroAssemblyUtil.upStarActiveNumDic[self.id] = activeNum;
	return activeNum;
end

--获取快捷升星的总材料数
function Lua_HeroFastUpStarVo.Get:speedAllNum()
	if self._speedAllNum == nil then
		self._speedAllNum = self.heroVo.heroUpStarVo.config.speed_all_num;
	end
	return self._speedAllNum;
end

--判断当前明星能否默认升星
function Lua_HeroFastUpStarVo.Get:isCanUpStar()
	return self.getInitActiveNum >= self.speedAllNum;
end

--获取当前升星公式的满足情况
function Lua_HeroFastUpStarVo.Get:getUpStarMeetTime()
	local meetTime = nil;--满足公式次数
	local curTime = 0;--当前材料满足次数
	local info = self.heroVo.heroUpStarVo.speedyCostHeroInfo;--快捷升星材料
	for i = 2, info:getSize() do
		local selectNum = 0;
		if info[i].isFastAutoSelect then
			local heroUidArr = DataCenter.heroData:getHeroUidArrByStar(info[i].star);
			if info[i].needNum > heroUidArr:getSize() then
				return 0;
			end

			for j = 1, heroUidArr:getSize() do
				hvo = DataCenter.heroData:getItemByUniqueId(heroUidArr[j]);
				if info[i].id ~= 0 then
					if hvo.isSpecialState == false and hvo.id == info[i].id and hvo.campType == info[i].campType and hvo.star == info[i].star then
						selectNum = selectNum + 1;
					end
				else
					if hvo.isSpecialState == false and hvo.campType == info[i].campType and hvo.star == info[i].star then
						selectNum = selectNum + 1;
					end
				end
			end
		else
			return 0;
		end

		if info[i].needNum > selectNum then
			return 0;
		end

		local totalNum = 0;
		if i == 2 then
			totalNum = info[1].needNum + info[2].needNum;
		else
			totalNum = info[i].needNum;
		end
		curTime = Mathf.Floor(selectNum / totalNum);
		if meetTime == nil or meetTime > curTime then
			meetTime = curTime;
		end
	end
	return meetTime;
end

--排序
function Lua_HeroFastUpStarVo.Get:sort()
	local weight = 0;
	if not self.isCanUpStar then
		weight = 100000000000;
	end
	return weight + self.config.sort;
end

-------------------- 配置数据 --------------------

function Lua_HeroFastUpStarVo.Get:hero_id()
	return self.config.hero_id;
end

-- function Lua_HeroFastUpStarVo.Get:sort()
-- 	return self.config.sort;
-- end

function Lua_HeroFastUpStarVo.Get:star()
	return self.config.star;
end

function Lua_HeroFastUpStarVo.Get:show_star()
	return self.config.show_star;
end

function Lua_HeroFastUpStarVo.Get:color()
	return self.config.color;
end

function Lua_HeroFastUpStarVo.Get:level()
	return self.config.level;
end