--装备vo
Lua_EquipVo = class("Lua_EquipVo", Lua_ToolVo)
function Lua_EquipVo:ctor(id, count)
    self:superCall("ctor", id, count);
end

function Lua_EquipVo:fromServer(msg)
    self._hero_uid = nil;
    self.unique_id = tonumber(msg.unique_id);--唯一id

    self.equipAllExp = tonumber(msg.equip_info.exp);--强化到当前等级的总经验
    self.equipLevel = msg.equip_info.level;--装备强化等级
    self.equipScore = msg.equip_info.score;--装备评分
    self.lockState = msg.equip_info.lock_state == 1;--上锁状态 0：未上锁 1：已上锁

    self.equipProp = msg.equip_info.prop;--装备主属性
    self.extraProp = msg.equip_info.extra_prop;--装备副属性
    self:reset();
end

--重置字段
function Lua_EquipVo:reset()
    self._bMaxLevel = nil;
    self._equipSort = nil;
    self._equipGrade = nil;
    self._lockAttrNum = nil;
    self._equipLevelId = nil;
    self._equipCurLevelExp = nil;

    self._decompose = nil;
end

---------------------------------- 字段 -------------------------------------------

--强化品质配置id
function Lua_EquipVo.Get:equipLevel()
    if self._equipLevel == nil then
        return 0;
    end
    return self._equipLevel;
end

--强化品质配置id
function Lua_EquipVo.Set:equipLevel(val)
    self._equipLevel = val;
end

--评级级别
function Lua_EquipVo.Get:equipGrade()
    if self._equipGrade == nil and self.extraProp ~= nil and #self.extraProp > 0 then--词条解锁才有评级
        local id = self.color*100 + self.star;
        self._equipGrade = DataCenter.equipUtil:getEquipGrade(id, self.extraProp);
    end
    return self._equipGrade;
end

--强化品质配置id
function Lua_EquipVo.Get:equipColorId()
    --强化品质id = color*100 + star
    if self._equipColorId == nil then
        self._equipColorId = self.color *100 + self.star;
    end
    return self._equipColorId;
end

--装备等级配置id
function Lua_EquipVo.Get:equipLevelId()
    --装备等级配置id = id*100 + 强化等级
    if self._equipLevelId == nil then
        self._equipLevelId = self.id *100 + self.equipLevel;
    end
    return self._equipLevelId;
end

--装备所属的英雄唯一id
function Lua_EquipVo.Get:hero_uid()
   if self._hero_uid == nil then
        return 0;
    end
    return self._hero_uid;
end

--设置装备所属的英雄唯一id
function Lua_EquipVo.Set:hero_uid(val)
    self._hero_uid = val;
end

--装备当前等级已强化经验
function Lua_EquipVo.Get:equipCurLevelExp()
    if self._equipCurLevelExp == nil then
        local up_exp = 0;
        if self.equipLevel > 0 then
            up_exp = DataCenter.equipUtil:getEquipExp(self.equipLevelId - 1);
        end
        self._equipCurLevelExp = self.equipAllExp - up_exp;
    end
    return self._equipCurLevelExp;
end

--装备副属性上锁数量
function Lua_EquipVo.Get:lockAttrNum()
    if self._lockAttrNum == nil then
        self._lockAttrNum = 0;
        for i=1, #self.extraProp do
            if self.extraProp[i].lock_state == 1 then
                self._lockAttrNum = self._lockAttrNum +1;
            end
        end
    end
    return self._lockAttrNum;
end

--装备最大等级
function Lua_EquipVo.Get:bMaxLevel()
    if self._bMaxLevel == nil then
        self._bMaxLevel = DataCenter.equipUtil:getEquipMaxLevelByLevelId(self.equipLevelId);
    end
    return self._bMaxLevel;
end

--装备分解获得材料
function Lua_EquipVo.Get:decompose()
    if self._decompose == nil then
        local arr = Array();
        local decompose = self.config.decompose;
        self._decompose = DataCenter.equipUtil:getEquipDecomposeInfo(self.equipColorId, self.equipAllExp, decompose);
    end
    return self._decompose;
end

--装备评分
function Lua_EquipVo.Get:equipScore()
    if self._equipScore == nil or self._equipScore == 0 then
        return self.score;
    end
    return self._equipScore;
end

--装备评分
function Lua_EquipVo.Set:equipScore(val)
    self._equipScore = val;
end






---------------------------------- 配置表数据 -------------------------------------------

--部位
function Lua_EquipVo.Get:part()
    return self.config.part;
end

--配置基础评分
function Lua_EquipVo.Get:score()
    return self.config.score;
end

--属性id
function Lua_EquipVo.Get:equip_prop_id()
    return self.config.equip_prop_id;
end














---------------------------------- 排序 -------------------------------------------
-- 装备背包排序 
function Lua_EquipVo.Get:equipSort()
    if self._equipSort == nil then
        self._equipSort = -(self.equipLevel*10000000000000 + self.color*1000000000000 + self.star*100000000000 + self.equipScore*10-self.part);
    end
    return self._equipSort;
end