--装备消息类
checkRequire("Lua_EquipUtil");
checkRequire("Lua_EquipData");
Lua_EquipProxy = class("Lua_EquipProxy");
function Lua_EquipProxy:ctor()
	DataCenter.equipUtil = Lua_EquipUtil.new();
	DataCenter.equipData = Lua_EquipData.new();

    Lua_MsgUtil.addLuaMsg(50179005, self, self.rEquipLock);  -- 请求装备上锁返回
    Lua_MsgUtil.addLuaMsg(50179006, self, self.rEquipAttrLock);-- 请求装备属性上锁返回
    Lua_MsgUtil.addLuaMsg(50179010, self, self.rRecastSave); -- 请求重铸装备(返回)
    Lua_MsgUtil.addLuaMsg(50179011, self, self.rRecastInfo); -- 请求装备重铸界面信息返回
    Lua_MsgUtil.addLuaMsg(50179008, self, self.rStrongEquip);-- 请求强化装备(返回)
end



----------------------------------------------------------------------------------------------------------------------------
-- 上行消息号

-- 请求穿戴装备
function Lua_EquipProxy:sWornEquip(equip_uid, hero_uid, other_hero_uid)
    -- print(equip_uid,"  请求穿戴装备   ",hero_uid,"       ",other_hero_uid)
    local cmd = ProtoPublic_pb.Proto10179004();
    cmd.hero_uid = tonumber(hero_uid);
    cmd.equip_uid = tonumber(equip_uid);
    cmd.other_hero_uid = tonumber(other_hero_uid);--替换时的其他英雄唯一id 不是替换发0
    
    sendMsg(10179004, cmd);
end

-- 请求锁定装备
function Lua_EquipProxy:sLockEquip(equip_uid, hero_uid, lock_state)
    local cmd = ProtoPublic_pb.Proto10179005();
    cmd.equip_uid = tonumber(equip_uid);
    cmd.hero_uid = tonumber(hero_uid);--装备所属的英雄唯一id
    cmd.lock_state = tonumber(lock_state);--1.锁定 0：解锁
    sendMsg(10179005, cmd);
end

-- 请求锁定装备副属性
function Lua_EquipProxy:sLockEquipAttr(equip_uid, hero_uid, lock_entry_list)
    local cmd = ProtoPublic_pb.Proto10179006();
    cmd.equip_uid = tonumber(equip_uid);
    cmd.hero_uid = tonumber(hero_uid);
    for key, val in pairs(lock_entry_list) do
        local struct = getProtoMsg("ProtoPair");
        struct.key = tonumber(key); --key: 第几个词条
        struct.value = tonumber(val);--val: 上锁状态 1：上锁 0：解锁
        -- print(key,"     请求锁定装备副属性    ",val)
        cmd.lock_entry_list:addToList(struct);
    end
    sendMsg(10179006, cmd);
end

-- 请求卸下装备
function Lua_EquipProxy:sDemountEquip(equip_uid, hero_uid)
    -- print(equip_uid,"  请求卸下装备   ",hero_uid)
    local cmd = ProtoPublic_pb.Proto10179007();
    cmd.hero_uid = tonumber(hero_uid);
    cmd.equip_uid = tonumber(equip_uid);
    sendMsg(10179007, cmd);
end

-- 请求强化装备
function Lua_EquipProxy:sStrongEquip(equip_uid, hero_uid, material)
    -- print(equip_uid,"   请求强化装备  ",hero_uid)
    local cmd = ProtoPublic_pb.Proto10179008();
    cmd.equip_uid = tonumber(equip_uid);
    cmd.hero_uid = tonumber(hero_uid);
    for id,count in pairs(material) do
        if count > 0 then
            local struct = getProtoMsg("ProtoPairLong");
            if string.len(id) >= 20 then
                id = string.sub(id,1,9);
            end
            struct.key = tonumber(id);
            struct.value = tonumber(count);
            -- print(id,"     请求强化装备    ",count)
            cmd.material:addToList(struct);
        end
    end

    sendMsg(10179008, cmd);
end

-- 请求重铸装备
function Lua_EquipProxy:sRecastEquip(equip_uid, hero_uid)
    -- print(hero_uid,"   请求重铸装备  ",equip_uid)
    local cmd = ProtoPublic_pb.Proto10179009();
    cmd.equip_uid = tonumber(equip_uid);
    cmd.hero_uid = tonumber(hero_uid);
    sendMsg(10179009, cmd);
end

-- 请求请求保存重铸效果
function Lua_EquipProxy:sRecastSave(equip_uid, hero_uid)
    local cmd = ProtoPublic_pb.Proto10179010();
    cmd.equip_uid = tonumber(equip_uid);
    cmd.type = 1;--1：保存 2：取消
    cmd.hero_uid = tonumber(hero_uid);--装备所属的英雄唯一id 没有发0
    sendMsg(10179010, cmd);
end

-- 请求装备重铸信息
function Lua_EquipProxy:sRecast(equip_uid, hero_uid)
    local cmd = ProtoPublic_pb.Proto10179011();
    cmd.equip_uid = tonumber(equip_uid);
    cmd.hero_uid = tonumber(hero_uid);
    sendMsg(10179011, cmd);
end

-- 请求一键穿戴/卸下装备
function Lua_EquipProxy:sEquipChange(hero_uid,index)
    local cmd = ProtoPublic_pb.Proto10179012();
    cmd.hero_uid = tonumber(hero_uid);
    cmd.type = tonumber(index);--1：穿戴 2：卸下
    sendMsg(10179012, cmd);
end










----------------------------------------------------------------------------------------------------------------------------
-- 下行消息号

-- 请求装备上锁返回
function Lua_EquipProxy:rEquipLock(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50179005();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("UPDATE_EQUIP_LOCK",tonumber(msg.equip_uid));
    end
end

-- 请求装备属性上锁返回
function Lua_EquipProxy:rEquipAttrLock(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50179006();
        msg:ParseFromString(mp.data);
        -- print("请求装备属性上锁返回   ",tonumber(msg.equip_uid))
        Lua_MsgUtil.callFunc("UPDATE_EQUIP_DEVELO",tonumber(msg.equip_uid));
    end
end

-- 请求装备重铸界面信息返回
function Lua_EquipProxy:rRecastInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50179011();
        msg:ParseFromString(mp.data);
        -- print("请求装备重铸界面信息返回   ",tonumber(msg.equip_uid))
        Lua_MsgUtil.callFunc("UPDATE_EQUIP_RECAST_INFO",msg);
    end
end

-- 请求强化装备返回
function Lua_EquipProxy:rStrongEquip(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50179008();
        msg:ParseFromString(mp.data);
        OperateAlert.showLangValue(126789);
        Lua_MsgUtil.callFunc("UPDATE_EQUIP_STRONG", tonumber(msg.equip_uid));
    end
end

-- 请求重铸装备保存返回
function Lua_EquipProxy:rRecastSave(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50179010();
        msg:ParseFromString(mp.data);
        -- print("请求重铸装备保存返回   ",tonumber(msg.equip_uid))
        Lua_MsgUtil.callFunc("UPDATE_EQUIP_DEVELO",tonumber(msg.equip_uid));
    end
end