--英雄星魂
checkRequire("Lua_HeroJewelryVo"); -- 英雄星魂
Lua_HeroJewelryData = class("Lua_HeroJewelryData")
function Lua_HeroJewelryData:ctor()
	self:superCall("ctor");
    self.partItemList = {};
    self.uniqueItemList = {};
    self.selectJewelryStar = 0; -- 选择的星魂星级
    self.recastLockOne = false;
    self.recastLockTwo = false;
end

function Lua_HeroJewelryData:dispose()
    self._type = nil;
    self.allItemInfo = nil;
    self.uniqueItemList = {};
    self.partItemList = {};
    self.lockInfo = nil;
    self.selectJewelryStar = nil;
    self.recastLockOne = false;
    self.recastLockTwo = false;
end

-- 重铸返回
function Lua_HeroJewelryData:fromServer50145001(msg)
    if msg == nil then
        return;
    end
    
    local info = msg.jewelry;
    -- print("info.unique_id  = =",info.unique_id)
    local vo = self:getJewelryVoByUniqueId(info.unique_id);
    vo:fromServer(info);
end

-- 添加一个星魂
function Lua_HeroJewelryData:addOneItem(oneItem)
    -- print(" 添加一个星魂 ",oneItem.unique_id," 添加一个星魂 = id =",oneItem.id," 名字  =",oneItem.name)
    local part = oneItem.part;
    if self.partItemList[part] == nil then
        self.partItemList[part] = { };
    end

    if self.allItemInfo == nil then
        self.allItemInfo = Array();
    end

    if self.uniqueItemList[oneItem.unique_id] ~= nil then
        for i=1,self.allItemInfo:getSize() do
            if self.allItemInfo[i].unique_id == oneItem.unique_id then
                self.allItemInfo[i] = oneItem;
                break;
            end
        end
    else
        self.allItemInfo:add(oneItem);
    end

    self.uniqueItemList[oneItem.unique_id] = oneItem;
    self.partItemList[part][oneItem.unique_id] = oneItem;
end

-- 移除一个星魂
function Lua_HeroJewelryData:removeOneItem(oneItem)
    local part = oneItem.part;
    -- print(oneItem.unique_id," 移除一个星魂 = id =",oneItem.id," 名字  =",oneItem.name)
    if self.partItemList[part] == nil then
        return;
    end
    if self.partItemList[part][oneItem.unique_id] == nil then
        return;
    end
    self.partItemList[part][oneItem.unique_id] = nil;
    self.uniqueItemList[oneItem.unique_id] = nil;
    for i=1,self.allItemInfo:getSize() do
        if self.allItemInfo[i].unique_id == oneItem.unique_id then
            self.allItemInfo:remove(i);
            break;
        end
    end
end

-- 获取所有星魂数据
function Lua_HeroJewelryData.Get:getJewelryInfo()
    if self.allItemInfo == nil then
        return Array();
    end
    return self.allItemInfo;
end

-- 通过唯一id获取星魂vo
function Lua_HeroJewelryData:getJewelryVoByUniqueId(unique_id)
    return self.uniqueItemList[tonumber(unique_id)];
end

-- 通过部位 + 唯一id获取星魂vo
function Lua_HeroJewelryData:getItemVoByPart(part,unique_id)
    return self.partItemList[part][unique_id];
end

-- 获取部位所有数据
function Lua_HeroJewelryData:getItemArrByPart(part)
    local arr = Array();
    local list = self.partItemList[part];
    if list ~= nil then
        for k,v in pairs(list) do
            arr:add(v);
        end
        arr:sort("changeSort",true);
    end
    return arr;
end

-- 星魂套装id标记
function Lua_HeroJewelryData:getJewelrySuitDic(info)
    local list = {};
    if info ~= nil then
        for i=1,#info do
            if info[i] ~= nil then
                local suit_id = info[i].suit_activate_id;
                if suit_id ~= 0 then
                    if list[suit_id] == nil then
                        list[suit_id] = 1;
                    else
                        list[suit_id] = list[suit_id] +1;
                    end
                end
            end
        end
    end
    return list;
end


-- 星魂红点
function Lua_HeroJewelryData:checkJewelryRedByPart(part,data,is_limit)
    if data == nil then
        return false;
    end
    if is_limit == true or data.is_show_Fight == true then -- 主线上阵的英雄
        local tag_bool = nil;
        if data.celebrityJewelryInfo == nil then
            tag_bool = true;
        else
            if data.celebrityJewelryInfo[part] == nil then
                tag_bool = true;
            end
        end
        if tag_bool == true then -- 对应部位没穿戴星魂
            if self.getJewelryInfo ~= nil then
                local len = self.getJewelryInfo:getSize();
                for i=1, len do
                    if self.getJewelryInfo[i].part == part and self.getJewelryInfo[i].is_adorn == false then --背包检测星魂
                        return true;
                    end
                end
            end
        end
    end

    return false;
end






---------------------------------- 重铸界面数据 -------------------------------------------

-- 设置重铸属性上锁状态
function Lua_HeroJewelryData:setRecastLockInfo(index,name)
    if self.lockInfo == nil then
        self.lockInfo = {};
    end
    self.lockInfo[index] = name;
end

function Lua_HeroJewelryData.Get:getRecastLockInfo()
    local arr = Array();
    if self.lockInfo ~= nil then
        for k,v in pairs(self.lockInfo) do
            if v ~= nil then
                arr:add(v);
            end
        end
    end
    return arr;
end

function Lua_HeroJewelryData:resetRecastLockInfo()
    if self.lockInfo ~= nil then
        self.lockInfo = nil;
    end
end







---------------------------------- 商谈界面数据 -------------------------------------------

-- 商谈数据
function Lua_HeroJewelryData:fromServer50145002(msg)
    if msg == nil then
        return;
    end
    if msg.free == 1 then
        self.free = true;
    else
        self.free = false;
    end
    -- DataCenter.redDotUtil:updateRedDotVoById(10074,not self.free)

    self.brand_times = msg.times; -- 商谈抽取次数
    self.draw_record = msg.draw_record; -- 全服抽奖记录
    self.person_draw_record = msg.person_draw_record; -- 个人抽奖记录
end


-- 抽奖保底次数
function Lua_HeroJewelryData:getDrawLimitNumByType(_type) 
    if self.brand_times ~= nil  then
        for i,v in ipairs(self.brand_times) do
            if v.key == _type then
                return v.value;
            end
        end
    end
    return nil
end

-- 抽奖保底次数
function Lua_HeroJewelryData:getDrawLimitNum(_type) 
    local limit = DataCenter.heroJewelryUtil.jewelry_draw_limit;
    local times = self:getDrawLimitNumByType(_type);
    if times ~= nil then
        local num = times%limit;
        if num ~= 0 then
            return limit - num;
        end
    end
    return limit;
end


-- 个人抽奖记录
function Lua_HeroJewelryData.Get:selfDrawRecordInfo() 
    local arr = Array();
    if self.person_draw_record ~= nil then
        for i,v in ipairs(self.person_draw_record) do
            local vo = Lua_ToolVo.createToolVo(tonumber(v.key));
            if vo ~= nil then
                local show_num = "["..vo.colorStr.."]".."*"..v.value;
                local colorName = vo.colorName;
                if vo.main_type == Lua_PackDefine.STAR_JEWELRY then --星魂
                    colorName = vo.showColorName;
                end
                local str = LanUtil.formateStr(126571,tostring(colorName),tostring(show_num));
                arr:add({des = str,sort = v.other});
            end
        end
    end
    arr:sort("sort",true);
    return arr;
end

-- 全服抽奖记录
function Lua_HeroJewelryData.Get:allDrawRecordInfo()
    local arr = Array();
    if self.draw_record ~= nil then
        for i,v in ipairs(self.draw_record) do
            arr:add(v);
        end
    end
    return arr;
end

-- 商谈抽奖返回
function Lua_HeroJewelryData:fromServer50145004(msg)
    if msg == nil then
        return;
    end
    local item_list = msg.item_id;
    local arr = Array();
    for i=1,#item_list do
        local tvo = self.drawRewardIdDic[tonumber(item_list[i])];
        if tvo ~= nil then
            arr:add(tvo);
        end
    end
    
    Lua_WindowUtil.openWin("Lua_BrandRewardItemTipsWindow", Lua_WinParam.ACTION_OPEN,{ data = arr});
end


-- 弹窗返回抽奖数据
function Lua_HeroJewelryData:fromServerDrawInfo(list)
    self.drawRewardIdDic = {};
    local id;
    for i=1,#list do
        id = tonumber(list[i].id);
        local tvo = Lua_ToolVo.createToolVo(id, list[i].amount);
        tvo:fromServer(list[i]);
        self.drawRewardIdDic[id] = tvo;
    end
end






---------------------------------- 商品界面数据 -------------------------------------------

-- 更新限购数据
function Lua_HeroJewelryData:fromServer50145005(msg)
    if msg == nil then
        return;
    end
    local list = msg.special_item;
    for k,v in ipairs(list) do
        local vo = DataCenter.heroJewelryUtil:getJewelryShopVoById(v.key);
        if vo ~= nil then
            vo.limit_num = v.value;
        end
    end
end





---------------------------------- 星魂总览数据 -------------------------------------------

-- 激活套装数据
function Lua_HeroJewelryData:getSuitInfo(info)
    local list = {};
    local arr = Array();
    for i,v in pairs(info) do
        local suit_activate_id = v.suit_activate_id;
        if suit_activate_id ~= nil and suit_activate_id ~= 0 then
            if list[suit_activate_id] == nil then
                list[suit_activate_id] = 0;
                local suit_vo = Lua_JewelrySuitConfigData.getJewelrySuitConfig(suit_activate_id);
                if suit_vo.activate_num == 2 then
                    arr:add(suit_vo);
                elseif suit_vo.activate_num == 4 then
                    local two_id = suit_activate_id - 2;
                    two_suit_vo = Lua_JewelrySuitConfigData.getJewelrySuitConfig(two_id);
                    arr:add(two_suit_vo);
                    if suit_vo.type == 1 then
                        arr:add(suit_vo);
                    end
                end
            end
        end
    end
    return arr;
end

-- 套装属性
function Lua_HeroJewelryData:getSuitVoInfo(data)
    local list = {};
    -- local tag_list = {};
    local info = data.celebrityJewelryInfo;
    if info ~= nil then
        for i,v in pairs(info) do
            local suit_all_prop = v.suit_all_prop;
            for k,value in pairs(suit_all_prop) do
                -- print(k,"00000000000",value)
                if list[k] == nil then
                    list[k] = value;
                else
                    list[k] = list[k] + value;
                end
            end
        end

        local suit_info = self:getSuitInfo(info);
        for i=1, suit_info:getSize() do
            local attr_nume = suit_info[i].prop_name;
            local attr_value = suit_info[i].prop_value;
            if list[attr_nume] == nil then
                list[attr_nume] = attr_value;
            else
                list[attr_nume] = list[attr_nume] + attr_value;
            end
        end
    end
    return list;
end

-- 获取套装类型   用于根据类型进行UI显示
function Lua_HeroJewelryData:getSuitType(data)
    local info = data.celebrityJewelryInfo;
    if info ~= nil then
        for i,v in pairs(info) do
            if v.activateJewelrySuitVo ~= nil then
                return v.activateJewelrySuitVo.type;
            end
        end
    end
    return 1;
end

function Lua_HeroJewelryData:showSuitPropInfo(dic)
    local arr = Array();
    for k,v in pairs(dic) do
        local propVo = DataCenter.attributesUtil:createAttrVo(k);
    -- return propVo.show_name;
        local value = v;
        if propVo.isPercent == 1 then
            value = string.format("%.1f", value*100).."%";
        else
            value = Mathf.Floor(value+0.5);
        end
        -- print(k,"  show_name  ",propVo.show_name,"  showValue  ",value)
        arr:add({show_name = propVo.show_name,showValue = value,sort = propVo.sort})
    end

    arr:sort("sort", false);
    return arr;
end