-- 星魂Vo
checkRequire("Lua_JewelryRecastVo");
checkRequire("Lua_JewelrySuitConfigData");
checkRequire("Lua_JewelryBasePropCofingData");
Lua_heroJewelryVo = class("Lua_heroJewelryVo", Lua_ToolVo)
function Lua_heroJewelryVo:ctor(id,count)
    self:superCall("ctor", id,count);
end

function Lua_heroJewelryVo:fromServer(msg)
    self.force = msg.force;    -- 战力
    self.lock_info = msg.nail; -- 属性上锁
    self.suit_scheme_id = msg.suit_id;-- 方案id
    self._random_prop = msg.random_prop;-- 随机属性
    self._update_prop = msg.update_prop;-- 重铸后属性
    self.suit_activate_id = msg.suit_effect; --激活套装id
    -- print(msg.celebrity_uid,"  激活套装id = = ",msg.suit_effect)
    self.unique_id = tonumber(msg.unique_id);-- 星魂唯一ID
    self.recast_times = msg.recast_times; -- 出售返回数量
    self.celebrity_unique_id = tonumber(msg.celebrity_uid); -- 穿戴英雄唯一ID
end

-- 是否穿戴
function Lua_heroJewelryVo.Get:is_adorn()
    if self.celebrity_unique_id == nil or self.celebrity_unique_id == 0  then
        return false;
    end
    return true;
end

-- 是否显示按钮 图鉴用
function Lua_heroJewelryVo.Get:is_show_button()
    if self._is_show_button == nil then
        if self.unique_id == nil then
            return false;
        end
        return true;
    end
    return self._is_show_button;
end

-- 是否显示按钮 图鉴用
function Lua_heroJewelryVo.Set:is_show_button(val)
    self._is_show_button = val;
end

-- 是否拥有随机属性
function Lua_heroJewelryVo.Get:isOwnRandomProp()
    return self.quality >1;
end

-- 英雄名字
function Lua_heroJewelryVo.Get:celebrity_name()
    return self._celebrity_name;
end

function Lua_heroJewelryVo.Set:celebrity_name(val)
    self._celebrity_name = val;
end

-- 基础属性战力
function Lua_heroJewelryVo.Get:force()
    if self._force == nil then
        return self.baseForce;
    end
    return self._force;
end

function Lua_heroJewelryVo.Set:force(val)
    self._force = val;
end

-- 基础属性
function Lua_heroJewelryVo.Get:prop()
    if self._prop == nil then
        return self.base_prop_config;
    end
    return self._prop;
end

function Lua_heroJewelryVo.Set:prop(val)
    self._prop = val;
end

-- -- 是否出现在套装方案
function Lua_heroJewelryVo.Get:is_show_suit_scheme()
    if self.suitSchemeVo ~= nil then
        return true;
    end
    return false;
end

-- --显示套装方案名字
function Lua_heroJewelryVo.Get:suit_name()
    if self.suitSchemeVo == nil then
        return "";
    end
    return self.suitSchemeVo.suit_name;
end

function Lua_heroJewelryVo.Get:suitSchemeVo()
    return DataCenter.jewelrySuitData:getSuitSchemeByUniqueId(self.unique_id);
end

function Lua_heroJewelryVo.Get:random_prop()
    if self._random_prop == nil then
        return Array();
    end
    local arr = Array();
    local recastLockOne = DataCenter.heroJewelryData.recastLockOne;
    local recastLockTwo = DataCenter.heroJewelryData.recastLockTwo;
    for k,v in ipairs(self._random_prop) do
        list = {};
        local sort = 100;
        if recastLockOne ~= true and recastLockTwo == true then -- 第二条上锁
            if v.other == 1 then
                sort = 2;
            else
               sort = 1;
            end
        elseif recastLockOne == true and recastLockTwo ~= true then -- 第一条上锁
            if v.other == 1 then
                sort = 1;
            else
               sort = 2; 
            end
        end
        list.sort = sort;
        list.name = v.name;
        list.value = v.value;
        arr:add(list);
    end
    arr:sort("sort",false)
    return arr;
end

function Lua_heroJewelryVo.Get:update_prop()
    if self._update_prop == nil then
        return Array();
    end
    local arr = Array();
    local recastLockOne = DataCenter.heroJewelryData.recastLockOne;
    local recastLockTwo = DataCenter.heroJewelryData.recastLockTwo;
    for k,v in ipairs(self._update_prop) do
        list = {};
        local sort = 100;
        if recastLockOne ~= true and recastLockTwo == true then -- 第二条上锁
            if v.other == 1 then
                sort = 2;
            else
               sort = 1;
            end
        elseif recastLockOne == true and recastLockTwo ~= true then -- 第一条上锁
            if v.other == 1 then
                sort = 1;
            else
               sort = 2; 
            end
        end
        list.sort = sort;
        list.name = v.name;
        list.value = v.value;
        arr:add(list);
    end
    arr:sort("sort",false)
    return arr;

end





---------------------------------- Item配置 -------------------------------------------

--星魂对应系列图集
function Lua_heroJewelryVo.Get:jewelry_path()
    return "/images/jewelry/"..self.series_sprite..".png";
end

--星魂对应系列UI
function Lua_heroJewelryVo.Get:series_sprite()
    return self.config.series_sprite;
end

--获取星魂佩戴位置名字
function Lua_heroJewelryVo.Get:part_name()
    return Lua_heroTypeDefine.getJewelryPartName(self.part);
end

--获取星魂质量名字
function Lua_heroJewelryVo.Get:quality_name()
    return Lua_heroTypeDefine.getJewelryQualityName(self.quality);
end

function Lua_heroJewelryVo.Get:showColorName()
    return "[" .. self.colorStr .. "]".."【" .. self.quality_name .. "】"..self.name .. "[-]";
end

-- 质量
function Lua_heroJewelryVo.Get:quality()
    if self._quality == nil then
        return self.config.quality;
    end
    return self._quality;
end

function Lua_heroJewelryVo.Set:quality(val)
    self._quality = val
end

-- 系列
function Lua_heroJewelryVo.Get:series()
    return self.config.series;
end

-- 部位
function Lua_heroJewelryVo.Get:part()
    if self.config.part == nil then
        return 0;
    end
    return self.config.part;
end





---------------------------------- 属性 -------------------------------------------

-- 属性描述
function Lua_heroJewelryVo.Get:base_prop_config()
    return Lua_JewelryBasePropCofingData.getBasePropConfig(self.id);
end

-- 属性描述
function Lua_heroJewelryVo:getPropDes(name,value)
    local propVo = DataCenter.attributesUtil:createAttrVo(name);
    if propVo.isPercent == 1 then
        value = string.format("%.1f", value*100).."%";
    else
        value = Mathf.Floor(value+0.5);
    end
    return propVo.show_name.." : "..value;
end

-- 基础属性
function Lua_heroJewelryVo.Get:base_prop()
    return self:getPropDes(self.prop.name,self.prop.value);
end

-- Tips 展示 随机属性
function Lua_heroJewelryVo.Get:random_prop_des()
    local str = "";
    for i=1,2 do
        if str == "" then
            str = "";
        else
            str = str.."\n";
        end
        
        if self.random_prop[i] ~= nil then
            str = str..self:getPropDes(self.random_prop[i].name,self.random_prop[i].value)
        else
            if i == 1 then
                if self.quality == 1 then -- 良品
                    str = str..LanUtil.getValue(126530);
                elseif self.quality == 2 then-- 精品
                    str = str..LanUtil.getValue(126562);
                elseif self.quality == 3 then-- 极品
                    str = str..LanUtil.getValue(126562);
                end
            elseif i == 2 then
                if self.quality == 1 then -- 良品
                    str = str..LanUtil.getValue(126531);
                elseif self.quality == 2 then-- 精品
                    str = str..LanUtil.getValue(126531);
                elseif self.quality == 3 then-- 极品
                    str = str..LanUtil.getValue(126562);
                end
            end
        end
    end

    return str;
end

-- 基础属性
function Lua_heroJewelryVo.Get:change_base_prop()
    return self:getChangePropDes(self.prop.name,self.prop.value);
end

-- 星魂更换 展示 随机属性
function Lua_heroJewelryVo.Get:show_change_random_prop()
    if self.random_prop:getSize() == 0 then
        return LanUtil.getValue(20);
    end

    local str = "";
    for i=1,self.random_prop:getSize() do
       if str == "" then
            str = "";
        else
            str = str.."   ";
        end

        str = str..self:getChangePropDes(self.random_prop[i].name,self.random_prop[i].value)     
    end

    return str;
end

-- 星魂更换属性描述
function Lua_heroJewelryVo:getChangePropDes(name,value)
    local propVo = DataCenter.attributesUtil:createAttrVo(name);
    if propVo.isPercent == 1 then
        value = string.format("%.1f", value*100).."%";
    else
        value = Mathf.Floor(value+0.5);
    end
    return propVo.show_name.." "..value;
end

-- 套装总览属性
function Lua_heroJewelryVo.Get:suit_all_prop()
    local prop_list = {};
    prop_list[self.prop.name] = self.prop.value; -- 基础属性
    if self.random_prop:getSize() ~= 0 then -- 随机属性
        for i=1,self.random_prop:getSize() do
            if prop_list[self.random_prop[i].name] == nil then
                prop_list[self.random_prop[i].name] = self.random_prop[i].value;
            else
                prop_list[self.random_prop[i].name] = prop_list[self.random_prop[i].name] + self.random_prop[i].value;
            end
        end
    end
    return prop_list;
end


-- 出售数据
function Lua_heroJewelryVo.Get:sellItemInfo()
    local id = self.series*100 + self.quality*10 + self.star;
    local vo = DataCenter.heroJewelryUtil:getJewelrySellInfoById(id);
    return Lua_ToolVo.createToolVo(vo.item[1], self.recast_times);
end

-- 战力
function Lua_heroJewelryVo.Get:baseForce()
    return self.base_prop_config.baseForce;
end





---------------------------------- 属性Tips -------------------------------------------

-- 2件套装vo
function Lua_heroJewelryVo.Get:twoJewelrySuitVo()
    local suit_id = self.series * 100 + self.star * 10 + 2;
    return Lua_JewelrySuitConfigData.getJewelrySuitConfig(suit_id);
end

-- 4件套装vo
function Lua_heroJewelryVo.Get:fourJewelrySuitVo()
    local suit_id = self.series * 100 + self.star * 10 + 4;
    -- print(self.series,"  4件套装vo  ",self.star,"  4件套装vo  ",suit_id)
    return Lua_JewelrySuitConfigData.getJewelrySuitConfig(suit_id);
end

-- 激活套装vo
function Lua_heroJewelryVo.Get:activateJewelrySuitVo()
    if self.suit_activate_id == nil or self.suit_activate_id == 0 then
        return nil;
    end
    -- print("激活套装vo  -==",self.suit_activate_id)
    return Lua_JewelrySuitConfigData.getJewelrySuitConfig(self.suit_activate_id);
end

-- 激活套装个数
function Lua_heroJewelryVo.Get:activate_suit_num()
    local num;
    if self.suit_activate_id == 0 or self.suit_activate_id == nil then
        num = 1;
    else
        num = self.activateJewelrySuitVo.activate_num;
    end
    return num;
end

-- 背包套装名字描述
function Lua_heroJewelryVo.Get:pack_suit_tips_name()
    local vo = self.fourJewelrySuitVo;
    local num = vo.activate_num;
    return vo.name.."(1/"..num..")";
end

-- 套装tips描述
function Lua_heroJewelryVo.Get:suit_tips_name()
    local vo = self.fourJewelrySuitVo;
    local num = vo.activate_num;
    return vo.name.."("..self.activate_suit_num.."/"..num..")";
end

-- 套装2件tips属性
function Lua_heroJewelryVo.Get:suit_two_prop()
    local vo = self.twoJewelrySuitVo;
    local color = "[B0CFEA]";
    if self.activate_suit_num >= vo.activate_num then
        color = "[2FD733]";
    end
    return color..vo.prop_des;
end

-- 套装2件tips条件
function Lua_heroJewelryVo.Get:suit_two_condition()
    local vo = self.twoJewelrySuitVo;
    local color = "[B0CFEA]";
    if self.activate_suit_num >= vo.activate_num then
        color = "[2FD733]";
    end
    return color..vo.prop_condition_des;
end

--四件属性描述
function Lua_heroJewelryVo.Get:showFourPropDes()
    local vo = self.fourJewelrySuitVo;
    local des;
    if vo.type == 2 then
        des = vo.jewelrySuitSkillVo.name;
    elseif vo.type == 3 then
        des = LanUtil.formateStr(126540, tostring(vo.jewelrySuitSkillVo.name));
    else
        des = vo.prop_des;
    end
    return des;
end

-- 套装4件tips属性
function Lua_heroJewelryVo.Get:suit_four_prop()
    local color = "[B0CFEA]";
    if self.activate_suit_num >= self.fourJewelrySuitVo.activate_num then
        color = "[2FD733]";
    end

    return color..self.showFourPropDes;
end

-- 套装4件tips条件
function Lua_heroJewelryVo.Get:suit_four_condition()
    local vo = self.fourJewelrySuitVo;
    local color = "[B0CFEA]";
    if self.activate_suit_num >= vo.activate_num then
        color = "[2FD733]";
    end
    return color..vo.prop_condition_des;
end






---------------------------------- 功能vo实例化 -------------------------------------------

-- 重铸Vo
function Lua_heroJewelryVo.Get:jewelryRecastVo()
    return Lua_JewelryRecastVo.new(self.id,self.star,self.random_prop,self.update_prop);
end




---------------------------------- 权重排序 -------------------------------------------

-- 星魂更换排序
function Lua_heroJewelryVo.Get:changeSort()
    local weight = 0;
    if DataCenter.jewelrySuitData.change_suit_id ~= nil then -- 套装方案打开
        if self.is_show_suit_scheme == true then
            weight = 100000000000;
        else
            weight = 1000000000000;
        end
    else
        if self.is_adorn == true then
            weight = 100000000000;
        else
            weight = 1000000000000;
        end
    end
    if DataCenter.jewelrySuitData.select_jewelry_und ~= nil then
        if self.unique_id == DataCenter.jewelrySuitData.select_jewelry_und then
            weight = 10000000000000;
        end
    end

    weight = weight + self.star*10000000000+self.quality*1000000000 + self.force*1000 + self.series*10 + self.part;
    return weight;
end

-- 星魂图鉴排序
function Lua_heroJewelryVo.Get:atlasSort()
    if self._atlasSort == nil then
        self._atlasSort = self.series*1000 + self.star*100 + self.part;
    end
    return self._atlasSort;
end

-- 星魂背包排序
function Lua_heroJewelryVo.Get:packSort()
    if self._packSort == nil then
        self._packSort = self.star*10000000000+self.quality*1000000000 + self.force*1000 + self.series*10 + self.part;
    end
    return self._packSort;
end