-- 星魂重铸vo
checkRequire("Lua_JewelryRecastCostCofingData");
Lua_JewelryRecastVo = class("Lua_JewelryRecastVo")
function Lua_JewelryRecastVo:ctor(id,star,random_prop,update_prop)
    self.unique_id = tonumber(id);-- 星魂唯一ID
    self.star = star;-- 星级
    self.random_prop = random_prop;-- 随机属性
    self.update_prop = update_prop;-- 重铸后属性
end

---------------------------------- 重铸前属性 -------------------------------------------

-- 重铸前 是否拥有第一条属性
function Lua_JewelryRecastVo.Get:is_recast_one_prop()
    if self.random_prop[1] ~= nil then
        return true;
    end
    return false;
end

-- 重铸前 第一条属性名字段
function Lua_JewelryRecastVo.Get:recast_one_attr()
    return self.random_prop[1].name;
end

-- 重铸前 第一条属性名封装
function Lua_JewelryRecastVo.Get:recast_one_name()
    local propVo = DataCenter.attributesUtil:createAttrVo(self.recast_one_attr);
    return propVo.show_name;
end

-- 重铸前 第一条属性
function Lua_JewelryRecastVo.Get:recast_one_prop()
    return self.random_prop[1].value;
end

-- 重铸前 第一条属性展示
function Lua_JewelryRecastVo.Get:show_recast_one_prop()
    local value = self.recast_one_prop;
    local propVo = DataCenter.attributesUtil:createAttrVo(self.recast_one_attr);
    if propVo.isPercent == 1 then
        value = string.format("%.1f", value*100).."%";
    else
        value = Mathf.Floor(value);
    end
    return value;
end

-- 重铸前 第一条属性区间索引
function Lua_JewelryRecastVo.Get:recast_one_index()
    -- print(self.star,"重铸前 第一条属性区间索引  = =",self.recast_one_attr,"重铸前 第一条属性区间索引  = =",self.recast_one_prop)
    return DataCenter.heroJewelryUtil:getRandomInterval(self.star,self.recast_one_attr,self.recast_one_prop);
end

-- 重铸前 第一条属性条UI
function Lua_JewelryRecastVo.Get:recast_one_bar()
    return Lua_CelebrityTypeDefine.getJewelryBarSprite(self.recast_one_index);
end

-- 重铸前 第一条属性最大值
function Lua_JewelryRecastVo.Get:recast_one_max()
    local vo = DataCenter.heroJewelryUtil:getJewelryRandomVo(self.recast_one_attr);
    local value = vo.all_value;
    local max = value[self.star];
    return max[2];
end

-- 重铸前 第一条属性是否是最大值
function Lua_JewelryRecastVo.Get:is_recast_one_max()
    return DataCenter.heroJewelryUtil:isMaxValue(self.star,self.recast_one_attr,self.recast_one_prop);
end

-- 重铸前 是否拥有第二条属性
function Lua_JewelryRecastVo.Get:is_recast_two_prop()
    if self.random_prop[2] ~= nil then
        return true;
    end
    return false;
end

-- 重铸前 第二条属性名
function Lua_JewelryRecastVo.Get:recast_two_attr()
    return self.random_prop[2].name;
end

-- 重铸前 第二条属性名封装
function Lua_JewelryRecastVo.Get:recast_two_name()
    if self.is_recast_two_prop then
        local propVo = DataCenter.attributesUtil:createAttrVo(self.recast_two_attr);
        return propVo.show_name;
    end
    return LanUtil.getValue(126557);
end

-- 重铸前 第二条属性
function Lua_JewelryRecastVo.Get:recast_two_prop()
    if self.random_prop[2] ~= nil then
        return self.random_prop[2].value;
    end
    return 0;
end

-- 重铸前 第二条属性展示
function Lua_JewelryRecastVo.Get:show_recast_two_prop()
     -- Mathf.Floor(self.celebrityBasePropInfo[v] + 0.5);
    local value = self.recast_two_prop;
    local propVo = DataCenter.attributesUtil:createAttrVo(self.recast_two_attr);
    if propVo.isPercent == 1 then
        value = string.format("%.1f", value*100).."%";
    else
        value = Mathf.Floor(value);
    end
    return value;
end

-- 重铸前 第二条属性区间索引
function Lua_JewelryRecastVo.Get:recast_two_index()
    -- print(self.star,"重铸前 第二条属性区间索引  = =",self.recast_two_attr,"重铸前 第二条属性区间索引  = =",self.recast_two_prop)
    return DataCenter.heroJewelryUtil:getRandomInterval(self.star,self.recast_two_attr,self.recast_two_prop);
end

-- 重铸前 第二条属性条UI
function Lua_JewelryRecastVo.Get:recast_two_bar()
    return Lua_CelebrityTypeDefine.getJewelryBarSprite(self.recast_two_index);
end

-- 重铸前 第二条属性最大值
function Lua_JewelryRecastVo.Get:recast_two_max()
    local vo = DataCenter.heroJewelryUtil:getJewelryRandomVo(self.recast_two_attr);
    local value = vo.all_value;
    local max = value[self.star];
    return max[2];
end

-- 重铸前 第二条属性是否是最大值
function Lua_JewelryRecastVo.Get:is_recast_two_max()
    return DataCenter.heroJewelryUtil:isMaxValue(self.star,self.recast_two_attr,self.recast_two_prop);
end

-- 重铸前后两个属性字段是否相同
function Lua_JewelryRecastVo.Get:is_all_same_prop()
    if self.is_one_same_prop == true and self.is_two_same_prop == true then
        return true;
    end
    return false;
end

-- 重铸前后第一条属性字段是否相同
function Lua_JewelryRecastVo.Get:is_one_same_prop()
    if self.recast_one_attr == self.update_one_attr then
        return true;
    end
    return false;
end

-- 重铸前后第二条属性字段是否相同
function Lua_JewelryRecastVo.Get:is_two_same_prop()
    if self.recast_two_attr == self.update_two_attr then
        return true;
    end
    return false;
end

---------------------------------- 重铸后属性 -------------------------------------------

-- 重铸后 是否拥有第一条属性
function Lua_JewelryRecastVo.Get:is_update_one_prop()
    if self.update_prop[1] ~= nil then
        return true;
    end
    return false;
end

-- 重铸后 第一条属性名字段
function Lua_JewelryRecastVo.Get:update_one_attr()
    return self.update_prop[1].name;
end

-- 重铸后 第一条属性名封装
function Lua_JewelryRecastVo.Get:update_one_name()
	local str;
	if self.is_update_one_prop == true then
	    local propVo = DataCenter.attributesUtil:createAttrVo(self.update_one_attr);
	    str = propVo.show_name;
	else
		str = LanUtil.getValue(126556);
	end
	return str;
end

-- 重铸后 第一条属性
function Lua_JewelryRecastVo.Get:update_one_prop()
    return self.update_prop[1].value;
end

-- 重铸后 第一条属性展示
function Lua_JewelryRecastVo.Get:show_update_one_prop()
     -- Mathf.Floor(self.celebrityBasePropInfo[v] + 0.5);
    local value = self.update_one_prop;
    local propVo = DataCenter.attributesUtil:createAttrVo(self.update_one_attr);
    if propVo.isPercent == 1 then
        value = string.format("%.1f", value*100).."%";
    else
        value = Mathf.Floor(value);
    end
    return value;
end

-- 重铸后 第一条属性区间索引
function Lua_JewelryRecastVo.Get:update_one_index()
    -- print(self.star,"重铸后 第一条属性区间索引  = =",self.update_one_attr,"重铸后 第一条属性区间索引  = =",self.update_one_prop)
    return DataCenter.heroJewelryUtil:getRandomInterval(self.star,self.update_one_attr,self.update_one_prop);
end

-- 重铸后 第一条属性条UI
function Lua_JewelryRecastVo.Get:update_one_bar()
    -- print("重铸后 第一条属性条UI  = =",self.update_one_index)
    return Lua_CelebrityTypeDefine.getJewelryBarSprite(self.update_one_index);
end

-- 重铸后 第一条属性最大值
function Lua_JewelryRecastVo.Get:update_one_max()
    local vo = DataCenter.heroJewelryUtil:getJewelryRandomVo(self.update_one_attr);
    local value = vo.all_value;
    local max = value[self.star];
    return max[2];
end

-- 重铸后 第一条属性是否是最大值
function Lua_JewelryRecastVo.Get:is_update_one_max()
    return DataCenter.heroJewelryUtil:isMaxValue(self.star,self.update_one_attr,self.update_one_prop);
end

-- 重铸后 是否拥有第二条属性
function Lua_JewelryRecastVo.Get:is_update_two_prop()
    if self.update_prop[2] ~= nil then
        return true;
    end
    return false;
end

-- 重铸后 第二条属性名
function Lua_JewelryRecastVo.Get:update_two_attr()
    return self.update_prop[2].name;
end

-- 重铸后 第二条属性名封装
function Lua_JewelryRecastVo.Get:update_two_name()
	if self.is_recast_two_prop == true then
	    if self.is_update_two_prop then
	        local propVo = DataCenter.attributesUtil:createAttrVo(self.update_two_attr);
	        return propVo.show_name;
	    else
	    	return LanUtil.getValue(126556);
	    end
	else
		return LanUtil.getValue(126557);
	end
end

-- 重铸后 第二条属性
function Lua_JewelryRecastVo.Get:update_two_prop()
    if self.update_prop[2] ~= nil then
        return self.update_prop[2].value;
    end
    return 0;
end

-- 重铸后 第二条属性展示
function Lua_JewelryRecastVo.Get:show_update_two_prop()
     -- Mathf.Floor(self.celebrityBasePropInfo[v] + 0.5);
    local value = self.update_two_prop;
    local propVo = DataCenter.attributesUtil:createAttrVo(self.update_two_attr);
    if propVo.isPercent == 1 then
        value = string.format("%.1f", value*100).."%";
    else
        value = Mathf.Floor(value);
    end
    return value;
end

-- 重铸后 第二条属性区间索引
function Lua_JewelryRecastVo.Get:update_two_index()
    -- print(self.star,"重铸后 第二条属性区间索引  = =",self.update_two_attr,"重铸后 第二条属性区间索引  = =",self.update_two_prop)
    return DataCenter.heroJewelryUtil:getRandomInterval(self.star,self.update_two_attr,self.update_two_prop);
end

-- 重铸后 第二条属性条UI
function Lua_JewelryRecastVo.Get:update_two_bar()
    -- print("重铸后 第一条属性条UI  = =",self.update_two_index)
    return Lua_CelebrityTypeDefine.getJewelryBarSprite(self.update_two_index);
end

-- 重铸后 第二条属性最大值
function Lua_JewelryRecastVo.Get:update_two_max()
    local vo = DataCenter.heroJewelryUtil:getJewelryRandomVo(self.update_two_attr);
    local value = vo.all_value;
    local max = value[self.star];
    return max[2];
end

-- 重铸后 第二条属性是否是最大值
function Lua_JewelryRecastVo.Get:is_update_two_max()
    return DataCenter.heroJewelryUtil:isMaxValue(self.star,self.update_two_attr,self.update_two_prop);
end






---------------------------------- 重铸消耗 -------------------------------------------

-- 重铸消耗
function Lua_JewelryRecastVo.Get:recastCostCostConfig()
    return Lua_JewelryRecastCostCofingData.getRecastCostConfig(self.star);
end

-- 重铸消耗道具
function Lua_JewelryRecastVo.Get:recastCostCostInfo()
    return self.recastCostCostConfig.recastCostCostInfo;
end

-- 重铸上锁消耗
function Lua_JewelryRecastVo.Get:lockCostCostInfo() 
    return self.recastCostCostConfig.lockCostCostInfo;
end