-- 星魂套装
checkRequire("Lua_JewelrySuitSchemeVo"); -- 套装方案vo
Lua_JewelrySuitData = class("Lua_JewelrySuitData")
function Lua_JewelrySuitData:ctor()
	self:superCall("ctor");
	self.change_suit_id = nil; -- 要更换的套装id
    self.change_suit_part = nil; -- 要更换的套装部位
    self.select_jewelry_und = nil;
    self.tag_one_jewelry_change = nil; -- A方案到B方案 标记
    self.tag_one_celebrity_change = nil;-- A英雄到B英雄 标记
end

function Lua_JewelrySuitData:dispose()
	self.allSuitInfo = nil;
	self.change_suit_id = nil;
    self._jewelrySuitInfo = nil;
    self.change_suit_part = nil;
    self.select_jewelry_und = nil;
    self.tag_one_jewelry_change = nil;
    self.tag_one_celebrity_change = nil;
end

function Lua_JewelrySuitData.Get:jewelrySuitInfo() -- 套装数据
    if self._jewelrySuitInfo == nil then
        self._jewelrySuitInfo = {};
        local suit_free = DataCenter.heroJewelryUtil.jewelry_suit_free;
 		local suit_limit = DataCenter.heroJewelryUtil.jewelry_suit_limit;
 		for i=1,suit_limit do
            local vo = Lua_JewelrySuitSchemeVo.new(i);
            if i <= suit_free then
                vo.is_free = true;
            end
			self._jewelrySuitInfo[i] = vo;
		end
    end

    return self._jewelrySuitInfo;
end

function Lua_JewelrySuitData:fromServer50145006(msg)
    if msg == nil then
        return;
    end
    self.allSuitInfo = Array();
    local max_free = msg.max;
    for i=1,max_free do
        local vo = self.jewelrySuitInfo[i];
        vo.is_free = true;-- 免费开启的 方案
        self.allSuitInfo:add(vo);
    end

    local list = msg.suit_list;
    if list ~= nil and #list ~= 0 then
        for i,v in ipairs(list) do
            -- print("v.suit_id  == ",v.suit_id)
            local vo = self:getjewelrySuitVoById(v.suit_id);
            vo:fromServerInfo(v);
        end
    end
end

function Lua_JewelrySuitData:getjewelrySuitVoById(id)
    return self.jewelrySuitInfo[id];
end

function Lua_JewelrySuitData.Get:jewelrySuitList()
    local tag_num = 0;
    local arr = Array();
    for i,v in ipairs(self.jewelrySuitInfo) do
    	arr:add(v);
    	if v.is_free == false then
    		break;
    	end
    end
    return arr;
end

function Lua_JewelrySuitData.Get:getAllSuitInfo()
    if self.allSuitInfo ~= nil then
    	return self.allSuitInfo;
    end
    return Array();
end

-- 通过英雄唯一id获取套装vo
function Lua_JewelrySuitData:getSuitVoByUniqueId(unique_id)
    for i,v in ipairs(self.jewelrySuitInfo) do
        local jewelrySuitInfo = v.jewelrySuitInfo;
        if jewelrySuitInfo ~= nil then
            for j,value in pairs(jewelrySuitInfo) do
                if value.celebrity_unique_id == unique_id then
                    return v;
                end
            end
        end
    end
    return nil
end

---------------------------------- 套装界面数据 -------------------------------------------

-- 获取套装方案 vo
function Lua_JewelrySuitData:getSuitSchemeByUniqueId(unique_id)
    -- print("  获取装方案  ",unique_id)
    for i=1,self.getAllSuitInfo:getSize() do
        local list = self.getAllSuitInfo[i].jewelrySuitInfo;
        -- print(list,"  获取装方案  ",unique_id)
        if list ~= nil then
            for k,v in pairs(list) do
                -- print(v.unique_id,"  获取套装方案  ",unique_id)
                if v.unique_id == unique_id then
                    return self.getAllSuitInfo[i];
                end
            end
        end
    end
    return nil;
end

-- 英雄获取套装方案名字
function Lua_JewelrySuitData:getSuitSchemeName(suit_list)
    local suit_name = LanUtil.getValue(126579);-- 默认套装方案名字
	if suit_list == nil then
    	return suit_name;
    end
    for i=1,self.getAllSuitInfo:getSize() do
    	local tag_num = 0;
    	local list = self.getAllSuitInfo[i].jewelrySuitInfo;
    	for i = 1, 4 do
            if list ~= nil then
        		if suit_list[i] ~= nil and list[i] ~= nil then
        			if suit_list[i].unique_id == list[i].unique_id then
        				tag_num = tag_num +1;
        			end
        		elseif suit_list[i] == nil and list[i] == nil then
        			tag_num = tag_num + 1;
        		end
            end
    	end

    	if tag_num == 4 and self.getAllSuitInfo[i]._celebrity_name ~= "" then
    		suit_name = self.getAllSuitInfo[i].suit_name;
    		break;
    	end
    end
    return suit_name;
end

-- 英雄获取激活套装名
function Lua_JewelrySuitData:getActivateSuitName(suit_list)
    if suit_list == nil then
        return LanUtil.getValue(126577);
    end
    local isActivateAllSuit = false;
    local tag_num = 1;
    local list = {};
    local suit_activate_id;
    for k,v in pairs(suit_list) do
        suit_activate_id = v.suit_activate_id;
        if v.suit_activate_id ~= 0 then
            if v.activate_suit_num == 4 then
                isActivateAllSuit = true;
            end
            if list[v.suit_activate_id] == nil then
                list[v.suit_activate_id] = v.activateJewelrySuitVo.name;
            end
        end
    end

    local str = "";
    for k,v in pairs(list) do
        if str == "" then
            str = "";
        else
            str = str.."\n";
        end
        str = str..LanUtil.formateStr(126606, v,tostring(2));
        if isActivateAllSuit then
            str = str.."\n"..LanUtil.formateStr(126606, v,tostring(4));
        end
    end

    if str == "" then
        return LanUtil.getValue(126577);
    end

    return str;
end

-- 是否激活一整套
function Lua_JewelrySuitData:isActivateFourSuit(suit_list)
    if suit_list == nil then
        return false
    end
    local tag_num = 0;
    for k,v in pairs(suit_list) do
        if v.suit_activate_id ~= 0 then
            tag_num = tag_num +1;
        end  
    end
    if tag_num == 4 then
        return true;
    end
    return false;
end

-- 套装效果
function Lua_JewelrySuitData:suitPropInfoByList(suit_list)
    if suit_list == nil then
    	return LanUtil.getValue(126577);
    end
    local tag_list = {};
    local arr = Array();
    for i,v in pairs(suit_list) do
    	local suit_activate_id = v.suit_activate_id
    	if suit_activate_id ~= nil and suit_activate_id ~= 0 then
	    	if tag_list[suit_activate_id] == nil then
	    		tag_list[suit_activate_id] = suit_activate_id;
	    		arr:add(v);
	    	end
	    end
    end

    local prop_list = nil;
    local skill_des = "";
    local len = arr:getSize();

    if len == 0 then
    	return LanUtil.getValue(126577);
    else
    	prop_list = {};
    	for i=1,len do
    		local vo = arr[i].activateJewelrySuitVo;
            if vo.activate_num == 4 then
                if vo.type == 1 then
                    local vo_four = arr[i].twoJewelrySuitVo;
                    prop_list[vo_four.prop_name] = vo_four.prop_value;
                else
                    skill_des = "   "..vo.skill_name;
                    vo = arr[i].twoJewelrySuitVo;
                end
            end
    		if prop_list[vo.prop_name] == nil then
    			prop_list[vo.prop_name] = vo.prop_value;
    		else
    			prop_list[vo.prop_name] = prop_list[vo.prop_name] + vo.prop_value;
    		end
    	end
    end

    local show_des = self:getSuitPropDes(prop_list)..skill_des;
    return LanUtil.formateStr(126578, tostring(show_des));
end

-- 方案套装效果描述
function Lua_JewelrySuitData:showSuitPropDes(jewelrySuitSchemeVo)
    local list = jewelrySuitSchemeVo.suitIdDic;
    if list == nil or #list == 0 then
        return LanUtil.getValue(126577);
    end
    local prop_list = {};
    local skill_des = "";
    local vo;
    local suit_id;
    for i=1,#list do
        suit_id = list[i];
        vo = Lua_JewelrySuitConfigData.getJewelrySuitConfig(suit_id);
        if vo.activate_num == 4 then -- 四件套
            if vo.type == 1 then
                local vo_four = Lua_JewelrySuitConfigData.getJewelrySuitConfig(suit_id-2);
                prop_list[vo_four.prop_name] = vo_four.prop_value;
            else
                skill_des = "   "..vo.skill_name;
                vo = Lua_JewelrySuitConfigData.getJewelrySuitConfig(suit_id-2);
            end
        end
        if prop_list[vo.prop_name] == nil then
            prop_list[vo.prop_name] = vo.prop_value;
        else
            prop_list[vo.prop_name] = prop_list[vo.prop_name] + vo.prop_value;
        end
    end
    local show_des = self:getSuitPropDes(prop_list)..skill_des;
    return LanUtil.formateStr(126578, tostring(show_des));
end

-- 获取属性描述
function Lua_JewelrySuitData:getSuitPropDes(prop_list)
    local str = "";
    if prop_list ~= nil then
	    for k,v in pairs(prop_list) do
            local attrVo = DataCenter.attributesUtil:createAttrVo(k);
	    	local show_name = attrVo.show_name;
	    	if str == "" then
	    		str = "";
	    	else
	    		str = str.."   ";
	    	end
            local value = v;
            if attrVo.isPercent == 1 then
                value = (value *100).."%";
            end
	    	str = str..show_name.."+"..value;
	    end
	end
    return str;
end

-- 通过星魂UI获取方案数据
function Lua_JewelrySuitData:getSuitSchemeVo(unique_id)
    for i=1,self.getAllSuitInfo:getSize() do
        local jewelrySuitInfo = self.getAllSuitInfo[i].jewelrySuitInfo
        if jewelrySuitInfo ~= nil then
            for k,v in pairs(jewelrySuitInfo) do
                if v.unique_id == unique_id then
                    return self.getAllSuitInfo[i].id;
                end
            end
        end
    end
    return nil;
end

-- 获取 英雄身上星魂到方案数据
function Lua_JewelrySuitData:getShowSuitAdornTips(jewelrySuitSchemeVo)
    local arr = Array();
    local suit_info = jewelrySuitSchemeVo.jewelrySuitInfo;
    if suit_info ~= nil then
        for i,v in pairs(suit_info) do
            arr:add({jewelryVo = v,suit_name = jewelrySuitSchemeVo.suit_name});
        end
    end
    return arr;
end

-- 获取 方案穿戴到英雄身上 数据
function Lua_JewelrySuitData:getShowSuitSaveTipsTips(data, selectUniqueId)
    local arr = Array();
    local tag_id = data.celebrity_uid;
    local scheme_suit_info = data.jewelrySuitInfo;
    if scheme_suit_info ~= nil then
        for k,v in pairs(scheme_suit_info) do
            local unique_id = v.celebrity_unique_id;
            -- print(tag_id,"= = 方案穿戴到英雄身上 = =",unique_id,"= = 方案穿戴到英雄身上 = =",selectUniqueId)
            if unique_id ~= 0 and unique_id ~= selectUniqueId then
                local celebrityVo = DataCenter.celebrityData:getItemByUniqueId(unique_id);
                arr:add({jewelryVo = v,celebrityVo = celebrityVo});
            end
        end
    end
    return arr;
end

-- 获取 单个星魂 A方案到B方案数据
function Lua_JewelrySuitData:getOneShowSuitAdornTips(jewelryVo)
    local arr = Array();
    arr:add({jewelryVo = jewelryVo, suit_name = jewelryVo.suit_name});
    return arr;
end

-- 获取 单个星魂 A英雄到B英雄数据
function Lua_JewelrySuitData:getOneShowSuitSaveTipsTips(jewelryVo)
    local arr = Array();
    local celebrity_unique_id = jewelryVo.celebrity_unique_id;
    local celebrityVo = DataCenter.celebrityData:getItemByUniqueId(celebrity_unique_id);
    arr:add({jewelryVo = jewelryVo, celebrityVo = celebrityVo});
    return arr;
end