-- 英雄星魂 配置
checkRequire("Lua_JewelryShopVo");
checkRequire("Lua_JewelryBrandVo");
checkRequire("Lua_JewelryRandomConfigData");
Lua_heroJewelryUtil = class("Lua_heroJewelryUtil");
function Lua_heroJewelryUtil:ctor()
    self:superCall("ctor");
    self.selectStar = 0;
    self.selectTagButtonIndex = nil;
    self.selectShopTabIndex = nil;
    self.selectBrandIndex = 1;
end

function Lua_heroJewelryUtil:dispose()
    self.selectStar = 0;
    self.selectTagButtonIndex = nil;
    self.selectShopTabIndex = nil;
    self.tag_condition = nil;
    self.selectBrandIndex = 1;
end

---------------------------------- 星魂常量 -------------------------------------------

-- 星魂商店碎片道具id
function Lua_heroJewelryUtil.Get:jewelry_shop_show_id()
    if self._jewelry_shop_show_id == nil then
        self._jewelry_shop_show_id = getConfig({ "const","jewelry_shop_show_id","value"});
    end
    return self._jewelry_shop_show_id;
end

--商城消耗道具vo
function Lua_heroJewelryUtil.Get:cost_vo()
    if self._cost_vo == nil then
        self._cost_vo = Lua_ToolVo.new(self.jewelry_shop_show_id);
    end
    return self._cost_vo;
end 

-- 拥有碎片道具数量
function Lua_heroJewelryUtil.Get:have_item_num()
    return DataCenter.packData:getPackInfoByPackType(Lua_PackData.PROP_TAG):getItemNumById(self.jewelry_shop_show_id);
end

-- 商谈界面部分奖励道具展示
function Lua_heroJewelryUtil.Get:jewelryBrandShowInfo()
    if self._brandShowInfo == nil then
        self._brandShowInfo = Array();
        local list = getConfig({ "const","brand_show_items","jsonvalue"});
        for i,v in ipairs(list) do
            local tvo = Lua_ToolVo.createToolVo(tonumber(v));
            self._brandShowInfo:add(tvo);
        end
    end
    return self._brandShowInfo;
end

-- 商谈抽奖默认一抽
function Lua_heroJewelryUtil.Get:brand_draw_one()
    if self.draw_one_num == nil then
        self.draw_one_num = getConfig({ "const","brand_draw_one","value"});
    end

    return self.draw_one_num;
end

-- 商谈抽奖默认十连抽
function Lua_heroJewelryUtil.Get:brand_draw_ten()
    if self.draw_ten_num == nil then
        self.draw_ten_num = getConfig({ "const","brand_draw_ten","value"});
    end
    return self.draw_ten_num;
end

-- 星魂商谈保底次数
function Lua_heroJewelryUtil.Get:jewelry_draw_limit()
    if self.draw_limit == nil then
        self.draw_limit = getConfig({"const","jewelry_draw_limit","value"});
    end
    return self.draw_limit;
end

-- 星魂套装开启方案消耗
function Lua_heroJewelryUtil.Get:jewelry_suit_cost()
    if self.suit_cost == nil then
        self.suit_cost = getConfig({"const","jewelry_suit_cost","value"});
    end
    return self.suit_cost;
end

-- 星魂套装免费方案个数
function Lua_heroJewelryUtil.Get:jewelry_suit_free()
    if self.suit_free == nil then
        self.suit_free = getConfig({"const","jewelry_suit_free","value"});
    end
    return self.suit_free;
end

-- 星魂套装方案上限
function Lua_heroJewelryUtil.Get:jewelry_suit_limit()
    if self.suit_limit == nil then
        self.suit_limit = getConfig({"const","jewelry_suit_limit","value"});
    end
    return self.suit_limit;
end

-- 星魂套装方案上限
function Lua_heroJewelryUtil.Get:show_jewelry_random()
    if self._show_jewelry_random == nil then
        self._show_jewelry_random = getConfig({"const","show_jewelry_random","jsonvalue"});
    end
    return self._show_jewelry_random;
end




---------------------------------- 品质 表配置数据 -------------------------------------------

-- 星魂随机属性
function Lua_heroJewelryUtil:getJewelryRandomPropInfo(part)
        local jewelryRandomPropInfo = Array();
        local list = self.show_jewelry_random[part]
        for k,v in pairs(list) do
            local vo = Lua_JewelryRandomConfigData.getJewelryRandomConfig(v);
            jewelryRandomPropInfo:add(vo);
        end
        jewelryRandomPropInfo:sort("sort",false)

    return jewelryRandomPropInfo;
end

-- 星魂随机属性vo
function Lua_heroJewelryUtil:getJewelryRandomVo(attr_name)
    return Lua_JewelryRandomConfigData.getJewelryRandomConfig(attr_name);
end

-- 星魂属性是否是橙色区间最大值
function Lua_heroJewelryUtil:isMaxValue(star,attr_name,attr_value)
    local vo = self:getJewelryRandomVo(attr_name);
    local orange_info = vo.orange_value[star];
    local max = orange_info[2];
    if attr_value >= max then
        return true;
    end
    return false;
end

-- 星魂随机属性所在的区间索引
function Lua_heroJewelryUtil:getRandomInterval(star,attr_name,attr_value)
    local index = 1;
    for i=1, 4 do
        local val = self:isValueInterval(i,star,attr_name,attr_value);
        if val ~= nil then
            index = i;
            break;
        end
    end
    return index;
end

function Lua_heroJewelryUtil:isValueInterval(index, star, attr_name, attr_value)
    -- print(index,"   计算   ",star,"   计算    ",attr_name,"   计算    ",attr_value)
    local vo = self:getJewelryRandomVo(attr_name);
    local cur_value = attr_value - 0.00001;

    local green_info = vo.green_value[star];
    local blue_info = vo.blue_value[star];
    local purple_info = vo.purple_value[star];
    local orange_info = vo.orange_value[star];

    local min;
    local max;
    if index == 1 then 
        min = green_info[1];
        max = green_info[2];
        if cur_value >= min and cur_value < max then
            return max;
        end
    elseif index == 2 then
        min = blue_info[1];
        max = blue_info[2];
        if cur_value >= min and cur_value < max then
            return max;
        end
    elseif index == 3 then 
        min = purple_info[1];
        max = purple_info[2];
        if cur_value >= min and cur_value < max then
            return max;
        end
    elseif index == 4 then 
        min = orange_info[1];
        max = orange_info[2];
        if cur_value >= min and cur_value < max then
            return max;
        end
    end
    
    return nil;
end






---------------------------------- 星魂图鉴数据 -------------------------------------------

-- 星魂图鉴配置
function Lua_heroJewelryUtil.Get:jewelryAtlasInfo()
    if self.jewelryAtlasDic == nil then
        self.jewelryAtlasDic = {};
        local cfg = getConfig({"jewelry_atlas"});
        for k,v in pairs(cfg) do
            local vo = Lua_ToolVo.createToolVo(tonumber(v.jewelry_id));
            if self.jewelryAtlasDic[vo.series] == nil then
                self.jewelryAtlasDic[vo.series] = Array();
            end
            self.jewelryAtlasDic[vo.series]:add(vo);
        end
    end

    return self.jewelryAtlasDic;
end

-- 获取同星级星魂
function Lua_heroJewelryUtil:getJewelryAtlasVoBySeriesr(seriesr)
    local arr = self.jewelryAtlasInfo[seriesr];
    arr:sort("atlasSort",true);
    return arr;
end

-- 星魂图鉴页签
function Lua_heroJewelryUtil.Get:jewelryAtlasTabInfo()
    if self._jewelryAtlasTabInfo == nil then
        self._jewelryAtlasTabInfo = Array();
        local cfg = getConfig({ "jewelry_atlas_star"});
        for i,v in ipairs(cfg) do
            self._jewelryAtlasTabInfo:add({id = i,name = v.des});
        end
    end
    
    return self._jewelryAtlasTabInfo
end


---------------------------------- 星魂商店数据 -------------------------------------------

-- 星魂商店配置
function Lua_heroJewelryUtil:getJewelryShopInfo()
    if self._jewelryShopDic == nil then
        self._jewelryShopDic = {};
        self._jewelryShopInfo = {};
        local cfg = getConfig({ "jewelry_shop"});
        for k,v in pairs(cfg) do
            local vo = Lua_JewelryShopVo.new(k,v);
            local series = vo.itemVo.series;
            if series == nil then
                series = 1;
            end
            if self._jewelryShopDic[series] == nil then
                self._jewelryShopDic[series] = {};
            end
            self._jewelryShopDic[series][k] = vo;
            self._jewelryShopInfo[k] = vo;
        end
    end
end

-- 获取同星级星魂
function Lua_heroJewelryUtil:getJewelryShopVoBySeries(series)
    if self._jewelryShopDic == nil then
        self:getJewelryShopInfo();
    end
    local arr = Array();
    local list = self._jewelryShopDic[series];
    local condition = DataCenter.jewelryCopyData.chapterPassCount;-- 通关章
    if condition == nil then
        condition = 0;
    end
    if list ~= nil then
        for k,v in pairs(list) do
            if v.condition <= condition then
                arr:add(v);
            end
        end
        arr:sort("sort",false);
    end

    return arr;
end

-- 获取同星级星魂
function Lua_heroJewelryUtil:getJewelryShopVoById(id)
    if self._jewelryShopInfo == nil then
        self:getJewelryShopInfo();
    end

    return self._jewelryShopInfo[id];
end





---------------------------------- 商谈配置数据 -------------------------------------------

-- 星魂商谈配置
function Lua_heroJewelryUtil.Get:jewelryBrandConfig()
    if self._jewelryBrandConfig == nil then
        self._jewelryBrandConfig = {};
        local cfg = getConfig({ "jewel_draw"});
        for i,v in ipairs(cfg) do
            local vo = Lua_JewelryBrandVo.new(i,v);
            self._jewelryBrandConfig[i] = vo;
        end
    end
    return self._jewelryBrandConfig;
end

function Lua_heroJewelryUtil.Get:jewelryBrandInfo()
    local condition = DataCenter.jewelryCopyData.chapterPassCount;-- 通关章
    if self.tag_condition ~= condition then
        self.tag_condition = condition;
        self._jewelryBrandInfo = Array();
        local info = self.jewelryBrandConfig;
        for k,v in ipairs(info) do
            if condition >= v.condition then
                self._jewelryBrandInfo:add(v);
            end
        end
    end

    return self._jewelryBrandInfo;
end

function Lua_heroJewelryUtil.Get:showBrandMaxIndex()
    if self.jewelryBrandInfo == nil then
        return 1;
    end

    return self.jewelryBrandInfo:getSize();
end

-- 是否选择商谈品牌最大索引
function Lua_heroJewelryUtil:isSelectMaxIndex(index)
    if self.jewelryBrandConfig[index] == nil then
        return true;
    end
    return false;
end

-- 获取品牌数据
function Lua_heroJewelryUtil:getJewelryBrandVoById(id)
    if self.jewelryBrandConfig[id] ~= nil then
        return self.jewelryBrandConfig[id];
    end
    return nil;
end





---------------------------------- 星魂出售配置数据 -------------------------------------------

-- 星魂出售
function Lua_heroJewelryUtil:getJewelrySellInfoById(id)
    if self._jewelrySellConfig == nil then
       self._jewelrySellConfig = getConfig({ "jewelry_sell"});
    end
    return self._jewelrySellConfig[id];
end