-- 品牌商谈Vo
Lua_JewelryBrandVo = class("Lua_JewelryBrandVo")
function Lua_JewelryBrandVo:ctor(id, config)
    self.id = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig( { "jewel_draw", id });
    end
end

-- 名字
function Lua_JewelryBrandVo.Get:name()
    return self.config.name;
end

-- 消耗钻石
function Lua_JewelryBrandVo.Get:money_cost()
    return self.config.money_cost;
end

-- 单抽道具消耗
function Lua_JewelryBrandVo.Get:item_one_cost()
    return self.config.item_one_cost;
end

-- 十抽道具消耗
function Lua_JewelryBrandVo.Get:item_ten_cost()
    return self.config.item_ten_cost;
end

-- 条件
function Lua_JewelryBrandVo.Get:condition()
    return self.config.condition;
end

-- 图集名
function Lua_JewelryBrandVo.Get:atlas()
    return self.config.atlas;
end

-- UI名
function Lua_JewelryBrandVo.Get:sprite()
    return self.config.sprite;
end

-- 特效
function Lua_JewelryBrandVo.Get:effect()
    return self.config.effect;
end

-- 金币
function Lua_JewelryBrandVo.Get:gold_coin()
    return self.config.gold_coin;
end

-- 描述
function Lua_JewelryBrandVo.Get:des()
    return self.config.des;
end




---------------------------------- 商谈界面数据 -------------------------------------------

-- 消耗钻石vo
function Lua_JewelryBrandVo.Get:money_cost_vo()
    return Lua_ToolVo.new(Lua_ResourcesData.DIAMOND);
end

-- 单抽消耗钻石
function Lua_JewelryBrandVo.Get:money_cost_one()
    return self.money_cost[1];
end

-- 十抽消耗钻石
function Lua_JewelryBrandVo.Get:money_cost_ten()
    return self.money_cost[2];
end

-- 单抽信物消耗Vo
function Lua_JewelryBrandVo.Get:item_one_vo()
    local id = self.item_one_cost[1];
    return Lua_ToolVo.new(id);
end

-- 单抽消耗信物数量
function Lua_JewelryBrandVo.Get:item_one_num()
    return self.item_one_cost[2];
end

-- 十抽消耗信物Vo
function Lua_JewelryBrandVo.Get:item_ten_vo()
	local id = self.item_ten_cost[1];
    return Lua_ToolVo.new(id);
end

-- 十抽信物信物数量
function Lua_JewelryBrandVo.Get:item_ten_num()
    return self.item_ten_cost[2];
end

--单抽获得金币
function Lua_JewelryBrandVo.Get:one_gold_coin()
    return self.gold_coin[2]*DataCenter.heroJewelryUtil.brand_draw_one;
end

--十抽抽获得金币
function Lua_JewelryBrandVo.Get:ten_gold_coin()
    return self.gold_coin[2]*DataCenter.heroJewelryUtil.brand_draw_ten;
end

-- 物信是否够一次商谈
function Lua_JewelryBrandVo.Get:is_one_brand()
    local have_num = DataCenter.packData:getItemCount(self.item_one_cost[1]);
    if have_num >= self.item_one_cost[2] then
    	return true;
    end
    return false;
end

-- 物信是否够十次商谈
function Lua_JewelryBrandVo.Get:is_ten_brand()
	local have_num = DataCenter.packData:getItemCount(self.item_ten_cost[1]);
    if have_num >= self.item_ten_cost[2] then
    	return true;
    end
    return false;
end

-- 钻石是否够一次商谈
function Lua_JewelryBrandVo.Get:is_one_money()
    local have_num = DataCenter.packData:getItemCount(Lua_ResourcesData.DIAMOND);
    if have_num >= self.money_cost_one then
    	return true;
    end
    return false;
end

-- 钻石是否够十次商谈
function Lua_JewelryBrandVo.Get:is_ten_money()
	local have_num = DataCenter.packData:getItemCount(Lua_ResourcesData.DIAMOND);
    if have_num >= self.money_cost_ten then
    	return true;
    end
    return false;
end