-- 商品vo
Lua_JewelryShopVo = class("Lua_JewelryShopVo")
function Lua_JewelryShopVo:ctor(id, config)
    self.id = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig( { "jewelry_shop", id });
    end
end

-- 限购次数
function Lua_JewelryShopVo.Get:limit_num()
    if self._limit_num == nil then
        self._limit_num = 0;
    end
    return self.limit_bug_num - self._limit_num;
end

function Lua_JewelryShopVo.Set:limit_num(val)
    self._limit_num = val
end

-- 限购总次数
function Lua_JewelryShopVo.Get:limit_bug_num()
    if self.daily_bug_num ~= nil then
        return self.daily_bug_num;
    elseif self.week_bug_num ~= nil then
        return self.week_bug_num;
    end
    return nil;
end

-- 是否是特殊物品
function Lua_JewelryShopVo.Get:is_limit_item()
    if self.config.jewelry == 0 then
        return true;
    end
    return false;
end

-- 星魂id
function Lua_JewelryShopVo.Get:jewelry_id()
    return self.config.jewelry_id;
end

-- 购买消耗
function Lua_JewelryShopVo.Get:cost()
    return self.config.cost;
end

-- 每日限购次数
function Lua_JewelryShopVo.Get:daily_bug_num()
    return self.config.daily;
end

-- 每周限购次数
function Lua_JewelryShopVo.Get:week_bug_num()
    return self.config.week;
end

-- 显示条件
function Lua_JewelryShopVo.Get:condition()
    return self.config.condition;
end

--排序
function Lua_JewelryShopVo.Get:sort()
    if self.itemVo.series == nil then
        return 0;
    end
    return self.itemVo.series*1000 + self.itemVo.star*100 + self.itemVo.part;
end

-- 消耗道具id
function Lua_JewelryShopVo.Get:cost_id()
    return self.cost[1];
end

-- 消耗道具数量
function Lua_JewelryShopVo.Get:cost_num()
    return self.cost[2];
end


-- 消耗道具数量
function Lua_JewelryShopVo.Get:cost_vo()
    return Lua_ToolVo.new(self.cost_id);
end


function Lua_JewelryShopVo.Get:itemVo() -- Vo
    local vo = Lua_ToolVo.createToolVo(tonumber(self.jewelry_id));
    vo.quality = 0;
    vo.isShop = true;
    return vo;
end