
-- 英雄星魂套装配置
Lua_JewelrySuitConfigData = class("Lua_JewelrySuitConfigData");
function Lua_JewelrySuitConfigData.getJewelrySuitConfig(id)
	if Lua_JewelrySuitConfigData.getJewelrySuitConfigDic == nil then
		Lua_JewelrySuitConfigData.getJewelrySuitConfigDic = {};
	end

	id = tonumber(id);
	if Lua_JewelrySuitConfigData.getJewelrySuitConfigDic[id] == nil then
		local cfg = getConfig( { "jewelry_suit_prop", id });
	    if cfg == nil then
	    	LogManager.LogError("no jewelry_suit_prop-星魂套装表 id = " .. id, false);
	    	return nil;
	    end
		Lua_JewelrySuitConfigData.getJewelrySuitConfigDic[id] = Lua_JewelrySuitConfigData.new(id);
	end
	return Lua_JewelrySuitConfigData.getJewelrySuitConfigDic[id];
end

function Lua_JewelrySuitConfigData:ctor(id)
	self:superCall("ctor");
    self.id = tonumber(id);
    if self.config == nil then
	   self.config = getConfig({"jewelry_suit_prop", id});
    end
end

-- 激活需要件数
function Lua_JewelrySuitConfigData.Get:activate_num()
    return self.config.activate_num;
end

-- 套装名字
function Lua_JewelrySuitConfigData.Get:name()
    return self.config.name;
end

-- 套装效果 1 - 属性加成  2 - 特殊效果  3 - 特殊技能
function Lua_JewelrySuitConfigData.Get:type()
    return self.config.type;
end

-- 属性名
function Lua_JewelrySuitConfigData.Get:prop_name()
    return self.config.prop_name;
end

-- 属性数值
function Lua_JewelrySuitConfigData.Get:prop_value()
    return self.config.prop_value;
end

-- 属性描述
function Lua_JewelrySuitConfigData.Get:prop_des()
	if self.prop_name == nil then
		return "";
	end
    local propVo = DataCenter.attributesUtil:createAttrVo(self.prop_name);
    propVo.value = self.prop_value;
    return propVo.show_name.."+"..propVo.showValue;
end

-- 属性激活描述
function Lua_JewelrySuitConfigData.Get:prop_condition_des()
    return LanUtil.formateStr(126537,tostring(self.activate_num));
end

-- 特殊技能id
function Lua_JewelrySuitConfigData.Get:skill_id()
    return self.config.skill;
end

-- 技能VO
function Lua_JewelrySuitConfigData.Get:jewelrySuitSkillVo()
    return DataCenter.skillConfigData:getSkillVoById(tonumber(self.skill_id));
end

-- 特殊技能名字
function Lua_JewelrySuitConfigData.Get:skill_name()
	if self.type == 2 then
		return self.jewelrySuitSkillVo.name;
	else
	    return LanUtil.formateStr(126538,tostring(self.jewelrySuitSkillVo.name));
	end
end