-- 英雄布阵数据
checkRequire("Lua_HeroLineupVo"); -- 阵容vo
checkRequire("Lua_HeroConnectVo");
Lua_HeroLineupData = class("Lua_HeroLineupData");
function Lua_HeroLineupData:ctor()
    self:superCall("ctor");
    self:dispose();
end

function Lua_HeroLineupData:dispose()
    self._isLineuping = false;
    self.heroLineupDic = {};
    if self.connPopupArr == nil then
        self.connPopupArr = Array()
    else
        self.connPopupArr:clear()
    end
end

function Lua_HeroLineupData.Set:isLineuping(value)
    if self._isLineuping ~= value then
        self._isLineuping = value;
        if not value then
            DataCenter.popupWinManager:checkPopupWin();
        end
    end
end

function Lua_HeroLineupData.Get:isLineuping()
    return self._isLineuping;
end

function Lua_HeroLineupData:fromServer50114008(msg)
    if msg == nil or msg.lineup_list == nil then
        return;
    end

    for i = 1, #msg.lineup_list do
        self:addLineupInfo(msg.lineup_list[i]);
    end
end

function Lua_HeroLineupData:fromServer50114009(msg)
    if msg == nil or msg.lineup == nil then
        return;
    end

    self:addLineupInfo(msg.lineup);
end

--通知英雄布阵
function Lua_HeroLineupData:fromServer80114010(msg)
    if msg == nil or msg.lineup == nil then
        return;
    end

    for i = 1, #msg.lineup do
        self:addLineupInfo(msg.lineup[i]);
    end
end

function Lua_HeroLineupData:addLineupInfo(info)
    local vo = self:getLineupVo(info.lineup_type);
    vo:fromServer(info);
    Lua_MsgUtil.callFunc("UPDATE_HERO_LINEUP_INFO", info.lineup_type);
end

function Lua_HeroLineupData:getLineupVo(lineup_type, config)
    if self.heroLineupDic[lineup_type] == nil then
        self.heroLineupDic[lineup_type] = Lua_HeroLineupVo.new(lineup_type, config);
    end
    return self.heroLineupDic[lineup_type];
end










--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- 布阵上阵数量
function Lua_HeroLineupData:getLineupHeroNum(lineupType, lineupIdx)
    local vo = self:getLineupVo(lineupType)
    return vo:getHeroNumByLineupIdx(lineupIdx or 1)
end

-- 布阵上阵所有数量
function Lua_HeroLineupData:getLineupHeroTotalNum(lineupType)
    local vo = self:getLineupVo(lineupType)
    local num = 0
    for i = 1, vo.team_number do
        num = num + vo:getHeroNumByLineupIdx(i)
    end
    return num
end

-- 引导用 英雄所在分队 英雄站位
function Lua_HeroLineupData:getLineupHeroInfo(lineupType, heroId)
    local vo = self:getLineupVo(lineupType)
    local lineupIdx = 0
    local standIdx = 0
    if heroId then
        lineupIdx, standIdx = vo:getHeroStandIdxById(heroId)
    end
    return lineupIdx, standIdx
end

-- 引导用 获取对应索引位是否有神器
function Lua_HeroLineupData:getLineupArtifact(lineupType, lineupIdx, index)
    local vo = self:getLineupVo(lineupType)
    return vo:getArtifactId(lineupIdx, index)
end










--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- 布阵显示的场景
function Lua_HeroLineupData:getLineUpSceneId(lineupType)
    if lineupType == Lua_HeroUtil.LINEUP_MAIN_TYPE then
        return self:getFightLineupSceneId(DataCenter.mainLineData.curTemplateId);
    end
    
    local vo = self:getLineupVo(lineupType)
    return self:getFightLineupSceneId(vo.templateId);
end

-- 战斗布阵显示的场景
function Lua_HeroLineupData:getFightLineupSceneId(templateId)
    return Lua_FightTemplateConfigData.getConfigData(templateId).scene_id;
end










--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- 布阵战力
function Lua_HeroLineupData:calcLineupForce(lineupType, standArr)
    local force = 0;
    local heroVo;
    if lineupType == Lua_HeroUtil.LINEUP_EXPEDITION then
        for i = 1, standArr:getSize() do
            if standArr[i] > 0 then
                heroVo = DataCenter.expeditionData:getLineupHeroVo(standArr[i]);
                if heroVo then
                    force = force + heroVo.heroForce;
                end
            end
        end
    elseif lineupType == Lua_HeroUtil.LINEUP_INFINITYHALL_TEAM then
        local vo = DataCenter.infinityHallData.chooseHeroVo
        for i = 1, standArr:getSize() do
            if standArr[i] > 0 then
                if vo and vo.unique_id == standArr[i] then
                    force = force + vo.heroForce;
                else
                    heroVo = DataCenter.heroData:getItemByUniqueId(standArr[i]);
                    if heroVo then
                        force = force + heroVo.heroForce;
                    end
                end
            end
        end        
    else
        for i = 1, standArr:getSize() do
            if standArr[i] > 0 then
                heroVo = DataCenter.heroData:getItemByUniqueId(standArr[i]);
                if heroVo then
                    force = force + heroVo.heroForce;
                end
            end
        end
    end
    return force;
end

-- 空站位
function Lua_HeroLineupData:getNullStandIdx(standType, lineupDic, lineupIdx)
    local list = DataCenter.heroLineupUtil:getStandListByType(standType);
    local arr = lineupDic[lineupIdx];
    local standIdx;
    for i = 1, #list do
        standIdx = list[i];
        if arr[standIdx] == 0 then
            return standIdx
        end
    end
    return nil;
end

-- 是否修改布阵
function Lua_HeroLineupData:checkLineupIsChange(lineupIdx, serverDic, localDic)
    if serverDic == nil or localDic == nil then
        return false;
    end

    local arr = serverDic[lineupIdx]
    for i = 1, arr:getSize() do
        if localDic[lineupIdx][i] ~= arr[i] then
            return true
        end
    end
    return false;
end

-- 是否修改站位类型
function Lua_HeroLineupData:checkTandTypeIsChange(lineupIdx, serverDic, localDic)
    if serverDic == nil or localDic == nil then
        return false;
    end

    if serverDic[lineupIdx] ~= localDic[lineupIdx] then
        return true;
    end
    
    return false;
end

-- 获得未上阵的神器
function Lua_HeroLineupData:getUnWearArtifact(artifactDic, lineupIdx)
    if artifactDic then
        local arr = DataCenter.artifactUtil:getArtifactList();
        local vo;
        for i = 1, arr:getSize() do
            vo = DataCenter.artifactUtil:getArtifactVoById(arr[i]);
            if vo.is_activate == 1 and self:getArtifactLineupIdx(artifactDic[lineupIdx], vo.id) == nil then
                return vo.id;
            end
        end
    end
    return nil;
end

-- 神器所在队伍
function Lua_HeroLineupData:getArtifactLineupIdx(artifactArr, artifactId)
    if artifactArr then
        for i = 1, artifactArr:getSize() do
            if artifactArr[i] == artifactId then
                return i;
            end
        end
    end
    return nil
end

function Lua_HeroLineupData:checkStandIdxIsLock(stand_type, standIdx)
    local info = DataCenter.heroLineupUtil:getStandInfoByType(stand_type)
    if info and info.unlock_list then
        local id
        for i = 1, #info.unlock_list do
            id = info.unlock_list[i][2]
            if info.unlock_list[i][1] == standIdx and id > 0 and not DataCenter.mainLineData:getCheckpointIsCompleted(id) then
                return id
            end
        end
    end
    return nil
end










--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- 英雄列表
function Lua_HeroLineupData:getHeroList(campType, careerType, lineup_type, lineup_index, sortType)
    local arr = Array();

    local uidArr = DataCenter.heroData.heroUidArr;
    local heroVo;
    for i = 1, uidArr:getSize() do
        heroVo = DataCenter.heroData:getItemByUniqueId(uidArr[i]);
        if heroVo and (campType == 0 or heroVo.campType == campType) and (careerType == 0 or heroVo.career == careerType) then
            arr:add(heroVo.unique_id);
        end
    end

    if sortType == 1 then
        self:heroListSortByForce(arr)
    else
        arr:sortf(self, self.heroListSortFun, { lineup_type = lineup_type, lineup_index = lineup_index })
    end
    return arr
end

-- 英雄列表
function Lua_HeroLineupData:getHeroListByCampDic(campType, careerType, campDic, lineup_type, lineup_index, sortType)
    local arr = Array();
    local uidArr = DataCenter.heroData.heroUidArr;
    local heroVo;
    for i = 1, uidArr:getSize() do
        heroVo = DataCenter.heroData:getItemByUniqueId(uidArr[i]);
        if heroVo and (campType == 0 or heroVo.campType == campType) and campDic[heroVo.campType] and (careerType == 0 or heroVo.career == careerType) then
            arr:add(heroVo.unique_id);
        end
    end
    if sortType == 1 then
        self:heroListSortByForce(arr);
    else
        arr:sortf(self, self.heroListSortFun, { lineup_type = lineup_type, lineup_index = lineup_index })
    end
    return arr;
end

function Lua_HeroLineupData:heroListSortByForce(arr)
    local len = arr:getSize();
    for i = 1, len do
        for j = i + 1, len do
            local a = DataCenter.heroData:getItemByUniqueId(arr[i]);
            local b = DataCenter.heroData:getItemByUniqueId(arr[j]);
            if a.heroForce < b.heroForce then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end

function Lua_HeroLineupData:heroListSortFun(a, b, param)
    a = DataCenter.heroData:getItemByUniqueId(a)
    b = DataCenter.heroData:getItemByUniqueId(b)
    local _a = a:lineupSort(param.lineup_type, param.lineup_index)
    local _b = b:lineupSort(param.lineup_type, param.lineup_index)
    if _a < _b then
        return false
    elseif _a == _b then
        if a.star < b.star then
            return false
        elseif a.star == b.star then
            if a.level < b.level then
                return false
            elseif a.level == b.level then
                if a.color < b.color then
                    return false
                elseif a.color == b.color then
                    if a.sort > b.sort then
                        return false
                    end
                end
            end
        end
    end
    return true
end

-- 一键上阵英雄
function Lua_HeroLineupData:setHeroOneKey(stand_type, lineupDic, lineupIdx, lineup_type, arr, limit_num)
    -- 优先上阵战力最高的5个英雄，根据战力高低决定上阵先后顺序（战力高的优先）
    if arr == nil then
        arr = self:getHeroList(0, 0, lineup_type, lineupIdx, 1);
    end
    local len = arr:getSize();
    if len <= 0 then
        return;
    end

    local list = DataCenter.heroLineupUtil:getStandListByType(stand_type)
    local need_num = #list; --需要上阵数量
    if limit_num ~= nil then
        need_num = limit_num;
    end

    local standArr = lineupDic[lineupIdx]
    -- local lineup_num = 0
    -- for i = 1, standArr:getSize() do
    --     if standArr[i] > 0 then
    --         lineup_num = lineup_num + 1
    --     end
    -- end
    -- if lineup_num >= need_num then --上满阵
    --     return;
    -- end
    -- need_num = need_num - lineup_num;
    for i = 1, standArr:getSize() do -- 一键上阵，需要卸下当前所有英雄再重新上阵
        standArr[i] = 0
    end

    local heroVo;
    local existDic = {}; --已上阵英雄
    for i = 1, #lineupDic do
        standArr = lineupDic[i]
        for j = 1, standArr:getSize() do
            if standArr[j] > 0 then
                heroVo = DataCenter.heroData:getItemByUniqueId(standArr[j])
                if heroVo then
                    existDic[heroVo.id] = j;
                end
            end
        end
    end

    -- 1坦克、2战士：优先前排→中排→后排
    -- 3辅助、4控制：优先后排→中排→前排
    -- 靠左的空位优先
    local posDic = {}
    local standIdx
    for i = 1, #list do
        standIdx = list[i]
        posDic[standIdx] = 1
    end
    function setHero(min, max, vo)
        for j = min, max do
            if posDic[j] == 1 and existDic[vo.id] == nil and standArr[j] == 0 then
                existDic[vo.id] = j
                standArr[j] = vo.unique_id
                need_num = need_num - 1
                return true
            end
        end
        return false
    end
    
    standArr = lineupDic[lineupIdx]
    for i = 1, len do
        heroVo = DataCenter.heroData:getItemByUniqueId(arr[i])
        if existDic[heroVo.id] == nil then
            if heroVo and (heroVo.career == 1 or heroVo.career == 2) then
                for j = 1, #list do
                    standIdx = list[j]
                    if standArr[standIdx] == 0 then
                        existDic[heroVo.id] = standIdx;
                        standArr[standIdx] = arr[i];
                        need_num = need_num - 1;
                        break
                    end
                end
            else
                local bSet = setHero(8, 10, heroVo) -- 后排
                if not bSet then
                    setHero(4, 7, heroVo) -- 中排
                end
                if not bSet then
                    setHero(1, 3, heroVo) -- 前排
                end
            end
        end

        if need_num <= 0 then
            return
        end
    end
    
    -- for i = 1, #list do
    --     standIdx = list[i];
    --     if standArr[standIdx] == 0 then
    --         for j = 1, len do
    --             heroId = DataCenter.heroData:getItemByUniqueId(arr[j]).id;
    --             if existDic[heroId] == nil then
    --                 existDic[heroId] = standIdx;
    --                 standArr[standIdx] = arr[j];
    --                 need_num = need_num - 1;
    --                 break;
    --             end
    --         end
    --     end

    --     if need_num <= 0 then
    --         break;
    --     end
    -- end
end

-- 判断是否拥有可上阵英雄（与已上阵相同的重复英雄筛除）
function Lua_HeroLineupData:checkPackHaveHero(lineupDic, list)
    local existDic = {} --已上阵英雄
    local uniqueId
    local heroId
    for i = 1, #lineupDic do
        for j = 1, lineupDic[i]:getSize() do
            uniqueId = lineupDic[i][j]
            if uniqueId > 0 then
                heroId = DataCenter.heroData:getItemByUniqueId(uniqueId).id
                existDic[heroId] = j;
            end
        end
    end

    if list == nil then
        list = DataCenter.heroData.heroUidArr
    end
    local len
    if list.typeof and list:typeof() == "Array" then
        len = list:getSize()
    else
        len = #list
    end
    for i = 1, len do
        heroId = DataCenter.heroData:getItemByUniqueId(list[i]).id
        if existDic[heroId] == nil then
            return true
        end
    end
    return false
end










--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- 站位类型改变更新新的站位
function Lua_HeroLineupData:updateStandByType(lineupDic, lineupIdx, prev_stand_type, cur_stand_type)
    -- 1、当前位类型站位信息的索引
    -- 2、通过索引更新变化的站位类型的站位信息
    local arr = lineupDic[lineupIdx]
    local tab = {}
    for i = 1, arr:getSize() do
        if arr[i] > 0 then
            tab[i] = arr[i]
        end
        arr[i] = 0
    end

    local index
    local new_stand
    for standIdx, uniqueId in pairs(tab) do
        index = DataCenter.heroLineupUtil:getIndexByStand(prev_stand_type, standIdx)
        new_stand = DataCenter.heroLineupUtil:getStandByIndex(cur_stand_type, index)
        lineupDic[lineupIdx][new_stand] = uniqueId
    end
end

-- 站位改变
function Lua_HeroLineupData:updateStandChange(standArr, uniqueId, new_stand, lineup_type, sceneId, stand_type)
    local prev_stand = nil; -- 旧位置
    local change_uid = nil; -- 新位置的英雄
    for i = 1, standArr:getSize() do
        if standArr[i] == uniqueId then
            prev_stand = i;
        end
        if standArr[i] > 0 and i == new_stand then
            change_uid = standArr[i];
        end
    end

    if prev_stand == nil then return; end

    if lineup_type == Lua_HeroUtil.LINEUP_STORY and new_stand <= 0 then
        if DataCenter.newHeroActData:checkLeadHero(uniqueId) == true then
            OperateAlert.showLangValue(126321);
            return;
        end
    end

    if new_stand <= 0 then
        standArr[prev_stand] = 0;
    else
        if self:checkStandIdxIsLock(stand_type, new_stand) then
            change_uid = uniqueId;
            standArr[new_stand] = 0;
        else
            standArr[new_stand] = uniqueId;
        end
    end

    if change_uid == nil or change_uid <= 0 then
        standArr[prev_stand] = 0;
    else
        local vo = DataCenter.heroLineupData:getLineupVo(lineup_type)
        local modelPosX = Lua_FightCampPosConfig.getConfigData(vo.campposId):getPosxByIdx(Lua_FightDefine.FIGHT_ATTACKER, prev_stand);
        local modelPosY = 0;
        local modelPosZ = Lua_FightCampPosConfig.getConfigData(vo.campposId):getPoszByIdx(Lua_FightDefine.FIGHT_ATTACKER, prev_stand);

        local heroModel = DataCenter.thingData:getThingPlayer(sceneId, 0, change_uid);
        heroModel.player:setActive(false)
        heroModel.player:setActive(true)
        heroModel.player:setPosPoint(modelPosX, modelPosY, modelPosZ, true);
        heroModel.player.data.formationPos = prev_stand;

        standArr[prev_stand] = change_uid;
    end
end










--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- 外部数据 arr[1] = camp
function Lua_HeroLineupData:getAureoleInfoByArr(arr)
    local tab = {};
    local campType;
    for i = 1, arr:getSize() do
        campType = arr[i];
        if tab[campType] == nil then
            tab[campType] = 1;
        else
            tab[campType] = tab[campType] + 1;
        end
    end
    return tab;
end

-- 站位
function Lua_HeroLineupData:getAureoleInfo(lineupType, standArr)
    local tab = {};
    function setCampType(vo)
        if tab[vo.campType] == nil then
            tab[vo.campType] = 1;
        else
            tab[vo.campType] = tab[vo.campType] + 1;
        end
    end

    local heroVo;
    if lineupType == Lua_HeroUtil.LINEUP_EXPEDITION then
        for i = 1, standArr:getSize() do
            if standArr[i] > 0 then
                heroVo = DataCenter.expeditionData:getLineupHeroVo(standArr[i]);
                if heroVo then
                    setCampType(heroVo)
                end
            end
        end
    elseif lineupType == Lua_HeroUtil.LINEUP_INFINITYHALL_TEAM then
        local vo = DataCenter.infinityHallData.chooseHeroVo
        for i = 1, standArr:getSize() do
            if standArr[i] > 0 then
                if vo and vo.unique_id == standArr[i] then
                    setCampType(vo)
                else
                    heroVo = DataCenter.heroData:getItemByUniqueId(standArr[i]);
                    if heroVo then
                        setCampType(heroVo)
                    end
                end
            end
        end        
    else
        for i = 1, standArr:getSize() do
            if standArr[i] > 0 then
                heroVo = DataCenter.heroData:getItemByUniqueId(standArr[i]);
                if heroVo then
                    setCampType(heroVo)
                end
            end
        end
    end
    return tab;
end

-- 结构体名：ProtoShowHero
function Lua_HeroLineupData:getAureoleInfoByHeroList(list)
    local tab = {};
    if list ~= nil then
        local heroVo;
        for i = 1, #list do
            heroVo = Lua_HeroVo.new(list[i].hero_id);
            if tab[heroVo.campType] == nil then
                tab[heroVo.campType] = 1;
            else
                tab[heroVo.campType] = tab[heroVo.campType] + 1;
            end
        end
    end
    return tab;
end

-- list[hero_id]
function Lua_HeroLineupData:getAureoleInfoByHeroTab(heroTab)
    local tab = {};
    local heroVo;
    for hid, v in pairs(heroTab) do
        heroVo = Lua_HeroVo.new(hid);
        if tab[heroVo.campType] == nil then
            tab[heroVo.campType] = 1;
        else
            tab[heroVo.campType] = tab[heroVo.campType] + 1;
        end
    end
    return tab;
end










--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function Lua_HeroLineupData:checkConnectByLineup(lineupType, lineupIdx, connectId)
    local vo = self:getLineupVo(lineupType)
    local connVo = vo:checkConnectIsActivate(lineupIdx, connectId)
    if connVo == nil then
        return false, Lua_HeroConnectVo.new(connectId)
    end
    return true, connVo
end

-- list：ProtoShowHero
function Lua_HeroLineupData:checkConnectByProto(list, connectId)
    local obj
    local config
    local heroDic = {}
    local campDic = {}
    local careerDic = {}
    for i = 1, #list do
        obj = list[i]
        if obj.hero_id and tonumber(obj.hero_id) > 0 then
            config = Lua_HeroConfigData.getConfig(obj.hero_id)
            if config == nil then
                config = Lua_MonsterConfigData.getMonsterConfig(obj.hero_id)
                config = Lua_HeroConfigData.getConfig(config.heroId)
            end

            heroDic[config.id] = config.id
            if campDic[config.camp] == nil then
                campDic[config.camp] = Array()
            end
            campDic[config.camp]:add(config.id)

            if careerDic[config.career] == nil then
                careerDic[config.career] = Array()
            end
            careerDic[config.career]:add(config.id)
        end
    end
    return self:checkConnect(heroDic, campDic, careerDic, connectId)
end

function Lua_HeroLineupData:checkConnectByConfig(list, connectId)
    local config
    local heroDic = {}
    local campDic = {}
    local careerDic = {}
    for i = 1, #list do
        config = Lua_MonsterConfigData.getMonsterConfig(list[i][1])
        if config then
            config = Lua_HeroConfigData.getConfig(config.heroId)

            heroDic[config.id] = config.id
            if campDic[config.camp] == nil then
                campDic[config.camp] = Array()
            end
            campDic[config.camp]:add(config.id)

            if careerDic[config.career] == nil then
                careerDic[config.career] = Array()
            end
            careerDic[config.career]:add(config.id)
        end
    end
    return self:checkConnect(heroDic, campDic, careerDic, connectId)
end

function Lua_HeroLineupData:checkConnect(heroDic, campDic, careerDic, connectId)
    local connVo = Lua_HeroConnectVo.new(connectId)
    connVo:setData(heroDic, campDic, careerDic)
    heroDic = nil
    campDic = nil
    careerDic = nil
    return connVo.isActivate, connVo
end

function Lua_HeroLineupData:getConnectArrByLineup(lineupType, lineupIdx)
    local activateNum = 0
    local data = Array()
    local vo = self:getLineupVo(lineupType)
    local arr = vo.lineupDic[lineupIdx]
    local heroDic = {}
    local campDic = {}
    local careerDic = {}
    local heroVo
    local len = arr:getSize()
    for i = 1, len do
        if arr[i] > 0 then
            if lineupType == Lua_HeroUtil.LINEUP_EXPEDITION then
                heroVo = DataCenter.expeditionData:getLineupHeroVo(arr[i])
            elseif lineupType == Lua_HeroUtil.LINEUP_INFINITYHALL_TEAM then
                heroVo = DataCenter.infinityHallData.chooseHeroVo
                if heroVo == nil or heroVo.unique_id ~= arr[i] then
                    heroVo = DataCenter.heroData:getItemByUniqueId(arr[i])
                end
            else
                heroVo = DataCenter.heroData:getItemByUniqueId(arr[i])
            end

            heroDic[heroVo.id] = heroVo.id
            if campDic[heroVo.campType] == nil then
                campDic[heroVo.campType] = Array()
            end
            campDic[heroVo.campType]:add(heroVo.id)

            if careerDic[heroVo.career] == nil then
                careerDic[heroVo.career] = Array()
            end
            careerDic[heroVo.career]:add(heroVo.id)
        end
    end

    local connVo
    for i = 1, len do
        if arr[i] > 0 then
            if lineupType == Lua_HeroUtil.LINEUP_EXPEDITION then
                heroVo = DataCenter.expeditionData:getLineupHeroVo(arr[i])
            elseif lineupType == Lua_HeroUtil.LINEUP_INFINITYHALL_TEAM then
                heroVo = DataCenter.infinityHallData.chooseHeroVo
                if heroVo == nil or heroVo.unique_id ~= arr[i] then
                    heroVo = DataCenter.heroData:getItemByUniqueId(arr[i])
                end
            else
                heroVo = DataCenter.heroData:getItemByUniqueId(arr[i])
            end

            if heroVo and heroVo.connectId > 0 then
                connVo = Lua_HeroConnectVo.new(heroVo.connectId)
                connVo:setData(heroDic, campDic, careerDic)
                if connVo.isActivate then
                    activateNum = activateNum + 1
                end
                data:add(connVo)
            end
        end
    end

    heroDic = nil
    campDic = nil
    careerDic = nil

    data:sort("sortIdx", false)
    return activateNum, data
end

function Lua_HeroLineupData:getConnectArrByConfig(list, lineupIdx)
    local activateNum = 0
    local data = Array()
    local config
    local heroDic = {}
    local campDic = {}
    local careerDic = {}
    local connDic = {}
    list = list[lineupIdx]
    for i = 1, #list do
        config = Lua_MonsterConfigData.getMonsterConfig(list[i][1])
        if config then
            config = Lua_HeroConfigData.getConfig(config.heroId)

            heroDic[config.id] = config.id
            if campDic[config.camp] == nil then
                campDic[config.camp] = Array()
            end
            campDic[config.camp]:add(config.id)

            if careerDic[config.career] == nil then
                careerDic[config.career] = Array()
            end
            careerDic[config.career]:add(config.id)
        end
    end

    local connVo
    for i = 1,  #list do
        config = Lua_MonsterConfigData.getMonsterConfig(list[i][1])
        if config then
            config = Lua_HeroConfigData.getConfig(config.heroId)
            if config.connect_id > 0 and connDic[config.connect_id] == nil then
                connVo = Lua_HeroConnectVo.new(config.connect_id)
                connVo:setData(heroDic, campDic, careerDic)
                if connVo.isActivate then
                    activateNum = activateNum + 1
                end
                connDic[config.connect_id] = 1
                data:add(connVo)
            end
        end
    end

    heroDic = nil
    campDic = nil
    careerDic = nil
    connDic = nil

    data:sort("sortIdx", false)
    return activateNum, data
end

function Lua_HeroLineupData:getConnectArrByProto(list)
    local activateNum = 0
    local data = Array()
    local config
    local heroDic = {}
    local campDic = {}
    local careerDic = {}
    for i = 1, #list do
        obj = list[i]
        if obj.hero_id and tonumber(obj.hero_id) > 0 and obj.blood > 0 then
            config = Lua_HeroConfigData.getConfig(obj.hero_id)
            if config == nil then
                config = Lua_MonsterConfigData.getMonsterConfig(obj.hero_id)
                config = Lua_HeroConfigData.getConfig(config.heroId)
            end

            heroDic[config.id] = config.id
            if campDic[config.camp] == nil then
                campDic[config.camp] = Array()
            end
            campDic[config.camp]:add(config.id)

            if careerDic[config.career] == nil then
                careerDic[config.career] = Array()
            end
            careerDic[config.career]:add(config.id)
        end
    end

    local connVo
    for i = 1, #list do
        obj = list[i]
        if obj.hero_id and tonumber(obj.hero_id) > 0 and obj.blood > 0 then
            config = Lua_HeroConfigData.getConfig(obj.hero_id)
            if config == nil then
                config = Lua_MonsterConfigData.getMonsterConfig(obj.hero_id)
                config = Lua_HeroConfigData.getConfig(config.heroId)
            end

            if config.connect_id > 0 then
                connVo = Lua_HeroConnectVo.new(config.connect_id)
                connVo:setData(heroDic, campDic, careerDic)
                if connVo.isActivate then
                    activateNum = activateNum + 1
                end
                data:add(connVo)
            end
        end
    end

    heroDic = nil
    campDic = nil
    careerDic = nil

    data:sort("sortIdx", false)
    return activateNum, data
end

function Lua_HeroLineupData:addConnPopupWin(vo)
    if self.connPopupArr:indexOf(vo) == -1 then
        self.connPopupArr:add(vo)
    end
end

function Lua_HeroLineupData:checkConnPopupWin()
    local len = self.connPopupArr:getSize()
    if len > 0 then
        Lua_WindowUtil.openWin("Lua_HeroConnectTipsWindow", Lua_WinParam.ACTION_OPEN, self.connPopupArr:shift())
        return true
    end
    return false
end