-- 布阵配置数据
Lua_HeroLineupUtil = class("Lua_HeroLineupUtil");
function Lua_HeroLineupUtil:ctor()
    self:superCall("ctor");
    self:dispose();
end

function Lua_HeroLineupUtil:dispose()
    self.standDic = nil;
    self.standIndexDic = nil;
end

function Lua_HeroLineupUtil:getLineupTabArr()
    if self.lineupTabArr == nil then
        self.lineupTabArr = Array();
        local config = getConfig("hero_camp_lineup");
        local vo;
        for k, v in pairs(config) do
            if v.is_show == 1 then
                vo = DataCenter.heroLineupData:getLineupVo(k, v);
                self.lineupTabArr:add(vo);
            end
        end
        self.lineupTabArr:sort("sort", false);
    end
    return self.lineupTabArr;
end

--获取站位信息
function Lua_HeroLineupUtil.Get:standConfigInfo()
    if self.standcfg == nil then
        self.standcfg = getConfig("hero_camp_position");
    end
    return self.standcfg;
end

function Lua_HeroLineupUtil:getStandInfoByType(stand_type)
    return self.standConfigInfo[stand_type];
end

--获取xx阵法站位的索引
function Lua_HeroLineupUtil:getIndexByStand(stand_type, standIdx)
    if self.standIndexDic == nil then
        self.standIndexDic = {};
    end
    if self.standIndexDic[stand_type] == nil then
        self.standIndexDic[stand_type] = {};
        local stand_list = self:getStandListByType(stand_type);
        for i = 1, #stand_list do
            self.standIndexDic[stand_type][stand_list[i]] = i;
        end
    end

    return self.standIndexDic[stand_type][standIdx];
end

--获取xx阵法索引的站位
function Lua_HeroLineupUtil:getStandByIndex(stand_type, index)
    if self.standDic == nil then
        self.standDic = {};
    end
    if self.standDic[stand_type] == nil then
        self.standDic[stand_type] = {};
        local stand_list = self:getStandListByType(stand_type);
        for i = 1, #stand_list do
            self.standDic[stand_type][i] = stand_list[i];
        end
    end
    
    return self.standDic[stand_type][index];
end

function Lua_HeroLineupUtil:getStandListByType(stand_type)
    local info = self:getStandInfoByType(stand_type)
    if info.unlock_list then
        local list = {}
        local standIdx
        local id
        for i = 1, #info.unlock_list do
            standIdx = info.unlock_list[i][1]
            id = info.unlock_list[i][2]
            if id == 0 then
                table.insert(list, standIdx)
            elseif DataCenter.mainLineData:getCheckpointIsCompleted(id) then
                table.insert(list, standIdx)
            end
        end        
        return list
    end
    return info.position_list
end

function Lua_HeroLineupUtil:getPosListByType(stand_type)
    local info = self:getStandInfoByType(stand_type)
    if info then
        return info.position_list
    end
    return nil
end










---------------------------------------------- 光环数据 ----------------------------------------------

--获取激活光环id
function Lua_HeroLineupUtil:getAureoleId(info)
    if info == nil then
        return 0;
    end
    -- 举例：
    --      假如上阵了2个水系，1个光系，2个火系，则会触发3名同系的加成
    --      假如上阵了4名水系，1名光系，则会触发5名水系的加成

    -- 特殊情况
    --      假如阵容5名英雄中只存在光系暗系英雄，则光环会选择纯光或纯暗中，系别数量多的一方
    -- 举例：
    --      假设存在3名光系，2名暗系的英雄，因为阵容中光系英雄数量更多，则会激活5名光系的光环
    local list1 = {};--自然系
    local list2 = {};--光暗系别
    local tag_num = 0;
    if info.typeof ~= nil and info:typeof() == "Array" then
        local camp;
        for i=1, info:getSize() do
            camp = info[i];
            if camp <= 4 then
                if list1[camp] == nil then
                    list1[camp] = 1;
                else
                    list1[camp] = list1[camp] + 1;
                end
            else
                if list2[camp] == nil then
                    list2[camp] = 1;
                else
                    list2[camp] = list2[camp] + 1;
                end
            end
        end
        tag_num = info:getSize();
    else
        for k,v in pairs(info) do
            if k <= 4 then
                list1[k] = v;
            else
                list2[k] = v;
            end
            tag_num = tag_num + v;
        end
    end

    if tag_num <= 1 then
        return 0;
    end

    local act_id = 0;  --激活光环id
    local act_num = 0; --激活数量
    local act_camp = 0;--激活阵容类型
    
    local _num = 0; --激活光暗数量
    for k,v in pairs(list2) do
        _num = _num + v;
    end

    if _num == 0 then--全是自然系
        for k,v in pairs(list1) do
            if act_num == 0 then
                act_num = v;
                act_camp = k;
            else
                if v > act_num then
                    act_num = v;
                    act_camp = k;
                end
            end
        end
    else
        local num = 0; --激活自然系数量
        for k,v in pairs(list1) do
            num = num + v;
        end
        if num == 0 then--全是光暗系
            local bool = false;--是否是光暗混合
            for camp, num in pairs(list2) do
                if act_num == 0 then
                    act_num = num;
                    act_camp = camp;
                else
                    if bool == false then
                        bool = camp ~= act_camp;
                    end
                    if num > act_num then
                        act_num = num;
                        act_camp = camp;
                    end
                end
            end
            act_num = _num;
            if bool == true and _num == 5 then --光暗混合光环特殊处理
                act_camp = 7;
            end
        else--自然光暗混合
            for k,v in pairs(list1) do
                if act_num == 0 then
                    act_num = v;
                    act_camp = k;
                else
                    if v > act_num then
                        act_num = v;
                        act_camp = k;
                    end
                end
            end
            act_num = act_num + _num;--光暗系可代替自然系，参与组成
        end
    end

    if act_num == 5 then
        act_id = act_num*1000+act_camp;
    else
        act_id = act_num*1000;
    end

    list1 = nil;
    list2 = nil;
    return act_id;
end

-- --英雄光环类型数据
-- function Lua_HeroLineupUtil:aureoleTypeInfo(aureole_id)
--     local arr = Array();
--     local info = getConfig({ "hero_aureole_type"});
--     for i=1,#info do
--         arr:add({data = info[i],aureole_id = aureole_id});
--     end
--     return arr;
-- end

-- 获取同类型 光环数据
function Lua_HeroLineupUtil:getAureoleInfoByType(aureole_type)
    local arr = Array();
    local info = getConfig("hero_camp_aureole");
    for k,v in pairs(info) do
        if v.aureole_type == aureole_type then
            arr:add(v);
        end
    end
    self:sortInfo(arr);
    return arr;
end

function Lua_HeroLineupUtil:sortInfo(arr)
    for i = 1, arr:getSize() do
        for j = i + 1, arr:getSize() do
            local a = arr[i].sort;
            local b = arr[j].sort;
            if a > b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end

function Lua_HeroLineupUtil:getAureoleConfig(id)
    return getConfig("hero_camp_aureole", id);
end

--获取光环属性
function Lua_HeroLineupUtil:getAureoleAttrInfo(id)
    local cfg = self:getAureoleConfig(id);
    local arr = Array();
    if cfg ~= nil then
        local vo;
        local list = cfg.attr_list;
        for i=1,#list do
            vo = DataCenter.attributesUtil:createAttrVo(list[i]);
            if vo ~= nil then
                vo.value = getConfig("hero_camp_aureole", id, list[i]);
                arr:add(vo);
            end
        end
        arr:sort("sort", true);
    end
    
    return arr;
end