--英雄符石
checkRequire("Lua_RunesVo");--符石
Lua_RunesData = class("Lua_RunesData")
function Lua_RunesData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_RunesData:dispose()
    self.bSortRunesPack = false;-- 符石背包排序
    self.bInitRunesInfo = false;-- 符石数据初始化

	self.allRunesDic = {};         -- key:uid, value:rvo
    self.allRunesUidArr = Array(); -- 符石uid集合
    self.runesPackUidArr = Array();-- 符石背包uid集合
    self._runesPackInfo = nil;
    self.runesPackColorDic = {};    -- key:品质 value:uid集合
    self.recastNumDic = nil;--重铸进度次数
end

function Lua_RunesData:fromServer50186001(msg)
	if msg == nil then
		return
	end
	local rvo;
    local info;
    local unique_id;
	local list = msg.rune_list;
	for i = 1, #list do
		info = list[i];
        unique_id = tonumber(info.unique_id);
        rvo = self:getRunesVoByUid(unique_id);
        if rvo == nil then
            rvo = self:addRunesItem(unique_id, info);
        end
        rvo:fromServer(info);
	end
    self.bInitRunesInfo = true;-- 符石数据初始化完毕
    DataCenter.heroData:checkHeroRedDotState();
end

function Lua_RunesData:fromServer80186002(msg)
	if msg == nil then
		return
	end
	local rvo;
    local info;
    local unique_id;
    local _type = msg.type;
    --print("符石  ",_type)
    local list = msg.rune_list;
    for i = 1, #list do
        info = list[i];
        -- print("info = =",info.forge_left_exp)
        unique_id = tonumber(info.unique_id);
        if _type == 2 then
            self:deleteRunesByUid(unique_id);
        else
            rvo = self:getRunesVoByUid(unique_id);
            if rvo == nil then
                rvo = self:addRunesItem(unique_id, info);
            else
                local old_backSort = rvo.backSort;-- 背包排序权重
                local old_hero_uid = rvo.hero_uid;
                rvo:fromServer(info);
                if old_backSort ~= rvo.backSort then
                    self.bSortRunesPack = true;
                end
   
                --更新符石背包数据
                if old_hero_uid == 0 and rvo.hero_uid ~= 0 then
                    self.bSortRunesPack = true;
                    self.runesPackUidArr:removeItem(unique_id);
                    self:deleteColorDic(rvo.color, unique_id);
                elseif old_hero_uid ~= 0 and rvo.hero_uid == 0 then
                    self.bSortRunesPack = true;
                    self.runesPackUidArr:add(unique_id);
                    self:addColorDic(rvo.color, unique_id);
                end
            end
            Lua_MsgUtil.callFunc("UPDATE_ONE_RUNES_INFO", unique_id);
        end
    end

    if _type == 1 then-- 增加
        Lua_MsgUtil.callFunc("ADD_RUNES_ITEM");
        DataCenter.heroData:checkHeroRedDotState();
    elseif _type == 2 then -- 2:删除
        Lua_MsgUtil.callFunc("DELETE_RUNES_ITEM");
        DataCenter.heroData:checkHeroRedDotState();
    elseif _type == 3 then -- 3:属性变化
        Lua_MsgUtil.callFunc("RUNES_ATTR");
    elseif _type == 4 then -- 4:技能变化
        Lua_MsgUtil.callFunc("RUNES_SKILL");
    elseif _type == 5 then -- 5:穿戴变化
	    Lua_MsgUtil.callFunc("RUNES_WORN");
    end
    -- print(" self.runesPackUidArr:getSize()   = =",self.runesPackUidArr:getSize())
end

-- 新增符石
function Lua_RunesData:addRunesItem(unique_id, serverInfo)
    if unique_id == nil or serverInfo == nil then
        return;
    end
    local vo = Lua_RunesVo.new(tonumber(serverInfo.id), 1);
    vo:fromServer(serverInfo);
    if self.allRunesDic[unique_id] == nil then
        self.allRunesUidArr:add(unique_id);
        if vo.hero_uid == 0 then
        	self.runesPackUidArr:add(unique_id);
            self:addColorDic(vo.color, unique_id);
        end
    end
    self.bSortRunesPack = true;
    self.allRunesDic[unique_id] = vo;
    return vo;
end

--删除符石
function Lua_RunesData:deleteRunesByUid(uid)
    if uid == nil or self.allRunesDic == nil then
        return;
    end
    local vo = self.allRunesDic[uid];
    if vo == nil then
        return;
    end
    self.bSortRunesPack = true;
    self.allRunesDic[uid] = nil;
    self.allRunesUidArr:removeItem(uid);
    self.runesPackUidArr:removeItem(uid);
    self:deleteColorDic(vo.color, unique_id);
	vo:clean();
	vo = nil;
end

-- 添加品质列表信息
function Lua_RunesData:addColorDic(color, uid)
    if self.runesPackColorDic[color] == nil then
        self.runesPackColorDic[color] = Array();
    end
    self.runesPackColorDic[color]:add(uid);
end

-- 删除部位列表信息
function Lua_RunesData:deleteColorDic(color, uid)
    if self.runesPackColorDic[color] ~= nil then
        self.runesPackColorDic[color]:removeItem(uid);
    end
end











---------------------------------- 数据接口 -------------------------------------------

-- 通过唯一id获取符石vo
function Lua_RunesData:getRunesVoByUid(unique_id)
    if self.allRunesDic == nil or self.allRunesDic[tonumber(unique_id)] == nil then
        return nil;
    end
    return self.allRunesDic[tonumber(unique_id)];
end












---------------------------------- 红点 -------------------------------------------

-- 是否展示装备页签红点
function Lua_RunesData:checkRunesRedDotState(heroVo)
    for i = 1, 2 do
        if self:checkPartRedDotState(i, heroVo) == true then
            return true;
        end
    end

    return false;
end

--部位红点
function Lua_RunesData:checkPartRedDotState(part, heroVo)
    local is_unlock  = DataCenter.runesUtil:RunesPartUnlock(part, heroVo.level, heroVo.star);
    if is_unlock == true then--已解锁
        if heroVo.runsInfo[part] == nil or heroVo.runsInfo[part] == 0 then--未穿戴
            if self.runesPackUidArr:getSize() > 0 then--穿戴红点
                return true;
            end
        else--已穿戴
            local rvo = self:getRunesVoByUid(heroVo.runsInfo[part]);
            local vo;
            for i = 1, self.runesPackUidArr:getSize() do
                vo = self:getRunesVoByUid(self.runesPackUidArr[i]);
                if vo ~= nil and vo.color > rvo.color then --替换红点
                    return true;
                end
            end
        end
    end

    return false;
end

-- 符石合成红点
function Lua_RunesData:checkRunesCompoundRedDotState()
    for k, v in pairs(self.runesPackColorDic) do
        if k < 5 then
            if self.runesPackColorDic[k] ~= nil then
                local len = self.runesPackColorDic[k]:getSize();
                if len >= DataCenter.runesUtil.show_red_num then
                    return true;
                end
            end
        end
    end

    return false;
end








---------------------------------- 界面数据 -------------------------------------------
--符石背包展示数据
function Lua_RunesData.Get:runesPackInfo()
    if self.bSortRunesPack == true then
        self.bSortRunesPack = false;
        self._runesPackInfo = nil;
    end
    if self._runesPackInfo ~= nil then
        return self._runesPackInfo;
    end
    local rvo;
    self._runesPackInfo = Array()
    for i = 1, self.runesPackUidArr:getSize() do
        rvo = self:getRunesVoByUid(self.runesPackUidArr[i]);
        self._runesPackInfo:add(rvo);
    end
    self._runesPackInfo:sort("backSort", true);
    return self._runesPackInfo;
end

function Lua_RunesData:getBatchArrByFilter(batchType, filterDic)
    local arr = Array();
    local rvo;
    for i = 1, self.runesPackUidArr:getSize() do
        rvo = self:getRunesVoByUid(self.runesPackUidArr[i]);
        if batchType == 1 then
            if rvo.decompose_logo == 1 and DataCenter.packData:checkVoIsMeetFilter(filterDic, rvo) then
                arr:add(rvo.unique_id);
            end
        elseif batchType == 2 then
            if rvo.sell_logo == 1 and DataCenter.packData:checkVoIsMeetFilter(filterDic, rvo) then
                arr:add(rvo.unique_id);
            end
        end
    end
    arr:sortf(self, self.onPackSortFun)
    return arr;
end

function Lua_RunesData:onPackSortFun(a, b)
    a = self:getRunesVoByUid(a);
    b = self:getRunesVoByUid(b);
    if a.backSort < b.backSort then
        return false
    end
    return true
end

--符石更换数据
function Lua_RunesData:getRunesChangeInfo(l_uid, r_uid)
    local arr = Array()
    for i=1,self.allRunesUidArr:getSize() do
        if self.allRunesUidArr[i] ~= l_uid and self.allRunesUidArr[i] ~= r_uid then
            arr:add(self.allRunesUidArr[i]);
        end
    end
    self:sortRunesChangeInfo(arr);
    return arr;
end

function Lua_RunesData:sortRunesChangeInfo(arr)
    local len = arr:getSize();
    if len <= 1 then
        return;
    end
    for i = 1, len do
        for j = i + 1, len do
            local a = self:getRunesVoByUid(arr[i]).backSort;
            local b = self:getRunesVoByUid(arr[j]).backSort;
            if a < b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end

















-- 消耗数据
function Lua_RunesData:getRunesCostInfo(window_list)
    local rvo;
    local select_num = 0;--记录当前已选择的材料数量
    local select_color;--记录当前已选材料的品质
    
    local arr = Array()
    for i=1,self.runesPackUidArr:getSize() do
        rvo = self:getRunesVoByUid(self.runesPackUidArr[i]);
        if rvo ~= nil and rvo.color < DataCenter.runesUtil.compound_color_limit then
            if window_list[self.runesPackUidArr[i]] ~= nil then
                select_color = rvo.color;
                select_num = select_num +1;
            end
            arr:add({unique_id = self.runesPackUidArr[i], isSelect = window_list[self.runesPackUidArr[i]] ~= nil});
        end
    end
    self:sortRunesCostInfo(arr);
    return select_num, select_color, arr;
end

-- 一键选择
function Lua_RunesData:getOneSelectCostDic(need_num)
    local rvo;
    local arr = Array()
    for i=1,self.runesPackUidArr:getSize() do
        rvo = self:getRunesVoByUid(self.runesPackUidArr[i]);
        if rvo ~= nil and rvo.color < DataCenter.runesUtil.compound_color_limit then
            arr:add({unique_id = self.runesPackUidArr[i]});
        end
    end
    self:sortRunesCostInfo(arr);

    local tag_list = {};
    for i=1,arr:getSize() do
        rvo = self:getRunesVoByUid(arr[i].unique_id);
        if tag_list[rvo.color] == nil then
            tag_list[rvo.color] = Array();
        end
        tag_list[rvo.color]:add(arr[i].unique_id);
    end

    local num;
    local color = DataCenter.runesUtil.compound_color_limit;
    for k,v in pairs(tag_list) do
        num = v:getSize();
        if num >= need_num then
            if color > k then
                color = k;
            end
        end
    end

    local isBool = false;
    local list = {};
    local arr = tag_list[color];
    if arr ~= nil then
        local tag_num = 0;
        for i=1,arr:getSize() do
            tag_num = tag_num + 1;
            list[arr[i]] = 1;
            if tag_num == need_num then
                isBool = true;
                break;
            end
        end
    end
    tag_list = nil;
    return list,isBool;
end

function Lua_RunesData:sortRunesCostInfo(arr)
    local len = arr:getSize();
    if len <= 1 then
        return;
    end
    for i = 1, len do
        for j = i + 1, len do
            local a = self:getRunesVoByUid(arr[i].unique_id).backSort;
            local b = self:getRunesVoByUid(arr[j].unique_id).backSort;
            if a > b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end

--成功率
function Lua_RunesData:getSucceedNum(list, num)
    for i=1,#list do
        if list[i][1] == num then
            return list[i][2];
        end
    end

    return 0;
end

--合成花费
function Lua_RunesData:getCompoundCostNum(list, num)
    for i=1,list do
        if list[i][1] == num then
            return list[i][2];
        end
    end

    return 0;
end

--合成一键选择数量
function Lua_RunesData.Set:showPutNum(val)
    self._showPutNum = val;
end

function Lua_RunesData.Get:showPutNum()
    if self._showPutNum == nil then
       self._showPutNum = DataCenter.runesUtil.put_runes_max;
    end
    return self._showPutNum
end