--符石消息类
checkRequire("Lua_RunesUtil");
checkRequire("Lua_RunesData");
Lua_RunesProxy = class("Lua_RunesProxy");
function Lua_RunesProxy:ctor()
	DataCenter.runesUtil = Lua_RunesUtil.new();
	DataCenter.runesData = Lua_RunesData.new();

	Lua_MsgUtil.addLuaMsg(50186001, self, self.rRunesInfo);    -- 请求符石信息(返回)
    Lua_MsgUtil.addLuaMsg(50186005, self, self.rCompoundRunes); -- 请求合成符石(返回)
    Lua_MsgUtil.addLuaMsg(50186006, self, self.rDecomposeRunes); -- 请求分解符石返回
    Lua_MsgUtil.addLuaMsg(50186007, self, self.rRecastRunes);  -- 请求符石重铸(返回)
    Lua_MsgUtil.addLuaMsg(50186008, self, self.rRecastSave);   -- 请求重铸保存(返回)
    Lua_MsgUtil.addLuaMsg(50186011, self, self.rRecastNum);    -- 请求重铸次数(返回)
    Lua_MsgUtil.addLuaMsg(50186012, self, self.rLuckyRecast);  -- 请求幸运重铸界面(返回)

	Lua_MsgUtil.addLuaMsg(80186002, self, self.updateRunesInfo); -- 通知符石信息
end



----------------------------------------------------------------------------------------------------------------------------
-- 上行消息号

-- 请求符石信息
function Lua_RunesProxy:sRunesInfo()
    sendMsg(10186001);
end

-- 请求穿戴符石
function Lua_RunesProxy:sWornRunes(hero_uid, part, rune_uid, other_hero_uid)
    local cmd = ProtoPublic_pb.Proto10186003();
    cmd.hero_uid = tonumber(hero_uid);
    cmd.part = tonumber(part);
    cmd.rune_uid = tonumber(rune_uid);
    cmd.other_hero_uid = tonumber(other_hero_uid);

    sendMsg(10186003, cmd);
end

-- 请求卸下符石
function Lua_RunesProxy:sDemountRunes(hero_uid, part)
    local cmd = ProtoPublic_pb.Proto10186004();
    cmd.hero_uid = tonumber(hero_uid);
    cmd.part = tonumber(part);
    sendMsg(10186004, cmd);
end

-- 请求合成符石
function Lua_RunesProxy:sCompoundRunes(list)
    local cmd = ProtoPublic_pb.Proto10186005();
    for k, v in pairs(list) do
       cmd.rune_uid_list:append(tonumber(k));
    end
    sendMsg(10186005, cmd);
end

-- 请求分解符石
function Lua_RunesProxy:sDecomposeRunes(rune_uid_list)
    if rune_uid_list == nil then
        return;
    end

    local cmd = ProtoPublic_pb.Proto10186006();
    for k,v in pairs(rune_uid_list) do
        cmd.rune_uid_list:append(tonumber(k));
    end
    sendMsg(10186006, cmd);
end

-- 请求重铸符石
function Lua_RunesProxy:sRecastRunes(rune_uid, recast_type, hero_uid, list)
    local cmd = ProtoPublic_pb.Proto10186007();
    cmd.rune_uid = tonumber(rune_uid);
    cmd.recast_type = tonumber(recast_type);--1：幸运重铸 0：普通重铸
    cmd.hero_uid = tonumber(hero_uid);
    if list ~= nil then
        for skill_id,v in pairs(list) do
            cmd.select_skill:append(tonumber(skill_id));
        end
    end
    sendMsg(10186007, cmd);
end

-- 请求请求保存重铸效果
function Lua_RunesProxy:sSaveRecastResult(rune_uid, hero_uid)
    local cmd = ProtoPublic_pb.Proto10186008();
    cmd.rune_uid = tonumber(rune_uid);
    cmd.hero_uid = tonumber(hero_uid);
    sendMsg(10186008, cmd);
end

-- 请求兑换符石
function Lua_RunesProxy:sRunesTexchange()
    sendMsg(10186010);
end

-- 请求重铸次数
function Lua_RunesProxy:sRecastNum(color)
    local cmd = ProtoPublic_pb.Proto10186011();
    cmd.color = color;
    sendMsg(10186011, cmd);
end

-- 请求幸运重铸界面
function Lua_RunesProxy:sLuckyRecast(color)
    local cmd = ProtoPublic_pb.Proto10186012();
    cmd.color = color;
    sendMsg(10186012, cmd);
end








----------------------------------------------------------------------------------------------------------------------------
-- 下行消息号

-- 请求符石信息(返回)
function Lua_RunesProxy:rRunesInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50186001();
        msg:ParseFromString(mp.data);
        DataCenter.runesData:fromServer50186001(msg);
    end
end

-- 通知更新符石信息
function Lua_RunesProxy:updateRunesInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80186002();
        msg:ParseFromString(mp.data);
        DataCenter.runesData:fromServer80186002(msg);
    end
end

-- 请求合成符石返回(返回)
function Lua_RunesProxy:rCompoundRunes(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50186005();
        msg:ParseFromString(mp.data);
        if msg.ret_val == 1 then
            OperateAlert.showLangValue(126804);
        else
            OperateAlert.showLangValue(126805);
        end
        Lua_MsgUtil.callFunc("SRUNES_COMPOUND");
    end
end

-- 请求合成符石返回(返回)
function Lua_RunesProxy:rDecomposeRunes(mp)
    if mp.errno == 0 then
        Lua_WindowUtil.openWin("Lua_PackBatchWindow", Lua_WinParam.ACTION_CLOSE);
    end
end

-- 请求重铸符石(返回)
function Lua_RunesProxy:rRecastRunes(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50186007();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("RECAST_SURE",tonumber(msg.rune_uid));
        OperateAlert.showLangValue(126733);
    end
end

-- 重铸保存(返回)
function Lua_RunesProxy:rRecastSave(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50186008();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("RECAST_SAVE",tonumber(msg.rune_uid));
        OperateAlert.showLangValue(126721);
    end
end

-- 请求重铸次数(返回)
function Lua_RunesProxy:rRecastNum(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50186011();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("RECAST_NUM",msg.recast_num);
    end
end


-- 请求幸运重铸界面(返回)
function Lua_RunesProxy:rLuckyRecast(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50186012();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("UPDATE_LUCKY_RECAST",msg.skill_list);--可选技能列表
    end
end