--符石配置
Lua_RunesUtil = class("Lua_HeroRunesUtil");
function Lua_RunesUtil:ctor()
	self:superCall("ctor");
end


------------------------------------ 符石常量 ------------------------------------
-- 合成最少放入几个符石
function Lua_RunesUtil.Get:put_runes_min()
    return getConfig({ "runes_const","put_runes_min","value"});
end

-- 合成最多放入符石个数
function Lua_RunesUtil.Get:put_runes_max()
    return getConfig({ "runes_const","put_runes_max","value"});
end

-- 重铸保底进度展示品质限制
function Lua_RunesUtil.Get:recast_bar_limit()
    return getConfig({ "runes_const","recast_bar_limit","value"});
end

-- 熔炼奖励id
function Lua_RunesUtil.Get:smelt_reward_vo()
    if self._forge_reward_vo == nil then
        local id = getConfig({ "runes_const","forge_exchange","value"});
        self._forge_reward_vo = Lua_ToolVo.createToolVo(id);
    end
    return self._forge_reward_vo;
end

-- 熔炼值
function Lua_RunesUtil.Get:smelt_value()
    if self._forge_value == nil then
        self._forge_value = getConfig({ "runes_const","forge_exchange","json_value"});
    end
    return self._forge_value[2];
end

-- 熔炼值id
function Lua_RunesUtil.Get:smelt_id()
    if self._forge_value == nil then
        self._forge_value = getConfig({ "runes_const","forge_exchange","json_value"});
    end
    return self._forge_value[1];
end

-- 背包同类型符石大于多少个后展示红点提示
function Lua_RunesUtil.Get:show_red_num()
    return getConfig({ "runes_const","show_red_num","value"});
end

-- 幸运重铸选择的数量
function Lua_RunesUtil.Get:lucky_recast_num()
    return getConfig({ "runes_const","lucky_recast_num","value"});
end

-- 符石合成品质限制
function Lua_RunesUtil.Get:compound_color_limit()
    return getConfig({ "runes_const","compound_color_limit","value"});
end














--符文部位
function Lua_RunesUtil:getRunesPartConfigInfo(id)
    local config = getConfig({ "runes_groove",id});
    return config;
end

--部位是否解锁
function Lua_RunesUtil:RunesPartUnlock(part, level, star)
    local info = getConfig({ "runes_groove", part});
    if info ~= nil and  info.unlock_lvl <= level and info.unlock_star <= star then
        return true;
    end
    return false;
end

-- 符石技能 list：服务端数据
function Lua_RunesUtil:getSkillArrByServer(list)
    local arr = Array();
    if list ~= nil and #list > 0 then   
        local vo;
        for i = 1, #list do
            vo = Lua_SkillConfigData.getConfigData(tonumber(list[i]))
            if vo ~= nil then
                arr:add(vo);
            end
        end
        arr:sort("skillId", true);
    end
    return arr;
end

--符石技能展示
function Lua_RunesUtil:getRunesSkillInfoByLevel(level)
    if self.runesSkillDic == nil then
        self.runesSkillDic = {};
        local config = getConfig({ "runes_skill"});
        for k,v in pairs(config) do
            if self.runesSkillDic[v.skill_level] == nil then
                self.runesSkillDic[v.skill_level] = Array();
            end
            self.runesSkillDic[v.skill_level]:add({id = k, sort = v.sort});
        end
    end
    local arr = self.runesSkillDic[level];
    if arr ~= nil then
        arr:sort("sort",false);
    end
    return arr;
end

--符石重铸
function Lua_RunesUtil:getRecastConfigInfo(id)
    if self.recastConfig == nil then
	   self.recastConfig = getConfig({ "runes_recast"});
    end
    return self.recastConfig[id];
end

--重铸材料
function Lua_RunesUtil:getCostItemInfo(list, bool)
    local arr = Array();
    for i=1,#list do
        arr:add({id = list[i][1],need_num = list[i][2]});
    end
    return arr;
end

--材料是否足够
function Lua_RunesUtil:isHaveMeetCost(arr)
    local id = nil;
    for i=1,arr:getSize() do
        local bagNum = DataCenter.packData:getItemCountById(arr[i].id);
        if bagNum < arr[i].need_num then
            id = arr[i].id;
            break;
        end
    end
    return id;
end



--获取符石基础属性评分系数
function Lua_RunesUtil:getBasicsAttrCoeff(attrId)
    if self.basicsCoeffDic == nil then
        self.basicsCoeffDic = {};
        local list = getConfig({ "runes_const","basic_attr_list","json_value"});
        for i=1,#list do
            self.basicsCoeffDic[list[i][1]] = list[i][2];
        end
    end
    if self.basicsCoeffDic[attrId] == nil then
        return 0;
    end
    return self.basicsCoeffDic[attrId];
end

--获取符石特殊属性固定评分
function Lua_RunesUtil:getSpecialAttrGrade(attrId)
    if self.specialCoeffDic == nil then
        self.specialCoeffDic = {};
        local list = getConfig({ "runes_const","special_attr_list","json_value"});
        for i=1,#list do
            self.specialCoeffDic[list[i][1]] = list[i][2];
        end
    end
    if self.specialCoeffDic[attrId] == nil then
        return 0;
    end
    return self.specialCoeffDic[attrId];
end