-- 战技配置表数据
Lua_TalentConfigData = class("Lua_TalentConfigData");
function Lua_TalentConfigData.getConfigData(id)
	if Lua_TalentConfigData.configDic == nil then
		Lua_TalentConfigData.configDic = {};
	end

	id = tonumber(id);
	if Lua_TalentConfigData.configDic[id] == nil then
		local cfg = getConfig( { "talent", id });
	    if cfg == nil then
	    	return nil;
	    end
		Lua_TalentConfigData.configDic[id] = Lua_TalentConfigData.new(id, cfg);
	end
	return Lua_TalentConfigData.configDic[id];
end

function Lua_TalentConfigData:ctor(id, config)
	self:superCall("ctor");
    self.id = id;
    self.config = config;
    if self.config == nil then
	    self.config = getConfig({"talent", id});
	end
end

-- 战技名字
function Lua_TalentConfigData.Get:name()
	return self.config.name;
end

-- 战技类型
function Lua_TalentConfigData.Get:type()
	return self.config.type;
end

-- 品质
function Lua_TalentConfigData.Get:color()
	return self.config.color;
end

-- 战技等级
function Lua_TalentConfigData.Get:level()
	return self.config.level;
end

-- 下等级战技id
function Lua_TalentConfigData.Get:next_id()
    return self.config.next_id;
end

-- 学习消耗
function Lua_TalentConfigData.Get:study_cost()
    return self.config.study_cost;
end

-- 升级消耗
function Lua_TalentConfigData.Get:upgarde_cost()
    return self.config.upgarde_cost;
end

-- 封装消耗
function Lua_TalentConfigData.Get:pack_cost()
    return self.config.pack_cost;
end

-- 封装获得
function Lua_TalentConfigData.Get:pack_obtain()
    return self.config.pack_obtain;
end

-- 遗忘消耗
function Lua_TalentConfigData.Get:forget_cost()
    return self.config.forget_cost;
end

-- 遗忘获得
function Lua_TalentConfigData.Get:forget_obtain()
    return self.config.forget_obtain;
end

-- 技能id
function Lua_TalentConfigData.Get:skill_id()
	return self.config.skill_id;
end

-- 技能vo
function Lua_TalentConfigData.Get:skill_vo()
	return Lua_SkillConfigData.getConfigData(self.skill_id);
end

-- 排序
function Lua_TalentConfigData.Get:sort()
	return self.config.sort;
end