checkRequire("Lua_InfinityHallUtil");
checkRequire("Lua_InfinityHallData");
Lua_InfinityHallProxy = class("Lua_InfinityHallProxy");
function Lua_InfinityHallProxy:ctor()
	DataCenter.infinityHallUtil = Lua_InfinityHallUtil.new();
	DataCenter.infinityHallData = Lua_InfinityHallData.new();

	Lua_MsgUtil.addLuaMsg(50193001, self, self.rInfinityHall); -- 请求战殿界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50193002, self, self.rSupportHero); -- 请求助阵英雄界面（返回）
	Lua_MsgUtil.addLuaMsg(50193003, self, self.rUseSupportHero); -- 请求使用助阵英雄（返回）
	Lua_MsgUtil.addLuaMsg(50193004, self, self.rSetSupportHero); -- 请求设定支援英雄（返回）
	Lua_MsgUtil.addLuaMsg(50193005, self, self.rReceiveAward); -- 请求领取首通奖励（返回）
	Lua_MsgUtil.addLuaMsg(50193006, self, self.rRankInfo); -- 请求领取首通奖励（返回）
	Lua_MsgUtil.addLuaMsg(50193007, self, self.rCheckFightBuff); -- 请求查看选择的buff列表（返回）
	Lua_MsgUtil.addLuaMsg(50193008, self, self.rRewardInfo); -- 请求战殿奖励详情界面(返回)
	Lua_MsgUtil.addLuaMsg(50193009, self, self.rSingleRewardInfo); -- 请求无穷战殿单层战殿奖励信息(返回)
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 事件监听





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求战殿界面信息
function Lua_InfinityHallProxy:sInfinityHall(type)
	local cmd = ProtoPublic_pb.Proto10193001();
	cmd.type = type;
	sendMsg(10193001, cmd);
end

-- 请求助阵英雄界面
function Lua_InfinityHallProxy:sSupportHero()
	sendMsg(10193002);
end

-- 请求使用助阵英雄
function Lua_InfinityHallProxy:sUseSupportHero(player_id)
	local cmd = ProtoPublic_pb.Proto10193003();
	cmd.player_id = tonumber(player_id);
	sendMsg(10193003, cmd);
end

-- 请求设定支援英雄
function Lua_InfinityHallProxy:sSetSupportHero(hero_id)
	local cmd = ProtoPublic_pb.Proto10193004();
	cmd.hero_id = tonumber(hero_id);
	sendMsg(10193004, cmd);
end

-- 请求领取首通奖励
function Lua_InfinityHallProxy:sReceiveAward(type, floor)
	local cmd = ProtoPublic_pb.Proto10193005();
	cmd.type = type;
	cmd.floor = floor;
	sendMsg(10193005, cmd);
end

-- 请求排行信息
function Lua_InfinityHallProxy:sRankInfo(type)
	local cmd = ProtoPublic_pb.Proto10193006();
	cmd.type = type;
	sendMsg(10193006, cmd);
end

-- 请求查看选择的buff列表
function Lua_InfinityHallProxy:sCheckFightBuff()
	sendMsg(10193007);
end

-- 请求战殿奖励详情界面
function Lua_InfinityHallProxy:sRewardInfo(type)
	local cmd = ProtoPublic_pb.Proto10193008();
	cmd.type = type;
	sendMsg(10193008, cmd);
end

-- 请求无穷战殿单层战殿奖励信息
function Lua_InfinityHallProxy:sSingleRewardInfo(type, floor)
	local cmd = ProtoPublic_pb.Proto10193009();
	cmd.type = type;
	cmd.floor = floor;
	sendMsg(10193009, cmd);
end

-- 请求领取无穷战殿每日礼包
function Lua_InfinityHallProxy:sReceiveDailyReward()
	sendMsg(10193010);
end







------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_InfinityHallProxy:rInfinityHall(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50193001();
		msg:ParseFromString(mp.data);
		DataCenter.infinityHallData:fromServer50193001(msg);
		Lua_MsgUtil.callFunc("INFINITYHALL_INFO");
	end
end

function Lua_InfinityHallProxy:rSupportHero(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50193002();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("INFINITYHALL_SURROPT_HREO", msg);
	end
end

function Lua_InfinityHallProxy:rUseSupportHero(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50193003();
		msg:ParseFromString(mp.data);
		DataCenter.infinityHallData:fromServer50193003(msg);
		Lua_MsgUtil.callFunc("INFINITYHALL_INFO");
	end
end

function Lua_InfinityHallProxy:rSetSupportHero(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50193004();
		msg:ParseFromString(mp.data);
		DataCenter.infinityHallData:fromServer50193004(msg);
		Lua_MsgUtil.callFunc("INFINITYHALL_SURROPT_HREO");
	end
end

function Lua_InfinityHallProxy:rReceiveAward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50193005();
		msg:ParseFromString(mp.data);
		DataCenter.infinityHallData:fromServer50193005(msg);
		Lua_MsgUtil.callFunc("INFINITYHALL_REWARD");
	end
end

function Lua_InfinityHallProxy:rRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50193006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("INFINITYHALL_RANK_INFO", msg);
	end
end

function Lua_InfinityHallProxy:rCheckFightBuff(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50193007();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("INFINITYHALL_FIGHT_BUFF", msg);
	end
end

function Lua_InfinityHallProxy:rRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50193008();
		msg:ParseFromString(mp.data);
		DataCenter.infinityHallData:fromServer50193008(msg);
		Lua_MsgUtil.callFunc("INFINITYHALL_REWARD");
	end
end

function Lua_InfinityHallProxy:rSingleRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50193009();
		msg:ParseFromString(mp.data);
		DataCenter.infinityHallData:fromServer50193009(msg);
	end
end