--神陵秘境Data
checkRequire("Lua_JokerDeulCellVo");
checkRequire("Lua_JokerControlVo");
checkRequire("Lua_JokerDeulRewardVo");
checkRequire("Lua_JokerDeulRankVo");
checkRequire("Lua_JokerDeulShopVo");
Lua_JokerDuelData = class("Lua_JokerDuelData");
function Lua_JokerDuelData:ctor()
	self:dispose();
end

function Lua_JokerDuelData:dispose()
	self.gridInfo = {};
	self.itemInfo = {};
	self.monsterInfo = {};

	self.curStarIndex = nil;--当前选择的英雄下标
	self.isPlayBossAni = false;--是否正在播放boss过场动画

	self.skipDuel = 0;--跳过战斗
	self.duelLeader = false;--对决boss
	self.isFighting = false;--对决中(不跳过战斗)

	self.isOpenWin = false;--打开界面操作

	self:clearLastProp();
	self:clearSweepData();
end

function Lua_JokerDuelData:clearLastProp()--删除上轮未通关属性
	if self.lastPropArr ~= nil then
		self.lastPropArr:dispose();
		self.lastPropArr:clear();
		self.lastPropArr = nil;
	end
end

function Lua_JokerDuelData:clearSweepData()--删除扫荡数据
	if self.sweepArr ~= nil then
		self.sweepArr:dispose();
		self.sweepArr:clear();
		self.sweepArr = nil;
	end
	self.isSweeping = false;--扫荡中
	self.sweepTime = 0;--扫荡次数
end

function Lua_JokerDuelData:formServer50164001(msg)--上轮未通关属性
	self.lastPropArr = Array();
	for k, v in ipairs(msg.prop) do
		local vo = DataCenter.attributesUtil:createAttrVo(v.name);
		vo.value = v.value;
		self.lastPropArr:add(vo);
	end
end

function Lua_JokerDuelData:formServer50164002(msg)--请求神陵秘境界面（返回）
	local lastScriptSate = self.isInScript;--记录上一次副本状态
	self.isInScript = msg.is_in_script;--是否在副本中（1：是，0：否）
	if self.isOpenWin then --打开界面操作
		self.isOpenWin = false;
		Lua_WindowUtil.openWin("Lua_JokerDuelWindow", Lua_WinParam.ACTION_OPEN, nil);
		return;
	elseif lastScriptSate == 1 and self.isInScript == 0 then--副本重置
		-- DataCenter.redDotUtil:getRedDotVoById(10075).isAlreadyShow = false;
		-- DataCenter.redDotUtil:updateRedDotVoById(10075, true);

		if Lua_WindowUtil.isWindowShowing("Lua_JokerDuelWindow") then
			OperateAlert.showLangValue(201809);

			if Lua_WindowUtil.isWindowShowing("Lua_InstructionTipsWindow") then
				Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_CLOSE, nil);
			elseif Lua_WindowUtil.isWindowShowing("Lua_TipsWindow") then
				Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_CLOSE, nil);
			end
			Lua_MsgUtil.callFunc("CLOSE_JOKER_WINDOW");
		end
		self:dispose();
		return;
	end

	self:addItemInfo(msg);--更新道具信息(扫荡特殊处理)
	Lua_MsgUtil.callFunc("UPDATE_JOKER_ITEMINFO");

	if self.isSweeping and self.sweepTime > 0 then--扫荡数据处理
		if self.sweepArr == nil then
			self.sweepArr = Array();
		end
		if self.sweepArr:getSize() < self.sweepTime then
			self.sweepArr:add(msg)

			if self.sweepArr:getSize() == self.sweepTime then
				Lua_MsgUtil.callFunc("JOKER_START_SWEEP");
			end
		end
		return;
	end

	self:updateJokerInfo(msg);
end

function Lua_JokerDuelData:formServer50164021()--请求购买体能饮料/通行证（返回）
	local showStr = LanUtil.formateStr(201826, tostring(self.buyItemName), tostring(self.buyItemNum));--获得提示
	OperateAlert.show(showStr);
end










function Lua_JokerDuelData:updateJokerInfo(msg)--更新神陵秘境信息
	self.state = msg.state;--是否通关（1：是，0：否）
	self.isSweep = msg.is_sweep;--是否能进行一键横扫（1：是，0：否）
	self.isAutoPick = msg.is_auto_pick;--是否能自动拾取道具（1：是，0：否）

	self.stage = msg.stage;--关卡数
	self.defeatNum = msg.defeat_amount;--累计战胜英雄数量
	self.aceShopNum = msg.shop_amount;--王牌商店商品数量
	self.resetTick = msg.reset_tick;--下次重置时间戳

	self:updateGridInfo(msg);--更新格子信息
	self:updateCampInfo(msg);--更新阵容信息
	self:updateTaskInfo(msg);--更新任务信息
	self:updatePropInfo(msg);--更新属性信息

	-- local showRedDot = self.getCurStarVo == nil or (self.state == 1 and self.stage == DataCenter.jokerDuelUtil:getConstVo("max_level").value);--英雄全阵亡或通关所有关卡(红点消失)
	-- DataCenter.redDotUtil:updateRedDotVoById(10075, not showRedDot);
	
	local isFightPlaying = DataCenter.fightData:checkFightingByTemplateId(Lua_FightDefine.TEMPLATE_ID_JOKERDUEL);--神陵秘境(不跳过)
	if self.isInScript == 1 and not isFightPlaying then
		Lua_MsgUtil.callFunc("UPDATE_JOKER_INFO");
	end
end

function Lua_JokerDuelData:updateGridInfo(msg)--格子信息
	self.gridArr = Array();
	for k, v in ipairs(msg.grid_info) do
		if self.gridInfo[v.index] == nil then
			self.gridInfo[v.index] = Lua_JokerDeulCellVo.new();
		end
		self.gridInfo[v.index]:fromServer(v);
		self.gridArr:add(self.gridInfo[v.index]);
	end
end

function Lua_JokerDuelData:updateCampInfo(msg)--阵容信息
	self.campArr = Array();
	self.campList = {};--索引用
	for k, v in ipairs(msg.camp_info) do
		local vo = Lua_ToolVo.createToolVo(tonumber(v.hero_id));
		if vo ~= nil then
			vo:fromServer(v);
			vo.index = v.index;--英雄阵容索引
			vo.curEnergy = v.cur_energy;----当前能量
			self.campArr:add(vo);
			self.campList[vo.index] = vo;
		end
	end 
	self.campArr:sort("index", false);

	self:updateCurStarIndex();--更新当前英雄选择
end

function Lua_JokerDuelData:addItemInfo(msg)--道具信息
	local info = msg.item_info;
	if #info > 0 then
		for k, v in ipairs(info) do
			self:setItemVo(v.type, v);
		end
	end
end

function Lua_JokerDuelData:updateItemInfo(msg)--道具信息
	local info = msg.item_info;
	self:setItemVo(info.type, info);
end


function Lua_JokerDuelData:updateTaskInfo(msg)--任务信息
	self.taskArr = Array();
	for k, v in ipairs(msg.task_info) do
		local vo = Lua_JokerDeulRewardVo.new(v.key);
		vo:fromServer(v);
		self.taskArr:add(vo);
	end
	self.taskArr:sort("sortRank", false);
end

function Lua_JokerDuelData:updatePropInfo(msg)--属性信息
	self.attributeArr = DataCenter.attributesUtil:getAttrArrByServer(msg.prop_info);
end

function Lua_JokerDuelData:updateRankInfo(msg)--排行榜信息
	self.ownRankVo = msg.self_rank;

	self.rankArr = Array();
	for k, v in ipairs(msg.rank_list) do
		local vo = Lua_JokerDeulRankVo.new();
		vo:fromServer(v);
		self.rankArr:add(vo);
	end

	local maxRank = DataCenter.jokerDuelUtil:getConstVo("max_rank_num").value;
	local curNum = self.rankArr:getSize();
	local remainNum = maxRank - curNum;
	for i = curNum + 1, maxRank do--假数据
		local vo = Lua_JokerDeulRankVo.new();
		vo.rank = i;
		self.rankArr:add(vo);
	end
	self.rankArr:sort("rank", false);
end

function Lua_JokerDuelData:updateContactShopInfo(msg)--联系赞助商店信息
	self.contactShopItemArr = Array();
	for k, v in ipairs(msg.shop_list) do
		local vo = Lua_JokerDeulShopVo.new(v.id);
		vo:fromServer(v);
		self.contactShopItemArr:add(vo);
	end
	self.contactShopItemArr:sort("index", true);
end

function Lua_JokerDuelData:updateAceShopInfo(msg)--王牌商店信息
	self.aceShopItemArr = Array();
	for k, v in ipairs(msg.shop_list) do
		local vo = Lua_JokerDeulShopVo.new(v.id);
		vo:fromServer(v);
		self.aceShopItemArr:add(vo);
	end
	self.aceShopItemArr:sort("rank", true);
end

function Lua_JokerDuelData:updatePassRewardInfo(msg)--过关奖励信息
	local arr = Array();
	for k, v in ipairs(msg.calc_reward) do
		local vo = Lua_ToolVo.createToolVo(tonumber(v.id), tonumber(v.amount));
		arr:add(vo);
	end
	Lua_MsgUtil.callFunc("UPDATE_JOKER_PASSREWARD", arr);
end












function Lua_JokerDuelData:setItemVo(index, info)--设置道具栏Vo
	if index == nil then
		return
	end
	if self.itemInfo[index] == nil then
		self.itemInfo[index] = Lua_JokerControlVo.new();
	end
	self.itemInfo[index]:fromServer(info);
end

function Lua_JokerDuelData:setBuyItem(name, num)--设置购买商品信息
	self.buyItemName = name;
	self.buyItemNum = num;
end

function Lua_JokerDuelData.Get:getCurTaskVo()--获取当前第一个任务
	if self.taskArr ~= nil and self.taskArr[1] ~= nil then
		return self.taskArr[1];
	end 
	return nil;
end

function Lua_JokerDuelData:updateCurStarIndex()--更新选择英雄下标
	if self.curStarIndex ~= nil then
		if self.campList[self.curStarIndex] == nil or self.campList[self.curStarIndex].blood <= 0 then
			self.curStarIndex = nil;
			self:updateCurStarIndex();
		end
	else
		for i = 1, self.campArr:getSize() do--默认选取最左边
			if self.campArr[i].blood > 0 then
				self.curStarIndex = self.campArr[i].index;
				break;
			end
		end
	end
end

function Lua_JokerDuelData.Get:getCurStarVo()--获取当前选择英雄vo
	if self.curStarIndex ~= nil then
		return self.campList[self.curStarIndex];
	end
	return nil;
end

function Lua_JokerDuelData.Get:getMonsterArr()--获取怪物数据
	local arr = Array();
	for k, v in pairs(self.monsterInfo) do
		if v ~= nil and v.blood > 0 then
			if v.isLeader == 0 or (v.isLeader == 1 and not self.isPlayBossAni) then
				arr:add(v);
			end
		end
	end
	return arr;
end

function Lua_JokerDuelData.Get:getBossState()--判断Boss是否出现
	return self.monsterInfo[13] ~= nil;
end

function Lua_JokerDuelData:setMonsterIndex()--设置怪物默认选择下标(仅通行证界面使用)
	local arr = self.getMonsterArr;
	if arr:getSize() >= 1 then
		self.monsterIndex = arr[1].index;
	else
		self.monsterIndex = nil;
	end
end

function Lua_JokerDuelData.Get:getCurMonsterVo()--获取当前怪物(仅通行证界面使用)
	return self.monsterInfo[self.monsterIndex];
end

function Lua_JokerDuelData:getClickLimit(types)--点击操作限制
	if types == 1 then--仅限制战斗中
		return self.isFighting;
	elseif types == 2 then--仅限制扫荡中
		return self.isSweeping; 
	elseif types == 3 then--限制战斗中和扫荡中
		return self:getClickLimit(1) or self:getClickLimit(2);
	end
end









-- 展示皇陵英雄选择界面数据
function Lua_JokerDuelData:showSelectHeroInfo(campType)
    DataCenter.heroData:sortHeroInfo();
    local cvo;
    local curSelectIdx = 0;
    local arr = Array();
    local info = DataCenter.heroData.allHeroUidArr;
    local lineupLimit = DataCenter.heroUtil:trialHeroLineup(Lua_HeroUtil.LINEUP_JOKERDUEL); -- 试用英雄上阵限制
    for i=1, info:getSize() do
        cvo = DataCenter.heroData:getItemByUniqueId(info[i]);
        if campType == Lua_HeroUtil.All_TYPE or cvo.campType == campType then
        	if not cvo.trial_state or lineupLimit then
            	arr:add({unique_id = info[i], isSelect = false, id = cvo.id});
        	end
        end
    end
    return arr;
end