checkRequire("Lua_KunXuHolyLandStageVo");
Lua_KunXuHolyLandData = class("Lua_KunXuHolyLandData");
function Lua_KunXuHolyLandData:ctor()
	self.lastClickTime = 0;
	self.deltaTime = 0.2;
	self.isResetTime = nil;
	self.openFightId = nil; -- 打开的战斗关卡id
	self.fightingId = nil; -- 正在战斗的关卡id
	self.needResetData = nil; -- 需要重置
	Lua_MsgUtil.addEventListener("FUNCTION_OPEN",self, self.hideRedPoint); --功能开启
end

function Lua_KunXuHolyLandData:dispose()
	if self.curStageVo ~= nil then
		self.curStageVo:dispose();
		self.curStageVo = nil;
	end
	self.rewardList = nil;
	self.rewardIdList = nil;
	self.showRewardRP = nil;
	self.showFirstOpenRP = nil;
	self.isResetTime = nil; -- 策划案中重置前几分钟内不允许战斗
	self.openFightId = nil; -- 打开的战斗关卡id
	self.fightingId = nil; -- 正在战斗的关卡id
	self.needResetData = nil; -- 需要重置
	self.curStageId = nil;
	self.showDescLevelId = nil;
	self.bOpened = nil; -- 功能由开启至关闭的检测
end

-- 请求活动界面信息(返回)
function Lua_KunXuHolyLandData:fromServer50204001(msg)
	if msg == nil then
		return;
	end
	self.bOpened = true;
	self.closeTick = tonumber(msg.close_tick);
	self.passLevelId = msg.pass_stage; --已通关关卡id
	self.passLevelNum = self.passLevelId == 0 and 0 or self.passLevelId % 100; --已通关关卡数量
	self.totalStar = msg.total_star; -- 已获得的总星数
	self.fullRewardState = msg.full_reward; -- 满星困难奖励状态 0不可领取 1可领取 2已领取
	self.canQuickFight = msg.quick_fight == 1; -- 是否可以快速战斗 0不可以 1可以
	self.switchState = msg.switch_state; -- 跳过战斗开关状态 0 关闭跳过 1开启跳过
	self.firstOpen = msg.first_open; -- 轮次开启后首次开启 0否 1是
	self.passReward = msg.pass_reward; --全通奖励状态 0不可领取 1可领取 2已领取
	if self.curStageId ~= msg.chapter_id or self.needResetData then
		if self.needResetData then
			self.needResetData = false;
			self.isResetTime = false;
		end
		if self.curStageVo ~= nil then
			self.curStageVo:dispose();
			self.curStageVo = nil;
			self.rewardList = nil;
			self.rewardIdList = nil;
		end
		self.curStageId = msg.chapter_id; -- 当前难度
		self.curStageVo = Lua_KunXuHolyLandStageVo.new(self.curStageId);
	end
	self.curStageVo:updateDataFromServer(msg.stage_state, msg.star_reward);

	self:updateRewardRedPoint();
	self:updateFirstOpenRedPoint();
end

-- 请求快速战斗(返回)
function Lua_KunXuHolyLandData:fromServer50204002(msg)
	if msg == nil then
		return;
	end

	self.curStageVo:updateQuickFightLevelListState(msg.stage_state);
end

-- 请求跳过战斗开关(返回)
function Lua_KunXuHolyLandData:fromServer50204003(msg)
	if msg == nil then
		return;
	end
	
	self.switchState = msg.switch_state; -- 跳过战斗开关状态 0 关闭跳过 1开启跳过
end

-- 请求领取星级奖励(返回)
function Lua_KunXuHolyLandData:fromServer50204004(msg)
	if msg == nil then
		return;
	end

	self.curStageVo:updateStarRewardState(msg.star_reward);
	self:updateRewardRedPoint();
end

-- 请求领取完美通关奖励(返回)
function Lua_KunXuHolyLandData:fromServer50204005(msg)
	if msg == nil then
		return;
	end

	self.fullRewardState = msg.full_state;
	self:updateRewardRedPoint();
end

-- 请求领取全通奖励(返回)
function Lua_KunXuHolyLandData:fromServer50204006(msg)
	if msg == nil then
		return;
	end

	self.passReward = msg.pass_reward;
	self:updateRewardRedPoint();
end

-- 通知活动关闭战斗(返回)
function Lua_KunXuHolyLandData:fromServer80204001(msg)
	if msg == nil then
		return;
	end

	self.isResetTime = msg.fight_open == 1; -- 1 关闭
end

-- 通知活动可以更新新一轮(返回)
function Lua_KunXuHolyLandData:fromServer80204002(msg)
	if msg == nil then
		return;
	end

	self.needResetData = true;
	self.curStageId = msg.new_round;
end

function Lua_KunXuHolyLandData:getLevelInfoById(levelId)
	if levelId == nil or self.curStageVo == nil then
		return;
	end
	return self.curStageVo:getLevelVoById(levelId);
end

-- 快速战斗结果窗口是否展开重置为不展开
function Lua_KunXuHolyLandData:resetQuickFight()
	local list = self.curStageVo.levelIdList;
	if list == nil then
		return;
	end
	local vo;
	for i = 1, #list do
		vo = self:getLevelInfoById(list[i]);
		vo:resetIsCurMeet();
	end
	self.showDescLevelId = nil;
end

function Lua_KunXuHolyLandData:getStarRewardById(starStateId)
	return self.curStageVo:getStarRewardById(starStateId);
end

function Lua_KunXuHolyLandData.Get:canPassFight()
	 return DataCenter.funcOpenData:isOpened(10250, true);
end

function Lua_KunXuHolyLandData:getHeroInfo()
	local heroVo;
	local leftHeroId, rightHeroId;
	local lineup_type = Lua_KunXuHolyLandUtil.LINEUP_TYPE; -- 英雄布阵配置表-昆墟圣地
	local leftForce, rightForce, maxLeftForce, maxRightForce = 0, 0, -1, -1;
	local lineupVo = DataCenter.heroLineupData:getLineupVo(lineup_type);
	local arr = lineupVo.lineupDic[1];
	for i = 1, arr:getSize() do
		if arr[i] > 0 then
			heroVo = DataCenter.heroData:getItemByUniqueId(arr[i]);
			if heroVo then
				leftForce = leftForce + heroVo.heroForce;
				if maxLeftForce < heroVo.heroForce then
					maxLeftForce = heroVo.heroForce;
					leftHeroId = arr[i];
				end
			end
		end
	end

	arr = lineupVo.lineupDic[2];
	for i = 1, arr:getSize() do
		if arr[i] > 0 then
			heroVo = DataCenter.heroData:getItemByUniqueId(arr[i]);
			if heroVo then
				rightForce = rightForce + heroVo.heroForce;
				if maxRightForce < heroVo.heroForce then
					maxRightForce = heroVo.heroForce;
					rightHeroId = arr[i];
				end
			end
		end
	end
	-- 左战力总和      左最高战力unique_id， 右战力总和    右最高战力unique_id
	return leftForce, leftHeroId,          rightForce,  rightHeroId;
end

-- 奖励红点
function Lua_KunXuHolyLandData:updateRewardRedPoint()
	local isShowRedPoint = false;
	if self.passReward == 1 then-- 全通奖励
		isShowRedPoint = true;
	end

	if self.fullRewardState == 1 then -- 完美通关
		isShowRedPoint = true;
	end

	if isShowRedPoint == false then -- 星级阶段的奖励
		local list = self.curStageVo.starRewardList;
		for k, v in pairs(list) do
			if v.receivedStage == 1 then
				isShowRedPoint = true;
				break;
			end
		end
	end
	if self.showRewardRP ~= isShowRedPoint then
		self.showRewardRP = isShowRedPoint;
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.KunXuHolyLand_Reward, isShowRedPoint);
	end
end

function Lua_KunXuHolyLandData:updateFirstOpenRedPoint()
	local isShowRedPoint = self.firstOpen == 0;
	if self.showFirstOpenRP ~= isShowRedPoint then
		self.showFirstOpenRP = isShowRedPoint;
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.KunXuHolyLand_FirstOpen, isShowRedPoint);
	end
end

-- 可以挑战的最大关卡id
function Lua_KunXuHolyLandData:getEnableFightLevelId()
	local levelId = self.passLevelId;
	levelId = levelId == 0 and self.curStageVo.levelIdList[1] or levelId + 1;
	return levelId;
end

function Lua_KunXuHolyLandData:getTotalMonsterList()
	if self.curStageVo ~= nil then
		return self.curStageVo.totalMonsterList;
	end
end

-- 功能由开启到关闭
function Lua_KunXuHolyLandData:hideRedPoint(openDic)
	if not DataCenter.funcOpenData:isOpened(10245) and self.bOpened then
		self.bOpened = false;
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.KunXuHolyLand_FirstOpen, false);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.KunXuHolyLand_Reward, false);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.KunXuHolyLand_War, false);
		Lua_MsgUtil.callFunc("UPDATE_EXPERIENCEITEM_INFO"); -- 入口item
	end
end