-- 关卡
checkRequire("Lua_StarCondVo")
Lua_KunXuHolyLandLevelVo = class("Lua_KunXuHolyLandLevelVo")
function Lua_KunXuHolyLandLevelVo:ctor(id, config)
	self.levelId = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig({ "holy_land_stage", id });
    end

    if self.config == nil then
    	return;
    end
    self:setStarList();
end

function Lua_KunXuHolyLandLevelVo:dispose()
	if self.starList ~= nil then
		for k, v in pairs(self.starList) do
			v = nil;
		end
		self.starList = nil;
	end
	if self.monsterModelList ~= nil then
		for k, v in pairs(self.monsterModelList) do
			v = nil;
		end
		self.monsterModelList = nil;
	end
	self._isShowReward = nil;
end

-- 设置星级list
function Lua_KunXuHolyLandLevelVo:setStarList()
	if self.starList == nil then
		self.starList = {};

		local str;
		local obj;
		local _desc;
		for i = 1, #self.starCondition do
			obj = self.starCondition[i];
			if type(obj[1]) == "number" then
				_desc = DataCenter.kunXuHolyLandUtil:getDesc(obj[1], obj[2]);
			else
				_desc = nil;
				for j = 1, #obj do
					str = DataCenter.kunXuHolyLandUtil:getDesc(obj[j][1], obj[j][2]);
					if _desc == nil then
						_desc = str;
					else
						_desc = LanUtil.formateStr(440031, _desc, str);
					end
				end
			end
			self.starList[i] = { desc = _desc, isMeet = false, isCurMeet = false }; -- isMeet:星级是否满足;  isCurMeet:快速战斗显示星级是否满足
		end
	end
end

-- 重置快速战斗记录的数据
function Lua_KunXuHolyLandLevelVo:resetIsCurMeet()
	for i = 1, #self.starList do
		self.starList[i].isCurMeet = false;
	end
end

-- 实时战斗星级显示
function Lua_KunXuHolyLandLevelVo.Get:starCondArr()
	if self._starCondArr == nil then
		self._starCondArr = Array();
		local vo;
		for i = 1, #self.starCondition do
			vo = Lua_StarCondVo.new(Lua_FightDefine.TEMPLATE_ID_KUNXU);
			vo:parseCond(self.starCondition[i]);
			self._starCondArr:add(vo);
		end
	end
	return self._starCondArr;
end

-- 更新星级list：是否满足
function Lua_KunXuHolyLandLevelVo:updateStarList(star_state)
	local vo;
	local obj;
	for i = 1, #star_state do
		obj = star_state[i];
		vo = self.starList[obj.key];
		if vo ~= nil then
			vo.isMeet = obj.value == 1; --value 1获取(满足） 0未获取（未满足）
		end
	end
end

-- 更新快速战斗星级list：是否满足
function Lua_KunXuHolyLandLevelVo:updateQuickFightStarList(star_state)
	local vo;
	local obj;
	for i = 1, #star_state do
		obj = star_state[i];
		vo = self.starList[obj.key];
		if vo ~= nil then
			vo.isCurMeet = obj.value == 1; --value 1获取(满足） 0未获取（未满足）
		end
	end
end


-- 关卡名称
function Lua_KunXuHolyLandLevelVo.Get:levelName()
	if self._levelName == nil then
		self._levelName = LanUtil.formateStr(440032, self.level);
	end
	return self._levelName;
end

-- 单个队伍战力，及模型展示
function Lua_KunXuHolyLandLevelVo:showSingleMonsterModel(monsterId, index)
	local cfgData = Lua_MonsterPlayerConfigData.getConfigData(monsterId);
    if cfgData == nil then
        return;
    end

    local totalForce = cfgData.force ~= nil and cfgData.force[index] or 0;--cfgData.force == nil and 0 or cfgData.force;
    totalForce = totalForce == nil and 0 or totalForce;
    local list = cfgData.fighter_list;
    local modelId;
    local monsterVo;
    local monsterForce = -1;
    for k, v in pairs(list[index]) do
    	monsterVo = Lua_MonsterConfigData.getMonsterConfig(v[1]);
    	if monsterVo.force > monsterForce then
    		monsterForce = monsterVo.force;
    		modelId = v[1];
    		
    		-- monsterModel = monsterVo.heroVo.modelSrc;
    		-- monsterPath = monsterVo.heroVo.heroRolePath;
    	end
    end

    return totalForce, modelId;
end

-- 两条队伍
function Lua_KunXuHolyLandLevelVo:getMonsterModel()
	if self.monsterModelList == nil then
		self.monsterModelList = {};
		local _force, _monsterId = self:showSingleMonsterModel(self.monsterId, 1);
		self.monsterModelList[1] = { force = _force, monsterId = _monsterId }; -- 左边

		_force, _monsterId = self:showSingleMonsterModel(self.monsterId, 2);
		self.monsterModelList[2] = { force = _force, monsterId = _monsterId }; -- 右边
	end
	return self.monsterModelList;
end

function Lua_KunXuHolyLandLevelVo.Set:isShowReward(value)
	self._isShowReward = value;
end

function Lua_KunXuHolyLandLevelVo.Get:isShowReward()
	if self._isShowReward == nil then
		self._isShowReward = false;
	end
	return self._isShowReward;
end










-------------------------------------------配置表数据-----------------------------------
-- 关卡
function Lua_KunXuHolyLandLevelVo.Get:level()
	return self.config.stage;
end

-- 星级条件
function Lua_KunXuHolyLandLevelVo.Get:starCondition()
	return self.config.star_cond;
end

-- -- 左队怪物阵容id
-- function Lua_KunXuHolyLandLevelVo.Get:leftMonsterId()
-- 	return self.config.monster_id;
-- end

-- -- 右队怪物阵容id
-- function Lua_KunXuHolyLandLevelVo.Get:rightMonsterId()
-- 	return self.config.monster_id;
-- end

-- 怪物阵容id
function Lua_KunXuHolyLandLevelVo.Get:monsterId()
	return self.config.monster_id;
end

-- 关卡通关奖励
function Lua_KunXuHolyLandLevelVo.Get:reward()
	return self.config.reward;
end




















