-- 难度等级
checkRequire("Lua_KunXuHolyLandLevelVo")
Lua_KunXuHolyLandStageVo = class("Lua_KunXuHolyLandStageVo")
function Lua_KunXuHolyLandStageVo:ctor(id, config)
	self.stageId = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig({ "holy_land_chapter", id });
    end

    if self.config == nil then
    	print("no KunXuHolyLandStage:", id);
    	return;
    end
    self:setLevelList();
    self:setStarRewardList();
end

function Lua_KunXuHolyLandStageVo:dispose()
	if self.starRewardList ~= nil then
		self.starRewardList = nil;
	end
	if self.levelList ~= nil then
		for k, v in pairs(self.levelList) do
			v:dispose();
			v = nil;
		end
		self.levelList = nil;
	end
	self.starRewardIdList = nil;
	self.levelIdList = nil;
	self.isShowPassReward = nil;
	self.isShowFullReward = nil;
end


function Lua_KunXuHolyLandStageVo:updateDataFromServer(stage_state, star_reward)
	self:updateLevelListState(stage_state);
	self:updateStarRewardState(star_reward);
end

-- function Lua_KunXuHolyLandStageVo:setStageData()
-- end

-- 该难度各星级阶段奖励设置
function Lua_KunXuHolyLandStageVo:setStarRewardList()
	if self.starRewardList == nil then
		self.starRewardList = {};
		self.starRewardIdList = {};

		local count = 0;
		local config = getConfig({ "holy_land_reward" });
		for k, v in pairs(config) do
			if v.chapter == self.stageId then
				count = count + 1;
				self.starRewardList[v.id] = {starId = v.id, starCondition = v.star_cond, reward = v.reward, receivedStage = 0, isShowReward = false, altas = v.altas, normalIcon = v.normal_icon, lightEffect = v.light_effect, openIcon = v.open_icon }; -- receivedStage:0不可领取 1可领取 2已领取
				self.starRewardIdList[count] = v.id;
			end
		end
		table.sort( self.starRewardIdList, function(a, b) 
			return self.starRewardList[a].starCondition < self.starRewardList[b].starCondition; end );
	end
end

-- 根据星级阶段id获取对应数据
function Lua_KunXuHolyLandStageVo:getStarRewardById(starStateId)
	if starStateId == nil or self.starRewardList == nil or self.starRewardList[starStateId] == nil then
		return;
	end
	return self.starRewardList[starStateId];
end

-- 更新各星级阶段的奖励领取状态
function Lua_KunXuHolyLandStageVo:updateStarRewardState(star_reward)
	local vo;
	local obj;
	for i = 1, #star_reward do
		obj = star_reward[i];
		vo = self:getStarRewardById(obj.key);
		if vo ~= nil then
			vo.receivedStage = obj.value;
		end
	end
end

-- 该难度的关卡设置
function Lua_KunXuHolyLandStageVo:setLevelList()
	if self.levelList == nil then
		self.levelList = {};
		self.levelIdList = {};

		local vo;
		local levelId;
		local count = 0;
		local config = getConfig({ "holy_land_stage" });		
		for k, v in pairs(config) do
			if v.chapter == self.stageId then
				levelId = v.id;
				vo = self:getLevelVoById(levelId);
				if vo == nil then
					count = count + 1;
					self.levelIdList[count] = levelId;
					self.levelList[levelId] = Lua_KunXuHolyLandLevelVo.new(levelId, v);
				end
			end
		end
		table.sort( self.levelIdList, function(a, b)
			return a < b;end );
	end
end

-- 根据关卡id获取对应数据
function Lua_KunXuHolyLandStageVo:getLevelVoById(levelId)
	if levelId == nil or self.levelList == nil or self.levelList[levelId] == nil then
		return;
	end
	return self.levelList[levelId];
end

-- 更新关卡列表
function Lua_KunXuHolyLandStageVo:updateLevelListState(stage_state)
	local vo;
	local obj;
	for i = 1, #stage_state do
		obj = stage_state[i];
		vo = self:getLevelVoById(obj.stage_id);
		if vo ~= nil then
			vo:updateStarList(obj.star_state);
		end
	end
end

-- 更新快速战斗数据
function Lua_KunXuHolyLandStageVo:updateQuickFightLevelListState(stage_state)
	local vo;
	local obj;
	for i = 1, #stage_state do
		obj = stage_state[i];
		vo = self:getLevelVoById(obj.stage_id);
		if vo ~= nil then
			vo:updateQuickFightStarList(obj.star_state);
		end
	end
end

-- 全通奖励是否已展示
function Lua_KunXuHolyLandStageVo.Get:isShowPassReward()
	if self._isShowPassReward == nil then
		self._isShowPassReward = false;
	end
	return self._isShowPassReward;
end

function Lua_KunXuHolyLandStageVo.Set:isShowPassReward(value)
	self._isShowPassReward = value;
end

-- 完美全通奖励是否已展示
function Lua_KunXuHolyLandStageVo.Get:isShowFullReward()
	if self._isShowFullReward == nil then
		self._isShowFullReward = false;
	end
	return self._isShowFullReward;
end

function Lua_KunXuHolyLandStageVo.Set:isShowFullReward(value)
	self._isShowFullReward = value;
end

-- -- 重置快速战斗记录的数据
-- function Lua_KunXuHolyLandStageVo:resetQuickFightMeet()
-- 	for k, v in pairs(self.levelList) do
-- 		v:resetIsCurMeet();
-- 	end
-- end

function Lua_KunXuHolyLandStageVo.Get:totalMonsterList()
	if self._totalMonsterList == nil then
		self._totalMonsterList = {};
		if self.levelIdList ~= nil then
			local vo;
			local monsterData;
			local count = 0;
			local monsterId;
			for i = 1, #self.levelIdList do		
				vo = self:getLevelVoById(self.levelIdList[i]);
				if vo ~= nil then 
					monsterData = vo:getMonsterModel();
					monsterId = monsterData[1].monsterId;
					if monsterId ~= nil then
						count = count + 1;
						self._totalMonsterList[count] = monsterId;
					end
					monsterId = monsterData[2].monsterId;
					if monsterId ~= nil then
						count = count + 1;
						self._totalMonsterList[count] = monsterId;
					end
				end
			end
		end
	end
	return self._totalMonsterList;
end


















-------------------------------------------配置表数据-----------------------------------
-- 难度等级
function Lua_KunXuHolyLandStageVo.Get:difficultyGrade()
	return self.config.grade;
end

-- 包含关卡数
function Lua_KunXuHolyLandStageVo.Get:levelCount()
	return self.config.stage;
end
	
-- 全通奖励
function Lua_KunXuHolyLandStageVo.Get:passReward()
	return self.config.pass_reward;
end

-- 完美通关奖励(只有困难有)
function Lua_KunXuHolyLandStageVo.Get:fullReward()
	if self.difficultyGrade == 2 then
		return self.config.full_reward;
	else
		return nil;
	end
end