--同调器数据
checkRequire("Lua_LifeTreeGridVo");
checkRequire("Lua_StatueEnergyCofingData");
Lua_LifeTreeData = class("Lua_LifeTreeData")
function Lua_LifeTreeData:ctor()
    self:superCall("ctor");
    self:dispose();
end

function Lua_LifeTreeData:dispose()
    self.cur_level = 0;
    self.stone_num = 0;
    self.curGridNum = 0;
    self.level_limit = 0;
    self.statue_level = 0;
    self.energy_num = 0;
    self.break_state = 0;

    self.isShowOpenWin = false;
    self.bInitLifeTree = false;--同调器数据初始化
    self.bInitStoneInfo = false;--英雄之力数据初始化

    self.tag_break = nil;
    self._guardGridArr = nil;--格子
    self.stone_prop_list = nil;
    self.statue_prop_list = nil;
    self.statueEnergyArr = nil;

    self.showHeroInfo = Array();
end

-- 守护格子配置数据
function Lua_LifeTreeData.Get:guardGridInfo()
    if self.isBreak == true and self.tag_break == nil then
        self._guardGridArr = nil;
        self.tag_break = 1;
    end

    if self._guardGridArr == nil then
        self._guardGridArr = Array();
        local len = DataCenter.lifeTreeUtil.grid_limit;
        if self.isBreak == true then
            len = len + DataCenter.lifeTreeUtil.enter_amount;
        end
        local config = getConfig({"life_tree_seat"}); 
        local vo;
        for i=1,#config do
            if i <= len then
                vo = Lua_LifeTreeGridVo.new(i,config[i]);
                vo.isUnlock = false;
                self._guardGridArr:add(vo);
            end
        end
    end

    return self._guardGridArr;
end

function Lua_LifeTreeData:fromServer50162001(msg)
    if msg == nil then
        return;
    end

    
    local id;
    local list = msg.column;
    self.curGridNum = #list;
    -- print("self.curGridNum = =",self.curGridNum)
    for i=1,#list do
        id = list[i].key;
        local vo = self.guardGridInfo[id];
        if vo ~= nil then
            vo:initializeInfo();
            vo.isUnlock = true;
            vo:fromServerInfo(list[i]);
        end
    end
    self:updateAheadUnlock();
    self.bInitLifeTree = true;

    self:checkGodTabRedDot()--同调器页签红点检测
end


-- 更新是否可以解锁状态
function Lua_LifeTreeData:updateAheadUnlock()
    local tag = self.curGridNum+1;
    if tag > self.maxGridNum then
        return;
    end
    local len = self.guardGridInfo:getSize();
    for i=1,len do
        self.guardGridInfo[i].isAheadUnlock = (i == tag);
    end
end

-- 最大格子数
function Lua_LifeTreeData.Get:maxGridNum()
    return self.guardGridInfo:getSize();
end

-- 是否已解锁最大格子
function Lua_LifeTreeData.Get:isUnlockMaxNum()
    return self.curGridNum == self.maxGridNum;
end


-- 英雄所在的格子id
function Lua_LifeTreeData:getGridIdByUid(uid)
    local len = self.guardGridInfo:getSize();
    for i=1,len do
        if self.guardGridInfo[i].hero_uid == uid then
            return self.guardGridInfo[i].grid_id;
        end
    end
    return 0;
end








------------------------------------ 同调器 ------------------------------------------------

-- 同调器数据
function Lua_LifeTreeData:fromServer80162001(msg)
    if msg == nil then
        return;
    end

    self.cur_level = msg.cur_level;    --同调器当前等级
    self.level_limit = msg.level_limit;--同调器当前等级上限
    self.break_state = msg.break_state;--突破状态（0：不可突破 1：可突破 2：已突破）
    self.fromServer80162001Msg = msg;
    if DataCenter.heroData == nil or DataCenter.heroData.bInitHeroInfo ~= true then
        return;
    end
    self:initLifeTreeInfo();
end

-- 初始化晶碑数据
function Lua_LifeTreeData:initLifeTreeInfo()
    if self.fromServer80162001Msg == nil then
        return;
    end

    self.showHeRedic = {};
    self.showHeroInfo:clear();
    local list = self.fromServer80162001Msg.idlist;
    for i=1, #list do
        self.showHeRedic[tonumber(list[i])] = i;
        self.showHeroInfo:add(tonumber(list[i]));
    end

    self.fromServer80162001Msg = nil;

    self:checkGodTabRedDot()--同调器页签红点检测
end


--获取英雄Uid所在的槽位索引
function Lua_LifeTreeData:getGridIndexByUid(uid)
    if self.showHeRedic == nil or self.showHeRedic[tonumber(uid)] == nil then
        return nil;
    end
    return self.showHeRedic[tonumber(uid)];
end

-- 英雄排序
function Lua_LifeTreeData:sortHeroInfo(arr)
    local len = arr:getSize();
    if len <= 1 then
        return;
    end
    for i = 1, len do
        for j = i + 1, len do
            local a = DataCenter.heroData:getItemByUniqueId(arr[i]).lifeTreeSort;
            local b = DataCenter.heroData:getItemByUniqueId(arr[j]).lifeTreeSort;   
            if a < b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end

--是否已突破
function Lua_LifeTreeData.Get:isBreak()
    return self.break_state == 2;
end

--是否激活同调器
function Lua_LifeTreeData.Get:isActivateLifeTree()
    local bool = self.showHeroInfo:getSize() == DataCenter.lifeTreeUtil.enter_amount;
    if bool == true or self.isBreak == true then
        return true;
    end
    return false;
end

--是否达到当前等级上限
function Lua_LifeTreeData.Get:isLevelLimit()
    return self.cur_level == self.level_limit;
end

--选择英雄
function Lua_LifeTreeData:selectShowHeroInfo(campType,select_uid)
    local arr = Array();
    local info = DataCenter.heroData.allHeroUidArr;
    if info ~= nil then
        local hvo;
        local uid;
        for i=1,info:getSize() do
            uid = info[i];
            hvo = DataCenter.heroData:getItemByUniqueId(uid);
            
            if self.showHeRedic[uid] == nil    -- 入住神位中的5名英雄，不会出现在英雄选择弹框中
                and hvo.is_resonance == false  -- 已经置入同调器守护槽中获得同调器等级的英雄，不会出现在英雄选择弹框中
                and hvo.level < self.cur_level -- 当前等级＝同调器等级的英雄，不会出现在英雄选择弹框中
                and hvo.dispatch_state == false-- 转换状态
                and hvo.initial_star > DataCenter.lifeTreeUtil.grid_select_limit-- 守护选择英雄初始星级限制
                then
                if hvo.campType == campType or campType == Lua_HeroUtil.All_TYPE then
                    arr:add({data = hvo, isSelect = uid == select_uid});
                end
            end 
        end
    end
    self:sortInfo(arr);
    return arr;
end

-- 英雄排序
function Lua_LifeTreeData:sortInfo(arr)
    local len = arr:getSize();
    if len <= 1 then
        return;
    end
    for i = 1, len do
        for j = i + 1, len do
            local a = arr[i].data.backSort;
            local b = arr[j].data.backSort;
            if a < b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end









------------------------------------ 同调器红点 ------------------------------------------------

--更新同调器页签红点检测
function Lua_LifeTreeData:checkGodTabRedDot()
    if self.bInitLifeTree == false then
        return false;
    end

    local showState = false
    if self.breakRedDot or self.gridUnlockRedDot or self.upgradeRedDot  then
        showState = true;
    end
    Lua_MsgUtil.callFunc("UPDATE_GOD_TAB_REDDOT");--同调器页签红点更新
    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Main_LifeTree_GodTab, showState);
end

--守护槽解锁红点
function Lua_LifeTreeData.Get:gridUnlockRedDot()
    if self.isUnlockMaxNum ~= true then
        local vo = self.guardGridInfo[self.curGridNum+1];
        if vo ~= nil and vo.unlockRedDot == true then
            return true;
        end
    end
    return false;
end

--同调器突破红点
function Lua_LifeTreeData.Get:breakRedDot()
    if self.break_state == 1 then -- 可突破
        return true;
    end
    return false;
end

--同调器升级红点
function Lua_LifeTreeData.Get:upgradeRedDot()
    if self.isBreak == true then
        local isMaxLevel = DataCenter.lifeTreeUtil:isMaxLevel(self.cur_level);
        if isMaxLevel ~= true and self.isLevelLimit ~= true then
            local cost_list = DataCenter.lifeTreeUtil:lifeTreeCost(self.cur_level);
            if cost_list ~= nil then
                for i=1, #cost_list do
                    local need_num = cost_list[i][2];
                    local bagNum = DataCenter.packData:getItemCountById(cost_list[i][1]);
                    if bagNum < need_num then
                        return false;
                    end
                end
            end
            return true;
        end
    end
    
    return false;
end
















------------------------------------ 星辉神殿 ------------------------------------------------

--英雄之力
function Lua_LifeTreeData:fromServer50189001(msg)
    if msg == nil then
        return;
    end
    self.statue_level = msg.level; --英雄之力等级
    self.stone_num = msg.stone_num;--已镶嵌宝石数量
    self.statue_cur_force = msg.cur_force;--当前英雄之力战力
    self.statue_next_force = msg.next_force - msg.cur_force;--下一级英雄之力战力
    self.statue_prop_list = msg.cur_prop_list;--当前英雄之力属性列表
    self.statue_next_prop_list = msg.next_prop_list;--下一级英雄之力属性列表
    if self.isShowOpenWin ~= true then
        self.energy_num = 0;
    end
    self.bInitStoneInfo = true;
    self:checkStatueTabRedDot();--英雄之力页签红点检测
end

--宝石镶嵌是否达到上限
function Lua_LifeTreeData.Get:isStonelimit()
   return self.stone_num >= DataCenter.lifeTreeUtil.inset_limit;
end

--星辉能量
function Lua_LifeTreeData:fromServer80189001(msg)
    if msg == nil then
        return;
    end
    
    self.energy_num = 0;
    self.statueEnergyArr = Array();
    local list = msg.id_list;
    if #list > 0 then
        local vo;
        local num = 0;
        for i=1,#list do
            vo = Lua_StatueEnergyCofingData.getConfigData(tonumber(list[i]));
            self.energy_num = self.energy_num + vo.energy_value;
            self.statueEnergyArr:add(vo);
        end
        if #list >1 then
            self.statueEnergyArr:sort("sort",true);
        end
    end
    self.isShowOpenWin = #list >= 1;--是否打开星辉能量收取界面

    self:checkStatueTabRedDot();--英雄之力页签红点检测
end









------------------------------------ 英雄之力红点 ------------------------------------------------

--英雄之力页签红点检测
function Lua_LifeTreeData:checkStatueTabRedDot()
    if self.bInitStoneInfo == false then
        return false;
    end

    local showState = false;
    -- print(self.stoneRedDot,"  英雄之力页签红点检测 ",self.energyRedDot)
    if self.stoneRedDot == true or self.energyRedDot == true then
        showState = true;
    end

    Lua_MsgUtil.callFunc("UPDATE_STATUE_TAB_REDDOT");--英雄之力页签红点更新
    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Main_LifeTree_StatueTab, showState);
end

--英雄之力升级红点
function Lua_LifeTreeData.Get:statueUpgradeRedDot()
    local data = DataCenter.lifeTreeUtil:getStarStatueInfo(self.statue_level);
    if data.next_id ~= nil and data.next_id ~= 0 then--未满级
        local item_id = data.cost[1][1];
        local have_num = DataCenter.packData:getItemCountById(item_id);
        local need_num = data.cost[1][2];
        if have_num >= need_num then --能量是否够升级
            return true;
        end
    end
    return false;
end

--英雄之力 当前能量 + 可收取能量 是否够升级
function Lua_LifeTreeData.Get:energyRedDot()
    local data = DataCenter.lifeTreeUtil:getStarStatueInfo(self.statue_level);
    if data == nil then
        return
    end
    if data.next_id ~= nil and data.next_id ~= 0 then--未满级
        local item_id = data.cost[1][1];
        local have_num = DataCenter.packData:getItemCountById(item_id);
        local need_num = data.cost[1][2];
        if have_num >= need_num then --能量是否足够
            return true;
        else
            --当前能量 + 可收取能量 是否够升级
            if have_num + self.energy_num >= need_num then
                return true;
            end
        end
    end
    return false;
end

--宝石镶嵌红点
function Lua_LifeTreeData.Get:stoneRedDot()
    if self.isStonelimit == true then
        return false;
    end

    local have_num = DataCenter.packData:getItemCountById(Lua_PackDefine.STAR_STONE);
    if have_num > 0 then 
        return true;
    end
    return false;
end