-- 生命神树
checkRequire("Lua_LifeTreeData");
checkRequire("Lua_LifeTreeUtil");

Lua_LifeTreeProxy = class("Lua_LifeTreeProxy");
function Lua_LifeTreeProxy:ctor()
    DataCenter.lifeTreeUtil = Lua_LifeTreeUtil.new(); -- 英雄配置数据
    DataCenter.lifeTreeData = Lua_LifeTreeData.new(); -- 英雄数据

    Lua_MsgUtil.addLuaMsg(50162002, self, self.rPutHero); -- 守护英雄栏位(返回)
    Lua_MsgUtil.addLuaMsg(50162001, self, self.rLifeTreeGridInfo); -- 守护英雄栏位(返回)
    Lua_MsgUtil.addLuaMsg(80162001, self, self.updateLifeTreeInfo);-- 生命神树状态(通知)
    Lua_MsgUtil.addLuaMsg(80162007, self, self.rLifeTreeCostInfo); -- 生命神树资源返还(通知)

    Lua_MsgUtil.addLuaMsg(50189001, self, self.rStatue);      -- 请求星辉神像界面(返回)
    Lua_MsgUtil.addLuaMsg(80189001, self, self.rStatueEnergy);-- 请求获取星辉能量(返回)

    Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.updateLifeRedDotByItem);--获取道具更新红点
    Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateLifeRedDotByResource);--获取道具更新红点
end


----------------------------------------------------------------------------------------------------------------------------
-- 上行消息号

-- 请求生命神树信息
function Lua_LifeTreeProxy:slifeTreeInfo()
    sendMsg(10162001);
end

-- 英雄放入栏位
function Lua_LifeTreeProxy:sPutHero(hero_uid, grid_id)
    -- print(hero_uid," 英雄放入栏位 ",grid_id)
    local cmd = ProtoPublic_pb.Proto10162002();
    cmd.uid = tonumber(hero_uid);
    cmd.num = tonumber(grid_id);
    sendMsg(10162002, cmd);
end

-- 英雄退出栏位
function Lua_LifeTreeProxy:sDemountHero(grid_id)
    -- print(" 英雄退出栏位 ",grid_id)
    local cmd = ProtoPublic_pb.Proto10162003();
    cmd.num = tonumber(grid_id);
    sendMsg(10162003, cmd);
end

-- 刷新栏位冷却
function Lua_LifeTreeProxy:sRefreshGrid(grid_id)
    -- print(" 刷新栏位冷却 ",grid_id)
    local cmd = ProtoPublic_pb.Proto10162004();
    cmd.num = tonumber(grid_id);
    sendMsg(10162004, cmd);
end

-- 解锁守护栏位
function Lua_LifeTreeProxy:sUnlockGrid(type)
    -- print(" 解锁守护栏位 ",grid_id)
    local cmd = ProtoPublic_pb.Proto10162005();
    cmd.type = tonumber(type);
    sendMsg(10162005, cmd);
end

-- 生命神树升级
function Lua_LifeTreeProxy:sUpgrade()
    -- print(" 生命神树升级 ")
    sendMsg(10162006);
end

-- 请求星辉神像界面
function Lua_LifeTreeProxy:sStatue()  
    -- print(" 请求星辉神像界面 ")
    sendMsg(10189001);
end

-- 请求星辉神像升级
function Lua_LifeTreeProxy:sStatueUpgrade()  
    -- print(" 请求星辉神像升级 ")
    sendMsg(10189002);
end

-- 请求获取星辉能量
function Lua_LifeTreeProxy:sGetStatueEnergy()  
    -- print(" 请求获取星辉能量 ")
    sendMsg(10189004);
end

-- 请求星辉宝石镶嵌
function Lua_LifeTreeProxy:sStoneInlay()
    -- print(" 请求星辉宝石镶嵌 ")
    sendMsg(10189006);
end

-- 生命神树突破
function Lua_LifeTreeProxy:sBreak()
    -- print(" 生命神树突破 ")
    sendMsg(10162008);
end








----------------------------------------------------------------------------------------------------------------------------
-- 下行消息号

-- 守护英雄栏位(返回)
function Lua_LifeTreeProxy:rLifeTreeGridInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50162001();
        msg:ParseFromString(mp.data);
        --print("守护英雄栏位(返回)")
        DataCenter.lifeTreeData:fromServer50162001(msg);
        Lua_MsgUtil.callFunc("LIFE_TREE_GRID_INFO");
    end
end

-- 生命神树状态(通知)
function Lua_LifeTreeProxy:updateLifeTreeInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80162001();
        msg:ParseFromString(mp.data);
        -- print("生命神树状态(通知)")
        DataCenter.lifeTreeData:fromServer80162001(msg);
        Lua_MsgUtil.callFunc("LIFE_TREE_INFO");
    end
end

-- 生命神树资源返还(通知)
function Lua_LifeTreeProxy:rLifeTreeCostInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80162007();
        msg:ParseFromString(mp.data);
        -- print("生命神树资源返还(通知)")
        Lua_WindowUtil.openWin("Lua_GodTreeTipsWindow", Lua_WinParam.ACTION_OPEN, msg);
    end
end


-- 英雄放入栏位(返回)
function Lua_LifeTreeProxy:rPutHero(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50162002();
        msg:ParseFromString(mp.data);
        -- print("英雄放入栏位(返回)",msg.unique_id)
        Lua_WindowUtil.openWin("Lua_GuardPutTipsWindow", Lua_WinParam.ACTION_OPEN, tonumber(msg.unique_id));
    end
end

-- 请求星辉神像界面(返回)
function Lua_LifeTreeProxy:rStatue(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50189001();
        msg:ParseFromString(mp.data);
        -- print("请求星辉神像界面(返回))")
        DataCenter.lifeTreeData:fromServer50189001(msg);
        Lua_MsgUtil.callFunc("GOD_STATUE_INFO");
    end
end

-- 请求获取星辉能量(返回)
function Lua_LifeTreeProxy:rStatueEnergy(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80189001();
        msg:ParseFromString(mp.data);
        -- print("请求获取星辉能量(返回)")
        DataCenter.lifeTreeData:fromServer80189001(msg);
    end
end









----------------------------------------------------------------------------------------------------------------------------
-- 红点更新

-- 获取到资源更新红点
function Lua_LifeTreeProxy:updateLifeRedDotByResource(dic)
    if dic[Lua_ResourcesDefine.GOLD] --金币
    or dic[Lua_ResourcesDefine.HERO_EXP] --英雄经验
    or dic[Lua_ResourcesDefine.STAR_LUCK]--原石
    then
        DataCenter.lifeTreeData:checkGodTabRedDot();--同调器
    end

    if dic[Lua_ResourcesDefine.HERO_PROVE] ~= nil then --英雄之证
        DataCenter.lifeTreeData:checkStatueTabRedDot();--英雄之力
    end
end


-- 获取道具更新红点
function Lua_LifeTreeProxy:updateLifeRedDotByItem(dic)
    if dic[Lua_PackDefine.ORDE_STONE] ~= nil then --进阶石
        DataCenter.lifeTreeData:checkGodTabRedDot();--同调器
    end

    if dic[Lua_PackDefine.STAR_STONE] ~= nil then --英灵宝石
        DataCenter.lifeTreeData:checkStatueTabRedDot();--英雄之力
    end
end