checkRequire("Lua_LimitTimeGiftVo");
Lua_LimitTimeGiftData = class("Lua_LimitTimeGiftData");
function Lua_LimitTimeGiftData:ctor()
	self:dispose();
end

function Lua_LimitTimeGiftData:dispose()
	self.typeDic = {}; -- 未结束类型的活动置为1
	self.limitTimeGiftDic = {}; -- key礼包id value配置表数据+服务端数据
	self.limitTypeArr = Array(); -- 礼包类型集合
	self.giftIdsArr = Array(); -- 未结束活动id集合
	self.recordPopupInfo = Array(); -- 记录要弹出的信息
end

function Lua_LimitTimeGiftData:fromServer50197020(msg)
	if msg == nil then
		return;
	end
	self:updateGiftState(msg.gift_state);
end

function Lua_LimitTimeGiftData:fromServer80197020(msg)
	if msg == nil then
		return;
	end
	self:updateGiftState(msg.gift_state);
end

function Lua_LimitTimeGiftData:updateGiftState(list)
	self.limitTypeArr:clear();
	self.giftIdsArr:clear();

	local obj;
	local vo;
	local endTime;
	local minTime;
	local maxTime = 0;
	self.typeDic = {};
	for i = 1, #list do
		obj = list[i];
		vo = self:getlimitTimeGiftVo(obj.gift_id);
		if vo == nil then
			vo = Lua_LimitTimeGiftVo.new(obj.gift_id);
			self.limitTimeGiftDic[obj.gift_id] = vo;
		end
		vo:updateServerInfo(obj);

		endTime = vo.endTime;
		if endTime > 0 then
			if self.typeDic[vo.giftType] == nil then
				self.typeDic[vo.giftType] = 1;
				self.limitTypeArr:add(vo.giftType);
			end
			self.giftIdsArr:add(obj.gift_id);
		end

		if obj.is_open == 1 then -- is_open 是否弹出新弹窗 0不弹出 1弹出
			self:judgePopupInfo(vo);
		end
		maxTime = endTime > maxTime and endTime or maxTime;
		if minTime == nil then
			minTime = endTime;
		else
			minTime = minTime > endTime and endTime or minTime;
		end
	end
	self.limitTypeArr:sort(nil, false);

	self:checkPopupInfo();
	DataCenter.mainMenuData:setIconShowInfo(Lua_MenuViewDefine.ICON_LIMIT_TIME_GIFT, maxTime > 0, maxTime);
	Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	if minTime ~= nil and minTime > 0 then
		Lua_CommonUtil.delayCall(minTime, self, self.updateLeftTime);
	end
end

function Lua_LimitTimeGiftData:getlimitTimeGiftVo(id)
	if self.limitTimeGiftDic[id] ~= nil then
		return self.limitTimeGiftDic[id];
	end
	return;
end

-- 同一类型，后面阶段的覆盖前面的
function Lua_LimitTimeGiftData:judgePopupInfo(giftInfo)
	local vo;
	local isAdd = true;
	local arr = Array();
	for i = 1, self.recordPopupInfo:getSize() do
		vo = self.recordPopupInfo:remove(1);
		if vo.giftType == giftInfo.giftType then
			if vo.endTime > 0 and vo.process > giftInfo.process then
				isAdd = false;
				arr:add(vo);
			end
		else
			if vo.endTime > 0 then
				arr:add(vo);
			end
		end
	end
	self.recordPopupInfo = arr;
	if isAdd then
		self.recordPopupInfo:add(giftInfo);
	end
end

function Lua_LimitTimeGiftData:updateLeftTime()
	Lua_ProxyManager.getProxy("Lua_LimitTimeGiftProxy"):sLimitTimeGiftInfo();
end










---------------------------------------- 外部方法 ----------------------------------------
function Lua_LimitTimeGiftData:checkPopupInfo()
	-- print("checkPopupInfo", self.recordPopupInfo:getSize());
	if DataCenter.sceneData.curSceneId == Lua_SceneDefine.MAINCITY and self.recordPopupInfo:getSize() > 0 then
		local popupInfo = self.recordPopupInfo:remove(1);
		Lua_WindowUtil.openWin("Lua_LimitTimeGiftWindow", Lua_WinParam.ACTION_OPEN, popupInfo);
	end
end

function Lua_LimitTimeGiftData:getGiftShowArr(giftType)
	local vo;
	local arr = Array();
	for i = 1, self.giftIdsArr:getSize() do
		vo = self:getlimitTimeGiftVo(self.giftIdsArr[i]);
		if vo.giftType == giftType then
			arr:add(vo);
		end
	end
	arr:sort("process", false);
	return arr;
end

function Lua_LimitTimeGiftData:getGiftShowState(giftType)
	return self.typeDic[giftType] == 1;
end

function Lua_LimitTimeGiftData.Get:limitTimeConst()
	if self._limitTimeConst == nil then
		self._limitTimeConst = getConfig("time_limit_gift", "const");
	end
	return self._limitTimeConst;
end