Lua_LimitTimeGiftVo = class("Lua_LimitTimeGiftVo");
function Lua_LimitTimeGiftVo:ctor(id)
	self.id = id;
	self.config = getConfig("time_limit_gift", id);

	if self.config == nil then
		LogManager.LogError("no time_limit_gift config id：" .. id, false);
	end
end

function Lua_LimitTimeGiftVo:updateServerInfo(msg)
	self.closeTick = msg.close_tick; -- 礼包关闭时间戳
	self.leftTimes = msg.times; -- 礼包剩余次数
	self.isOpen = msg.is_open; -- 是否弹出新弹窗 0不弹出 1弹出
end

function Lua_LimitTimeGiftVo.Get:endTime()
	return self.closeTick - DataCenter.roleData.serverTime;
end

-- 礼包类型
function Lua_LimitTimeGiftVo.Get:giftType()
	return self.config.gift_type;
end

-- 阶段
function Lua_LimitTimeGiftVo.Get:process()
	return self.config.process;
end

function Lua_LimitTimeGiftVo.Get:recharge()
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.id);
	return tonumber(rechargeInfo.money);
end

-- 限购次数
function Lua_LimitTimeGiftVo.Get:limitTimes()
	return self.config.limit_times;
end

-- 奖励道具
function Lua_LimitTimeGiftVo.Get:rewardItem()
	return self.config.reward_item;
end

-- 返利数值
function Lua_LimitTimeGiftVo.Get:sloganValue()
	return self.config.slogan_value;
end

-- 标语
function Lua_LimitTimeGiftVo.Get:desStr()
	return self.config.des_str;
end