Lua_StarRiverTrialData = class("Lua_StarRiverTrialData")
function Lua_StarRiverTrialData:ctor()
	self:dispose();
end

function Lua_StarRiverTrialData:dispose()
	
end

function Lua_StarRiverTrialData:fromServer50197028(msg)
	self.total_star = msg.total_star; -- 总星数
	self.curr_rank = msg.curr_rank; -- 当前排名
	self.close_tick = msg.close_tick; -- 活动结束时间戳
	self.drawIdList = msg.draw_list; --已领取id列表
	self.hasLogin = msg.first_login; -- 今日是否已经登录过,0没登录过，1已经登录过
    
    self:updateStateInfo();
    self:updateRedPoint();
end

function Lua_StarRiverTrialData:fromServer50197029(msg)
	if msg == nil then
		return;
	end
	self.rank_list = msg.rank_list; --排名信息列表
	self.myself_rank = msg.myself_rank; --自身排名信息
end

function Lua_StarRiverTrialData:updateStateInfo()
	local vo;
	local state;
	for i = 1, #self.config do
		vo = self:getRewardVoById(self.config[i].id);
		if self.total_star < vo.star_amount then
			state = 0;
		else
			state = 1;
			for j = 1, #self.drawIdList do
				if vo.id == self.drawIdList[j] then
					state = 2;
					break;
				end
			end
		end
		vo:fromServer(state);
	end
end

function Lua_StarRiverTrialData.Get:config()
	if self._config == nil then
		self._config = getConfig({"star_river_trial"});
	end
	return self._config;
end

function Lua_StarRiverTrialData.Get:rankRewardConfig()
	return getConfig({"star_river_trial_rank"});
end

function Lua_StarRiverTrialData:getRankRewardConfig(rank)
	local config = self.rankRewardConfig;
	if rank == 0 then
		if config[#config].rank_right == 0 then
			return config[#config];
		end
	end
	for i = 1, #config do
		if rank <= config[i].rank_right and rank >= config[i].rank_left then
			return config[i];
		end
	end
	return nil;
end

function Lua_StarRiverTrialData:getRewardVoById(id)
	if self.rewardVoList == nil then
		self.rewardVoList = {};
	end
	if self.rewardVoList[id] == nil then
		self.rewardVoList[id] = Lua_StarRiverRewardVo.new(id);
	end
	return self.rewardVoList[id];
end

function Lua_StarRiverTrialData:getRedPointState()
	local isOver = DataCenter.starRiverTrialData.close_tick - DataCenter.roleData.serverTime <= 0;
	return self._canDraw and not isOver or self.hasLogin == 0;
end

function Lua_StarRiverTrialData:updateRedPoint()
	local state = self:getRedPointState();
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LimitedTimeAct_StarRiverTrial, state);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.StarTrial_River, state);
	if Lua_WindowUtil.isWindowShowing("Lua_StarTrialWindow") then
		DataCenter.starTrialData:updateStarRiverBtnRedPoint(state);
	end
end







Lua_StarRiverRewardVo = class("Lua_StarRiverRewardVo")
function Lua_StarRiverRewardVo:ctor(id)
	self.id = id;
	self.config = getConfig({"star_river_trial", id});
end

function Lua_StarRiverRewardVo:fromServer(state)
	self.state = state; -- 0未完成，1可领取，2已领取
end

function Lua_StarRiverRewardVo.Get:star_amount()
	return self.config.star_amount;
end

function Lua_StarRiverRewardVo.Get:reward()
	return self.config.reward;
end

function Lua_StarRiverRewardVo.Get:sort()
	if self.state == 0 then
		return 1;
	elseif self.state == 1 then
		return 0;
	else
		return 2;
	end
end