Lua_LuckyGiftBoxData = class("Lua_LuckyGiftBoxData");
function Lua_LuckyGiftBoxData:ctor()
	self:dispose();
end

function Lua_LuckyGiftBoxData:dispose()
	self.actIdx = nil;
	self.showState = false;
	self.curGiftIdx = nil;
	self.curSelectIdx = nil;
	self.selecdtingIdx = 1;
	self.drawCount = 0;
	self.recordBestGift = {};
	self.luckyBoxInfoDic = {};
	self.bestGiftInfoDic = {};
	self.detailInfoDic = {};
end

-- 幸运礼盒界面信息
function Lua_LuckyGiftBoxData:fromServer50108012(msg)
	if msg == nil then
		return;
	end

	self.box_max_count = msg.box_max_count; -- 礼盒最大数量
	self.activity_item_id = msg.activity_item_id; -- 活动道具id
	self.advance_gift_id = msg.advance_gift_id; -- 终极礼盒道具id
	self.advance_gift_amount = msg.advance_gift_amount; -- 终极奖励道具数量
	self.cost_item_id = msg.cost_item_id; -- 当前消耗道具id
	self.cost_item_amount = msg.cost_item_amount; -- 当前消耗道具数量
	self.cost_type = msg.cost_type; -- 当前消耗道具类型 1原价钻石 2折扣钻石 3活动道具
	self.cost_residue_times = msg.cost_residue_times; -- 钻石抽取剩余次数
	self.cost_max_times = msg.cost_max_times; -- 钻石使用上限次数
	self.icon_config = msg.icon_config; -- 图标配置 key 图集 value 图片名
	self.is_last_round = msg.is_last_round; -- 是否最后一轮:0 否 1 是
	self.drawCount = #msg.reward_state; -- 已抽的礼盒个数
	self.actIdx = msg.act_index; -- 后台活动索引

	if #msg.reward_state == 0 then
		self.luckyBoxInfoDic = {};
		self.recordBestGift = {};
	end

	local obj;
	local vo;
	local hasBestGift;
	for i = 1, #msg.reward_state do
		obj = msg.reward_state[i];
		vo = self.luckyBoxInfoDic[obj.cell_index];
		if vo == nil then
			self.curGiftIdx = obj.cell_index; -- 奖励位置索引 

			vo = {};
			vo.tvo = Lua_ToolVo.createToolVo(obj.gift_id, obj.gift_amount);
			vo.cell_index = obj.cell_index;
			self.luckyBoxInfoDic[obj.cell_index] = vo;
		end

		if msg.advance_gift_id == obj.gift_id and obj.gift_amount == msg.advance_gift_amount then
			self.recordBestGift[msg.advance_gift_id] = msg.advance_gift_amount;
		end
	end

	Lua_MsgUtil.callFunc("UPDATE_LUCKYGIFTBOX_INFO");
end

-- 判断终极奖励是否抽中
function Lua_LuckyGiftBoxData.Get:isDraw()
	if self.recordBestGift[self.advance_gift_id] == nil then
		return false;
	end
	return true;
end

-- 终极礼盒界面信息
function Lua_LuckyGiftBoxData:fromServer50108017(msg)
	if msg == nil then
		return;
	end

	self.round = msg.round; -- 当前轮次
	self.advance_gift_id = msg.advance_gift_id; -- 终极奖励道具id
	self.advance_gift_amount = msg.advance_gift_amount; -- 终极奖励道具数量

	local obj;
	local vo;
	local info;
	for i = 1, #msg.advance_gift_state do
		obj = msg.advance_gift_state[i];
		if self.bestGiftInfoDic[obj.round] == nil then
			self.bestGiftInfoDic[obj.round] = {};
			self.bestGiftInfoDic[obj.round].round = obj.round;
			self.bestGiftInfoDic[obj.round].info = {};
		end
		info = self.bestGiftInfoDic[obj.round].info;

		vo = info[obj.cell_index];
		if vo == nil then
			vo = {};
			vo.tvo = Lua_ToolVo.createToolVo(obj.gift_id, obj.gift_amount);
			vo.cell_index = obj.cell_index; -- 轮次位置索引
			vo.round = obj.round; -- 轮次
			vo.limit_level = obj.limit_level; -- 限制等级

			info[obj.cell_index] = vo;
		end
	end

	self.curSelectIdx = self:getCurSelectIdx(self.bestGiftInfoDic[msg.round].info);
end

-- 当前终极奖励道具索引
function Lua_LuckyGiftBoxData:getCurSelectIdx(data)
	local curSelectIdx;
	for i = 1, #data do
		if data[i].tvo.id == self.advance_gift_id and data[i].tvo.count == self.advance_gift_amount then
			curSelectIdx = i;
			break;
		end
	end
	return curSelectIdx;
end

-- 幸运礼盒详情界面信息
function Lua_LuckyGiftBoxData:fromServer50108018(msg)
	if msg == nil then
		return;
	end

	local obj;
	local vo;
	for i = 1, #msg.lucky_box_info do
		obj = msg.lucky_box_info[i];
		vo = self.detailInfoDic[i];
		if vo == nil then
			vo = {};
			vo.tvo = Lua_ToolVo.createToolVo(obj.gift_id, obj.gift_amount);

			self.detailInfoDic[i] = vo;
		end

		vo.limit_times = obj.limit_times; -- 礼包上限次数
		vo.residue_times = obj.residue_times; -- 礼包剩余次数
	end
end
