checkRequire("Lua_MailData");
Lua_MailProxy = class("Lua_MailProxy");
function Lua_MailProxy:ctor()
    DataCenter.mailData = Lua_MailData.new();

    Lua_MsgUtil.addLuaMsg(80104001, self, self.nAddMailItem);
    Lua_MsgUtil.addLuaMsg(50104002, self, self.rGetMailInfo);
    Lua_MsgUtil.addLuaMsg(50104003, self, self.rUpdataOneMailItemInfo);
    Lua_MsgUtil.addLuaMsg(50104004, self, self.rUpdataMailInfo);
    Lua_MsgUtil.addLuaMsg(50104005, self, self.removeMailItem);
end

-------------------- 返回 --------------------

-- 新邮件通知（通知）
function Lua_MailProxy:nAddMailItem(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80104001();
        msg:ParseFromString(mp.data);
        local bCheckTip = false;
        for i = 1, #msg.mail_list do
            DataCenter.mailData:addOrUpdataMailItem(msg.mail_list[i], false);
            if bCheckTip ~= true and tonumber(msg.mail_list[i].mail_id) == 1057 then
                bCheckTip = true;
            end
        end
        DataCenter.mailData:showMainIconRedDot();
        if bCheckTip and Lua_WindowUtil.isWindowShowing("Lua_SponsorPlayWindow")==false then
            -- DataCenter.redDotUtil:updateRedDotVoById(10064, true);
        end
    end
end

-- 获取玩家邮件列表（返回）
function Lua_MailProxy:rGetMailInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50104002();
        msg:ParseFromString(mp.data);
        DataCenter.mailData:fromServer50104002(msg);
    end
end

-- 获取单个邮件详细信息（返回）
function Lua_MailProxy:rUpdataOneMailItemInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50104003();
        msg:ParseFromString(mp.data);
        DataCenter.mailData:addOrUpdataMailItem(msg.mail_info);
        Lua_MsgUtil.callFunc("UPDATA_MAILITEM_ONE", msg.mail_info);
    end
end

-- 提取邮件附件（返回）
function Lua_MailProxy:rUpdataMailInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50104004();
        msg:ParseFromString(mp.data);
        for i = 1, #msg.mail_list do
            DataCenter.mailData:addOrUpdataMailItem(msg.mail_list[i], false);
        end
        DataCenter.mailData:showMainIconRedDot();
        Lua_MsgUtil.callFunc("UPDATA_MAILITEM_LIST", msg.mail_list);
    end
end

-- 删除邮件（返回）
function Lua_MailProxy:removeMailItem(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50104005();
        msg:ParseFromString(mp.data);
        for i = 1, #msg.mail_id_list do
            DataCenter.mailData:removeMailItem(msg.mail_id_list[i], false);
        end
        DataCenter.mailData:showMainIconRedDot();
        Lua_MsgUtil.callFunc("REMOVE_MAILITEM", msg.mail_id_list);
    end
end





-------------------- 请求 --------------------

-- 获取玩家邮件列表
function Lua_MailProxy:sGetMailInfo()
    sendMsg(10104002);
end

-- 获取单个邮件详细信息
function Lua_MailProxy:sGetSingleMailInfo(mail_id)
    local msg = ProtoPublic_pb.Proto10104003();
    msg.mail_id = mail_id;
    sendMsg(10104003, msg);
end

-- 提取邮件附件
function Lua_MailProxy:sReceiveMailItem(mail_id)
    local msg = ProtoPublic_pb.Proto10104004();
    msg.mail_id = mail_id;
    sendMsg(10104004, msg);
end

-- 删除邮件
function Lua_MailProxy:sRemoveMailItem(data)
    local msg = ProtoPublic_pb.Proto10104005();
    if type(data) == "table" then
        for i = 1, data:getSize() do
            msg.mail_id_list:append(data[i].mail_id);
        end
    else
        msg.mail_id_list:append(data);
    end
    sendMsg(10104005, msg);
end