-- 属性动画显示
Lua_AttrChangeTipsWindow = class("Lua_AttrChangeTipsWindow", Lua_Window);
function Lua_AttrChangeTipsWindow:ctor()
    self:superCall("ctor");
    self.isFullSizeWin = true;
    self.windowName = "Lua_AttrChangeTipsWindow";
    self.openSound = nil;
    self.closeSound = nil;
end

function Lua_AttrChangeTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.bTweenPos = true;

    self.star_posx = Lua_CommonUtil.getCommonConfig("attr_star_posx", 1);--初始位置
    self.distance = Mathf.Abs(self.star_posx);--初始位置
    self.attr_offect = Lua_CommonUtil.getCommonConfig("attr_offect", 4);--回弹系数
    self.attr_interval = Lua_CommonUtil.getCommonConfig("attr_interval", 4);--属性间隔时间
    self.delay = Lua_CommonUtil.getCommonConfig("attr_delay_time", 1);--延时多久后开始向上渐变隐藏
    self.alpha_time = Lua_CommonUtil.getCommonConfig("attr_alpha_time", 4);--淡入
    self.alpha_time = Lua_CommonUtil.getCommonConfig("attr_alpha_time", 4);--属性逐条出现速度
end

function Lua_AttrChangeTipsWindow:dispose()
    if self.attrInfo ~= nil then
        for i=1, self.attrInfo:getSize() do
            TweenUtil.getInstance():stop(self.attrInfo[i].mainContent);
        end
        self.attrInfo:dispose();
        self.attrInfo:clear();
        self.attrInfo = nil;
    end
    Lua_CommonUtil.removeTimer(self, self.startAlphaTweenTimer);
    Lua_CommonUtil.removeTimer(self, self.showAlphaTweenTimer);
    self:superCall("dispose");
end

function Lua_AttrChangeTipsWindow:showWin(param)
    self:superCall("showWin",param);
    -- self.bTweenPos = true;
    -- local param = Array();
    -- local attrVo;
    -- for i=1, 14 do
    --     attrVo = DataCenter.attributesUtil:createAttrVo("health");
    --     attrVo.value = 50000;
    --     param:add(attrVo);
    -- end

    Lua_CommonUtil.removeTimer(self, self.startAlphaTweenTimer);
    Lua_CommonUtil.removeTimer(self, self.showAlphaTweenTimer);

    self.target_num = 0;
    self.show_len = param:getSize();
    self:showAttributes(param);

    if self.bTweenPos then--TweenPos动画只播一次；
        self.bTweenPos = false;
        self.offsetX = self.distance;
        self:showTweenTargetPos();
    else
        self.offsetX = 0;
        self:startDelayTimer();
    end
end

--属性展示
function Lua_AttrChangeTipsWindow:showAttributes(arr)
    if self.attrInfo == nil then
        self.attrInfo = Array();
    end

    local len = self.attrInfo:getSize();
    for i = 1, len do
        self.attrInfo[i]:setEnable(false);
    end
    local alpha = self.bTweenPos and 0 or 1;
    local distance = self.bTweenPos and 0 or self.distance;
    local item;
    for i = 1, arr:getSize() do
        item = self.attrInfo[i];
        if item == nil then
            item = Lua_AttrChangeItem.new(self.content);
            -- item:setRectAnchor(1);
            self.attrInfo:add(item);
        end
        TweenUtil.getInstance():stop(self.attrInfo[i].mainContent);
        item:setData(arr[i]);
        item:setAlpha(alpha);
        item:setEnable(true);
        item:setLocation(self.star_posx + distance, 253 - (i-1)*41, 0);
    end
end

function Lua_AttrChangeTipsWindow:showTweenTargetPos()
    local item;
    local delayTime = 0;
    local len = self.attrInfo:getSize();
    for i=1,len do
        item = self.attrInfo[i];
        itemX = item.posX;
        itemY = item.posY;
        if i > 0 then
            delayTime = delayTime + self.attr_interval;
        end

        TweenUtil.getInstance():stop(item.mainContent);
        TweenUtil.getInstance():addTweenTargetAlpha(item.mainContent, 0.2, delayTime, 1, false);
        TweenUtil.getInstance():addTweenTargetPos(item.mainContent, 0.2, delayTime, item.posX + self.distance, item.posY, 0, 
            self, self.onTweenTargetPos, self.attr_offect, false, 0);
    end
end

function Lua_AttrChangeTipsWindow:onTweenTargetPos()
    self.target_num = self.target_num + 1;
    if self.target_num == self.show_len then
        self:startDelayTimer();
    end
end

function Lua_AttrChangeTipsWindow:startDelayTimer()
    Lua_CommonUtil.addTimer("startAlphaTweenTimer", self.delay, self, self.startAlphaTweenTimer);
end

function Lua_AttrChangeTipsWindow:startAlphaTweenTimer()
    Lua_CommonUtil.removeTimer(self, self.startAlphaTweenTimer);
    local delayTime = 0;
    local len = self.attrInfo:getSize();
    for i=1, len do
        TweenUtil.getInstance():stop(self.attrInfo[i].mainContent);
        if i > 0 then
            delayTime = delayTime + 0.05;
        end
        self.attrInfo[i]:init(delayTime, self.offsetX);
    end
    
    self.starTime = getTime();
    Lua_CommonUtil.addTimer("showAlphaTweenTimer", 0.01, self, self.showAlphaTweenTimer);
end

function Lua_AttrChangeTipsWindow:showAlphaTweenTimer()
    local diff = getTime() - self.starTime;
    local len = self.attrInfo:getSize();
    for i=1,len do
        if self.attrInfo[i].bEndAlphaTween then
            if i == len then
                Lua_CommonUtil.removeTimer(self, self.showAlphaTweenTimer);
                self:hide();
            end
        else
            self.attrInfo[i]:updateTweenAlpha(diff);
        end
    end
end































-- 属性展示
Lua_AttrChangeItem = class("Lua_AttrChangeItem", Lua_DisplayObject);
function Lua_AttrChangeItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_AttrChangeItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bg_spr = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_mask_01", 0, 0, 200, 38);

    self.name_txt = UICreate.createLabel(self.content, nil, -89, 0, 100, 40, 26);
    self.name_txt.pivot = UIUtils.Pivot.Left;
    self.name_txt.fontName = "huakang_font";
    self.name_txt.alignmentValue = 3;
    self.name_txt.horizontalOverflowValue = 1;
    self.name_txt.effectStyle = 2
    self.name_txt.effectColorStr = Lua_ColorDefine.transColor("000000");
    self.name_txt:setEffectDistance(2, 2)

    self.attr_txt = UICreate.createLabel(self.content, nil, 0, 0, 100, 40, 26);
    self.attr_txt.pivot = UIUtils.Pivot.Left;
    self.attr_txt.fontName = "huakang_font";
    self.attr_txt.alignmentValue = 3;
    self.attr_txt.horizontalOverflowValue = 1;
    self.attr_txt.effectStyle = 2;
    self.attr_txt.colorStr = Lua_ColorDefine.transColorStr("5bca49");
    self.attr_txt.effectColorStr = Lua_ColorDefine.transColor("000000");
    self.attr_txt:setEffectDistance(2, 2)
end

function Lua_AttrChangeItem:setData(attrVo)
    self.name_txt.text = attrVo.show_name;
    self.name_txt:resetSize();

    self.attr_txt.text = "+"..attrVo.showValue;
    self.attr_txt:setLocation(-89 + self.name_txt.width+5, 0, 0)
    self.attr_txt:resetSize();
end

function Lua_AttrChangeItem:setAlpha(value)
    self.bg_spr.alpha = value;
    self.name_txt.alpha = value;
    self.attr_txt.alpha = value;
end

--初始化
function Lua_AttrChangeItem:init(delayTime, offsetX)
    self.delayTime = delayTime;
    self.posYSpeed = 3;--移动速度
    self.diffPosY = self.posY;
    
    self.endAlpha = 0;
    self.curAlpha = 1;
    self.alphaSpeed = 0.1;--速度

    self.bEndAlphaTween = false;
    self.curPosX = self.posX + offsetX;
    self:setAlphaAndPos(self.curAlpha, self.curPosX, self.posY);
end

function Lua_AttrChangeItem:updateTweenAlpha(diff)
    local diff = diff - self.delayTime;
    if diff <= 0 or self.bEndAlphaTween then
        return;
    end
    self.diffPosY = self.diffPosY + diff + self.posYSpeed;
    self.curAlpha = self.curAlpha - self.alphaSpeed;
    if self.curAlpha <= self.endAlpha then
        self.curAlpha = self.endAlpha;
        self.bEndAlphaTween = true;
    end
    self:setAlphaAndPos(self.curAlpha, self.curPosX, self.diffPosY);
end

function Lua_AttrChangeItem:setAlphaAndPos(curAlpha, posX, posY)
    self.bg_spr.alpha = curAlpha;
    self.name_txt.alpha = curAlpha;
    self.attr_txt.alpha = curAlpha;
    LuaUtil.setObjPos(self.content, posX, posY, 0);
end

function Lua_AttrChangeItem.Get:bEndAlphaTween()
    if self._bEndAlphaTween == nil then
        return false;
    end
    return self._bEndAlphaTween;
end

function Lua_AttrChangeItem.Set:bEndAlphaTween(val)
    self._bEndAlphaTween = val;
end

function Lua_AttrChangeItem:dispose()
    if self.bg_spr ~= nil then
        self.bg_spr:dispose();
        self.bg_spr = nil;
    end
    if self.attr_txt ~= nil then
        self.attr_txt:dispose();
        self.attr_txt = nil;
    end
    self:superCall("dispose");
end