--战力变动
Lua_ForceChangeTipsWindow = class("Lua_ForceChangeTipsWindow", Lua_Window);
function Lua_ForceChangeTipsWindow:ctor()
    self:superCall("ctor");
    self.isFullSizeWin = true;
    self.windowName = "Lua_ForceChangeTipsWindow";
    self.openSound = nil;
    self.closeSound = nil;
end

function Lua_ForceChangeTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.bTweenScale = true;
    self.banner = UICreate.createUIAtlasImage(self.content, "number", "xui_zl5_number_017", 20, 327, 0, 0);

    self.curForce = Lua_NumberImage.new(self.content);
    self.curForce:setLocation(-106, 327, 0);
    self.curForce.preStr = "xui_zl3_number_0";
    self.curForce.numAtlas = "number"
    self.curForce.pivot = 1;
    self.curForce.numOffsetX = -11;

    self.addForce = Lua_NumberImage.new(self.content);
    self.addForce.preStr = "xui_zl4_number_0";
    self.addForce.numAtlas = "number"
    self.addForce.pivot = 1;
    self.addForce.numOffsetX = -8;

    self.uiEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_zd_zlts_0001", "ui_zd_zlts_0001", 0, 327);
end

function Lua_ForceChangeTipsWindow:dispose()
    -- TweenUtil.getInstance():stop(self.content);
    Lua_CommonUtil.removeTimer(self, self.addForceTimer);
    Lua_CommonUtil.removeTimer(self, self.startAlphaTweenTimer);
    Lua_CommonUtil.removeTimer(self, self.forceChangeDelayCall);
    
    self.banner = nil;
    if self.curForce ~= nil then
        self.curForce:dispose();
        self.curForce = nil;
    end
    if self.addForce ~= nil then
        self.addForce:dispose();
        self.addForce = nil;
    end    
    if self.showEff ~= nil then
        self.showEff:dispose();
        self.showEff = nil;
    end

    if self.attrInfo ~= nil then
        self.attrInfo:dispose();
        self.attrInfo:clear();
        self.attrInfo = nil;
    end

    if self.uiEffect ~= nil then
        self.uiEffect:dispose();
        self.uiEffect = nil;
    end
    self:superCall("dispose");
end

function Lua_ForceChangeTipsWindow:showWin(param)
    self:superCall("showWin", param);

    self.banner.alpha = 1;
    self.curForce:setAlpha(1);
    self.curForce.num = numImageTrans(param.oldForce, nil, 0);

    self.addForce:setLocation(-100 + self.curForce.totalWidth, 327, 0);
    self.addForce:setAlpha(1);
    self.addForce.num = "0";

    self.diffForce = param.newForce - param.oldForce;

    Lua_CommonUtil.removeTimer(self, self.addForceTimer);
    Lua_CommonUtil.removeTimer(self, self.forceChangeDelayCall);
    Lua_CommonUtil.removeTimer(self, self.startAlphaTweenTimer);
    
    -- self:startScaleTween();--战力缩放
    self:startAlphaTween();--战力显隐

    if self.uiEffect ~= nil then
        self.uiEffect:setEnable(false);
        self.uiEffect:setEnable(true);
    end
end

--战力缩放
function Lua_ForceChangeTipsWindow:startScaleTween()
    if self.bTweenScale then
        self.bTweenScale = false;
        TweenUtil.getInstance():stop(self.content);
        TweenUtil.getInstance():addTweenTargetScale(self.content, 0.2, 0, 1.1, 1.1, 1.1, self, self.showScaleTween);
    end
end

function Lua_ForceChangeTipsWindow:showScaleTween()
    TweenUtil.getInstance():stop(self.content);
    TweenUtil.getInstance():addTweenTargetScale(self.content, 0.2, 0, 1, 1, 1);
end




--战力显隐
function Lua_ForceChangeTipsWindow:startAlphaTween()
    Lua_CommonUtil.removeTimer(self, self.startAlphaTween);
    self.forceAlphaVo = Lua_ForceAlphaVo.new(self.diffForce)
    Lua_CommonUtil.addTimer("addForceTimer", 0.07, self, self.addForceTimer);
end

function Lua_ForceChangeTipsWindow:addForceTimer()
    self.addForce.preStr = self.diffForce > 0 and "xui_zl4_number_0" or "xui_zl5_number_0";
    self.addForce.num = self.forceAlphaVo.curAddForce;
    if self.forceAlphaVo.bAddForceEnd then
        Lua_CommonUtil.removeTimer(self, self.addForceTimer);
        local delay = Lua_CommonUtil.getCommonConfig("force_delay_time", 4);
        Lua_CommonUtil.addTimer("forceChangeDelayCall", delay, self, self.forceChangeDelayCall, nil, 1);
    end
end

function Lua_ForceChangeTipsWindow:forceChangeDelayCall()
    Lua_CommonUtil.removeTimer(self, self.forceChangeDelayCall);
    Lua_CommonUtil.addTimer("startAlphaTweenTimer", self.forceAlphaVo.interval, self, self.startAlphaTweenTimer);
end

function Lua_ForceChangeTipsWindow:startAlphaTweenTimer()
    -- self.forceAlphaVo:updatePosY();
    -- LuaUtil.setObjPos(self.object, 0, -450 + self.forceAlphaVo.diffposY, 0);
    self.forceAlphaVo:updateAlpha()
    self.banner.alpha = self.forceAlphaVo.curAlpha
    self.curForce:setAlpha(self.forceAlphaVo.curAlpha)
    self.addForce:setAlpha(self.forceAlphaVo.curAlpha)
    if self.forceAlphaVo.bEndAlpha then
        Lua_CommonUtil.removeTimer(self, self.startAlphaTweenTimer);
        self:hide();
    end
end























Lua_ForceAlphaVo = class("Lua_ForceAlphaVo");
Lua_ForceAlphaVo.ADD = 1
Lua_ForceAlphaVo.REDUCE = 0
function Lua_ForceAlphaVo:ctor(targetAddForce)
    self:superCall("ctor");
    self.startAlpha = 1;
    self.endAlpha = 0;
    self.alphaSpeed = 0.1;--速度
    self.curAlpha = 1;--当前alpha值
    self.interval = 0.01;--每次的执行间隔
    self.targetAddForce = Mathf.Abs(targetAddForce)--目标增加战力
    self.curForce = 0;
    self.addForceCount = Lua_CommonUtil.getCommonConfig("force_ratio_count",1);--战力变化比值（值越小，战力变快越快）
    self.changeType = targetAddForce > 0 and Lua_ForceAlphaVo.ADD or Lua_ForceAlphaVo.REDUCE--1-增加战力 0-减少战力

    self.startTime = getTime();
    -- self.diffposY = 0;
    -- self.posSpeed = 5;--上移速度
end

--每次改变的战力值
function Lua_ForceAlphaVo.Get:diffTime()
    return getTime() - self.startTime
end

--战力向上移动
-- function Lua_ForceAlphaVo:updatePosY()
--     self.diffposY = self.diffposY + (self.diffTime + self.posSpeed);
-- end

function Lua_ForceAlphaVo:updateAlpha()
    self.curAlpha = self.curAlpha - self.alphaSpeed
end

--是否结束
function Lua_ForceAlphaVo.Get:bEndAlpha()
    return self.curAlpha < self.endAlpha
end

--每次改变的战力值
function Lua_ForceAlphaVo.Get:everytimeChangeForce()
    if self.targetAddForce < self.addForceCount then
        return 1;
    end
    return Mathf.Floor(self.targetAddForce / self.addForceCount)
end

function Lua_ForceAlphaVo.Get:curAddForce()
    self.curForce = self.curForce + self.everytimeChangeForce
    if self.bAddForceEnd then
        self.curForce = self.targetAddForce
    end
    return string.format("%s%s", self.changeType == Lua_ForceAlphaVo.ADD and "+" or "-", numImageTrans(self.curForce, nil, 0))
end

function Lua_ForceAlphaVo.Get:bAddForceEnd()
    return self.curForce >= self.targetAddForce
end