-- 主界面窗口基类
Lua_MainBaseWindow = class("Lua_MainBaseWindow", Lua_Window);
function Lua_MainBaseWindow:ctor()
    self:superCall("ctor");
    
    self.windowName = "Lua_MainBaseWindow";
    self.isFullSizeWin = true;
    self.openSound = nil;
    self.closeSound = nil;

    self.itemDic = {};
    self.showStateDic = {};
end

function Lua_MainBaseWindow:buildShowItem()
    self:superCall("buildShowItem");

    self:addLuaEvent("UPDATE_MAIN_MENU", self, self.onUpdateMainMenu);
    if Lua_WindowUtil.isWinInitComplete("Lua_MainCityWindow") then
        self:onUpdateMainMenu();
    end
end

function Lua_MainBaseWindow:dispose()
    if self.itemDic ~= nil then
        for k,v in pairs(self.itemDic) do
            if v.item ~= nil then
                TweenUtil.getInstance():stop(v.item.mainContent);
                v.item:dispose();
                v.item = nil;
            end
        end
        self.itemDic = nil;
    end
    self:superCall("dispose");
end

function Lua_MainBaseWindow:onScreenResize()
    self:superCall("onScreenResize");
    self:updateShowHidePos();
end

function Lua_MainBaseWindow:updateShowHidePos()

end

function Lua_MainBaseWindow:onUpdateMainMenu(list)
    if self.menuList == list then
        return;
    end
    self.menuList = list;

    for _, v in pairs(self.itemDic) do
        if v.item ~= nil then
            TweenUtil.getInstance():stop(v.item.mainContent);
        end
    end

    local tab = DataCenter.mainMenuData.menuStateDic
    for k, _ in pairs(tab) do
        DataCenter.mainMenuData:setMenuState(k, false)
    end

    if list ~= nil then
        for _, v in pairs(list) do
            DataCenter.mainMenuData:setMenuState(v, true)
        end
    end
    
    self:updateShowHide();
end

function Lua_MainBaseWindow:updateShowHide()
    local tab = DataCenter.mainMenuData.menuStateDic
    for k,v in pairs(tab) do
        local t = self.itemDic[k];
        if t ~= nil and t.item ~= nil then
            if v == true then
                TweenUtil.getInstance():addTweenTargetPos(t.item.mainContent, 0.2, 0, t.showPos.x, t.showPos.y, t.showPos.z);
            else
                TweenUtil.getInstance():addTweenTargetPos(t.item.mainContent, 0.2, 0, t.hidePos.x, t.hidePos.y, t.hidePos.z);
            end
        end
    end
end