-- 除主菜单外的主界面窗口
checkRequire("Lua_MainBaseWindow");
checkRequire("Lua_TopLeftPanel");
-- checkRequire("Lua_TopRightPanel");
checkRequire("Lua_TopRightShrinkPanel");
checkRequire("Lua_DownRightPanel");
checkRequire("Lua_ChatInfoMiniPanel");
checkRequire("Lua_TaskPanel");
checkRequire("Lua_AllianceRedPacketNoticePanel");
Lua_MainMenuWindow = class("Lua_MainMenuWindow", Lua_MainBaseWindow);
function Lua_MainMenuWindow:ctor()
    self:superCall("ctor");
    
    self.layer = MainWinDefine.BASE_LAYER;
    self.windowName = "Lua_MainMenuWindow";
end

function Lua_MainMenuWindow:buildPanel(go)
    self:superCall("buildPanel", go);

     self:addLuaEvent("UPDATE_TASK_STATE", self, self.updateTaskState);
     self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.updateLeagueState);
end

function Lua_MainMenuWindow:buildShowItem()
    self:superCall("buildShowItem");
    
    DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_TOPLEFT, false)
    -- DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_TOPRIGHT, false)
    DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_TOPRIGHT_SHRINK, false)
    DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_DOWNRIGHT, false)
    DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_TASK, false)
    DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_CHAT, false)
    DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_LEAGUE_REDPACKET, false)

    local w = MainWinDefine.V_width;
    -- local h = MainWinDefine.V_height;
    -- local half_w = MainWinDefine.V_width / 2;
    local half_h = MainWinDefine.V_height / 2;

    self.topLeftPanel = Lua_TopLeftPanel.new(self.content);
    self.topLeftPanel:setRectAnchor(0);
    self.topLeftPanel:setLocation(-w, 0, 0);

    self.topRightShrinkPanel = Lua_TopRightShrinkPanel.new(self.content);
    self.topRightShrinkPanel:setRectAnchor(2);
    self.topRightShrinkPanel:setLocation(w, 0, 0);

    self.downRightPanel = Lua_DownRightPanel.new(self.content);
    self.downRightPanel:setRectAnchor(8);
    self.downRightPanel:setLocation(w, 0, 0);
    
    self.chatInfoPanel = Lua_ChatInfoMiniPanel.new(self.content);
    self.chatInfoPanel:setRectAnchor(7);
    self.chatInfoPanel:setLocation(0, -half_h, 0);

    self:updateShowHidePos();
    self:updateTaskState();
    self:updateLeagueState();
end

function Lua_MainMenuWindow:updateShowHidePos()
    local w = MainWinDefine.V_width;
    -- local h = MainWinDefine.V_height;
    -- local half_w = MainWinDefine.V_width / 2;
    local half_h = MainWinDefine.V_height / 2;

    self.itemDic[Lua_MenuViewDefine.INDEX_TOPLEFT] = { item = self.topLeftPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3( -w, 0, 0) };
    self.itemDic[Lua_MenuViewDefine.INDEX_TOPRIGHT_SHRINK] = { item = self.topRightShrinkPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(w, 0, 0) };
    self.itemDic[Lua_MenuViewDefine.INDEX_DOWNRIGHT] = { item = self.downRightPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(w, 0, 0) };
    self.itemDic[Lua_MenuViewDefine.INDEX_CHAT] = { item = self.chatInfoPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(0, -half_h, 0) };
    if self.itemDic[Lua_MenuViewDefine.INDEX_TASK] ~= nil and self.taskPanel ~= nil then
        self.itemDic[Lua_MenuViewDefine.INDEX_TASK] = { item = self.taskPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(-w, 0, 0) };
    end
    if self.itemDic[Lua_MenuViewDefine.INDEX_LEAGUE_REDPACKET] ~= nil and self.leagueRedPacketPanel ~= nil then
        self.itemDic[Lua_MenuViewDefine.INDEX_LEAGUE_REDPACKET] = { item = self.leagueRedPacketPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(w, 0, 0) };
    end
end

function Lua_MainMenuWindow:updateTaskState()
    if DataCenter.taskData.openState == false then
        if self.taskPanel ~= nil then
            self.taskPanel:dispose();
            self.taskPanel = nil;
        end
        self.itemDic[Lua_MenuViewDefine.INDEX_TASK] = nil;
    else
        if self.taskPanel == nil then
            local w = MainWinDefine.V_width;
            self.taskPanel = Lua_TaskPanel.new(self.content);
            self.taskPanel:setRectAnchor(6);
            if DataCenter.mainMenuData:getMenuState(Lua_MenuViewDefine.INDEX_TASK) then
                self.taskPanel:setLocation(0, 0, 0);
            else
                self.taskPanel:setLocation(-w, 0, 0);
            end
            self.itemDic[Lua_MenuViewDefine.INDEX_TASK] = { item = self.taskPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(-w, 0, 0) };
        end
    end
end

function Lua_MainMenuWindow:updateLeagueState()
    if DataCenter.roleData:isJoinTheLeague() then
        if self.leagueRedPacketPanel == nil then
            local w = MainWinDefine.V_width;
            self.leagueRedPacketPanel = Lua_AllianceRedPacketNoticePanel.new(self.content);
            self.leagueRedPacketPanel:setRectAnchor(8);
            if DataCenter.mainMenuData:getMenuState(Lua_MenuViewDefine.INDEX_LEAGUE_REDPACKET) then
                self.leagueRedPacketPanel:setLocation(0, 0, 0);
            else
                self.leagueRedPacketPanel:setLocation(w, 0, 0);
            end
            self.itemDic[Lua_MenuViewDefine.INDEX_LEAGUE_REDPACKET] = { item = self.leagueRedPacketPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(w, 0, 0) };
        end
    else
        if self.leagueRedPacketPanel ~= nil then
            self.leagueRedPacketPanel:dispose();
            self.leagueRedPacketPanel = nil;
        end
        self.itemDic[Lua_MenuViewDefine.INDEX_LEAGUE_REDPACKET] = nil;
    end
end