-- 角色信息界面
checkRequire("Lua_MainBaseWindow");
checkRequire("Lua_RoleInfoPanel");
checkRequire("Lua_LiuHaiMaskPanel");
Lua_RoleInfoWindow = class("Lua_RoleInfoWindow", Lua_MainBaseWindow);
function Lua_RoleInfoWindow:ctor()
    self:superCall("ctor");
    self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
    self.windowName = "Lua_RoleInfoWindow";
end

function Lua_RoleInfoWindow:buildShowItem()
    self:superCall("buildShowItem");

    DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_LIUHAI, false)
    DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_ROLEINFO, false)

    -- local w = MainWinDefine.V_width;
    -- local h = MainWinDefine.V_height;
    -- local half_w = MainWinDefine.V_width / 2;
    local half_h = MainWinDefine.V_height / 2;

    self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content);
    self.roleInfoPanel:setRectAnchor(1);
    self.roleInfoPanel:setLocation(0, half_h, 0);

    self:checkLiuHaiMask();
    self:updateShowHidePos();
end

function Lua_RoleInfoWindow:dispose()
    self:superCall("dispose");
end

function Lua_RoleInfoWindow:onScreenResize()
    self:superCall("onScreenResize");
    self:checkLiuHaiMask();
end

function Lua_RoleInfoWindow:checkLiuHaiMask()
    local height = GlobalVar.screenOffsetTopH;
    if height > 0 then
        if self.liuHaiMaskPanel == nil then
            local half_h = MainWinDefine.V_height / 2;
            self.liuHaiMaskPanel = Lua_LiuHaiMaskPanel.new(self.content);
            self.liuHaiMaskPanel:setRectAnchor(1);
            self.liuHaiMaskPanel:setLocation(0, half_h, 0);
            self.itemDic[Lua_MenuViewDefine.INDEX_LIUHAI] = { item = self.liuHaiMaskPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(0, half_h, 0) };
        end
        self.liuHaiMaskPanel:setLiuHaiMask(height);
    else
        if self.liuHaiMaskPanel then
            self.liuHaiMaskPanel:setLiuHaiMask(0);
        end
    end
end

function Lua_RoleInfoWindow:updateShowHidePos()
    -- local w = MainWinDefine.V_width;
    -- local h = MainWinDefine.V_height;
    -- local half_w = MainWinDefine.V_width / 2;
    local half_h = MainWinDefine.V_height / 2;
    if self.itemDic[Lua_MenuViewDefine.INDEX_LIUHAI] and self.liuHaiMaskPanel then
        self.itemDic[Lua_MenuViewDefine.INDEX_LIUHAI] = { item = self.liuHaiMaskPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(0, half_h, 0) };
    end
    self.itemDic[Lua_MenuViewDefine.INDEX_ROLEINFO] = { item = self.roleInfoPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(0, half_h, 0) };
end