-- 左上角图标
Lua_TopLeftPanel = class("Lua_TopLeftPanel", Lua_DisplayObject);
function Lua_TopLeftPanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_TopLeftPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.startX = 49;
    self.startY = -182.5;
    self.spaceX = 100;
    self.spaceY = -100;
    self.iconShowArr = Array();
    self.iconHideArr = Array();

    self:addLuaEvent("TOP_MENUICON_UPDATE", self, self.onUpdateIcon);
    self:addLuaEvent("MENUICON_SINGLE_UPDATE", self, self.onUpdateIcon);
    self:showIcon();
end

function Lua_TopLeftPanel:dispose()
    if self.iconShowArr then
        self.iconShowArr:dispose();
        self.iconShowArr:clear();
        self.iconShowArr = nil;
    end
    if self.iconHideArr then
        self.iconHideArr:dispose();
        self.iconHideArr:clear();
        self.iconHideArr = nil;
    end
    self.iconDic = nil;
    self:superCall("dispose");
end

function Lua_TopLeftPanel:showIcon()
    self:returnIcon();
    self.iconDic = {};

    local arr = DataCenter.mainMenuData.topLeftIconArr;
    if arr == nil then
        DataCenter.mainMenuData:updateTopIconData();
        return;
    end
    local len = arr:getSize();
    local count = 7;
    local hIdx = 1; -- 横行
    local vIdx = 1; -- 竖列

    local vo;
    local icon;
    local iconArr = Array();
    local fixedDic = {};
    for i = 1, len do
        vo = arr[i];
        
        icon = self:addIcon();
        icon:setData(vo);
        self.iconDic[vo.uniqueId] = icon;

        if vo.isFixed == false then
            iconArr:add(icon);
        else
            if hIdx > count then -- 前n列满count个，则n+1列重新开始
                hIdx = 1;
                vIdx = vIdx + 1;
            end
            if fixedDic[hIdx] == nil then
                fixedDic[hIdx] = {};
            end
            fixedDic[hIdx][vIdx] = icon;
            hIdx = hIdx + 1;
        end
    end
    iconArr:sort("sortNum", false);

    len = iconArr:getSize();
    count = 4;
    local i = 1;
    local idx = 1;
    local num = 3; -- 前n行显示count，后续count+1，依次类推
    local posX;
    local posY;
    while (i <= len) do
        if idx < count or idx % count == 0 then
            hIdx = Mathf.Floor(idx / (count + 1)) + 1;
        else
            hIdx = Mathf.Floor(idx / count) + 1;
        end
        vIdx = idx % count;
        vIdx = vIdx == 0 and count or vIdx;

        posX = self.startX + (vIdx - 1) * self.spaceX;
        posY = self.startY + (hIdx - 1) * self.spaceY;
        if fixedDic[hIdx] == nil or fixedDic[hIdx][vIdx] == nil then
            iconArr[i]:setLocation(posX, posY, 0);
            i = i + 1;
        end

        idx = idx + 1;
        if idx > (count * num) then
            if count == 5 then
                idx = idx + num;
            end
            count = 6;
        end
    end

    for _hIdx, dic in pairs(fixedDic) do
        for _vIdx, _icon in pairs(dic) do
            posX = self.startX + (_vIdx - 1) * self.spaceX;
            posY = self.startY + (_hIdx - 1) * self.spaceY;
            _icon:setLocation(posX, posY, 0);
        end
    end
end

function Lua_TopLeftPanel:addIcon()
    local len = self.iconHideArr:getSize();
    local icon = nil;
    if len > 0 then
        icon = self.iconHideArr:remove(1);
        icon:setEnable(true);
    end

    if icon == nil then
        icon = Lua_MainMenuIcon.new(self.content);
    end
    self.iconShowArr:add(icon);
    return icon;
end

function Lua_TopLeftPanel:returnIcon()
    local len = self.iconShowArr:getSize();
    local icon;
    while len > 0 do
        icon = self.iconShowArr:remove(len);
        self.iconDic[icon.uniqueId] = nil;
        icon:setData(nil);
        icon:setLocation(0, 0, 0);
        icon:setEnable(false);
        self.iconHideArr:add(icon);
        len = len - 1;
    end
end

function Lua_TopLeftPanel:onUpdateIcon(param)
    if param == nil or self.iconDic == nil then
        self:showIcon();
    else
        if type(param) == "number" then
            if self.iconDic[param] ~= nil then
                self.iconDic[param]:updateData();
            end
        end
    end
end