-- 右上角收缩图标
Lua_TopRightShrinkPanel = class("Lua_TopRightShrinkPanel", Lua_DisplayObject);
function Lua_TopRightShrinkPanel:ctor(p)
    self:superCall("ctor", p, "TopRightShrinkPanel_skin", true);
end

function Lua_TopRightShrinkPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.iconShowArr = Array();
    self.iconHideArr = Array();
    self.openState = DataCenter.mainMenuData.bTopRightShrinkState;
    self.startX = -61;
    self.startY = -145;
    self.showCount = 1;
    self.showHeight = 0;
    self.startHeight = 0;
    self.targetHeight = 0;
    self.startPosY = 0;
    self.targetPosY = 0;
    self.moveDistance = 0;
    self.upArrowPosY = 0;
    self.upBgHeight = 0;

    self.showImg.clickScale = false;
    self.showImg:addClickFuntion(self, self.onShowImgClick);
    self.btnArrow:addClickFuntion(self, self.onBtnArrowClick);

    self:addLuaEvent("TOP_MENUICON_UPDATE", self, self.onUpdateIcon);
    self:addLuaEvent("MENUICON_SINGLE_UPDATE", self, self.onUpdateIcon);
    self:showIcon();
    self:checkRedDot();
end

function Lua_TopRightShrinkPanel:dispose()
    self:removeTween();
    if self.btnArrow then
        TweenUtil.getInstance():stop(self.btnArrow.mainContent);
    end

	local icon;
    if self.iconShowArr ~= nil then
        while self.iconShowArr:getSize() > 0 do
            icon = self.iconShowArr:remove();
            self.iconDic[icon.uniqueId] = nil;
            TweenUtil.getInstance():stop(icon.mainContent);
            icon:dispose();
            icon = nil;
        end
        self.iconShowArr:dispose();
        self.iconShowArr:clear();
        self.iconShowArr = nil;
    end

    if self.iconHideArr ~= nil then
        while self.iconHideArr:getSize() > 0 do
            icon = self.iconHideArr:remove();
            TweenUtil.getInstance():stop(icon.mainContent);
            icon:dispose();
            icon = nil;
        end
        self.iconHideArr:dispose();
        self.iconHideArr:clear();
        self.iconHideArr = nil;
    end

    if self.redDot ~= nil then
        self.redDot:dispose();
        self.redDot = nil;
    end

    self.iconDic = nil;
    self:superCall("dispose");
end

function Lua_TopRightShrinkPanel:onShowImgClick(go)

end

function Lua_TopRightShrinkPanel:onBtnArrowClick(go)
    if self.bStartTween == true then
        return;
    end

    local len = self.iconShowArr:getSize();
    if self.showCount >= len then
        return;
    end
    
	self.openState = not self.openState;
    DataCenter.mainMenuData.bTopRightShrinkState = self.openState;
    if self.openState then
		for i = self.showCount + 1, self.iconShowArr:getSize() do
            self.iconShowArr[i]:addAlphaTween(0, 1, 0.3);
            TweenUtil.getInstance():stop(self.iconShowArr[i].mainContent);
            TweenUtil.getInstance():addTweenTargetPos(self.iconShowArr[i].mainContent, 1, 0, self.startX, self.iconShowArr[i].data.posY, 0, 0, false);
        end

        TweenUtil.getInstance():stop(self.btnArrow.mainContent);
        TweenUtil.getInstance():addTweenTargetPos(self.btnArrow.mainContent, 1, 0, -60, self.upArrowPosY - self.moveDistance, 0, 0, false);
    else
		for i = self.showCount + 1, self.iconShowArr:getSize() do
            self.iconShowArr[i]:addAlphaTween(1, 0, -0.3);
            TweenUtil.getInstance():stop(self.iconShowArr[i].mainContent);
            TweenUtil.getInstance():addTweenTargetPos(self.iconShowArr[i].mainContent, 1, 0, self.startX, self.startY, 0, 0, false);
        end

        TweenUtil.getInstance():stop(self.btnArrow.mainContent);
        TweenUtil.getInstance():addTweenTargetPos(self.btnArrow.mainContent, 1, 0, -60, self.upArrowPosY, 0, 0, false);
	end

    self.startTime = getTime();
    if self.bStartTween ~= true then
        self.bStartTween = true;
        Lua_CommonUtil.addTimer("TopRightShrinkPanelTimer", 0.01, self, self.onTween, nil, -1);
    end
end

function Lua_TopRightShrinkPanel:onTween()
    local dt = getTime() - self.startTime;
    if dt * 3 >= 1 then
        self:removeTween();
        self:checkRedDot();
        if self.openState then
            self.showImg:SetDimensions(113, self.upBgHeight + self.moveDistance);
        else
            self.showImg:SetDimensions(113, self.upBgHeight);
        end
        return;
    end

    local bh;
    if self.openState == true then
        if dt * 3 > 1 then
            bh = self.upBgHeight + self.moveDistance;
        else
            bh = self.upBgHeight + self.moveDistance * dt * 3;
        end
    else
        if dt * 3 > 1 then
            bh = self.upBgHeight;
        else
            bh = self.upBgHeight + self.moveDistance * (1 - dt * 3);
        end
    end
    self.showImg:SetDimensions(113, bh);
end

function Lua_TopRightShrinkPanel:removeTween()
    if self.bStartTween == true then
        self.bStartTween = false;
        Lua_CommonUtil.removeTimer(self, self.onTween);
    end
end

function Lua_TopRightShrinkPanel:setBgAndArrow()
    if self.openState == true then
        self.showImg:SetDimensions(113, self.upBgHeight + self.moveDistance);
        self.btnArrow:setLocation(-60, self.upArrowPosY - self.moveDistance, 0);
    else
        self.showImg:SetDimensions(113, self.upBgHeight);
        self.btnArrow:setLocation(-60, self.upArrowPosY, 0);
    end
end

function Lua_TopRightShrinkPanel:showIcon()
    self.moveDistance = 0;
    self.upArrowPosY = 0;
    self.upBgHeight = 0;
    self.iconDic = {};
    self:returnIcon();
    
    local arr = DataCenter.mainMenuData.topRightIconArr;
    if arr == nil then
        DataCenter.mainMenuData:updateTopIconData();
        return;
    end

    local len = arr:getSize();
    if len <= 0 then
        self.showImg:setEnable(false);
        self.btnArrow:setEnable(false);
        return;
    end
    self.showImg:setEnable(true);
    self.btnArrow:setEnable(true);

    local width = 160; -- 背景初始高度
    local posY = Mathf.Abs(self.showImg.posY) + width - 21.5; -- 箭头初始位置
    local spaceY;
    local reduiseTime = 0;
    if len <= self.showCount then -- 去掉缓动
        self:removeTween();
        self.showImg:SetDimensions(113, width);
        self.btnArrow:setLocation(-60, -posY, 0);
        TweenUtil.getInstance():stop(self.btnArrow.mainContent);
    else
        self.upArrowPosY = -posY;
        self.upBgHeight = width
        for i = 1, len do
            if arr[i].leftTime > 0 then
                spaceY = 122.5;
            else
                spaceY = 100;
            end

            if i > 1 and i > self.showCount then
                if i > self.showCount then
                    self.moveDistance = self.moveDistance + spaceY;
                else
                    self.upArrowPosY = self.upArrowPosY + (-spaceY);
                    self.upBgHeight = self.upBgHeight + spaceY;
                end
            end
        end
        
        if self.bStartTween == true then
            reduiseTime = 1 - (getTime() - self.startTime);
            if reduiseTime < 0 then
                reduiseTime = 0;
            end

            if reduiseTime > 0 then
                TweenUtil.getInstance():stop(self.btnArrow.mainContent);
                if self.openState == true then
                    TweenUtil.getInstance():addTweenTargetPos(self.btnArrow.mainContent, reduiseTime, 0, -60, self.upArrowPosY - self.moveDistance, 0, 0, false);
                else
                    TweenUtil.getInstance():addTweenTargetPos(self.btnArrow.mainContent, reduiseTime, 0, -60, self.upArrowPosY, 0, 0, false);
                end
            else
                self:setBgAndArrow();
            end
        else
            self:setBgAndArrow();
        end
    end

    local vo;
    local icon;
    for i = 1, len do
        vo = arr[i];

        icon = self:addIcon();
        icon:setData(vo);
        self.iconDic[vo.uniqueId] = icon;

        vo.posX = self.startX;
        if i == 1 then
            posY = self.startY;
        else
            posY = posY + spaceY;
        end
        vo.posY = posY;

        if i <= self.showCount then
            icon:setAlpha(1);
            icon:setIconEffShow(true);
            icon:setLocation(self.startX, posY, 0);
        else
            if self.openState == true then
                if reduiseTime > 0 then -- 缓动
                    icon:setLocation(self.startX, posY * (1 - reduiseTime), 0);
                    TweenUtil.getInstance():addTweenTargetPos(icon.mainContent, 1, 0, self.startX, posY, 0, 0, false);
                else
                    icon:setLocation(self.startX, posY, 0);
                end
                icon:setAlpha(1);
                icon:setIconEffShow(true);
            else
                icon:setAlpha(0);
                icon:setIconEffShow(false);
                icon:setLocation(self.startX, self.startY, 0);
            end
        end

        if vo.leftTime > 0 then
            spaceY = -122.5;
        else
            spaceY = -100;
        end
    end
end

function Lua_TopRightShrinkPanel:addIcon()
    local icon;
    local len = self.iconHideArr:getSize();
    if len > 0 then
        icon = self.iconHideArr:remove(len);
        icon:setEnable(true);
    else
        icon = Lua_MainMenuIcon.new(self.content);
    end
    self.iconShowArr:add(icon);
    return icon;
end

function Lua_TopRightShrinkPanel:returnIcon()
    local icon;
    local len = self.iconShowArr:getSize();
    while len > 0 do
        icon = self.iconShowArr:remove(len);
        self.iconDic[icon.uniqueId] = nil;
        TweenUtil.getInstance():stop(icon.mainContent);
        icon:setData(nil);
        icon:setEnable(false);
        self.iconHideArr:add(icon);
        len = len - 1;
    end
end

function Lua_TopRightShrinkPanel:checkRedDot()
    if self.openState then
        if self.redDot then
            self.redDot:updateRedPointShow(false);
        end
        return;
    end

    local arr = DataCenter.mainMenuData.topRightIconArr;
    if arr == nil then
        if self.redDot then
            self.redDot:updateRedPointShow(false);
        end
        return;
    end

    local bRedDotState = false;
    for i = self.showCount + 1, arr:getSize() do
        if arr[i].bRedDotState then
            bRedDotState = true;
            break;
        end
    end

    if bRedDotState then
        if self.redDot == nil then
            self.redDot = Lua_RedPointIcon.new(self.content);
            self.redDot:createRedPointEff();
            self.redDot:setLocation(-30, -215);
        end
        self.redDot:updateRedPointShow(true);
    else
        if self.redDot ~= nil then
            self.redDot:updateRedPointShow(false);
        end
    end
end

function Lua_TopRightShrinkPanel:onUpdateIcon(param)
    if param == nil or self.iconDic == nil then
        self:showIcon();
    else
        if type(param) == "number" then
            if self.iconDic[param] ~= nil then
                self.iconDic[param]:updateData();
            end
        end
    end
end