checkRequire("Lua_FuncOpenVo");
Lua_FuncOpenUtil = class("Lua_FuncOpenUtil");
function Lua_FuncOpenUtil:ctor()
    self:superCall("ctor");
end

function Lua_FuncOpenUtil:dispose()
	if self.bInit == true then
		for _, vo in pairs(self.funcOpenDic) do
			vo:resetServerInfo();
		end
	end
end

function Lua_FuncOpenUtil:initFuncInfo()
	if self.bInit ~= true then
		self.bInit = true;
		self.funcOpenDic = {};
		self.funcIconDic = {};
		self.previewArr = Array();
		local config = getConfig("function_open");
		local vo;
		for k,v in pairs(config) do
			vo = Lua_FuncOpenVo.new(k, v);
			self.funcOpenDic[k] = vo;
			if vo.iconId > 0 then
				if self.funcIconDic[vo.iconId] == nil then
					self.funcIconDic[vo.iconId] = Array();
				end
				self.funcIconDic[vo.iconId]:add(k);
			end
			if vo.is_preview == 1 then
				self.previewArr:add(k);
			end
		end
	end
end

function Lua_FuncOpenUtil:getFuncOpenVoById(id)
	self:initFuncInfo();
	return self.funcOpenDic[id];
end

function Lua_FuncOpenUtil:getFuncOpenVoByIconId(iconId)
	self:initFuncInfo();
	local arr = self.funcIconDic[iconId]
	if arr and arr:getSize() > 0 then
		return self:getFuncOpenVoById(arr[1]);
	end
	return nil
end

function Lua_FuncOpenUtil:getFuncOpenArrByIconId(iconId)
	self:initFuncInfo();
	return self.funcIconDic[iconId]
end

function Lua_FuncOpenUtil:getPreviewArr()
	self:initFuncInfo();
	self.previewArr:sortf(self, self.onPreviewSort)
	return self.previewArr;
end

function Lua_FuncOpenUtil:onPreviewSort(a, b)
	a = self:getFuncOpenVoById(a)
	b = self:getFuncOpenVoById(b)
	if a.reward_state == b.reward_state then
		if a.preview_sort > b.preview_sort then
			return false
		end
	else
		if a.reward_state ~= 1 and b.reward_state == 1 then
			return false
		elseif a.reward_state == 2 and b.reward_state ~= 2 then
			return false
		end
	end
	return true
end