Lua_FuncOpenVo = class("Lua_FuncOpenVo")
function Lua_FuncOpenVo:ctor(id, config)
	self.id = id;
	self._config = config;
	self:resetServerInfo();
end

function Lua_FuncOpenVo.Get:config()
	if self._config == nil then
		self._config = getConfig("function_open", id);
	end
	return self._config
end

function Lua_FuncOpenVo:resetServerInfo()
    self._openState = 0;
    self._switchState = nil;
    self._reward_state = nil;
    self._pop_state = nil;
end

function Lua_FuncOpenVo:fromServerInfo(serverInfo)
	if serverInfo == nil or serverInfo.function_id ~= self.id then
		return;
	end

	self._openState = serverInfo.function_flag; -- 0：未开启 1：开启
    self._reward_state = serverInfo.reward_state; -- 奖励状态0:不可领取 1:可领取 2:已领取
    self._pop_state = serverInfo.pop_state; -- 弹窗状态0:不需要弹窗 1:需要弹窗 2:已弹窗
end

function Lua_FuncOpenVo.Get:isOpen()
	if self._openState == 0 or self._switchState == 0 then
		return false;
	end
	return true;
end

function Lua_FuncOpenVo.Get:switchState()
	if self._switchState == nil then
		self._switchState = PlayerData.instance:getPhpConfigNumberValue("phpClientInfo", tostring(self.id));
	end
	return self._switchState;
end

function Lua_FuncOpenVo.Get:reward_state()
	return self._reward_state or 0
end

function Lua_FuncOpenVo.Get:pop_state()
	return self._pop_state or 0
end

function Lua_FuncOpenVo.Get:advanceMessage()
	if self.switchState == 0 then
		return LanUtil.formateStr(123637, self.name);
	end
	return self.config.advance_message;
end

-------------------- 配置数据 --------------------

function Lua_FuncOpenVo.Get:name()
	return self.config.name;
end

function Lua_FuncOpenVo.Get:role_level()
	return self.config.role_level or 1;
end

--世界等级
function Lua_FuncOpenVo.Get:world_level()
	return self.config.world_level or 1;
end

--开服天数
function Lua_FuncOpenVo.Get:open_day()
	return self.config.open_day or 0;
end

--完成主线关卡
function Lua_FuncOpenVo.Get:game_level_id()
	return self.config.game_level_id;
end

--开启条件描述
function Lua_FuncOpenVo.Get:des_list()
	return self.config.des_list;
end

function Lua_FuncOpenVo.Get:iconId()
	return self.config.icon_id or 0;
end

function Lua_FuncOpenVo.Get:des()
	return self.config.des;
end

function Lua_FuncOpenVo.Get:is_preview()
	return self.config.is_preview;
end

function Lua_FuncOpenVo.Get:produce()
	return self.config.produce;
end

function Lua_FuncOpenVo.Get:reward()
	return self.config.reward;
end

function Lua_FuncOpenVo.Get:bgUrl()
	if self._bgUrl == nil then
		self._bgUrl = spliceStr("/images/func_preview/", self.config.bg)
	end
	return self._bgUrl;
end

function Lua_FuncOpenVo.Get:tips_title()
	return self.config.tips_title;
end

function Lua_FuncOpenVo.Get:tips_des()
	return self.config.tips_des;
end

function Lua_FuncOpenVo.Get:preview_sort()
	return self.config.preview_sort or 0;
end

function Lua_FuncOpenVo.Get:scheduleStr()
	local str = self.config.schedule
	if not strIsNullOrEmpty(str) then
		str = string.gsub(str, "role_level", DataCenter.roleData.level)
		str = string.gsub(str, "world_level", DataCenter.roleData.worldLv)
		str = string.gsub(str, "vip_level", DataCenter.roleData.vip)
		str = string.gsub(str, "open_day", DataCenter.roleData.open_days)
		str = string.gsub(str, "game_level_id", DataCenter.mainLineData.curCheckpointName)
		str = string.gsub(str, "tower", DataCenter.climbTowerData:getTowerVoById(Lua_ClimbTowerUtil.LIGHT_ID).cur_storey)
	end
	return str
end

function Lua_FuncOpenVo.Get:guideId()
	return self.config.guideId;
end