-- 主线相机动画控制器
checkRequire("Lua_MainLineChapterConfigData");
Lua_MainLineCamActController = class("Lua_MainLineCamActController")
function Lua_MainLineCamActController:ctor()
	self:superCall("ctor");

	self.actStep = 0;
	self.startLookAtPos = nil;
	self.endLookAtPos = nil;
	self.startDis = nil;
	self.endDis = nil;
	self.startPanAngle = nil;
	self.endPanAngle = nil;
	self.startTitleAngle = nil;
	self.endTitleAngle = nil;
	self.calculateVec = Vector3(); -- 用于计算的vec，防止频繁创建消耗性能
end

function Lua_MainLineCamActController:dispose()
	self:stopCamAct(true);
end

function Lua_MainLineCamActController.Get:cameraViewHandle()
	if self._cameraViewHandle == nil then
		self._cameraViewHandle = GlobalVar.cameraViewHandle;
	end
	return self._cameraViewHandle;
end

function Lua_MainLineCamActController.Get:cameraControl()
	if self._cameraControl == nil then
		self._cameraControl = CameraControl.Instance;
	end
	return self._cameraControl;
end

function Lua_MainLineCamActController.Get:bActComplete()
	return self.actStep == nil or self.actStep < 1 or self.actStep > 3;
end

function Lua_MainLineCamActController:showAction(chapterId, lastChapterId, startPos, endPos, bResetStartPoint)
	self.chapterId = chapterId;
	local cfg = Lua_MainLineChapterConfigData.getConfig(chapterId);
	if cfg == nil then
		return;
	end

	-- self.actStep = 1 当前位置到起始位置阶段，2到达起始位置后停留阶段，3起始位置到达目标位置阶段，4完成
	-- 相机直接拉到chapter的起始位置角度
	self.endPos = endPos;
	if bResetStartPoint == true then
		local lastCfg = Lua_MainLineChapterConfigData.getConfig(lastChapterId);
		if lastCfg ~= nil then
			self.carryOutTimeCount = DataCenter.mainLineUtil.topToEndUseTime;
			self.startLookAtPos = startPos == nil and lastCfg.bottomLookAtPos or startPos;
			self.startDis = lastCfg.bottomDis;
			self.startPanAngle = lastCfg.bottomPanAngle;
			self.startTitleAngle = lastCfg.bottomTitleAngle;

			self.actStep = 3;
		else
			self.carryOutTimeCount = DataCenter.mainLineUtil.topWaitUseTime;
			self.startLookAtPos = cfg.topLookAtPos;
			self.startDis = cfg.topDis;
			self.startPanAngle = cfg.topPanAngle;
			self.startTitleAngle = cfg.topTitleAngle;

			self.actStep = 2;
		end

		self.endLookAtPos = endPos == nil and cfg.bottomLookAtPos or endPos;
		self.endDis = cfg.bottomDis;
		self.endPanAngle = cfg.bottomPanAngle;
		self.endTitleAngle = cfg.bottomTitleAngle;
	else
		self.carryOutTimeCount = DataCenter.mainLineUtil.startToTopUseTime;
		local lastCfg = Lua_MainLineChapterConfigData.getConfig(lastChapterId);
		if lastCfg ~= nil then
			self.startLookAtPos = startPos == nil and lastCfg.bottomLookAtPos or startPos;
			self.startDis = lastCfg.bottomDis;
			self.startPanAngle = lastCfg.bottomPanAngle;
			self.startTitleAngle = lastCfg.bottomTitleAngle;
		else
			if startPos == nil then
				local px = self.cameraControl.curLookAtPosX;
				local py = self.cameraControl.curLookAtPosY;
				local pz = self.cameraControl.curLookAtPosZ;
				if self.curLookAtPos == nil then
					self.curLookAtPos = Vector3(px, py, pz);
				else
					self.curLookAtPos:Set(px, py, pz);
				end
				self.startLookAtPos = self.curLookAtPos;
			else
				self.startLookAtPos = startPos;
			end
			self.startDis = self.cameraViewHandle.currentDistance;
			self.startPanAngle = self.cameraViewHandle.currentPanAngle;
			self.startTitleAngle = self.cameraViewHandle.currentTiltAngle;
		end

		self.endLookAtPos = cfg.topLookAtPos;
		self.endDis = cfg.topDis;
		self.endPanAngle = cfg.topPanAngle;
		self.endTitleAngle = cfg.topTitleAngle;
		self.actStep = 1;
	end

	GlobalVar.canDragMap = false;
	self.cameraViewHandle.isCanTouchOper = false;
	self.cameraViewHandle:updateDistanceTimeOper(0);
	self.cameraViewHandle:updateAngleTimeOper(0);
	self.cameraViewHandle:updateDistanceTimeAuto(0);
	self.cameraViewHandle:updateDistanceTimeBack(0);
	self.cameraViewHandle:updateAngleTimeBack(0);
	self.cameraViewHandle:updateLimitDistance(0, 100000);
	self.cameraViewHandle:updateLimitAngle(0, 360, 0, 360);
	self.cameraControl:SetFollowTargetPos(self.startLookAtPos.x, self.startLookAtPos.y, self.startLookAtPos.z);
	self.cameraViewHandle:rotCamTo(self.startPanAngle, self.startTitleAngle, self.startDis);
	self.cameraViewHandle.isCanHcUpdate = true;
	self.startTime = getTime();
	if self.bTimer ~= true then
		self.bTimer = true;
		-- Lua_CommonUtil.addTimer("MainlineCamActFrame", 0.01, self, self.frameScript); -- 迁移到core的lateupdate
		DataCenter.loginData:checkFpsState();
	end
end

function Lua_MainLineCamActController:clearTimer()
	if self.bTimer == true then
		self.bTimer = false;
		-- Lua_CommonUtil.removeTimer(self, self.frameScript); -- 迁移到core的lateupdate
		DataCenter.loginData:checkFpsState();
	end
end

function Lua_MainLineCamActController:stopCamAct(bValue)
	self:clearTimer();
	GlobalVar.canDragMap = true;
	self.actStep = 0;
	self.endPos = nil;
	self.startLookAtPos = nil;
	self.endLookAtPos = nil;
	self.startDis = nil;
	self.endDis = nil;
	self.startPanAngle = nil;
	self.endPanAngle = nil;
	self.startTitleAngle = nil;
	self.endTitleAngle = nil;
	self.levlsArr = nil;
	self.startCreateIdx = 1;
	if bValue == true then
		self:removeAllScenePoints();
	end
end

function Lua_MainLineCamActController:frameScript()
	if not self.bTimer then
		return false;
	end

	local t = getTime();
	local dt = t - self.startTime;
	self.startTime = t;

	-- print("Lua_MainLineCamActController.frameScript", self.actStep);
	if self.actStep == 1 then
		self:removeAllScenePoints();
		self:updateCamStartAct(dt);
	elseif self.actStep == 2 then
		self:updateCamTopAct(dt);
	elseif self.actStep == 3 then
		self:updateCamEndAct(dt);
	elseif self.actStep == 4 then
		self:createScenePoints();
	elseif self.actStep == 5 then
		self:initDragArea();
	else
		self:clearTimer();
		self.endPos = nil;
		GlobalVar.canDragMap = true;
		self.cameraViewHandle.isCanTouchOper = true;
		self.cameraViewHandle:updateDistanceTimeOper(0.1);
		self.cameraViewHandle:updateAngleTimeOper(0.1);
		self.cameraViewHandle:updateDistanceTimeAuto(0.7);
		self.cameraViewHandle:updateDistanceTimeBack(1);
		self.cameraViewHandle:updateAngleTimeBack(1);
		local cfg = Lua_MainLineChapterConfigData.getConfig(self.chapterId);
		self.cameraViewHandle:updateLimitDistance(cfg.perMinDis, cfg.perMaxDis);
		self.cameraViewHandle:updateLimitAngle(cfg.titleMinAngle, cfg.titleMaxAngle, cfg.panMinAngle, cfg.panMaxAngle);

		Lua_MsgUtil.callFunc("MAINLINE_CAM_ACT_CONPLETED");
	end
	return true;
end

function Lua_MainLineCamActController:updateCamStartAct(dt)
	self.carryOutTimeCount = self.carryOutTimeCount - dt;
	local rate = (DataCenter.mainLineUtil.startToTopUseTime - self.carryOutTimeCount) / DataCenter.mainLineUtil.startToTopUseTime;
	if rate >= 1 then
		self.actStep = self.actStep + 1;
		self.carryOutTimeCount = DataCenter.mainLineUtil.topWaitUseTime;
		local cfg = Lua_MainLineChapterConfigData.getConfig(self.chapterId);
		self.startLookAtPos = cfg.topLookAtPos;
		self.endLookAtPos = self.endPos == nil and cfg.bottomLookAtPos or self.endPos;
		self.startDis = cfg.topDis;
		self.endDis = cfg.bottomDis;
		self.startPanAngle = cfg.topPanAngle;
		self.endPanAngle = cfg.bottomPanAngle;
		self.startTitleAngle = cfg.topTitleAngle;
		self.endTitleAngle = cfg.bottomTitleAngle;
		self.cameraControl:SetFollowTargetPos(self.startLookAtPos.x, self.startLookAtPos.y, self.startLookAtPos.z);
		self.cameraViewHandle:rotCamTo(self.startPanAngle, self.startTitleAngle, self.startDis);
		self.cameraViewHandle.isCanHcUpdate = true;
	else
		self:calculate(rate, self.startLookAtPos, self.endLookAtPos, self.calculateVec);
		self.cameraControl:SetFollowTargetPos(self.calculateVec.x, self.calculateVec.y, self.calculateVec.z);
		local panAngle = self.startPanAngle + (self.endPanAngle - self.startPanAngle) * rate;
		local tiltAngle = self.startTitleAngle + (self.endTitleAngle - self.startTitleAngle) * rate;
		local distance = self.startDis + (self.endDis - self.startDis) * rate;
		self.cameraViewHandle:rotCamTo(panAngle, tiltAngle, distance);
		self.cameraViewHandle.isCanHcUpdate = true;
	end
end

function Lua_MainLineCamActController:updateCamTopAct(dt)
	self.carryOutTimeCount = self.carryOutTimeCount - dt;
	if self.carryOutTimeCount <= 0 then
		self.actStep = self.actStep + 1;
		self.carryOutTimeCount = DataCenter.mainLineUtil.topToEndUseTime;
	end
end

function Lua_MainLineCamActController:updateCamEndAct(dt)
	self.carryOutTimeCount = self.carryOutTimeCount - dt;
	local rate = (DataCenter.mainLineUtil.topToEndUseTime - self.carryOutTimeCount) / DataCenter.mainLineUtil.topToEndUseTime;
	if rate >= 1 then
		self.actStep = self.actStep + 1;
		self.cameraControl:SetFollowTargetPos(self.endLookAtPos.x, self.endLookAtPos.y, self.endLookAtPos.z);
		self.cameraViewHandle:rotCamTo(self.endPanAngle, self.endTitleAngle, self.endDis);
		self.cameraViewHandle.isCanHcUpdate = true;
		self.startLookAtPos = nil;
		self.endLookAtPos = nil;
		self.startDis = nil;
		self.endDis = nil;
		self.startPanAngle = nil;
		self.endPanAngle = nil;
		self.startTitleAngle = nil;
		self.endTitleAngle = nil;
	else
		self:calculate(rate, self.startLookAtPos, self.endLookAtPos, self.calculateVec);
		self.cameraControl:SetFollowTargetPos(self.calculateVec.x, self.calculateVec.y, self.calculateVec.z);
		local panAngle = self.startPanAngle + (self.endPanAngle - self.startPanAngle) * rate;
		local tiltAngle = self.startTitleAngle + (self.endTitleAngle - self.startTitleAngle) * rate;
		local distance = self.startDis + (self.endDis - self.startDis) * rate;
		self.cameraViewHandle:rotCamTo(panAngle, tiltAngle, distance);
		self.cameraViewHandle.isCanHcUpdate = true;
	end
end

function Lua_MainLineCamActController:calculate(rate, startVec, endVec, result)
	if startVec == nil or endVec == nil then
		return;
	end

	if result == nil then result = Vector3(); end
	result.x = startVec.x + (endVec.x - startVec.x) * rate;
	result.y = startVec.y + (endVec.y - startVec.y) * rate;
	result.z = startVec.z + (endVec.z - startVec.z) * rate;
	return result;
end

-- 移除地图节点信息
function Lua_MainLineCamActController:removeAllScenePoints()
	ThingUtil.instance:removeAll(DataCenter.mainLineData.curSceneId, 0, 0);
end

-- 创建地图上的节点信息
function Lua_MainLineCamActController:createScenePoints()
	local arr = DataCenter.mainLineUtil:getLevelsByChapterId(self.chapterId);
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do
			-- 创建一个副本节点
			local levelId = arr[i];
			local cfg = Lua_MainLineCheckpointConfigData.getConfig(levelId);
			if cfg ~= nil then
				local lastCfg = Lua_MainLineCheckpointConfigData.getConfig(levelId - 1);
				if lastCfg ~= nil then
					local nextCfg = Lua_MainLineCheckpointConfigData.getConfig(levelId + 1);
					if nextCfg == nil then -- 是终点
						self:createLevelPoint(levelId, cfg.scenePosVec, cfg.sceneNodeRotVec, cfg.is_boss);
						self:createSceneLineEff(levelId, lastCfg.scenePosVec, cfg.scenePosVec);
					else -- 是中间点
						self:createLevelPoint(levelId, cfg.scenePosVec, cfg.sceneNodeRotVec, cfg.is_boss);
						self:createSceneLineEff(levelId, lastCfg.scenePosVec, cfg.scenePosVec);
					end
				else -- 是起点
					self:createLevelPoint(levelId, cfg.scenePosVec, cfg.sceneNodeRotVec, cfg.is_boss);
				end
			end
		end
	end

	self.actStep = self.actStep + 1;
end

-- 创建关卡节点
function Lua_MainLineCamActController:createLevelPoint(levelId, pos, rot, is_boss)
	local sceneId = DataCenter.mainLineData.curSceneId
	local roleId = 800000000 + levelId
	if ThingUtil.instance:hasThingById(sceneId, 0, roleId) then
		ThingUtil.instance:showPlayer(sceneId, 0, roleId);
	else
		local effectFile = "guanqia";
		local effectName;
		-- local hangerEffId;
		local curId = DataCenter.mainLineData.checkpointId;
		if is_boss == 1 then
			if levelId > curId then
				effectName = "guanqia_1"; -- 未通关
			else
				effectName = "guanqia_2"; -- 已通关
			end
			-- hangerEffId = "diaoluo_light1";
		else
			if levelId > curId then
				effectName = "guanqia_3"; -- 未通关
			elseif levelId < curId then
				effectName = "guanqia_5"; -- 已通关
			else
				effectName = "guanqia_4"; -- 通关中
			end
			-- hangerEffId = "diaoluo_light2";
		end

		local data = SceneLevelNodeData();
		data.kind = Lua_ThingDefine.LEVEL_NODE;
		data.roleId = roleId;
		data.objId = levelId;
		data.px = pos.x;
		data.py = pos.y;
		data.pz = pos.z;
		data.rotX = rot.x;
		data.rotY = rot.y;
		data.rotZ = rot.z;
		data.scaX = 1;
		data.scaY = 1;
		data.scaZ = 1;
		data.showShadow = false;
		data.effectFile = effectFile;
		data.effectName = effectName;
		-- data.hangerEffId = hangerEffId;
		data.fightRecordId = 0;
		data.isShowName = true;
		data.canBeClick = true;
		data.sceneId = sceneId;
		ThingUtil.instance:addSceneLevelNode(data);
	end
end

-- 创建连线
function Lua_MainLineCamActController:createSceneLineEff(endId, startPos, endPos)
	local sceneId = DataCenter.mainLineData.curSceneId
	local roleId = 700000000 + endId
	if ThingUtil.instance:hasThingById(sceneId, 0, roleId) then
		ThingUtil.instance:showPlayer(sceneId, 0, roleId);
	else
		local effectFile = "guanqia_guangxian";
		local effectName;
		local curId = DataCenter.mainLineData.checkpointId;
		if endId > curId then -- 未通关
			effectName = "guanqia_guangxian1";
		elseif endId == curId then
			if DataCenter.mainLineData:getCheckpointIsCompleted(curId) then
				effectName = "guanqia_guangxian3"; -- 已通关
			else
				effectName = "guanqia_guangxian2"; -- 通关中
			end
		else
			effectName = "guanqia_guangxian3";
		end

		local data = SceneEffectData();
		data.kind = Lua_ThingDefine.SCENE_EFFECT;
		data.roleId = roleId;
		data.objId = endId;
		data.px = (startPos.x + endPos.x) / 2;
		data.py = (startPos.y + endPos.y) / 2;
		data.pz = (startPos.z + endPos.z) / 2;
		data:setLookAt(endPos.x, endPos.y, endPos.z);
		local dis = Mathf.Sqrt((startPos.x - endPos.x)^2 + (startPos.y - endPos.y)^2 + (startPos.z - endPos.z)^2);
		local sca = dis / 600; -- 特效默认长度
		data.scaX = sca;
		data.scaY = 1;
		data.scaZ = -sca;
		data.canBeClick = false;
		data.showShadow = false;
		data.isShowName = false;
		data.effectFile = effectFile;
		data.effectName = effectName;
		data.fightRecordId = 0;
		data.sceneId = sceneId;
		ThingUtil.instance:addSceneEffect(data, true);
	end
end

function Lua_MainLineCamActController:checkDir(value)
	while value > 180 do
		value = value - 360;
	end
	while value < -180 do
		value = value + 360;
	end
	return value;
end

-- 初始化拖拽区域
function Lua_MainLineCamActController:initDragArea()
	self.actStep = self.actStep + 1;
	local cfg = Lua_MainLineChapterConfigData.getConfig(self.chapterId);
	if cfg == nil then
		return;
	end

	local dragCenterPos = cfg.dragCenterPos;
	if dragCenterPos == nil then
		return;
	end

	local dragRange = cfg.dragRange;
	if dragRange == nil then
		return;
	end

	local dragRate = cfg.dragRate;
	local lookAtPos = self.endPos == nil and cfg.bottomLookAtPos or self.endPos;
	LuaUtil.updateMapDragInfo(dragCenterPos.x, dragCenterPos.y, dragCenterPos.z, dragRange.x, dragRange.y, dragRate, lookAtPos.x, lookAtPos.y, lookAtPos.z);
end

function Lua_MainLineCamActController:setDefault()
	GlobalVar.canDragMap = false;
	local chapterId = DataCenter.mainLineData.curChapterId;
	local cfg = Lua_MainLineChapterConfigData.getConfig(chapterId);
	self.cameraControl:SetFollowTargetPos(cfg.topLookAtPos.x, cfg.topLookAtPos.y, cfg.topLookAtPos.z);
	self.cameraViewHandle:updateDistanceTimeOper(0);
	self.cameraViewHandle:updateAngleTimeOper(0);
	self.cameraViewHandle:updateDistanceTimeAuto(0);
	self.cameraViewHandle:updateDistanceTimeBack(0);
	self.cameraViewHandle:updateAngleTimeBack(0);
	self.cameraViewHandle:updateLimitDistance(0, 100000);
	self.cameraViewHandle:updateLimitAngle(0, 360, 0, 360);
	self.cameraViewHandle:rotCamTo(cfg.topPanAngle, cfg.topTitleAngle, cfg.topDis);
	self.cameraViewHandle.isCanHcUpdate = true;	
end