Lua_HookData = class("Lua_HookData")
function Lua_HookData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_HookData:dispose()
	self.profit_rate = nil;
	self.extra_reward = nil;
	self.hook_time = 0;
	self.hook_uplimit_time = 0;
	self.is_activate = 0;
	self.free_times = 0;
	self.buy_times = 0;
	self.cur_buy_times = 0;
	self.all_reward = nil;
	self.is_activity = 0;
	self.info_amount = 0;

	self.setTime = 0;
	self.profitDic = nil;
end

function Lua_HookData:fromServer50140013(msg)
	if msg == nil then
		return;
	end

	self.profit_rate = msg.profit_rate; -- 收益速度（key：道具id，value：每分钟获得数）
	self.extra_reward = msg.extra_reward; -- 当前已获得的额外收益
	self.hook_time = msg.hook_time; -- 玩家累计挂机时长（秒）
	self.hook_uplimit_time = msg.hook_uplimit_time; -- 玩家挂机时长上限（秒）
	self.is_activate = msg.is_activate; -- 快速战斗特权是否激活（0：未激活，1：已激活）
	self.free_times = msg.free_times; -- 快速战斗免费次数
	self.buy_times = msg.buy_times; -- 快速战斗剩余购买次数
	self.cur_buy_times = msg.cur_buy_times; -- 今日已购买快速战斗次数
	self.all_reward = msg.all_reward; -- 全部额外收益预览
	self.is_activity = msg.is_activity; -- 1活动中，0非活动中
	self.info_amount = msg.info_amount; -- 一次快速战斗可以获取的情报值

	self.setTime = getTime();
	self:checkFastFightRedPoint();
end

function Lua_HookData:fromServer50140014(msg)
	if msg == nil then
		return;
	end

	if msg.over_info == 0 then
		Lua_WindowUtil.openWin("Lua_HookIncomeResultWindow", Lua_WinParam.ACTION_OPEN, msg);
	else
		local tipsData = { des = LanUtil.getValue(307011), btnType = 1, owner = self, sureFun = self.onSureReceive };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	end
end

function Lua_HookData:onSureReceive()
	Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sHookRewardReceive(1);
end

function Lua_HookData:fromServer50140015(msg)
	if msg == nil then
		return;
	end

	self.free_times = msg.free_times; -- 快速战斗免费次数
	self.buy_times = msg.buy_times; -- 快速战斗剩余购买次数
	self.cur_buy_times = msg.cur_buy_times; -- 今日已购买快速战斗次数
	self:checkFastFightRedPoint();
end

function Lua_HookData:fromServer80140014(msg)
	if msg == nil then
		return;
	end

	self.extra_reward = msg.extra_reward; -- 额外收益
end

function Lua_HookData.Get:show_hook_time()
	if self.hook_time == nil or self.hook_time < 0 then
		return 0;
	end
	
	local num = self.hook_time + (getTime() - self.setTime);
	if num >= self.hook_uplimit_time then
		num = self.hook_uplimit_time;
	elseif num < 0 then
		num = 0;
	end
	return Mathf.Floor(num);
end

-- 检查情报值是否溢出
-- function Lua_HookData:checkIntelligenceIsOverflow()
-- 	local maxValue = DataCenter.mainLineUtil.maxInfoValue;
-- 	local curValue = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.INTELLIGENCE);
-- 	local getValue = 0;
-- 	if self.extra_reward ~= nil then
-- 		for i = 1, #self.extra_reward do
-- 			if self.extra_reward[i].id == Lua_ResourcesDefine.INTELLIGENCE then
-- 				getValue = self.extra_reward[i].amount;
-- 				break;
-- 			end
-- 		end
-- 	end
-- 	if curValue + getValue > maxValue then
-- 		return true;
-- 	end
-- 	return false;
-- end

function Lua_HookData:checkIntelligenceIsOverflow2()
	local maxValue = DataCenter.mainLineUtil.maxInfoValue;
	local curValue = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.INTELLIGENCE);
	local getValue = 0;
	local time = DataCenter.mainLineUtil.one_hook_earnings_time;
	local checkpointId = DataCenter.mainLineData.checkpointId;
	local config = Lua_MainLineCheckpointConfigData.getConfig(checkpointId);
	if config ~= nil and config.normal_profit ~= nil then
		local list = config.normal_profit;
		for i = 1, #list do
			if list[i][1] == Lua_ResourcesDefine.INTELLIGENCE then
				getValue = time * list[i][2];
				break;
			end
		end
	end
	if curValue + getValue > maxValue then
		return true;
	end
	return false;	
end

function Lua_HookData.Get:fastFightConsume()
	local list = DataCenter.mainLineUtil.speed_publicity_exp;
	return list[self.cur_buy_times + 1];
end

function Lua_HookData:getProfitCount(id)
	if self.profit_rate ~= nil then
		local obj;
		for i = 1, #self.profit_rate do
			obj = self.profit_rate[i];
			if obj.key == id then
				return obj.value;
			end
		end
	end
	return 0;
end

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
-- 红点
function Lua_HookData:checkFastFightRedPoint()
	if DataCenter.funcOpenData:isOpened(10220) then
		local leftTimes = self.free_times + self.buy_times;
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.MainLine_FastFight, leftTimes > 0);
	end
end