Lua_MainLineTaskVo = class("Lua_MainLineTaskVo")
function Lua_MainLineTaskVo:ctor()
	self:dispose();
end

function Lua_MainLineTaskVo:dispose()
	self.uid = 0;
	self.tick = 0;
	self.state = 0;
	self.send_cost = nil;
	if self._condArr ~= nil then
		self._condArr:clear();
		self._condArr = nil;
	end
end

function Lua_MainLineTaskVo:fromServer(data)
	if data == nil then
		return;
	end
	
	self.uid = tonumber(data.uid); -- 情报唯一id
	self.tick = data.tick; -- 派遣结束时间戳
	self.state = data.state; -- 状态：0未派遣，1派遣中，2派遣完成可领取
	self.send_cost = data.send_cost; -- 派遣消耗
	self.info_id = data.info_id; -- 情报配置id
end

-- 派遣剩余时间
function Lua_MainLineTaskVo.Get:leftTime()
	return self.tick - DataCenter.roleData.serverTime;
end

function Lua_MainLineTaskVo.Get:sortWeight()
	if self.state == 0 then
		return 10000 + self.color;
	elseif self.state == 1 then
		return 1000 - self.leftTime + self.color;
	elseif self.state == 2 then
		return 100000 + self.color;
	end
	return 0;
end

function Lua_MainLineTaskVo.Get:condArr()
	if self._condArr == nil then
		self._condArr = Array();
		if self.hero_cond ~= nil then
			if self.hero_cond[1] > 0 then
				self._condArr:add({ condType = 1, condValue = self.hero_cond[1] }); -- 星级
			end
			if self.hero_cond[2] ~= nil then
				for i = 1, #self.hero_cond[2] do
					self._condArr:add({ condType = 2, condValue = self.hero_cond[2][i] }); -- 阵营
				end
			end
		end
	end
	return self._condArr;
end

function Lua_MainLineTaskVo.Get:costVo()
	if self.state == 0 then
		if self.send_cost ~= nil then
			local vo = Lua_ToolVo.createToolVo(self.send_cost[1].id, self.send_cost[1].amount);
			vo:fromServer(self.send_cost[1]);
			return vo;
		end
	elseif self.state == 1 then
		if self.speed_cost ~= nil then
			for i = 1, #self.speed_cost do
				if self.leftTime > self.speed_cost[i][1] then
					return Lua_ToolVo.createToolVo(self.speed_cost[i][2][1], self.speed_cost[i][2][2]);
				end
			end
		end
	end
	return nil;
end

-------------------- 配置数据 --------------------

function Lua_MainLineTaskVo.Get:config()
	return getConfig({ "mainline_info_send", self.info_id });
end

function Lua_MainLineTaskVo.Get:name()
	if self.config == nil then
		return "";
	end
	return self.config.name;
end

function Lua_MainLineTaskVo.Get:color()
	if self.config == nil then
		return 1;
	end
	return self.config.color;
end

function Lua_MainLineTaskVo.Get:time()
	if self.config == nil then
		return 0;
	end
	return self.config.time;
end

function Lua_MainLineTaskVo.Get:speed_cost()
	if self.config == nil then
		return nil;
	end
	return self.config.speed_cost;
end

function Lua_MainLineTaskVo.Get:hero_num()
	if self.config == nil then
		return 0;
	end
	return self.config.hero_num;
end

function Lua_MainLineTaskVo.Get:hero_cond()
	if self.config == nil then
		return nil;
	end
	return self.config.hero_cond;
end

function Lua_MainLineTaskVo.Get:reward()
	if self.config == nil then
		return nil;
	end
	return self.config.reward;
end

function Lua_MainLineTaskVo.Get:des()
	if self.config == nil then
		return "";
	end
	return self.config.des;
end