checkRequire("Lua_MainLineUtil");
checkRequire("Lua_MainLineData");
checkRequire("Lua_HookData");
-- checkRequire("Lua_CamFollowBackManager");
-- checkRequire("Lua_MainLineSceneController");
-- checkRequire("Lua_MainLineSceneFightController");
checkRequire("Lua_MainLineCamActController");
Lua_MainLineProxy = class("Lua_MainLineProxy");
function Lua_MainLineProxy:ctor()
	DataCenter.hookData = Lua_HookData.new();
	DataCenter.mainLineData = Lua_MainLineData.new();
	DataCenter.mainLineUtil = Lua_MainLineUtil.new();
	-- DataCenter.camFollowBackManager = Lua_CamFollowBackManager.new();
	-- DataCenter.mainLineSceneController = Lua_MainLineSceneController.new();
	-- DataCenter.mainLineSceneFigthController = Lua_MainLineSceneFightController.new();
	DataCenter.mainLineCamActController = Lua_MainLineCamActController.new();

	-- MsgUtil.addEventListener("CAMERA_AUTOTOBACK_RESET", self, self.onResetFollowCamera);
	-- Lua_MsgUtil.addEventListener("SCENE_HIDE", self, self.onSceneHide);
	
	Lua_MsgUtil.addLuaMsg(50140002, self, self.rReceiveReward); -- 领取关卡奖励(返回)
	Lua_MsgUtil.addLuaMsg(50140004, self, self.rMainLineInfo); -- 主线推图(市场)信息(返回)
	Lua_MsgUtil.addLuaMsg(50140008, self, self.rTaskInfo); -- 情报派遣信息(返回)
	Lua_MsgUtil.addLuaMsg(50140009, self, self.rTaskSend); -- 情报派遣（返回）
	Lua_MsgUtil.addLuaMsg(50140010, self, self.rTaskSpeedUp); -- 情报加速（返回）
	Lua_MsgUtil.addLuaMsg(50140011, self, self.rTaskRefresh); -- 情报刷新（返回）
	Lua_MsgUtil.addLuaMsg(50140012, self, self.rTaskRewardReceive); -- 领取情报奖励（返回）

	Lua_MsgUtil.addLuaMsg(50140013, self, self.rHookInfo); -- 请求挂机收益界面（返回）
	Lua_MsgUtil.addLuaMsg(50140014, self, self.rHookRewardReceive); -- 请求领取挂机收益（返回）
	Lua_MsgUtil.addLuaMsg(50140015, self, self.rFastFight); -- 请求快速战斗（返回）

	Lua_MsgUtil.addLuaMsg(80140001, self, self.updateMainLineInfo); -- 通知主线推图(市场)信息
	Lua_MsgUtil.addLuaMsg(80140013, self, self.openHookIncomeWin); -- 通知收益弹框
	Lua_MsgUtil.addLuaMsg(80140014, self, self.updateHookExtraReward); -- 通知额外奖励变化
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 事件监听
-- function Lua_MainLineProxy:onResetFollowCamera()
-- 	DataCenter.camFollowBackManager:resetAutoToBack();
-- end

-- function Lua_MainLineProxy:onSceneHide()
-- 	if Scene3DManager.instance:isCurShowScene(DataCenter.mainLineSceneController.mainLineSceneId, 0) ~= true then
-- 		DataCenter.camFollowBackManager:checkFollowState(DataCenter.mainLineSceneController.mainLineSceneId, 0, DataCenter.mainLineSceneController.mainLineFollowId, false);
-- 	end
-- end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 主线宣传
function Lua_MainLineProxy:sAdvance()
	sendMsg(10140001);
end

-- 领取关卡奖励
function Lua_MainLineProxy:sReceiveReward(param)
	local cmd = ProtoPublic_pb.Proto10140002();
	if type(param) == type_str_table then
		for i = 1, param:getSize() do
			cmd.game_level_id:append(param[i])
		end
	else
		cmd.game_level_id:append(param)
	end
	sendMsg(10140002, cmd);
end

-- 主线信息
function Lua_MainLineProxy:sMainLineInfo()
	sendMsg(10140004);
end

-- 情报派遣信息
function Lua_MainLineProxy:sTaskInfo()
	sendMsg(10140008);
end

-- 情报派遣
function Lua_MainLineProxy:sTaskSend(info_uid, arr)
	local cmd = ProtoPublic_pb.Proto10140009();
	cmd.info_uid = info_uid;
	for i = 1, arr:getSize() do
		if arr[i] > 0 then
			cmd.hero_uid_list:append(arr[i]);
		end
	end
	sendMsg(10140009, cmd);
end

-- 情报加速
function Lua_MainLineProxy:sTaskSpeedUp(info_uid)
	local cmd = ProtoPublic_pb.Proto10140010();
	cmd.info_uid = info_uid;
	sendMsg(10140010, cmd);
end

-- 情报加速
function Lua_MainLineProxy:sTaskRefresh()
	sendMsg(10140011);
end

-- 领取情报奖励
function Lua_MainLineProxy:sTaskRewardReceive(uid)
	local cmd = ProtoPublic_pb.Proto10140012();
	cmd.uid = uid; -- 情报唯一id，0表示一键领取
	sendMsg(10140012, cmd);
end

-- 请求挂机收益界面
function Lua_MainLineProxy:sHookInfo()
	sendMsg(10140013);
end

-- 请求领取挂机收益
function Lua_MainLineProxy:sHookRewardReceive(draw_type)
	local cmd = ProtoPublic_pb.Proto10140014();
	cmd.draw_type = draw_type; -- 0查询领取 1直接领取
	sendMsg(10140014, cmd);
end

-- 请求快速战斗
function Lua_MainLineProxy:sFastFight()
	sendMsg(10140015);
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_MainLineProxy:rReceiveReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140002();
		msg:ParseFromString(mp.data);
		DataCenter.mainLineData:fromServer50140002(msg);
		Lua_MsgUtil.callFunc("MAINLINE_REWARD_RECEIVE_UPDATE");
	end
end

function Lua_MainLineProxy:rMainLineInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140004();
		msg:ParseFromString(mp.data);
		DataCenter.mainLineData:fromServer50140004(msg);
		Lua_MsgUtil.callFunc("UPDATE_MAINLINE_INFO");
	end
end

function Lua_MainLineProxy:rTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140008();
		msg:ParseFromString(mp.data);
		DataCenter.mainLineData:updateTaskData(msg);
		Lua_MsgUtil.callFunc("UPDATE_MAINLINE_TASK");
	end
end

function Lua_MainLineProxy:rTaskSend(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140009();
		msg:ParseFromString(mp.data);
		DataCenter.mainLineData:updateSingleTaskData(msg);
		OperateAlert.showLangValue(307054);
		Lua_MsgUtil.callFunc("UPDATE_MAINLINE_TASK");
		Lua_WindowUtil.openWin("Lua_MainLineTaskDetailsWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_MainLineProxy:rTaskSpeedUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140010();
		msg:ParseFromString(mp.data);
		DataCenter.mainLineData:updateTaskData(msg);
		Lua_MsgUtil.callFunc("UPDATE_MAINLINE_TASK");
	end
end

function Lua_MainLineProxy:rTaskRefresh(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140011();
		msg:ParseFromString(mp.data);
		DataCenter.mainLineData:updateTaskData(msg);
		Lua_MsgUtil.callFunc("UPDATE_MAINLINE_TASK");
	end
end

function Lua_MainLineProxy:rTaskRewardReceive(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140012();
		msg:ParseFromString(mp.data);
		DataCenter.mainLineData:updateTaskData(msg);
		Lua_MsgUtil.callFunc("UPDATE_MAINLINE_TASK");
	end
end

function Lua_MainLineProxy:rHookInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140013();
		msg:ParseFromString(mp.data);
		DataCenter.hookData:fromServer50140013(msg);
		Lua_MsgUtil.callFunc("UPDATE_HOOK_INFO");
	end
end

function Lua_MainLineProxy:rHookRewardReceive(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140014();
		msg:ParseFromString(mp.data);
		DataCenter.hookData:fromServer50140014(msg);
	end
end

function Lua_MainLineProxy:rFastFight(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50140015();
		msg:ParseFromString(mp.data);
		DataCenter.hookData:fromServer50140015(msg);
		Lua_WindowUtil.openWin("Lua_FastFightWindow", Lua_WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_FastFightResultWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

function Lua_MainLineProxy:updateMainLineInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80140001();
		msg:ParseFromString(mp.data);
		DataCenter.mainLineData:fromServer80140001(msg);
		Lua_MsgUtil.callFunc("UPDATE_MAINLINE_INFO");
	end
end

function Lua_MainLineProxy:openHookIncomeWin(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80140013();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_HookIncomeTipsWindow", Lua_WinParam.ACTION_OPEN, msg.hook_hour);
	end
end

function Lua_MainLineProxy:updateHookExtraReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80140014();
		msg:ParseFromString(mp.data);
		DataCenter.hookData:fromServer80140014(msg);
	end
end