-- 相机跟随设置
Lua_CamFollowBackManager = class("Lua_CamFollowBackManager")
Lua_CamFollowBackManager.TIME_TYPE_OPER = 1; -- 手动
Lua_CamFollowBackManager.TIME_TYPE_BACK = 2; -- 追尾
function Lua_CamFollowBackManager:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_CamFollowBackManager:dispose()
	self.checkFollowDistance = 500;
    self.autoToBackTiltAngle = 25;
    self.autoToBackDistance = 29;

    self._isAuto = false;
    self._checkMove = false;
    self._angle = 0;
    self._followerId = 0;
    self._sceneId = 0;
    self._fightId = 0;

    Lua_CommonUtil.removeTimer(self, self.onAutoToBack);
end

function Lua_CamFollowBackManager.Get:followerId()
	return self._followerId;
end

function Lua_CamFollowBackManager.Get:sceneId()
	return self._sceneId;
end

function Lua_CamFollowBackManager.Get:fightId()
	return self._fightId;
end

function Lua_CamFollowBackManager:resetAutoToBack()
    self._angle = 99999;
end

-- 设置跟随目标
function Lua_CamFollowBackManager:setFollower(sId, fId, roleId)
	if ThingUtil.instance:hasThingById(sId, fId, roleId) ~= true then
        self._sceneId = 0;
        self._fightId = 0;
        self._followerId = 0;
        CameraControl.Instance:SetFollowTarget(nil);
        self:removeTick();
        return;
    end

    if CameraControl.Instance:SetFollowTargetById(sId, fId, roleId) then
	    self._sceneId = sId;
	    self._fightId = fId;
	    self._followerId = roleId;
    end
end

-- 设置跟随状态
function Lua_CamFollowBackManager:checkFollowState(sId, fId, bFollow)
    if sId > 0 and fId == self._fightId and sId == self._sceneId then
        self:checkStartMove(sId, fId, self._followerId, bFollow);
        if bFollow ~= true then 
        	CameraControl.Instance:SetFollowTarget(nil);
        end
    end
end

-- 设置跟随状态
function Lua_CamFollowBackManager:checkStartMove(sId, fId, rId, val)
	if self._checkMove == val then
        return;
    end

    if self._sceneId ~= sId or self._fightId ~= fId or self._followerId ~= rId then
        return;
    end

    if val == true then 
        if ThingUtil.instance:hasThingById(self._sceneId, self._fightId, self._followerId) == true then
            local dir = ThingUtil.instance:getThingDir(self._sceneId, self._fightId, self._followerId);
            CameraControl.Instance:rotCamTo(90 - dir, 9999, 9999);
            CameraControl.Instance:hcUpdate(true);
        end
    end

    self._checkMove = val;
    self:setAutoToBack(val);
end

function Lua_CamFollowBackManager:setAutoToBack(val)
    if self._isAuto == val then
        return; 
    end

    self._isAuto = val;
    if val ~= true then
        self:removeTick();
        return;
    end

    Lua_CommonUtil.addTimer("AutoToBack", 0.01, self, self.onAutoToBack, nil, nil);
end

function Lua_CamFollowBackManager:removeTick()
    self._angle = 99999;
    GlobalVar.isCurrMoveBack = false;
    Lua_CommonUtil.removeTimer(self, self.onAutoToBack);
    CameraControl.Instance:onAppCurrentValue();
end

function Lua_CamFollowBackManager:onAutoToBack(dt)
    if ThingUtil.instance:hasThingById(self._sceneId, self._fightId, self._followerId) ~= true then
        self:removeTick();
        return;
    end

    local dir = ThingUtil.instance:getThingDir(self._sceneId, self._fightId, self._followerId);
    local f = 90 - dir;
    if self._angle ~= f then
        self._angle = f;
        GlobalVar.isCurrMoveBack = true;
        CameraControl.Instance:setTimeType(Lua_CamFollowBackManager.TIME_TYPE_BACK);
        CameraControl.Instance:setDistanceAuto(false);
        CameraControl.Instance:rotCamTo(f, 9999, 9999);
    end
end