-- 新英雄主题活动 Data
checkRequire("Lua_NewHeroStoryChapterVo");
checkRequire("Lua_NewHeroStoryLevelVo");
Lua_NewHeroActivityData = class("Lua_NewHeroActivityData");
Lua_NewHeroActivityData.RECRUIT = 20004; -- 新英雄招募

function Lua_NewHeroActivityData:ctor()
	self:dispose();
end

function Lua_NewHeroActivityData:dispose()
	self.login_day = 1;
	self.sevenDayInfoDic = {};

	self.shopHotDic = {};
	self._shopHotArr = Array();

	self.oneDrawTime = 1; -- 招募一次次数
	self.tenDrawTime = 10; -- 招募十次次数
	self.selectNum = 1; -- 招募选择次数
	self.diamondCost = 0; -- 招募钻石消耗

	self.rewardInfoDic = {};
	self._rewardInfoArr = Array();

	self.selectChapter = nil; -- 选择浏览章节
	self.chapterRewardDic = {};
	self.chapterRewardArr = Array();

	self.standRewardArr = Array();
	self.totalRewadArr = Array();
	self.warCoinRewardDic = {};
	self.warCoinTaskDic = {};
	self.warCoinTaskArr = Array();

	self.powerPopupArr = Array();
end

------------------------- 20002 新英雄海报 -------------------------

function Lua_NewHeroActivityData:fromServer80108021(msg)
	Lua_WindowUtil.openWin("Lua_NewHeroActPosterWindow", Lua_WinParam.ACTION_OPEN, msg);
end

------------------------- 20002 七天登录 -------------------------

function Lua_NewHeroActivityData:fromServer50108019(msg)
	if msg == nil then
		return;
	end

	self.login_day = msg.login_day; -- 玩家登录天数
	self.close_tick = msg.close_tick; -- 当天结束戳

	local obj;
	local vo;
	for i = 1, #msg.gift_list do
		obj = msg.gift_list[i];
		vo = self.sevenDayInfoDic[obj.id];
		if vo == nil then
			vo = {};
			vo.id = obj.id; -- 第几天 id
			vo.tvo = Lua_ToolVo.createToolVo(obj.item_list.key, obj.item_list.value);

			self.sevenDayInfoDic[obj.id] = vo;
		end
		vo.state = obj.state; -- 奖励状态 0：不可领取 1：可领取 2：已领取
	end
end

function Lua_NewHeroActivityData.Get:canDrawIdx()
	local day;
	for i = 1, #self.sevenDayInfoDic do
		if self.sevenDayInfoDic[i].state == 1 or self.sevenDayInfoDic[i].state == 0 then 
			day = i;
			break;
		end
	end

	day = day == nil and #self.sevenDayInfoDic or day;
	return day;
end










------------------------- 20003 商店热卖 -------------------------

function Lua_NewHeroActivityData:fromServer50108022(msg)
	if msg == nil then
		return;
	end

	local obj;
	local vo;
	local tvoArr;
	local tvo;
	for i = 1, #msg.gift_list do
		obj = msg.gift_list[i];
		vo = self.shopHotDic[obj.gift_id];
		if vo == nil then
			vo = {};
			vo.gift_id = obj.gift_id; -- 礼包id
			vo.buy_limit = obj.buy_limit; -- 限购次数
			vo.title = obj.title; -- 标题
			vo.recharge_id = obj.recharge_id; -- 充值id

			tvoArr = Array();
			for j = 1, #obj.item_list do
				tvo = Lua_ToolVo.createToolVo(obj.item_list[j].key, obj.item_list[j].value);
				tvoArr:add(tvo);
			end
			vo.tvoArr = tvoArr;

			self.shopHotDic[obj.gift_id] = vo;
			self._shopHotArr:add(vo);
		end
		vo.buy_times = obj.buy_times; -- 已购买次数
	end
end

function Lua_NewHeroActivityData.Get:shopHotArr()
	self._shopHotArr:sortf(self, self.sortShopHotFun);
	return self._shopHotArr;
end

function Lua_NewHeroActivityData:sortShopHotFun(a, b)
	local _a = a.buy_limit - a.buy_times;
	local _b = b.buy_limit - b.buy_times;
	if (_a > 0 and _b > 0) or (_a <= 0 and _b <= 0) then
		if a.gift_id > b.gift_id then
			return false;
		end
	else
		if _b > 0 then
			return false;
		end
	end
	return true;
end










------------------------- 20004 新英雄招募 -------------------------

function Lua_NewHeroActivityData:fromServer50108023(msg)
	self.heroId = msg.hero_id; -- 主题英雄id
	self.fightPreviewId = msg.return_id; -- 预览跳转界面id

	self.isFreeDraw = msg.is_first; -- 是否首抽 0否 1是
	self.diamondLimit = msg.cost_limit_times; -- 钻石每日使用次数上限
	self.diamondTime = msg.cost_draw_times; -- 钻石每日使用剩余次数
	self.mustTime = msg.residue_draw_times; -- 招募保底剩余次数

	self.costItemId = msg.activity_item_id; -- 活动招募道具id
	self.oneDrawExp = msg.get_exp; -- 钻石招募一次获取经验值
	self.oneDrawCost = msg.once_item_cost; -- 一次招募钻石数量
	self.tenDrawCost = msg.ten_item_cost; -- 十次招募钻石数量

	Lua_MsgUtil.callFunc("UPDATE_NEWHERO_RECRUIT");
end

function Lua_NewHeroActivityData:fromServer50108024(msg)
	DataCenter.recruitData.selectType = Lua_RecruitData.NEWHERO;
	self.recruitInfo = DataCenter.recruitUtil:getRecTotVoById(Lua_RecruitData.NEWHERO);

	if self.allHeroArr == nil then
		self.allHeroArr = Array();
	else
		self.allHeroArr:clear();
	end
	if self.showHeroArr == nil then
		self.showHeroArr = Array();
	else
		self.showHeroArr:clear();
	end

	self.actIdx = msg.act_index;

	local vo;
	for k, v in ipairs(msg.hero_list) do
		vo = Lua_ToolVo.createToolVo(v.value);
		if vo ~= nil then
            self.allHeroArr:add(vo);
        end
	end
    self:showReward();
end

function Lua_NewHeroActivityData:showReward()
    local vo = {};

    local itemNum = DataCenter.packData:getItemCountById(self.costItemId);
    if itemNum >= self.selectNum then
    	vo.costId = self.costItemId;
    	vo.costTxt = numberTrans(itemNum) .. "/" .. self.selectNum;
    else
    	vo.costId = Lua_ResourcesDefine.DIAMOND;
    	vo.costTxt = numberTrans(DataCenter.moneyData:getMoney(vo.costId)) .. "/" .. (self.diamondCost);
    	vo.redrawGold = self.diamondCost;
    end

    -- vo.leftBtnVo = Lua_RecruitButtonVo.new();
    -- vo.leftBtnVo.name = string.format(LanUtil.getValue(140305), self.selectNum);
    -- vo.leftBtnVo.owner = self;
    -- vo.leftBtnVo.OnBtnClick = self.costCallBack;

    vo.itemList = self.allHeroArr;
    
    Lua_WindowUtil.openWin("Lua_RecruitShowItemWindow", Lua_WinParam.ACTION_OPEN, vo)
end

function Lua_NewHeroActivityData:costCallBack()
	if not DataCenter.heroData:isBagEnough(self.selectNum) then
		OperateAlert.showLangValue(140321);
		return;
	end

	local itemNum = DataCenter.packData:getItemCountById(self.costItemId);
    if itemNum >= self.selectNum then
    	self:onSureFun();
    else
    	if DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, self.diamondCost, true) then
    		if self.diamondTime >= self.selectNum then
    			self:onSureFun();
    		else
    			OperateAlert.show("今天剩余钻石招募次数不足");
    		end
    	end
    end
end

function Lua_NewHeroActivityData:onSureFun()
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sRecruitReward(self.actIdx, self.selectNum);
end










------------------------- 20005 新英雄升星专属 -------------------------

function Lua_NewHeroActivityData:fromServer50108029(msg)
	if msg == nil then
		return;
	end

	self.eventId = msg.return_id; -- 跳转界面id
	self.heroId = msg.hero_id; -- 主题活动英雄id
	self.curHeroMaxStar = msg.star; -- 英雄星级
	self.curPlayerHeroInfo = self:getHeroInfoByHeroId(msg.hero_id); -- 当前玩家拥有的英雄

	local obj;
	local vo;
	for i = 1, #msg.reward_state do
		obj = msg.reward_state[i];
		vo = self.rewardInfoDic[obj.star];
		if vo == nil then
			vo = {};
			vo.star = obj.star;
			
			local freeInfo;
			freeInfo = {};
			freeInfo.limit_times = obj.free_cell.limit_times; -- 限购次数
			freeInfo.gift_id = obj.free_cell.gift_id; -- 礼包id
			freeInfo.recharge = obj.free_cell.recharge; -- 购买金额

			local tvo;
			local freeArr= Array();
			for j = 1, #obj.free_cell.reward_item do
				tvo = Lua_ToolVo.createToolVo(obj.free_cell.reward_item[j].id, obj.free_cell.reward_item[j].amount);
				freeArr:add(tvo);
			end
			freeInfo.tvoArr = freeArr;
			
			local rechargeInfo = {};
			rechargeInfo.limit_times = obj.recharge_cell.limit_times; -- 限购次数
			rechargeInfo.gift_id = obj.recharge_cell.gift_id; -- 礼包id
			rechargeInfo.recharge = obj.recharge_cell.recharge; -- 购买金额

			local rechargeArr = Array();
			for j = 1, #obj.recharge_cell.reward_item do
				tvo = Lua_ToolVo.createToolVo(obj.recharge_cell.reward_item[j].id, obj.recharge_cell.reward_item[j].amount);
				rechargeArr:add(tvo);
			end
			rechargeInfo.tvoArr = rechargeArr;

			vo.freeInfo = freeInfo; -- 免费奖励
			vo.rechargeInfo = rechargeInfo; -- 充值奖励

			self.rewardInfoDic[obj.star] = vo;
			self._rewardInfoArr:add(vo);
		end
		vo.freeInfo.curr_times = obj.free_cell.curr_times; -- 剩余次数
		vo.rechargeInfo.curr_times = obj.recharge_cell.curr_times; -- 剩余次数
	end
end

function Lua_NewHeroActivityData:getHeroInfoByHeroId(heroId)
	local packHeroUidArr = DataCenter.heroData.allHeroUidArr;
	local heroArr = Array();
	local heroVo;
	for i = 1, packHeroUidArr:getSize() do
		heroVo = DataCenter.heroData:getItemByUniqueId(packHeroUidArr[i]);
		if heroVo.id == heroId then
			heroArr:add(heroVo);
		end
	end
	heroArr:sort("star", true);

	if heroArr[1] == nil then
		return nil;
	else
		return heroArr[1];
	end
end

function Lua_NewHeroActivityData.Get:rewardInfoArr()
	self._rewardInfoArr:sort("star", false);
	return self._rewardInfoArr;
end










------------------------- 20006 剧情关卡 -------------------------

function Lua_NewHeroActivityData:fromServer50108025(msg)
	local vo;
	self.storyChapterArr = Array();
	self.storyChapterDic = {};
	for k, v in ipairs(msg.story_info) do
		vo = Lua_NewHeroStoryChapterVo.new();
		vo:fromServerInfo(v);
		self.storyChapterArr:add(vo);
		self.storyChapterDic[v.chapter_id] = vo;
	end

	-- 篇章奖励
	local obj;
	for i = 1, #msg.reward_state do
		obj = msg.reward_state[i];
		vo = self.chapterRewardDic[obj.index];
		if vo == nil then
			vo = {};
			self.chapterRewardDic[obj.index] = vo;
			self.chapterRewardArr:add(vo);
		end
		
		vo.index = obj.index; -- 篇章ID
		vo.state = obj.state; -- 领取状态（0：不可领取，1：可领取，2：已领取）

		local tvo;
		local tvoArr = Array();
		for j = 1, #obj.reward do
			tvo = Lua_ToolVo.new(obj.reward[j].id, obj.reward[j].amount);
			tvoArr:add(tvo);
		end
		vo.tvoArr = tvoArr;
		vo.sort = (vo.state + 1) % 3;
	end
	self.chapterRewardArr:sortf(self, self.sortStoryFun);

	self.recordList = msg.record_list; -- 记录列表
	table.sort(self.recordList, function(a, b) return a.times > b.times end);

	Lua_MsgUtil.callFunc("UPDATE_NEWHERO_STORYINFO");
end

function Lua_NewHeroActivityData:fromServer50108026(msg)
	self.leadHeroInfoDic = {}; -- 关卡主角英雄（挑战时必须在布阵中）
	for i = 1, #msg.target_hero do
		self.leadHeroInfoDic[tonumber(msg.target_hero[i])] = 1;
	end

	self.limitHeroDic = {};
	for k, v in ipairs(msg.hero_state) do
		self.limitHeroDic[tonumber(v.key)] = tonumber(v.value) == 1; -- 0不需要，1需要
	end

	local vo;
	self.heroVoArr = Array();
	self.heroUidList = {};
	for k, v in ipairs(msg.hero_list) do
		if not self.limitHeroDic[tonumber(v.hero_id)] or DataCenter.heroAtlasData:getAtlasStateByHid(tonumber(v.hero_id)) then
			vo = Lua_HeroVo.new(v.hero_id);
			vo:fromServer(v);
			vo.unique_id = tonumber(v.hero_id);
			self.heroVoArr:add(vo);
			self.heroUidList[vo.unique_id] = vo;
		end
	end

	self.heroLineup = msg.hero_lineup;
end

function Lua_NewHeroActivityData:sortStoryFun(a, b)
	if a.sort == b.sort then
		if a.index > b.index then
			return false;
		end
	elseif b.sort > a.sort then
		return false;
	end
	return true;
end

function Lua_NewHeroActivityData.Get:lastChapterId()
	return self.storyChapterArr[1].chapterId;
end

function Lua_NewHeroActivityData:checkLeadHero(uid)
	return self.leadHeroInfoDic[uid] == 1;
end

function Lua_NewHeroActivityData:getChapterVo(id)
	return self.storyChapterDic[id];
end

function Lua_NewHeroActivityData.Get:defaultChapter()
	local chapter = self.storyChapterArr:getSize();
	local passNum = 0;
	for i = 1, self.storyChapterArr:getSize() do
		if self.storyChapterArr[i].state == 2 then
			chapter = i;
			break;
		elseif self.storyChapterArr[i].state == 3 then
			passNum = passNum + 1;
		end
	end

	if passNum >= self.storyChapterArr:getSize() then
		chapter = 1;
	end

	return chapter;
end










------------------------- 20007 战令 -------------------------

function Lua_NewHeroActivityData:fromServer50108031(msg)
	if msg == nil then
		return;
	end

	self.level = msg.level; -- 当前等级
	self.exe = msg.exe; -- 经验值
	self.cur_exe_process = msg.cur_exe_process; -- 当前等级经验进度
	self.warCoinRechargeId = msg.recharge_id; -- 充值id
	self.recharge_state = msg.recharge_state; -- 充值解锁状态 0 否，1 是
	self.up_level_item = msg.up_level_item; -- 升级等级道具

	-- 战令奖励信息
	local obj;
	local vo;
	for i = 1, #msg.reward_list do
		obj = msg.reward_list[i];
		vo = self.warCoinRewardDic[obj.level];
		if vo == nil then
			vo = {};
			vo.level = obj.level; -- 等级

			-- 普通战令奖励
			local ordinaryArr = Array();
			local tvo;
			for j = 1, #obj.reward_item do
				tvo = Lua_ToolVo.createToolVo(obj.reward_item[j].key, obj.reward_item[j].value);
				ordinaryArr:add(tvo);
			end
			vo.ordinaryRewards = ordinaryArr;

			-- 高级战令奖励
			local advancedArr = Array();
			for j = 1, #obj.stage_reward_item do
				tvo = Lua_ToolVo.createToolVo(obj.stage_reward_item[j].key, obj.stage_reward_item[j].value);
				advancedArr:add({level = obj.level, tvo = tvo});
			end
			vo.advancedRewards = advancedArr;

			self.warCoinRewardDic[obj.level] = vo;
		end
		-- 默认0 不可领取，1 领取，2 已领取
		vo.reward_state = obj.reward_state; -- 普通战令奖励领取状态
		vo.stage_reward_state = obj.stage_reward_state; -- 高级战令奖励领取状态

		for j = 1, vo.advancedRewards:getSize() do
			vo.advancedRewards[j].stage_reward_state = obj.stage_reward_state;
		end
	end

	-- 任务信息
	for i = 1, #msg.task_list do
		obj = msg.task_list[i];
		vo = self.warCoinTaskDic[obj.task_id];
		if vo == nil then
			vo = {};
			vo.task_id = obj.task_id; -- 任务id
			vo.limit_times = obj.limit_times; -- 限制奖励总次数
			vo.process = obj.process; -- 任务进度
			vo.tvo = Lua_ToolVo.createToolVo(obj.exe.key, obj.exe.value);
			vo.dec = obj.dec; -- 任务描述
			vo.task_type = obj.task_type; -- 任务类型 1 固定性，2 指引性
			vo.fun_id = obj.fun_id; -- 功能跳转id

			self.warCoinTaskDic[obj.task_id] = vo;
			self.warCoinTaskArr:add(vo);
		end
		vo.finish_times = obj.finish_times; -- 奖励完成次数
		vo.cur_process = obj.cur_process; -- 当前任务进度
		vo.reward_state = obj.reward_state; -- 奖励领取状态 0 不可领取，1 可领取，2 已领取
	end

	-- 立得奖励信息
	local standRewardDic = self:mergeRewardInfo(msg.recharge_reward_list);
	local rechargeVo;
	local arr = Array();
	self.standRewardArr:clear();
	for k,v in pairs(standRewardDic) do
		rechargeVo = Lua_ToolVo.createToolVo(k, v);
		self.standRewardArr:add(rechargeVo);
	end

	-- 累计奖励信息
	local totalRewadDic = self:mergeRewardInfo(msg.total_reward_list);
	self.totalRewadArr:clear();
	for k,v in pairs(totalRewadDic) do
		rechargeVo = Lua_ToolVo.createToolVo(k, v);
		self.totalRewadArr:add(rechargeVo);
	end
end

-- 合并相同id的道具奖励
function Lua_NewHeroActivityData:mergeRewardInfo(rewardInfo)
	local info = {};
	for i = 1, #rewardInfo do
		if info[rewardInfo[i].key] == nil then
			info[rewardInfo[i].key] = rewardInfo[i].value;
		else
			info[rewardInfo[i].key] = info[rewardInfo[i].key] + rewardInfo[i].value;
		end
	end
	return info;
end










------------------------- 20008 新英雄试用 -------------------------

function Lua_NewHeroActivityData:fromServer80108035(msg)
	self.trialActIdx = msg.act_index; -- 后台活动索引
	self.trialHeroId = msg.hero_id; -- 英雄id
	self.trialstate = msg.trial_state; -- 试用状态 0未试用
	self.trialTime = msg.trial_times; -- 试用初始时间 天
	self.isFirst = msg.is_first_show; -- 是否第一次显示

	if self.isFirst == 1 and self.trialstate == 0 then
		Lua_WindowUtil.openWin("Lua_NewHeroActTryWindow", Lua_WinParam.ACTION_OPEN);
	end
end










------------------------- 20009 新英雄-怪物挑战 -------------------------

function Lua_NewHeroActivityData:fromServer50108036(msg)
	if msg == nil then
		return;
	end

	self.free_times = msg.free_times; -- 剩余挑战次数
	self.free_limit = msg.free_limit; -- 当天挑战上限
	self.buff_info = msg.buff_info; -- 增益信息
	self.stage_info = msg.stage_info; -- 关卡信息
end

function Lua_NewHeroActivityData:fromServer80108036(msg)
	if msg == nil then
		return;
	end

	self.actIdx = msg.act_index;
	self.isPopup = msg.state; -- 增益状态（0：未升级，1：升级）

	if self.isPopup == 1 then
		self.isPopup = 0;
		if not Lua_WindowUtil.isWindowShowing("Lua_TaskRewardTipWindow") then
			self:showPopupInfo(self.buff_info);
			self.buff_info = msg.buff_info;
		else
			self.powerPopupArr:add(msg.buff_info);
		end
	end
end

function Lua_NewHeroActivityData:showPopupInfo(buff_info)
	Lua_WindowUtil.openWin("Lua_MonsterTrialPowerWindow", Lua_WinParam.ACTION_OPEN, buff_info);
end

function Lua_NewHeroActivityData:removePrePopupInfo()
	if self.powerPopupArr:getSize() > 0 then
		self:showPopupInfo(self.powerPopupArr:shift());
	end
end

function Lua_NewHeroActivityData:fromServer50108037(msg)
	if msg == nil then
		return;
	end

	self.rank_reward = msg.rank_reward;
	local vo;
	local obj;
	local tvo;
	local tvoArr;
	self.rankRewardInfoDic = {};
	for i = 1, #msg.rank_reward do -- 奖励信息
		obj = msg.rank_reward[i];
		vo = {};
		vo.rank_left = obj.rank_left;
		vo.rank_right = obj.rank_right;

		tvoArr = Array();
		for j = 1, #obj.reward do
			tvo = Lua_ToolVo.createToolVo(obj.reward[j].key, obj.reward[j].value);
			tvoArr:add(tvo);
		end
		vo.tvoArr = tvoArr;
		self.rankRewardInfoDic[i] = vo;
	end
end