--新英雄主题活动 Proxy
checkRequire("Lua_NewHeroActivityData");
Lua_NewHeroActivityProxy = class("Lua_NewHeroActivityProxy");

function Lua_NewHeroActivityProxy:ctor()
	DataCenter.newHeroActData = Lua_NewHeroActivityData.new();

	Lua_MsgUtil.addLuaMsg(80108021, self, self.nOpenPosterWindow); -- 新英雄主题-海报（通知）
	Lua_MsgUtil.addLuaMsg(50108021, self, self.rTrialHero); -- 新英雄主题-请求试用（返回）
	Lua_MsgUtil.addLuaMsg(80108035, self, self.nOpenTrialWindow); -- 新英雄主题-海报（通知）

	Lua_MsgUtil.addLuaMsg(50108019, self, self.rSevenDayLoginInfo); -- 新英雄主题-请求七天登录界面（返回）
	Lua_MsgUtil.addLuaMsg(50108022, self, self.rShopHotInfo); -- 新英雄主题-请求商店热卖界面（返回）
	Lua_MsgUtil.addLuaMsg(50108023, self, self.rRecruitInfo); -- 新英雄主题-新英雄招募界面（返回）
	Lua_MsgUtil.addLuaMsg(50108024, self, self.rRecruitReward); -- 新英雄主题-请求招募英雄（返回）
	Lua_MsgUtil.addLuaMsg(50108025, self, self.rStoryInfo); -- 新英雄主题-请求剧情界面（返回）
	Lua_MsgUtil.addLuaMsg(50108026, self, self.rStoryNextStep); -- 新英雄主题-请求剧情关卡操作（返回）
	Lua_MsgUtil.addLuaMsg(50108029, self, self.rUpStarInfo); -- 新英雄主题-主题升星专属（返回）
	Lua_MsgUtil.addLuaMsg(50108031, self, self.rWarCoinInfo); -- 新英雄主题-请求战令界面（返回）
	Lua_MsgUtil.addLuaMsg(50108036, self, self.rMonsterTrialInfo); -- 新英雄主题-请求怪物挑战界面（返回）
	Lua_MsgUtil.addLuaMsg(80108036, self, self.nUpPowerInfo); -- 新英雄主题-怪物挑战增益状态（通知）
	Lua_MsgUtil.addLuaMsg(50108037, self, self.rMonsterTrialRewardInfo); -- 新英雄主题-请求查看怪物副本排行奖励（返回）
end

-------------------------上行消息号-------------------------

-------------------- 20002 七天登录 

-- 新英雄主题-七天登录奖励领取 act_index 活动唯一索引， draw_day 第几天奖励
function Lua_NewHeroActivityProxy:sDrawSevenDayLogin(act_index, draw_day)
	local cmd = ProtoPublic_pb.Proto10108020();
	cmd.act_index = act_index;
	cmd.draw_day = draw_day;
	sendMsg(10108020, cmd);
end

-------------------- 20004 新英雄招募

-- 新英雄主题-请求招募英雄
function Lua_NewHeroActivityProxy:sRecruitReward(act_index, draw_times)
	local cmd = ProtoPublic_pb.Proto10108024();
	cmd.act_index = act_index; -- 活动索引
	cmd.draw_times = draw_times; -- 招募次数
	sendMsg(10108024, cmd);
end

-------------------- 20005 新英雄升星专属

-- 新英雄主题-请求领取主题升星免费奖励
function Lua_NewHeroActivityProxy:sDrawUpStarReward(gift_id, act_index)
	local cmd = ProtoPublic_pb.Proto10108030();
	cmd.gift_id = gift_id; -- 礼包id
	cmd.act_index = act_index; -- 后台活动索引
	sendMsg(10108030, cmd);
end

-------------------- 20006 剧情关卡

-- 新英雄主题-请求剧情关卡操作
function Lua_NewHeroActivityProxy:sStoryNextStep(act_index, id, type)
	local cmd = ProtoPublic_pb.Proto10108026();
	cmd.act_index = act_index; -- 活动索引
	cmd.id = id; -- 剧情关卡id
	cmd.type = type; -- 操作状态（1：观看剧情，2：回顾剧情）
	sendMsg(10108026, cmd);
end

-- 新英雄主题-请求剧情关卡布阵
function Lua_NewHeroActivityProxy:sStoryLineup(act_index, id, stand_type, lineup_list, artifact_list)
	local cmd = ProtoPublic_pb.Proto10108027();
	cmd.act_index = act_index; -- 活动索引
	cmd.id = id; -- 剧情关卡id

    local struct1;
    local struct2;
    local arr;
    local posList;
    local standIdx;
    for i = 1, #lineup_list do
        struct1 = getProtoMsg("ProtoHeroDetachment");
        struct1.index = i;
        struct1.stand_type = stand_type[i];

        arr = lineup_list[i];
        posList = DataCenter.heroLineupUtil:getPosListByType(stand_type[i]);
        for j = 1, #posList do
            standIdx = posList[j];
            if arr[standIdx] > 0 then
	            struct2 = getProtoMsg("ProtoPairLong");
	            struct2.key = standIdx
	            struct2.value = arr[standIdx]
	            struct1.location_list:addToList(struct2);
	        end
        end

        arr = artifact_list[i];
        for j = 1, arr:getSize() do
        	if arr[j] > 0 then
	            struct2 = getProtoMsg("ProtoPair");
	            struct2.key = j;
	            struct2.value = arr[j];
	            struct1.artifact_list:addToList(struct2);
	        end
        end
    end
    lineup.detachment_list:addToList(struct1);

	sendMsg(10108027, cmd);
end

-- 新英雄主题-请求领取篇章奖励
function Lua_NewHeroActivityProxy:sStoryReward(act_index, chapter_id)
	local cmd = ProtoPublic_pb.Proto10108028();
	cmd.act_index = act_index; -- 活动索引
	cmd.chapter_id = chapter_id; -- 篇章id
	sendMsg(10108028, cmd);
end

-------------------- 20007 战令

-- 新英雄主题-请求领取战令奖励
function Lua_NewHeroActivityProxy:sDrawWarCoinReward(act_index, level, type)
	local cmd = ProtoPublic_pb.Proto10108032();
	cmd.act_index = act_index; -- 活动索引
	cmd.level = level; -- 等级
	cmd.type = type; -- 奖励类型 1 普通战令奖励，2 高级战令奖励
	sendMsg(10108032, cmd);
end

-- 新英雄主题-请求领取战令任务经验
function Lua_NewHeroActivityProxy:sDrawWarCoinExp(act_index, task_id)
	local cmd = ProtoPublic_pb.Proto10108033();
	cmd.act_index = act_index; -- 活动索引
	cmd.task_id = task_id; -- 任务id
	sendMsg(10108033, cmd);
end

-- 新英雄主题-请求战令升级
function Lua_NewHeroActivityProxy:sUpgradeOfWarCoin(act_index)
	local cmd = ProtoPublic_pb.Proto10108034();
	cmd.act_index = act_index; -- 活动索引
	sendMsg(10108034, cmd);
end

-------------------- 20008 新英雄试用

-- 新英雄主题-请求试用
function Lua_NewHeroActivityProxy:sTrialHero(act_index, hero_id)
	local cmd = ProtoPublic_pb.Proto10108021();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.hero_id = hero_id; -- 英雄id
	sendMsg(10108021, cmd);
end

-------------------- 20009 新英雄-怪物挑战

-- 新英雄主题-请求查看怪物副本排行奖励
function Lua_NewHeroActivityProxy:sMonsterTrialRewardInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108037();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108037, cmd);
end




















-------------------------下行消息号-------------------------

-------------------- 20001 新英雄海报 

-- 新英雄主题-海报（通知）
function Lua_NewHeroActivityProxy:nOpenPosterWindow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108021();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer80108021(msg);
	end
end

-------------------- 20002 七天登录

-- 新英雄主题-请求七天登录界面（返回）
function Lua_NewHeroActivityProxy:rSevenDayLoginInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108019();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108019(msg);
		Lua_MsgUtil.callFunc("UPDATE_SEVENDAY_LOGIN_INFO");
	end
end

-------------------- 20003 商店热卖

-- 新英雄主题-请求商店热卖界面（返回）
function Lua_NewHeroActivityProxy:rShopHotInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108022();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108022(msg);
		Lua_MsgUtil.callFunc("UPDATE_SHOPHOT_INFO");
	end
end

-------------------- 20004 新英雄招募

-- 新英雄主题-新英雄招募界面（返回）
function Lua_NewHeroActivityProxy:rRecruitInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108023();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108023(msg);
	end
end

-- 新英雄主题-请求招募英雄（返回）
function Lua_NewHeroActivityProxy:rRecruitReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108024();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108024(msg);
	end
end

-------------------- 20005 升星专属

-- 新英雄主题-主题升星专属（返回）
function Lua_NewHeroActivityProxy:rUpStarInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108029();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108029(msg);
		Lua_MsgUtil.callFunc("UPDATE_NEWHERO_UPSTAR_INFO");
	end
end

-------------------- 20006 剧情关卡

-- 新英雄主题-请求剧情界面（返回）
function Lua_NewHeroActivityProxy:rStoryInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108025();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108025(msg);
	end
end

-- 新英雄主题-请求剧情关卡操作（返回）
function Lua_NewHeroActivityProxy:rStoryNextStep(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108026();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108026(msg);
	end
end

-------------------- 20007 战令

-- 新英雄主题-请求战令界面（返回）
function Lua_NewHeroActivityProxy:rWarCoinInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108031();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108031(msg);
		Lua_MsgUtil.callFunc("UPDATE_WARCOIN_INFO");
	end
end

-------------------- 20008 新英雄试用

-- 新英雄主题-请求试用（返回）
function Lua_NewHeroActivityProxy:rTrialHero(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_NewHeroActShowWindow", Lua_WinParam.ACTION_OPEN);
	end
end

-- 新英雄主题-通知试用英雄界面（通知）
function Lua_NewHeroActivityProxy:nOpenTrialWindow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108035();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer80108035(msg);
	end
end

-------------------- 20009 新英雄-怪物挑战

-- 新英雄主题-请求怪物挑战界面（返回）
function Lua_NewHeroActivityProxy:rMonsterTrialInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108036();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108036(msg);
		Lua_MsgUtil.callFunc("UPDATE_MONSTERTRIAL_INFO");
	end
end

-- 新英雄主题-怪物挑战增益状态（通知）
function Lua_NewHeroActivityProxy:nUpPowerInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108036();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer80108036(msg);
	end
end

-- 新英雄主题-请求查看怪物副本排行奖励（返回）
function Lua_NewHeroActivityProxy:rMonsterTrialRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108037();
		msg:ParseFromString(mp.data);
		DataCenter.newHeroActData:fromServer50108037(msg);
		Lua_MsgUtil.callFunc("UPDATE_MONSTERTRIAL_REWARD_INFO");
	end
end