--开服狂欢
checkRequire("Lua_OpenServerCarnivalVo");
Lua_OpenServerCarnivalData = class("Lua_OpenServerCarnivalData")
function Lua_OpenServerCarnivalData:ctor()
	self.dayIdBaseCount = 100; --天数id = 100 + 开启天数
	self.openSecActDay = 8; -- 开启第二期活动的天数
	self.totalActDay = 14; -- 整体天数
	self.pressDelta = 0.2;
	self.curPressTime = 0;
	self:dispose();
end

function Lua_OpenServerCarnivalData:dispose()
	if self.dayConfigList ~= nil then
		self.dayConfigList = nil;
	end
	if self.taskDic ~= nil then
		self.taskDic = nil;
	end
	if self.finishReward ~= nil then
		self.finishReward = nil;
	end
	-- self.totalTasksCount = 0; -- 总任务数
	if self.totalTasksCount ~= nil then
		self.totalTasksCount = nil;
	end
end

function Lua_OpenServerCarnivalData:fromServer50197023(msg)
	if msg == nil then
		return;
	end
	
	self.closeTick = msg.close_tick;
	self.isCloseAct = msg.close_tick - DataCenter.roleData.serverTime <= 0;
	self:initConfigInfo();
	self:updateServerInfo(msg.total_reward_state, tonumber(msg.open_day), msg.day_reward_state, msg.task_info)
	self:showRedPoint();
	self:closeActivity();
	-- DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerCarnival, self.showRedPoint);
end

-- 初始化配置表信息
function Lua_OpenServerCarnivalData:initConfigInfo()
	if self.dayConfigList == nil then
		self.dayConfigList = {};
		self.tabDayIdList = {}; -- 记录每期的天数id
		self.totalTasksCount = {};
		
		--读取完成每天全部任务的奖励，以及完成两期的总奖励
		local vo;
		local config = getConfig({"open_carnival_reward"});
		for k,v in pairs(config) do
			vo = self.getDayConfigById(v.id);
			if vo == nil then
				vo = Lua_OpenServerCarnivalVo.new(v.id, v);
				self.dayConfigList[vo.id] = vo;

				if type(v.id) ~= "number" then
					self:recordFinishReward(v);
				else
					-- 记录每期的活动天数信息
					self:recordDayList(vo);
				end
			end
		end

		self.totalDay = 0;
		for i = 1, #self.tabDayIdList do
			table.sort( self.tabDayIdList[i], function(a, b)
						return a < b; end );
			self.totalDay = self.totalDay + #self.tabDayIdList[i];
		end
	end

	--读取任务配置信息	
	if self.taskDic == nil then
		self.taskDic = {};
		config = getConfig({"open_carnival"});
		for k,v in pairs(config) do
			vo = self:getTaskConfigById(v.id);
			if vo == nil then
				vo = Lua_OpenServerCarnivalTaskVo.new(v.id, v);
				self.taskDic[v.id] = vo;
			end
		end
	end
end

-- 记录每期最终奖励
function Lua_OpenServerCarnivalData:recordFinishReward(configObj)
	if self.finishReward == nil then
		self.finishReward = {};
	end

	local rewardId = configObj.reward_id;
	if type(configObj.id) == "string" and rewardId ~= nil then
		self.finishReward[rewardId] = configObj.id;
	end
end

--记录每期的活动天数信息
function Lua_OpenServerCarnivalData:recordDayList(vo)
	local taskTab = vo.taskTab;
	if self.tabDayIdList[taskTab] == nil then
		self.tabDayIdList[taskTab] = {}; -- 每期活动的天数id
		self.totalTasksCount[taskTab] = 0; -- 每期任务总数
	end

	local count = #self.tabDayIdList[taskTab];
	self.tabDayIdList[taskTab][count + 1] = vo.id;
	self.totalTasksCount[taskTab] = self.totalTasksCount[taskTab] + vo.dayTaskCount;
end

-- 根据活动期数获取对应天数id列表
function Lua_OpenServerCarnivalData:getDayIdListByTab(tab)
	if tab == nil or self.tabDayIdList[tab] == nil then
		return nil;
	end

	return self.tabDayIdList[tab];
end

-- 根据活动期数获取对应的最终奖励id
function Lua_OpenServerCarnivalData:getFinishRewardByTab(tab)
	if tab == nil or self.finishReward == nil or self.finishReward[tab] == nil then
		return nil;
	end
	return self.finishReward[tab];
end

-- 根据活动期数获取任务总数
function Lua_OpenServerCarnivalData:getTotalTaskCountByTab(tab)
	if tab == nil or self.totalTasksCount[tab] == nil then
		return nil;
	end
	return self.totalTasksCount[tab];
end

-- 是否关闭活动
function Lua_OpenServerCarnivalData:closeActivity()
	if self.isCloseAct then 
		DataCenter.mainMenuData:setIconShowInfo(Lua_MenuViewDefine.ICON_OPENSERVER_CARNIVAL, false);
	end
end

-- 根据id获取天数信息Vo
function Lua_OpenServerCarnivalData:getDayConfigById(id)
	if id == nil or self.dayConfigList == nil or self.dayConfigList[id] == nil then
		return nil;
	end
	return self.dayConfigList[id];
end

-- 根据任务id获取任务config
function Lua_OpenServerCarnivalData:getTaskConfigById(taskId)
	if taskId == nil or self.taskDic == nil or self.taskDic[taskId] == nil then
		return nil;
	end
	return self.taskDic[taskId];
end

function Lua_OpenServerCarnivalData:updateServerInfo(total_reward_state, open_day, day_reward_state, task_info)
	local vo;
	local id;
	for i = 1, #total_reward_state do
		id = self:getFinishRewardByTab(total_reward_state[i].key);
		vo = self:getDayConfigById(id);
		vo.rewardState = total_reward_state[i].value;
	end
	
	--开启天数限制
	self.openDay = open_day <= 0 and 1 or open_day;
	self.openDay = self.openDay > self.totalDay and self.totalDay or self.openDay;

	-- 更新每日奖励的领取状态
	local obj;
	for i = 1, #day_reward_state do
		obj = day_reward_state[i];
		vo = self:getDayConfigById(obj.key);
		vo.rewardState = tonumber(obj.value);
	end

	-- 更新任务的领取状态
	for i = 1, #task_info do
		obj = task_info[i];
		vo = self:getTaskConfigById(obj.key);
		vo.rewardState = tonumber(obj.value);
		vo.curProcess = tonumber(obj.other);
	end
end

-- 根据天数id获取该天已完成的任务数量(可领取或已领取)
function Lua_OpenServerCarnivalData:getCompletedTaskCountByDay(day)
	local id;
	local rewardState;
	local count = 0;
	local osvo = self:getDayConfigById(day);
	if osvo ~= nil then
		local taskList = osvo.taskIdList;
		for i = 1, #taskList do
			id = taskList[i];
			rewardState = self:getTaskConfigById(id).rewardState;
			if rewardState == 1 or rewardState == 2 then
				count = count + 1;
			end
		end
	end
	return count;
end

-- 获取第几期内openday天数以内的任务完成数量
function Lua_OpenServerCarnivalData:getTotalCompletedTask(tabId)
	local totalCount = 0;

	if tabId > self.hasActCount then
		return totalCount;
	end

	local startDay = tabId == 2 and self.openSecActDay or 1;
	local endDay = tabId == 2 and self.openDay or (self.openDay < self.openSecActDay and self.openDay or self.openSecActDay - 1);
	for i = startDay, endDay do

		totalCount = totalCount + self:getCompletedTaskCountByDay(self.dayIdBaseCount + i);
	end
	return totalCount;
end

-- 根据天数id,判断该天是否有奖励未领取
function Lua_OpenServerCarnivalData:enableReceiveRewardByDay(day)
	return self:enableSatisfyCondition(day,1);
end

-- 根据天数id,判断该天是否有任务未完成
function Lua_OpenServerCarnivalData:haveUncompleteTaskByDay(day)
	return self:enableSatisfyCondition(day,0);
end

--day天是否满足条件condition：0：不可领   1:可领取   2：已领取
function Lua_OpenServerCarnivalData:enableSatisfyCondition(day, condition)
	if day == nil or self.dayConfigList == nil or self.dayConfigList[day] == nil then
		return false;
	end

	local id;
	local rewardState;
	local taskList = self:getDayConfigById(day).taskIdList;

	for i = 1, #taskList do
		id = taskList[i];
		rewardState = self:getTaskConfigById(id).rewardState;

		if rewardState == condition then
			return true;
		end
	end
	return false;
end

-- 更新红点
function Lua_OpenServerCarnivalData:showRedPoint()
	local dayId;
	local endDayId;
	self.firstTabRewardId = nil; 
	self.secondTabRewardId = nil;
	self.hasActCount = self.openDay >= self.openSecActDay and 2 or 1; -- 同时存在几种活动

	endDayId = self.hasActCount == 2 and self.openSecActDay - 1 or self.openDay;
	for i = 1, endDayId do
		dayId = self.dayIdBaseCount + i;
		if self:enableReceiveRewardByDay(dayId) == true or self:getDayConfigById(dayId).rewardState == 1 then
			self.firstTabRewardId = dayId; 
			break;
		end
	end
	if self.firstTabRewardId == nil then
		local finishReward = self:getDayConfigById("one");
		local hasReward = finishReward ~= nil and finishReward.rewardState == 1;
		self.firstTabRewardId = hasReward and self.openSecActDay - 1 + self.dayIdBaseCount or nil;
	end


	for i = self.openSecActDay, self.openDay do
		dayId = self.dayIdBaseCount + i;
		if self:enableReceiveRewardByDay(dayId) == true or self:getDayConfigById(dayId).rewardState == 1 then
			self.secondTabRewardId = dayId; 
			break;
		end
	end
	if self.secondTabRewardId == nil then
		local finishReward = self:getDayConfigById("two");
		local hasReward = finishReward ~= nil and finishReward.rewardState == 1;
		self.secondTabRewardId = hasReward and self.totalActDay + self.dayIdBaseCount or nil;
	end
	-- 红点
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerCarnival_First,  self.firstTabRewardId  ~= nil);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerCarnival_Second, self.secondTabRewardId ~= nil);
end

function Lua_OpenServerCarnivalData:getSelectedDayByTab(tab)
	if tab == nil then
		-- 第一期有奖励可领取时，优先打开
		if self.firstTabRewardId ~= nil then
			return self.firstTabRewardId, 1;
		elseif self.secondTabRewardId ~= nil then
			return self.secondTabRewardId, 2;
		end
	elseif tab == 1 and self.firstTabRewardId ~= nil then
		return self.firstTabRewardId;
	elseif tab == 2 and self.secondTabRewardId ~= nil then
		return self.secondTabRewardId;
	end

	local dayId;
	local targetDayId;
	local startDay;
	local endDay;

	if tab == nil then
		startDay = self.hasActCount == 2 and self.openSecActDay or 1;
		endDay = self.openDay;
	elseif tab == 1 then
		startDay = 1;
		endDay = self.openDay >= self.openSecActDay and self.openSecActDay - 1 or self.openDay;
	elseif tab == 2 then
		startDay = self.openSecActDay;
		-- endDay = self.openDay;
		endDay = self.openDay >= self.openSecActDay and self.openDay or self.openSecActDay;
	end
	
	targetDayId = self.dayIdBaseCount + endDay;

	for i = startDay, endDay do
		dayId = self.dayIdBaseCount + i;
		if self:haveUncompleteTaskByDay(dayId) == true then
			targetDayId = dayId;
			break;
		end
	end

	return targetDayId, tab == nil and self.hasActCount or tab;
end

-- 根据dayId 获取具体天数
function Lua_OpenServerCarnivalData:getDayTxtByDayId(dayId)
	return dayId - self.dayIdBaseCount;
end

-- 根据dayId,页签tab 获取具体列表中的index
function Lua_OpenServerCarnivalData:getDayIndex(tab, dayId)
	local index = tab == 1 and dayId - self.dayIdBaseCount or dayId - self.dayIdBaseCount - (self.openSecActDay - 1 );
	return index;
end

-- 能否点击
function Lua_OpenServerCarnivalData.Get:canPressByTime()
	-- 点击间隔
	local curTime = getTime();
	if curTime - self.curPressTime < self.pressDelta then
		self.curPressTime = curTime;
		return false;
	end
	return true;
end

-- -- 排序规则
-- function Lua_OpenServerCarnivalData:sortFunc(a, b)
-- 	local aState = self:getTaskConfigById(a).rewardState;
-- 	local bState = self:getTaskConfigById(b).rewardState;
-- 	local aWeight = a - aState % 2 *10000 + Mathf.Floor( aState / 2) * 1000;
-- 	local bWeight = b - bState % 2 *10000 + Mathf.Floor( bState / 2) * 1000;
-- 	if aWeight > bWeight then
-- 		return false;
-- 	else
-- 		return true;
-- 	end
-- end
