--开服狂欢
Lua_OpenServerCarnivalVo = class("Lua_OpenServerCarnivalVo");
function Lua_OpenServerCarnivalVo:ctor(id,config)
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig({"open_carnival_reward", id });
	end
	self.rewardState = 0;
end

-- 奖励携带对应的id
function Lua_OpenServerCarnivalVo.Get:rewardItems()
	if self._rewardItems == nil then
		self._rewardItems = {};
		local rewards = self.config.reward_items;
		local _isFinishReward = type(self.id) ~= "number";
		local rewardId = _isFinishReward and self.config.reward_id or self.id;
		for i = 1, #rewards do
			self._rewardItems[i] = {id = self.id, reward = rewards[i], receiveId = rewardId };
		end
	end
	return self._rewardItems;
end

-- 对应的任务id列表
function Lua_OpenServerCarnivalVo.Get:taskIdList()
	return self.config.task_id_list;
end

-- 获取对应的任务数量
function Lua_OpenServerCarnivalVo.Get:dayTaskCount()
	return #self.taskIdList;
end

-- 获取对应的任务活动期数
function Lua_OpenServerCarnivalVo.Get:taskTab()
	return self.config.task_tab;
end







---------------------------------------------------------------------
--任务信息
Lua_OpenServerCarnivalTaskVo = class("Lua_OpenServerCarnivalTaskVo")
function Lua_OpenServerCarnivalTaskVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig({"open_carnival", id });
	end
	self.rewardState = 0;
	self.curProcess = 0;
end

-- 任务标题
function Lua_OpenServerCarnivalTaskVo.Get:title()
	return self.config.title;
end

--任务描述
function Lua_OpenServerCarnivalTaskVo.Get:description()
	return self.totalTaskInfo.desc;
end

-- 任务类型
function Lua_OpenServerCarnivalTaskVo.Get:type()
	return self.totalTaskInfo.task_id;
end

function Lua_OpenServerCarnivalTaskVo.Get:curProcess()
	if self._curProcess == nil then
		self._curProcess = 0;
	end
	return self._curProcess;
end

function Lua_OpenServerCarnivalTaskVo.Set:curProcess(value)
	if self.bLevel and value ~= 0 then
		local config = getConfig({ "mainline_game_level", value});
		if config ~= nil then
			self._curProcess = config.number;
		end;
	else
		self._curProcess = value;
	end
end

--进度
function Lua_OpenServerCarnivalTaskVo.Get:process()
	if self.bLevel then
		local config = getConfig({ "mainline_game_level", self.totalTaskInfo.progress});
		if config ~= nil then
			return config.number;
		end;
	end
	return self.totalTaskInfo.progress;
end

--任务奖励
function Lua_OpenServerCarnivalTaskVo.Get:rewardLists()
	return self.totalTaskInfo.reward;
end

--功能跳转id
function Lua_OpenServerCarnivalTaskVo.Get:funcPathId()
	return self.totalTaskInfo.eventId
end

-- 条件id（用于读取总表内对应的数据）
function Lua_OpenServerCarnivalTaskVo.Get:conditionId()
	return self.config.condition_id;
end

-- 读取总表内对应的数据
function Lua_OpenServerCarnivalTaskVo.Get:totalTaskInfo()
	if self._totalTaskInfo == nil then
		self._totalTaskInfo = getConfig({"total_task", self.conditionId});
	end

	return self._totalTaskInfo;
end

-- 是否关卡
function Lua_OpenServerCarnivalTaskVo.Get:bLevel()
	return self.totalTaskInfo.task_id == 58;
end