checkRequire("Lua_OpenServerHeroGiftVo");
Lua_OpenServerHeroGiftData = class("Lua_OpenServerHeroGiftData");
function Lua_OpenServerHeroGiftData:ctor()
	self:dispose();
end

function Lua_OpenServerHeroGiftData:dispose()
	self.isOpen = 0; -- 默认没有打开英雄赠礼界面
	self.end_time = nil;
	self.cell_list = nil;
	self.isPlayTween = false;
	self.heroGiftDic = nil;
	self.phaseDic = nil;
	self._drawItemId = nil;
	self._drawItemNum = nil;
	self._entranceList = nil;
end

function Lua_OpenServerHeroGiftData:fromServer50197046(msg)
	if msg == nil then
		return;
	end

	if self.cell_list and #msg.cell_list == 0 and self.round_num == msg.round_num then
		self.heroGiftDic = nil;
	end

	self.round_num = msg.round_num; -- 轮次
	self.draw_num = msg.draw_num; -- 当前抽奖次数
	self.end_time = msg.end_time; -- 结束时间
	self.heroInfo = msg.hero_item; -- 英雄是否第一次抽中信息
	self.cell_num = msg.cell_num; -- 抽中格子id，0表示没进行抽奖
	self.cell_list = msg.cell_list; -- 已抽中格子id
	self.isPlayTween = msg.cell_num ~= 0;

	self:initConfigInfo();
	local id;
	for i = 1, #msg.cell_list do
		id = msg.cell_list[i];
		self.heroGiftDic[id]:updateDrawInfo(true);
	end
	
	self:updateHeroGiftRedDot();

	local time = self.end_time - DataCenter.roleData.serverTime
	DataCenter.mainMenuData:setIconShowInfo(Lua_MenuViewDefine.ICON_OPENSERVERTRIAL, time > 0, time);
end

function Lua_OpenServerHeroGiftData:initConfigInfo()
	if self.heroGiftDic == nil then
		self.heroGiftDic = {};
		self.phaseDic = {};

		local config = getConfig("hero_gift");
		local vo;
		local phase;
		local pos;
		for k, v in pairs(config) do
			if k ~= "const" then
				vo = Lua_OpenServerHeroGiftVo.new(k, v);
				self.heroGiftDic[vo.id] = vo;

				phase = Mathf.Floor(k / 10000);
				if self.phaseDic[phase] == nil then
					self.phaseDic[phase] = Array();
				end
				self.phaseDic[phase]:add(vo);
			end
		end

		phase = getConfig("hero_gift", "const", "round_limit");
		for i = 1, phase do
			self.phaseDic[i]:sort("id", false);
		end
	end
end

function Lua_OpenServerHeroGiftData:updateHeroGiftRedDot(dic)
	if self.end_time then
		local hasCount = DataCenter.packData:getItemCountById(self.drawItemId);
		local arr = self:curPhaseShowArr();
		local state = hasCount >= self.drawItemNum and arr:getSize() > self.draw_num;
		if dic ~= nil then
			if dic[self.drawItemId] ~= nil then
				DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerTrial_HeroGift, state);
			end
		else
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerTrial_HeroGift, state);
		end
	end
end

function Lua_OpenServerHeroGiftData:curPhaseShowArr()
	return self.phaseDic[self.round_num];
end

-- 抽奖道具id
function Lua_OpenServerHeroGiftData.Get:drawItemId()
	if self._drawItemId == nil then
		self._drawItemId = getConfig("hero_gift", "const", "recover_item");
	end
	return self._drawItemId[self.round_num];
end

-- 抽奖道具数量
function Lua_OpenServerHeroGiftData.Get:drawItemNum()
	if self._drawItemNum == nil then
		self._drawItemNum = getConfig("hero_gift", "const", "draw_num_list");
	end
	local curPhaseNumDic = self._drawItemNum[self.round_num];
	local times = self.draw_num >= #curPhaseNumDic and #curPhaseNumDic or self.draw_num + 1;
	return curPhaseNumDic[times];
end

-- 道具获取入口
function Lua_OpenServerHeroGiftData.Get:entranceList()
	if self._entranceList == nil then
		self._entranceList = getConfig("hero_gift", "const", "icon_list");
	end
	return self._entranceList[self.round_num];
end