checkRequire("Lua_InternalActivityVo");
Lua_InternalActivitiesData = class("Lua_InternalActivitiesData")
function Lua_InternalActivitiesData:ctor()
	self:superCall("ctor");
end

function Lua_InternalActivitiesData:dispose()
	self.actDic = nil;
end

function Lua_InternalActivitiesData:getActivityVo(id)
	if self.actDic == nil then
		self.actDic = {};
	end
	if self.actDic[id] == nil then
		local config = getConfig("internal_activities", id)
		if config == nil then
			return nil;
		end
		self.actDic[id] = Lua_InternalActivityVo.new(id);
	end
	return self.actDic[id];
end

-- 更新活动服务端数据
function Lua_InternalActivitiesData:updateActivityInfo(id, open_state, close_tick)
	if id == nil or id <= 0 then
		return;
	end
	open_state = (open_state == nil) and 0 or open_state; -- 1开启 0关闭
	close_tick = (close_tick == nil) and 0 or close_tick; -- 关闭时间

	local vo = self:getActivityVo(id);
	vo:fromServerInfo(open_state, close_tick);
end

function Lua_InternalActivitiesData:checkActIsOpened(id)
	local actVo = self:getActivityVo(id);
	if actVo.config == nil then
		return false;
	end
	return actVo.bOpened;
end

-- 检查活动是否结束
function Lua_InternalActivitiesData:checkActIsEnd(actVo, winName)
	if actVo == nil or not actVo.bOpened then
		-- 强制关闭整个活动界面
		if not strIsNullOrEmpty(winName) then
			Lua_WindowUtil.openWin(winName, Lua_WinParam.ACTION_CLOSE);
		end
		OperateAlert.showLangValue(107706);
		return true;
	end
	return false;
end