Lua_OperationalActivitiesUtil = class("Lua_OperationalActivitiesUtil")
function Lua_OperationalActivitiesUtil:ctor()
	self:superCall("ctor")
	self:dispose()
end

function Lua_OperationalActivitiesUtil:dispose()
	self.preActVo = nil
end

function Lua_OperationalActivitiesUtil:getActivityArr(iconId)
	local fixList
	if iconId == Lua_MenuViewDefine.ICON_WELFARE then -- 福利大厅
		fixList = {}
	elseif iconId == Lua_MenuViewDefine.ICON_EXCELLENT_ACT then -- 精彩活动
		fixList = {1, 2, 3, 10, 14, 15, 16, 58}
	elseif iconId == Lua_MenuViewDefine.ICON_LIMITEDTIME_ACT then -- 限时活动
		fixList = {47, 48, 49, 50, 51, 55}
	elseif iconId == Lua_MenuViewDefine.ICON_RACCOON_MART then -- 浣熊百货
		fixList = {4, 9, 46, 53}
	elseif iconId == Lua_MenuViewDefine.ICON_WAR_ORDER then -- 战令
		fixList = {17, 18, 52, 56, 57} -- 19 神陵秘境战令移除，策划说没有这个功能了
		-- if DataCenter.peakDuelData.openState then -- 巅峰对决
		-- 	table.insert(fixList, 20)
		-- end
	elseif iconId == Lua_MenuViewDefine.ICON_OPENSERVERTRIAL then -- 开服试炼
		fixList = {21}
	end

	local arr = Array()
	local tab = {}
	local vo
	local actId
	-- 内置活动
	if fixList then
		for i = 1, #fixList do
			vo = DataCenter.internalActData:getActivityVo(fixList[i])
			if vo.bOpened == true then
				arr:add(vo)
				tab[vo.id] = 1

				if vo.hasSecTab then
					for j = 1, #vo.sec_tab_list do
						actId = vo.sec_tab_list[j]
						tab[actId] = 1
					end
				end
			end
		end
	end

	-- 后台活动
	local actArr = DataCenter.backstageActData:getActArrByMainIconId(iconId)
	if actArr then
		for i = 1, actArr:getSize() do
			vo = DataCenter.backstageActData:getActVoByIdx(actArr[i])
			arr:add(vo)
			tab[vo.actType] = 1
		end
	end

	arr:sort("sort", false)
	return arr, tab
end

function Lua_OperationalActivitiesUtil:setPreLoadById(actId)
	local actVo = DataCenter.internalActData:getActivityVo(actId)
	self:setPreLoadByVo(actVo)
	return actVo
end

function Lua_OperationalActivitiesUtil:setPreLoadByType(actType)
	local arr = DataCenter.backstageActData:getActIdxArrByType(actType)
	if arr then
		local actVo = DataCenter.backstageActData:getActVoByIdx(arr[1])
		self:setPreLoadByVo(actVo)
		return actVo
	end
	return nil
end

function Lua_OperationalActivitiesUtil:setPreLoadByVo(actVo)
	if actVo == nil or self.preActVo then
		return
	end
	self.preActVo = actVo
end