--巅峰对决数据
checkRequire("Lua_PeakDuelRankVo");
Lua_PeakDuelData = class("Lua_PeakDuelData");
function Lua_PeakDuelData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_PeakDuelData:dispose()
	self.openState = false;
	self.segmentLvl = 101;
	self.region_id = 0;
	self.times = 1;

	self.topRankDic = nil;
	self.topRoleDic = nil;

	self.rankDic = nil;
	self.rankRoleDic = nil;

	self.left_buy_times = 0;
	self.left_match_times = 0;
	self.left_praise_times = 0;
	self.matchCoolTime = 0; -- 匹配冷却时间
	self.match_result = 0;
end

-- 巅峰对决界面信息(返回)
function Lua_PeakDuelData:fromServer50161001(msg)
	if msg == nil then
		return;
	end

	self.segmentLvl = msg.segment_lvl; -- 当前段位
	
	self.region_name = msg.region_name; -- 赛区
	self.region_id = tonumber(msg.region_id); -- 赛区id
	self.times = msg.times; -- 第几赛季

	if msg.top_three_role ~= nil then
		for i = 1, #msg.top_three_role do
			self:setTopRankInfo(msg.top_three_role[i]);
		end
	end

	self.left_buy_times = msg.left_buy_times; -- 剩余购买次数
	self.left_match_times = msg.left_match_times; -- 剩余匹配次数
	self.left_praise_times = msg.left_praise_times; -- 剩余点赞次数

	self.last_fight_tick = tonumber(msg.last_fight_tick);
	if self.last_fight_tick > 0 then
		local matching_cool_time = DataCenter.peakDuelUtil.matching_cool_time;
		local interval = DataCenter.roleData.serverTime - self.last_fight_tick;
		self.matchCoolTime = matching_cool_time - interval;
	end
end

function Lua_PeakDuelData:setTopRankInfo(info)
	if self.topRankDic == nil then
		self.topRankDic = {};
	end
	if self.topRoleDic == nil then
		self.topRoleDic = {};
	end
	local vo;
	if self.topRankDic[info.rank] == nil then
		vo = Lua_PeakDuelRankVo.new();
		self.topRankDic[info.rank] = vo;
	else
		vo = self.topRankDic[info.rank];
	end
	vo:fromServer(info);
	self.topRoleDic[vo.role_id] = vo.rank;
end

function Lua_PeakDuelData:updateTopRankInfo(role_id, praise_num, is_praised)
	if self.topRoleDic == nil or self.topRoleDic[role_id] == nil then
		return;
	end

	local rank = self.topRoleDic[role_id];
	self.topRankDic[rank].praise_num = praise_num;
	self.topRankDic[rank].is_praised = is_praised;
end











-- 巅峰对决排名信息(返回)
function Lua_PeakDuelData:fromServer50161008(msg)
	if msg == nil then
		return;
	end

	if msg.role_list ~= nil then
		if self.rankArr == nil then
			self.rankArr = Array();
		else
			self.rankArr:clear();
		end
		for i = 1, #msg.role_list do
			self:setRankInfo(msg.role_list[i], self.rankArr);
		end
	end

	if self.myRankVo == nil then
		self.myRankVo = Lua_PeakDuelRankVo.new();
	end
	self.myRankVo:fromServer(msg.self_rank);
end

-- 排名点赞(返回)
function Lua_PeakDuelData:fromServer50161009(msg)
	if msg == nil then
		return;
	end

	if tonumber(msg.region_id) == self.region_id and msg.times == self.times then -- 更新当前休赛期前三名
		self:updateTopRankInfo(tonumber(msg.player_id), msg.praise_num, msg.is_praised);
	end

	self:updateRankInfo(tonumber(msg.player_id), msg.praise_num, msg.is_praised);

	self.left_praise_times = msg.left_praise_times; --剩余点赞次数
end

function Lua_PeakDuelData:fromServer50161026(msg)
	if msg == nil then
		return;
	end	

	self.left_praise_times = msg.left_praise_times; --剩余点赞次数
end

function Lua_PeakDuelData:setRankInfo(info, arr)
	if self.rankDic == nil then
		self.rankDic = {};
	end
	if self.rankRoleDic == nil then
		self.rankRoleDic = {};
	end

	local vo;
	if self.rankDic[info.rank] == nil then
		vo = Lua_PeakDuelRankVo.new();
		self.rankDic[info.rank] = vo;
	else
		vo = self.rankDic[info.rank];
	end
	vo:fromServer(info);
	if vo.rank > 3 then
		arr:add(vo.rank);
	end
	self.rankRoleDic[vo.role_id] = vo.rank;
end

function Lua_PeakDuelData:updateRankInfo(role_id, praise_num, is_praised)
	if self.rankRoleDic == nil or self.rankRoleDic[role_id] == nil then
		return;
	end

	local rank = self.rankRoleDic[role_id];
	self.rankDic[rank].praise_num = praise_num;
	self.rankDic[rank].is_praised = is_praised;
end

function Lua_PeakDuelData:getRankInfo(rank)
	if self.rankDic == nil then
		return nil;
	end
	return self.rankDic[rank];
end

function Lua_PeakDuelData:fromServer50161021(msg)
	if msg == nil then
		return;
	end
	self.left_buy_times = msg.left_buy_times; -- 剩余购买次数
	self.left_match_times = msg.left_match_times; -- 剩余匹配次数
end








-- 巅峰对决匹配界面(返回)
function Lua_PeakDuelData:fromServer50161022(msg)
	if msg == nil then
		return;
	end

	self.left_match_times = msg.left_match_times; -- 剩余匹配次数
	self.match_result = msg.is_have_match; -- 是否有匹配数据 0没有 1有匹配数据

	-- if self.is_have_match == 1 then
	-- 	self:updateMatchResult(msg)
	-- 	self.match_result = 1;
	-- else
	-- 	self.lineup = nil;
	-- 	self.show_role = nil;
	-- 	self.match_segment = nil;
	-- 	self.fight_start_tick = nil;
	-- end
end

function Lua_PeakDuelData:fromServer50161003(msg)
	if msg == nil then
		return;
	end

	self.left_match_times = msg.left_match_times; -- 剩余匹配次数
	self.match_result = msg.match_result; -- 匹配结果 1：成功 0：失败
end

-- -- 巅峰对决匹配结果(返回)
-- function Lua_PeakDuelData:updateMatchResult(msg)
-- 	if msg == nil then
-- 		return;
-- 	end
-- 	self.match_result = msg.match_result;--匹配结果 1：成功 0：失败

-- 	self.show_role = msg.match_info.show_role;--角色信息
-- 	self.match_segment = msg.match_info.segment_lvl;--对手段位
-- 	self.fight_start_tick = msg.match_info.fight_start_tick;--战斗开始时戳

-- 	self.matchLineupDic = {};
-- 	local list = msg.match_info.lineup;--匹配到的阵容
-- 	for i=1,#list do
-- 		self.matchLineupDic[list[i].index] = list[i];
-- 	end
-- end

-- -- 获取匹配某个分队数据
-- function Lua_PeakDuelData:getMatchLineupInfo(lineup_type, group_index)
--     if self.matchLineupDic == nil or self.matchLineupDic[lineup_type] == nil then
--         return nil;
--     end
--     return self.matchLineupDic[group_index];
-- end

-- -- 可以匹配剩余时间
-- function Lua_PeakDuelData.Get:matchLeftTime()
--     local time = self.fightStarTimes == 0 and self.fight_start_tick or self.fightStarTimes;
--     if time == 0 then
--     	return 0;
--     end
--     local leftiTmes = DataCenter.roleData.serverTime - time - DataCenter.peakDuelUtil.matching_cool_time;
-- 	if leftiTmes <= 0 then
--     	return 0;
--     end
--     return leftiTmes;
-- end

-- -- 通知巅峰对决战斗结算
-- function Lua_PeakDuelData:fromServer80161013(msg)
-- 	if msg == nil then
-- 		return;
-- 	end
-- 	self.msg80161013 = msg;
-- 	--晋级数据
-- 	self.fightResultDic = {};
-- 	local f_list = msg.upgrade_result;--key:升段赛的第几场 value:战斗结果 1胜利 0失败
-- 	for i=1,#f_list do
-- 		self.fightResultDic[f_list[i].key] = f_list[i].value;
-- 	end
-- end