checkRequire("Lua_WeeklyGiftVo");
Lua_WeeklyGiftData = class("Lua_WeeklyGiftData");
function Lua_WeeklyGiftData:ctor()
	self:dispose();
end

function Lua_WeeklyGiftData:dispose()
	self._weeklyGiftArr = Array();
	self.weeklyGiftDic = {};
	self.openWeek = nil;
	self.worldLv = nil;
end

function Lua_WeeklyGiftData:fromServer50197012(msg)
	if msg == nil then
		return;
	end

	self.openWeek = msg.open_week; -- 开服周数
	self.worldLv = msg.world_level; -- 世界等级
	self.nextWeek = msg.next_week; -- 下周刷新时间戳
	self:updateWeeklyGiftInfo(msg.grade_state); -- 各档位剩余领取次数 key礼包id value剩余次数
end

function Lua_WeeklyGiftData:updateWeeklyGiftInfo(msg)
	local obj;
	local vo;
	local redShowState = false;
	self._weeklyGiftArr:clear();
	for i = 1, #msg do
		obj = msg[i];
		vo = self.weeklyGiftDic[obj.key];
		if vo == nil then
			local config = getConfig("week_gift", obj.key);
			if config ~= nil then
				vo = Lua_WeeklyGiftVo.new(obj.key, config);
				self.weeklyGiftDic[obj.key] = vo;
			end
		end
		
		if vo ~= nil then
			vo:updateBuyTimes(obj.value, self.openWeek, self.worldLv);
			if vo.isOpened then
				self._weeklyGiftArr:add(vo);
				if not redShowState and vo.recharge == 0 and vo.curLimitTimes > 0 then
					redShowState = true;
				end
			end
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.RaccoonMart_GiftShop_WeeklyGift, redShowState);
end

function Lua_WeeklyGiftData:getWeeklyGiftVoById(id)
	return self.weeklyGiftDic[id];
end

function Lua_WeeklyGiftData.Get:weeklyGiftArr()
	self._weeklyGiftArr:sortf(self, self.sortFun);
	return self._weeklyGiftArr;
end

function Lua_WeeklyGiftData:sortFun(a, b)
	local _a = a.curLimitTimes;
	local _b = b.curLimitTimes;
	if (_a > 0 and _b > 0) or (_a <= 0 and _b <= 0) then
		if a.id > b.id then
			return false;
		end
	elseif _b > 0 then
		return false;
	end
	return true;
end