Lua_MonthCardVo = class("Lua_MonthCardVo")
function Lua_MonthCardVo:ctor(id, config)
	self.id = id;
	self._config = config;

	self:dispose();
end

function Lua_MonthCardVo:dispose()
	self.draw_State = 0; -- 领取状态
	self.residue_Days = 0; -- 剩余时间
	self.aggregatment = 0; -- 累计充值
end

function Lua_MonthCardVo:fromServer(msg)
	self.draw_State = msg.draw_state; -- 领取状态，0 不可领取，1 可领取，2 已领取
	self.residue_Days = msg.residue_days; -- 剩余时间
	self.aggregatment = Mathf.Floor(msg.total_recharge); -- 累计充值
end





function Lua_MonthCardVo.Get:config()
	if self._config == nil then
		self._config = getConfig("recharge_month_card", self.id);
	end
	return self._config;
end

-- 天数
function Lua_MonthCardVo.Get:day()
	return self.config.day;
end

-- 总金额
function Lua_MonthCardVo.Get:total_recharge()
	return self.config.total_recharge;
end

-- 档位
function Lua_MonthCardVo.Get:grade()
	return self.config.grade;
end

-- 月卡是否开启
function Lua_MonthCardVo.Get:open()
	return self.config.open;
end

-- 月卡奖励配置
function Lua_MonthCardVo.Get:reward()
	return self.config.reward;
end

-- 月卡背景
function Lua_MonthCardVo.Get:card_bg()
	return self.config.card_bg;
end

-- 月卡icon 图集
function Lua_MonthCardVo.Get:icon_atlas()
	return self.config.icon_atlas;
end

-- 月卡icon 图
function Lua_MonthCardVo.Get:icon_sprite()
	return self.config.icon_sprite;
end

-- 活动开启等级
function Lua_MonthCardVo.Get:open_Level()
	return self.config.open_level;
end

-- 同档位月卡配置优先级
function Lua_MonthCardVo.Get:sortIndex()
	return self.config.sort_index;
end

-- 月卡总奖励
function Lua_MonthCardVo.Get:total_Reward()
	return self.config.reward[2] * self.config.day;
end