--排行榜Data
Lua_RankData = class("Lua_RankData");

--排行榜类型
Lua_RankData.FIGHT_TYPE = 2;--战力排行
Lua_RankData.LIGHT_TOWER_TYPE = 9;--光之塔排行
Lua_RankData.STAR_TRIAL_TYPE = 10;--星魂试炼排行
Lua_RankData.WIND_TYPE = 11; --风系英雄养成排行
Lua_RankData.FIRE_TYPE = 12; --火系英雄养成排行
Lua_RankData.WATER_TYPE = 13;--水系英雄养成排行
Lua_RankData.SOIL_TYPE = 14;--水系英雄养成排行
Lua_RankData.LIGHT_TYPE = 15;--光系英雄养成排行
Lua_RankData.DARK_TYPE = 16;--暗系英雄养成排行
Lua_RankData.MAIN_LINE_TYPE = 17;--主线通关排行榜
Lua_RankData.LEAGUE_TYPE = 18;--联盟排行榜
Lua_RankData.ARENA_TYPE = 19;--竞技场排行榜
Lua_RankData.MONSTER_TYPE = 20;--新英雄-怪物副本排行
Lua_RankData.CHAOS_FORES_TYPE = 21;--幽暗森林排行
Lua_RankData.CROSS_SERVER_LEAGUE_TYPE = 2002;--跨服公会榜
Lua_RankData.CROSS_SERVER_FIGHT_TYPE = 2003;--跨服战力榜
Lua_RankData.KUNXUHOLYLAND_TYPE = 2005; --昆墟圣地

function Lua_RankData:ctor()
	self:dispose()
end

function Lua_RankData:dispose()
	self.curRankType = nil;
	self.rankMainInfo = {};
	self.rankProgress = {};
end

function Lua_RankData:fromServer50109001(msg)
	Lua_MsgUtil.callFunc("UPDATE_RANK_INFO", msg);
end

function Lua_RankData:fromServer50109002(msg)
	local info;
	for i = 1, #msg.rank_list do
		info = msg.rank_list[i]
		self.rankMainInfo[info.rank_type] = info.ranker
	end
	Lua_MsgUtil.callFunc("UPDATE_RANK_MAIN_INFO");
end

function Lua_RankData:getRankMainInfo(rankType)
	return self.rankMainInfo[rankType]
end

function Lua_RankData:fromServer50109003(msg)
	local info;
	for i = 1, #msg.rank_progress do
		info = msg.rank_progress[i]
		self.rankProgress[info.id] = info
	end
	Lua_MsgUtil.callFunc("UPDATE_RANK_REWARD_INFO")
end

function Lua_RankData:fromServer50109004(msg)
	local info = msg.rank_progress
	self.rankProgress[info.id] = info
	Lua_MsgUtil.callFunc("UPDATE_RANK_REWARD_INFO")
end

function Lua_RankData:getRankProgress(id)
	return self.rankProgress[id]
end

function Lua_RankData:fromServer80109005(msg)
	self.rankRedState = {}
	local state = false
	local info;
	for i = 1, #msg.rank_type_list do
		info = msg.rank_type_list[i]
		self.rankRedState[info] = 1
		state = true
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Rank, state)
	Lua_MsgUtil.callFunc("UPDATE_RANK_REDPOINT")
end

function Lua_RankData:getRedPointState(rankType)
	if self.rankRedState == nil then
		return nil
	end
	return self.rankRedState[rankType]
end

function Lua_RankData:getRankRewardArr(rankType)
	local arr = DataCenter.rankUtil:getRewardConfigArr(rankType);
	if arr then
		arr:sortf(self, self.rewardSortFun)
	end
	return arr;
end

function Lua_RankData:rewardSortFun(a, b)
	local _a = self.rankProgress[a.id]
	local _b = self.rankProgress[b.id]
	if _a == nil or _a.state == 0 then
		_a = 100000000 + a.id
	else
		if _a.state == 1 then
			_a = a.id
		elseif _a.state == 2 then
			_a = 900000000 + a.id
		end
	end
	if _b == nil or _b.state == 0 then
		_b = 100000000 + b.id
	else
		if _b.state == 1 then
			_b = b.id
		elseif _b.state == 2 then
			_b = 900000000 + b.id
		end
	end

	if _a > _b then
		return false
	end
	return true
end