--排行榜Proxy
checkRequire("Lua_RankData");
checkRequire("Lua_RankUtil");
Lua_RankProxy = class("Lua_RankProxy");

function Lua_RankProxy:ctor()
	DataCenter.rankData = Lua_RankData.new();
	DataCenter.rankUtil = Lua_RankUtil.new();

	Lua_MsgUtil.addLuaMsg(50109001, self, self.rGetRankInfo); --请求排行榜信息(返回)
	Lua_MsgUtil.addLuaMsg(50109002, self, self.rGetRankMainInfo); --请求排行榜主页信息(返回)
	Lua_MsgUtil.addLuaMsg(50109003, self, self.rGetRankRewardInfo); --请求进度奖励界面(返回)
	Lua_MsgUtil.addLuaMsg(50109004, self, self.rReceiveReward); --请求领取进度奖励(返回)
	Lua_MsgUtil.addLuaMsg(50109011, self, self.rAllianceRank); --请求公会战力排行返回
	Lua_MsgUtil.addLuaMsg(80109005, self, self.updateRankRedPoint); --排行榜奖励红点通知
end

------------------------------------上行------------------------------------

function Lua_RankProxy:sGetRankInfo(rank_type, page)--请求排行榜信息
	local cmd = ProtoPublic_pb.Proto10109001();
	cmd.rank_type = rank_type; -- 排行类型
	cmd.page = page; -- 0：清空刷新 1 下一页
	sendMsg(10109001, cmd);
end

function Lua_RankProxy:sGetRankMainInfo()--请求排行榜主页信息
	sendMsg(10109002);
end

function Lua_RankProxy:sGetRankRewardInfo(type)--请求进度奖励界面
	local cmd = ProtoPublic_pb.Proto10109003();
	cmd.type = type;
	sendMsg(10109003, cmd);
end

function Lua_RankProxy:sReceiveReward(rank_type, id)--请求领取进度奖励
	local cmd = ProtoPublic_pb.Proto10109004();
	cmd.rank_type = rank_type;
	cmd.id = id;
	sendMsg(10109004, cmd);
end

function Lua_RankProxy:sAllianceRank(page)--请求公会战力排行
	local cmd = ProtoPublic_pb.Proto10109011();
	cmd.page = page;
	sendMsg(10109011, cmd);
end

------------------------------------下行------------------------------------

function Lua_RankProxy:rGetRankInfo(mp)--请求排行榜信息(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50109001();
		msg:ParseFromString(mp.data);
		DataCenter.rankData:fromServer50109001(msg);
	end
end

function Lua_RankProxy:rGetRankMainInfo(mp)--请求排行榜主页信息(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50109002();
		msg:ParseFromString(mp.data);
		DataCenter.rankData:fromServer50109002(msg);
	end
end

function Lua_RankProxy:rGetRankRewardInfo(mp)--请求进度奖励界面(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50109003();
		msg:ParseFromString(mp.data);
		DataCenter.rankData:fromServer50109003(msg);
	end
end

function Lua_RankProxy:rReceiveReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50109004();
		msg:ParseFromString(mp.data);
		DataCenter.rankData:fromServer50109004(msg);
	end
end

function Lua_RankProxy:rAllianceRank(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50109011();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_RANK_INFO", msg);
	end
end

function Lua_RankProxy:updateRankRedPoint(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80109005();
		msg:ParseFromString(mp.data);
		DataCenter.rankData:fromServer80109005(msg);
	end
end