-- 六边形地图单元
Lua_HexagonMapCell = class("Lua_HexagonMapCell");
function Lua_HexagonMapCell:ctor()
	self:superCall("ctor");
	
	self._id = nil;
	self.sceneId = 0;
	self.fightId = 0;
	self.gCost = 0;
	self.hCost = 0;
	self.config = nil;
end

function Lua_HexagonMapCell:clean()
	self._id = 0;
	self.sceneId = 0;
	self.fightId = 0;
	self.gCost = 0;
	self.hCost = 0;
	self.config = nil;
end

function Lua_HexagonMapCell.Get:id()
	return self._id;
end

function Lua_HexagonMapCell:setSceneInfo(sid, fid, cellId)
	self._id = cellId;
	self.sceneId = sid;
	self.fightId = fid;
	self.config = getConfig({"tb_hexagonMapCell", cellId});
end

function Lua_HexagonMapCell.Get:cube()
	if self.config ~= nil then
		return self.config.cube;
	end
	return nil;
end

function Lua_HexagonMapCell.Get:position()
	if self.config ~= nil then
		return self.config.position;
	end
	return nil;
end

function Lua_HexagonMapCell.Get:neighbors()
	if self.config ~= nil then
		return self.config.neighbors;
	end
	return nil;
end

function Lua_HexagonMapCell.Get:gridType()
	if self.config ~= nil and self.config.grid_type ~= nil then
		return self.config.grid_type;
	end
	return 0;
end

function Lua_HexagonMapCell.Get:fCost()
	return self.hCost + self.gCost;
end