checkRequire("Lua_StructureVo")
Lua_ConstructUtil = class("Lua_ConstructUtil")
function Lua_ConstructUtil:ctor()
	self:superCall("ctor")
end

function Lua_ConstructUtil:init()
	if self.bInit ~= true then
		self.bInit = true
		self.sceneDic = {}
		self.modelDic = {}
		local config = getConfig({ "structure" })
		for k, v in pairs(config) do
			if self.sceneDic[v.scene_id] == nil then
				self.sceneDic[v.scene_id] = Array()
			end
			self.sceneDic[v.scene_id]:add(k)

			if not strIsNullOrEmpty(v.modelSrc) then
				self.modelDic[v.modelSrc] = k
			end
		end
		for _, v in pairs(self.sceneDic) do
			v:sortf(self, self.onSreucrureSortFun)
		end
	end
end

function Lua_ConstructUtil:onSreucrureSortFun(a, b)
	a = self:getStructureVo(a)
	b = self:getStructureVo(b)
	if a.sort > b.sort then
		return false
	end
	return true
end

function Lua_ConstructUtil:getStructureArr(sceneId)
	self:init()
	return self.sceneDic[sceneId]
end

function Lua_ConstructUtil:getStructureVo(id)
	if self.structureDic == nil then
		self.structureDic = {}
	end
	if self.structureDic[id] == nil then
		local config = getConfig("structure", id)
		if config == nil then
			return nil
		end
		self.structureDic[id] = Lua_StructureVo.new(id, config)
	end
	return self.structureDic[id]
end

function Lua_ConstructUtil:getVoByModelSrc(modelSrc)
	self:init()
	local id = self.modelDic[modelSrc]
	if id and id > 0 then
		return self:getStructureVo(id)
	end
	return nil
end