-- 场景
Lua_SceneUtil = class("Lua_SceneUtil");
function Lua_SceneUtil:ctor()
	self:superCall("ctor");
end

function Lua_SceneUtil:getGridCfg(gridId)
	if gridId == nil or gridId <= 0 then
		return nil;
	end
	return getConfig({"tb_hexagonMapCell", gridId});
end


function Lua_SceneUtil:getGridCube(gridId)
	if gridId == nil or gridId <= 0 then
		return nil;
	end
	
	local gridCfg = getConfig({"tb_hexagonMapCell", gridId});
	if gridCfg ~= nil then
		return gridCfg.cube;
	end
	return nil;
end

function Lua_SceneUtil:getGridPosition(gridId)
	if gridId == nil or gridId <= 0 then
		return nil;
	end

	local gridCfg = getConfig({"tb_hexagonMapCell", gridId});
	if gridCfg ~= nil then
		return gridCfg.position;
	end
	return nil;
end

function Lua_SceneUtil:getGridNeighbors(gridId)
	if gridId == nil or gridId <= 0 then
		return nil;
	end
	
	local gridCfg = getConfig({"tb_hexagonMapCell", gridId});
	if gridCfg ~= nil then
		return gridCfg.neighbors;
	end
	return nil;
end

function Lua_SceneUtil:getGridType(gridId)
	if gridId == nil or gridId <= 0 then
		return 0;
	end
	
	local gridCfg = getConfig({"tb_hexagonMapCell", gridId});
	if gridCfg ~= nil and gridCfg.grid_type ~= nil then
		return gridCfg.grid_type;
	end
	return 0;
end