-- 漫游点配置
Lua_SceneWanderPointConfigData = class("Lua_SceneWanderPointConfigData");
function Lua_SceneWanderPointConfigData.getConfigData(pid)
    if pid == nil then
        return nil;
    end

    if Lua_SceneWanderPointConfigData.configs == nil then
        Lua_SceneWanderPointConfigData.configs = {};
    end

    if Lua_SceneWanderPointConfigData.configs[pid] == nil then
        local cfg = getConfig({"tb_sceneWanderPoint", pid});
        if cfg == nil then return nil; end
        Lua_SceneWanderPointConfigData.configs[pid] = Lua_SceneWanderPointConfigData.new(pid, cfg);
    end
    return Lua_SceneWanderPointConfigData.configs[pid];
end

function Lua_SceneWanderPointConfigData:ctor(pid, config)
    self:superCall("ctor");
    self.id = pid;
    self.config = config;
    if self.config == nil then
        self.config = getConfig({"tb_sceneWanderPoint", pid});
    end
end

function Lua_SceneWanderPointConfigData.Get:sceneId()
	if self.config.sceneId == nil then
		return 0;
	end
    return self.config.sceneId;
end

function Lua_SceneWanderPointConfigData.Get:nextPosId()
	if self.config.nextPosId == nil then
		return 0;
	end
    return self.config.nextPosId;
end

function Lua_SceneWanderPointConfigData.Get:pos()
    return self.config.pos;
end 

function Lua_SceneWanderPointConfigData.Get:posVec()
	if self._posVec == nil then
		local list = self.config.pos;
		if list == nil then
			return nil;
		end

		local px = #list > 0 and list[1] or 0;
		local py = #list > 1 and list[2] or 0;
		local pz = #list > 2 and list[3] or 0;
		self._posVec = Vector3(px, py, pz);
	end
    return self._posVec;
end 

function Lua_SceneWanderPointConfigData.Get:moveType()
	if self.config.moveType == nil then
		return 0;
	end
    return self.config.moveType;
end

function Lua_SceneWanderPointConfigData.Get:isMoveToTarget()
    return self.moveType ~= 1;
end

function Lua_SceneWanderPointConfigData.Get:monsterGroupId()
	if self.config.monsterGroupId == nil then
		return 0;
	end
    return self.config.monsterGroupId;
end

function Lua_SceneWanderPointConfigData.Get:monsterMoveGroupId()
	if self.config.monsterMoveGroupId == nil then
		return 0;
	end
    return self.config.monsterMoveGroupId;
end

function Lua_SceneWanderPointConfigData.Get:completeCondition()
	if self.config.completeCondition == nil then
		return 0;
	end
	return self.config.completeCondition;
end

function Lua_SceneWanderPointConfigData.Get:formationDis()
	if self.config.formationDis == nil then
		return 300;
	end
	return self.config.formationDis;
end