-- 单个建筑物Vo
Lua_StructureVo = class("Lua_StructureVo")
function Lua_StructureVo:ctor(id, config)
	self:superCall("ctor");
	self._id = id;
	self._config = config;
end

function Lua_StructureVo.Get:id()
	return self._id;
end

function Lua_StructureVo.Get:config()
	if self._config == nil then
		self._config = getConfig("structure", self.id);
	end
	return self._config;
end

function Lua_StructureVo.Get:bGray()
	return false;
end

function Lua_StructureVo.Get:canBuild()
	if self.isShield ~= 1 and self.needBuild == 1 then
		if self.id == 10101009 then
			return not DataCenter.hundredCeremonyData.isActEnd;
		end
	end
	return false;
end

function Lua_StructureVo.Get:hangerEffId()
	return nil;
end

function Lua_StructureVo.Get:scenePosTab()
	if self._scenePosTab == nil then
		if self.scene_pos ~= nil then
			local x = #self.scene_pos > 0 and self.scene_pos[1] or 0;
			local y = #self.scene_pos > 1 and self.scene_pos[2] or 0;
			local z = #self.scene_pos > 2 and self.scene_pos[3] or 0;
			self._scenePosTab = {x, y, z};
		else
			self._scenePosTab = {0, 0, 0};
		end
	end
	return self._scenePosTab;
end

function Lua_StructureVo.Get:scenePos()
	if self._scenePos == nil then
		if self.scene_pos ~= nil then
			local x = #self.scene_pos > 0 and self.scene_pos[1] or 0;
			local y = #self.scene_pos > 1 and self.scene_pos[2] or 0;
			local z = #self.scene_pos > 2 and self.scene_pos[3] or 0;
			self._scenePos = Vector3(x * 0.01, y * 0.01, z * 0.01);
		else
			self._scenePos = Vector3.zero;
		end
	end
	return self._scenePos;
end

function Lua_StructureVo.Get:namePos()
	if self._namePos == nil then
		if self.name_pos ~= nil then
			local x = #self.name_pos > 0 and self.name_pos[1] or 0;
			local y = #self.name_pos > 1 and self.name_pos[2] or 0;
			local z = #self.name_pos > 2 and self.name_pos[3] or 0;
			self._namePos = Vector3(x, y, z);
		else
			self._namePos = Vector3.zero;
		end
	end
	return self._namePos;
end

function Lua_StructureVo.Get:nameOffset()
	if self._nameOffset == nil then
		if self.name_offset ~= nil then
			local x = #self.name_offset > 0 and self.name_offset[1] or 0;
			local y = #self.name_offset > 1 and self.name_offset[2] or 0;
			local z = #self.name_offset > 2 and self.name_offset[3] or 0;
			self._nameOffset = {x * 0.01, y * 0.01, z * 0.01};
		else
			self._nameOffset = {0, 0, 0};
		end
	end
	return self._nameOffset;
end

function Lua_StructureVo.Get:redPointId()
	if self._redPointId == nil and self.pathId and self.pathId > 0 then
		local vo = DataCenter.funcPathUtil:getFuncPathVo(self.pathId)
		self._redPointId = vo.red_point_id
	end
	return self._redPointId
end

------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
function Lua_StructureVo.Get:name()
	return self.config.name;
end

function Lua_StructureVo.Get:sceneId()
	return self.config.scene_id or 0;
end

function Lua_StructureVo.Get:isShield()
	return self.config.is_shield;
end

function Lua_StructureVo.Get:jid()
	return self.config.jid;
end

function Lua_StructureVo.Get:modelSrc()
	return self.config.modelSrc;
end

function Lua_StructureVo.Get:scene_pos()
	return self.config.scene_pos;
end

function Lua_StructureVo.Get:dir()
	return self.config.dir or 0;
end

function Lua_StructureVo.Get:name_pos()
	return self.config.name_pos;
end

function Lua_StructureVo.Get:needBuild()
	return self.config.need_build or 0;
end

function Lua_StructureVo.Get:name_offset()
	return self.config.name_offset;
end

function Lua_StructureVo.Get:pathId()
	return self.config.path_id;
end

function Lua_StructureVo.Get:sort()
	return self.config.sort or 0;
end

function Lua_StructureVo.Get:templateList()
	if self._templateList == nil  then
		if self.config.template_list == nil then
			if self.pathId and self.pathId > 0 then
				local vo = DataCenter.funcPathUtil:getFuncPathVo(self.pathId)
				self._templateList = vo.template_list
			end
		else
			self._templateList = self.config.template_list
		end
	end
	return self._templateList
end