checkRequire("Lua_SevenDayVo")
Lua_SevenDayData = class("Lua_SevenDayData")
function Lua_SevenDayData:ctor()
	self:dispose();
end

function Lua_SevenDayData:dispose()
	self.login_day = 1;
	self.dayInfoDic = {};
end

function Lua_SevenDayData:fromServer50126005(msg)
	if msg == nil then
		return;
	end

	self.login_day = msg.login_day; -- 玩家登录天数

	-- 奖励状态 key:第几天 value:领取状态(0条件不足，1未领取，2已领取)
	local day;
	local dayState;
	local redShowState = false;
	for i = 1, #msg.reward_state do
		day = tonumber(tostring(msg.reward_state[i].key));
		dayState = tonumber(tostring(msg.reward_state[i].value));
		self.dayInfoDic[day] = dayState;
		
		if day <= msg.login_day and dayState == 1 and redShowState == false then
			redShowState = true;
		end
	end

	-- 按顺序领取
	if self.dayInfoDic[#msg.reward_state] == 2 then
		DataCenter.mainMenuData:setIconShowInfo(30003, false);
	end
	if DataCenter.funcOpenData:isOpened(10019) then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.EightDay, redShowState);
	end
end

-- 获得最开始可以领取的天数，没有就最后一天
function Lua_SevenDayData.Get:drawDay()
	local day = 8;
	for i = 1, #self.dayInfoDic do -- 今日未领取或者不可领取
		if self.dayInfoDic[i] == 1 or self.dayInfoDic[i] == 0 then 
			day = i;
			break;
		end
	end
	return day;
end

function Lua_SevenDayData:getReceiveState(day)
	return self.dayInfoDic[day];
end

function Lua_SevenDayData.Get:sevenDayArr()
	if self._sevenDayArr == nil then
		self._sevenDayArr = Array();

		local config = getConfig("rewardhall_sevendays");
		local vo;
		for k,v in pairs(config) do
			vo = Lua_SevenDayVo.new(k, v);
			self._sevenDayArr:add(vo);
		end
		self._sevenDayArr:sort("id", false);
	end
	return self._sevenDayArr;
end