-- buff数据
Lua_BuffConfigData = class("Lua_BuffConfigData");
function Lua_BuffConfigData.getConfigData(id)
	if id == nil or id <= 0 then
		return nil;
	end
	
    if Lua_BuffConfigData.configsDic == nil then
        Lua_BuffConfigData.configsDic = {};
    end
    if Lua_BuffConfigData.configsDic[id] == nil then
    	local cfg = getConfig({"tb_buff", id});
    	if cfg == nil then
    		LogManager.LogError("no tb_buff config id : " .. id, false);
    		return nil;
    	end
        Lua_BuffConfigData.configsDic[id] = Lua_BuffConfigData.new(id, cfg);
    end
    return Lua_BuffConfigData.configsDic[id];
end

function Lua_BuffConfigData:ctor(id, cfg)
	self:superCall("ctor");

	self.skillId = id;
	self.config = cfg;
	if self.config == nil then
		self.config = getConfig({ "tb_buff", id });
	end
end

function Lua_BuffConfigData.Get:name()
	return self.config.name;
end

function Lua_BuffConfigData.Get:des()
	return self.config.des;
end

function Lua_BuffConfigData.Get:main_type()
	return self.config.main_type;
end

function Lua_BuffConfigData.Get:sub_type()
	return self.config.sub_type;
end

function Lua_BuffConfigData.Get:buffType()
	if self.config == nil or self.config.buff_type == nil then
		return 0;
	end
	return self.config.buff_type;
end

function Lua_BuffConfigData.Get:effect()
	return self.config.effect;
end

function Lua_BuffConfigData.Get:bShowState()
	return self.config.show_state == 0;
end

function Lua_BuffConfigData.Get:priority()
	return self.config.priority;
end

function Lua_BuffConfigData.Get:atlas()
	return self.config.atlas;
end

function Lua_BuffConfigData.Get:sprite()
	return self.config.sprite;
end

function Lua_BuffConfigData.Get:bianxingJid()
	return self.config.bianxingJid;
end

function Lua_BuffConfigData.Get:hangerId()
	return self.config.hangerId;
end

function Lua_BuffConfigData.Get:noShowHurt()
	return self.config.noShowHurt;
end

-- 时否是场地效果
function Lua_BuffConfigData.Get:isFormationEff()
	return false;
end

-- buff效果描述
function Lua_BuffConfigData.Get:effect_des()
	if self.config.effect_des == nil then
		return "";
	end
	return self.config.effect_des;
end

-- 显示排序
function Lua_BuffConfigData.Get:sort()
	if self.config.sort == nil then
		return 0;
	end
	return self.config.sort;
end