-- 技能表现
Lua_SkillEffectConfigData = class("Lua_SkillEffectConfigData");
function Lua_SkillEffectConfigData.getConfigData(id)
    if Lua_SkillEffectConfigData.configsDic == nil then
        Lua_SkillEffectConfigData.configsDic = {};
    end
    if Lua_SkillEffectConfigData.configsDic[id] == nil then
    	local cfg = getConfig({"tb_skill_effect", id});
    	if cfg == nil then
    		return nil;
    	end
        Lua_SkillEffectConfigData.configsDic[id] = Lua_SkillEffectConfigData.new(id, cfg);
    end
    return Lua_SkillEffectConfigData.configsDic[id];
end

function Lua_SkillEffectConfigData:ctor(id, cfg)
	self:superCall("ctor");

	self.skillEffId = id;
	self.config = cfg;
	if self.config == nil then
		self.config = getConfig({"tb_skill_effect", id});
	end
end

function Lua_SkillEffectConfigData.Get:countTime()
	if self._countTime == nil then
		self._countTime = self.config.countTime / 30;
	end
	return self._countTime;
end

function Lua_SkillEffectConfigData.Get:hurtTimes()
	if self.config.hurtTime ~= nil then
		return #self.config.hurtTime;
	end
	return 0;
end

function Lua_SkillEffectConfigData.Get:atlas()
	return self.config.atlas;
end

function Lua_SkillEffectConfigData.Get:sprite()
	return self.config.sprite;
end

function Lua_SkillEffectConfigData.Get:unlock_level_list() --解锁等级
	return self.config.unlock_level_list;
end

function Lua_SkillEffectConfigData.Get:skill_tag() -- 技能标签
	return self.config.skill_tag;
end

function Lua_SkillEffectConfigData.Get:des() -- 技能描述
	if self.config == nil or self.config.des == nil then
		return "";
	end
	return self.config.des;
end

function Lua_SkillEffectConfigData.Get:des1() -- 技能描述
	if self.config == nil or self.config.des1 == nil then
		return "";
	end
	return self.config.des1;
end

function Lua_SkillEffectConfigData.Get:des2() -- 技能描述
	if self.config == nil or self.config.des2 == nil then
		return "";
	end
	return self.config.des2;
end

function Lua_SkillEffectConfigData.Get:des3() -- 技能描述
	if self.config == nil or self.config.des3 == nil then
		return "";
	end
	return self.config.des3;
end

function Lua_SkillEffectConfigData.Get:des4() -- 技能描述
	if self.config == nil or self.config.des4 == nil then
		return "";
	end
	return self.config.des4;
end

function Lua_SkillEffectConfigData.Get:des5() -- 技能描述
	if self.config == nil or self.config.des5 == nil then
		return "";
	end
	return self.config.des5;
end

function Lua_SkillEffectConfigData.Get:white_des() -- 技能描述（颜色值以功能为主）
	if self.config == nil or self.config.white_des == nil then
		return "";
	end
	return self.config.white_des;
end

function Lua_SkillEffectConfigData.Get:buff_list() -- buff效果
	return self.config.buff_list;
end

function Lua_SkillEffectConfigData.Get:bShowFlash()
	if self.config == nil or self.config.isFalsh == nil then
		return false;
	end
	return self.config.isFalsh == 1;
end

--稀有度（符石用）
function Lua_SkillEffectConfigData.Get:rarity()
	if self.config == nil or self.config.rarity == nil then
		return 0;
	end
	return self.config.rarity;
end

--评分（符石用）
function Lua_SkillEffectConfigData.Get:grade()
	if self.config == nil or self.config.grade == nil then
		return 0;
	end
	return self.config.grade;
end

-- 目标选择类型，搭配target字段一起使用
function Lua_SkillEffectConfigData.Get:targetType()
	if self.config == nil or self.config.targetType == nil then
		return nil;
	end
	
	if self._targetType == nil then
		self._targetType = {};
		local t = self.config.targetType;
		for i = 1, #t do
			local list = t[i];
			for j = 1, #list do
				local pos = list[j];
				if self._targetType[pos] == nil then
					self._targetType[pos] = {};
				end
				table.insert(self._targetType[pos], i);
			end
		end
	end
	return self._targetType;
end

function Lua_SkillEffectConfigData.Get:flyEff()
	if self.config == nil or self.config.flyEff == nil then
		return nil;
	end
	return self.config.flyEff;
end

function Lua_SkillEffectConfigData.Get:flyTogetherNum()
	if self.config == nil or self.config.flyTogetherNum == nil then
		return 0;
	end
	return self.config.flyTogetherNum;
end

function Lua_SkillEffectConfigData.Get:color()
    if self.config.color == nil then
        return 1;
    end
    return self.config.color;
end

function Lua_SkillEffectConfigData.Get:isCondition()
    if self.config.isCondition == nil then
        return 0;
    end
    return self.config.isCondition;
end

function Lua_SkillEffectConfigData.Get:connect_id()
    if self.config.connect_id == nil then
        return 0;
    end
    return self.config.connect_id;
end
