--星魂试炼Util
checkRequire("Lua_StarTrialChapterVo");
checkRequire("Lua_StarTrialStageVo");
Lua_StarTrialUtil = class("Lua_StarTrialUtil");
function Lua_StarTrialUtil:ctor()
	self:dispose();
end

function Lua_StarTrialUtil:dispose()
	self._chapterList = nil;
	self._stageList = nil;
	self._stageConfig = nil
	self._constConfig = nil
	self._sweepCofig = nil;
	if self._chapterArr ~= nil then
		self._chapterArr:dispose();
		self._chapterArr:clear();
		self._chapterArr = nil;
	end
end

function Lua_StarTrialUtil.Get:getChapterConfig()
	if self._chapterConfig == nil then
		self._chapterConfig = getConfig({"star_trial_chatper"});
	end
	return self._chapterConfig;
end

function Lua_StarTrialUtil:getChapterVo(id)
	if self._chapterList == nil then
		self._chapterList = {};
	end
	if self._chapterList[id] == nil then
		self._chapterList[id] = Lua_StarTrialChapterVo.new(id, self.getChapterConfig[id]);
	end
	return self._chapterList[id];
end

function Lua_StarTrialUtil.Get:getChapterArr()
	if self._chapterArr == nil then
		self._chapterArr = Array();
		local vo;
		for k, v in pairs(self.getChapterConfig) do
			vo = self:getChapterVo(v.id);
			self._chapterArr:add(vo);
		end
		self._chapterArr:sort("id", false);
	end
	return self._chapterArr;
end

function Lua_StarTrialUtil.Get:getStageConfig()
	if self._stageConfig == nil then
		self._stageConfig = getConfig({"star_trial_stage"});
	end
	return self._stageConfig;
end

function Lua_StarTrialUtil:getStageVo(id)
	if self._stageList == nil then
		self._stageList = {};
	end
	if self._stageList[id] == nil then
		self._stageList[id] = Lua_StarTrialStageVo.new(id, self.getStageConfig[id]);
	end
	return self._stageList[id];
end

function Lua_StarTrialUtil:getStateByStageId(id)
	local vo = self:getStageVo(id);
	if vo ~= nil then
		return vo.state == 2;
	end
	return false;
end

function Lua_StarTrialUtil:getConstConfig(id, name)
	if self._constConfig == nil then
		self._constConfig = getConfig({"star_trial_const"});
	end
	local config = self._constConfig[id];
	if config ~= nil then
		return config[name];
	end
	return nil;
end

function Lua_StarTrialUtil:getSweepInfoById(id)
	if self._sweepCofig == nil then
		self._sweepCofig = getConfig({"star_trial_day_reward"});
	end
	return self._sweepCofig[tonumber(id)];
end

function Lua_StarTrialUtil.Get:stageMoveTime()
	if self._moveTime == nil then
		self._moveTime = getConfig({"star_trial_const", "sub_move_time", "value"});
	end
	return self._moveTime;
end

function Lua_StarTrialUtil.Get:lineTime()
	if self._lineTime == nil then
		self._lineTime = getConfig({"star_trial_const", "line_time", "float_value"});
	end
	return self._lineTime;
end
