checkRequire("Lua_TaskData");
checkRequire("Lua_TaskUtil");
Lua_TaskProxy = class("Lua_TaskProxy");
function Lua_TaskProxy:ctor()
	DataCenter.taskData = Lua_TaskData.new();
	DataCenter.taskUtil = Lua_TaskUtil.new();

	Lua_MsgUtil.addLuaMsg(80178001, self, self.nTaskInfoState);
	Lua_MsgUtil.addLuaMsg(50178002, self, self.rTaskInfo);
	Lua_MsgUtil.addLuaMsg(50178005, self, self.rExploreTourInfo);
	Lua_MsgUtil.addLuaMsg(50178006, self, self.rExploreTourReward);
	Lua_MsgUtil.addLuaMsg(50178007, self, self.rUnLockArtifact);
	Lua_MsgUtil.addLuaMsg(80178008, self, self.updateExploreTourReward);
	Lua_MsgUtil.addLuaMsg(50178009, self, self.rTaskActiveWarInfo);
end

-------------------- 返回 --------------------

-- 任务奖励状态信息（通知）
function Lua_TaskProxy:nTaskInfoState(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80178001();
		msg:ParseFromString(mp.data);
		DataCenter.taskData:fromServer80178001(msg);
	end
end

-- 请求任务信息（返回）
function Lua_TaskProxy:rTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50178002();
		msg:ParseFromString(mp.data);
		DataCenter.taskData:fromServer50178002(msg);
		Lua_MsgUtil.callFunc("SELECT_DAILYTASK_PANEL");
	end
end

--请求主线任务信息返回
function Lua_TaskProxy:rExploreTourInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50178005();
		msg:ParseFromString(mp.data);
		DataCenter.taskData:fromServer50178005(msg);
	end
end

--请求领取主线任务奖励返回
function Lua_TaskProxy:rExploreTourReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50178006();
		msg:ParseFromString(mp.data);
		DataCenter.taskData:fromServer50178006(msg);
	end
end

--请求解锁主线神器返回
function Lua_TaskProxy:rUnLockArtifact(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50178007();
		msg:ParseFromString(mp.data);
		DataCenter.taskData:fromServer50178007(msg);
	end
end

--通知主线任务完成
function Lua_TaskProxy:updateExploreTourReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80178008();
		msg:ParseFromString(mp.data);
		DataCenter.taskData:fromServer80178008(msg);
	end
end

-- 请求日常任务-活跃战令信息（返回）
function Lua_TaskProxy:rTaskActiveWarInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50178009();
		msg:ParseFromString(mp.data);
		DataCenter.taskData:fromServer50178009(msg);
		Lua_MsgUtil.callFunc("ACTIVE_WAR");
	end
end



-------------------- 请求 --------------------

-- 请求任务信息
function Lua_TaskProxy:sTaskInfo()
	sendMsg(10178002);
end

-- 请求提交已完成的任务，main_type 主类型，task_id 任务ID
function Lua_TaskProxy:sCompleteTask(main_type, task_id)
	local cmd = ProtoPublic_pb.Proto10178003();
	cmd.main_type = main_type;
	cmd.task_id = task_id;
	sendMsg(10178003, cmd);
end

-- 请求领取活跃奖励，main_type 任务主类型，point 奖励对应活跃度id
function Lua_TaskProxy:sReceiveTaskReward(main_type, point)
	local cmd = ProtoPublic_pb.Proto10178004();
	cmd.main_type = main_type;
	cmd.point = point;
	sendMsg(10178004, cmd);
end

-- 请求主线任务信息
function Lua_TaskProxy:sExploreTourInfo()
	sendMsg(10178005);
end

-- 请求领取主线任务奖励
function Lua_TaskProxy:sExploreTourReward(task_id)
	local cmd = ProtoPublic_pb.Proto10178006();
	cmd.task_id = task_id; -- 对应的任务id 阶段奖励发0
	sendMsg(10178006, cmd);
end

-- 请求解锁主线神器
function Lua_TaskProxy:sUnLockArtifact()
	sendMsg(10178007);
end

-- 请求日常任务-活跃战令信息
function Lua_TaskProxy:sTaskActiveWarInfo(flag)
	local cmd = ProtoPublic_pb.Proto10178009();
	cmd.flag = flag; -- 0不改标识 1改标识
	sendMsg(10178009, cmd);
end

-- 请求领取日常任务-活跃战令 的奖励
function Lua_TaskProxy:sTaskActiveWarReward(id, type)
	local cmd = ProtoPublic_pb.Proto10178010();
	cmd.id = id; -- 阶段id:满足领取条件
	cmd.type = type; -- 奖励类型:初级战令，高级战令
	sendMsg(10178010, cmd);
end

-- 请求解锁日常任务-活跃战令的初级战令
function Lua_TaskProxy:sTaskActiveWarUnlockPrimary()
	sendMsg(10178011);
end