--冒险之旅 任务Vo
Lua_ExploreTourTaskVo = class("Lua_ExploreTourTaskVo");

function Lua_ExploreTourTaskVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig({"mainline_task", id});
	end

	if self.config ~= nil and self.config.condition_id ~= nil then
		self.replaceCfg = getConfig({"total_task", self.config.condition_id});
	end
	self:dispose();
end

function Lua_ExploreTourTaskVo:dispose()
	self.rewardState = 0;
	self.taskProgress = 0;
end

function Lua_ExploreTourTaskVo:fromServer(msg)
	self.rewardState = tonumber(msg.value);--任务奖励状态 0 不可领 1：可领取 2：已领取

	local progress = tonumber(msg.other);
	if self.task_id == 58 and progress ~= 0 then
		self.taskProgress = Lua_MainLineCheckpointConfigData.getConfig(progress).number;
	else
		self.taskProgress = tonumber(progress);--任务进度
	end
end

--排序：可领取<未达成<已领取
function Lua_ExploreTourTaskVo.Get:sort()
	local sort = self.id;
	if self.rewardState == 1 then
		sort = self.id - 1000;
	elseif self.rewardState == 2 then
		sort = self.id + 1000;
	end
	return sort;
end

function Lua_ExploreTourTaskVo.Get:rewardVo()
	if self._rewardVo == nil then
		self._rewardVo = Lua_ToolVo.new(self.reward_item[1][1], self.reward_item[1][2]);
	end
	return self._rewardVo;
end

---------------------------------------- 配置数据 ----------------------------------------

--任务标题
function Lua_ExploreTourTaskVo.Get:title()
	return self.config.title;
end

--任务描述
function Lua_ExploreTourTaskVo.Get:description()
	if self.replaceCfg ~= nil then
		return self.replaceCfg.desc;
	end
	return self.config.description;
end

--阶段
function Lua_ExploreTourTaskVo.Get:stage()
	return self.config.stage;
end

--进度
function Lua_ExploreTourTaskVo.Get:process()
	if self.replaceCfg ~= nil then
		if self.task_id == 58 then
			return Lua_MainLineCheckpointConfigData.getConfig(self.replaceCfg.progress).number;
		else
			return self.replaceCfg.progress;
		end
	end
	return self.config.process;
end

--任务奖励
function Lua_ExploreTourTaskVo.Get:reward_item()
	if self.replaceCfg ~= nil then
		return self.replaceCfg.reward;
	end
	return self.config.reward_item;
end

--功能跳转id
function Lua_ExploreTourTaskVo.Get:func_path_id()
	if self.replaceCfg ~= nil then
		return self.replaceCfg.eventId;
	end
	return self.config.func_path_id;
end

--任务类型id
function Lua_ExploreTourTaskVo.Get:task_id()
	if self.replaceCfg ~= nil then
		return self.replaceCfg.task_id;
	end
	return 0;
end

-- 总任务配置表id
function Lua_ExploreTourTaskVo.Get:conditionId()
	return self.config.condition_id;
end