-- 日常、周常活跃度各阶段可获取的奖励Vo（读取配置表)
Lua_TaskActInfoVo = class("Lua_TaskActInfoVo");
function Lua_TaskActInfoVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if config == nil then
		self.config = getConfig("task_progress", id);
	end

	self:dispose();
end

function Lua_TaskActInfoVo:dispose()
	self.isDraw = false; -- 未领取
end

-- 更新活跃度奖励的领取状态，0不可领取 1可领取 2已领取
function Lua_TaskActInfoVo:updateServer(activePoint, isDraw)
	self.rewardState = activePoint >= self.active and 1 or 0; -- 0不可领取 1可领取 2已领取
	self.rewardState = isDraw and 2 or self.rewardState;
end

-- 0不可领取 1可领取 2已领取
function Lua_TaskActInfoVo:getRewardState()
	return self.rewardState == nil and 0 or self.rewardState;
end





------------------------- 配置表信息 -------------------------
-- 主类型
function Lua_TaskActInfoVo.Get:mainType()
	return self.config.main_type;
end

-- 活跃度
function Lua_TaskActInfoVo.Get:active()
	return self.config.liveness;
end

-- 奖励信息
function Lua_TaskActInfoVo.Get:reward()
	return self.config.reward;
end

-- 可领取特效
function Lua_TaskActInfoVo.Get:can_drwa_effect()
	return self.config.can_drwa_effect;
end

-- 不可领取
function Lua_TaskActInfoVo.Get:un_draw()
	return self.config.un_draw;
end

-- 可领取
function Lua_TaskActInfoVo.Get:can_draw()
	return self.config.can_draw;
end

-- 已领取
function Lua_TaskActInfoVo.Get:has_draw()
	return self.config.has_draw;
end

-- 可领取边框
function Lua_TaskActInfoVo.Get:can_frame()
	return self.config.can_frame;
end

-- 已领取边框
function Lua_TaskActInfoVo.Get:has_frame()
	return self.config.has_frame;
end