Lua_ThingData = class("Lua_ThingData");
function Lua_ThingData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_ThingData:dispose(val)
	self.thingPlayerDic = {}; -- key playerId, val player
	self.sceneThingDic = {}; -- key sceneId, val playerId集合
	self.fightThingDic = {}; -- key fightId, val table(key:formationType, val:playerId集合)
	self.fightThingIdsDic = {}; -- key fightId, val val:playerId集合
end

-- 记录场景的player
function Lua_ThingData:addThingPlayer(thing, playerId, objId, sceneId, fightRecordId, formationType, formationPos)
	if self.thingPlayerDic[sceneId] == nil then
		self.thingPlayerDic[sceneId] = {};
	end
	if self.thingPlayerDic[sceneId][fightRecordId] == nil then
		self.thingPlayerDic[sceneId][fightRecordId] = {};
	end
	self.thingPlayerDic[sceneId][fightRecordId][playerId] = thing;

	if self.sceneThingDic[sceneId] == nil then
		self.sceneThingDic[sceneId] = {};
	end
	if self.sceneThingDic[sceneId][fightRecordId] == nil then
		self.sceneThingDic[sceneId][fightRecordId] = Array();
	end
	if self.sceneThingDic[sceneId][fightRecordId]:indexOf(playerId) == -1 then
		self.sceneThingDic[sceneId][fightRecordId]:add(playerId);
		if fightRecordId > 0 then
			if self.fightThingIdsDic[fightRecordId] == nil then
				self.fightThingIdsDic[fightRecordId] = Array();
			end
			self.fightThingIdsDic[fightRecordId]:add(playerId);

			if self.fightThingDic[fightRecordId] == nil then
				self.fightThingDic[fightRecordId] = {};
			end
			if self.fightThingDic[fightRecordId][formationType] == nil then
				self.fightThingDic[fightRecordId][formationType] = Array();
			end
			self.fightThingDic[fightRecordId][formationType]:add(playerId);
		end
	end
end

function Lua_ThingData:removeThingPlayer(thing, playerId, objId, sceneId, fightRecordId, formationType, formationPos)
	if self.thingPlayerDic[sceneId] ~= nil and self.thingPlayerDic[sceneId][fightRecordId] ~= nil then
		self.thingPlayerDic[sceneId][fightRecordId][playerId]= nil;
	end

	if self.sceneThingDic[sceneId] ~= nil and self.sceneThingDic[sceneId][fightRecordId] ~= nil then
		self.sceneThingDic[sceneId][fightRecordId]:removeItem(playerId);
		if self.sceneThingDic[sceneId][fightRecordId]:getSize() <= 0 then
			self.sceneThingDic[sceneId][fightRecordId] = nil;
			self.thingPlayerDic[sceneId][fightRecordId] = nil;
		end
	end

	if fightRecordId > 0 then
		if self.fightThingDic[fightRecordId] ~= nil and self.fightThingDic[fightRecordId][formationType] ~= nil then
			self.fightThingDic[fightRecordId][formationType]:removeItem(playerId);
			if self.fightThingDic[fightRecordId][formationType]:getSize() <= 0 then
				self.fightThingDic[fightRecordId][formationType] = nil;
			end
		end

		if self.fightThingIdsDic[fightRecordId] ~= nil then
			self.fightThingIdsDic[fightRecordId]:removeItem(playerId);
			if self.fightThingIdsDic[fightRecordId]:getSize() <= 0 then
				self.fightThingIdsDic[fightRecordId] = nil;
				self.fightThingDic[fightRecordId] = nil;
			end
		end
	end
end

function Lua_ThingData:getThingIds(sceneId, fightId)
	if self.sceneThingDic[sceneId] ~= nil then
		return self.sceneThingDic[sceneId][fightId];
	end
	return nil;
end

function Lua_ThingData:getThingIdsByFormationType(fightId, t)
	if fightId > 0 then
		if self.fightThingDic[fightId] ~= nil then
			return self.fightThingDic[fightId][t];
		end
	end
	return nil;
end

function Lua_ThingData:getThingPlayer(sceneId, fightId, playerId)
	playerId = tonumber(playerId);
	fightId = tonumber(fightId);
	playerId = tonumber(playerId);
	if self.thingPlayerDic[sceneId] ~= nil and self.thingPlayerDic[sceneId][fightId] ~= nil then
		return self.thingPlayerDic[sceneId][fightId][playerId];
	end
	return nil;
end

function Lua_ThingData:getThingData(playerId)
	
end

function Lua_ThingData:checkIsTarget(sceneId, fightId, targetId, isAuto)
	-- local thingVo = self:getThingPlayer(sceneId, fightId, targetId);
	-- if thingVo == nil then
	-- 	return false;
	-- end

	return false;
end