Lua_AttributesVo = class("Lua_AttributesVo")
function Lua_AttributesVo:ctor(id, config)
	self.id = id;
	self._config = config;
end

function Lua_AttributesVo.Get:config()
	if self._config == nil then
		self._config = getConfig({ "tb_prop", self.id });
	end
	return self._config;
end

function Lua_AttributesVo.Set:value(val)
	self._value = val;
end

function Lua_AttributesVo.Get:value()
	return self._value or 0;
end

function Lua_AttributesVo.Set:nextValue(val)
	self._nextValue = val;
end

function Lua_AttributesVo.Get:nextValue()
	return self._nextValue or 0;
end

-- 文本显示用
function Lua_AttributesVo.Get:showValue()
	if self.isPercent == 1 then
		if self.value <= 0 then
			return string.format("%s%s", self.value, "%");
		end
		return string.format("%.1f%s", self.value * 100, "%");
	end
	return Mathf.Floor(self.value + 0.5);
end

function Lua_AttributesVo.Get:showNextValue()
	if self.isPercent == 1 then
		if self.nextValue <= 0 then
			return string.format("%s%s", self.nextValue, "%");
		end
		return string.format("%.1f%s", self.nextValue * 100, "%");
	end
	return Mathf.Floor(self.nextValue + 0.5);
end

-- 差值
function Lua_AttributesVo.Get:showDiffValue()
	local diffValue = self.nextValue - self.value;
	if self.isPercent == 1 then
		if diffValue <= 0 then
			return string.format("%s%s", diffValue, "%");
		end
		diffValue = string.format("%.1f%s", diffValue * 100, "%");
	end
	return diffValue;
end

function Lua_AttributesVo.Get:defaultValueStr()
	if self.config.default == nil then
		return 0;
	end

	local val = self.config.default;
	if self.isPercent == 1 then
		if val <= 0 then
			return string.format("%s%s", val, "%");
		end
		val = string.format("%.1f%s", val * 100, "%");
	end
	return tostring(val);
end

-------------------- 配置数据 --------------------

--属性名
function Lua_AttributesVo.Get:show_name()
	if self.config.show_name == nil then
		return "";
	end
	return self.config.show_name;
end

--百分比
function Lua_AttributesVo.Get:isPercent()
	if self._isPercent ~= nil then
		return self._isPercent;
	end
	return self.config.is_percent or 0;
end

--百分比
function Lua_AttributesVo.Set:isPercent(val)
	self._isPercent = val;
end

--排序
function Lua_AttributesVo.Get:sort()
	if self.config.sort == nil then
		return 999;
	end
	return self.config.sort;
end

--英雄基础属性图标
function Lua_AttributesVo.Get:hero_attr_icon()
	return self.config.hero_attr_icon;
end

--英雄基础属性对应百分比字段
function Lua_AttributesVo.Get:rate_field()
	return self.config.rate_field;
end

--属性图标
function Lua_AttributesVo.Get:attr_icon_1()
	return self.config.attr_icon_1;
end

function Lua_AttributesVo.Get:attr_icon_2()
	return self.config.attr_icon_2;
end

function Lua_AttributesVo.Get:defaultValue()
	if self.config.default == nil then
		return 0;
	end

	local val = self.config.default;
	if self.isPercent == 1 then
		val = val * 100;
	end
	return val;
end

-- 神兵评分系数
function Lua_AttributesVo.Get:weapon_coefficient()
	return self.config.weapon_coefficient or 0
end

-- 神兵评分固定值
function Lua_AttributesVo.Get:weapon_fixed()
	return self.config.weapon_fixed or 0
end