-- 怪物配置
Lua_MonsterConfigData = class("Lua_MonsterConfigData");
function Lua_MonsterConfigData.getMonsterConfig(monsterId)
	if monsterId == nil then
		return nil
	end

	if Lua_MonsterConfigData.monsterDic == nil then
		Lua_MonsterConfigData.monsterDic = {};
	end
	
	monsterId = tonumber(monsterId);
	if Lua_MonsterConfigData.monsterDic[monsterId] == nil then
		local indexId = Mathf.Floor(monsterId / 100000)
		local value = getConfig("tb_monster_index", indexId, "index")
		local config
		if value == nil then
			config = getConfig("tb_monster", monsterId);
		else
			config = getConfig(value, monsterId);
		end
		if config == nil then
			LogManager.LogError("no tb_monster id = " .. monsterId, false);
			return nil;
		end
		Lua_MonsterConfigData.monsterDic[monsterId] = Lua_MonsterConfigData.new(monsterId, config);
	end
	return Lua_MonsterConfigData.monsterDic[monsterId];
end

function Lua_MonsterConfigData:ctor(monsterId, config)
	self:superCall("ctor");
	self.monsterId = tonumber(monsterId);
	if config == nil then
		local indexId = Mathf.Floor(self.monsterId / 100000)
		local value = getConfig("tb_monster_index", indexId, "index")
		if value == nil then
			self.config = getConfig("tb_monster", self.monsterId);
		else
			self.config = getConfig(value, self.monsterId);
		end
	else
		self.config = config
	end
	if self.config == nil then
		LogManager.LogError("no tb_monster id = " .. monsterId, false);
	end
end

function Lua_MonsterConfigData:getAttrVal(attrName)
	return self.config[attrName];
end

function Lua_MonsterConfigData.Get:heroVo()
	if self._heroVo == nil then
		self._heroVo = Lua_HeroVo.new(self.heroId);
		self._heroVo.name = self.name;
		self._heroVo.star = self.star;
		self._heroVo.campType = self.camp;
		self._heroVo.color = self.color;
		self._heroVo.level = self.level;
	end
	return self._heroVo;
end

function Lua_MonsterConfigData.Get:avatar_atlas_1()
	return self.heroVo.avatar_atlas_1;
end

function Lua_MonsterConfigData.Get:avatar_sprite_1()
	return self.heroVo.avatar_sprite_1;
end

function Lua_MonsterConfigData.Get:avatar_atlas_2()
	return self.heroVo.avatar_atlas_2;
end

function Lua_MonsterConfigData.Get:avatar_sprite_2()
	return self.heroVo.avatar_sprite_2;
end

-------------------- 配置数据 --------------------

function Lua_MonsterConfigData.Get:name()
	return self.config.name;
end

function Lua_MonsterConfigData.Get:monsterType()
	if self.config.monster_type == nil then
		return 0;
	end
	return self.config.monster_type;
end

function Lua_MonsterConfigData.Get:heroId()
	return self.config.hero_id;
end

function Lua_MonsterConfigData.Get:boss_avatar_atlas_1()
	return self.config.boss_avatar_atlas_1;
end

function Lua_MonsterConfigData.Get:boss_avatar_sprite_1()
	return self.config.boss_avatar_sprite_1;
end

-- 寂灭岛BOSS位置
function Lua_MonsterConfigData.Get:equip_copy_pos()
	if self.config.equip_copy_pos == nil then
		return {0, 0, 0};
	end
	return self.config.equip_copy_pos;
end

-- 寂灭岛BOSS缩放
function Lua_MonsterConfigData.Get:equip_copy_scale()
	if self.config.equip_copy_scale == nil then
		return 1;
	end
	return self.config.equip_copy_scale;
end

function Lua_MonsterConfigData.Get:camp()
	return self.config.camp;
end

function Lua_MonsterConfigData.Get:star()
	if self.config.star == nil then
		return 0;
	end
	return self.config.star;
end

function Lua_MonsterConfigData.Get:color()
	if self.config.color == nil then
		return 0;
	end
	return self.config.color;
end

function Lua_MonsterConfigData.Get:level()
	if self.config.level == nil then
		return 0;
	end
	return self.config.level;
end

function Lua_MonsterConfigData.Get:force()
	if self.config.force == nil then
		return 0;
	end
	return self.config.force;
end

function Lua_MonsterConfigData.Get:scale()
	if self.config.scale == nil or self.config.scale <= 0 then
		return 1;
	end
	return self.config.scale;
end

function Lua_MonsterConfigData.Get:nameHeight()--名字显示高度
	if self.config.name_height == nil then
		return 230;
	end
	return self.config.name_height;
end

function Lua_MonsterConfigData.Get:nameScale()
	if self.config.name_scale == nil or self.config.name_scale <= 0 then
		return 1;
	end
	return self.config.name_scale;
end

function Lua_MonsterConfigData.Get:health()
	if self.config.health == nil then
		return 1;
	end
	return self.config.health;
end

function Lua_MonsterConfigData.Get:attack()
	if self.config.attack == nil then
		return 0;
	end
	return self.config.attack;
end

function Lua_MonsterConfigData.Get:speed()
	if self.config.speed == nil then
		return 0;
	end
	return self.config.speed;
end

function Lua_MonsterConfigData.Get:bornPos()
	return self.config.bornPos;
end

function Lua_MonsterConfigData.Get:bornPosVec()
	if self._bornPosVec == nil then
		local list = self.config.bornPos;
		if list == nil then
			return nil;
		end

		local px = #list > 0 and list[1] or 0;
		local py = #list > 1 and list[2] or 0;
		local pz = #list > 2 and list[3] or 0;
		self._bornPosVec = Vector3(px, py, pz); 
	end

	return self._bornPosVec;
end

function Lua_MonsterConfigData.Get:targetPos()
	return self.config.targetPos;
end

function Lua_MonsterConfigData.Get:targetPosVec()
	if self._targetPosVec == nil then
		local list = self.config.targetPos;
		if list == nil then
			return nil;
		end

		local px = #list > 0 and list[1] or 0;
		local py = #list > 1 and list[2] or 0;
		local pz = #list > 2 and list[3] or 0;
		self._targetPosVec = Vector3(px, py, pz); 
	end

	return self._targetPosVec;
end

function Lua_MonsterConfigData.Get:skill_list()
	return self.config.skill_list;
end

-- 是否读取明星模板对应技能
function Lua_MonsterConfigData.Get:use_hero_skill()
	return self.config.use_hero_skill;
end

function Lua_MonsterConfigData.Get:hpBarType()
	return self.config.hp_bar_type;
end