--图腾数据
checkRequire("Lua_TotemVo");
checkRequire("Lua_TotemOrderCofingData")
Lua_TotemData = class("Lua_TotemData")
function Lua_TotemData:ctor()
    self:superCall("ctor");
    self:dispose();
end

function Lua_TotemData:dispose()
    self.totemDic = nil;
    self.totemInfo = Array();

    self.bInitTotemInfo = false;--初始化标识
end

-- 配置表数据数据
function Lua_TotemData.Get:totemConfingInfo()
    if self.totemDic == nil then
        self.totemDic = {};
        local confing = getConfig({ "totem"});
        for i,v in ipairs(confing) do
            local vo = Lua_TotemVo.new(i,v);
            self.totemDic[vo.id] = vo;
        end
    end

    return self.totemDic;
end

-- 服务端下发数据
function Lua_TotemData:fromServer50192001(msg)
    if msg == nil then
        return;
    end
    local list = msg.totem_list;
    for i=1,#list do
        local id = list[i].camp;
        self:updateTotemVo(list[i])
        self.totemInfo:add(id);
    end
    -- self:updateTotemRedDot();
    self.bInitTotemInfo = true;
end

-- 更新数据
function Lua_TotemData:updateTotemVo(msg)
    local vo = self:getTotemVoByCamp(msg.camp);
    vo:fromServerInfo(msg);
    -- self:updateTotemRedDot();
end

function Lua_TotemData:getTotemVoByCamp(id)
    return self.totemConfingInfo[id];
end







--------------------------------------- 红点检测 ----------------------------------------------------
function Lua_TotemData:updateTotemRedDot()
    if DataCenter.funcOpenData:isOpened(10127) ~= true then
        return
    end
    local list = self.totemConfingInfo;
    local show_red = false;
    for i,v in pairs(list) do
        if v.checkTotemRedDot == true then
            show_red = true;
            break;
        end
    end

    -- DataCenter.redDotUtil:updateRedDotVoById(10070, show_red);

    Lua_MsgUtil.callFunc("UPDATE_Totem_REDDOT");
end







--------------------------------------- 界面数据 ----------------------------------------------------
-- 获取 对应类型英雄数据
function Lua_TotemData:getTotemHeroInfo(cost_hvo, selectDic)
    local id = cost_hvo.id;
    local star = cost_hvo.star;
    local campType = cost_hvo.campType;

    local hvo;
    local unique_id;
    local arr = Array();
    local heroUidArr = DataCenter.heroData:getHeroUidArrByStar(star);
    for i=1, heroUidArr:getSize() do
        unique_id = heroUidArr[i];
        hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
        -- print(hvo.id," 111111 = =",id)
        if id ~= 0 then --指定英雄
            -- print(hvo.id," 指定英雄 = =",id)
            if hvo.id == id and hvo.campType == campType and hvo.star == star then
                -- print("id = =",hvo.id)
                arr:add({uid = unique_id, isSelect = (selectDic[unique_id] ~= nil), sort = hvo.backSort});
            end
        elseif campType ~= 0 then --指定类型
            if hvo.campType == campType and hvo.star == star then
                arr:add({uid = unique_id, isSelect = (selectDic[unique_id] ~= nil), sort = hvo.backSort});
            end
        elseif star ~= 0 then --指定星级
            if hvo.star == star then
                arr:add({uid = unique_id, isSelect = (selectDic[unique_id] ~= nil), sort = hvo.backSort});
            end
        end
    end

    --万能道具
    local id = DataCenter.heroUtil:getAlmightyId(campType,star);
    if id ~= nil then
        local num = DataCenter.packData:getItemVoById(id)
        if num ~= nil then
            for i=1,num do
                arr:add({uid = id*10000+i, id = id, isSelect = false, sort = -1});
            end
        end
    end
    arr:sort("sort",false);
    return arr;
end