-- 图腾
checkRequire("Lua_TotemData");
checkRequire("Lua_TotemUtil");
Lua_TotemProxy = class("Lua_TotemProxy");
function Lua_TotemProxy:ctor()
    DataCenter.totemUtil = Lua_TotemUtil.new(); -- 英雄配置数据
    DataCenter.totemData = Lua_TotemData.new(); -- 英雄数据

    Lua_MsgUtil.addLuaMsg(50192001, self, self.rTotemInfo);    -- 请求图腾界面信息（返回）
    Lua_MsgUtil.addLuaMsg(50192002, self, self.rTotemActivate);-- 图腾激活（返回）
    Lua_MsgUtil.addLuaMsg(50192003, self, self.rTotemUpgrade); -- 图腾注灵（返回）
    Lua_MsgUtil.addLuaMsg(50192004, self, self.rTotemOrder);   -- 图腾进阶（返回）
end




----------------------------------------------------------------------------------------------------------------------------
-- 上行消息号

-- 请求图腾信息
function Lua_TotemProxy:sTotem()
    sendMsg(10192001);
end

-- 图腾激活
function Lua_TotemProxy:sHalidoActivate(camp, list)
    local cmd = ProtoPublic_pb.Proto10192002();
    cmd.camp = camp;

    local struct = getProtoMsg("ProtoStarUpMaterial");
    struct.index = 1;
    for uid, v in pairs(list) do
        local unique_id = uid;
        local len = string.len(unique_id);
        if len >= 13 then
            unique_id = string.sub(unique_id,1,9);
        end
        -- print(id,"    图腾激活    ",uid);
        struct.uid_list:append(tonumber(uid));
    end
    cmd.material_list:addToList(struct);
    sendMsg(10192002, cmd);
end

-- 图腾注灵
function Lua_TotemProxy:sTotemUpgrade(camp)
    local cmd = ProtoPublic_pb.Proto10192003();
    cmd.camp = tonumber(camp);
    -- print("图腾注灵  == ",camp);
    sendMsg(10192003, cmd);
end

-- 图腾进阶
function Lua_TotemProxy:sTotemOrder(camp, list)
    local cmd = ProtoPublic_pb.Proto10192004();
    cmd.camp = camp;

    local struct = getProtoMsg("ProtoStarUpMaterial");
    struct.index = 1;
    for uid, v in pairs(list) do
        local unique_id = uid;
        local len = string.len(unique_id);
        if len >= 13 then
            unique_id = string.sub(unique_id,1,9);
        end
        -- print(id,"    图腾进阶    ",uid);
        struct.uid_list:append(tonumber(uid));
    end
    cmd.material_list:addToList(struct);

    sendMsg(10192004, cmd);
end





----------------------------------------------------------------------------------------------------------------------------
-- 下行消息号

-- 获取图腾信息(返回)
function Lua_TotemProxy:rTotemInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50192001();
        msg:ParseFromString(mp.data);
        -- print("获取图腾信息(返回)")
        DataCenter.totemData:fromServer50192001(msg);

        Lua_MsgUtil.callFunc("UPDATE_TOTEM_INFO");
    end
end

-- 图腾激活（返回）
function Lua_TotemProxy:rTotemActivate(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50192002();
        msg:ParseFromString(mp.data);

        -- print("图腾激活（返回）")
        DataCenter.totemData:updateTotemVo(msg.totem);
        Lua_WindowUtil.openWin("Lua_TotemLockSucceedWindow", Lua_WinParam.ACTION_OPEN, msg.totem.camp);

        Lua_MsgUtil.callFunc("UPDATE_ACTIVATE_INFO",msg.totem.camp);
    end
end

-- 图腾注灵（返回）
function Lua_TotemProxy:rTotemUpgrade(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50192003();
        msg:ParseFromString(mp.data);
        -- print("图腾注灵（返回）")
        local camp = msg.totem.camp;
        local oldData = DataCenter.totemData:getTotemVoByCamp(camp);
        local bool = false;
        if oldData.level < msg.totem.level then
            bool = true;
        end
        DataCenter.totemData:updateTotemVo(msg.totem);
        if bool == true then
            Lua_WindowUtil.openWin("Lua_TotemUpgradeSucceedWindow", Lua_WinParam.ACTION_OPEN, msg.totem.camp);
        end

        Lua_MsgUtil.callFunc("UPDATE_UPGRADE_INFO",msg.totem.camp);
    end
end

-- 图腾进阶（返回）
function Lua_TotemProxy:rTotemOrder(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50192004();
        msg:ParseFromString(mp.data);
        -- print("图腾进阶（返回）",msg.totem.camp)
        DataCenter.totemData:updateTotemVo(msg.totem);
        Lua_WindowUtil.openWin("Lua_TotemOrderSucceedWindow", Lua_WinParam.ACTION_OPEN, msg.totem.camp);
        
        Lua_MsgUtil.callFunc("UPDATE_ORDER_INFO",msg.totem.camp);
    end
end