-- 图腾升阶配置
Lua_TotemOrderCofingData = class("Lua_TotemOrderCofingData");
function Lua_TotemOrderCofingData.getConfigData(id)
    if Lua_TotemOrderCofingData.cofingDic == nil then
        Lua_TotemOrderCofingData.cofingDic = {};
    end

    id = tonumber(id);
    if Lua_TotemOrderCofingData.cofingDic[id] == nil then
    	local cfg = getConfig( { "totem_order", id });
	    if cfg == nil then
	    	LogManager.LogError("no totem_order-图腾升阶 id = " .. id, false);
	    	return nil;
	    end
        Lua_TotemOrderCofingData.cofingDic[id] = Lua_TotemOrderCofingData.new(id,cfg);
    end
    return Lua_TotemOrderCofingData.cofingDic[id];
end

function Lua_TotemOrderCofingData:ctor(id, config)
    self:superCall("ctor");
    self.id = id;
    self.config = config;
    if self.config == nil then
	    self.config = getConfig({"totem_order", id});
	end
end

-- 阵营
function Lua_TotemOrderCofingData.Get:camp()
    return self.config.camp;
end

-- 阶级
function Lua_TotemOrderCofingData.Get:order()
    return self.config.order;
end

-- 下阶id
function Lua_TotemOrderCofingData.Get:next_id()
    return self.config.next_id;
end

-- 名字
function Lua_TotemOrderCofingData.Get:name()
    return self.config.name;
end

-- 等级条件
function Lua_TotemOrderCofingData.Get:level_cond()
    return self.config.level_cond;
end

-- 技能名字
function Lua_TotemOrderCofingData.Get:skill_name()
    return self.config.skill_name;
end

-- 排序
function Lua_TotemOrderCofingData.Get:sort()
    return self.config.sort;
end

-- 技能图标
function Lua_TotemOrderCofingData.Get:skill_sprite()
    return self.config.skill_sprite;
end

-- 属性字段
function Lua_TotemOrderCofingData.Get:prop_list()
    return self.config.prop_list;
end

-- 英雄消耗
function Lua_TotemOrderCofingData.Get:order_up_hero_cost()
    return self.config.order_up_hero_cost;
end

-- 道具消耗
function Lua_TotemOrderCofingData.Get:order_up_item_cost()
    return self.config.order_up_item_cost;
end

-- 属性
function Lua_TotemOrderCofingData.Get:orderPropInfo()
    if self._orderPropInfo == nil then
        self._orderPropInfo = Array();
        local extra_attr = self.prop_list;
        for i=1,#extra_attr do
            local str = extra_attr[i];
            if str ~= "speed" then
                str = str.."_extra";
            end

            local value = getConfig({ "totem_order", self.id, str});
            local propVo = DataCenter.attributesUtil:createAttrVo(extra_attr[i]);
            propVo.value = value;
            if extra_attr[i] ~= "speed" then
                propVo.isPercent = 1;
            end
            self._orderPropInfo:add(propVo);
        end
    end
    return self._orderPropInfo;
end