-- 古城秘藏 Data
checkRequire("Lua_TownTreasureCellVo");
Lua_TownTreasureData = class("Lua_TownTreasureData");

function Lua_TownTreasureData:ctor()
	self:dispose();
end

function Lua_TownTreasureData:dispose()
	self.curVersion = 0;
end

function Lua_TownTreasureData:fromServer50207001(msg)
	if self.curVersion ~= msg.round then
		self.curVersion = msg.round
		self.cellDic = {};
		local config = getConfig("tower_secrete_cell");
		local vo;
		for k, v in pairs(config) do
			if v.version_id == self.curVersion then
				vo = Lua_TownTreasureCellVo.new(v.id, v);
				self.cellDic[v.id] = vo;
			end
		end

		self.roadArr = Array();
		local startId = DataCenter.townTreasureUtil:getVersionInfo(self.curVersion, "start_id");
		local curId = 0;
		vo = self.cellDic[startId];
		while vo ~= nil and startId ~= curId do
			self.roadArr:add(vo.id);
			curId = vo.next_stage;
			vo = self.cellDic[curId];
		end
	end

	local cellVo;
	for i = 1, #msg.cells do
		cellVo = self.cellDic[msg.cells[i].key];
		if cellVo ~= nil then
			cellVo:fromServerInfo(msg.cells[i]);
		end 
	end

	self.close_tick = msg.close_tick;
	self.role_pos = msg.role_pos;
	self.use_times = msg.use_times;
	self.curr_times = msg.curr_times;
	self.loop_times = msg.loop_times;
	self.round = msg.round;
	self.near_cell = msg.near_cell;

	Lua_MsgUtil.callFunc("TOWN_TREASURE_INFO_UPDATE");
end