Lua_LuckyTurntableData = class("Lua_LuckyTurntableData");
Lua_LuckyTurntableData.ordinaryTurnTable = 1; -- 普通
Lua_LuckyTurntableData.seniorTurnTable = 2; -- 高级
Lua_LuckyTurntableData.rule = 1; -- 规则
Lua_LuckyTurntableData.reward = 2; -- 奖励
function Lua_LuckyTurntableData:ctor()
	self:dispose();
end

function Lua_LuckyTurntableData:dispose()
	self.turnTableInfo = {};
	self.curSelectType = 1;
	self.selectWishReward = {};
	self.seniorResidueTimes = 0;
end

function Lua_LuckyTurntableData:fromServer50188001(msg)
	if msg.turntable_type == 2 then
		self.seniorResidueTimes = msg.left_diamonds_draw_times; -- 高级抽奖钻石剩余次数
	end

	if self.turnTableInfo[msg.turntable_type] == nil then
		self.turnTableInfo[msg.turntable_type] = {};
	end
	self.turnTableInfo[msg.turntable_type].lastRefreshTick = msg.last_free_refresh_tick; -- 上次免费刷新时间戳
	self.turnTableInfo[msg.turntable_type].refreshState = msg.free_refresh_state; -- 1：免费刷新，0：付费刷新
	self.turnTableInfo[msg.turntable_type].rewardInfo = self:getRewardInfoArr(msg.turntable_type, msg.turntable_info); -- 普通转盘信息：key:转盘id value: 奖励id
	self.turnTableInfo[msg.turntable_type].recordInfo = msg.record_info; -- 玩家获奖记录信息
	self.turnTableInfo[msg.turntable_type].wishLeftTimes = msg.left_wish_times; -- 心愿奖励剩余次数
	self.turnTableInfo[msg.turntable_type].isSkipAni = msg.is_skip; -- 是否跳过动画 1：跳过 0：不跳过
	self.turnTableInfo[msg.turntable_type].wishId = msg.wish_reward_id; -- 心愿奖励id 未设置为0
	if msg.wish_reward_id ~= 0 then
		self.selectWishReward[msg.turntable_type] = DataCenter.luckyTurntableUtil:getWishRewardByWishId(msg.wish_reward_id);
	end

	self:updateRedPoint(msg);
end

function Lua_LuckyTurntableData:fromServer50188003(msg)
	self.turnTableInfo[Lua_LuckyTurntableData.ordinaryTurnTable].rewardInfo = self:getRewardInfoArr(Lua_LuckyTurntableData.ordinaryTurnTable, msg.turntable_info); -- 普通转盘信息
	self.turnTableInfo[Lua_LuckyTurntableData.ordinaryTurnTable].lastRefreshTick = msg.last_free_refresh_tick; -- 上次免费刷新时间戳
	self.turnTableInfo[Lua_LuckyTurntableData.ordinaryTurnTable].refreshState = msg.free_refresh_state; -- 1：免费刷新，0：付费刷新
end

function Lua_LuckyTurntableData:fromServer50188004(msg)	
	if msg.turntable_type == 2 then
		self.seniorResidueTimes = msg.left_diamonds_draw_times; -- 高级抽奖钻石剩余次数
	end
	self.turnTableInfo[msg.turntable_type].rewardInfo = self:getRewardInfoArr(msg.turntable_type, msg.turntable_info); -- 普通转盘信息
	self.turnTableInfo[msg.turntable_type].drawResult = msg.draw_result; -- key：格子id，value 奖励id
	self.turnTableInfo[msg.turntable_type].wishLeftTimes = msg.left_wish_times; -- 心愿奖励剩余次数
	self.turnTableInfo[msg.turntable_type].recordInfo = msg.record_info; -- 幸运转盘的记录信息
	self.hasNewReward = self.turnTableInfo[msg.turntable_type].isSkipAni == 0 and true or false;
	
	self:updateRedPoint(msg);
end

function Lua_LuckyTurntableData:fromServer50188005(msg)
	self.turnTableInfo[msg.turntable_type].wishId = msg.wish_reward_id; -- 心愿奖励格子信息
	self.turnTableInfo[msg.turntable_type].wishLeftTimes = msg.left_wish_times; -- 心愿奖励剩余次数
	self.selectWishReward[msg.turntable_type] = DataCenter.luckyTurntableUtil:getWishRewardByWishId(msg.wish_reward_id);
end

function Lua_LuckyTurntableData:fromServer50188006(msg)
	self.turnTableInfo[msg.turntable_type].isSkipAni = msg.is_skip; -- 是否跳过动画 1：跳过 0：不跳过
end

function Lua_LuckyTurntableData:fromServer80188008(msg)
	self.seniorResidueTimes = msg.left_diamonds_draw_times; -- 高级抽奖钻石剩余次数
end

function Lua_LuckyTurntableData:getRewardInfoArr(turnTableType, turnTableInfo)
	local turntableReward = DataCenter.luckyTurntableUtil.ordinaryReward;
	local turnTableInfoArr = Array();
	local vo;
	for i=1, #turnTableInfo do
		vo = turntableReward[tonumber(turnTableInfo[i].value)];
		vo.times = turnTableInfo[i].other;
		turnTableInfoArr:add(vo);
	end
	return turnTableInfoArr;
end

-- self.luckRoulette:元素为普通、高级轮盘table
function Lua_LuckyTurntableData:initRuleAndRewardConfig()
	if self.luckRoulette == nil then -- 幸运轮盘
		self.luckRoulette = {}; -- 记录幸运轮盘所有的信息
		self.ruleList = {}; -- 记录规则id 
		self.rewardList = {}; --记录奖励id 
		local config = getConfig({ "luck_turntable_rule_reward" });
		-- local count;
		for k, vo in pairs(config) do
			local obj = self:getLuckRouletteById(vo.id);
			if obj == nil then
				obj = self:dealWithConfigData(vo);
				self.luckRoulette[vo.id] = obj;
			end
		end
	end
end

-- 根据id获取对应的信息
function Lua_LuckyTurntableData:getLuckRouletteById(Id)
	if self.luckRoulette == nil or Id == nil or self.luckRoulette[Id] == nil then
		return nil;
	end

	return self.luckRoulette[Id];
end

-- 仅供Lua_LuckyTurntableData内部使用，根据类型获取对应的抽奖概率列表，没有则创建
function Lua_LuckyTurntableData:getRewardListByType(type)
	if type == nil or self.rewardList[type] == nil then
		self.rewardList[type] = {};
	end

	return self.rewardList[type];
end


-- 将数据分为规则或抽奖概率
-- Lua_LuckyTurntableData.rule = 1; -- 规则
-- Lua_LuckyTurntableData.reward = 2; -- 奖励
function Lua_LuckyTurntableData:dealWithConfigData(singleData)
	local count;
	local list;
	local param = {};
	if singleData.rule_or_probability == Lua_LuckyTurntableData.rule then
		self.ruleList[singleData.turntable_type] = singleData.id;
		param = {rule = singleData.rule};
	else
		list = self:getRewardListByType(singleData.turntable_type);
		count = #list + 1;
		list[count] = singleData.id;
		param = {itemName = singleData.item, probability = singleData.probability, sort = singleData.sort};
	end
	return param;
end

-- 外部使用 根据类型获取对应的规则
function Lua_LuckyTurntableData:getRuleByType(type)
	if self.luckRoulette == nil then
		self:initRuleAndRewardConfig();
	end
	local ruleId = self.ruleList[type];
	if ruleId == nil then return;end
	return self:getLuckRouletteById(ruleId).rule;
end

-- 外部使用 根据类型获取对应的抽奖概率列表
function Lua_LuckyTurntableData:getRewardIndexesByType(type)
	if self.luckRoulette == nil then
		self:initRuleAndRewardConfig();
		local list = self:getRewardListByType(type);
		table.sort(list, function(a,b)
			return self:getLuckRouletteById(a).sort < self:getLuckRouletteById(b).sort;end)
	end
	return self:getRewardListByType(type);
end


-- 判断是否抽中心愿奖励： type:类型  
-- return 1:单抽时为心愿奖励     2:十抽条件下,第十个奖励为心愿奖励    3:其余情况下
function Lua_LuckyTurntableData:isSelectedWishReward(type1)
	local wishId = self.turnTableInfo[type1].wishId; -- 心愿id
	local drawResult = self.turnTableInfo[type1].drawResult;
	local rewardCount = #drawResult; -- rewardCount：奖励次数（单抽、十抽）
	local residueCount = self.turnTableInfo[type1].wishLeftTimes; -- 保底剩余次数
	local totalCount = DataCenter.luckyTurntableUtil:getWishRewardByWishId(wishId).guarantee_times; -- 保底总次数
	
	-- self.rewardCell:旋转指向的轮盘奖励格子
	if rewardCount == 1 and residueCount == totalCount then
		-- self.rewardCell = nil;
		return 1;
	elseif rewardCount == 10 and residueCount == totalCount then
		self.rewardCell = drawResult[rewardCount - 1].cell_id;
		return 2;
	else
		self.rewardCell = drawResult[rewardCount].cell_id;
		return 3;
	end
end

-- 更新红点
function Lua_LuckyTurntableData:updateRedPoint(msg)
	local info;
	local haveCount;
	if msg.turntable_type == Lua_LuckyTurntableData.ordinaryTurnTable then
		info = DataCenter.vipData:getVipVoByLevel(DataCenter.roleData.vip).normal_turntable_ten_cost;
		haveCount = DataCenter.packData:getItemCountById(info[1][1]);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LuckyTurntable_ordinary, haveCount >= info[1][2]);
	else
		local costId, costNum = self:judgeCostIdByType(DataCenter.luckyTurntableUtil:getTurntableConstConfig("advanced_multi_draw", 1))
		haveCount = DataCenter.packData:getItemCountById(costId);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LuckyTurntable_senior, haveCount >= costNum);
	end
end

-- 高级多抽使用道具
function Lua_LuckyTurntableData:judgeCostIdByType(num)
	local residueNum = self.seniorResidueTimes;
	local keyStr = num == 1 and "advanced_single_draw" or "advanced_multi_draw";
	local luckyDrawInfo = DataCenter.luckyTurntableUtil:getTurntableConstConfig(keyStr, 4);

	local costId, costNum = luckyDrawInfo[1][1], luckyDrawInfo[1][2];
	local isEnough = DataCenter.packData:getItemCountById(costId) >= costNum;

	if (not isEnough) and residueNum >= num then
		luckyDrawInfo = DataCenter.luckyTurntableUtil:getTurntableConstConfig(keyStr, 5);
		costId, costNum = luckyDrawInfo[1][1], luckyDrawInfo[1][2];
	end
	return costId, costNum;
end