Lua_LuckyTurntableUtil = class("Lua_LuckyTurntableUtil");
function Lua_LuckyTurntableUtil:ctor()
end

-- 幸运转盘常量数据
function Lua_LuckyTurntableUtil:getTurntableConstConfig(key, valueType)
	local config = getConfig("luck_turntable_const", key);
	if config ~= nil then
		if valueType == 1 then
			return config.value; -- 整形值
		elseif valueType == 2 then
			return config.value2; -- 整形值2
		elseif valueType == 3 then
			return config.str_value; -- 字符串
		elseif valueType == 4 then
			return config.json_value; -- 数组值
		elseif valueType == 5 then
			return config.json_value2; -- 数组值
		end
	end

	return nil;
end

-- 普通转盘抽中奖励
function Lua_LuckyTurntableUtil.Get:ordinaryReward()
	return getConfig("normal_luck_turntable_reward");
end

-- 高级转盘抽中奖励
function Lua_LuckyTurntableUtil.Get:seniorReward()
	return getConfig("advance_luck_turntable_reward");
end

-- 高级转盘显示奖励
function Lua_LuckyTurntableUtil.Get:seniorTurntableShowReward()
	if self._seniorTurntableShowReward == nil then
		self._seniorTurntableShowReward = Array();

		local config = getConfig("advance_luck_turntable_ui");
		for k,v in pairs(config) do
			self._seniorTurntableShowReward:add(v);
		end
		self._seniorTurntableShowReward:sort("cell_id", false);
	end

	return self._seniorTurntableShowReward;
end

-- 幸运转盘心愿奖励
function Lua_LuckyTurntableUtil:getWishRewardByWishId(wishId)
	return getConfig("luck_turntable_wish_reward", wishId);
end

-- 幸运转盘心愿奖励
function Lua_LuckyTurntableUtil.Get:turntableWishRewardDic()
	if self._turntableWishRewardDic == nil then
		self._turntableWishRewardDic = {};

		local config = getConfig("luck_turntable_wish_reward");
		for k,v in pairs(config) do
			if self._turntableWishRewardDic[v.type] == nil then
				self._turntableWishRewardDic[v.type] = Array();
			end
			self._turntableWishRewardDic[v.type]:add(v);
		end
	end

	return self._turntableWishRewardDic;
end

-- 根据类型获取心愿奖励
function Lua_LuckyTurntableUtil:getWishRewardInfoByType(type)
	self.turntableWishRewardDic[type]:sort("id", false);
	return self.turntableWishRewardDic[type];
end

-- 抽奖时轮盘旋转的时间
function Lua_LuckyTurntableUtil.Get:rotationTime()
	if self._rotationTime == nil then
		self._rotationTime = tonumber( getConfig("luck_turntable_const", "turntable_time", "json_value")[1] );
	end
	return self._rotationTime;
end

-- 抽奖时轮盘旋转的圈数
function Lua_LuckyTurntableUtil.Get:rotationNumber()
	if self._rotationNumber == nil then
		self._rotationNumber = tonumber( getConfig("luck_turntable_const", "turntable_rotation_number", "json_value")[1] );
	end
	return self._rotationNumber;
end

-- 抽奖时轮盘旋转缓冲间隔时间
function Lua_LuckyTurntableUtil.Get:rotationResidue()
	if self._rotationResidue == nil then
		self._rotationResidue = tonumber( getConfig("luck_turntable_const", "turntable_rotation_buffer", "json_value")[1] );
	end
	return self._rotationResidue;
end

-- 每日高级转盘钻石抽奖上限
function Lua_LuckyTurntableUtil.Get:totalDrawCount()
	return tonumber( getConfig("luck_turntable_const", "advance_diamond_draw_limit", "value") );
end