checkRequire("Lua_VipLevelVo")
Lua_VipData = class("Lua_VipData");

function Lua_VipData:ctor()
   self:dispose();
end

function Lua_VipData:dispose()
    self.level = 0;
    self.isPos = false; -- 是否定位到当前等级
end

function Lua_VipData:initVipInfo()
    self.vipVoList = {};
    self._maxVipLevel = 0;
    local config = getConfig({ "vip" });
    for k, v in pairs(config) do
        self.vipVoList[k] = Lua_VipLevelVo.new(k, v);

        if k > self._maxVipLevel then
            self._maxVipLevel = k;
        end
    end
end

function Lua_VipData:fromServer50112001(msg)
    self.level = msg.vip_level;--vip等级

    local vo;
    local redDotState = false;
    self.vipVoArr = Array();
    for k, v in ipairs(msg.reward_list) do--vip礼包（key：vip等级，value:已购买次数）
        vo = self:getVipVoByLevel(v.key);

        if vo.id <= self.level then
            vo.rewardState = 2;

            if vo.buy_times > v.value then
                vo.rewardState = 1;
                redDotState = true;
            end
        else
            vo.rewardState = 0;
        end
        self.vipVoArr:add(vo);
    end
    self.vipVoArr:sort("id", false);
    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.RaccoonMart_Vip, redDotState);
    Lua_MsgUtil.callFunc("SET_VIPPANEL_INFO");
end

function Lua_VipData:fromServer80112001(msg)--VIP等级提升（通知)
    self.level = msg.vip_level;
    DataCenter.roleData.vip = msg.vip_level;
    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.RaccoonMart_Vip, true);
    DataCenter.gameReported:UpdatePlayerInfo(Lua_SDKMessageType.UpdatePlayerInfo_PlayerUpdate);
    Lua_MsgUtil.callFunc("VIP_LEVEL_UPDATE");
end

function Lua_VipData:getBtnSelectIndex()
    local index = self.level + 1;
    for i = 1, self.vipVoArr:getSize() do
        if self.vipVoArr[i].rewardState == 1 then
            index = i;
            break;
        end
    end
    return index;
end

------------------------------------ 外部调用 ------------------------------------

function Lua_VipData.Get:vipExp()
    return DataCenter.moneyData:getMoney(Lua_ResourcesDefine.VIP_EXP);
end

function Lua_VipData.Get:maxVipLevel()
     if self._maxVipLevel == nil then
        self:initVipInfo();
    end
    return self._maxVipLevel;
end

function Lua_VipData:getVipVoByLevel(level)
    if self.vipVoList == nil then
        self:initVipInfo();
    end
    return self.vipVoList[level];
end

function Lua_VipData.Get:curVipLevelVo()
    return self:getVipVoByLevel(self.level)
end

function Lua_VipData:getConstConfig(key, type)
    if self._constConfig == nil then
        self._constConfig = getConfig({"vip_const"});
    end

    local config = self._constConfig[key];
    if config ~= nil then
        if type == 1 then
            return config.value;
        elseif type == 2 then
            return config.strvalue;
        elseif type == 3 then
            return config.jsonvalue;
        end
    end
     return nil;
end

function Lua_VipData:getExpIconData()
    if self._iconList == nil then
        local item = getConfig({"vip_const", "vip_item", "value"});
        local atlas = getConfig({"item", item, "atlas"});
        local sprite = getConfig({"item", item, "sprite"});
        self._iconList = {atlas = atlas, sprite = sprite};
    end
    return self._iconList;
end
