Lua_ExclusivePlanTaskVo = class("Lua_ExclusivePlanTaskVo")
function Lua_ExclusivePlanTaskVo:ctor()
	
end

function Lua_ExclusivePlanTaskVo:fromServer(data)
	self.id = data.id;
	self.progress = data.progress;
	self.state = data.flag;
	self.times = data.complete_num;
end

function Lua_ExclusivePlanTaskVo.Get:config()
	return getConfig({"sole_plan_task", self.id});
end

function Lua_ExclusivePlanTaskVo.Get:taskConfig()
	if self.config ~= nil then
		return getConfig({"total_task", tonumber(self.config.condition_id)});
	end
end

function Lua_ExclusivePlanTaskVo.Get:satisfyLevel() --等级是否满足
    if DataCenter.exclusivePlanData.planLevel >= self.config.plan_limit then
    	return true;
	else
		return false;
	end
end

function Lua_ExclusivePlanTaskVo.Get:satisfyplanType() --企划类型是否满足
    if self.config.star_limit == 1 and DataCenter.exclusivePlanData.planType == 0 then
    	return false;
	else
		return true;
	end
end

function Lua_ExclusivePlanTaskVo.Get:sort() --排序规则
	if self.satisfyLevel == false or self.satisfyplanType == false then
		return 4;
	end
	if self.state == 1 then
		return 1;
	elseif self.state == 0 then
		return 2;
	else
		return 3;
	end
end

------------------------配置表配置--------------------------------

function Lua_ExclusivePlanTaskVo.Get:opendLevel() --开启等级
    if self.config == nil or self.config.plan_limit == nil then
    	return 999;
    end
	return self.config.plan_limit;
end

function Lua_ExclusivePlanTaskVo.Get:describe() --任务描述
    if self.taskConfig == nil then
    	return nil;
    end
	return self.taskConfig.desc;
end

function Lua_ExclusivePlanTaskVo.Get:taskTimes()
	if self.config == nil then
		return 0;
	end
	return self.config.task_limit_num;
end

function Lua_ExclusivePlanTaskVo.Get:targetVal() --目标进度值
    if self.taskConfig == nil or self.taskConfig.progress == nil then
    	return 0;
    end
	return self.taskConfig.progress;
end

function Lua_ExclusivePlanTaskVo.Get:taskReward() --任务奖励
    if self.taskConfig == nil then
    	return nil;
    end
	return self.taskConfig.reward;
end

function Lua_ExclusivePlanTaskVo.Get:eventId() --前往功能id
    if self.taskConfig == nil then
    	return nil;
    end
	return self.taskConfig.eventId;
end