-- 战令奖励Vo
Lua_WarOrderRewardVo = class("Lua_WarOrderRewardVo");
function Lua_WarOrderRewardVo:ctor(id)
	self.id = id;
	self.config = getConfig("war_order", id);
end

function Lua_WarOrderRewardVo:fromServerInfo(msg)
	self.norState = msg.value; -- 普通奖励状态（0不可领取 1可领取 2已领取）
	self.advState = msg.ex_value; -- 高级奖励状态（0不可领取 1可领取 2已领取）
end

function Lua_WarOrderRewardVo.Get:norRewardVo()
	if self._norRewardList == nil then
		self._norRewardList = Array();

		local vo;
		for k, v in pairs(self.normal_reward) do
			vo = Lua_ToolVo.createToolVo(v[1], v[2]);
			vo.index = self.id;
			vo.state = self.norState;
			vo.unLock = true;

			self._norRewardList:add(vo);
		end
	end
	return self._norRewardList;
end

function Lua_WarOrderRewardVo.Get:advRewardVo()
	if self._advRewardList == nil then
		self._advRewardList = Array();

		local vo;
		local unLock = DataCenter.warOrderData:curAdvActState(self.step);
		for k, v in pairs(self.adv_reward) do
			vo = Lua_ToolVo.createToolVo(v[1], v[2]);
			vo.index = self.id;
			vo.state = self.advState;
			vo.unLock = unLock;

			self._advRewardList:add(vo);
		end
	end
	return self._advRewardList;
end










-- 条件值
function Lua_WarOrderRewardVo.Get:cond_value()
	return self.config.cond_value;
end

-- 展示条件
function Lua_WarOrderRewardVo.Get:show_cond()
	return self.config.show_cond;
end

-- 排序
function Lua_WarOrderRewardVo.Get:sort()
	return self.config.sort;
end

-- 阶段
function Lua_WarOrderRewardVo.Get:step()
	return self.config.step;
end

-- 是否阶段内第一个
function Lua_WarOrderRewardVo.Get:is_first()
	return self.config.is_first;
end

-- 是否阶段内最后一个
function Lua_WarOrderRewardVo.Get:is_last()
	return self.config.is_last;
end

-- 普通奖励
function Lua_WarOrderRewardVo.Get:normal_reward()
	return self.config.normal_reward;
end

-- 高级奖励
function Lua_WarOrderRewardVo.Get:adv_reward()
	return self.config.adv_reward;
end

-- 购买等级价格
function Lua_WarOrderRewardVo.Get:money()
	return self.config.money;
end