Lua_WarOrderUtil = class("Lua_WarOrderUtil");
function Lua_WarOrderUtil:ctor()
end

function Lua_WarOrderUtil:getInfoByType(type)
	if self._typeInfo == nil then
		self._typeInfo = getConfig("war_order_type");
	end
	if self._typeInfo ~= nil then
		return self._typeInfo[type];
	end
	return nil;
end

function Lua_WarOrderUtil:getConfigInfo(id, key)
	if self._config == nil then
		self._config = getConfig("war_order");
	end

	local config = self._config[id];
	if config ~= nil then
		return config[key];
	end
	return nil;
end

-- 常量配置
function Lua_WarOrderUtil:getConstConfig(key)
	return self:getConfigInfo("config", key);
end

function Lua_WarOrderUtil:getMaxStep(type)
	local config = self:getConstConfig("max_step");
	if config ~= nil and config[type] ~= nil then
		return config[type][2];
	end
	return nil;
end

function Lua_WarOrderUtil:getFuncPath(type)
	local config = self:getConstConfig("func_path");
	if config ~= nil then
		return config[type];
	end
	return nil;
end

function Lua_WarOrderUtil:getRechargeId(type, step)
	local config;
	if type == Lua_WarOrderData.LightTower then
		config = self:getConstConfig("light_tower_recharge_id");
	elseif type == Lua_WarOrderData.Expedition then
		config = self:getConstConfig("expedition_recharge_id");
	elseif type == Lua_WarOrderData.JokerDuel then
		config = self:getConstConfig("tomb_room_recharge_id");
	elseif type == Lua_WarOrderData.PeakDuel then
		config = self:getConstConfig("peak_duel_recharge_id");
	elseif type == Lua_WarOrderData.EquipCopyWarMakes then -- 配置需增加寂灭岛充值id
		config = self:getConstConfig("silent_island_recharge_id");
	elseif type == Lua_WarOrderData.KunXuHolyLandWarMakes then -- 配置需增加昆墟圣地充值id
		config = self:getConstConfig("holy_land_recharge_id");
	end

	if config ~= nil then
		return config[step][2];
	end
	return nil;
end

function Lua_WarOrderUtil:getRechargeReward(type, step)
	local config;
	if type == Lua_WarOrderData.LightTower then
		config = self:getConstConfig("light_tower_recharge_reward");
	elseif type == Lua_WarOrderData.Expedition then
		config = self:getConstConfig("expedition_recharge_reward");
	elseif type == Lua_WarOrderData.JokerDuel then
		config = self:getConstConfig("tomb_room_recharge_reward");
	elseif type == Lua_WarOrderData.PeakDuel then
		config = self:getConstConfig("peak_duel_recharge_reward");
	elseif type == Lua_WarOrderData.EquipCopyWarMakes then -- 配置需增加寂灭岛的奖励
		config = self:getConstConfig("silent_island_recharge_reward");
	elseif type == Lua_WarOrderData.KunXuHolyLandWarMakes then -- 配置需增加昆墟圣地的奖励
		config = self:getConstConfig("holy_land_recharge_reward");
	end

	if config ~= nil then
		return config[step];
	end
	return nil;
end

function Lua_WarOrderUtil:getLvBgInfo(type)
	local config = self:getConstConfig("lv_bg_list");
	if config ~= nil then
		return config[type];
	end
	return nil;
end

function Lua_WarOrderUtil:getNameDes(type)
	local config = self:getConstConfig("des_list");
	if config ~= nil then
		return config[type];
	end
	return nil;
end

function Lua_WarOrderUtil:getIconInfo(type)
	local config = self:getConstConfig("icon_list");
	if config ~= nil then
		return config[type];
	end
	return nil;
end