checkRequire("Lua_WelfareUtil");
checkRequire("Lua_WelfareData");
Lua_WelfareProxy = class("Lua_WelfareProxy");
function Lua_WelfareProxy:ctor()
	DataCenter.welfareUtil = Lua_WelfareUtil.new();
	DataCenter.welfareData = Lua_WelfareData.new();
	
	Lua_MsgUtil.addLuaMsg(50126001, self, self.rSignInInfo);
	Lua_MsgUtil.addLuaMsg(50126002, self, self.rSignIn);
	Lua_MsgUtil.addLuaMsg(50126008, self, self.rOpenGradeGiftInfo);
end

------------------ 30天签到 ------------------
-------------------- 返回 --------------------

-- 打开签到界面（返回）
function Lua_WelfareProxy:rSignInInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50126001();
		msg:ParseFromString(mp.data);
		DataCenter.welfareData:fromServer50126001(msg);
		Lua_MsgUtil.callFunc("UPDATE_SIGNIN_INFO");
	end
end

-- 签到（返回）
function Lua_WelfareProxy:rSignIn(mp)
	if mp.errno == 0 then
		OperateAlert.showLangValue(129011);
	end
end

-------------------- 请求 --------------------

-- 打开签到界面
function Lua_WelfareProxy:sSignInInfo()
	sendMsg(10126001);
end

-- 签到
function Lua_WelfareProxy:sSignIn(day)
	local cmd = ProtoPublic_pb.Proto10126002();
	cmd.day = day;
	sendMsg(10126002, cmd);
end





-------------------- 等级礼包 --------------------
---------------------- 返回 ----------------------

-- 打开等级礼包界面（返回）
function Lua_WelfareProxy:rOpenGradeGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50126008();
		msg:ParseFromString(mp.data);
		DataCenter.welfareData:fromServer50126008(msg);
		Lua_MsgUtil.callFunc("UPDATE_GRADEGIFT_REWARD");
	end
end

-------------------- 请求 --------------------

-- 打开等级礼包界面
function Lua_WelfareProxy:sOpenGradeGiftInfo()
	sendMsg(10126008);
end

-- 领取等级礼包
function Lua_WelfareProxy:sReceiveGradeGift(draw_grade)
	local cmd = ProtoPublic_pb.Proto10126009();
	cmd.draw_grade = draw_grade; -- 领取等级礼包的id
	sendMsg(10126009, cmd);
end