-- 建筑
Lua_ConstructionPlayer = class("Lua_ConstructionPlayer");
function Lua_ConstructionPlayer:setPlayer(player)
    self.player = player;
end

function Lua_ConstructionPlayer:initData()
    if self.player.IsUI == true then
        return;
    end

    local data = self.player.data;
    self.ownerId = tonumber(tostring(data.ownerId));
    self.playerId = tonumber(tostring(data.roleId));
    self.objId = tonumber(tostring(data.objId));
    self.sceneId = data.sceneId;
    self.fightRecordId = tonumber(tostring(data.fightRecordId));
    DataCenter.thingData:addThingPlayer(self, self.playerId, self.objId, self.sceneId, self.fightRecordId, 0, 0);
end

function Lua_ConstructionPlayer:getLuaData()
    return DataCenter.constructUtil:getStructureVo(self.objId);
end

function Lua_ConstructionPlayer:loadBodyComplete()
    if self.player.data.isShowName then
        self:getHeadShowContainer();
        self:updateHeadInfo();
    end

    if self.objId == 10101009 then
        if DataCenter.hundredCeremonyData.isCanDraw then
            self.player:addHangerEffect(Lua_ThingDefine.CONSTRUCTION_EFFECT, "bcsd_ft_0001");
        else
            self.player:removeEffect(Lua_ThingDefine.CONSTRUCTION_EFFECT, "bcsd_ft_0001");
        end
    end
end

function Lua_ConstructionPlayer:getHeadShowContainer()
    if self.headContainer == nil then
        self.headContainer = UICreate.createGameObject(self.player.root);
        LuaUtil.setObjPos(self.headContainer, 0, 0, 0);
        LuaUtil.setObjRot(self.headContainer,0, 0, 0);
        LuaUtil.setObjScale(self.headContainer, 0.02, 0.02, 0.02);
        self.headContainer.name = "headContainer";

        self.headContainer:AddComponent(typeof(UnityEngine.Canvas));
        local rectTf = self.headContainer:GetComponent(typeof(UnityEngine.RectTransform));
        LuaUtil.setRectSize(rectTf, 0, 0);
    end

    self.player:faceToCam();
end

function Lua_ConstructionPlayer:updateHeadInfo()
    if not DataCenter.roleData:isMyself(self.ownerId) then
        return;
    end

    self:showName();
end

function Lua_ConstructionPlayer:showName()
    if self.headContainer == nil then
        return;
    end

    local vo = self:getLuaData();
    if self.nameObject == nil then
        self.nameObject = UICreate.createGameObject(self.headContainer);
        LuaUtil.setObjPos(self.nameObject, vo.namePos.x, vo.namePos.y, vo.namePos.z);
        self.nameObject.name = "nameObject";
    end
    self.nameObject:SetActive(true);
end

function Lua_ConstructionPlayer:showClickInfo(str)
    if not DataCenter.roleData:isMyself(self.ownerId) then
        return;
    end

    if str == tostring(self.playerId) then
        local vo = self:getLuaData();
        if vo.pathId ~= nil and vo.pathId > 0 then
            DataCenter.funcPathUtil:gotoFunction(vo.pathId)
        end       
    else
        -- local arr = string.split(str, "_");
    end
end

function Lua_ConstructionPlayer:clearRes()
    if self.namePanel ~= nil then
        self.namePanel:dispose();
        self.namePanel = nil;
    end

    if self.nameObject ~= nil then
        UnityEngine.GameObject.Destroy(self.nameObject);
        self.nameObject = nil;
    end

    if self.headContainer ~= nil then
        UnityEngine.GameObject.Destroy(self.headContainer);
        self.headContainer = nil;
    end
end

function Lua_ConstructionPlayer:dispose()
    self.isDispose = true;
    if not self.player.IsUI then
        DataCenter.thingData:removeThingPlayer(self, self.playerId, self.objId, self.sceneId, self.fightRecordId, 0, 0);
    end
    self:clearRes();
    self.player = nil;
end