-- 战斗中对白
Lua_FightPlayDialogShowPanel = class("Lua_FightPlayDialogShowPanel", Lua_DisplayObject);
function Lua_FightPlayDialogShowPanel:ctor(p, formationType)
	local skinStr;
	self.formationType = formationType;
	if formationType == Lua_FightDefine.FIGHTPLAY_DEFENDER then
		skinStr = "FightPlayRightDiaLogPanel_skin";
	elseif formationType == Lua_FightDefine.FIGHTPLAY_ATTACKER then
		skinStr = "FightPlayLeftDiaLogPanel_skin";
	else
		skinStr = "FightPlayDiaLogPanel_skin";
	end
	self:superCall("ctor", p, skinStr);
end

function Lua_FightPlayDialogShowPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.txt.text = "";
    self:updateBg();
end

function Lua_FightPlayDialogShowPanel:dispose()
	TweenUtil.getInstance():stop(self.content);
    self:superCall("dispose");
end

function Lua_FightPlayDialogShowPanel:checkOverTime()
	if self.showStartTime ~= nil and self.showCountTime ~= nil  then
		local ct = self.showCountTime / DataCenter.fightPlayData.fightPlaySpeed;
		if getTime() - self.showStartTime >= ct then
			return true;
		end
	end 
	return false;
end

function Lua_FightPlayDialogShowPanel:setLocation(posX, posY, posZ)
	self:superCall("setLocation", posX, posY, posZ);
	self.itemX = posX;
	self:updateBg();
end

function Lua_FightPlayDialogShowPanel:updateBg()
	if self.bg == nil or self.itemX == nil then
		return;
	end

	if self.formationType ~= Lua_FightDefine.FIGHTPLAY_DEFENDER and self.formationType ~= Lua_FightDefine.FIGHTPLAY_ATTACKER then
		if self.itemX > 0 then
			self.bg:setScale(-1, 1);
		else
			self.bg:setScale(1, 1);
		end
	end
end

function Lua_FightPlayDialogShowPanel:updateData(dialogCfg)
	if dialogCfg == nil then
		return;
	end

	self.showStartTime = getTime();
	self.showCountTime = dialogCfg.showTime;
	self.txt.text = dialogCfg.desc;
	self:setScale(0.01, 0.01);
	TweenUtil.getInstance():stop(self.content);
	-- TweenUtil.getInstance():addTween(self.content, 0.5, 0, nil, nil, Vector3.one, nil, nil);
	TweenUtil.getInstance():addTweenTargetScale(self.content, 0.5, 0, 1, 1, 1, 0, false);
end